
UNITTOP = "top"
UNITBOTTOM = "btm"

local BattleScene = class("BattleScene", function(data)
    --return CCUILoader:load("res/csd/public/BattleLayer.csb")--display.newScene("BattleScene")
    return display.newLayer()
end)

function BattleScene:perloadPub()
    cc.Director:getInstance():getTextureCache():addImageAsync("res/art/tankdie/texture.png",function()end)
    cc.Director:getInstance():getTextureCache():addImageAsync("res/art/effect/defbroke1/texture.png",function()end)
    cc.Director:getInstance():getTextureCache():addImageAsync("res/art/effect/defbroke2/texture.png",function()end)
    cc.Director:getInstance():getTextureCache():addImageAsync("res/art/effect/smoke/texture.png",function()end)
    cc.Director:getInstance():getTextureCache():addImageAsync("res/art/effect/hole/texture.png",function()end)
    cc.Director:getInstance():getTextureCache():addImageAsync("res/pic/common/text/number/num01/num_60.png",function()end)
    cc.Director:getInstance():getTextureCache():addImageAsync("res/pic/battle/icon/icon_MISS.png",function()end)
    cc.Director:getInstance():getTextureCache():addImageAsync("art/UI/battle/star/texture.png",function()end)
end

function BattleScene:perloadUnit(v)
    local arr = string.split(v.anim_bullet,";")
    if arr[1] ~= "" and arr[1] ~= "0" then
        cc.Director:getInstance():getTextureCache():addImageAsync(arr[1].."/texture.png",function()end)
    end
    arr = string.split(v.anim_hit,";")
    if arr[1] ~= "" and arr[1] ~= "0" then
        cc.Director:getInstance():getTextureCache():addImageAsync(arr[1].."/texture.png",function()end)
    end
    arr = string.split(v.anim_fire,";")
    if arr[1] ~= "" and arr[1] ~= "0" then
        cc.Director:getInstance():getTextureCache():addImageAsync(arr[1].."/texture.png",function()end)
    end
    arr = string.split(v.anim_shell,";")
    if arr[1] ~= "" and arr[1] ~= "0" then
        cc.Director:getInstance():getTextureCache():addImageAsync(arr[1].."/texture.png",function()end)
    end
    if v.skillid ~=  0 then
        local skillInfo = gTankskill[v.skillid]
        if skillInfo and skillInfo.skilleffects ~= "" and skillInfo.skilleffects ~= "0" then
            local eArr = string.split(skillInfo.skilleffects,",")
            for i,v in ipairs(eArr) do
                local sArr = string.split(v,";")
                if sArr[1] ~= "" and sArr[1] ~= "0" then
                    cc.Director:getInstance():getTextureCache():addImageAsync(sArr[1].."/texture.png",function()end)
                end
            end
        end
    end
end

function BattleScene:ctor(data)
    cc.Director:getInstance():getTextureCache():removeUnusedTextures()
    self.content = CCUILoader:load("res/csd/public/BattleLayer.csb")
    self.timeLineAction = cc.CSLoader:createTimeline("res/csd/public/BattleLayer.csb")
    self.timeLineAction:retain()
    self.content:getChildByName("icon_V_Copy_0"):setVisible(false)
    self.content:getChildByName("icon_S_Copy_0"):setVisible(false)
    self:addChild(self.content)
    self:perloadPub()
    self.ggCallback = nil
    self.battleData = nil
    self.curRound = 0
    self.battleIndex = 0
    self.firstHit = true
    self.isGameOver = false

    self.showCommanders = false

    self.units = {}
    self.isStop = false

    if data.troops and #(data.troops)>0 then
        local pd = PlayerData:getInstanse()
        pd.tanks = data.troops
    end

    self.totalData = data
    self.battleData = data.res or data
    self:initView(self.battleData)

end

function BattleScene:shakeScreen(node)

    local action = Shake:createWithStrength(B_SHAKE_TIME,B_SHAKE_X,B_SHAKE_Y)
    node:runAction(action)

end

function BattleScene:setRound(round)
    self.text_round:setString(round.."/"..self.battleData.maxRound)
end

function BattleScene:initView(data)

    local function onNodeEvent(tag)
        if tag == "exit" then
            self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    self.content:getChildByName("text_leftName"):setString(data.atkName)
    local text_leftLv = self.content:getChildByName("text_leftLv")
    text_leftLv:setString(string.format(StringRes.LV2,data.atkLv))
    text_leftLv:setVisible( data.atkLv ~= 0 )
    local stratkSpeed = 1000
    if data.atkSpeed and data.atkSpeed ~= 0 then
        stratkSpeed = data.atkSpeed
    end
    self.content:getChildByName("text_leftSpeed"):setString(stratkSpeed)

    self.content:getChildByName("text_rightName"):setString(data.defName)
    local text_rightLv = self.content:getChildByName("text_rightLv")
    text_rightLv:setString(string.format(StringRes.LV2,data.defLv))
    text_rightLv:setVisible( data.defLv ~= 0 )
    local strdefSpeed = 1000
    if data.defSpeed and data.defSpeed ~= 0 then
        strdefSpeed = data.defSpeed
    end
    self.content:getChildByName("text_rightSpeed"):setString(strdefSpeed)

    self.text_round = self.content:getChildByName("text_round")
    self:setRound(1)

    self:setCommandersVisible(self.showCommanders)
    local btn_hero = self.content:getChildByName("btn_hero")
    btn_hero:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self.showCommanders = not self.showCommanders
            self:setCommandersVisible(self.showCommanders)
        end
    end)

    local btnSkip = self.content:getChildByName("btn_skip")
    btnSkip:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:gameOver(true)
        end
    end)
    self.btnSkip = btnSkip
    btnSkip:setVisible(false)

    self.topBg = cc.Node:create()
    self:addChild(self.topBg,-200)

    local diry = {x = 1,y = 0}
    local angle = cc.pGetAngle(cc.p(2,1),diry)
    local randomMap = math.random(1,#B_TOP_MAPS)
    self.pSpr1 = cc.Sprite:create(B_TOP_MAPS[randomMap])
    self.pSpr1:setAnchorPoint(cc.p(1,0.72))
    self.pSpr1:setRotation(math.deg(angle))
    self.pSpr1:setPosition(640,1136)
    --    self.pSpr1:setScale(1.5)

    self.pSpr1_2 = cc.Sprite:create(B_TOP_MAPS[randomMap])
    self.pSpr1_2:setAnchorPoint(cc.p(1,0.72))
    self.pSpr1_2:setPosition(cc.p(640-B_DIS_XLEN,1136-B_DIS_PERLEN))
    self.pSpr1_2:setRotation(math.deg(angle))

    self.topBg:addChild(self.pSpr1)
    self.topBg:addChild(self.pSpr1_2)

    local clipper = cc.ClippingNode:create()
    clipper:setAlphaThreshold(0.0)
    self.pSpr2 = cc.Sprite:create(B_BOTTOM_MAPS[randomMap])
    self.pSpr2:setAnchorPoint(cc.p(0,0.3))
    self.pSpr2:setRotation(math.deg(angle))

    self.pSpr2_2 = cc.Sprite:create(B_BOTTOM_MAPS[randomMap])
    self.pSpr2_2:setAnchorPoint(cc.p(0,0.3))
    self.pSpr2_2:setPosition(cc.p(B_DIS_XLEN,B_DIS_PERLEN))
    self.pSpr2_2:setRotation(math.deg(angle))

    --    self.pSpr2:setScale(1.5)
    self.bottomBg = cc.Node:create()
    self.bottomBg:addChild(self.pSpr2)
    self.bottomBg:addChild(self.pSpr2_2)
    clipper:addChild(self.bottomBg)

    local drawNode = cc.Sprite:create("res/pic/battle/panel/panel_battle_mask.png")
    drawNode:setAnchorPoint(cc.p(0,0))
    drawNode:setPosition(cc.p(0,0))
    drawNode:setScale(CONFIG_SCREEN_WIDTH/drawNode:getContentSize().width)
    clipper:setStencil(drawNode)

    self:addChild(clipper,-100)

    self:initUnits()

    NodeTranslator:deltaDo(0.1,function()
        self.updateId = cc.Director:getInstance():getScheduler():scheduleScriptFunc(handler(self,self.update),0,false)
        --开始音效
        if data.type == 1 or data.type ==2 then
            MyAudio:PlayEffect(MusicAndEffect.pveBattleStartEffect)
        else
            MyAudio:PlayEffect(MusicAndEffect.pvpBattleStartEffect)
        end
        self:startAction()
        if self.battleData.gfbSkill then
            require("src/app/views/battle/BattleSkill"):use(self)
            local seq = cc.Sequence:create(cc.DelayTime:create(B_TIME_ONFLY+B_TIME_PERFLY),cc.CallFunc:create(function(dt)
                self:playUnitsAction()
            end))
            self:runAction(seq)
        elseif self.battleData.isGuide then
            --将领按钮不可点
            btn_hero:setEnabled(false)
        else
            self:playUnitsAction()
        end
    end)

end

--local testUnitId = 26 --test
function BattleScene:initUnits()
    --进攻
    for i,v in pairs(self.battleData.atker)do
        v.isTop = false
--        v.baseId = testUnitId --test
        self:perloadUnit(Tank[v.baseId])
        v.content = self.content
        local unit = Unit.create(v)
        local ipos = self.content:getChildByName("ta"..v.index)
        ipos:setVisible(false)
        unit:setPosition(ipos:getPositionX()-500,ipos:getPositionY()-250)
        local seq = cc.Sequence:create(cc.DelayTime:create(0.1),cc.MoveTo:create(B_TIME_INPOS,cc.p(ipos:getPositionX(),ipos:getPositionY())),cc.CallFunc:create(function(s)
            unit:setPos(ipos:getPositionX(),ipos:getPositionY())
        end))
        unit:runAction(seq)
        self.bottomBg:addChild(unit,100+ipos:getTag())
        self.units[UNITBOTTOM..v.index] = unit
    end
    --防守
    for i,v in pairs(self.battleData.defer)do
        v.isTop = true
--        v.baseId = testUnitId --test
        self:perloadUnit(Tank[v.baseId])
        v.content = self.content
        local unit = Unit.create(v)
        local ipos = self.content:getChildByName("tb"..v.index)
        ipos:setVisible(false)
        unit:setPosition(ipos:getPositionX()+500,ipos:getPositionY()+250)
        local seq = cc.Sequence:create(cc.DelayTime:create(0.1),cc.MoveTo:create(B_TIME_INPOS,cc.p(ipos:getPositionX(),ipos:getPositionY())),cc.CallFunc:create(function(s)
            unit:setPos(ipos:getPositionX(),ipos:getPositionY())
        end))
        unit:runAction(seq)
        self.topBg:addChild(unit,100+ipos:getTag())
        self.units[UNITTOP..v.index] = unit
    end
end

function BattleScene:playUnitsAction()
    local rounds = self.battleData.rounds
    self:rounding(nil)
end

function BattleScene:gameOver(isJump)
    if self.isGameOver then return end

    if self.battleData.isGuide then
        self.btnSkip:setVisible(false)
        NoviceGuide:firstBattleEnd(isJump)
    elseif self.totalData.res then
        self.isStop = true
        require("src/app/views/battle/BattleResult"):show(self,self.totalData)
        NoviceGuide:reStartNext()
        --        local layer = require("src/app/views/battle/BattleResult").new(self.totalData)
        --        self:addChild(layer,200)
    else
        self:popScene()
    end

    self.isGameOver = true
end

--战斗回合中
function BattleScene:rounding(sender)
    self.curRound = self.curRound + 1
    if self.curRound > #self.battleData.rounds then
        --        print("rounds over")
        local seq = cc.Sequence:create(cc.DelayTime:create(2),cc.CallFunc:create(function(s)
            self:gameOver()
        end))
        self:runAction(seq)
        return
    end
    --    print("rounds"..self.curRound)
    self:setRound(self.curRound)
    local seq = cc.Sequence:create(cc.DelayTime:create(B_TIME_PERROUND),cc.CallFunc:create(self.batting))
    self:runAction(seq)
end

function BattleScene:fireAction(sender)
    if self.isStop then return end
    local curAtk = self.battleData.rounds[self.curRound]["atkInfos"][self.battleIndex]
    local perFireTime = B_TIME_PERFIRE
    local delayIime = 0
    if curAtk.type ==1 then
        --        print("攻击方"..curAtk.index.."位置开始攻击")
        local unit = self.units[UNITBOTTOM..curAtk.index]
        if unit then
            if Tank[unit.data.baseId].type == 4 then
                perFireTime = B_TIME_PERFIRE_ROCKET
            end
            delayIime = unit:fireWithData(curAtk)
        end
    elseif curAtk.type ==2 then
        --        print("防守方"..curAtk.index.."位置开始攻击")
        local unit = self.units[UNITTOP..curAtk.index]
        if unit then
            if Tank[unit.data.baseId].type == 4 then
                perFireTime = B_TIME_PERFIRE_ROCKET
            end
            delayIime = unit:fireWithData(curAtk)
        end
    end
    local seq = cc.Sequence:create(cc.DelayTime:create(#curAtk.aims*perFireTime+B_TIME_FIRETOHIT+delayIime),cc.CallFunc:create(self.hitAction))
    self:runAction(seq)
end

function BattleScene:hitAction(sender)
    if self.isStop then return end
    local curAtk = self.battleData.rounds[self.curRound]["atkInfos"][self.battleIndex]
    local perHitIndex = 0
    ---perHitAciton
    function perHitAciton(sender)

        if self.firstHit then --第一次命中时  出现跳过战斗按钮
            self.firstHit = false
            --            local seq = cc.Sequence:create(cc.DelayTime:create(1),cc.CallFunc:create(function(dt)
            self.btnSkip:setVisible(true)
            --            end))
            --            self:runAction(seq)
        end

        perHitIndex = perHitIndex+1
        if perHitIndex>#curAtk.aims then
            self:batting(nil)
            return
        end

        local v = curAtk.aims[perHitIndex]

        local perFireTime  = B_TIME_PERFIRE
        if v.aimType ==1 then --下方
            --            print("攻击方"..v.index.."位置受到"..v.hurt.."伤害")
            local unit = self.units[UNITBOTTOM..v.index]

            if Tank[self.units[UNITTOP..curAtk.index].data.baseId].type == 4 then
                perFireTime = B_TIME_PERFIRE_ROCKET
            end

            if unit then
                v.who = self.units[UNITTOP..curAtk.index]
                unit:hit(v)
            else
                --攻击地面

                local bulletNode = Animation:createAnimationWithType(Tank[self.units[UNITTOP..curAtk.index].data.baseId].anim_bullet,nil,{isTop = (v.aimType ==2)})
                local ipos = self.content:getChildByName("ta"..v.index)
                local _info = B_BULLET_DATA[Tank[self.units[UNITTOP..curAtk.index].data.baseId].type]
                local bulletX = _info.bottom.x --B_BULLET_X1
                local bulletY = _info.bottom.y --B_BULLET_Y1

                --                if Tank[self.units[UNITTOP..curAtk.index].data.baseId].type ==3 or Tank[self.units[UNITTOP..curAtk.index].data.baseId].type ==4 then
                --                    bulletX = B_BULLET_RDOWN_X
                --                    bulletY = B_BULLET_RDOWN_Y
                --                end
                --子弹旋转
                local diry = {x = 1,y = 0}
                local angle = cc.pGetAngle(cc.p(-bulletX,-bulletY),diry)
                bulletNode:setRotation(math.deg(angle))

                bulletNode:runAction(cc.Sequence:create(cc.MoveBy:create(B_BULLET_TIME,cc.p(-bulletX,-bulletY)),cc.CallFunc:create(function()
                    bulletNode:removeFromParent()

                    --被击音效
                    MyAudio:PlayEffect(Tank[self.units[UNITTOP..curAtk.index].data.baseId].hitAudio)
                    MyAudio:PlayEffect(MusicAndEffect.unitDead)

                    local hole = Animation:createAnimationWithType(Tank[self.units[UNITTOP..curAtk.index].data.baseId].anim_hole,nil,{isTop = (v.aimType ==2)})
                    hole:setPosition(ipos:getPositionX(),ipos:getPositionY())
                    self.bottomBg:addChild(hole,90)
                    hole:runAction(cc.Sequence:create(cc.MoveBy:create(B_TIME_DEAD_RM,cc.p(-B_SPEED_X*B_TIME_DEAD_RM,-B_SPEED_Y*B_TIME_DEAD_RM)),cc.CallFunc:create(function()
                        hole:removeFromParent()
                    end)))


                    local node = Animation:createAnimationWithType(Tank[self.units[UNITTOP..curAtk.index].data.baseId].anim_die,nil,{isTop = (v.aimType ==2)})
                    node:getArmature():registerAnimationEventHandler(
                        function (t)
                            node:removeFromParent()
                        end
                    )
                    node:setPosition(ipos:getPositionX(),ipos:getPositionY())
                    node:runAction(cc.Sequence:create(cc.MoveBy:create(B_TIME_DEAD_RM,cc.p(-B_SPEED_X*B_TIME_DEAD_RM,-B_SPEED_Y*B_TIME_DEAD_RM)),cc.CallFunc:create(function()
                        end)))
                    self.bottomBg:addChild(node,200)

                end)))
                bulletNode:setPosition(ipos:getPositionX()+bulletX,ipos:getPositionY()+bulletY)
                self.bottomBg:addChild(bulletNode,90)
            end
        elseif v.aimType ==2 then --上方
            --            print("防守方"..v.index.."位置受到"..v.hurt.."伤害")
            local unit = self.units[UNITTOP..v.index]

            if Tank[self.units[UNITBOTTOM..curAtk.index].data.baseId].type == 4 then
                perFireTime = B_TIME_PERFIRE_ROCKET
            end

            if unit then
                v.who = self.units[UNITBOTTOM..curAtk.index]
                unit:hit(v)
            else
                --攻击地面
                local _info = B_BULLET_DATA[Tank[self.units[UNITBOTTOM..curAtk.index].data.baseId].type]
                local bulletX = _info.top.x --B_BULLET_X1
                local bulletY = _info.top.y --B_BULLET_Y1

                if Tank[self.units[UNITBOTTOM..curAtk.index].data.baseId].type ==3 or Tank[self.units[UNITBOTTOM..curAtk.index].data.baseId].type ==4 then
                    bulletX = -_info.top.x -- -B_BULLET_RUP_X
                    bulletY = -_info.top.y -- -B_BULLET_RUP_Y
                end

                local bulletNode = Animation:createAnimationWithType(Tank[self.units[UNITBOTTOM..curAtk.index].data.baseId].anim_bullet,nil,{isTop = (v.aimType ==2)})
                --子弹旋转
                local diry = {x = 1,y = 0}
                local angle = cc.pGetAngle(cc.p(bulletX,bulletY),diry)
                bulletNode:setRotation(math.deg(angle))

                local ipos = self.content:getChildByName("tb"..v.index)
                bulletNode:runAction(cc.Sequence:create(cc.MoveBy:create(B_BULLET_TIME,cc.p(bulletX,bulletY)),cc.CallFunc:create(function()
                    bulletNode:removeFromParent()

                    --被击音效
                    MyAudio:PlayEffect(Tank[self.units[UNITBOTTOM..curAtk.index].data.baseId].hitAudio)
                    MyAudio:PlayEffect(MusicAndEffect.unitDead)

                    local hole = Animation:createAnimationWithType(Tank[self.units[UNITBOTTOM..curAtk.index].data.baseId].anim_hole,nil,{isTop = (v.aimType ==2)})
                    hole:setPosition(ipos:getPositionX(),ipos:getPositionY())
                    self.topBg:addChild(hole,90)
                    hole:runAction(cc.Sequence:create(cc.MoveBy:create(B_TIME_DEAD_RM,cc.p(B_SPEED_X*B_TIME_DEAD_RM,B_SPEED_Y*B_TIME_DEAD_RM)),cc.CallFunc:create(function()
                        hole:removeFromParent()
                    end)))

                    local node = Animation:createAnimationWithType(Tank[self.units[UNITBOTTOM..curAtk.index].data.baseId].anim_die,nil,{isTop = (v.aimType ==2)})
                    node:getArmature():registerAnimationEventHandler(
                        function (t)
                            node:removeFromParent()
                        end
                    )
                    node:setPosition(ipos:getPositionX(),ipos:getPositionY())
                    node:runAction(cc.Sequence:create(cc.MoveBy:create(B_TIME_DEAD_RM,cc.p(B_SPEED_X*B_TIME_DEAD_RM,B_SPEED_Y*B_TIME_DEAD_RM)),cc.CallFunc:create(function()
                        end)))
                    self.topBg:addChild(node,200)

                end)))
                bulletNode:setPosition(ipos:getPositionX()-bulletX,ipos:getPositionY()-bulletY)
                self.topBg:addChild(bulletNode,90)

            end
        end


        local seq = cc.Sequence:create(cc.DelayTime:create(perFireTime),cc.CallFunc:create(perHitAciton))
        self:runAction(seq)

    end
    ---perHitAciton

    perHitAciton(nil)

end

--每回合中的战斗
function BattleScene:batting(sender)
    self.battleIndex = self.battleIndex+1
    if self.battleIndex > #self.battleData.rounds[self.curRound]["atkInfos"] then
        self.battleIndex = 0
        print("batting over")
        self:rounding(nil)
        return
    end
    --    print("batting"..self.battleIndex)
    local seq = cc.Sequence:create(cc.DelayTime:create(B_TIME_HITTOFIRE),cc.CallFunc:create(self.fireAction))
    self:runAction(seq)
end

function BattleScene:updateBottomPos(p1,p2,delX,delY)
    local curX = p1:getPositionX()
    local curY = p1:getPositionY()
    local tempX = curX-delX
    local tempY = curY-delY
    p1:setPositionX(tempX)
    p1:setPositionY(tempY)
    p2:setPositionX(tempX+B_DIS_XLEN)
    p2:setPositionY(tempY+B_DIS_PERLEN)
    local tmp = -B_DIS_PERLEN*2 - p1:getPositionX()
    if tmp>= 0 then
        p1:setPositionX(-tmp+B_DIS_XLEN)
        p1:setPositionY(-tmp/2+B_DIS_PERLEN)
        p2:setPositionX(-tmp)
        p2:setPositionY(-tmp/2)
    end
end

function BattleScene:updateTopPos(p1,p2,delX,delY)
    local curX = p1:getPositionX()
    local curY = p1:getPositionY()
    local tempX = curX+delX
    local tempY = curY+delY
    p1:setPositionX(tempX)
    p1:setPositionY(tempY)
    p2:setPositionX(tempX-B_DIS_XLEN)
    p2:setPositionY(tempY-B_DIS_PERLEN)
    local tmp = p1:getPositionX()- (640+B_DIS_PERLEN*2)
    if tmp>= 0 then
        p1:setPositionX(tmp+(640-B_DIS_XLEN))
        p1:setPositionY(tmp/2+(1136-B_DIS_PERLEN))
        p2:setPositionX(tmp+640)
        p2:setPositionY(tmp/2+1136)
    end
end

function BattleScene:update(dt)

    if dt > 2 then dt = 1/30 end

    local delY = B_SPEED_Y*dt
    local delX = delY*B_SPEED_X/B_SPEED_Y

    local curX1 = self.pSpr1:getPositionX()
    local curX1_2 = self.pSpr1_2:getPositionX()

    if curX1 > curX1_2 then
        self:updateTopPos(self.pSpr1,self.pSpr1_2,delX,delY)
    else
        self:updateTopPos(self.pSpr1_2,self.pSpr1,delX,delY)
    end

    local curX2 = self.pSpr2:getPositionX()
    local curX2_2 = self.pSpr2_2:getPositionX()

    if curX2 < curX2_2 then
        self:updateBottomPos(self.pSpr2,self.pSpr2_2,delX,delY)
    else
        self:updateBottomPos(self.pSpr2_2,self.pSpr2,delX,delY)
    end

end

function BattleScene:onEnter()

end

function BattleScene:onExit()
    cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.updateId)
    cc.Director:getInstance():getTextureCache():removeUnusedTextures()
    self.units = {}
end

function BattleScene:startAction()
    self.content:getChildByName("icon_V_Copy_0"):setVisible(true)
    self.content:getChildByName("icon_S_Copy_0"):setVisible(true)
    self:runAction(self.timeLineAction)
    self.timeLineAction:gotoFrameAndPlay(0, 60, false)
    self.timeLineAction:release()
end

function BattleScene:pushScene(callback)
    --    self.lastScene = cc.Director:getInstance():getRunningScene()
    --    cc.Director:getInstance():pushScene(self)
    IS_BATTLING = true
    self.ggCallback = callback
    local Scene = display.getRunningScene()
    Scene:addChild(self,gTopLay+2)
    if Scene.setChildVisible then
        Scene:setChildVisible(false)
    end    
    self:setName("Battle")
end

function BattleScene:popScene()
    --    local temp = self.lastScene
    --    cc.Director:getInstance():popScene()
    --    return temp
    --    self:onExit()
    IS_BATTLING = false
    local tmp = self.ggCallback
    self:removeFromParent()
    local Scene = display.getRunningScene()
    if Scene.setChildVisible then
        Scene:setChildVisible(true)    
    end
    if tmp then
        tmp()
    end
    return Scene
end

function BattleScene:removeUnitWithKey(key)
    self.units[key] = nil
end

function BattleScene:setCommandersVisible(vis)
    for k,v in pairs(self.units) do
        if v then v:setCommanderVisible(vis) end
    end
end

return BattleScene