--require "Cocos2d"
--require "Cocos2dConstants"

local UpdateScene = class("UpdateScene", function()
    return display.newScene("UpdateScene")
end)
require("src/app/IPConfig")
local updateUrl = g_UpdateUrl --k8
--local updateUrl = "http://hstudio.f3322.org:8099/slg_admin_qa/" --qa   http://123.59.67.83
--local updateUrl = "http://123.59.67.83:8086/slg_admin/" --cloud
gExchange_btn = 1

local CCUILoader = require("framework.cc.uiloader.uiloader")


local cjson = require("cjson")


--重新加载模块
-- 外部库 登记
local package_list = package_list or {
    bit = true,
    lfs = true,
    cjson = true,
    pb = true,
    socket = true,
}

-- 全局性质类/或禁止重新加载的文件记录
local ignored_file_list = ignored_file_list or {
    global = true ,
}

--已重新加载的文件记录
local loaded_file_list = loaded_file_list or {}

--视图排版控制
function leading_tag( indent )
    -- body
    if indent < 1 then
        return ''
    else
        return string.rep( '    |',  indent - 1  ) .. '    '
    end
end

--关键递归重新加载函数
--filename 文件名
--indent   递归深度, 用于控制排版显示
function recursive_reload( filename, indent )
    -- body
    if package_list[ filename] then 
        --对于 外部库, 只进行重新加载, 不做递归子文件
        --卸载旧文件
        package.loaded[ filename] = nil

        --装载信文件
        require( filename )

        --标记"已被重新加载"
        loaded_file_list[ filename] = true

        --print( leading_tag(indent) .. filename .. "... done" )
        return true
    end

    --普通文件
    --进行 "已被重新加载" 检测
    if loaded_file_list[ filename] then 
        --print( leading_tag(indent) .. filename .. "...already been reloaded IGNORED" )
        return true
    end

    local fullPath = cc.FileUtils:getInstance():fullPathForFilename(string.gsub(filename, '%.', '/') .. '.lua');
    --print(fullPath)
    --读取当前文件内容, 以进行子文件递归重新加载
    local file, err = io.open( fullPath )
    if file == nil then 
        print( string.format( "failed to reaload file(%s), with error:%s", fullPath, err or "unknown" ) )
        return false
    end

    print( leading_tag(indent) .. filename)

    -- 缓存文件内容，及时关闭文件，否则文件不可写入
    local data = {}
    local comment = false
    for line in file:lines() do
        line = string.trim(line);
        if string.find(line, '%-%-%[%[%-%-') ~= nil then
            comment = true;
        end

        if comment and (string.find(line, '%]%]') ~= nil or string.find(line, '%-%-%]%]%-%-') ~= nil) then
            comment = false;
        end

        -- 被注释掉的，和持有特殊标志的require文件不重新加载
        local linecomment = (line[1] == '-' and line[2] == '-')
        if not comment and not linecomment and string.find(line, '%-%- Ignore Reload') == nil  then
            table.insert(data, line);
        end
    end

    io.close(file)

    local function getFileName(line)
        local begIndex = string.find(line, "'");
        local endIndex = string.find(line, "'", (begIndex or 1) + 1)
        if begIndex == nil or endIndex == nil then
            begIndex = string.find(line, '"');
            endIndex = string.find(line, '"', (begIndex or 1) + 1)
        end

        if begIndex == nil or endIndex == nil then
            return nil;
        end

        return string.sub(line, begIndex + 1, endIndex - 1)
    end

    -- 先解析文件，加载里面的子文件
    for _,line in ipairs(data) do
        -- 去除空白符
        --line = string.gsub( line, '%s', '' )
        local subFileName = nil 
        if string.find(line, 'require') ~= nil then
            subFileName = getFileName(line);
        elseif string.find(line, 'import') ~= nil then
            -- TODO 兼容import 通过fullPath进行解析
            subFileName = nil
        end

        if subFileName then
            --printInfo('file: %s     subFile: %s', line, subFileName)
            --进行递归 
            local success = recursive_reload( subFileName, indent + 1 )
            if not success then 
                print( string.format( "failed to reload sub file of (%s)", filename ) )
                return false
            end

        end

    end    


    -- "后序" 处理当前文件...
    if ignored_file_list[ filename] then
        --忽略 "禁止被重新加载"的文件
        print( leading_tag(indent) .. filename .. "... IGNORED" )
        return true
    else

        --卸载旧文件
        package.loaded[ filename] = nil

        --装载新文件
        require( filename )

        --设置"已被重新加载" 标记
        loaded_file_list[ filename] = true
        --print( leading_tag(indent) .. filename .. "... done" )
        return true
    end
end

--主入口函数
function reload_script_files()

    --loaded_file_list = {}
    
    
    package.loaded["src/app/cfg/StringRes"] = nil
    require("src/app/cfg/StringRes")
    
    
    package.loaded["src/app/util/Common"] = nil
    require("src/app/util/Common")
    
--    package.loaded["src/app/IPConfig"] = nil
--    require("src/app/IPConfig")
    
    
 --   package.loaded["src/app/util/SDKPlatform"] = nil
   -- require("src/app/util/SDKPlatform")

    --本项目是以 main.lua 为主文件
    --recursive_reload( "src/app/MyApp", 0 )


    return "reload ok"
end

function UpdateScene.create()

    


    local scene = UpdateScene.new()
    scene:addChild(scene:createLayer())
    
    return scene
end

function UpdateScene:ctor()
    --处理版本号为空
    if cc.UserDefault:getInstance():getStringForKey("current-version-code") == "" then
        cc.UserDefault:getInstance():setStringForKey("current-version-code","1")
    end


    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
    
    
    self:addChild(self:createLayer())
end



--检测强制更新
function UpdateScene:getForceUpdate()
    local req = network.createHTTPRequest(function(event)
        local ok = (event.name == "completed")
        local request = event.request
        if not ok then
            -- 请求失败，显示错误代码和错误消息
            if event.name == "failed" then
                --
                self:showConnectFaild()
            end
            return
        end

        local code = request:getResponseStatusCode()
        if code ~= 200 then
            -- 请求结束，但没有返回 200 响应代码
            print("code:"..code)
            self:showConnectFaild()
            return
        end

        local response = request:getResponseData()
        response = cjson.decode(response)
        
        
        --版本号相同
        if response.is_update == 0 then
            print("no_forceupdate")
            self:checkUpdateOnline()
        else--版本号不同
            print("yes_forceupdate")
            self:doforceUpdate(SDKPlatform:getForceUpdateParam(),response.download_url)
        end
        
        gExchange_btn = response.exchange_btn
        
    end,g_UpdateUrl.."version.php?channel_id="..SDKPlatform:getSDKId().."&type=apk&version="..Common:getVersion(),"GET")
--    local _t = {channel_id = "ios"}
--    for k,v in pairs(_t) do
--        req:addPOSTValue(k,v)
--    end
	print("updateUrl=",g_UpdateUrl)
    req:setTimeout(5)
    req:start()
end


function UpdateScene:getAllIp(callback)

    SDKPlatform:printLog("getAllIp")

    local function myrequest(ip,faildcallback)
        local req = network.createHTTPRequest(function(event)
            local ok = (event.name == "completed")
            local request = event.request
            if not ok then
                -- 请求失败，显示错误代码和错误消息
                if event.name == "failed" then
                --
                    if faildcallback ~= nil then
                        faildcallback()
                    end
                end
                
                
                return
            end

            local code = request:getResponseStatusCode()
            if code ~= 200 then
                -- 请求结束，但没有返回 200 响应代码
                print("code:"..code)
                if faildcallback ~= nil then
                    faildcallback()
                end
                return
            end

            local response = request:getResponseData()
            response = cjson.decode(response)

            if response ~= nil then
--                {
--                "update":"hstudio.f3322.org:8186",
--                "login":"192.168.0.251:9090",
--                "count":"120.132.60.44:8086",
--                "pay":"hstudio.f3322.org:8186",
--                "notice":"hstudio.f3322.org:8186"}

--                 g_UpdateUrl = "http://"..response.update.."/slg_admin/"
--                 g_LoginConnect = "http://"..response.login
--                 g_Statics = "http://"..response.count.."/slg_analysis/tank_sync_login.php"
--                 gPayUrlPath = "http://"..response.pay.."/slg_pay/"
--                 g_PayOrder = gPayUrlPath.."interface.php?act=create_order_sn"
--                 g_Gonggao = "http://"..response.notice.."/slg_admin/getNotice.php"

               g_UpdateUrl = response.update
               g_LoginConnect = response.login
               g_Statics = response.count
               gPayUrlPath = response.pay
               g_PayOrder = gPayUrlPath.."interface.php?act=create_order_sn"
               g_Gonggao = response.notice
                
                if callback ~= nil then
                    callback(1)
                end

            else
                if faildcallback ~= nil then
                    faildcallback()
                end
            end
        end,ip,"GET")
        req:setTimeout(5)
        req:start()
    end

    myrequest(g_EntranceIp,function()
        myrequest(g_EntranceHttp,function()
            if callback ~= nil then
                callback(0)
            end
        
        end)
    end)

	
end


function UpdateScene:createLayer()
    require("src/app/cfg/StringRes")
    require("src/app/util/Common")
    
    self.updateLayer = CCUILoader:load("res/updatecsd/ui_updating_main.csb")
    self.updateLayer:getChildByName("text_version"):setString("V"..Common:getVersion().."("..cc.UserDefault:getInstance():getStringForKey("current-version-code")..")")
    
    
    
    
    self:addNodeEventListener(cc.KEYPAD_EVENT, function(event)
        if event.key == "back" then
            if self.updateLayer:getChildByTag(999) then return end
            local noticeDbg = CCUILoader:load("res/updatecsd/layer_popout_confirm.csb")
            local bg = noticeDbg:getChildByName("panel_mask"):getChildByName("panel_bg")
            bg:getChildByName("text_remind"):setString(StringRes.notice)
            --文字
            require("src/app/cfg/StringRes")

            bg:getChildByName("text_remind_content"):setString( StringRes.exit_notice )

            local ok = bg:getChildByName("btn_confirm")
            ok:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then
                    noticeDbg:removeFromParent()
                    app.exit()
                end

            end)

            local cancel = bg:getChildByName("btn_cancel") 
            cancel:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then 
                    noticeDbg:removeFromParent()
                end

            end)

            self.updateLayer:addChild(noticeDbg,999,999)
        end
    end)
    self:setKeypadEnabled(true)
    
    local function onNodeEvent(tag)
        if tag == "enter" then
            
        elseif tag == "exit" then
            reload_script_files()
        end
    end
    self.updateLayer:registerScriptHandler(onNodeEvent)
    
    
    
    UpdateScene:getAllIp(function(state)
        if state == 1 then
            --检测强制更新
            self:getForceUpdate()
        else
            self:showConnectFaild()
            print("get ip faild")
        end
    end)
    
    
    
    
    
    
    
    
    
    return self.updateLayer
end


function UpdateScene:showConnectFaild()
    local noticeDbg = CCUILoader:load("res/updatecsd/layer_popout_confirm.csb")
    local bg = noticeDbg:getChildByName("panel_mask"):getChildByName("panel_bg")

    --文字
    print("---------tt")

    bg:getChildByName("text_remind_content"):setString(StringRes.text_reconnect)
    --bg:getChildByName("text_remind_content"):setString("fdsfds")

    local ok = bg:getChildByName("btn_confirm")
    ok:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then 
            noticeDbg:removeFromParent()
            app:enterScene("UpdateScene",{true})
        end

    end)

    local cancel = bg:getChildByName("btn_cancel") 
    cancel:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then 
            noticeDbg:removeFromParent()
            app:exit()
        end

    end)

    self.updateLayer:addChild(noticeDbg)
end



function UpdateScene:doforceUpdate(isIternet,url)
    --强制更新
    if true then
        local noticeDbg = CCUILoader:load("res/updatecsd/layer_popout_confirm.csb")
        local bg = noticeDbg:getChildByName("panel_mask"):getChildByName("panel_bg")

        --文字
        print("---------tt")

        bg:getChildByName("text_remind_content"):setString(StringRes.force_update_desc)

        local ok = bg:getChildByName("btn_confirm")
        ok:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then 
                noticeDbg:removeFromParent()
                if isIternet then
                    Common:downloadApk(url,function() app:exit() end)
                else
                    local function onProgress( percent )
                        --local progress = string.format("downloading %d%%",percent)
                        --title:setString(progress)
                        percent = tonumber(percent)
                        
                        self.updateLayer:getChildByName("progressbar_updating"):setVisible(true)
                        self.updateLayer:getChildByName("progressbar_updating"):setPercent(percent)

                        self.updateLayer:getChildByName("text_updating"):setVisible(true)
                        if percent == 100 then
                            self.updateLayer:getChildByName("text_updating"):setString(StringRes.jieya_wait)
                        else
                            self.updateLayer:getChildByName("text_updating"):setString(StringRes.downloading.."..."..percent.."%")
                        end

                    end
                
                    Common:downloadApk(url,onProgress)
                end
                --Common:downloadApk(updateUrl.."slg_admin/AppActivity.apk")
            end

        end)

        local cancel = bg:getChildByName("btn_cancel") 
        cancel:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then 
                noticeDbg:removeFromParent()
                app:exit()
            end

        end)

        self.updateLayer:addChild(noticeDbg)
    end
end


--热更新检测
function UpdateScene:checkUpdateOnline()
    local req = network.createHTTPRequest(function(event)
        local ok = (event.name == "completed")
        local request = event.request
        if not ok then
            -- 请求失败，显示错误代码和错误消息
            if event.name == "failed" then
            --
                self:showConnectFaild()
            end
            return
        end

        local code = request:getResponseStatusCode()
        if code ~= 200 then
            -- 请求结束，但没有返回 200 响应代码
            print("code:"..code)
            self:showConnectFaild()
            return
        end

        local response = request:getResponseData()
        response = cjson.decode(response)
        print("----url"..response.zip_url)
        print("----url"..response.get_version)
        --有更新
        if response.is_update == 1 then
            self:getAssetsManager(response.zip_url,response.get_version)
            self:doHotUpdate(response.zip_size)
        else--无更新
            self:gotoGame()
        end
        
        
        --版本号相同
        
    end,g_UpdateUrl.."version.php?channel_id="..SDKPlatform:getSDKId().."&version="..cc.UserDefault:getInstance():getStringForKey("current-version-code").."&type=zip","GET")
    --end,g_UpdateUrl.."version.php?channel_id="..SDKPlatform:getSDKId().."&version=1".."&type=zip","GET")
    --http://192.168.0.253/slg_admin_qa/getVersion.php
    print("----urltt:"..g_UpdateUrl.."version.php?channel_id="..SDKPlatform:getSDKId().."&version="..cc.UserDefault:getInstance():getStringForKey("current-version-code").."&type=zip")
    req:setTimeout(5)
    req:start()
end

--处理热更新
function UpdateScene:doHotUpdate(size)
    require("src/app/util/SDKPlatform")
    SDKPlatform:printLog("----doHotUpdate")
    --热更新
    if self:getAssetsManager():checkUpdate() then
        local noticeDbg = CCUILoader:load("res/updatecsd/layer_popout_confirm.csb")
        local bg = noticeDbg:getChildByName("panel_mask"):getChildByName("panel_bg")
        --文字
        require("src/app/cfg/StringRes")

        local packages = math.ceil(size/1024/1024)
        if packages <= 1 then
            packages = math.ceil(size/1024).."K"
        else
            packages = math.ceil(size/1024/1024).."M"
        end


        bg:getChildByName("text_remind_content"):setString( string.format(StringRes.update_desc,packages) )

        local ok = bg:getChildByName("btn_confirm")
        ok:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then 
                noticeDbg:removeFromParent()

                self:getAssetsManager():update()
            end

        end)

        local cancel = bg:getChildByName("btn_cancel") 
        cancel:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then 
                noticeDbg:removeFromParent()

            end

        end)

        self.updateLayer:addChild(noticeDbg)
    end
end

function UpdateScene:gotoGame()
    require("src/app/MyApp.lua"):init()

    local memery = Common:getSysTotalMemery()
    print("")
    if memery <= 900 then
        cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A4444)
    end


    app:enterScene("LoginScene",{true}) 
end


function UpdateScene:getAssetsManager(url1,url2)
    if self.assetsManager ~= nil then
        return self.assetsManager
    end


    local function onError(errorCode)
        if errorCode == cc.ASSETSMANAGER_NO_NEW_VERSION then
            print("no new version")
            self:gotoGame()
        elseif errorCode == cc.ASSETSMANAGER_NETWORK then
            print("network error")
        end
    end

    local function onProgress( percent )
        --local progress = string.format("downloading %d%%",percent)
        --title:setString(progress)
        self.updateLayer:getChildByName("progressbar_updating"):setVisible(true)
        self.updateLayer:getChildByName("progressbar_updating"):setPercent(percent)
        
        self.updateLayer:getChildByName("text_updating"):setVisible(true)
        if percent == 100 then
            self.updateLayer:getChildByName("text_updating"):setString(StringRes.jieya_wait)
        else
            self.updateLayer:getChildByName("text_updating"):setString(StringRes.updating.."..."..percent.."%")
        end
        
    end

    local function onSuccess()
        print("downloading ok")
        local tt = package.loaded
        reload_script_files()
        
        
        self:gotoGame()
    end

    local pathToSave          = ""
    pathToSave = createDownloadDir()  
    --pathToSave = "d:\tt" getVersion UserDefault::getInstance()->getStringForKey("current-version-code")

    self.assetsManager = cc.AssetsManager:new(url1,url2,
        pathToSave)
    self.assetsManager:retain()
    self.assetsManager:setDelegate(onError, cc.ASSETSMANAGER_PROTOCOL_ERROR )
    self.assetsManager:setDelegate(onProgress, cc.ASSETSMANAGER_PROTOCOL_PROGRESS)
    self.assetsManager:setDelegate(onSuccess, cc.ASSETSMANAGER_PROTOCOL_SUCCESS )
    self.assetsManager:setConnectionTimeout(30) 
    return self.assetsManager
end

function UpdateScene:update()
    self.assetsManager:update()    
end

return UpdateScene