local Airborne = {}
local boxNode = nil

function Airborne:updateParachute(id)
    self:resetBox()
    if id and id > 0 then
        FlyWordPrompt:prompt(StringRes.air_1)
        local parachuteNode = Animation:createAnimation(gUIeffect[30].effect)
        parachuteNode:setPosition(cc.pAdd(self:randPos(),cc.p(-40,108)))
        gWorldScene.BaseBg:getChildByName("ScrollView_1"):getChildByName("homeMap_mi"):addChild(parachuteNode,1000)
        parachuteNode:getArmature():registerAnimationEventHandler(
            function (t)
                parachuteNode:removeFromParent()
                self:updateBox(id)
            end
        )
    else
        self:updateBox(id)
    end
end

function Airborne:init()
    if boxNode == nil then
        boxNode = Animation:createAnimation(gUIeffect[31].effect)
        local parent = gWorldScene.BaseBg:getChildByName("ScrollView_1"):getChildByName("homeMap_mi")
        local clickArea = parent:getChildByName("airborne_click_area"):clone()
        clickArea:setPosition(cc.p(0,0))
        boxNode:addChild(clickArea)
        parent:addChild(boxNode,1000)
        clickArea:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                Connect:sendMsg("PlayerAction","getAirborneRes",{resId = boxNode.tag_id},
                    function(data)
                        if data.state == 1 then
                            local str = StringRes.exchange_get_reward
                            if data.templateId == -1 then--金币
                                str = str..data.gold..StringRes.coin
                                PlayerData:getInstanse().basicData.gold = data.allGold
                            else--道具
                                local info = gItem[data.templateId]
                                str = str..StringRes[info.name].."x"..data.count
                            end
                            FlyWordPrompt:prompt(str)
                            self:resetBox()
                        elseif data.state == 2 then
                            Common:showCodeInfo(157)
                            self:resetBox()
                        end
                    end)
            end
        end)
        self:resetBox()
        local function onNodeEvent(tag)
            if tag == "exit" then
               boxNode = nil
            end
        end
        boxNode:registerScriptHandler(onNodeEvent)
    end
end

function Airborne:updateBox(id)
    if id and id > 0 then
        if boxNode == nil then self:init() end
        boxNode:setPosition(self:getSavePos())
        boxNode.tag_id = id
    else
        if boxNode then
            self:resetBox()
        end
    end
end

function Airborne:resetBox()
    if boxNode then
        boxNode:setPosition(cc.p(-500,-500))
    end
end

local KEY = "AirbornePosIndex"

function Airborne:randPos()
    local index = math.random(1,#gMaterialCoordinate)
    cc.UserDefault:getInstance():setIntegerForKey(KEY,index)
    return self:getPos(index)
end

function Airborne:getSavePos()
    local index = cc.UserDefault:getInstance():getIntegerForKey(KEY,-1)
    return self:getPos(index)
end

function Airborne:getPos(index)
    local pos = nil
    if index == -1 or gMaterialCoordinate[index] == nil then
        pos = self:randPos()
    else
        pos = gMaterialCoordinate[index].pos
    end
    return pos
end

return Airborne