
Formula = {}

local attributeSting = {"hp","atk","","",""}
--（单个战斗单位攻击分数*可上阵最大数量+单个战斗单位防御分数*可上阵最大数量）/100 = 总战力
--单个战斗单位攻击分数 = [伤害+（伤害*暴击几率*爆伤）]*（1+穿刺几率）*(1+命中)
--单个战斗单位防御分数 = {血量+【（血量*闪避率*（1+韧性）】}*（1+防护率）*（1+装甲）
--获取单个单位战斗力：单个战斗单位攻击分数 + 单个战斗单位防御分数
function Formula:getFight(id)
    local cInfo = Tank[id]
    local addAttr = PlayerData:getInstanse().warUnitAddAttrs[cInfo.type]
    local hit = cInfo.hit + addAttr.addHit
    local armor = cInfo.armor + addAttr.addArmor
    local atk = (cInfo.atk+cInfo.atk*addAttr.addAtk)*10
    local crit = addAttr.addCrit+cInfo.crit --暴击几率
    local critAtk = addAttr.addCritAtk + cInfo.critAtk --爆伤
    local pierce = addAttr.addPierce + cInfo.pierce --穿透
    local atkScale = (atk+atk*crit*critAtk)*(1+pierce)*(1+hit)
    local hp = addAttr.addHp*cInfo.hp + cInfo.hp
    local dodge = addAttr.addDodge + cInfo.dodge --闪避
    local tenacity = addAttr.addTenacity + cInfo.tenacity -- 韧性
    local def = addAttr.addDef + cInfo.def--防护率
    local defScale = (hp+hp*dodge*(1+tenacity))*(1+def)*(1+armor)
    return (defScale+atkScale)/3
end

--获取将领强度   ----将领4项属性之和 *10 + 将领技能等级之和 *35
function Formula:getRoleFight(info)
    local attr = info.hit + info.dodge + info.crit + info.armor + info.pierce + info.def
    local skill = 0
    for _,info in ipairs(info.commanderSkillVOs) do
        skill = skill + info.lv
    end
    return math.ceil(attr*10 + skill*35)
end

--获取通过将领加强后的坦克属性
function Formula:getFightAddRole(tankId,roleId)
    local roleInfo = GeneralData:get(roleId)
    if roleInfo then
        local cInfo = Tank[tankId]
        local addAttr = PlayerData:getInstanse().warUnitAddAttrs[cInfo.type]
        local hit = cInfo.hit + addAttr.addHit + roleInfo.hit/100
        local armor = cInfo.armor + addAttr.addArmor + roleInfo.armor/100
        local atk = (cInfo.atk+cInfo.atk*addAttr.addAtk)*10
        local crit = addAttr.addCrit+cInfo.crit + roleInfo.crit/100 --暴击几率
        local critAtk = addAttr.addCritAtk + cInfo.critAtk --爆伤
        local pierce = addAttr.addPierce + cInfo.pierce + roleInfo.pierce/100 --穿透
        local atkScale = (atk+atk*crit*critAtk)*(1+pierce)*(1+hit)
        local hp = addAttr.addHp*cInfo.hp + cInfo.hp
        local dodge = addAttr.addDodge + cInfo.dodge + roleInfo.dodge/100 --闪避
        local tenacity = addAttr.addTenacity + cInfo.tenacity -- 韧性
        local def = addAttr.addDef + cInfo.def + roleInfo.def/100--防护率
        local defScale = (hp+hp*dodge*(1+tenacity))*(1+def)*(1+armor)
        return (defScale+atkScale)/3
    else
        return self:getFight(tankId)
    end
end

return Formula