
-- 全程一个玩家，Player这个文件就相当于一个实例
local Player = {}
local Connect = require("src/app/util/Connect")
local ServerListView = require("src/app/views/login/ServerListView")
local CreateRoleView = require("src/app/views/login/CreateRoleView")

function Player.initSocket()
    ServerListView:enterDefault(function(server)
        local user = cc.UserDefault:getInstance()

        local ip = server.host
        local port = server.port
        Player.sessionKey = user:getStringForKey("sessionKey")
        --local cjson = require("cjson")
        --require("src/app/util/SDKPlatform")
        --SDKPlatform:printLog("serverList="..cjson.encode(response.data.serverList))
        SDKPlatform:printLog("you will connect network.ip:"..ip..",port:"..port)
        Connect:conect(ip,port,function(isReconnect)
            local msg = {sessionKey=Player.sessionKey,channelId = SDKPlatform:getSDKId(),serverId=SDKPlatform:get("ServerId"),isReconnect=isReconnect}
            Connect:sendMsg("LoginAction","initLogin",msg,Player.initPlayer,not isReconnect)
        end)
    end)
end

function Player.initPlayer(data)
    if data.state == 0 then
        RegisterCleanUp:handle(true) --数据清除
        CreateRoleView:open(display.getRunningScene(),function(name,type,node)
            local msg = {sessionKey=Player.sessionKey,
                        name = name,
                        serverId=SDKPlatform:get("ServerId"),
                        icon = type}
            Connect:sendMsg("LoginAction","createPlayer",msg,function(newdata)
                node:removeFromParent()
                Player.createPlayer(newdata)
            end,true)
        end)
    elseif data.state == 2 then
        Connect:registerAllMsg()
    else
        RegisterCleanUp:handle(true) --数据清除
        Player.createPlayer(data)
    end
end

function Player.createPlayer(data)
    if data.state == 1 then
        local msg = {playerId=data.playerId}
        Connect:sendMsg("LoginAction","loadPlayer",msg,Player.loadPlayer,true)
   end
end

function Player.loadPlayer(data)
    if data.state == 1 then
        Player.enterGame(data)
        local user = cc.UserDefault:getInstance()
        for k,v in pairs(data) do
            if k~="state" then
                user:setStringForKey(k,v)
            end
        end
--        local msg = {}
--        Connect:sendMsg("CityAction","intoCity",msg,Player.enterGame,false)
    end
end

function Player.enterGame(data1)
    require("src/app/unit/GeneralData") --将领数据
    local pd = PlayerData:getInstanse()
    Connect:sendMsg("InterfaceAction","loadInterface",nil,
        function(data)
            GeneralData:init()

            --基本数据
            pd.basicData = data.playerInfoVO
            --基础建筑
            pd.baseBuild = data.middleInterfaceVOs

            --坦克
            pd.tanks = data.troops

            --坦克附加属性
            pd.warUnitAddAttrs = data.warUnitAddAttrs

            --郊外建筑
            pd.outSideBuild = data.outskirtsInterfaceVO.outskirtsBlockVOs

            --敌军来袭
            pd.EnemyIncoming = data.atkWorldInfoVOs

            pd.FriendTroop = {}
            for key, var in pairs(data.garrisonTroopVOs) do
                pd.FriendTroop[var.playerId..var.armyId] = var
            end

            app:enterScene("WorldScene")
            SDKPlatform:initRole()
            --新手引导开始
            NoviceGuide:start(gWorldScene)
            gWorldScene:CheckSpaceOutSide()


            gWorldScene:NoviceGuideWomenshow()


        end,true)
end

return Player