

Unit = class("Unit",function()
    return cc.Node:create()
end)

function Unit.create(data)
    local unit = Unit.new(data)
    if unit ~= nil then
        return unit
    end
    return nil
end

local ActionTypes = {
    BEFORE_FIRE = 1, --开火前
    AFTER_FIRE = 2, --开火后
    HIT = 3, --命中
    HIT_AIM = 4, --命中目标
}

function Unit:ctor(data)

    self.data = data
    self.unitNode = nil
    self.unitAnimation = nil
    self.numBg = nil
    self.header = nil
    self.textNum = nil
    --    self.onfire = false
    self.lv_buffs = nil
    self.buffsdata = nil
    self.tab_effects = {}
    self:init()
end

function Unit:init()
    self.numBg = self.data.content:getChildByName("icon_numBg"):clone()
    self.lv_buffs = self.data.content:getChildByName("listview_buffs"):clone()
    if self.data.commander > 0 then
        self.header = self.data.content:getChildByName("panel_general"):clone()
    end
    self.textNum = self.numBg:getChildByName("text_num")
    if self.data.isTop then
        self.unitNode = Animation:createAnimation(Tank[self.data.baseId].anim_base,nil)
        self.numBg:setPosition(self:getDesPos("up_num"))
        if self.header then
            self.header:setPosition(cc.pAdd(self:getDesPos("up_gun"),cc.p(30,50)))
        end
        --履带烟尘
        self.dustNode = Animation:createAnimationWithType(Tank[self.data.baseId].anim_fog,nil,{isTop = self.data.isTop})
        self.dustNode:setPosition(self:getDesPos("up_smoke_over"))
        self.unitNode:addChild(self.dustNode,10)

        local dustNodeDown = Animation:createAnimationWithType(Tank[self.data.baseId].anim_fog,nil,{isTop = self.data.isTop})
        dustNodeDown:setPosition(self:getDesPos("up_smoke_down"))
        self:addChild(dustNodeDown,-1)

        self.lv_buffs:setPosition(cc.pAdd(self:getDesPos("up_num"),cc.p(24,-36)))
        self.lv_buffs:setAnchorPoint(cc.p(0,0))
    else
        self.unitNode = Animation:createAnimation(Tank[self.data.baseId].anim_base,"down_idle")
        self.numBg:setPosition(self:getDesPos("down_num"))
        if self.header then
            self.header:setPosition(cc.pAdd(self:getDesPos("down_gun"),cc.p(-30,18)))
        end
        --履带烟尘
        self.dustNode = Animation:createAnimationWithType(Tank[self.data.baseId].anim_fog,nil,{isTop = self.data.isTop})
        self.dustNode:setPosition(self:getDesPos("down_smoke_over"))
        --        self.dustNode:setRotation(180)
        self.unitNode:addChild(self.dustNode,10)

        self.dustNodeDown = Animation:createAnimationWithType(Tank[self.data.baseId].anim_fog,nil,{isTop = self.data.isTop})
        self.dustNodeDown:setPosition(self:getDesPos("down_smoke_down"))
        --        self.dustNodeDown:setRotation(180)
        self:addChild(self.dustNodeDown,-1)

        self.lv_buffs:setPosition(cc.pAdd(self:getDesPos("down_num"),cc.p(-24,-36)))
        self.lv_buffs:setAnchorPoint(cc.p(1,0))
    end
    self:addChild(self.unitNode)
    self.unitNode:addChild(self.numBg,500)
    self:setUnitNum(self.data.num)

    self.unitNode:addChild(self.lv_buffs,500)

    --将领头像
    if self.header then
        self.unitNode:addChild(self.header,501)
        self:setCommanderStar(self.data.qua)
        self:setCommanderHead(gGeneral[self.data.commander].icon)
        self:setCommanderVisible(false)
    end

    self.unitAnimation = self.unitNode:getAnimation()
    self:getDesPos("up_gun")
    self:getDesPos("down_gun")
    self:getDesPos("down_smoke_over")
    self:getDesPos("down_smoke_down")
    self:getDesPos("up_smoke_over")
    self:getDesPos("up_smoke_down")
    --    local size = self.unitNode:getBoundingBox()
    --    local anc = self.unitNode:getAnchorPoint()
    --    self:addChild(cc.Sprite:create("pic/common/icon/player/icon_gm.png"))
end

function Unit:getDesPos(name)
    local bone = self.unitNode:getArmature():getBone(name)
    bone:setVisible(false)
    local node = bone:getSlot():getDisplay()
    return cc.p(node:getPositionX(),node:getPositionY())
end

function Unit:getDesUpDownPos(name)
    local str = "down_"
    if self.data.isTop then
        str = "up_"
    end
    local bone = self.unitNode:getArmature():getBone(str..name)
    bone:setVisible(false)
    local node = bone:getSlot():getDisplay()
    return cc.p(node:getPositionX(),node:getPositionY())
end

function Unit:setUnitNum(num)

    if num == 0 then
        self.numBg:setVisible(false)
    else
        self.textNum:setString(num)
        local contentSize = self.textNum:getContentSize()
        contentSize = cc.size(contentSize.width+18,contentSize.height+4)
        self.textNum:setPosition(contentSize.width/2,contentSize.height/2)
        self.numBg:setContentSize(contentSize)
    end
end

function Unit:fireWithData(data)
    self.buffsdata = data.skillBuffs
    self.skillBuffsCounter = 0
    --当前发射次数
    self.fireCounter = 0
    --总发射次数
    self.fireTotal = #data.aims
    local delayIime = self:logicSkillEffect(ActionTypes.BEFORE_FIRE)
    NodeTranslator:deltaDo(delayIime,function()
        self:fire(nil)
    end)
    return delayIime
end

function Unit:fire(sender)

    local perFireTime  = B_TIME_PERFIRE
    if Tank[self.data.baseId].type == 4 then
        perFireTime = B_TIME_PERFIRE_ROCKET
    end

    self.fireCounter  = self.fireCounter+1
    
    NodeTranslator:deltaDo(B_BULLET_TIME*2+B_TIME_FIRETOHIT+perFireTime,function()
        if self.skillBuffsCounter then
            self.skillBuffsCounter = self.skillBuffsCounter + 1
        end
        if self.buffsdata and #(self.buffsdata)>0 and self.skillBuffsCounter <= #(self.buffsdata) then
            self:logicSkillEffect(ActionTypes.HIT_AIM)
        end
    end)
    
    if self.fireCounter > self.fireTotal then
        self:runAction(cc.MoveTo:create(1,self.oriPos))
        self:logicSkillEffect(ActionTypes.AFTER_FIRE)
        return
    end

    --攻击音效
    MyAudio:PlayEffect(Tank[self.data.baseId].atkAudio)

    local seq = cc.Sequence:create(cc.DelayTime:create(perFireTime),cc.CallFunc:create(self.fire))
    self:runAction(seq)

    --后坐力动画 anim_recoil
    local recoilNode = Animation:createAnimationWithType(Tank[self.data.baseId].anim_recoil,nil,{isTop = self.data.isTop})
    recoilNode:getArmature():registerAnimationEventHandler(
        function (t)
            recoilNode:removeFromParent()
        end
    )
    recoilNode:setPosition(self:getPosition())
    self:getParent():addChild(recoilNode)

    --弹壳动画
    local shellNode = nil
    if Tank[self.data.baseId].anim_shell ~= "" and Tank[self.data.baseId].anim_shell ~= "0" then
        shellNode = Animation:createAnimationWithType(Tank[self.data.baseId].anim_shell,nil,{isTop = self.data.isTop})
        --        shellNode:getArmature():registerAnimationEventHandler(
        --            function (t)
        --                shellNode:stopAllActions()
        --                shellNode:removeFromParent()
        --            end
        --        )
        self:getParent():addChild(shellNode,90)
    end

    --子弹动画
    local bulletNode = nil
    local strFire = "_gun"
    local _info = B_BULLET_DATA[Tank[self.data.baseId].type]
    if self.data.isTop then
        if Tank[self.data.baseId].type ~= 4 then
            self.unitAnimation:gotoAndPlay("up_attack")
        end
        strFire = "up"..strFire

        --火箭没有后坐力向后移动  /子弹轨迹不同
        local bulletX = _info.top.x --B_BULLET_X1
        local bulletY = _info.top.y --B_BULLET_Y1
        if Tank[self.data.baseId].type == 3 or Tank[self.data.baseId].type == 4 then
        --            bulletX = B_BULLET_RUP_X
        --            bulletY = B_BULLET_RUP_Y
        else
            self:runAction(cc.MoveBy:create(B_RECOIL_TIME,cc.p(B_RECOIL_X,B_RECOIL_Y)))
            recoilNode:runAction(cc.MoveBy:create(1,cc.p(B_SPEED_X,B_SPEED_Y)))
        end

        bulletNode = Animation:createAnimationWithType(Tank[self.data.baseId].anim_bullet,nil,{isTop = self.data.isTop})
        bulletNode:setVisible(false)
        bulletNode:runAction(cc.Sequence:create(cc.DelayTime:create(0.1),cc.Show:create(),cc.MoveBy:create(B_BULLET_TIME,cc.p(bulletX,bulletY)),cc.CallFunc:create(function()
            bulletNode:removeFromParent()
        end)))

        --子弹旋转
        local diry = {x = 1,y = 0}
        local angle = cc.pGetAngle(cc.p(bulletX,bulletY),diry)
        bulletNode:setRotation(math.deg(angle))

        local pPos = {}
        pPos.x , pPos.y = self:getPosition()
        local cPos = self:getDesPos("up_num")
        pPos.x = pPos.x+cPos.x
        pPos.y = pPos.y+cPos.y
        if shellNode then
            shellNode:setPosition(pPos)
            shellNode:runAction(cc.Sequence:create(cc.MoveBy:create(B_TIME_DEAD_RM,cc.p(B_SPEED_X*B_TIME_DEAD_RM,B_SPEED_Y*B_TIME_DEAD_RM)),cc.CallFunc:create(function()
                shellNode:removeFromParent()
            end)))
        end
    else
        strFire = "down"..strFire
        if Tank[self.data.baseId].type ~= 4 then
            self.unitAnimation:gotoAndPlay("down_attack")
        end

        local bulletX = _info.bottom.x -- -B_BULLET_X1
        local bulletY = _info.bottom.y -- -B_BULLET_Y1
        if Tank[self.data.baseId].type == 3 or Tank[self.data.baseId].type == 4 then
        --            bulletX = B_BULLET_RDOWN_X
        --            bulletY = B_BULLET_RDOWN_Y
        else
            self:runAction(cc.MoveBy:create(B_RECOIL_TIME,cc.p(-B_RECOIL_X,-B_RECOIL_Y)))
            recoilNode:runAction(cc.MoveBy:create(1,cc.p(-B_SPEED_X,-B_SPEED_Y)))
        end

        bulletNode = Animation:createAnimationWithType(Tank[self.data.baseId].anim_bullet,nil,{isTop = self.data.isTop})
        bulletNode:setVisible(false)
        bulletNode:runAction(cc.Sequence:create(cc.DelayTime:create(0.1),cc.Show:create(),cc.MoveBy:create(B_BULLET_TIME,cc.p(bulletX,bulletY)),cc.CallFunc:create(function()
            bulletNode:removeFromParent()
        end)))

        --子弹旋转
        local diry = {x = 1,y = 0}
        local angle = cc.pGetAngle(cc.p(bulletX,bulletY),diry)
        bulletNode:setRotation(math.deg(angle))

        local pPos = {}
        pPos.x , pPos.y = self:getPosition()
        local cPos = self:getDesPos("down_num")
        pPos.x = pPos.x+cPos.x
        pPos.y = pPos.y+cPos.y
        if shellNode then
            shellNode:setPosition(pPos)
            shellNode:runAction(cc.Sequence:create(cc.MoveBy:create(B_TIME_DEAD_RM,cc.p(-B_SPEED_X*B_TIME_DEAD_RM,-B_SPEED_Y*B_TIME_DEAD_RM)),cc.CallFunc:create(function()
                shellNode:removeFromParent()
            end)))
        end
        recoilNode:setPositionY(recoilNode:getPositionY()-20) --美术代码调位置
    end

    local firePos = self:getDesPos(strFire)
    if Tank[self.data.baseId].type == 4 then --火箭车  子弹偏移
        local data = B_ROCKET_FIRE_OFFSET.bottom
        if self.data.isTop then
            data = B_ROCKET_FIRE_OFFSET.top
        end
        firePos = cc.pAdd(data[self.fireCounter],firePos)
    end
    --开火火焰
    local fireNode = Animation:createAnimationWithType(Tank[self.data.baseId].anim_fire,nil,{isTop = self.data.isTop})
    fireNode:setPosition(firePos)
    fireNode:getArmature():registerAnimationEventHandler(
        function (t)
            fireNode:removeFromParent()
        end
    )
    self:addChild(fireNode)

    bulletNode:setPosition(firePos)
    self:addChild(bulletNode)

end

function Unit:shield()

end

function Unit:dead(data)
    --    self:setLocalZOrder(90)
    self:stopActionByTag(100)
    self:removeAllBuffs() --移除身上buff
    --死亡
    MyAudio:PlayEffect(MusicAndEffect.unitDead)

    if self.fireNode then self.fireNode:removeFromParent() end
    if self.dustNode then self.dustNode:removeFromParent() end
    if self.dustNodeDown then self.dustNodeDown:removeFromParent() end
    if self.data.isTop then
        --        self.unitAnimation:gotoAndPlay("up_dead")
        self.data.content:getParent():removeUnitWithKey(UNITTOP..self.data.index)
        self:runAction(cc.Sequence:create(cc.MoveBy:create(B_TIME_DEAD_RM,cc.p(B_SPEED_X*B_TIME_DEAD_RM,B_SPEED_Y*B_TIME_DEAD_RM)),cc.CallFunc:create(function()
            self:removeFromParent()
        end)))
    else
        --        self.unitAnimation:gotoAndPlay("down_dead")
        self.data.content:getParent():removeUnitWithKey(UNITBOTTOM..self.data.index)
        self:runAction(cc.Sequence:create(cc.MoveBy:create(B_TIME_DEAD_RM,cc.p(-B_SPEED_X*B_TIME_DEAD_RM,-B_SPEED_Y*B_TIME_DEAD_RM)),cc.CallFunc:create(function()
            self:removeFromParent()
        end)))
    end

    --死亡残骸
    self.unitNode:setVisible(false)
    local deadNode = Animation:createAnimationWithType(Tank[self.data.baseId].deathwreckage,nil,{isTop = self.data.isTop})
    local tmpUnitBox = self.unitNode:getBoundingBox()
    local tmpDeadBox = deadNode:getBoundingBox()
    deadNode:setScale(tmpUnitBox.width / tmpDeadBox.width)
    self:addChild(deadNode,-1)

    local node = Animation:createAnimationWithType(Tank[self.data.baseId].anim_die,nil,{isTop = self.data.isTop})
    node:getArmature():registerAnimationEventHandler(
        function (t)
            node:removeFromParent()
        end
    )
    self:addChild(node)
end

function Unit:fadeOutAction(node,isCrit)
    node:setScale(0.1)
    if isCrit then
        node:runAction(cc.Sequence:create(cc.ScaleTo:create(0.1,1.5),cc.ScaleTo:create(0.1,0.75)))
    else
        node:runAction(cc.ScaleTo:create(0.2,0.5))
    end
    node:runAction(cc.Sequence:create(cc.MoveBy:create(0.1,cc.p(0,40)),cc.DelayTime:create(0.4),cc.CallFunc:create(function()
        node:runAction(cc.FadeOut:create(0.8))
        node:runAction(cc.Sequence:create(cc.MoveBy:create(0.8,cc.p(0,100)),cc.CallFunc:create(function()
            node:removeFromParent()
        end)))
    end)))
end

function Unit:fadeOutActionMiss(node)
    node:setScale(0.1)
    node:runAction(cc.ScaleTo:create(0.2,1))
    node:runAction(cc.Sequence:create(cc.MoveBy:create(0.1,cc.p(0,40)),cc.DelayTime:create(0.4),cc.CallFunc:create(function()
        node:runAction(cc.FadeOut:create(0.8))
        node:runAction(cc.Sequence:create(cc.MoveBy:create(0.8,cc.p(0,100)),cc.CallFunc:create(function()
            node:removeFromParent()
        end)))
    end)))
end
--是否是空中支援伤害
function Unit:hitCallBack(data,isJetSupport)
    if data.skillBuffs then
        self:logicSkillEffect(ActionTypes.HIT)
    end

    local strHit = nil --击中效果资源
    --被击音效
    if isJetSupport then
        MyAudio:PlayEffect(MusicAndEffect.jetHit)
        strHit = B_JET_HIT
    else
        MyAudio:PlayEffect(Tank[data.who.data.baseId].hitAudio)
        strHit = Tank[data.who.data.baseId].anim_hit
    end
--    data.type = 2
    if data.type == 0 or data.type == 1 then --普通伤害
        local numNode = cc.LabelBMFont:create("-"..data.hurt, "res/pic/common/text/number/num01/num_60.fnt")
        numNode:setPosition(self:getPosition())
        self:getParent():getParent():addChild(numNode,120)
        if data.type == 1 then--暴击
            self:fadeOutAction(numNode,true)
            if self.data.isTop then
                self:getParent():getParent():shakeScreen(self:getParent())
            else
                self:getParent():getParent():getParent():shakeScreen(self:getParent())
            end
        else
            self:fadeOutAction(numNode)
        end

    elseif data.type == 2 then --miss
        local node = Animation:createAnimationWithType(Tank[self.data.baseId].anim_miss,nil,{isTop = self.data.isTop})
        node:setPosition(self:getDesUpDownPos("gun"))
        node:getArmature():registerAnimationEventHandler(
            function (t)
                node:removeFromParent()
            end
        )
        self:addChild(node)
        local missNode = cc.Sprite:create("res/pic/battle/icon/icon_MISS.png")
        missNode:setPosition(self:getPosition())
        self:getParent():getParent():addChild(missNode,120)
        self:fadeOutActionMiss(missNode)
    end

    if data.restrain == 1 then --克制
        local node = Animation:createAnimationWithType(Tank[self.data.baseId].anim_shield1,nil,{isTop = self.data.isTop})
        local pos = cc.p(0,-20)
        if not self.data.isTop then
            pos = cc.p(20,-10)
        end
        node:setPosition(cc.pAdd(self:getDesUpDownPos("gun"),pos))
        node:getArmature():registerAnimationEventHandler(
            function (t)
                node:removeFromParent()
            end
        )
        self:addChild(node)
    elseif data.restrain ==2 then--反克制
        local node = Animation:createAnimationWithType(Tank[self.data.baseId].anim_shield2,nil,{isTop = self.data.isTop})
        local pos = cc.p(0,-20)
        if not self.data.isTop then
            pos=cc.p(20,-10)
        end
        node:setPosition(cc.pAdd(self:getDesUpDownPos("gun"),pos))
        node:getArmature():registerAnimationEventHandler(
            function (t)
                if t.type == 7 then
                    node:removeFromParent()
                end
            end
        )
        self:addChild(node)
    end

    --燃烧状态
    --if not self.onfire then
    --    if data.remain/self.data.num < B_ONFIRE_PERCENT then
    --        self.fireNode = Animation:createAnimation(Tank[self.data.baseId].anim_onfire)
    --        self:addChild(self.fireNode)
    --        self.onfire = true
    --    end
    --end

    self:setUnitNum(data.remain)
    if data.remain== 0 then
        self:dead(data)
    else

        --miss无击中效果
        if not (data.type == 2) then
            local node = Animation:createAnimationWithType(strHit,nil,{isTop = self.data.isTop})
            node:getArmature():registerAnimationEventHandler(
                function (t)
                    node:removeFromParent()
                end
            )
            self:addChild(node)
        end
    end

end

function Unit:hit(data)
    self.buffsdata = data.skillBuffs
    --子弹动画
    local bulletNode = nil
    local _info = B_BULLET_DATA[Tank[data.who.data.baseId].type]
    if self.data.isTop then
        local bulletX = -_info.top.x --B_BULLET_X1
        local bulletY = -_info.top.y--B_BULLET_Y1

        --        if Tank[data.who.data.baseId].type ==3 or Tank[data.who.data.baseId].type ==4 then
        --            bulletX = -B_BULLET_RUP_X
        --            bulletY = -B_BULLET_RUP_Y
        --        end

        bulletNode = Animation:createAnimationWithType(Tank[data.who.data.baseId].anim_bullet,nil,{isTop = self.data.isTop})
        bulletNode:runAction(cc.Sequence:create(cc.MoveBy:create(B_BULLET_TIME,cc.p(bulletX,bulletY)),cc.CallFunc:create(function()
            bulletNode:removeFromParent()
            self:hitCallBack(data)
        end)))
        bulletNode:setPosition(-bulletX,-bulletY)

        --子弹旋转
        local diry = {x = 1,y = 0}
        local angle = cc.pGetAngle(cc.p(bulletX,bulletY),diry)
        bulletNode:setRotation(math.deg(angle))

    else

        local bulletX = _info.bottom.x--B_BULLET_X1
        local bulletY = _info.bottom.y--B_BULLET_Y1

        --        if Tank[data.who.data.baseId].type ==3 or Tank[data.who.data.baseId].type ==4 then
        --            bulletX = B_BULLET_RDOWN_X
        --            bulletY = B_BULLET_RDOWN_Y
        --        end

        bulletNode = Animation:createAnimationWithType(Tank[data.who.data.baseId].anim_bullet,nil,{isTop = self.data.isTop})
        bulletNode:runAction(cc.Sequence:create(cc.MoveBy:create(B_BULLET_TIME,cc.p(-bulletX,-bulletY)),cc.CallFunc:create(function()
            bulletNode:removeFromParent()
            self:hitCallBack(data)
        end)))
        bulletNode:setPosition(bulletX,bulletY)

        --子弹旋转
        local diry = {x = 1,y = 0}
        local angle = cc.pGetAngle(cc.p(-bulletX,-bulletY),diry)
        bulletNode:setRotation(math.deg(angle))

    end


    self:addChild(bulletNode)

end

function Unit:autoMove(dt)
    local rad = math.random(50,100)/50
    local dis = 18
    if rad < 1.5 then
        dis = -dis
    end
    local action = cc.Sequence:create(cc.MoveBy:create(rad,cc.p(dis,dis/B_SPEED_X*B_SPEED_Y)),cc.MoveTo:create(rad,self.oriPos),cc.CallFunc:create(self.autoMove))
    action:setTag(100)
    self:runAction(action)
end

--设置单位位置
function Unit:setPos(x,y)
    self.oriPos = cc.p(x,y)
    self:setPosition(x,y)
    self:autoMove(0)
end

function Unit:setCommanderStar(star)
    local Image_star_bg = self.header:getChildByName("Image_star_bg")
    for i = 1 , 5 do
        local item = Image_star_bg:getChildByName("panel_star_"..i)
        item:setVisible(i==star)
    end
    Common:changePic(self.header:getChildByName("panel_outline"),gGeneralQualityIcon[star])
end

function Unit:setCommanderHead(icon)
    Common:changePic(self.header:getChildByName("icon_avatar"),icon)
end

function Unit:setCommanderVisible(vis)
    if self.header then
        self.header:setVisible(vis)
    end
end

--    BEFORE_FIRE , --开火前
--    AFTER_FIRE, --开火后
--    HIT, --命中
function Unit:logicSkillEffect(type)
    local delayTime = 0
    if self.buffsdata then

        if type == ActionTypes.HIT_AIM and #(self.buffsdata) > 0 then  --命中目标的效果
            local v = self.buffsdata[self.skillBuffsCounter]
            local sInfo = gTankskill[v.skillId]
            if sInfo.condition == 3 and v.type == 1 then --显示效果命中目标后
                self:addSkillEffect(v)
            elseif sInfo.disbuff == 4 and v.type == 0 then --消失效果命中目标后
                self:removeSkillEffect(v)
            end
            delayTime = B_ONFIRE_TIME
        else

            for i,v in ipairs(self.buffsdata) do
                local sInfo = gTankskill[v.skillId]
                if sInfo == nil then break end

                if type == ActionTypes.BEFORE_FIRE  and sInfo.disbuff == 1 and v.type == 0 then --消失效果开火前
                    self:removeSkillEffect(v)
                elseif type == ActionTypes.AFTER_FIRE  and sInfo.disbuff == 2 and v.type == 0 then --消失效果开火后
                    self:removeSkillEffect(v)
                elseif type == ActionTypes.HIT  and sInfo.disbuff == 3 and v.type == 0 then --消失效果命中后
                    self:removeSkillEffect(v)
                elseif type == ActionTypes.AFTER_FIRE and sInfo.condition == 1 and v.type == 1 then --显示效果开火后
                    self:addSkillEffect(v)
                elseif type == ActionTypes.HIT and sInfo.condition == 2 and v.type == 1 then --显示效果命中后
                    self:addSkillEffect(v)
                end

                if type == ActionTypes.BEFORE_FIRE and sInfo.etype == 4 then --燃烧伤害
                    local numNode = cc.LabelBMFont:create("-"..v.effect, "res/pic/common/text/number/num01/num_60.fnt")
                    numNode:setPosition(self:getPosition())
                    self:getParent():getParent():addChild(numNode,120)
                    self:fadeOutAction(numNode)
                    self:setUnitNum(v.remain)
                    if v.remain== 0 then --燃烧死亡
                        self:dead(nil)
                    end
                    delayTime = B_ONFIRE_TIME
                end

            end

        end
    end
    return delayTime
end

function Unit:addSkillEffect(data)
    local sInfo = gTankskill[data.skillId]

    local tmpBuff= self.lv_buffs:getChildByName("SkillBuff"..sInfo.etype)
    if tmpBuff then
        if tmpBuff.setNum then tmpBuff.setNum(data.effect)  end --刷新buff数字
        return
    end
    if self.unitNode:getChildByName("SkillEffect"..sInfo.etype) then return end


    if sInfo.skilleffects and sInfo.skilleffects ~= "" and sInfo.skilleffects ~= "0" then
        local effects = string.split(sInfo.skilleffects,",")
        local vpoints = string.split(sInfo.vpoint,",")
        local layers = string.split(sInfo.layer,",")
        local effect = Animation:createAnimationWithType(effects[1],nil,{isTop = self.data.isTop})
        effect:setName("SkillEffect"..sInfo.etype)
        self.tab_effects["SkillEffect"..sInfo.etype] = effect
        if #effects > 1 then
            for i = 2, #effects ,1 do
                local child = Animation:createAnimationWithType(effects[i],nil,{isTop = self.data.isTop})
                self.unitNode:addChild(child,tonumber(layers[i])) 
                if vpoints[i] then
                    effect:setPosition(self:getDesUpDownPos(vpoints[i]))
                end
                effect.children = {}
                table.insert(effect.children,child)
            end
        end

        if sInfo.vpoint and sInfo.vpoint ~= "" and sInfo.vpoint ~= "0" then
            effect:setPosition(self:getDesUpDownPos(vpoints[1]))
        end
        self.unitNode:addChild(effect,10+tonumber(layers[1]))
    end

    if sInfo.bufficon and sInfo.bufficon ~= "" and sInfo.bufficon ~= "0" then
        local buff = Animation:createAnimation(sInfo.bufficon)
        local box = buff:getBoundingBox()
        local widget = ccui.Widget:create()
        widget:setContentSize(box.width,box.height)
        buff:setPosition(box.width/2,box.height/2)
        widget:addChild(buff)

        --buff 上的数字
        if sInfo.etype ~= 4 and sInfo.covertime ~= 0 then
            local text = ccui.Text:create()
            text:enableOutline(cc.c4b(0,0,0,255),3)
            text:setAnchorPoint(0.5,0)
            text:setPosition(cc.p(box.width/2,box.height+6))
            widget:addChild(text)
            function setNum(num)
                text:setString(num)
            end
            widget.setNum = setNum
            widget.setNum(data.effect)
        end

        widget:setName("SkillBuff"..sInfo.etype)
        self.lv_buffs:pushBackCustomItem(widget)
        self:reSizeLvbuffs()

    end
end

function Unit:removeSkillEffect(data)
    local sInfo = gTankskill[data.skillId]
    local effect = self.unitNode:getChildByName("SkillEffect"..sInfo.etype)
    if effect then
        self.tab_effects["SkillEffect"..sInfo.etype] = nil
        effect:removeFromParent()
        if effect.children then
            for i,v in ipairs(effect.children) do
                v:removeFromParent()
            end
        end
    end
    local buff = self.lv_buffs:getChildByName("SkillBuff"..sInfo.etype)
    if buff then
        self.lv_buffs:removeItem(self.lv_buffs:getIndex(buff))
        self:reSizeLvbuffs()
    end
end

function Unit:reSizeLvbuffs()
    local items = self.lv_buffs:getItems()
    local totalWidth = (#items - 1) * self.lv_buffs:getItemsMargin();
    for i,v in ipairs(items) do
        totalWidth = totalWidth+v:getContentSize().width
    end
    self.lv_buffs:setContentSize(cc.size(totalWidth,self.lv_buffs:getContentSize().height))
end

function Unit:removeAllBuffs()
    self.lv_buffs:removeAllItems()
    --同时移除所有特效
    for k,v in pairs(self.tab_effects) do
        v:removeFromParent()
        if v.children then
            for i,v in ipairs(v.children) do
                v:removeFromParent()
            end
        end
    end
    self.tab_effects = {}
end

return Unit