
require("src/app/util/StringTemp")

Animation = {}




--gUIeffect[9].effect
function Animation:showNum(node,numnode,num)

    local oprateNode = node:getChildByName(numnode:getName())

    if oprateNode == nil then
        node:addChild(numnode)
        oprateNode = numnode
    end
    if num >= 100 then
        oprateNode:getChildByName("Text_num"):setScale(0.66)
    end
    oprateNode:getChildByName("Text_num"):setString(num)

    local size = node:getContentSize()
    oprateNode:setPosition( cc.p(size.width,size.height) )
end
function Animation:hideNum(node,numnode)
    local t = node:getChildByName(numnode:getName())
    if t ~= nil then
        node:removeChild(t)
    end
end


--gUIeffect[9].effect
function Animation:playAnimation(node,modelString,locksize,space)
    if node:getChildByName(modelString) == nil then
        local anim = Animation:createAnimation(modelString)
        anim:setName(modelString)
        node:addChild(anim)
        local mysize = anim:getBoundingBox()

        local xishux = (0-mysize.x)-mysize.width/2
        local xishuy = (0-mysize.y)-mysize.height/2

        local size = node:getContentSize()
        anim:setPosition( cc.p(size.width*0.5+xishux,size.height*0.5+xishuy) )
        mysize = anim:getBoundingBox()
        if locksize then
            if space == nil then
                space = 0
            end
            --anim:setScale(1.3,1.3)
            --anim:setScale(size.width/node:getScaleX()/mysize.width,size.height/node:getScaleY()/mysize.height)
            anim:setScale(size.width/(mysize.width-space),size.height/(mysize.height-space))
        end
    end
end


function Animation:playAnimation2(node,modelString,scale)

    --if gUIeffect[6].effect == modelString then
    if not NoviceGuide:getState() then
        if node:getChildByName(modelString) == nil then
            local anim = Animation:createAnimation(modelString)
            anim:setName(modelString)
            node:addChild(anim)
            local mysize = anim:getBoundingBox()

            --local xishux = (0-mysize.x)-mysize.width/2
            --local xishuy = (0-mysize.y)-mysize.height/2

            local size = node:getContentSize()
            anim:setPosition( cc.p(size.width*0.5,size.height*0.5) )
            mysize = anim:getBoundingBox()
            if scale then
                anim:setScale(scale,scale)
            end
            return anim
        end
    end
    --end
    return nil


end



function Animation:playAnimation3(node,modelString,name,pos)

    --if gUIeffect[6].effect == modelString then
    if not NoviceGuide:getState() then
        if node:getChildByName(name) == nil then
            local anim = Animation:createAnimation(modelString)
            anim:setName(name)
            node:addChild(anim)
            local mysize = anim:getBoundingBox()

            --local xishux = (0-mysize.x)-mysize.width/2
            --local xishuy = (0-mysize.y)-mysize.height/2

            local size = node:getContentSize()
            
            if pos == nil then
            	pos = {x = 0,y = 0}
            end
            
            anim:setPosition( cc.p(size.width*0.5+pos.x,size.height*0.5+pos.y) )
            
            return anim
        end
    end
    --end
    return nil


end



--主界面锤子动画
function Animation:playChuiziAnimation(node,name,position)
    if node:getChildByName(name) == nil then
        local anim = Animation:createAnimation(gUIeffect[20].effect)
        anim:setName(name)
        node:addChild(anim)
        local mysize = anim:getBoundingBox()

        --local xishux = (0-mysize.x)-mysize.width/2
        --local xishuy = (0-mysize.y)-mysize.height/2

        local size = node:getContentSize()
        anim:setPosition( position )
        mysize = anim:getBoundingBox()
    end
end


--


function Animation:stopAnimation(node,modelString)
    local anim = node:getChildByName(modelString)
    if anim ~= nil then
        node:removeChild(anim)
    end
end

-- 创建动画
function Animation:createAnimation(modelString,animString)

    local function fun(modelString,animString)
        if modelString == nil or modelString == "" or modelString == "0" then
            return nil
        end

        local s = StringTemp:Split(modelString,";")
        if animString ~= nil then
            s[3] = animString
        end

        db.DBCCFactory:getInstance():loadDragonBonesData(s[1].."/skeleton.xml", s[2])
        db.DBCCFactory:getInstance():loadTextureAtlas(s[1].."/texture.xml", s[2]);
        local node = db.DBCCFactory:getInstance():buildArmatureNode(s[2])
        if node == nil then
            print("not found "..s[2])
            return nil
        end
        node:getAnimation():gotoAndPlay(s[3])
        return node
    end

    local t = StringTemp:Split(modelString,"@")
    if #t == 1 then
        return fun(modelString,animString)
    else
        local node = cc.Node:create()
        for key, var in pairs(t) do
            local n = fun(var,animString)
            if n ~= nil  then
                node:addChild(n)
            end

        end
        return node
    end
end

---- 创建动画UP
--function Animation:createAnimationUp(modelString)
--    local s = StringTemp:Split(modelString,";")
--    s[2] = "up_"..s[2]
--    db.DBCCFactory:getInstance():loadDragonBonesData(s[1].."/skeleton.xml", s[2])
--    db.DBCCFactory:getInstance():loadTextureAtlas(s[1].."/texture.xml", s[2])
--    local node = db.DBCCFactory:getInstance():buildArmatureNode(s[2])
--    node:getAnimation():gotoAndPlay(s[3])
--    return node
--end
--
---- 创建动画DOWN
--function Animation:createAnimationDown(modelString)
--    local s = StringTemp:Split(modelString,";")
--    s[2] = "down_"..s[2]
--    db.DBCCFactory:getInstance():loadDragonBonesData(s[1].."/skeleton.xml", s[2])
--    db.DBCCFactory:getInstance():loadTextureAtlas(s[1].."/texture.xml", s[2])
--    local node = db.DBCCFactory:getInstance():buildArmatureNode(s[2])
--    node:getAnimation():gotoAndPlay(s[3])
--    return node
--end

function Animation:createAnimationWithType(modelString,animString,data)
    local t = StringTemp:Split(modelString,"#")
    if #t == 1 then
        return Animation:createAnimation(modelString,animString)
    else
        if t[2] == "custom" then
            return Animation:createAnimationWithTypeData(modelString,animString,data)
        elseif t[2] == "flipxy" then
            local node = Animation:createAnimation(t[1],animString)
            if not data.isTop then
                node:setScaleX(-1)
                node:setScaleY(-1)
                if t[3] then
                    node:setRotation(tonumber(t[3]))
                end
            end
            return node
        elseif t[2] == "flipx" then
            local node = Animation:createAnimation(t[1],animString)
            if not data.isTop then
                node:setScaleX(-1)
            end
            return node
        elseif t[2] == "updown" then
            local str = "down_"
            if data.isTop then
                str = "up_"
            end
            local s = StringTemp:Split(t[1],";")
            s[2] = str..s[2]
            db.DBCCFactory:getInstance():loadDragonBonesData(s[1].."/skeleton.xml", s[2])
            db.DBCCFactory:getInstance():loadTextureAtlas(s[1].."/texture.xml", s[2])
            local node = db.DBCCFactory:getInstance():buildArmatureNode(s[2])
            node:getAnimation():gotoAndPlay(s[3])
            return node
        end
    end
end

function Animation:createAnimationWithTypeData(modelString,animString,data)
    local t = StringTemp:Split(modelString,"#")
    if #t == 1 then
        return Animation:createAnimation(modelString,animString)
    else
        local node = Animation:createAnimation(t[1],animString)
        for i,v in ipairs(t) do
            if v == "scale" then
                node:setScale(tonumber(t[i+1]))
            elseif v == "flipy" then
                if not data.isTop then
                    node:setScaleY(-1*node:getScaleY())
                end
            elseif v == "flipx" then
                if not data.isTop then
                    node:setScaleX(-1*node:getScaleX())
                end
            elseif v == "flipxy" then
                if not data.isTop then
                    node:setScaleX(-1*node:getScaleX())
                    node:setScaleY(-1*node:getScaleY())
                end
            elseif v == "rotate" then
                if not data.isTop then
                    node:setRotation(tonumber(t[i+1]))
                end
            end
        end
        return node
    end
end

return Animation