Common = {_code_funcs={}}


function Common:setBtnTouchEnable(btn , enable)
    btn:setBright(enable)
    btn:setEnabled(enable)
    btn:setTouchEnabled(enable)
end

function Common:copyTab(st)
    local tab = {}
    for k, v in pairs(st or {}) do
        if type(v) ~= "table" then
            tab[k] = v
        else
            tab[k] = Common:copyTab(v)
        end
    end
    return tab
end

function Common:getTableLen(table)
    local t = 0
    for key, var in pairs(table) do
    	t = t + 1
    end
    return t

end

function Common:compareTab(d1,d2)
    for key, var in pairs(d1) do
        local var1 = d2[key]
        if type(var) ~= "table" then
            if var ~= var1 then
                return false
            end
        else
            if Common:compareTab(var,var1) == false then
                return false
            end
        end
    end

    return true
end


function Common:sortById(tab)
    local key_test ={}
    for i in pairs(tab) do
        table.insert(key_test,i)
    end
    table.sort(key_test)
    return key_test
end

function Common:setButtonEnabled(button,enable)
    button:setBright(enable)
    button:setEnabled(enable)
    button:setTouchEnabled(enable)
--    button:setTitleColor(enable and CommonColor.White or CommonColor.White)
end

--imageview换图
function Common:changePic(node,picPath)
    --local size = node:getContentSize()
    --local r1 = node:getCapInsets()
    --local s1 = node:getVirtualRendererSize()
    node:loadTexture(picPath,ResType)
    if node:isScale9Enabled() then
        --node:setScale9Enabled(false)
        --local r2 = node:getCapInsets()
        local s1 = node:getVirtualRendererSize()
        node:setCapInsets(cc.rect(0, 0, node:getVirtualRendererSize().width, node:getVirtualRendererSize().height));
    --node:setContentSize(cc.size(size.width,size.height))

    --node:setScale9Enabled(true)
    end

    --node:setContentSize(size)

end

function Common:registerCodeFunc(code,func)
    self._code_funcs[code] = func
end

function Common:showCodeInfo(code)
    local codeInfo = gPrompt_1[code]
    if codeInfo == nil  then
        PromptView:type1(nil,"error code:"..code,StringRes.ok)
    else
        if codeInfo.type == 0 then
            FlyWordPrompt:prompt(codeInfo.word)
        elseif codeInfo.type == 1 then
            PromptView:type1(nil,codeInfo.word,StringRes.ok,function()
                local func = self._code_funcs[code]
                if func then
                   func()
                end
            end)
        elseif codeInfo.type == 2 then
            PromptView:type2(StringRes.notice,
                codeInfo.word
                ,StringRes.ok,StringRes.cancel,
                function()
                    print("buy")
                    Recharge:show(gWorldScene)
                end)
        elseif codeInfo.type == 3 then
            ManyDialogInfo:create_more_produce_queues()
        else
            PromptView:type1(nil,codeInfo.word,StringRes.ok)
        end
    end
end

--建筑升级所需时间
function Common:getBuildingUpTime(upgradeLv,templateId)
    local pd =  PlayerData:getInstanse().PlayerAddition
    local tmp = math.ceil(math.pow(upgradeLv,2.7)*gBuilding[templateId].timecoe*(upgradeLv*0.01+0.3)/(1+pd.buildAdd))-3
    if tmp < 1 then tmp = 1 end
    return tmp
end

function Common:layerCenter(layer)
    layer:setAnchorPoint(cc.p(0.5,0.5))
    layer:setPosition(cc.p(CONFIG_SCREEN_WIDTH/2,CONFIG_SCREEN_HEIGHT/2))
end


--获取存档JSON数据(公告,活动)
function Common:getJsonData(key,key1)

    key1 = tostring(key1)

    local cjson = require("cjson")
    local UserDefault = cc.UserDefault:getInstance()


    local annou = cjson.decode(UserDefault:getStringForKey(key))
    if annou == nil then
        annou = {}
    end
    if annou[key1] == nil then
        annou[key1] = 0
    end

    return annou[key1]
end

--设置存档JSON数据(公告,活动)
function Common:setJsonData(key,key1,data)
    key1 = tostring(key1)

    local cjson = require("cjson")
    local UserDefault = cc.UserDefault:getInstance()


    local annou = cjson.decode(UserDefault:getStringForKey(key))
    if annou == nil then
        annou = {}
    end

    annou[key1] = data
    UserDefault:setStringForKey(key,cjson.encode(annou))


end




























--系统相关

--获取系统版本luaoc.callStaticMethod("SDKNdCom", "registerScriptHandler", {listener = callback})
function Common:getVersion()
    -- call Java method

    if device.platform == "android" then
        local javaClassName = "org/cocos2dx/lua/DeviceInfo"
        local javaMethodName = "getVersion"

        local javaMethodSig =  "()Ljava/lang/String;"
        local ok,version = luaj.callStaticMethod(javaClassName, javaMethodName, "", javaMethodSig)
        return version
    elseif  device.platform == "ios" then
        local ok,version = luaoc.callStaticMethod("CommonApiForLua", "getCurVersion")
        print("---get cur version-----",version)
        return version
    end

    return "1.2.7"
end
--强制更新下载
function Common:downloadApk(url,callback)
    -- call Java method

    if device.platform == "android" then
        local javaClassName = "org/cocos2dx/lua/AppActivity"
        local javaMethodName = "downloadApk"
        local javaParams = {url,callback}
        local javaMethodSig =  "(Ljava/lang/String;I)V"
        luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
    elseif device.platform == "ios" then
print("----url:",url)
        local args = {url=url}
        local ok,ret = luaoc.callStaticMethod("CommonApiForLua", "jumpToInternet", args)
        if not ok then
            print("ios down load apk error")
        end
        callback()
    end


end


--获取机型
function Common:getModel()
    -- call Java method

    if device.platform == "android" then
        local javaClassName = "org/cocos2dx/lua/AppActivity"
        local javaMethodName = "getModel"

        local javaMethodSig =  "()Ljava/lang/String;"
        local ok,version = luaj.callStaticMethod(javaClassName, javaMethodName, "", javaMethodSig)
        return version
    elseif  device.platform == "ios" then
        local ok,model = luaoc.callStaticMethod("CommonApiForLua", "getCurrentDeviceModel")
        return model
    end

    return "C8813D"
end



--获取net
function Common:getNetworkType()
    -- call Java method

    if device.platform == "android" then
        local javaClassName = "org/cocos2dx/lua/AppActivity"
        local javaMethodName = "getNetworkType"

        local javaMethodSig =  "()Ljava/lang/String;"
        local ok,version = luaj.callStaticMethod(javaClassName, javaMethodName, "", javaMethodSig)
        return version
    elseif  device.platform == "ios" then
        --local ok,version = luaoc.callStaticMethod("CommonApiForLua", "getCurVersion")
        return "nettt"
    end

    return "nettt"
end



--获取手机系统版本
function Common:getSysVersion()
    -- call Java method

    if device.platform == "android" then
        local javaClassName = "org/cocos2dx/lua/AppActivity"
        local javaMethodName = "getSysVersion"

        local javaMethodSig =  "()Ljava/lang/String;"
        local ok,version = luaj.callStaticMethod(javaClassName, javaMethodName, "", javaMethodSig)
        return version
    elseif  device.platform == "ios" then
        --local ok,version = luaoc.callStaticMethod("CommonApiForLua", "getCurVersion")
        return "4.0"
    end

    return "4.0"
end


--获取手机总内存
function Common:getSysTotalMemery()
    -- call Java method

    if device.platform == "android" then
        local javaClassName = "org/cocos2dx/lua/AppActivity"
        local javaMethodName = "getTotalMemory"

        local javaMethodSig =  "()I"
        local ok,TotalMemory = luaj.callStaticMethod(javaClassName, javaMethodName, "", javaMethodSig)
        if ok then
            return TotalMemory
        else
            return 2048
        end
        
    elseif  device.platform == "ios" then
        --local ok,version = luaoc.callStaticMethod("CommonApiForLua", "getCurVersion")
        return 2048
    end

    return 2048
end




--获取IMEI
function Common:getImei()
    -- call Java method

    if device.platform == "android" then
        local javaClassName = "org/cocos2dx/lua/AppActivity"
        local javaMethodName = "getImei"

        local javaMethodSig =  "()Ljava/lang/String;"
        local ok,version = luaj.callStaticMethod(javaClassName, javaMethodName, "", javaMethodSig)
        return version
    elseif  device.platform == "ios" then
        --local ok,version = luaoc.callStaticMethod("CommonApiForLua", "getCurVersion")
        return "123456"
    end

    return "123456"
end


--获取运营
function Common:getOperatorName()
    -- call Java method

    if device.platform == "android" then
        local javaClassName = "org/cocos2dx/lua/AppActivity"
        local javaMethodName = "getOperatorName"

        local javaMethodSig =  "()Ljava/lang/String;"
        local ok,version = luaj.callStaticMethod(javaClassName, javaMethodName, "", javaMethodSig)
        return version
    elseif  device.platform == "ios" then
        --local ok,version = luaoc.callStaticMethod("CommonApiForLua", "getCurVersion")
        return "CHINA UNICOM"
    end

    return "CHINA UNICOM"
end

--获取分辨率
function Common:getWidthAndHeight()
    -- call Java method

    if device.platform == "android" then
        local javaClassName = "org/cocos2dx/lua/AppActivity"
        local javaMethodName = "getWidthAndHeight"

        local javaMethodSig =  "()Ljava/lang/String;"
        local ok,version = luaj.callStaticMethod(javaClassName, javaMethodName, "", javaMethodSig)
        return version
    elseif  device.platform == "ios" then
        --local ok,version = luaoc.callStaticMethod("CommonApiForLua", "getCurVersion")
        return "100X100"
    end

    return "100X100"
end















function Common:test()
    -- call Java method

    if device.platform ~= "android" then
        return
    end

    local javaClassName = "org/cocos2dx/lua/AppActivity"
    local javaMethodName = "showAlertDialog"
    local javaParams = {
        "How are you ?",
        "I'm great !",
        function(event)
            local str = "Java method callback value is [" .. event .. "]"
            --btn:setButtonLabel(cc.ui.UILabel.new({text = str, size = 32}))
            print(str)
        end
    }
    local javaMethodSig =  "(Ljava/lang/String;Ljava/lang/String;I)V"
    luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
end

function Common:initBackKey(scene)
    scene:addNodeEventListener(cc.KEYPAD_EVENT, function(event)
        if event.key == "back" then
            SDKPlatform:exit()
        end
    end)
    scene:setKeypadEnabled(true)
end

function Common:setUnitTitleColor(text,tmp)
    text:setColor(CommonColor["TankTitleColor"..tmp.color])
end

function Common:getUnitTitleColor(tmp)
    local color = nil
    if tmp.color then
        color = CommonColor["TankTitleColor"..tmp.color]
    end
    return color
end

--建筑建造升级所需金币量
function Common:getGoldNeedForBuild(data)
    local templateId = data.templateId
    local upgradeLv = data.buildLv+1
    local GoldNeed = Common:getSpendByTime(Common:getBuildingUpTime(upgradeLv,templateId))
    local tempId = templateId.."_"..upgradeLv


    GoldNeed = GoldNeed + Common:getSpendByRes(gBuilding_Consumption[tempId].fe, gBuilding_Consumption[tempId].oil, gBuilding_Consumption[tempId].lead, 0, 0)


    return GoldNeed
end
--时间转换为金钱
function Common:getSpendByTime(time)
    return math.ceil(time/60)*15
end
--需要的资源转换为金钱
--输入的五个参数分别为资源的需求量：铁,石油，铝，合金，水晶
function Common:getSpendByRes(fe, oil, lead, titanium, crystal)    
    local pd = PlayerData:getInstanse()
    local GoldNeed = 0
    local require, own    
    require = fe
    if require >0 then
        own = pd.basicData.ferrum
        if require > own then
            GoldNeed = GoldNeed + math.ceil((require-own)/20000)    
        end
    end
    require = oil
    if require >0 then
        own = pd.basicData.oil
        if require > own then
            GoldNeed = GoldNeed + math.ceil((require-own)/20000)    
        end
    end
    require = lead
    if require >0 then
        own = pd.basicData.lead
        if require > own then
            GoldNeed = GoldNeed + math.ceil((require-own)/20000)    
        end
    end
    require = titanium
    if require >0 then
        own = pd.basicData.titanium
        if require > own then
            GoldNeed = GoldNeed + math.ceil((require-own)/4000)    
        end
    end
    require = crystal
    if require >0 then
        own = pd.basicData.crystal
        if require > own then
            GoldNeed = GoldNeed + math.ceil((require-own)/4000)    
        end
    end
    return GoldNeed
end
return Common