local CONECTTIME = 10
local isReConnectPageOpen = false
local connectUrl = g_LoginConnect
--"http://192.168.0.29:8080"
--local connectUrl = "http://192.168.0.29:8080"
--local connectUrl = "http://59.39.71.72:9090" --k8
--local connectUrl = "http://hstudio.f3322.org:9090" --qa
--local connectUrl = "http://123.59.67.83:9090" --cloud
Connect = {dataCallBack={}}
local cjson = require("cjson")
local uiloader = require("framework.cc.uiloader.uiloader")
local StringRes = require("src/app/cfg/StringRes")
local J20SocketTCP = require("src/app/J20Net/j20SocketTCP")
local Scheduler = cc.Director:getInstance():getScheduler()
local touchEnd = ccui.TouchEventType.ended

local function enterLoginScene()
    local sceneClass = require("src.app.scenes.LoginScene")
    local scene = sceneClass.new(true)
    display.replaceScene(scene)
end

-- 打开遮挡页
local loadLayerView = nil
local function openLoad()
    Connect.closeLoad()
    local scene = display.getRunningScene()
    if scene then 
    local file = "csd/ConnectWaitLayer.csb"
    loadLayerView = uiloader:load(file)
    scene:addChild(loadLayerView,1000)
    local timeLine = cc.CSLoader:createTimeline(file)
    loadLayerView:runAction(timeLine)
    timeLine:gotoFrameAndPlay(0,true)
    end
    return loadLayerView
end

-- 关闭遮挡页
local function closeLoad()
    if loadLayerView then
        local scene = display.getRunningScene()
        scene:removeChild(loadLayerView)
        loadLayerView = nil
    end
end

Connect.openLoad = openLoad
Connect.closeLoad = closeLoad

-- 打开重连界面
local function openReConnect(reConnectBack)
    if isReConnectPageOpen then
        return
    end
    isReConnectPageOpen = true
    local function close()
        isReConnectPageOpen = false
        enterLoginScene()
    end
    local function reConnect()
        isReConnectPageOpen = false
        reConnectBack()
    end
    PromptView:type2(nil,StringRes.text_reconnect,StringRes.ok,StringRes.cancel,
        reConnect,close)
end

local function endScheduler(layer,sch)
    closeLoad(layer)
    if sch then
        Scheduler:unscheduleScriptEntry(sch)
    end
end

local function startScheduler(layer,reConnectBack)
    local sch
    sch = Scheduler:scheduleScriptFunc(
        function()
--            openReConnect(reConnectBack)
            reConnectBack()
            endScheduler(layer,sch)
        end,CONECTTIME,false)
    return sch
end
local function httpCallback(succCallBack)
    return function(event)
        closeLoad()
        local ok = (event.name == "completed")
        local request = event.request
        if not ok then
            -- 请求失败，显示错误代码和错误消息
            if event.name == "failed" then
                PromptView:type1(nil,StringRes.connect_error,StringRes.ok)
            end
            return
        end

        local code = request:getResponseStatusCode()
        if code ~= 200 then
            -- 请求结束，但没有返回 200 响应代码
            print("code:"..code)
            return
        end

        local response = request:getResponseData()
        if response then
            succCallBack(response)
        else
            print("response is nil or false")
        end
    end
end

local function onStatus(callback)
    return function(_event)
        print("socket status:".._event.name)
        if _event.data then
        --print("socket receive raw data:", cc.utils.ByteArray.toString(_event.data, 16))
        end
        if callback then
            -- code 判断
            callback(_event.data,_event.code)
        end
    end
end

--请求一个http
--@param table _t 请求的数据
--@param function succCallBack 带一个服务器返回数据的函数
--@param bool showUI 是否需要显示界面（遮挡曾）
function Connect:requestHttp(_t,succCallBack)
    self.openLoad()
    local function encode(response)
    	local mresp=cjson.decode(response)
    	for k,v in pairs(mresp) do
        	    print("游戏服务器地址：k=",k,"  v=",v)
    	end
        succCallBack(cjson.decode(response))
    end
    local req = network.createHTTPRequest(httpCallback(encode),g_LoginConnect,"POST")
    print("游戏服务器地址：g_LoginConnect=",g_LoginConnect)
    for k,v in pairs(_t) do
        req:addPOSTValue(k,v)
    end
    req:start()
end

function Connect:requestPayHttp(_t,succCallBack,url)
    --self.openLoad()
    local AesHelper = AesHelper:getInstance()
    local function encode(response)
        response = string.gsub(response,"%$%$%$","+")
        local str = AesHelper:aesUncrypt(response)
        local rdata = cjson.decode(str)
        succCallBack(rdata)
    end
    local data = AesHelper:aesEncrypt(cjson.encode(_t))
    data = string.gsub(data,"+","$$$")
    local req = network.createHTTPRequest(httpCallback(encode),
        url or g_PayOrder,"POST")
    req:addPOSTValue("data",data)
    req:start()
end

local MessageCount = 0

--与某个服务器简历链接
function Connect:conect(ip,port,succCallback,isReconnect)
    --ip = "171.214.213.118"

    local layer = not isReconnect and openLoad() or nil

    local function connectSucc()
        closeLoad(layer)
        succCallback(isReconnect)
    end

    local _socket = J20SocketTCP.new(ip, port, false)
    self._reConnectFunc = function()
        self:conect(ip,port,succCallback,true)
    end
    local function sesseionClose(data)
--        openReConnect(self._reConnectFunc)
        
        if MessageCount > 0 then
            --PromptView:type1(nil,"retryconnect",StringRes.ok)
            self:conect(ip,port,succCallback,true)
        end
    end
    local function sessionFailure(data)
        closeLoad(layer)
        if isReconnect then
            self._reConnectFunc()
        else
            PromptView:type1(nil,StringRes.connect_error,StringRes.ok)
        end
    end
    MessageCount = 0
    _socket:addEventListener(J20SocketTCP.EVENT_CONNECTED,connectSucc)
    _socket:addEventListener(J20SocketTCP.EVENT_CLOSE,onStatus(sesseionClose))
    --_socket:addEventListener(J20SocketTCP.EVENT_CLOSED,onStatus(sesseionClose))
    _socket:addEventListener(J20SocketTCP.EVENT_CONNECT_FAILURE,onStatus(sessionFailure))
    --    _socket:addEventListener(J20SocketTCP.EVENT_DATA,onStatus(function(data)
    --        if data then
    --            self:doServerData(data)
    --        end
    --    end))
    _socket:connect()
    self._connect_func = succCallback;
    Common:registerCodeFunc(-1,enterLoginScene)
    Common:registerCodeFunc(-3,enterLoginScene)
    self._socket = _socket
end

--发送消息
local reConnectCount = 0
function Connect:sendMsg(actionName,msgName,data,func,isShowUI)
    if self._socket then
--    if self._socket.isConnected  then
        if isShowUI == nil then
            isShowUI = true
        end
        print("----send msg-----",actionName,msgName)
        MessageCount = MessageCount + 1
        local funcName = msgName..MessageCount
        local layer = isShowUI and openLoad() or nil
        local event = nil
        local timeSchuder = isShowUI and startScheduler(layer,function()
            --self:sendMsg(actionName,msgName,data,func,isShowUI)
            --        app:enterScene("WorldScene")
            --if reConnectCount > 0 then
            --    self._reConnectFunc()
            --else
            --    self._connect_func()
            --end
            closeLoad(layer)
            PromptView:type1(nil,StringRes.timeout,StringRes.ok)
            reConnectCount = reConnectCount + 1
        end)
        event = self._socket:addEventListener(funcName,onStatus(function(data,code)
            endScheduler(layer,timeSchuder)
            self._socket:removeEventListener(event)
            closeLoad(layer)
            reConnectCount = 0
            print("------------rescv msg -----code:",code)
            if code == 1 then
                func(data)
                NoviceGuide:complete(actionName,msgName)
            elseif code == -2 then
                self:reConnectNotBuild()
            else
                Common:showCodeInfo(code)
            end
        end))
        print("1sdkId=",tonumber(SDKPlatform:getSDKId()))
      if self._socket.isConnected  then
      	   print("1sdkId=",tonumber(SDKPlatform:getSDKId()))
      	   print("actionName=",actionName)
		   print("msgName=",msgName)
		   print("cjson.encode(data)=",cjson.encode(data))
		   print("funcName=",funcName)   
        self._socket:send(J20NetDataSend:new(actionName,msgName,cjson.encode(data),funcName,tonumber(SDKPlatform:getSDKId())):convert2chars())
      end

    end
end

--注册服务器主动发送消息的回调
function Connect:register(msgName,callback)
    if self._socket then
        local info = self.dataCallBack[msgName]
        if info then
            self._socket:removeEventListener(info.event)
        end
        local info = {event=nil,name=msgName,callback=callback}
        info.event = self._socket:addEventListener(msgName,onStatus(callback))
        self.dataCallBack[msgName] = info
    end
end

--取消注册
function Connect:unregister(msgName)
    local info = self.dataCallBack[msgName]
    if info and info.event then
        self._socket:removeEventListener(info.event)
        self.dataCallBack[msgName] = nil
    end
end

--注册所有原注册的消息
function Connect:registerAllMsg()
    if self._socket then
        for k,v in pairs(self.dataCallBack) do
            v.event = self._socket:addEventListener(v.name,onStatus(v.callback))
        end
    end
end

function Connect:reConnectNotBuild()
    local msg = {sessionKey=cc.UserDefault:getInstance():getStringForKey("sessionKey")}
    self:sendMsg("LoginAction","reConnect",msg,function(newMsg)
        if newMsg.state == 0 then
            self._connect_func()
        end
    end,true)
end

RegisterCleanUp:register(function()
    if Connect._socket then
        Connect._socket:forceClose()
        Connect._socket:removeAllEventListeners()
        Connect.dataCallBack = {}
        Connect._socket = nil
    end
end,true)--内部接口，执行服务器推送的消息
--function Connect:doServerData(data)
--    local callback = data.callback
--    local _t = self.dataCallBack[callback]
--    if _t then
--        for func,_ in pairs(_t) do
--            func(data.data)
--        end
--    end
--end

return Connect