DialogUtil = {}


function DialogUtil:addClickEvent2(layout , callback)
    DialogUtil:addClickEvent3(layout,"SwallowLayer",callback)
end

function DialogUtil:addClickEvent3(layout , clickLayerName , callback)
    local temp = layout:getChildByName(clickLayerName)
    DialogUtil:addClickEvent(temp,callback)
end

function DialogUtil:addClickEvent(layout, callback)
    layout:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then
            local  bPos = e:getTouchBeganPosition()
            local  ePos = e:getTouchEndPosition()
--            local dis = 1 
--            if  device.platform == "ios" then
--                dis = 10
--            end
            if cc.pGetDistance(bPos,ePos) < 20 then
                MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                callback()
            end
        end
    end)
end

function DialogUtil:speedUp(seconds,callback)
	local need = Common:getSpendByTime(seconds)
    local have = PlayerData:getInstanse().basicData.gold
    local buy = need - have
    if need > have then
        --需要更多金币
        PromptView:type2(nil,string.format(StringRes.gold_not_enough,need,have,buy),StringRes.ok,StringRes.cancel,
        function()
            print("buy !")
            Recharge:show(gWorldScene)
        end)
    else
        PromptView:type2WithConfirm(nil,string.format(StringRes.complete_cost,need,StringRes.coin),StringRes.ok,StringRes.cancel,
            function()
                callback()
            end)
    end
end
--立刻完成建筑升级
function DialogUtil:LvupNow(gold, callback)
    local need = gold
    local have = PlayerData:getInstanse().basicData.gold
    local buy = need - have
    if need > have then
        --需要更多金币
        PromptView:type2(nil,string.format(StringRes.gold_not_enough,need,have,buy),StringRes.ok,StringRes.cancel,
        function()
            print("buy !")
            Recharge:show(gWorldScene)
        end)
    else
        PromptView:type2WithConfirm(nil,string.format(StringRes.complete_cost,need,StringRes.coin),StringRes.ok,StringRes.cancel,
            function()
                callback()
            end)
    end
end

function DialogUtil:buy(gold,name,callback)
    local need = gold
    local have = PlayerData:getInstanse().basicData.gold
    local buy = need - have
    if need > have then
        --需要更多金币
        PromptView:type2(nil,string.format(StringRes.gold_not_enough,need,have,buy),StringRes.ok,StringRes.cancel,
        function()
            print("buy !")
            Recharge:show(gWorldScene)
        end)
    else
        PromptView:type2(StringRes.notice,
            string.format(StringRes.but_notice,gold,1,name)
            ,StringRes.ok,StringRes.cancel,
            function()
                --购买
                if callback() then callback() end
            end)
    end
end

function DialogUtil:buyWithTitle(gold,title,callback)
    local need = gold
    local have = PlayerData:getInstanse().basicData.gold
    local buy = need - have
    if need > have then
        --需要更多金币
        PromptView:type2(nil,string.format(StringRes.gold_not_enough,need,have,buy),StringRes.ok,StringRes.cancel,
            function()
                print("buy !")
                Recharge:show(gWorldScene)
            end)
    else
        PromptView:type2(StringRes.notice,
            title
            ,StringRes.ok,StringRes.cancel,
            function()
                --购买
                if callback() then callback() end
            end)
    end
end

function DialogUtil:buy2(gold,callback) --不需要确认
    local need = gold
    local have = PlayerData:getInstanse().basicData.gold
    local buy = need - have
    if need > have then
        --需要更多金币
        PromptView:type2(nil,string.format(StringRes.gold_not_enough,need,have,buy),StringRes.ok,StringRes.cancel,
            function()
                print("buy !")
                Recharge:show(gWorldScene)
            end)
    else
        if callback() then callback() end
    end
end

--cancel cancel_queue
function DialogUtil:cancel(okCallback)
    PromptView:type2(nil,StringRes.cancel_queue,StringRes.ok,StringRes.cancel,
        function()
            okCallback()
        end)
end


return DialogUtil