--展开
ExpandListView_Type_Open = 1
--关闭
ExpandListView_Type_Close = 2

ExpandListView = class("ExpandListView",function(listview,callback,getExHeight)
    return listview
end)

function ExpandListView:ctor(listview,callback,getExHeight)
    self.el_acTime = 0.2
    self:init(callback)
    self.getExHeight  = getExHeight
end

function ExpandListView:init(callback)
    local function listViewEvent(sender, eventType)
        if eventType == ccui.ListViewEventType.ONSELECTEDITEM_END then
            if not self.el_expanding then
                local index = sender:getCurSelectedIndex()
                print("select child index = ",index)
                local item = sender:getItem(index)
                if item.el_canExpand == 1 then
                    --展开
                    self:open(index,callback)
                    item.el_canExpand = 2
                elseif item.el_canExpand == 2 then
                    --关闭展开
                    self:close(index,callback)
                    item.el_canExpand = 1
                end
            end
        end
    end
    self:addEventListener(listViewEvent)
end

--展开
function ExpandListView:open(index,callback)
    self.exViewH = nil
    self.el_expanding = true
    local item = self:getItem(index)
    if self.getExHeight then self.exViewH = self.getExHeight(item,index)end
    local curParentY = self:getInnerContainer():getPositionY()
    local curY = item:getPositionY()
    local curYInListView = curY+curParentY --在listview中的Y坐标
    local total = self:getItems()

    local itemSize = item:getContentSize()
    local topY = 0
    local bottomY = 0

    local contentSize = self:getContentSize()
    if self.exViewH == nil then
        self.exViewH = contentSize.height
    end

    topY = contentSize.height - itemSize.height - curYInListView
    item:runAction(cc.Sequence:create( cc.MoveBy:create(self.el_acTime,cc.p(0,topY)),cc.CallFunc:create(function()
        self.el_expanding = false
        --1为展开  2为关闭
        callback(self,item,index,ExpandListView_Type_Open)
        self:getInnerContainer():setPositionY(curParentY+topY)
    end)))
    for i = index-1 , 0, -1 do
        local temp = self:getItem(i)
        temp:runAction(cc.Sequence:create( cc.MoveBy:create(self.el_acTime,cc.p(0,topY))))
    end
    for i = index+1 , #total-1, 1 do
        bottomY = topY - self.exViewH
        local temp = self:getItem(i)
        temp:runAction(cc.Sequence:create( cc.MoveBy:create(self.el_acTime,cc.p(0,bottomY))))
    end

end

function ExpandListView:close(index,callback)
    self.el_expanding = true
    local item = self:getItem(index)
    local curParentY = self:getInnerContainer():getPositionY()
    local curY = item:getPositionY()
--    local curYInListView = curY+curParentY --在listview中的Y坐标
    local total = self:getItems()

    local itemSize = item:getContentSize()
    local topY = 0
    local bottomY = 0
--    local contentSize = self:getContentSize()
    local rmItem = self:getItem(index+1)
    rmItem:setVisible(false)

    local contentH = self:getItem(index+1):getContentSize().height
    --移除content的时候够高度向上move
    if -curParentY > contentH then
        --上移位移
        topY = contentH
        local curItem = self:getItem(index+2)
        if curItem then
            curItem:runAction(cc.Sequence:create( cc.MoveBy:create(self.el_acTime,cc.p(0,topY)),cc.CallFunc:create(function()
                self.el_expanding = false
                callback(self,item,index,ExpandListView_Type_Close)
                if rmItem.el_canExpand == 3 then
                    self:removeItem(index+1)
                end
            end)))
        else
            self.el_expanding = false
            callback(self,item,index,ExpandListView_Type_Close)
            if rmItem.el_canExpand == 3 then
                self:removeItem(index+1)
            end
        end
        
        for i = index +3, #total -1 , 1 do
            local curItem = self:getItem(i)
            curItem:runAction(cc.MoveBy:create(self.el_acTime,cc.p(0,topY)))
        end
    else--移除content的时候不够高度向上move
        --上移位移
        topY = -curParentY
        --下移位移
        bottomY = -contentH-curParentY
        --判断下移高度是否够
--        local delta = (self:getItem(0):getPositionY()+curParentY)-(self.exViewH - itemSize.height)
        local delta = (self:getItem(0):getPositionY()+curParentY)-(self:getContentSize().height - self:getItem(0):getContentSize().height)
        if -delta>bottomY then--下移高度不够
            local tmp = -delta-bottomY
            bottomY = bottomY+tmp
            topY = topY+tmp
        end
        item:runAction(cc.Sequence:create( cc.MoveBy:create(self.el_acTime,cc.p(0,bottomY)),cc.CallFunc:create(function()
            self.el_expanding = false
            callback(self,item,index,ExpandListView_Type_Close)
            if rmItem.el_canExpand == 3 then
                self:removeItem(index+1)
            end
            self:getInnerContainer():setPositionY(0)
        end)))
        for i = 0 , index-1, 1 do
            local temp = self:getItem(i)
            temp:runAction(cc.Sequence:create( cc.MoveBy:create(self.el_acTime,cc.p(0,bottomY))))
        end
        for i = index+1 , #total-1, 1 do
            local temp = self:getItem(i)
            temp:runAction(cc.Sequence:create( cc.MoveBy:create(self.el_acTime,cc.p(0,topY))))
        end
        
    end

end

function ExpandListView:pushExpandItem(item)
    --1 可展开
    --2 展开中
    --3 展开内容
    item.el_canExpand = 1
    self:pushBackCustomItem(item)
end

function ExpandListView:insertExpandContent(item,index)
    --1 可展开
    --2 展开中
    --3 展开内容
    item.el_canExpand = 3
    self:insertCustomItem(item,index)
end

return ExpandListView