
local MultiToucheslayer = class("MultiToucheslayer",function() 
    return display.newLayer()
end)

function MultiToucheslayer:ctor(multiCount)
    multiCount = multiCount or 2
    self.TouchStartPosTables = {}
    
    local listenner = cc.EventListenerTouchAllAtOnce:create()
    listenner:setEnabled(true)
    listenner:registerScriptHandler(function(touchs,event)
        print("--------hsm------begin-count--",#touchs)
        if #touchs == multiCount then
            for index,touch in ipairs(touchs) do
                self.TouchStartPosTables[index] = touch:getLocation()
            end
        end
    end,cc.Handler.EVENT_TOUCHES_BEGAN)
    listenner:registerScriptHandler(function(touchs,event) 
        print("--------hsm----move---count--",#touchs)
        if #touchs == multiCount then
            local _t = {}
            for index,touch in ipairs(touchs) do
                _t[index] = touch:getLocation()
            end
            if self._move_event then
                self._move_event(self.TouchStartPosTables,_t)
            end
        end
    end,cc.Handler.EVENT_TOUCHES_MOVED)
    listenner:registerScriptHandler(function(touchs,event) 
        self.TouchStartPosTables = {}
    end,cc.Handler.EVENT_TOUCHES_CANCELLED)
    
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner,self)
end

function MultiToucheslayer:registerMove(func)
    self._move_event = func
end

function MultiToucheslayer:registerEnd(func)
    self._end_event = func
end

return MultiToucheslayer