
local yijie = nil
local json = require("cjson")
SDKPlatform = {}

function SDKPlatform:printLog(log)
    yijie:printLog(log)
end

--初始化
function SDKPlatform:init(callback)
--    if yijie then
--        callback(true)
--    end
--    local fileSize = cc.FileUtils:getInstance():isFileExist("YijieInterface.lua") or
--    cc.FileUtils:getInstance():isFileExist("YijieInterface.luac")

--    if fileSize then
--        require("src/YijieInterface")
--    end
--    if YijieInterface then
--        yijie = YijieInterface.new()
        if yijie and yijie.setSDKInitListener then
            --SDK 初始化回调
            local function sdkInitCallbackFunc(jPrama)
                local data = json.decode(jPrama);
                if data["tag"] == "success" then
                    --SDK 初始化成功
                    callback(true)
                elseif data["tag"] == "fail" then
                    --SDK 初始化失败
                    callback(false)
                end
            end
            --注册 SDK 初始化回调
            yijie:setSDKInitListener(sdkInitCallbackFunc)
        else
            callback(true)
        end
--    else
--        callback(true)  --没有SDK算初始化化成功
--    end
end

--为了处理热更新重新初始化
function SDKPlatform:hotUpdateEnd()
    if yijie == nil then
        local fileSize = cc.FileUtils:getInstance():isFileExist("YijieInterface.lua") or
        cc.FileUtils:getInstance():isFileExist("YijieInterface.luac")

        if fileSize then
            require("src/YijieInterface")
        end
        if YijieInterface then
            yijie = YijieInterface.new()
        end
    end
end

--是否有SDK
function SDKPlatform:haveSdk()
    return yijie and true or false
end

--登陆
function SDKPlatform:login(callback)
    if yijie == nil or SDKPlatform:isSelfProgram() then
        return
    end

    local layer = Connect.openLoad()
    --登陆回调
    local function loginCallback(jPrama)
        Connect.closeLoad(layer)
        local data = json.decode(jPrama);
        
        if data["result"] == "success" then--登录成功
            self:set("productCode",data["productCode"])
            self:set("channelId",data["channelId"])
            self:set("channelUserId",StringUtil.encodeURL(data["channelUserId"]))
            self:set("token",StringUtil.encodeURL(data["token"]))
            self:set("id",data["id"])
            self:set("userName",data["userName"])
            callback(true)
        elseif data["result"] == "fail" then--登陆失败
            callback(false)
        elseif data["result"] == "logout" then--登出回调
            callback(false)
        end
    end
    --注册登陆回调
    yijie:setLoginListener(loginCallback)
    --调用登陆接口
    yijie:login("login")
end

function SDKPlatform:logout()
    self:set("ServerId",nil)
    if yijie == nil or SDKPlatform:isSelfProgram()then
        return
    end
    yijie:logout("logout")
end

function SDKPlatform:initRole()
    if yijie and yijie.setRoleData then
        --"001"/* 角色唯一标识 */,
        --"法师"/* 角色名 */,
        --"30 级"/* 角色等级 */,
        --    "1000"/* 区域唯一标识 */,
        --    "一区"/* 区域名称 */
        local playerInfo = PlayerData:getInstanse().basicData
        yijie:setRoleData(
            tostring(playerInfo.playerId),
            playerInfo.name,
            string.format(StringRes.task_needlevel,playerInfo.lv),
            tostring(self.ServerId),
            self.ServerName)
    end
end

local function exitGame(unenmidiate,okFunc)
    local function myExit()
        statistics:sendExit()
        app:exit()
    end
    if unenmidiate then
        PromptView:type2(StringRes.notice,StringRes.exit_notice,StringRes.ok,StringRes.cancel,
            okFunc or myExit,nil,99999)
    else
        myExit()
    end
end

--账号实名检测
function SDKPlatform:checkAccount()--退出回调
    
    local function checkAccountCallback(jPrama)
        local data = json.decode(jPrama)
        if data["result"] then
            PromptView:type1(nil,data["result"],StringRes.ok,nil)
        end
--        if data["result"] == "" then
--            
--        elseif data["result"] == "" then
--            
--        elseif data["result"] == "" then
--            
--        end
    end
    
    if yijie then
        yijie:checkAccount(checkAccountCallback)
    end
end

--推出游戏
function SDKPlatform:exit()--退出回调
    if yijie == nil or SDKPlatform:isSelfProgram() then
        return exitGame(true)
    end
    local function exitCallback(jPrama)
        local data = json.decode(jPrama)
        print("游戏退出了 result=",data["result"])
        if data["result"] == "exit" then
            --退出游戏
            --日志
            statistics:sendExit()
            os.exit()
        elseif data["result"] == "noExit" then
            --继续游戏
        elseif data["result"] == "noProvide" then
            if self:directExit() then
                exitGame()
            else
                exitGame(true)
            end
        end
    end
    if self:haveExitView() then --用SDK界面退出
        yijie:exit(exitCallback)
    else                        --用自己游戏的SDK退出
        exitGame(true,function()
            yijie:exit(exitCallback)
        end)
    end
end

--定额支付,失败不一定是失败，只有等服务器回调回来才知道
function SDKPlatform:pay(name,price,param,callback)
    local cjson = require("cjson")
    require("src/app/util/SDKPlatform")
    SDKPlatform:printLog("playerData22=")
    --支付回调
    local orderId = param.order_sn
    local function payCallback(jPrama)
        local data = json.decode(jPrama)
        if data["result"] == "success" then--支付成功
        callback(true)
        elseif data["result"] == "oderno" then--支付订单
        print("支付订单号", data["remain"])
        callback(true)
        elseif data["result"] == "fail" then--支付失败
        callback(false)
        elseif data["result"] == "tokenover" then --登录失效
        callback(false)
            PromptView:type1(nil,StringRes.login_over_time,StringRes.ok,function()
                app:enterScene("LoginScene")
            end)
        end
    end
    self:initRole()
    local cjson = require("cjson")
    require("src/app/util/SDKPlatform")
    SDKPlatform:printLog("playerData33=")
    yijie:pay(
        orderId,
        price ,--/* 道具价格单位分 */,
        name,--/* 道具名称 */,
    1 ,--/* 个数默认为 1*/,
    param.param ,--/* 此次支付透传参数 */,
    "",--/* 游戏接收支付回调地址 暂时未用到*/,
    payCallback,param)
end

--非定额支付
function SDKPlatform:charge(callback)
    --支付回调
    local function payCallback(jPrama)
        local data = json.decode(jPrama)
        if data["result"] == "success" then--支付成功
            callback(true)
        elseif data["result"] == "oderno" then--支付订单
            print("支付订单号", data["remain"])
            callback(false)
        elseif data["result"] == "fail" then--支付失败
            callback(false)
        end
    end

--    yijie:charge (
--    "100"/* 道具名称 */,
--    100/* 价格单位分 */,
--    1/* 道具个数 */,
--    "test callbackinfo"/* 此次支付透传参数 */,
--    "http://game.pay?id=1"/* 游戏接收支付回调地址 */,
--    payCallback/* 支付回调 函数 */,)

end

function SDKPlatform:getSDKId()
    if yijie == nil then
        return "998"
    end
    return yijie:getSDKId()
end

function SDKPlatform:getForceUpdateParam()
    if yijie == nil or not yijie.getForceUpdateParam then
        return false
    end
    return yijie:getForceUpdateParam()
end

--用来判断是用自己包打还是SDK包打
function SDKPlatform:isSelfProgram()
    if yijie == nil then
        return true
    end
    return yijie:isSelfProgram()
end

--设置数据
function SDKPlatform:set(key,value)
    self[key] = value
end

--获取数据
function SDKPlatform:get(key)
    return self[key]
end

--判断是否有退出界面
function SDKPlatform:haveExitView()
    if yijie.haveExitView then
        return yijie:haveExitView()
    end
    return true
end

--额外参数的添加
function SDKPlatform:setData(key,value)
    if not self:isSelfProgram() and key and value then
        yijie:setDataString(key,value)
    end
end

--为了兼容以前的退出新加的
function SDKPlatform:directExit()
    if yijie and yijie.directExit then
        return yijie:directExit()
    end
    return true
end

SDKPlatform:hotUpdateEnd()

return SDKPlatform