
--异步获取数据(需要全局保存的才用这个)
Singleton = {}

local data = {}

function Singleton:create(action,msgName,_t,func)
    Connect:sendMsg(action,msgName,nil,function(_d) 
        _t.data=_d
        func(_d)
    end,true)
end

function Singleton:get(action,msgName,func)
    local value = data[action]
    if value and value.isLocal then
        func(value.data)
    else
        local new = value or {}
        new.isLocal = true
        data[action] = new
        Singleton:create(action,msgName,new,func)
    end
end

function Singleton:set(action,msgName,value)
    local info = data[action] or {}
    info.isLocal = true
    info.data = value
end

function Singleton:setFromServer(action,msgName)
    local value = data[action]
    value.isLocal = false
end

function Singleton:clear()
    data = {}
end

RegisterCleanUp:register(function()
    Singleton:clear() --清理缓存
end)

return Singleton