
StringTemp = {}
local osdate = os.date
local format = string.format
local tonumber = tonumber
local table = table
local string = string

-- 以秒为单位的时间转化成固定格式的字符串(具体怎么改以后策划定了，稍改下就行)
function StringTemp:toTime(time)
    --    if time<60 then
    --        return osdate("0m%Ss",time)
    --    else
    if time<3600 then
        return format("%dm%ds",time/60,time%60)
    elseif time < 3600*24 then
        local remain = time%3600
        return format("%dh%dm%ds",time/3600,remain/60,remain%60)
    else
        local remain = time%(3600*24)
        return format("%dd%dh",time/(3600*24),remain/3600)
    end
end

function StringTemp:toPosition(str)
	local pos = StringTemp:Split(str,",")
	if #pos == 2 then
        return cc.p(tonumber(pos[1]),tonumber(pos[2]))
	end
	return cc.p(0,0)
end

-- 以秒为单位的时间转化成固定格式的字符串(具体怎么改以后策划定了，稍改下就行)
--BUFF剩余时间固定显示为：X d Y h Z m R s （X，Y，Z，R为阿拉伯数字）
function StringTemp:toTime2(time)
    --    if time<60 then
    --        return osdate("0m%Ss",time)
    --    else
    local s = time%60
    local m = (time/60)%60
    local h = (time/3600)%24
    local d = time/(3600*24)
    return format("%dd%dh%dm%ds",d,h,m,s)
end

function StringTemp:format(s)
    if s < 10 then
        return format("0%d",s)
    else
        return format("%d",s)
    end
end

--显示格式为：小时：分钟：秒。
function StringTemp:toTime3(time)
    if time <= 0 then return "00:00:00" end
    local s = time%60
    local ss = StringTemp:format(s)
    local m = (time/60)%60
    local sm = StringTemp:format(m)
    local h = (time/3600)%24
    local sh = StringTemp:format(h)
    return format("%s:%s:%s",sh,sm,ss)
end


-- 转化成固定格式的字符串
function StringTemp:toNum(val,precision)

    local re = ""

    if val<1000 then
        re = math.floor(tonumber(val))
    elseif val<1000000 then
        if precision then
            re = string.format("%."..precision.."fK",val/1000)
        else
            re = string.format("%.1fK",val/1000)
        end
    elseif val<1000000000 then
        if precision then
            re = string.format("%."..precision.."fM",val/1000000)
        else
            re = string.format("%.1fM",val/1000000)
        end
    elseif val < 1000000000*1000 then
        if precision then
            re = string.format("%."..precision.."fG",val/1000000000)
        else
            re = string.format("%.1fG",val/1000000000)
        end
    end

    return re
end

--上次登录时间
function StringTemp:lastLoginTime(val)

    local re = ""

    if val > 60*24 then
        re = string.format(StringRes.time_d,math.ceil(val/(60*24)))
    elseif val < 60 then
        re = string.format(StringRes.time_h,1)
    else
        re = string.format(StringRes.time_h,math.ceil(val/60))
    end

    return re
end

--获取对应职业
function StringTemp:getJob(job)
    return StringRes["job_"..job]
end

--默认key1为id,key2为count(不能有小数)
--字符串转化成table 1:2,1:2 -> {{key1=1,key2=2},{key1=1,key2=2}} or 1,2->{1,2}
function StringTemp:toTable(str,key1,key2)
    local _t = {}
    local can = true
    for k,v in string.gmatch(str,"(%d+):(%d+)") do
        local _in = {}
        _in[key1 or "id"],_in[key2 or "count"] = tonumber(k),tonumber(v)
        table.insert(_t,_in)
        can = false
    end
    if can then
        for k,v in string.gmatch(str,"%d+") do
            table.insert(_t,tonumber(k))
        end
    end
    return _t
end

--"wo,aoi,adf," --最后有逗号，才能有最后一个
function StringTemp:toArray(str)
    local _t = {}
    for k,_ in string.gmatch(str,"(.-),") do
        table.insert(_t,k)
    end
    return _t
end

function StringTemp:toMailTime(str)
    local re = string.gsub(str,"(%w+)-(%w+)-(%w+)%s*(%w+):(%w+):(%w+)","%2/%3 %4:%5")
    return re
end

-- 有小数的转化 "sd:2,sd1:0.2" -> {sd=2,sd1=0.2}
function StringTemp:toTableDecimal(str)
    local _t = {}
    for k,v in string.gmatch(str,"(%w+):((%w*)(%.*)(%w*))") do
        _t[k] = tonumber(v)
    end
    return _t
end

function StringTemp:toArrayRes(resStr)
    local _t = {}
    for k,v in string.gmatch(resStr,"(%w+):((%w*)(%.*)(%w*))") do
        table.insert(_t,{id=k,count=tonumber(v)})
    end
    return _t
end

--id:1_coe:0.2,id:2_coe:0.1 -> {{id=1,coe=0.2},{id=2,coe=0.1}}
function StringTemp:toTabByStr1(str)
    local _t = {}
    local isLoop = false
    for k,v in string.gmatch(str,"(.*),(.*)") do
        local c = self:toTableDecimal(k)
        table.insert(_t,c)
        if v then
            c = self:toTableDecimal(v)
            table.insert(_t,c)
        end
        isLoop = true
    end
    if not isLoop then
        local newTable = self:toTableDecimal(str)
        if next(newTable) then
            table.insert(_t,newTable)
        end
    end
    return _t
end

function StringTemp:toPartByStr(str,k1,k2,k3)
    local _t = {}
    local a = {k1,k2,k3}
    for k,v,c in string.gmatch(str,"(%w+):(%w+):((%w*)(%~*)(%w*))") do
        local p = {}
        for i,s in ipairs({k,v,c}) do
            p[a[i]] = (tonumber(s) and tonumber(s) or s)
        end
        table.insert(_t,p)
    end
    return _t
end

--1:2:2,2:2:2 -> {{}}
function StringTemp:toTabByStr2(str,k1,k2,k3)
    local _t = {}
    local a = {k1,k2,k3}
    for k,v,c in string.gmatch(str,"(%w+):(%w+):(%w+)") do
        local p = {}
        for i,s in ipairs({k,v,c}) do
            p[a[i]] = (tonumber(s) and tonumber(s) or s)
        end
        table.insert(_t,p)
    end
    return _t
end

function StringTemp:Split(szFullString, szSeparator)
    local nFindStartIndex = 1
    local nSplitIndex = 1
    local nSplitArray = {}
    while true do
        local nFindLastIndex = string.find(szFullString, szSeparator, nFindStartIndex)
        if not nFindLastIndex then
            nSplitArray[nSplitIndex] = string.sub(szFullString, nFindStartIndex, string.len(szFullString))
            break
        end
        nSplitArray[nSplitIndex] = string.sub(szFullString, nFindStartIndex, nFindLastIndex - 1)
        nFindStartIndex = nFindLastIndex + string.len(szSeparator)
        nSplitIndex = nSplitIndex + 1
    end
    return nSplitArray
end



---------------------------
--@param
--@return
--
--


function StringTemp:specialReplace(content)
    local t = StringTemp:Split(content, "@")
    local re = ""
    for key, var in ipairs(t) do
    	if StringRes[var] ~= nil then
            re = re..StringRes[var]
        else
            re = re..var
    	end
    end
    return re
end

function StringTemp:Descript(words,size,color)


    if size == nil then
        size = 24
    end
    if color == nil  then
        color = CommonColor.White
    end

    words = string.gsub(words,"\r\n","\n")
    local tt = StringTemp:Split(words,"\n")
    if #tt <= 1 then
        tt = StringTemp:Split(words,"\\n")
    end

    local re = {}
    for key, var in pairs(tt) do
        re[key] = {}
        re[key][1] = {}
        if var == "" then
            var = " "
        end
        re[key][1].str = var
        re[key][1].color = color
        re[key][1].size = size
    end

    return re
end

--
function StringTemp:strtoTable(data)
    local re = {}
    local t1 = StringTemp:Split(data,",")
    for key, var in pairs(t1) do
        local t2 = StringTemp:Split(var,":")
        re[t2[1]] = t2[2]
        --local t = type(t2[2]);
        --if t == "number" then
        re[t2[1]] = tonumber(t2[2])
        if re[t2[1]] == nil then
            re[t2[1]] = t2[2]
        end
        --end
    end
    return re

        --local recvdata = cjson.decode("{tt:3,ty:2}")
end

function StringTemp:serverTimetoDate(time)
    return os.date("%m/%d %H:%M",math.floor(time/1000))
end

--"item:2_1"格式转换
function StringTemp:toReward(str,key1,key2,key3)
    local re = {}
    for k,v,r in string.gmatch(str,"(%w+):(%w+)_(%w+)") do
        re[key1 or "type"] = k
        re[key2 or "id"] = tonumber(v)
        re[key3 or "count"] = tonumber(r)
    end
    return re
end

function StringTemp:toGuidePos(str)
    for k,v in string.gmatch(str,"(%w+)_(%w+)") do
        return tonumber(k),tonumber(v)
    end
end

function StringTemp:toTempEnter(str)
    local re = {}
    str = string.gsub(str,"\r\n","\n")
    for s in string.gmatch(str,"(.-)\n") do
        table.insert(re,s)
    end
    return re
end

return StringTemp