TDstatistics = {}
local  ClassName = "org/cocos2dx/lua/TD"
--local  ClassName2 = "TDManager"

function TDstatistics:setAccount()
	
  TDstatistics:recordRoleInfo()
	if device.platform == "android" then
		local methodName = "setAccount"
		local pd = require("src/app/unit/PlayerData"):getInstanse()
		local signs = "(Ljava/lang/String;Ljava/lang/String;IILjava/lang/String;)V"
		local args = {tostring(pd.basicData.playerId),
					pd.basicData.name,
					pd.basicData.lv,
					pd.basicData.icon,
					require("src/app/util/SDKPlatform"):get("ServerName")}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)
    elseif device.platform == "ios" then

        local methodName = "setAccount"
        local pd = require("src/app/unit/PlayerData"):getInstanse()
        local args = {
                    playerId = tostring(pd.basicData.playerId),
                    name = pd.basicData.name,
                    Leve = pd.basicData.lv,
                    --性别
                    icon = pd.basicData.icon,
                    ServerName = require("src/app/util/SDKPlatform"):get("ServerName")}
        luaoc.callStaticMethod("TDManager", methodName, args)
    end

end

function TDstatistics:LevelUp()
	
  TDstatistics:recordRoleInfo()
    
	if device.platform == "android" then
		local methodName = "LevelUp"
		local pd = require("src/app/unit/PlayerData"):getInstanse()
		local signs = "(Ljava/lang/String;I)V"
		local args = {tostring(pd.basicData.playerId), pd.basicData.lv}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)
    elseif device.platform == "ios" then

        local methodName = "LevelUp"
        local pd = require("src/app/unit/PlayerData"):getInstanse()
        local args = {playerId = tostring(pd.basicData.playerId),Leve = pd.basicData.lv}
        luaoc.callStaticMethod("TDManager", methodName, args)
    end

end

--String orderId, 
--String iapId, 
--double currencyAmount, 
--String currencyType, 
--double virtualCurrencyAmount, 
--String paymentType
function TDstatistics:onChargeRequest(orderid, name, currencyAmout, currencyType, virtualCurrencyAmount, paymentType)
	if device.platform == "android" then
		local methodName = "onChargeRequest"
		local signs = "(Ljava/lang/String;Ljava/lang/String;FLjava/lang/String;FLjava/lang/String;)V"
		local args = {tostring(orderid), 
		              tostring(name),
		              (currencyAmout),
		              tostring(currencyType),
		              (virtualCurrencyAmount),
		              tostring(paymentType)}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)    	
    elseif device.platform == "ios" then

        local methodName = "onChargeRequest"
        local args = {orderid = tostring(orderid), 
                      name = tostring(name),
                      currencyAmout = (currencyAmout),
                      currencyType = tostring(currencyType),
                      virtualCurrencyAmount = (virtualCurrencyAmount),
                      paymentType = tostring(paymentType)}
        luaoc.callStaticMethod("TDManager", methodName, args)
    end
end

function TDstatistics:onChargeSuccess(orderId)	
	if device.platform == "android" then
		local methodName = "onChargeSuccess"
		local signs = "(Ljava/lang/String;)V"
		local args = {tostring(orderId)}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)    	
    elseif device.platform == "ios" then

        local methodName = "onChargeSuccess"
        local args = {orderId = tostring(orderId)}
        luaoc.callStaticMethod("TDManager", methodName, args)
    end
end


--赠予虚拟币
function TDstatistics:onReward(virtualCurrencyAmount, reason)
	if device.platform == "android" then
		local methodName = "onReward"
		local signs = "(ILjava/lang/String;)V"
		local args = {virtualCurrencyAmount, reason}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)
    elseif device.platform == "ios" then

        local methodName = "onReward"
        local args = {virtualCurrencyAmount = virtualCurrencyAmount, reason = reason}
        luaoc.callStaticMethod("TDManager", methodName, args)
    end
    self.SetAddGoldType(nil)
end
    
    
-- 记录付费点(使用虚拟币购买)    
-- @param item 类型 String 某个消费点的编号，最多32个字符。
-- @param itemNumber 类型 int，消费数量。
-- @param priceInVirtualCurrency 类型 double 虚拟币单价
function TDstatistics:onPurchase(item, itemNumber, priceInVirtualCurrency)
	if device.platform == "android" then
		local methodName = "onPurchase"
		local signs = "(Ljava/lang/String;II)V"
		local args = {item, itemNumber, priceInVirtualCurrency}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)    	
    elseif device.platform == "ios" then

        local methodName = "onPurchase"
        local args = {item = item,itemNumber = itemNumber, priceInVirtualCurrency = priceInVirtualCurrency}
        luaoc.callStaticMethod("TDManager", methodName, args)
    end
    self.SetUseGoldType(nil)
end


--消耗物品或服务等
function TDstatistics:onUse(item, itemNumber)
	if device.platform == "android" then
		local methodName = "onUse"
		local signs = "(Ljava/lang/String;I)V"
		local args = {item, itemNumber}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)    	
     elseif device.platform == "ios" then

        local methodName = "onUse"
        local args = {item = item, itemNumber = itemNumber}
        luaoc.callStaticMethod("TDManager", methodName, args)
    end
    
end
    

--@param missionId 类型 String 任务、关卡或副本的编号，最多32个字符。此处可填写ID，别名可在报表编辑。
--@param cause 类型 String 失败原因，最多16个字符。共支持100种原因。
--接受或进入
function TDstatistics:onMissionBegin(missionId)
	if device.platform == "android" then
		local methodName = "onMissionBegin"
		local signs = "(Ljava/lang/String;)V"
		local args = {missionId}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)    	
   elseif device.platform == "ios" then
        local methodName = "onMissionBegin"
        local args = {missionId = missionId}
        luaoc.callStaticMethod("TDManager", methodName, args)
    end
end
--任务完成
function TDstatistics:onMissionCompleted(missionId)
	if device.platform == "android" then
		local methodName = "onMissionCompleted"
		local signs = "(Ljava/lang/String;)V"
		local args = {missionId}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)    	
    elseif device.platform == "ios" then
        local methodName = "onMissionCompleted"
        local args = {missionId = missionId}
        luaoc.callStaticMethod("TDManager", methodName, args)
    end
end
--任务失败
function TDstatistics:onMissionFailed(missionId, cause)
	if device.platform == "android" then
		local methodName = "onMissionFailed"
		local signs = "(Ljava/lang/String;Ljava/lang/String;)V"
		local args = {missionId, cause}
    	luaoc.callStaticMethod(ClassName, methodName, args, signs)    	
    elseif device.platform == "ios" then
        local methodName = "onMissionFailed"
        local args = {missionId = missionId, cause = cause}
        luaoc.callStaticMethod("TDManager", methodName, args)
    end
end


addGold = nil
useGold = nil
function TDstatistics:SetAddGoldType(type)
    addGold = type
end

function TDstatistics:GetAddGoldType()
    return addGold
end

function TDstatistics:SetUseGoldType(type)
    useGold = type
end

function TDstatistics:GetUseGoldType()
    return useGold
end

function TDstatistics:reName(name)
    if device.platform == "android" then
		local methodName = "onReName"
		local signs = "(Ljava/lang/String;)V"
		local args = {name}
    	luaoc.callStaticMethod(ClassName, methodName, args, signs)    	
    end
end

--添加新手引导事件统计
function TDstatistics:onToturialEvent(step)

    test = 
    {  
        guide = '未开始'  
    }  
    
    if step == 1 then
        test.guide = "主界面点击建筑战车工厂"
    elseif step == 2 then
        test.guide = "建筑战车工厂"
    elseif step == 3 then
        test.guide = "建造完成战车工厂并打开"
    elseif step == 4 then
        test.guide =  "生产坦克"
    elseif step == 5 then
        test.guide =  "关闭生产完成界面"
    elseif step == 6 then
        test.guide = "主界面点击关卡"
    elseif step == 7 then
        test.guide = "选择关卡1-1"
    elseif step == 8 then
        test.guide = "选择出战坦克"
    elseif step == 9 then
        test.guide = "点击最大战力"
    elseif step == 10 then
        test.guide = "进攻按钮"
    elseif step == 11 then
        test.guide = "战斗胜利"
    elseif step == 12 then
        test.guide = "关闭战争胜利"
    elseif step == 13 then
        test.guide = "点击基地"
    elseif step == 14 then
        test.guide = "建筑炼铁厂"
    elseif step == 15 then
        test.guide = "建筑炼铁厂完成"
    elseif step == 16 then
        test.guide = "建筑采油厂"
    elseif step == 17 then
        test.guide = "采油厂建筑完成"
    elseif step == 18 then
        test.guide = "建筑铝矿厂"
    elseif step == 19 then
        test.guide = "建筑铝矿厂完成"
    elseif step == 20 then
        test.guide = "点击任务按钮"
    elseif step == 21 then
        test.guide = "领取角色任务礼包完成"
    elseif step == 22 then
        test.guide = "领取建筑一个战车工厂任务奖励" 
    elseif step == 23 then
        test.guide = "关闭领取任务奖励界面"
    elseif step == 24 then
        test.guide = "点击角色按钮"
    elseif step == 25 then
        test.guide = "提升领导力"
    elseif step == 26 then
        test.guide = "点击技能按钮"
    elseif step == 27 then
        test.guide = "点击命中按钮"
    elseif step == 28 then
        test.guide = "点击关闭按钮"
    elseif step == 29 then
        test.guide = "点击资源框"
    elseif step == 30 then
        test.guide = "铁矿按钮"
    elseif step == 31 then
        test.guide = "使用铁矿补给"   
    elseif step == 32 then
        test.guide = "成功使用铁矿补给"
    elseif step == 99 then
        test.guide = "新手引导完成"
    elseif step == 100 then
        test.guide = "关卡1-1战斗中"
    else
        test.guide = tostring(step)
    end
    jsonTest = json.encode(test)      --table转json 
    TDstatistics:onEvent('新版新手引导', tostring(jsonTest))

end

--添加新手引导事件统计
--1、loading，  2、loading结束  3、登陆注册界面  4、首场战斗，   5、创建角色动画
function TDstatistics:RecordBeforeCreate(step)
    test = 
    {  
        guide = step  
    }
    if step == 1 then
        test.guide = "loading"
    elseif step == 2 then
        test.guide = "loading结束"
    elseif step == 3 then
        test.guide = "登陆注册界面"
    elseif step == 4 then
        test.guide =  "首场战斗"
    elseif step == 5 then
        test.guide =  "创建角色"
    elseif step == 6 then
        test.guide =  "创建角色Ex"
    end
      
    jsonTest = json.encode(test)      --table转json 
    TDstatistics:onEvent('用户转换统计', tostring(jsonTest))
    TDstatistics:onXOEvent('用户转换统计', tostring(test.guide))

end

--添加新手引导事件统计
function TDstatistics:onEvent(Key, Event)
   
 	if device.platform == "android" then
        local methodName = "onEvent"
		local signs = "(Ljava/lang/String;Ljava/lang/String;)V"
		local args = {Key,Event}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)    	 
    elseif device.platform == "ios" then
        local methodName = "onEvent"
        local args = {Key = Key,Event = Event}
        luaoc.callStaticMethod("TDManager", methodName, args)
    end 
end


function TDstatistics:onXOEvent(event, subevent)
    if device.platform == "android" then
        local methodName = "onEvent"
		local signs = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V"
		local args = {event, subevent, "", "0", ""}    
    	luaj.callStaticMethod(ClassName, methodName, args, signs)    

        local argsSendNow = {"login_1", "", "", "0", ""}
        luaj.callStaticMethod(ClassName, methodName, argsSendNow, signs)  
    end
end

function TDstatistics:recordRoleInfo()
    if SDKPlatform:getSDKId() ==  "9473" then
    --360渠道做角色信息记录
        local pd = PlayerData:getInstanse().basicData
        if pd then
            local UserDefault = cc.UserDefault:getInstance()
            local server =  require("cjson").decode(UserDefault:getStringForKey("PreServer", ""))
            UserDefault:setStringForKey("360_RoleInfo_zoneid", server[1].id or "")
            UserDefault:setStringForKey("360_RoleInfo_zonename", server[1].name or "")
            UserDefault:setStringForKey("360_RoleInfo_roleid", pd.playerId)
            UserDefault:setStringForKey("360_RoleInfo_rolename", pd.name)
            UserDefault:setStringForKey("360_RoleInfo_gender", (pd.icon == 1 and "男") or (pd.icon == 2 and "女") or "无")
            UserDefault:setStringForKey("360_RoleInfo_rolelevel", pd.lv)
            UserDefault:setStringForKey("360_RoleInfo_power", pd.comat)
            UserDefault:setStringForKey("360_RoleInfo_vip", pd.vipLv)
            UserDefault:setStringForKey("360_RoleInfo_balance", pd.gold)
            UserDefault:setStringForKey("360_RoleInfo_partyid", pd.guildId)
            UserDefault:setStringForKey("360_RoleInfo_partyname", pd.guildName or "无")
            UserDefault:setStringForKey("360_RoleInfo_partyroleid", pd.job)
        end
    end
end



--AD统计接口，只有官网渠道接入了AD
function TDstatistics:onRegister(userid)
    if device.platform == "android" and SDKPlatform:getSDKId() == "9481" then
		local methodName = "onRegister"
		local signs = "(Ljava/lang/String;)V"
		local args = {userid}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)    
    end
end

--AD统计接口，只有官网渠道接入了AD
function TDstatistics:onLogin(userid)
    if device.platform == "android" and SDKPlatform:getSDKId() == "9481" then
		local methodName = "onLogin"
		local signs = "(Ljava/lang/String;)V"
		local args = {userid}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)    
    end
end

--AD统计接口，只有官网渠道接入了AD
function TDstatistics:onCreateRole(rolename)
    if device.platform == "android" and SDKPlatform:getSDKId() == "9481" then
		local methodName = "onCreateRole"
		local signs = "(Ljava/lang/String;)V"
		local args = {rolename}
    	luaj.callStaticMethod(ClassName, methodName, args, signs)    
    end
end

return TDstatistics