--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
local ViewList = {}
local OpenFunc = {}
local CloseFunc = {}
ViewManager = {}

function ViewManager:reset()
    ViewList = {}
    OpenFunc = {}
    CloseFunc = {}
end

function ViewManager:OpenView(node, autoClose, nodeName)
    table.insert(ViewList, node)
    self:CleanNilView()
    if nodeName then
        node.MyNodeName = nodeName
    end
    self:NotifyOpen(node)

    if autoClose == nil or autoClose then
        local function onNodeEvent(tag)
            if tag == "exit" then
                self:CloseView(node)
            end
        end
        local MyViewExitNode = cc.Node:create()
        node:addChild(MyViewExitNode)
        MyViewExitNode:registerScriptHandler(onNodeEvent)
    end
end

function ViewManager:CloseView(node)
    for i=#ViewList, 1, -1 do 
        if ViewList[i] == node then 
            table.remove(ViewList,i) 
            break
        end 
    end 
    self:CleanNilView()
    self:NotifyClose(node)
end

function ViewManager:CleanNilView()
    for i=#ViewList, 1, -1 do 
        if ViewList[i] == nil then 
            table.remove(ViewList,i) 
        end 
    end 
end

function ViewManager:NotifyOpen(node)
    for __, var in pairs(OpenFunc) do
        if var then
            var(node)
        end
    end
    
end

function ViewManager:NotifyClose(node)
    for __, var in pairs(CloseFunc) do
        if var then
            var(node)
        end
    end
end

function ViewManager:registerOpenFunction(name, func)
    if name and func then
        OpenFunc[name] = func
    end
end

function ViewManager:removeOpenFunctionByName(name)
    if name and OpenFunc[name] then
        OpenFunc[name] = nil
    end
end

function ViewManager:registerCloseFunction(name, func)
    if name and func then
        CloseFunc[name] = func
    end
end

function ViewManager:removeCloseFunctionByName(name)
    if name and CloseFunc[name] then
        CloseFunc[name] = nil
    end
end

function ViewManager:getViewCount()
    return #ViewList
end

function ViewManager:getTopView()
    return ViewList[#ViewList]
end

function ViewManager:isViewOpen(node)
    for i=1, #ViewList do 
        if ViewList[i] == node then 
            return true
        end 
    end 
    return false
end

return ViewManager
--endregion
