
require("src/app/views/Field/ResourceInfo")

CollectionInfo = class("CollectionInfo",function(data)
    return display.newLayer()
end)




function CollectionInfo:ctor(data)
    
    self.origdata = Common:copyTab(data)
    self.data = data

    self.Top = CCUILoader:load("res/csd/public/PanelBgLarge.csb")
    self:addChild(self.Top)
    self.Top:getChildByName("text_title"):setString(StringRes.collection)
    --关闭
    local close = self.Top:getChildByName("btn_close")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            
            self:editCol()
            
            self:removeFromParent()
        end
    end)
    
   --界面CSD
    self.csd = CCUILoader:load("res/csd/world/ui_world_favorite.csb")
    self:addChild(self.csd)
    
    
    
    --显示类型  (1:所有 2:资源 3：敌对 4:好友)
    self.showType = 1
    
    self:initBottom()
    
    self:freshInfo()
end

--发送修改后的信息
function CollectionInfo:editCol()
    
    
    if Common:compareTab(self.data,self.origdata) == true then
    	return
    end
    
    
    
    --//id:名字:资源类型:敌对类型:好友类型，id:名字:资源类型:敌对类型:好友类型
    local msg = ""
    for key, var in pairs(self.data) do
        local str = var.id.."#"..var.name.."#"..var.resType.."#"..var.armyType.."#"..var.friendType.."_"
        msg = msg..str
    end

    Connect:sendMsg("WorldAction","editWorldCollect",{editStr = msg},
        function(data)
            --更新数据
            if data.state == 1 then
                FlyWordPrompt:prompt(StringRes.shouchang_success)
            	return true
            else
                return false
            end
        end)
end

--初始化底部信息
function CollectionInfo:initBottom()




    local all = self.csd:getChildByName("panel_world_favorite_outline"):getChildByName("btn_all")
    local res = self.csd:getChildByName("panel_world_favorite_outline"):getChildByName("btn_resource")
    local enemy = self.csd:getChildByName("panel_world_favorite_outline"):getChildByName("btn_enemy")
    local friend = self.csd:getChildByName("panel_world_favorite_outline"):getChildByName("btn_friend")
    
    
    local function setSelect(type)
        all:setSelected(false)
        res:setSelected(false)
        enemy:setSelected(false)
        friend:setSelected(false)
    
        if type == 1 then
            all:setSelected(true)
        elseif type == 2 then
            res:setSelected(true)
        elseif type == 3 then
            enemy:setSelected(true)
        elseif type == 4 then
            friend:setSelected(true)
    	end
    	
        self.showType = type
        
        self:freshInfo()
    	
    end
    
    setSelect(self.showType)
    
    all:addEventListener(function(sender,eventType)
        if eventType == ccui.CheckBoxEventType.selected then
            setSelect(1)
        elseif eventType == ccui.CheckBoxEventType.unselected then

        end

    end)
    
    res:addEventListener(function(sender,eventType)
        if eventType == ccui.CheckBoxEventType.selected then
            setSelect(2)
        elseif eventType == ccui.CheckBoxEventType.unselected then

        end

    end)
    
    enemy:addEventListener(function(sender,eventType)
        if eventType == ccui.CheckBoxEventType.selected then
            setSelect(3)
        elseif eventType == ccui.CheckBoxEventType.unselected then

        end

    end)
    
    friend:addEventListener(function(sender,eventType)
        if eventType == ccui.CheckBoxEventType.selected then
            setSelect(4)
        elseif eventType == ccui.CheckBoxEventType.unselected then

        end

    end)
end


--刷新一个收藏信息
function CollectionInfo:freshOneInfo(nd,data,key)
    nd = nd:getChildByName("panel_favorite_bg")
    
    --输入框
    local textfield_name = nd:getChildByName("favorite_outline"):getChildByName("textfield_name")
    textfield_name:addEventListener(function(e, t)
        --if t == ccui.TextFiledEventType.insert_text then
            data.name = textfield_name:getString()
        --end
    end)
    --名字
    textfield_name:setString( data.name)
    
    
    --坐标
    nd:getChildByName("text_coordinate"):setString( "("..data.x..","..data.y..")")

    --分类 
    --资源
    if data.resType == 1 then
        nd:getChildByName("btn_resource"):setSelected(true)
    else
        nd:getChildByName("btn_resource"):setSelected(false)
    end
    
    --敌对
    if data.armyType == 1 then
        nd:getChildByName("btn_enemy"):setSelected(true)
    else
        nd:getChildByName("btn_enemy"):setSelected(false)
    end
    
    --好友
    if data.friendType == 1 then
        nd:getChildByName("btn_friend"):setSelected(true)
    else
        nd:getChildByName("btn_friend"):setSelected(false)
    end
    
    --删除
    local del = nd:getChildByName("btn_delete")
    del:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            PromptView:type2(StringRes.notice,
                StringRes.collection_1..data.name
                ,StringRes.ok,StringRes.cancel,
                function()
                    local msg = {id = data.id}
                    Connect:sendMsg("WorldAction","deleteWorldCollect",msg,
                        function(data)
                            --更新数据
                            if data.state == 1 then
                                table.remove(self.data,key)
                            	self:freshInfo()
                            end
                        end)
                end)

        end
    end)
    
    --资源
    local resCheckBox = nd:getChildByName("btn_resource")
    resCheckBox:addEventListener(function(sender,eventType)
            if eventType == ccui.CheckBoxEventType.selected then
                data.resType = 1
            elseif eventType == ccui.CheckBoxEventType.unselected then
                data.resType = 0
            end
    
    end)
    
    --敌人
    local enemyCheckBox = nd:getChildByName("btn_enemy")
    enemyCheckBox:addEventListener(function(sender,eventType)
        if eventType == ccui.CheckBoxEventType.selected then
            data.armyType = 1
        elseif eventType == ccui.CheckBoxEventType.unselected then
            data.armyType = 0
        end

    end)
    
    --朋友
    local friendCheckBox = nd:getChildByName("btn_friend")
    friendCheckBox:addEventListener(function(sender,eventType)
        if eventType == ccui.CheckBoxEventType.selected then
            data.friendType = 1
        elseif eventType == ccui.CheckBoxEventType.unselected then
            data.friendType = 0
        end

    end)
    
    --望远镜
    local btn_search = nd:getChildByName("btn_search")
    btn_search:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            gField:setCurCenterCell(data.x+1,data.y+1)
            gField:getData(true,true)
            self:removeFromParent()
        end
    end)
    --setCurCenterCell
    
    
    
    
end

--初始化信息
function CollectionInfo:freshInfo()
    local list  = self.csd:getChildByName("panel_world_favorite_outline"):getChildByName("listview_favorite_list")
    list:removeAllItems()
    
    for key, var in pairs(self.data) do
        if self.showType == 1 then
            local temp = self.csd:getChildByName("panel_world_favorite_outline"):getChildByName("panel_favorite"):clone()
            
            self:freshOneInfo(temp,var,key)
            list:pushBackCustomItem(temp)
            
        elseif self.showType == 2 then
            if var.resType == 1 then
                local temp = self.csd:getChildByName("panel_world_favorite_outline"):getChildByName("panel_favorite"):clone()

                self:freshOneInfo(temp,var,key)
                list:pushBackCustomItem(temp)
            end
        elseif self.showType == 3 then
            if var.armyType == 1 then
                local temp = self.csd:getChildByName("panel_world_favorite_outline"):getChildByName("panel_favorite"):clone()

                self:freshOneInfo(temp,var,key)
                list:pushBackCustomItem(temp)
            end
        elseif self.showType == 4 then
            if var.friendType == 1 then
                local temp = self.csd:getChildByName("panel_world_favorite_outline"):getChildByName("panel_favorite"):clone()

                self:freshOneInfo(temp,var,key)
                list:pushBackCustomItem(temp)
            end
    	end
    end
    
    
    
    
end



return CollectionInfo