
local socket = require "socket"
local Scheduler = cc.Director:getInstance():getScheduler()


ElsePersonInfo = class("ElsePersonInfo",function()
    return display.newLayer()
end)


function ElsePersonInfo:ctor()

    self.csb = cc.uiload:load("csd/world/Layer_world_palyer_else.csb")
    self:addChild(self.csb)
    
    
    self.bg = self.csb:getChildByName("panel_mask"):getChildByName("panel_world_resource_bg")
    
    --关闭
    local close = self.bg:getChildByName("btn_delete")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transZoomIn(self.bg , function()
                self:removeFromParent()
            end)
            
        end
    end)
    
end



--初始化数据  (data为格子数据)
function ElsePersonInfo:initData(data)
    
    --btn_info
    
    
    
    --名字
    local nameinfo = data.playerName
    local levelinfo = "Lv."..data.playerlv
    if data.warlv > 0 then
        nameinfo = nameinfo.."("..StringRes[gMilitary_rank[data.warlv].military]..")"
    else
        nameinfo = nameinfo
    end

    self.bg:getChildByName("text_name_info"):setString( nameinfo )
    self.bg:getChildByName("text_rank_info"):setString( levelinfo )
    
    

    --坐标
    self.bg:getChildByName("text_coordinate_info"):setString("("..data.x..","..data.y..")")
    
    
    --地形
    local terrain = self.bg:getChildByName("panel_player_geography")
    local offset = {
        [1] = { x = -1,y = 1},
        [2] = { x = 0,y = 1},
        [3] = { x = 1,y = 1},

        [4] = { x = -1,y = 0},
        [5] = { x = 0,y = 0},
        [6] = { x = 1,y = 0},

        [7] = { x = -1,y = -1},
        [8] = { x = 0,y = -1},
        [9] = { x = 1,y = -1},
    }
    for var=1, 9 do
        local t = terrain:getChildByName("btn_geography_0"..var)
        local tc = t:getChildByName("icon_geography_0"..var)
        tc:loadTexture( Field:getTerrainRes(data["terrainId"..var]),ResType)
        --点击查看
        t:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                if data["terrainId"..var] == 0 then
                    FlyWordPrompt:prompt(StringRes.world_bianyuan)
                else
                    --地形信息
                    local te = ManyDialogInfo:createTerrain(data["terrainId"..var],data.x+offset[var].x,data.y+offset[var].y)
                    self:addChild(te)
                end
                
            end
        end)
    end
    
    --箭头计算
    local pd = PlayerData:getInstanse()
    local x1 = pd.basicData.x-data.x
    local y1 = pd.basicData.y-data.y
    local angle = cc.pGetAngle({x=x1,y=y1},{x=0,y=1})/math.pi*180
    if angle < -67.5 then
        angle = angle + 360
    end
    local num = 1
    for var=1, 8 do
        if angle < 45*var-67.5 then
            num = var
            break
        end
    end
    for var=1, 8 do
        if var == num then
            terrain:getChildByName("icon_arrow_0"..var):setVisible(true)
        else
            terrain:getChildByName("icon_arrow_0"..var):setVisible(false)
        end
    end
    
    --属性
    local tt = { 
        [1] = 1,
        [2] = 2,
        [3] = 3,
        
        [4] = 6,
        [5] = 9,
        [6] = 8,
        
        [7] = 7,
        [8] = 4,
    }
    local info = StringTemp:strtoTable(gWorldTerrain[data["terrainId"..tt[num]]].Attribute)

    --
    local i = 1
    local nameTable = {"text_attack","taxt_defend"}
    for key, var in pairs(info) do
        self.bg:getChildByName(nameTable[i]):setString( StringRes[key]..":")

        local value = self.bg:getChildByName(nameTable[i]):getChildByName("text_value")
        if var > 0 then
            value:setString( "+"..(var*100).."%")
            value:setColor(CommonColor.Green)
            self.bg:getChildByName(nameTable[i]):setColor(CommonColor.Green)
        else
            value:setString( (var*100).."%")
            value:setColor(CommonColor.Red)
            self.bg:getChildByName(nameTable[i]):setColor(CommonColor.Red)
        end

        i = i + 1
    end
    
    
    
    
    
    --侦查
    local btn_scout = self.bg:getChildByName("btn_scout")
    btn_scout:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            
            PromptView:type2(StringRes.notice,
                string.format(StringRes.spy_1,SpyInfo:needCrystal(2,data.playerlv) )
                ,StringRes.ok,StringRes.cancel,
                function()
                    local msg = {x=data.x,y=data.y,type = 2}
                    Connect:sendMsg("WorldAction","spyonWorld",msg,
                        function(data1)
                            --更新数据
                            data1.x = data.x
                            data1.y = data.y
                            --data1.terrainId = data["terrainId"..tt[num]]
                            local spy = SpyInfo.new(data1)
                            
                            local myparent = self:getParent()
                            self:removeFromParent()
                            myparent:addChild(spy)
                            
                        end)
                end)
        
        end
    end)
    
    
    --搜藏
    local btn_favorite = self.bg:getChildByName("btn_favorite")
    btn_favorite:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local co = ManyDialogInfo:Collection( data.playerName,data.x,data.y,data.playerlv)
            self:addChild(co)

        end
    end)
    
    --描述
    local btn_info = self.bg:getChildByName("btn_info")
    btn_info:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            --地形信息
            local te = ManyDialogInfo:createPlayerInfo(data)
            self:addChild(te)

        end
    end)
    
    if data.guildId == pd.basicData.guildId and pd.basicData.guildId ~= 0 then
    	--驻防
        local btn_defense = self.bg:getChildByName("btn_attack")
        btn_defense:setTitleText(StringRes.defense_here)
        btn_defense:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

            local msg = {x=data.x,y=data.y}
            Connect:sendMsg("WorldAction","getMoveTime",msg,
                function(data1)
                    local TroopsView = require("src/app/views/troops/TroopsView")
                    TroopsView:open(gWorldScene,7,{time = data1.time,pos = {x = data.x,y = data.y, terrainId = data["terrainId"..tt[num]] }})

                    self:removeFromParent()
                end)




            end
        end)
    else
        --攻击
        local btn_attack = self.bg:getChildByName("btn_attack")
        btn_attack:setTitleText(StringRes.attacking)
        btn_attack:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            
                local msg = {x=data.x,y=data.y}
                Connect:sendMsg("WorldAction","getMoveTime",msg,
                    function(data1)
                        local TroopsView = require("src/app/views/troops/TroopsView")
                        TroopsView:open(gWorldScene,2,{time = data1.time,pos = {x = data.x,y = data.y, terrainId = data["terrainId"..tt[num]] }})

                        self:removeFromParent()
                    end)
            
            
            
--                local TroopsView = require("src/app/views/troops/TroopsView")
--                TroopsView:open(gWorldScene,2,{pos = {x = data.x,y = data.y, terrainId = data["terrainId"..tt[num]] }})
--
--                self:removeFromParent()

            end
        end)
    end
    
    
    
end



return ElsePersonInfo