
local socket = require "socket"
local Scheduler = cc.Director:getInstance():getScheduler()


MySelfInfo = class("MySelfInfo",function()
    return display.newLayer()
end)


function MySelfInfo:ctor()

    self.csb = cc.uiload:load("csd/world/Layer_world_palyer.csb")
    self:addChild(self.csb)
    
    
    self.bg = self.csb:getChildByName("panel_mask"):getChildByName("panel_world_player_bg")
    
    --关闭
    local close = self.bg:getChildByName("btn_delete")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transZoomIn(self.bg , function()
                self:removeFromParent()
            end)
            
        end
    end)
    
end


--初始化数据  (data为格子数据)
function MySelfInfo:initData(data)
    

	
	--名字
	local nameinfo = data.playerName.."(Lv."..data.playerlv
	if data.warlv > 0 then
	   nameinfo = nameinfo..StringRes[gMilitary_rank[data.warlv].military]..")"
	else
        nameinfo = nameinfo..")"
	end
	
    self.bg:getChildByName("text_name_info"):setString( nameinfo )
    
    --头像
    local pd = PlayerData:getInstanse()
    self.bg:getChildByName("icon_outline"):getChildByName("icon_player"):loadTexture(gRoleHeadIcon[pd.basicData.icon])
    
    --坐标
    self.bg:getChildByName("text_coordinate_info"):setString("("..data.x..","..data.y..")")
    
    --地形
    local terrain = self.bg:getChildByName("panel_player_geography")
    local offset = {
        [1] = { x = -1,y = 1},
        [2] = { x = 0,y = 1},
        [3] = { x = 1,y = 1},
        
        [4] = { x = -1,y = 0},
        [5] = { x = 0,y = 0},
        [6] = { x = 1,y = 0},
        
        [7] = { x = -1,y = -1},
        [8] = { x = 0,y = -1},
        [9] = { x = 1,y = -1},
    }
    for var=1, 9 do
        local t = terrain:getChildByName("btn_geography_0"..var)
        local tc = t:getChildByName("icon_geography_0"..var)
        tc:loadTexture( Field:getTerrainRes(data["terrainId"..var]),ResType)
        --点击查看
        t:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            
                if data["terrainId"..var] == 0 then
                    FlyWordPrompt:prompt(StringRes.world_bianyuan)
                else
                    --地形信息
                    local te = ManyDialogInfo:createTerrain(data["terrainId"..var],data.x+offset[var].x,data.y+offset[var].y)
                    self:addChild(te)
                end
                
            end
        end)
    end
    
    
    --属性
    local info = StringTemp:strtoTable(gWorldTerrain[data.terrainId5].Attribute)

    --
    local i = 1
    local nameTable = {"text_attack","taxt_defend"}
    for key, var in pairs(info) do
        self.bg:getChildByName(nameTable[i]):setString( StringRes[key]..":")

        local value = self.bg:getChildByName(nameTable[i]):getChildByName("text_value")
        if var > 0 then
            value:setString( "+"..(var*100).."%")
            value:setColor(CommonColor.Green)
            self.bg:getChildByName(nameTable[i]):setColor(CommonColor.Green)
        else
            value:setString( (var*100).."%")
            value:setColor(CommonColor.Red)
            self.bg:getChildByName(nameTable[i]):setColor(CommonColor.Red)
        end

        i = i + 1
    end
    
    
    --进入基地
    local gotoBase = self.bg:getChildByName("btn_base")
    gotoBase:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            gWorldScene.BgPage = 1
            gWorldScene:TurnBgQuest()
        
            --
            self:removeFromParent()
            
        end
    end)
    
end



return MySelfInfo