
require("src/app/views/Field/ResourceInfo")

SpyInfo = class("SpyInfo",function(data)
    return display.newLayer()
end)



--侦查消耗水晶计算  type (1:资源点 2:城市) 
function SpyInfo:needCrystal(type,level)
    
    
    
    local re = math.pow(level,1.3)*135*type
    
    return re
end



function SpyInfo:ctor(data,isNpc)

    if isNpc == nil then
    	self.isNpc = false
    else
        self.isNpc = isNpc
    end

    
    --剩余的水晶
    local pd = PlayerData:getInstanse()
    pd.basicData.crystal = data.crystal


    self.data = data

    self.Top = CCUILoader:load("res/csd/public/PanelBgLarge.csb")
    self:addChild(self.Top)
    self.Top:getChildByName("text_title"):setString(StringRes.spy_2)
    --关闭
    local close = self.Top:getChildByName("btn_close")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:removeFromParent()
        end
    end)
    
   --界面CSD
    self.csd = CCUILoader:load("res/csd/report/ui_spy_report.csb")
    self:addChild(self.csd)
    
    self:initInfo()
end

--初始化信息
function SpyInfo:initInfo()
    local list  = self.csd:getChildByName("listview_spy_report")
    
    --攻击
    local attack = self.csd:getChildByName("btn_attack")
    attack:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
        
            local msg = {x=self.data.x,y=self.data.y}
            Connect:sendMsg("WorldAction","getMoveTime",msg,
                function(data1)
                    local TroopsView = require("src/app/views/troops/TroopsView")
                    TroopsView:open(gWorldScene,2,{time = data1.time,pos = {x = self.data.x,y = self.data.y, terrainId = self.data.terrainId }})

                    self:removeFromParent()
                    
                end)
        
        
            
        end
    end)
    
    if self.data.canAtk == 1 then
    	attack:setVisible(true)
    else
        attack:setVisible(false)
    end
    

    --关闭
    local close = self.csd:getChildByName("btn_del")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            
            
            local msg = {id = self.data.recordId,type = 2}
            Connect:sendMsg("MailAction","delMail",msg,function(newdata)
               
            end,true)
            
            self:removeFromParent()
            
        end
    end)
    
    
    
    --目标信息
    
    local panel_target_info = self.csd:getChildByName("panel_target_info"):clone()
    
    --名称
    --资源点
    if self.data.type == 1 then
        panel_target_info:getChildByName("text_spy_1"):setString(
            StringRes.spy_3..StringRes[resName[self.data.spyAdd]].."("..self.data.point..")")
    else
        panel_target_info:getChildByName("text_spy_1"):setString(
            StringRes.spy_3..self.data.playerName.."("..self.data.guildName..")".."("..self.data.point..")")
    end
    --地形
    panel_target_info:getChildByName("text_spy_2"):setString(StringRes.spy_4..gWorldTerrain[self.data.terrainId].name)
    
    --时间
    panel_target_info:getChildByName("text_spy_3"):setString(StringRes.spy_5..self.data.time)
    
    --驻守玩家
    if self.data.defend == "" then
        panel_target_info:getChildByName("text_spy_4"):setString(StringRes.spy_6)
    else
        panel_target_info:getChildByName("text_spy_4"):setString(StringRes.spy_6..self.data.defend.."("..self.data.guildName..")")
    end
    
    
    list:pushBackCustomItem(panel_target_info)
    
    
    --资源信息
    if self.data.type == 2 then
    
        
        
    --res_max_rob
        local panel_player_resource_info = self.csd:getChildByName("panel_player_resource_info"):clone()
        local tempTable = {
            [1] = {des = "text_spy_6",id = 2,val = self.data.robVO.fe},
            [2] = {des = "text_spy_7",id = 3,val = self.data.robVO.oil},
            [3] = {des = "text_spy_8",id = 4,val = self.data.robVO.lead},
            [4] = {des = "text_spy_9",id = 5,val = self.data.robVO.taitan},
            [5] = {des = "text_spy_10",id = 1,val = self.data.robVO.crystal},
        }
        for var=1, 5 do
            panel_player_resource_info:getChildByName(tempTable[var].des):setString( 
                string.format( StringRes.res_max_rob,StringRes[resName[tempTable[var].id]],StringTemp:toNum(tempTable[var].val)  ) )
        end
        list:pushBackCustomItem(panel_player_resource_info)
        
    else
    
        if self.isNpc then
            local panel_resource_info = self.csd:getChildByName("panel_resource_info"):clone()
            local num = math.ceil(50*(math.pow(self.data.spylv,2.5)+50))
            local str = string.format( StringRes.Rebel_report, num)
            panel_resource_info:getChildByName("text_spy_5"):setString(str)
            list:pushBackCustomItem(panel_resource_info)
        else
            local panel_resource_info = self.csd:getChildByName("panel_resource_info"):clone()
            local str = string.format( StringRes.spy_7,StringRes[resName[self.data.spyAdd ]]..StringTemp:toNum(self.data.yield) )
            if self.data.yieldUp > 1 then
                str = str.."\n"..string.format(StringRes.spy_8,self.data.yieldUp*self.data.yield)
            end

            if self.data.nowGather > 0 then
                str = str.."\n"..string.format(StringRes.spy_9,self.data.nowGather)
            end

            panel_resource_info:getChildByName("text_spy_5"):setString(str)

            list:pushBackCustomItem(panel_resource_info)
        end
    
    
        
    end
    
    
    --部队信息
    
    local panel_troops_info = self.csd:getChildByName("panel_troops_info"):clone()
    for key, var in pairs(self.data.armies) do
        local tankIcon = panel_troops_info:getChildByName("icon_troop_"..var.index)
        if var.count > 0 then
            local msg = Tank[var.id]
            tankIcon:loadTexture(msg.icon,ResType)
        
            tankIcon:getChildByName("text_troops_"..var.index):setString(StringRes[msg.name].."("..var.count..")" )
            
            
        else
            tankIcon:getChildByName("text_troops_"..var.index):setString("" )
        end
        
    end
    list:pushBackCustomItem(panel_troops_info)
    
end



return SpyInfo