
local socket = require "socket"
local Scheduler = cc.Director:getInstance():getScheduler()


WorldNpc = class("WorldNpc",function()
    return display.newLayer()
end)


function WorldNpc:ctor()

    self.csb = cc.uiload:load("csd/world/Layer_world_resource.csb")
    self:addChild(self.csb)
    
    
    self.bg = self.csb:getChildByName("panel_mask"):getChildByName("panel_world_resource_bg")
    
    --关闭
    local close = self.bg:getChildByName("btn_delete")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transZoomIn(self.bg , function()
                self:removeFromParent()
            end)
            
        end
    end)
    
end

--1为水晶 2为铁矿 3为石油 4为铅矿 5为钛矿
--crystal = "水晶",
--ferrum = "铁矿",
--oil = "石油",
--lead = "铅矿",
--titanium = "钛矿",
resName = {
    [1] = "crystal",
    [2] = "ferrum",
    [3] = "oil",
    [4] = "lead",
    [5] = "titanium",
    
    [6] = "Rebel_name1",
    [7] = "Rebel_name2",
    [8] = "Rebel_name3",
    [9] = "Rebel_name4",
    [10] = "Rebel_name5",
    [11] = "Rebel_name6",
}
-- resIcon = {
--     [1] = "res/pic/common/resources/icon_crystal.png",
--     [2] = "res/pic/common/resources/icon_copper.png",
--     [3] = "res/pic/common/resources/icon_oil.png",
--     [4] = "res/pic/common/resources/icon_iron.png",
--     [5] = "res/pic/common/resources/icon_ore.png",
    
--     [6] = "res/pic/common/resources/icon_ore.png",
--     [7] = "res/pic/common/resources/icon_ore.png",
--     [8] = "res/pic/common/resources/icon_ore.png",
--     [9] = "res/pic/common/resources/icon_ore.png",
--     [10] = "res/pic/common/resources/icon_ore.png",
--     [11] = "res/pic/common/resources/icon_ore.png",
-- }
resIcon = {
   [1] = "res/pic/world/building/icon_crystal.png",
    [2] = "res/pic/world/building/icon_copper.png",
    [3] = "res/pic/world/building/icon_oil.png",
    [4] = "res/pic/world/building/icon_iron.png",
    [5] = "res/pic/world/building/icon_ore.png",
    
    [6] = "res/pic/world/army/icon_army_1.png",
    [7] = "res/pic/world/army/icon_army_2.png",
    [8] = "res/pic/world/army/icon_army_3.png",
    [9] = "res/pic/world/army/icon_army_4.png",
    [10] = "res/pic/world/army/icon_army_5.png",
    [11] = "res/pic/world/army/icon_army_6.png",
    
}

--初始化数据  (data为格子数据)
function WorldNpc:initData(data)
    
    --名字
    self.bg:getChildByName("text_name_info"):setString(
        StringRes[resName[data.resType]].."(Lv."..data.lv..")")

    --坐标
    self.bg:getChildByName("text_coordinate_info"):setString("("..data.x..","..data.y..")")



    --采集速度
    self.bg:getChildByName("text_desc"):setVisible(false)
	
    
    --地形
    local terrain = self.bg:getChildByName("panel_player_geography")
    local offset = {
        [1] = { x = -1,y = 1},
        [2] = { x = 0,y = 1},
        [3] = { x = 1,y = 1},

        [4] = { x = -1,y = 0},
        [5] = { x = 0,y = 0},
        [6] = { x = 1,y = 0},

        [7] = { x = -1,y = -1},
        [8] = { x = 0,y = -1},
        [9] = { x = 1,y = -1},
    }
    for var=1, 9 do
        local t = terrain:getChildByName("btn_geography_0"..var)
        local tc = t:getChildByName("icon_geography_0"..var)
        tc:loadTexture( Field:getTerrainRes(data["terrainId"..var]),ResType)
        --点击查看
        t:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                --地形信息
                if data["terrainId"..var] == 0 then
                    FlyWordPrompt:prompt(StringRes.world_bianyuan)
                else
                    local te = ManyDialogInfo:createTerrain(data["terrainId"..var],data.x+offset[var].x,data.y+offset[var].y)
                    self:addChild(te)
                end
                
            end
        end)
    end
    
    --箭头计算
    local pd = PlayerData:getInstanse()
    local x1 = pd.basicData.x-data.x
    local y1 = pd.basicData.y-data.y
    local angle = cc.pGetAngle({x=x1,y=y1},{x=0,y=1})/math.pi*180
    if angle < -67.5 then
        angle = angle + 360
    end
    local num = 1
    for var=1, 8 do
        if angle < 45*var-67.5 then
            num = var
            break
        end
    end
    for var=1, 8 do
        if var == num then
            terrain:getChildByName("icon_arrow_0"..var):setVisible(true)
        else
            terrain:getChildByName("icon_arrow_0"..var):setVisible(false)
        end
    end
    
    --属性
    local tt = { 
        [1] = 1,
        [2] = 2,
        [3] = 3,
        
        [4] = 6,
        [5] = 9,
        [6] = 8,
        
        [7] = 7,
        [8] = 4,
    }
    local info = StringTemp:strtoTable(gWorldTerrain[data["terrainId"..tt[num]]].Attribute)

    --
    local i = 1
    local nameTable = {"text_attack","taxt_defend"}
    for key, var in pairs(info) do
        self.bg:getChildByName(nameTable[i]):setString( StringRes[key]..":")

        local value = self.bg:getChildByName(nameTable[i]):getChildByName("text_value")
        if var > 0 then
            value:setString( "+"..(var*100).."%")
            value:setColor(CommonColor.Green)
            self.bg:getChildByName(nameTable[i]):setColor(CommonColor.Green)
        else
            value:setString( (var*100).."%")
            value:setColor(CommonColor.Red)
            self.bg:getChildByName(nameTable[i]):setColor(CommonColor.Red)
        end

        i = i + 1
    end
    
    
    
    
    
    --侦查
    local btn_scout = self.bg:getChildByName("btn_scout")
    btn_scout:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local pd = PlayerData:getInstanse()
            if data.playerId == pd.basicData.playerId then
            	Common:showCodeInfo(100)
            elseif data.guildId == pd.basicData.guildId and pd.basicData.guildId ~= 0 then
                Common:showCodeInfo(101)
            else
                PromptView:type2(StringRes.notice,
                string.format(StringRes.spy_1,SpyInfo:needCrystal(1,data.lv) )
                ,StringRes.ok,StringRes.cancel,
                function()
                    local msg = {x=data.x,y=data.y,type = 1}
                    Connect:sendMsg("WorldAction","spyonWorld",msg,
                        function(data1)
                            --更新数据
                            data1.yieldUp = data.yieldUp
                            data1.x = data.x
                            data1.y = data.y
                            data1.terrainId = data["terrainId"..tt[num]]
                            local spy = SpyInfo.new(data1,true)
                            
                            local myparent = self:getParent()
                            self:removeFromParent()
                            myparent:addChild(spy)
                        end)
                end)
            end
            
        
        
            
            
        end
    end)
    
    --描述
    local btn_info = self.bg:getChildByName("btn_info")
    btn_info:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.Rebel_des1,24,CommonColor.White) )
        end
    end)
    

    --搜藏
    local btn_favorite = self.bg:getChildByName("btn_favorite")
    btn_favorite:setVisible(false)

    
    
    
    --攻击
    local btn_attack = self.bg:getChildByName("btn_attack")
    btn_attack:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
        
            local msg = {x=data.x,y=data.y}
            Connect:sendMsg("WorldAction","getMoveTime",msg,
                function(data1)
                    local TroopsView = require("src/app/views/troops/TroopsView")
                    TroopsView:open(gWorldScene,2,{time = data1.time,pos = {x = data.x,y = data.y, terrainId = data["terrainId"..tt[num]] }})

                    self:removeFromParent()
                end)
        
        
        
            

        end
    end)
    
end



return WorldNpc