local PanelTabLayer = require("src/app/views/public/PanelTabLayer")

local Military = require("src/app/views/PlayerInfo/Military")
local MilitaryRank = require("src/app/views/PlayerInfo/MilitaryRank")

local BagAndStore = require("src/app/views/bag/BagAndStore")
local Scheduler = cc.Director:getInstance():getScheduler()
local PlayerInfo = class("PlayerInfo",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.player_info,tabs={StringRes.main_info,StringRes.skill,StringRes.builder}})
end)

function PlayerInfo:ctor(scene)
    self.info = nil
    self.skill = nil
    self.build = nil
    self:initTabs()

    ViewManager:OpenView(self)
end

function PlayerInfo:resetContent()
    if self.info then self.info:setVisible(false) end
    if self.skill then self.skill:setVisible(false) end
    if self.build then self.build:setVisible(false) end
end

function PlayerInfo:ViewPage(page)
    if self.info then self.info:setVisible(false) end
    if self.skill then self.skill:setVisible(false) end
    if self.build then self.build:setVisible(false) end

    page:setVisible(true)
end


--自动升级 提取等级最低且能升级的技能
function PlayerInfo:getMinSkill()
    local pd = PlayerData:getInstanse()
    if pd.basicData == nil then
        return nil
    end

    --等级最低
    local minVar = nil
    for key, var in pairs(pd.basicData.skillVOs) do
        if minVar == nil then
            minVar = var
        else
            if var.lv < minVar.lv then
                minVar = var
            elseif var.lv == minVar then
                if var.id < minVar.id then
                    minVar = var
                end
            end
        end

    end


    --是否能升级
    local nextLv = minVar.lv+1
    if nextLv > pd.basicData.medal or nextLv > pd.basicData.lv then
        return nil
    else
        local havemedal = pd.basicData.medal
        while nextLv <= havemedal and nextLv <= pd.basicData.lv do 
            havemedal = havemedal-nextLv
            nextLv = nextLv+1
        end
        minVar.upgradeLv = nextLv-1
        return minVar
    end

end



function PlayerInfo:FreshSkill()

    local pd = PlayerData:getInstanse()
    if pd.basicData == nil then
        return
    end

    --底部按钮
    local bottom = self.skill:getChildByTag(2)
    --自动升级按钮
    local autoupgradeBtn = bottom:getChildByName("Button_3")

    showShader:buttonToGray(autoupgradeBtn)
    local minSkill = self:getMinSkill()
    if minSkill == nil then
        Common:setBtnTouchEnable(autoupgradeBtn,false)
    else
        Common:setBtnTouchEnable(autoupgradeBtn,true)
    end
    autoupgradeBtn.data = minSkill
    autoupgradeBtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            PromptView:type2(StringRes.notice,
                string.format(StringRes.autolvup,StringRes[gPlayerSkill[e.data.id].name],e.data.upgradeLv)
                ,StringRes.ok,StringRes.cancel,
                function()
                    local msg = {skillId = e.data.id}
                    Connect:sendMsg("SkillAction","autoUpLvSkill",msg,
                        function(data)
                            --更新数据
                            pd.basicData.medal = data.medal
                            --重置技能列表数据
                            e.data.lv = data.lv

                            FlyWordPrompt:prompt(string.format(StringRes.skill_uplevel_success,StringRes[gPlayerSkill[e.data.id].name],data.lv))
                            self:FreshSkill()
                        end)
                end)
        end
    end)

    --重置
    local resetBtn = bottom:getChildByName("Button_4")
    resetBtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            PromptView:type2(StringRes.notice,
                string.format(StringRes.reset,28*15)
                ,StringRes.ok,StringRes.cancel,
                function()
                    Connect:sendMsg("SkillAction","resetSkill",nil,
                        function(data)
                            --更新数据
                            pd.basicData.medal = data.medal
                            pd.basicData.gold = data.gold
                            --重置技能列表数据
                            for key, var in pairs(pd.basicData.skillVOs) do
                                var.lv = 0
                            end

                            self:FreshSkill()
                        end)
                end)
        end
    end)

    --购买
    local buyBtn = bottom:getChildByName("Button_5")
    buyBtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local parent = self:getParent()
            self:removeFromParent()
            --商店
            local bb = BagAndStore.new(parent,2)
            bb.SelectType = 4
            parent:addChild(bb)


        end
    end)

    --文字
    local curMetalWords = bottom:getChildByName("Text_5")
    curMetalWords:setString( string.format(StringRes.prestige_got_now,pd.basicData.medal))


    --列表
    local lv = self.skill:getChildByTag(1):getChildByName("listview")
    lv:removeAllItems()

    --local model = cc.uiload:load("res/csd/public/PlayerOneSkill.csb"):getChildByName("Panel_1")

    if pd.basicData.skillVOs ~= nil then

        for key, var in pairs(pd.basicData.skillVOs) do
            local m1 = preLoad:getPanel("PlayerInfoSkill")

            --下一级
            local nextLv = var.lv+1


            --图标
            local icon = m1:getChildByName("Image_2")
            icon:loadTexture(gPlayerSkill[var.id].icon,ResType)

            --名字描述
            m1:getChildByName("Text_1"):setString( StringRes[gPlayerSkill[var.id].name].."Lv."..var.lv)

            --等级
            --m1:getChildByName("Text_2"):setString("Lv."..var.lv)

            --描述
            m1:getChildByName("Text_4"):setString(   string.format(StringRes[gPlayerSkill[var.id].lvup],var.lv)  )


            --升级按钮
            local upgradeBtn = m1:getChildByName("Button_1")

            showShader:buttonToGray(upgradeBtn)

            if nextLv > pd.basicData.medal or nextLv > pd.basicData.lv then
                Common:setBtnTouchEnable(upgradeBtn,false)
            else
                Common:setBtnTouchEnable(upgradeBtn,true)
            end
            upgradeBtn.data = var
            upgradeBtn:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    local msg = {skillId = e.data.id}
                    Connect:sendMsg("SkillAction","upLvSkill",msg,
                        function(data)
                            --更新数据
                            pd.basicData.medal = data.medal
                            --重置技能列表数据
                            var.lv = data.lv
                            FlyWordPrompt:prompt(string.format(StringRes.skill_uplevel_success,StringRes[gPlayerSkill[var.id].name],data.lv))
                            self:FreshSkill()
                        end)
                end
            end)

            --信息按钮
            local infoBtn = m1:getChildByName("Button_2")
            infoBtn.data = var
            infoBtn:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    local data = Common:copyTab(require("src/app/cfg/DescriptCfg").SkillInfo)
                    data[1][1].str = StringRes[gPlayerSkill[e.data.id].name].."Lv."..var.lv
                    data[2][1].str = StringRes[gPlayerSkill[e.data.id].eff_des]
                    data[3][1].str = "    "
                    data[4][1].str = StringRes.lvup_need
                    data[5][1].str = string.format(StringRes.mylv,nextLv)
                    if nextLv > pd.basicData.lv then
                        data[5][1].color=CommonColor.Red
                    end
                    data[6][1].str = string.format(StringRes.need_xunzhang,nextLv)
                    if nextLv > pd.basicData.medal then
                        data[6][1].color=CommonColor.Red
                    end


                    local DescriptView = require("src/app/views/prompt/DescriptView")
                    DescriptView:open(self,data)
                end
            end)

            lv:pushBackCustomItem(m1)
        end
    end


end


function PlayerInfo:FreshInfo()

    local pd = PlayerData:getInstanse()
    if pd.basicData == nil then
        return
    end

    local lv = self.info:getChildByName("listview")

    --玩家基本信息
    local baseInfo = lv:getItem(0)

    --头像
    baseInfo:getChildByName("icon_"):getChildByName("photo1"):loadTexture(gRoleHeadIcon[pd.basicData.icon])

    --名字
    baseInfo:getChildByName("Text_6"):setString(pd.basicData.name)

    --改名卡
    SpecialView:registerEvent( baseInfo:getChildByName("Image_7"),ccui.TouchEventType.ended,function()
        PlayerData:getInstanse():changeName(function()
            baseInfo:getChildByName("Text_6"):setString(pd.basicData.name)
        end)
    end)
    --战斗力
    baseInfo:getChildByName("Text_9"):setString(pd.basicData.comat)
    --带兵量
    baseInfo:getChildByName("Text_10"):setString(pd.basicData.armyCount+pd.basicData.warArmyCount+pd.basicData.commandArmyCount)
    --等级
    baseInfo:getChildByName("Text_4"):setString("Lv."..pd.basicData.lv)
    --经验值
    baseInfo:getChildByName("Text_11"):setString(StringTemp:toNum(pd.basicData.exp).."/"..StringTemp:toNum(pd.basicData.expMax))




    local function update(delta)
        local timeSrc = ""
        if pd.basicData.energyTime > 0 then
            timeSrc = "("..StringTemp:toTime(pd.basicData.energyTime)..")"
        end
        --能量值
        baseInfo:getChildByName("Text_12"):setString(pd.basicData.energy.."/"..gMaxEnergy..timeSrc)
    end
    update()
    local function onNodeEvent(tag)
        if tag == "enter" then
            self.update = Scheduler:scheduleScriptFunc(update, 0.9, false)
        elseif tag == "exit" then
            Scheduler:unscheduleScriptEntry(self.update)
        end
    end
    self:registerScriptHandler(onNodeEvent)





    --经验值进度条
    baseInfo:getChildByName("LoadingBar_1"):setPercent(pd.basicData.exp/pd.basicData.expMax*100)
    --能量值
    baseInfo:getChildByName("LoadingBar_2"):setPercent(pd.basicData.energy/gMaxEnergy*100)


    --购买能量按钮
    local buyEnergyBtn = baseInfo:getChildByName("Button_1")
    buyEnergyBtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

            PromptView:type2(StringRes.notice,
                string.format(StringRes.gold_buy_energy,pd.basicData.buyEnergyCost,5)
                ,StringRes.ok,StringRes.cancel,
                function()
                    Connect:sendMsg("PlayerAction","buyEnergy",nil,
                        function(data)
                            --更新数据
                            pd.basicData.energy = data.energy
                            pd.basicData.gold = data.gold
                            pd.basicData.energyTime = data.energyTime

                            pd.basicData.buyEnergyCost = data.buyEnergyCost
                            self:FreshInfo()
                        end)
                end)

        end
    end)
    local info1 = baseInfo:getChildByName("Button_1_Copy")
    info1:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.text_world00033))
        end
    end)
    
    
    --

    --军功信息
    local MilitaryInfo = lv:getItem(1)
    --图标
    local icon = MilitaryInfo:getChildByName("Image_5"):getChildByName("Image_2")
    icon:loadTexture(gMilitary_rank[pd.basicData.warLv].icon,ResType)

    --军衔
    MilitaryInfo:getChildByName("Text_1"):setString( StringRes[gMilitary_rank[pd.basicData.warLv].military])

    --军功
    MilitaryInfo:getChildByName("Text_3"):setString( StringTemp:toNum(pd.basicData.allWarCon) )
    --MilitaryInfo:getChildByName("Text_3"):setString( "" )

    --带兵数
    MilitaryInfo:getChildByName("Text_5"):setString( pd.basicData.warArmyCount )

    --信息按钮
    local infoBtn = MilitaryInfo:getChildByName("Button_1")
    infoBtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local military = Military.new()
            self:addChild(military)
        end
    end)


    --军功排行
    local Button_2 = MilitaryInfo:getChildByName("Button_2")
    Button_2:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local militaryrk = MilitaryRank.new()
            self:addChild(militaryrk)
        end
    end)

    --开放日期
    local Button_3 = MilitaryInfo:getChildByName("Button_3")
    Button_3:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local msg = {}
            Connect:sendMsg("PlayerAction","openWarShop",msg,
                function(data)
                    require("src/app/views/PlayerInfo/WarStore"):show(self,data)
                end)
            --            FlyWordPrompt:prompt(StringRes.open_1)
        end
    end)


    --统帅信息
    local TongShuaiInfo = lv:getItem(2)
    --统帅等级
    TongShuaiInfo:getChildByName("Text_2"):setString( "Lv."..pd.basicData.commandLv )
    --基础带兵数
    TongShuaiInfo:getChildByName("Text_4"):setString( pd.basicData.armyCount )
    --统帅带兵数
    TongShuaiInfo:getChildByName("Text_5"):setString( "+"..pd.basicData.commandArmyCount )

    --统率信息按钮
    local nextTongshuaiLv = pd.basicData.commandLv+1
    local sucoe = 1-(pd.basicData.commandLv-5)*0.03         --zhugan
    local gailv = ((sucoe)*100)
    if gailv >= 100 then
        gailv = 100
    end
    if gailv<4 then
        gailv = 4
    end
    gailv = ((gailv+pd.PlayerAddition.commandPro*100))
    local trrew = 0                                     


    local tongshuaiBtn = TongShuaiInfo:getChildByName("Button_2")
    tongshuaiBtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

            local DescriptView = require("src/app/views/prompt/DescriptView")
            
            --gVIP



            local str = string.format(StringRes.tongshuai_info,nextTongshuaiLv,math.ceil(math.pow(nextTongshuaiLv,1.35)+2),
                gailv.."%",nextTongshuaiLv,pd.basicData.commandBook )

            local t = StringTemp:Descript(str)
            if pd.basicData.lv < nextTongshuaiLv then
                t[8][1].color = CommonColor.Red
            end

            DescriptView:open(self,t )




        end
    end)
    --统率升级按钮
    local tongshuaiUpBtn = TongShuaiInfo:getChildByName("Button_1")
    showShader:buttonToGray(tongshuaiUpBtn)

    if nextTongshuaiLv > pd.basicData.lv then
        Common:setBtnTouchEnable(tongshuaiUpBtn,false)
    else
        Common:setBtnTouchEnable(tongshuaiUpBtn,true)
    end

    tongshuaiUpBtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if pd.basicData.commandBook <= 0 then
                PromptView:type2(StringRes.notice,
                    string.format(StringRes.gold_buyanduse_Tongshuai,gStore[43].price*15)
                    ,StringRes.ok,StringRes.cancel,
                    function()

                        local msg = {id = pd.basicData.commandBookId,type = 2}
                        Connect:sendMsg("PlayerAction","upCommandLv",msg,
                            function(data)
                                --更新数据
                                --pd.basicData.id = data.id
                                --pd.basicData.gold = data.gold
                                
                                local lastV = 0
                                if pd.basicData.commandLv > 0 then
                                	lastV = math.ceil(math.pow(pd.basicData.commandLv,1.35))+2
                                end
                                
                                
                                --成功
                                if data.state == 1 then
                                    FlyWordPrompt:prompt( string.format(StringRes.upgrade_1,
                                        math.ceil(math.pow(data.commandLv,1.35)+2-lastV)) )
                                else--失败
                                    FlyWordPrompt:prompt( StringRes.upgrade_2)
                                end
                                --
                                pd.basicData.commandLv = data.commandLv
                                pd.basicData.commandArmyCount = data.commandArmyCount
                                pd.basicData.gold = data.gold
                                pd.basicData.commandBook = data.commandBook
                                pd.basicData.comat = data.combat


                                self:FreshInfo()
                            end)
                    end)
            else
                local msg = {id = pd.basicData.commandBookId,type = 1}
                Connect:sendMsg("PlayerAction","upCommandLv",msg,
                    function(data)
                        --更新数据
                        --pd.basicData.id = data.id
                        --pd.basicData.gold = data.gold
                        
                        local lastV = 0
                        if pd.basicData.commandLv > 0 then
                            lastV = math.ceil(math.pow(pd.basicData.commandLv,1.35))+2
                        end
                        
                        --成功
                        if data.state == 1 then
                            FlyWordPrompt:prompt( string.format(StringRes.upgrade_1,
                                math.ceil(math.pow(data.commandLv,1.35)+2-lastV)) )
                        else--失败
                            FlyWordPrompt:prompt( StringRes.upgrade_2)
                        end
                        --
                        pd.basicData.commandLv = data.commandLv
                        pd.basicData.commandArmyCount = data.commandArmyCount
                        pd.basicData.gold = data.gold
                        pd.basicData.commandBook = data.commandBook
                        pd.basicData.comat = data.combat
                        self:FreshInfo()
                    end)
            end

        end
    end)





    --声望信息
    local ShengwangInfo = lv:getItem(3)
    --声望等级
    ShengwangInfo:getChildByName("Text_2"):setString( "Lv."..pd.basicData.prestigeLv )

    --声望数值
    ShengwangInfo:getChildByName("Text_3"):setString( pd.basicData.prestige.."/"..pd.basicData.preMax )

    --声望值进度条
    ShengwangInfo:getChildByName("LoadingBar_1"):setPercent(pd.basicData.prestige/pd.basicData.preMax*100)

    --声望数值
    ShengwangInfo:getChildByName("Text_4"):setString( string.format(StringRes.get_shengwang_everyday,gMilitary_rank[pd.basicData.warLv].Prestige) )

    --声望信息按钮
    local ShengwangBtn = ShengwangInfo:getChildByName("Button_2")
    ShengwangBtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            --PopWordsInfo:show(self,StringRes.shengwang_info)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.shengwang_info) )
        end
    end)

    --声望升级按钮
    local ShengwangUpgBtn = ShengwangInfo:getChildByName("Button_1")
    ShengwangUpgBtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local ennoble = Ennoble.new()
            self:addChild(ennoble)


            local function onNodeEvent(tag)
                if tag == "exit" then

                    self:FreshInfo()

                end
            end
            ennoble:registerScriptHandler(onNodeEvent)

        end
    end)


end



function PlayerInfo:FreshBuild()
    local pd = PlayerData:getInstanse()

    local AllBuilder = {}

    local pos = 1
    --基础建筑
    if pd.baseBuild ~= nil then
        for key, var in pairs(pd.baseBuild) do
            -- or var.time > 0
            if (var.buildLv >= 1) and gBuilding[var.templateId].lv >= 1 then

                local timescore = 0
                if var.time > 0 then
                    timescore = 100000000
                end

                local t1 =
                    {
                        buildType = var.buildType,
                        buildLv = var.buildLv,
                        time = var.time,
                        dbId = var.dbId,
                        allTime = var.allTime,
                        templateId = var.templateId,
                        blockId = 0,
                        Type = 1,
                        sortScore = var.templateId*10000+var.dbId*100+timescore-var.buildLv*1000000,
                    }
                --print("---------------t1.time:",t1.time)
                AllBuilder[pos] = t1
                pos = pos+1
            end
        end
    end
    --郊外建筑
    if pd.outSideBuild ~= nil then
        for key, var in pairs(pd.outSideBuild) do
            if var.buildLv >= 1 then

                local timescore = 0
                if var.time > 0 then
                    timescore = 100000000
                end
                local t1 =
                    {
                        buildType = var.buildType,
                        buildLv = var.buildLv,
                        time = var.time,
                        dbId = var.dbId,
                        allTime = var.allTime,
                        templateId = var.templateId,
                        blockId = var.blockId,
                        Type = 2,
                        sortScore = var.templateId*10000+var.dbId*100+timescore-var.buildLv*1000000,
                    }
                AllBuilder[pos] = t1
                pos = pos+1
            end
        end
    end



    --数据排序
    table.sort(AllBuilder,
        function(a,b)
            if a ~= nil and b ~= nil then
                if a.time > 0 and b.time > 0 then

                    return a.sortScore > b.sortScore

                elseif a.time > 0 then
                    return true
                elseif b.time > 0 then
                    return false
                else
                    return a.sortScore > b.sortScore
                end
            else
                if a == nil then
                    return false
                else
                    return true
                end
            end

        end)




    local lv = self.build:getChildByName("listview")
    lv:removeAllItems()
    print("--updateRelese--")
    preLoad:updateRelese()

    local item1 = CCUILoader:load("res/csd/public/ProducingItem.csb"):getChildByName("content")
    --local item2 = CCUILoader:load("res/csd/public/BuilderInfo.csb"):getChildByName("Panel_1")
    for key, var in pairs(AllBuilder) do

        if var.time > 0 then
            local it = item1:clone()

            --图标
            Common:changePic(it:getChildByName("icon_item"),gBuilding[var.templateId].icon)
            --it:getChildByName("icon_item"):setScale(1)
            --标题
            it:getChildByName("text_title"):setString( StringRes[gBuilding[var.templateId].name].."Lv."..var.buildLv)


            --取消按钮
            local exitBtn = it:getChildByName("btn_cancel")
            exitBtn.data = var
            exitBtn:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    --取消升级
                    --取消
                    require("src/app/util/DialogUtil"):cancel(function()
                        local msg = { type = e.data.buildType , dbId=e.data.dbId}
                        Connect:sendMsg("BuildAction","cancelBuildLvup",msg,
                            function (data)
                                local pd = PlayerData:getInstanse()
                                pd:cancelBuildFresh(data)
                                self:FreshBuild()
                            end,true)
                    end)
                end
            end)

            --加速按钮
            local quickBtn = it:getChildByName("btn_speed")
            quickBtn.data = var
            quickBtn:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    function SpeedUp()

                        --加速
                        local msg = { type = e.data.buildType , dbId=e.data.dbId}
                        Connect:sendMsg("BuildAction","buildOverSpeedUpFree",msg,
                            function (data)
                                local pd = PlayerData:getInstanse()
                                pd:BuildTimeOverFresh(data)
                                self:FreshBuild()
                                FlyWordPrompt:prompt(string.format(StringRes.levelup_info,StringRes[gBuilding[data.templateId].name],data.lv))
                            end,true)
                    end
                    local spend = Common:getSpendByTime(e.data.time)
                    if spend > PlayerData:getInstanse().basicData.lvUpFreeGold then
                        DialogUtil:speedUp( e.data.time, SpeedUp)
                    else
                        SpeedUp()
                    end

                end


            end)


            local function updateTime(t)
                --print("---------------time:",t)
                --更新时间
                var.time = var.time-t
                --print("---------------var.time:",var.time)
                if var.time < 0 then

                    if var.send == nil then
                        NodeTranslator:deltaDo(1.99,
                            function()
                                self:FreshBuild()
                            end
                        )
                        var.send = true
                    end

                    
                    
                    it:getChildByName("text_time"):setString( StringTemp:toTime(0))
                    --进度条
                    it:getChildByName("progress"):setPercent( 100)

                else
                    --时间数字


                    it:getChildByName("text_time"):setString( StringTemp:toTime(var.time))
                    --进度条
                    it:getChildByName("progress"):setPercent( 100-var.time/var.allTime*100)
                    local spend = Common:getSpendByTime(var.time)
                    spend = spend>PlayerData:getInstanse().basicData.lvUpFreeGold and spend or 0
                    if spend > 0 then
                        it:getChildByName("Text_coin"):setString(spend)
                    else
                        it:getChildByName("Text_coin"):setString(StringRes.Text_Free)
                    end
                    it:getChildByName("Text_coin"):setColor(spend>PlayerData:getInstanse().basicData.gold and CommonColor.Red or CommonColor.White)
                end



            end

            local function onNodeEvent(tag)
                if tag == "enter" then
                    updateTime(0)
                    it.updateTime = Scheduler:scheduleScriptFunc(updateTime, 0.9, false)
                elseif tag == "exit" then
                    Scheduler:unscheduleScriptEntry(it.updateTime)
                end
            end
            it:registerScriptHandler(onNodeEvent)

            lv:pushBackCustomItem(it)
        else
            local it = preLoad:getPanel("PlayerInfoBuilder")

            --图标
            it:getChildByName("Image_2"):loadTexture(gBuilding[var.templateId].icon,ResType)

            --            --标题
            --            it:getChildByName("Text_1"):setString( StringRes[gBuilding[var.templateId].name].."Lv."..var.buildLv)
            --标题
            it:getChildByName("Text_1"):setString( StringRes[gBuilding[var.templateId].name])
            --等级
            it:getChildByName("Text_2"):setString( "Lv."..var.buildLv)
            --时间

            it:getChildByName("Text_4"):setString( StringTemp:toTime(Common:getBuildingUpTime(var.buildLv+1,var.templateId)))




            --升级按钮
            local Button_levelUp = it:getChildByName("Button_1")
            showShader:buttonToGray(Button_levelUp)
            Button_levelUp.data = var
            Button_levelUp:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    --升级
                    local msg = { type = e.data.buildType , dbId=e.data.dbId}
                    Connect:sendMsg("BuildAction","buildinglvup",msg,
                        function (data)
                            if data.type == 0 then
                                --队列满
                                local bld = PlayerData:getInstanse():getMinTimeLevelUpBld()
                                ManyDialogInfo:more_produce_queues(bld.time,"buildQueue",PlayerData:getInstanse().basicData.lvUpFreeGold,function()
                                    local msg = { type = bld.buildType , dbId=bld.dbId}
                                    Connect:sendMsg("BuildAction","buildOverSpeedUp",msg,
                                        function (v)
                                            --加速完成
                                            local pd = PlayerData:getInstanse()
                                            pd:BuildTimeOverFresh(v)
                                            self:FreshBuild()
                                            FlyWordPrompt:prompt(string.format(StringRes.levelup_info,StringRes[gBuilding[v.templateId].name],v.lv))
                                        end)
                                end)
                            else
                                local pd = PlayerData:getInstanse()
                                pd:BuildFresh(data)
                                self:FreshBuild()
                            end
                        end,true)
                end
            end)

            --立刻升级按钮
            local Button_levelUpNow = it:getChildByName("Button_9")
            Button_levelUpNow.data = var
            showShader:buttonToGray(Button_levelUpNow)            
            Button_levelUpNow:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    require("src/app/util/SDKPlatform")
                    SDKPlatform:printLog("Button_levelUpNow")
                    local spend  = Common:getGoldNeedForBuild(e.data)
                    DialogUtil:LvupNow(spend, function()
                        --立刻完成
                        local msg = { type = e.data.buildType , dbId = e.data.dbId}
                        Connect:sendMsg("BuildAction","buildinglvupNow",msg,
                            function (sdata)                            
                                pd:BuildFresh(sdata)
                                pd:BuildTimeOverFresh(sdata)
                                self:FreshBuild()

                                FlyWordPrompt:prompt(string.format(StringRes.levelup_info,StringRes[gBuilding[sdata.templateId].name],sdata.lv))

                                local text = '{"'..StringRes[gBuilding[sdata.templateId].name]..'":"'..tostring(sdata.lv)..'"}'
                            end, true)
                    end)                   
            end
            end)
            Common:setBtnTouchEnable(Button_levelUpNow, true)  


            --信息按钮
            local Button_Info = it:getChildByName("Button_2")
            Button_Info.data = var
            Button_Info:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    ResNeedPopInfo:show(self,e.data)
                end
            end)

            local function updateTime(t)

                local spend = Common:getGoldNeedForBuild(var)
                local buildstate = Buildings:CheckUpgrade(var.templateId,var.buildLv)

                local Image_Coin = it:getChildByName("Image_coin")
                local Text_Coin = it:getChildByName("Text_coin")
                                
                Image_Coin:setVisible(buildstate ~= 3)
                Text_Coin:setVisible(buildstate ~= 3)
                Text_Coin:setString(spend)
                Text_Coin:setColor(spend>PlayerData:getInstanse().basicData.gold and CommonColor.Red or CommonColor.White)

                local Text_Time = it:getChildByName("Text_4")

                if buildstate == 1 then
                    --可以建造
                    Common:setBtnTouchEnable(Button_levelUp,true)    
                    Common:setBtnTouchEnable(Button_levelUpNow,true)     
                    Text_Time:setColor(CommonColor.White)
                    it:getChildByName("Image_4"):setVisible(true)
                elseif buildstate == 2 then
                    --资源不足
                    Common:setBtnTouchEnable(Button_levelUp,false)
                    Common:setBtnTouchEnable(Button_levelUpNow,true)    
                    Text_Time:setString( StringRes.Text_NeedRes)
                    Text_Time:setColor(CommonColor.Red)
                    it:getChildByName("Image_4"):setVisible(false)
                elseif buildstate == 3 then
                    --最大等级
                    Common:setBtnTouchEnable(Button_levelUp,false)
                    Text_Time:setString( StringRes.build_notice1)
                    Text_Time:setColor(CommonColor.Red)
                    it:getChildByName("Image_4"):setVisible(false)

                    Common:setBtnTouchEnable(Button_levelUpNow, false)   
                elseif buildstate == 4 then
                    --等级限制
                    Common:setBtnTouchEnable(Button_levelUp,false)
                    Common:setBtnTouchEnable(Button_levelUpNow,false)    
                    Text_Time:setString( StringRes.Text_NeedLevel)
                    Text_Time:setColor(CommonColor.Red)
                    it:getChildByName("Image_4"):setVisible(false)       
                end
            end

            local function onNodeEvent(tag)
                if tag == "enter" then
                    updateTime(0)
                    it.updateTime = Scheduler:scheduleScriptFunc(updateTime, 0.9, false)
                elseif tag == "exit" then
                    Scheduler:unscheduleScriptEntry(it.updateTime)
                end
            end
            it:registerScriptHandler(onNodeEvent)
            lv:pushBackCustomItem(it)
        end
    end

end


function PlayerInfo:initTabs()
    self:registerTabEvent(1,function()
        if self.info == nil then
            
           
        
            self.info = cc.uiload:load("res/csd/public/TabProduce.csb")
            self:addChild(self.info)
            local lv = self.info:getChildByName("listview")

            local item1 = CCUILoader:load("res/csd/public/PlayerBaseInfo.csb"):getChildByName("Panel_1"):clone()
            local item2 = CCUILoader:load("res/csd/public/PlayerJunXian.csb"):getChildByName("Panel_1"):clone()
            local item3 = CCUILoader:load("res/csd/public/PlayerTongShuai.csb"):getChildByName("Panel_1"):clone()
            local item4 = CCUILoader:load("res/csd/public/PlayerShengWang.csb"):getChildByName("Panel_1"):clone()
            lv:pushBackCustomItem(item1)
            lv:pushBackCustomItem(item2)
            lv:pushBackCustomItem(item3)
            lv:pushBackCustomItem(item4)
        end

        self:FreshInfo()
        self:ViewPage(self.info)
    end)
    self:registerTabEvent(2,function()
        if self.skill == nil then
            self.skill = ccui.Layout:create()
            local listView1 = cc.uiload:load("res/csd/public/TabListView1.csb")
            self.skill:addChild(listView1,1,1)


            local bottom = cc.uiload:load("res/csd/public/PlayerSkillBottom.csb")
            self.skill:addChild(bottom,2,2)

            self:addChild(self.skill)


            --self.skillModel = cc.uiload:load("res/csd/public/PlayerOneSkill.csb"):getChildByName("Panel_1")


        end

        self:FreshSkill()
        self:ViewPage(self.skill)

    end)
    self:registerTabEvent(3,function()
        if self.build == nil then
            self.build = cc.uiload:load("res/csd/public/TabProduce.csb")
            self:addChild(self.build)
            local lv = self.build:getChildByName("listview")


            self:FreshBuild()

            --            for i = 1,5 do
            --                local m1 = item1:clone()
            --                lv:pushBackCustomItem(m1)
            --            end
            --
            --            for i = 1,15 do
            --                local m1 = item2:clone()
            --                lv:pushBackCustomItem(m1)
            --            end
        end


        self:ViewPage(self.build)
    end)
    self:setTabSelect(1)
end

return PlayerInfo