local PanelTabLayer = require("src/app/views/public/PanelTabLayer")

local Scheduler = cc.Director:getInstance():getScheduler()
Ranks = class("Ranks",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.rank_title_4,tabs={StringRes.Static_Text_5,StringRes.rank_title_2,StringRes.rank_title_3}})
end)

function Ranks:ctor(scene)
    self.attack = nil
    self.chapter = nil
    self.honor = nil

    self.temp = cc.uiload:load("res/csd/ranking/ui_ranking_main.csb")
    self.temp:retain()

    local function onNodeEvent(tag)
        if tag == "enter" then


        elseif tag == "exit" then
            if self.temp ~= nil then
                self.temp:release()
                self.temp = nil
            end
        end
    end
    self:registerScriptHandler(onNodeEvent)

    self:initTabs()

    ViewManager:OpenView(self)
end

function Ranks:resetContent()
    if self.attack then self.attack:setVisible(false) end
    if self.chapter then self.chapter:setVisible(false) end
    if self.honor then self.honor:setVisible(false) end
end

function Ranks:ViewPage(page)
    if self.attack then self.attack:setVisible(false) end
    if self.chapter then self.chapter:setVisible(false) end
    if self.honor then self.honor:setVisible(false) end

    page:setVisible(true)
end


function Ranks:changeShowRankNum(num)
    if num == 0 then
        return "--"
    end
    return num
end


--刷新荣誉排行榜
function Ranks:FreshHonor()

    local list = self.honor:getChildByName("listview_ranking")
    list:removeAllItems()



    --自己
    local myitem = self.temp:getChildByName("panel_honor_player"):clone()
    myitem:getChildByName("text_ranking"):setString( Ranks:changeShowRankNum(self.honor.data.prank.rownum) )
    --名字
    myitem:getChildByName("text_name"):setString( self.honor.data.prank.name )
    --等级
    myitem:getChildByName("text_lev"):setString( "Lv."..self.honor.data.prank.lv )
    --值
    myitem:getChildByName("text_honor"):setString( StringTemp:toNum(self.honor.data.prank.num))
    list:pushBackCustomItem(myitem)

    if list ~= nil then
        local num = 20*self.honor.pageNum
        for var=1, num do

            if self.honor.data.ranks[var] == nil then
                return
            end

            local item = nil
            --自己
            if var == 1 then
                item = self.temp:getChildByName("panel_honor_1st"):clone()
            elseif var == 2 then
                item = self.temp:getChildByName("panel_honor_2nd"):clone()
            elseif var == 3 then
                item = self.temp:getChildByName("panel_honor_3rd"):clone()
            else
                item = self.temp:getChildByName("panel_honor_other"):clone()
                item:getChildByName("text_ranking"):setString( Ranks:changeShowRankNum(self.honor.data.ranks[var].rownum) )
            end

            --名字
            item:getChildByName("text_name"):setString( self.honor.data.ranks[var].name )
            --等级
            item:getChildByName("text_lev"):setString( "Lv."..self.honor.data.ranks[var].lv )
            --值
            item:getChildByName("text_honor"):setString( StringTemp:toNum(self.honor.data.ranks[var].num) )

            list:pushBackCustomItem(item)
        end

        --更多
        if self.honor.pageNum ~= 5 and #self.honor.data.ranks > 20 then
            local item = self.temp:getChildByName("panel_more"):clone()
            item:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    local num = self.honor.pageNum*20

                    self.honor.pageNum = self.honor.pageNum + 1


                    local pos = list:getIndex(e)

                    for var=1, 20 do
                        if self.honor.data.ranks[var+num] == nil then
                            list:removeLastItem()
                            return
                        end
                        local item = self.temp:getChildByName("panel_honor_other"):clone()
                        item:getChildByName("text_ranking"):setString( Ranks:changeShowRankNum(self.honor.data.ranks[var+num].rownum) )
                        --名字
                        item:getChildByName("text_name"):setString( self.honor.data.ranks[var+num].name )
                        --等级
                        item:getChildByName("text_lev"):setString( "Lv."..self.honor.data.ranks[var+num].lv )
                        --值
                        item:getChildByName("text_honor"):setString( StringTemp:toNum(self.honor.data.ranks[var+num].num) )

                        local pos = list:getIndex(e)
                        list:insertCustomItem(item,pos)
                    end

                    if self.honor.pageNum == 5 or self.honor.pageNum*20 > #self.honor.data.ranks then
                        list:removeLastItem()
                    end

                end
            end)
            list:pushBackCustomItem(item)
        end


    end

end

--刷新关卡排行榜
function Ranks:FreshChapter()

    local list = self.chapter:getChildByName("listview_ranking")
    list:removeAllItems()



    --自己
    local myitem = self.temp:getChildByName("panel_chapter_player"):clone()
    myitem:getChildByName("text_ranking"):setString( Ranks:changeShowRankNum(self.chapter.data.prank.rownum) )
    --名字
    myitem:getChildByName("text_name"):setString( self.chapter.data.prank.name )
    --等级
    myitem:getChildByName("text_lev"):setString( "Lv."..self.chapter.data.prank.lv )
    --值
    myitem:getChildByName("text_star"):setString( StringTemp:toNum(self.chapter.data.prank.num) )
    list:pushBackCustomItem(myitem)

    if list ~= nil then
        local num = 20*self.chapter.pageNum
        for var=1, num do

            if self.chapter.data.ranks[var] == nil then
                return
            end

            local item = nil
            --自己
            if var == 1 then
                item = self.temp:getChildByName("panel_chapter_1st"):clone()
            elseif var == 2 then
                item = self.temp:getChildByName("panel_chapter_2nd"):clone()
            elseif var == 3 then
                item = self.temp:getChildByName("panel_chapter_3rd"):clone()
            else
                item = self.temp:getChildByName("panel_chapter_other"):clone()
                item:getChildByName("text_ranking"):setString( Ranks:changeShowRankNum(self.chapter.data.ranks[var].rownum) )
            end

            --名字
            item:getChildByName("text_name"):setString( self.chapter.data.ranks[var].name )
            --等级
            item:getChildByName("text_lev"):setString( "Lv."..self.chapter.data.ranks[var].lv )
            --值
            item:getChildByName("text_star"):setString( StringTemp:toNum(self.chapter.data.ranks[var].num) )

            list:pushBackCustomItem(item)
        end

        --更多
        if self.chapter.pageNum ~= 5 and #self.chapter.data.ranks > 20 then
            local item = self.temp:getChildByName("panel_more"):clone()
            item:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    local num = self.chapter.pageNum*20

                    self.chapter.pageNum = self.chapter.pageNum + 1


                    local pos = list:getIndex(e)

                    for var=1, 20 do
                        if self.chapter.data.ranks[var+num] == nil then
                            list:removeLastItem()
                            return
                        end
                        local item = self.temp:getChildByName("panel_chapter_other"):clone()
                        item:getChildByName("text_ranking"):setString( Ranks:changeShowRankNum(self.chapter.data.ranks[var+num].rownum) )
                        --名字
                        item:getChildByName("text_name"):setString( self.chapter.data.ranks[var+num].name )
                        --等级
                        item:getChildByName("text_lev"):setString( "Lv."..self.chapter.data.ranks[var+num].lv )
                        --值
                        item:getChildByName("text_star"):setString( StringTemp:toNum(self.chapter.data.ranks[var+num].num) )

                        local pos = list:getIndex(e)
                        list:insertCustomItem(item,pos)
                    end

                    if self.chapter.pageNum == 5 or self.chapter.pageNum*20 > #self.chapter.data.ranks then
                        list:removeLastItem()
                    end

                end
            end)
            list:pushBackCustomItem(item)
        end


    end

end


--刷新战斗力排行
function Ranks:FreshAttack()
    local list = self.attack:getChildByName("listview_ranking")
    list:removeAllItems()



    --自己
    local myitem = self.temp:getChildByName("panel_attack_player"):clone()
    myitem:getChildByName("text_ranking"):setString( Ranks:changeShowRankNum(self.attack.data.prank.rownum) )
    --名字
    myitem:getChildByName("text_name"):setString( self.attack.data.prank.name )
    --等级
    myitem:getChildByName("text_lev"):setString( "Lv."..self.attack.data.prank.lv )
    --值
    myitem:getChildByName("text_attack"):setString( StringTemp:toNum(self.attack.data.prank.num) )
    list:pushBackCustomItem(myitem)

    if list ~= nil then
        local num = 20*self.attack.pageNum
        for var=1, num do

            if self.attack.data.ranks[var] == nil then
                return
            end

            local item = nil
            --自己
            if var == 1 then
                item = self.temp:getChildByName("panel_attack_1st"):clone()
            elseif var == 2 then
                item = self.temp:getChildByName("panel_attack_2nd"):clone()
            elseif var == 3 then
                item = self.temp:getChildByName("panel_attack_3rd"):clone()
            else
                item = self.temp:getChildByName("panel_attack_other"):clone()
                item:getChildByName("text_ranking"):setString( Ranks:changeShowRankNum(self.attack.data.ranks[var].rownum) )
            end

            --名字
            item:getChildByName("text_name"):setString( self.attack.data.ranks[var].name )
            --等级
            item:getChildByName("text_lev"):setString( "Lv."..self.attack.data.ranks[var].lv )
            --值
            item:getChildByName("text_attack"):setString( StringTemp:toNum(self.attack.data.ranks[var].num) )

            list:pushBackCustomItem(item)
        end

        --更多
        if self.attack.pageNum ~= 5 and #self.attack.data.ranks > 20 then
            local item = self.temp:getChildByName("panel_more"):clone()
            item:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    local num = self.attack.pageNum*20

                    self.attack.pageNum = self.attack.pageNum + 1


                    local pos = list:getIndex(e)

                    for var=1, 20 do
                        if self.attack.data.ranks[var+num] == nil then
                            list:removeLastItem()
                            return
                        end
                        local item = self.temp:getChildByName("panel_attack_other"):clone()
                        item:getChildByName("text_ranking"):setString( Ranks:changeShowRankNum(self.attack.data.ranks[var+num].rownum) )
                        --名字
                        item:getChildByName("text_name"):setString( self.attack.data.ranks[var+num].name )
                        --等级
                        item:getChildByName("text_lev"):setString( "Lv."..self.attack.data.ranks[var+num].lv )
                        --值
                        item:getChildByName("text_attack"):setString( StringTemp:toNum(self.attack.data.ranks[var+num].num) )

                        local pos = list:getIndex(e)
                        list:insertCustomItem(item,pos)
                    end

                    if self.attack.pageNum == 5 or self.attack.pageNum*20 > #self.attack.data.ranks then
                        list:removeLastItem()
                    end

                end
            end)
            list:pushBackCustomItem(item)
        end


    end
end


function Ranks:initTabs()
    self:registerTabEvent(1,function()
        if self.attack == nil then
            self.attack = ccui.Layout:create()
            --列表
            local t1 = self.temp:getChildByName("listview_ranking"):clone()
            self.attack:addChild(t1)

            --文字
            local title = self.temp:getChildByName("panel_attack"):clone()
            title:setPosition(cc.p(36,948))
            self.attack:addChild(title)

            self:addChild(self.attack)


            --显示页数
            self.attack.pageNum = 1

            --战斗力
            local msg = {type = 1}
            Connect:sendMsg("RankAction","getRank",msg,
                function(data)
                    --更新数据
                    self.attack.data = data
                    self:FreshAttack()
                end)

        end

        self:ViewPage(self.attack)
    end)
    self:registerTabEvent(2,function()
        if self.chapter == nil then
            self.chapter = ccui.Layout:create()
            --列表
            local t1 = self.temp:getChildByName("listview_ranking"):clone()
            self.chapter:addChild(t1)

            --文字
            local title = self.temp:getChildByName("panel_chapter"):clone()
            title:setPosition(cc.p(36,948))
            self.chapter:addChild(title)

            self:addChild(self.chapter)
            --显示页数
            self.chapter.pageNum = 1

            --关卡
            local msg = {type = 3}
            Connect:sendMsg("RankAction","getRank",msg,
                function(data)
                    --更新数据
                    self.chapter.data = data
                    self:FreshChapter()
                end)

        end

        self:ViewPage(self.chapter)

    end)
    self:registerTabEvent(3,function()
        if self.honor == nil then
            self.honor = ccui.Layout:create()
            --列表
            local t1 = self.temp:getChildByName("listview_ranking"):clone()
            self.honor:addChild(t1)

            --文字
            local title = self.temp:getChildByName("panel_honor"):clone()
            title:setPosition(cc.p(36,948))
            self.honor:addChild(title)

            self:addChild(self.honor)
            --显示页数
            self.honor.pageNum = 1

            --荣誉
            local msg = {type = 2}
            Connect:sendMsg("RankAction","getRank",msg,
                function(data)
                    --更新数据
                    self.honor.data = data
                    self:FreshHonor()
                end)
        end


        self:ViewPage(self.honor)
    end)
    self:setTabSelect(1)
end

return Ranks