AcademyCommon = {}

SCALE_PART = 0.75

AttributeKey={
    "hit",
    "dodge",
    "crit",
    "armor",
    "pierce",
    "def",
}

AttributeText={
    StringRes.playerskill_name01,
    StringRes.playerskill_name02,
    StringRes.playerskill_name03,
    StringRes.playerskill_name04,
    StringRes.aca_pierce,
    StringRes.aca_def,
}

function AcademyCommon:initGeneralSkillData(data)
    local tmp = {}
    tmp.len = #data
    for i,v in ipairs(data) do
        local info = gGeneralskill[v.templateId]
        v.icon = info.icon
        v.skillname = info.skillname
        v.skilldes = info.skilldes
        local arr = string.split(info.effect,":")
        v.mType = arr[1]
        v.mEffect = tonumber(arr[2])
        tmp["i"..v.skillindex] = v
    end
    return tmp
end

function AcademyCommon:initRecruitScsData(des1,des2,des3,icon,callback,data)
    local tmp = {}
    tmp.des1 = des1
    tmp.des2 = des2
    tmp.des3 = des3
    tmp.icon = icon
    tmp.callback = callback
    tmp.data = data
    return tmp
end

function AcademyCommon:splitFormat(strs,i1,i2) --1:1:3,2:2:5,3:3:10,4:4:10
    local a1 = string.split(strs,i1)
    local tab1 = {}
    local tab2 = {}
    for i,v in ipairs(a1)do
        local a2 = string.split(v,i2)
        table.insert(tab1,a2[1])
        table.insert(tab2,a2[2])
    end
    return tab1,tab2
end

function AcademyCommon:nodesFormatX(nodes,perdis)
    if perdis == nil then
        perdis = 6
    end
    for i = 2,#nodes do
        local cur = nodes[i]
        local last = nodes[i-1]
        cur:setPositionX(last:getPositionX()+last:getContentSize().width+perdis)
    end
end

function AcademyCommon:copyValues(v1,v2)
    for k,v in pairs(v2) do
        v1[k] = v
    end
end

local factors = {1,1.4,1.8,2.2,2.6}

function AcademyCommon:Attribute(parent,strs,data)
    local index = 1
    for i,v in ipairs(AttributeKey) do
        if data[v] and data[v] ~= 0 then
            local item = parent:getChildByName(strs[1]..index)
            if item then
                Common:changePic(item:getChildByName(strs[2]),gGeneralAttributeIcon[i])
                item:getChildByName(strs[3]):setString(string.format("%s+%0.2f%%",AttributeText[i],data[v]))
                if strs[4] and strs[5] then
                    if data.lv >= data.maxlv then
                        item:getChildByName(strs[4]):setVisible(false)
                        item:getChildByName(strs[5]):setVisible(false)
                    else
                        item:getChildByName(strs[4]):setVisible(true)
                        item:getChildByName(strs[5]):setVisible(true)
                        local info = gGeneral[data.templateId]
                        item:getChildByName(strs[5]):setString(string.format("%0.2f%%",info["base"..v]*factors[data.que]*(0.08*(data.lv)+1)))
                        AcademyCommon:nodesFormatX({item:getChildByName(strs[3]),item:getChildByName(strs[4]),item:getChildByName(strs[5])})
                    end
                end
            end
            index = index +1
        end
    end
end

function AcademyCommon:showStar(parent,str,star,total)
    if total == nil then total = 5 end --默认最大5星
    for i = 1 , total do
        local item = parent:getChildByName(str..i)
        if item then item:setVisible(i == star) end
    end
end