local AcademyGeneralInfo = class("AcademyGeneralInfo",function(data)
    return CCUILoader:load("csd/academy/manage/layer_academy_general_info.csb")
end)

function AcademyGeneralInfo:ctor(data)
    self:initView(data)
    local content = self:getChildByName("panel_mask"):getChildByName("panel_outline_bg")
    NodeTranslator:transZoomOut(content,nil)
    content:setSwallowTouches(false)
    DialogUtil:addClickEvent(self:getChildByName("panel_mask"),function()
        NodeTranslator:transZoomOut(content,function()
            self:removeFromParent()
        end)
    end)
end

function AcademyGeneralInfo:show(parent,data)
    local layer = AcademyGeneralInfo.new(data)
    parent:addChild(layer)
end

--初始化界面
function AcademyGeneralInfo:initView(data)
    local content = self:getChildByName("panel_mask"):getChildByName("panel_outline_bg")
    local info = gGeneral[data.id]
    local name = content:getChildByName("text_name")
    name:setString(info.generalname)
    local ColorMgr = require("src/app/util/ColorMgr")
    name:setColor(ColorMgr:getByQuality(data.que))
    content:getChildByName("text_citizenhood"):setString(string.format(StringRes.nationality,info.nation))
    content:getChildByName("panel_info_desc"):getChildByName("text_desc_02"):setString(info.lifedes)
    
    Common:changePic(content:getChildByName("icon_general"):getChildByName("panel_outline"),gGeneralQualityIcon[data.que])
    
    Common:changePic(content:getChildByName("icon_general"):getChildByName("icon_general"),info.icon)
end


return AcademyGeneralInfo