local AcademyMain = class("AcademyMain",function(data)
    return CCUILoader:load("csd/academy/recruit/ui_academy_main.csb")
end)

function AcademyMain:ctor(data)
    self.haveFree = false
    self:initView()
    self:updateHaveFree(data)

    ViewManager:OpenView(self)
end

function AcademyMain:updateHaveFree(data)
    self.haveFree = (data.freeCommonRecruitCount > 0 and data.freeCommonRecruitTime == 0) or (data.freeEliteRecruitCount > 0 and data.freeEliteRecruitTime == 0 )
    self.lv:getItem(0).setTipVisible(self.haveFree)
end

function AcademyMain:show(parent)
    Connect:sendMsg("WarCollegeAction","openCommanderRecruit",{ },
        function (data)
            local layer = AcademyMain.new(data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)

end

function AcademyMain:close()
    require("src/app/util/NodeTranslator"):transDown(self,function()
        self:removeFromParent()
        gWorldScene:getGametips()
    end)
end

--初始化界面
function AcademyMain:initView()


    --仓库储备
    self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.Building_Name_9) 

    --关闭按钮
    self:getChildByName("panel_bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)

    self:initItems()

end

function AcademyMain:initItems()
    local panel_line = self:getChildByName("panel_line")
    local lv = panel_line:getChildByName("listview_linebg")
    self.lv  = lv
    local panei_item = panel_line:getChildByName("panei_item")
    for i,v in ipairs(gMilitaryAcademy) do
        local item = panei_item:clone()
        Common:changePic(item:getChildByName("icon_recruit"),v.icon)
        item:getChildByName("text_recruit"):setString(v.maname)

        --信息
        item:getChildByName("btn_info"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                local DescriptView = require("src/app/views/prompt/DescriptView")
                DescriptView:open(self,StringTemp:Descript(v.ruledes))
            end
        end)

        --goto
        item:getChildByName("btn_goto"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                --新锐招募
                if v.id == 1 then
                    require("src/app/views/academy/AcademyRecruit"):show(self)
                elseif v.id == 2 then --将领管理
                    require("src/app/views/academy/AcademyManage"):show(self)
                end
            end
        end)
        
        function setTipVisible(vis)
            item:getChildByName("btn_goto"):getChildByName("icon_tip"):setVisible(vis)
        end
        item.setTipVisible = setTipVisible
        item.setTipVisible(false)

        lv:pushBackCustomItem(item)
    end
end

return AcademyMain