local AcademyManageDetail = class("AcademyManageDetail",function(data)
    return CCUILoader:load("res/csd/academy/manage/ui_academy_manage_detail.csb")
end)

function AcademyManageDetail:ctor(data)
    self.data = data
    self.generalData = data.recruitCommanderVOs[data.tag_index]
    self:initView()
end

function AcademyManageDetail:show(parent,data)
    local layer = AcademyManageDetail.new(data)
    parent:addChild(layer)
    if data.withAni == nil or data.withAni == true then
        NodeTranslator:transUp(layer,nil)
    end
end

function AcademyManageDetail:close()
    require("src/app/util/NodeTranslator"):transDown(self,function()
        self:removeFromParent()
    end)
end

--初始化界面
function AcademyManageDetail:initView()

    self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.maname_2)

    --关闭按钮
    self:getChildByName("panel_bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)
    
    self.panel_outline = self:getChildByName("panel_outline")
    local panel_general_bg = self.panel_outline:getChildByName("panel_general_bg")
    local btn_book = panel_general_bg:getChildByName("btn_book")
    btn_book:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            require("src/app/views/academy/AcademyGeneralInfo"):show(self,{id = self.generalData.templateId,que = self.generalData.que}) 
        end
    end)
    
    local info = gGeneral[self.generalData.templateId]
    self.generalInfo = info
    local text_name = panel_general_bg:getChildByName("text_name")
    text_name:setString(info.generalname)
    local ColorMgr = require("src/app/util/ColorMgr")
    text_name:setColor(ColorMgr:getByQuality(self.generalData.que))
    local panel_general = panel_general_bg:getChildByName("panel_general")
    local panel_outline = panel_general:getChildByName("panel_outline")
    Common:changePic(panel_outline,gGeneralQualityIcon[self.generalData.que])
    Common:changePic(panel_general:getChildByName("icon_general"),info.icon)
    AcademyCommon:showStar(panel_general_bg:getChildByName("icon_star_bg"),"panel_star_0",self.generalData.que)
    local text_grade = panel_general_bg:getChildByName("text_grade")
    text_grade:setString(string.format(StringRes.aca_lv3,self.generalData.lv,self.generalData.maxlv))
    panel_general_bg:getChildByName("text_amount"):setString(string.format(StringRes.aca_item_num,self.generalData.pirace))
    panel_general_bg:getChildByName("text_upgrade"):setString(string.format(StringRes.aca_levelup_need,self.generalData.maxexp))
    local percent = self.generalData.exp/(self.generalData.exp+self.generalData.maxexp)*100
    if self.generalData.exp == 0 and self.generalData.maxexp ==0 then
        percent = 100
    end
    panel_general_bg:getChildByName("icon_loadingbar_bg"):getChildByName("loadingbar_desc"):setPercent(percent)
    
    AcademyCommon:Attribute(panel_general_bg,{"panel_item_0","icon_item","text_desc"},self.generalData)
    
    local btn_upgrade = self.panel_outline:getChildByName("btn_upgrade")
    if self.generalData.lv<self.generalData.maxlv then --升级
        btn_upgrade:setTitleText(StringRes.levelup)
    else --突破
        btn_upgrade:setTitleText(StringRes.gradeUp)
    end
    btn_upgrade:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self.generalData.lv<self.generalData.maxlv then --升级
                require("src/app/views/academy/AcademyManageLevelUp"):show(self,self.data)
            else
                if self.generalData.que >= 5 then
                    FlyWordPrompt:prompt(StringRes.cannot_gradeUp)               
                else
                    require("src/app/views/academy/AcademyManageGradeUp"):show(self,self.data)
                end
            end
        end
    end)
    
    self.panel_item_bg = self.panel_outline:getChildByName("panel_item_bg")
    
    self:updateSkills()
end

function AcademyManageDetail:updateSkills()
    local listview_desc = self.panel_outline:getChildByName("listview_desc")
    listview_desc:removeAllItems()
    local sdata = AcademyCommon:initGeneralSkillData(self.generalData.commanderSkillVOs)
    if self.generalData.que>=4 then
        self.data.tag_skillData = sdata["i"..(self.generalData.que)]
    else
        self.data.tag_skillData = sdata["i"..(self.generalData.que+1)]
    end
    for i = 1 , sdata.len do
        local info = sdata["i"..i]
        local item = self.panel_item_bg:clone()
        listview_desc:pushBackCustomItem(item)
        Common:changePic(item:getChildByName("icon_item"),info.icon)
        item:getChildByName("text_desc_02"):setString(string.format(info.skilldes,info.effect))
        
        local panel_shade_bg = item:getChildByName("panel_shade_bg")
        local btn_upgrade = item:getChildByName("btn_upgrade")
        showShader:buttonToGray(btn_upgrade)
        if info.unlock == 0 then
            Common:setBtnTouchEnable(btn_upgrade,false)
            panel_shade_bg:setVisible(true)
            panel_shade_bg:getChildByName("icon_line"):getChildByName("text_desc"):setString(string.format(StringRes.aca_unlock,info.skillindex))
            item:getChildByName("text_desc_01"):setString(info.skillname)
        elseif info.unlock == 1 then
            panel_shade_bg:setVisible(false)
            item:getChildByName("text_desc_01"):setString(string.format(StringRes.aca_lv2,info.skillname,info.lv,info.maxlv))
        end
        if info.lv >= info.maxlv then
            Common:setBtnTouchEnable(btn_upgrade,false)
        end
        btn_upgrade:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                info.generalUuid = self.generalData.uuid
                require("src/app/views/academy/AcademyManageSkillUp"):show(self,info)
            end
        end)
    end
end

function AcademyManageDetail:updateLevel()
    local panel_outline = self:getChildByName("panel_outline")
    local panel_general_bg = panel_outline:getChildByName("panel_general_bg")
    local text_grade = panel_general_bg:getChildByName("text_grade")
    text_grade:setString(string.format(StringRes.aca_lv3,self.generalData.lv,self.generalData.maxlv))
    panel_general_bg:getChildByName("text_upgrade"):setString(string.format(StringRes.aca_levelup_need,self.generalData.maxexp))
    panel_general_bg:getChildByName("icon_loadingbar_bg"):getChildByName("loadingbar_desc"):setPercent(self.generalData.exp/(self.generalData.exp+self.generalData.maxexp)*100)
    AcademyCommon:Attribute(panel_general_bg,{"panel_item_0","icon_item","text_desc"},self.generalData)
    local btn_upgrade = panel_outline:getChildByName("btn_upgrade")
    if self.generalData.lv<self.generalData.maxlv then --升级
        btn_upgrade:setTitleText(StringRes.levelup)
    else --突破
        btn_upgrade:setTitleText(StringRes.gradeUp)
    end
    self:getParent():updateLevel()
end

function AcademyManageDetail:refreshSkills(data)
    AcademyCommon:copyValues(self.generalData,data.commanderVO)
    self:updateSkills()
end

return AcademyManageDetail