local AcademyManageGradeUp = class("AcademyManageGradeUp",function(data)
    return CCUILoader:load("csd/academy/manage/ui_academy_grade_up.csb")
end)

function AcademyManageGradeUp:ctor(data)
    self.data = data
    self.generalData = data.recruitCommanderVOs[data.tag_index]
    self:initView()
end

function AcademyManageGradeUp:show(parent,data)
    local layer = AcademyManageGradeUp.new(data)
    parent:addChild(layer)
    NodeTranslator:transUp(layer,nil)
end

function AcademyManageGradeUp:close()
    require("src/app/util/NodeTranslator"):transDown(self,function()
        self:removeFromParent()
    end)
end

--初始化界面
function AcademyManageGradeUp:initView()

    self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.maname_2)

    --关闭按钮
    self:getChildByName("panel_bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)

    local panel_outline = self:getChildByName("panel_outline")
    local panel_bk = panel_outline:getChildByName("panel_bk")

    local tmpInfo = gGeneral[self.generalData.templateId]

    local canGradeUp = true
    local panel_item_1 = panel_bk:getChildByName("panel_item_1")
    Common:changePic(panel_item_1:getChildByName("panel_avatar"):getChildByName("icon_avatar"),tmpInfo.icon)
    local costInfo =gGeneralbreachcost["que"..self.generalData.que+1]
    local desNum = costInfo.uppirace
    if self.generalData.pirace < desNum then 
        canGradeUp = false 
        panel_item_1:getChildByName("num_item"):setColor(CommonColor.Red)
    else
        panel_item_1:getChildByName("num_item"):setColor(CommonColor.White)
    end
    panel_item_1:getChildByName("num_item"):setString(string.format("%d/%d",self.generalData.pirace,desNum))
    panel_item_1:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            ItemDetail:show(gWorldScene,{icon = gGeneralQualityIcon[1],title = tmpInfo.generalname..StringRes.aca_item2,
                des = tmpInfo.lifedes,count = self.generalData.pirace,bg = tmpInfo.icon})
        end
    end)

    local ids , num = AcademyCommon:splitFormat(costInfo.cost,",",":")
    local serverNums = { id43 = self.data.commandBookCount, id65 = self.data.elitemedalCount, id66 = self.data.violetmedalCount}
    for i = 1 , 3 do
        local item = panel_bk:getChildByName("panel_item_"..(i+1))
        if ids[i] then
            local itemInfo = gItem[tonumber(ids[i])]
            local icon = item:getChildByName("item_book") or item:getChildByName("item_medal")
            Common:changePic(icon,itemInfo.icon)
            item:getChildByName("num_item"):setString(string.format("%d/%d",serverNums["id"..ids[i]],num[i]))
            item:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    ItemDetail:show(gWorldScene,{icon = itemInfo.icon,title = StringRes[itemInfo.name],
                        des = StringRes[itemInfo.desc],count = serverNums["id"..ids[i]]})
                end
            end)
            if serverNums["id"..ids[i]]<tonumber(num[i]) then 
                canGradeUp = false 
                item:getChildByName("num_item"):setColor(CommonColor.Red)
            else
                item:getChildByName("num_item"):setColor(CommonColor.White)
            end
        else
            item:setVisible(false)
        end
    end

    local text_title = panel_bk:getChildByName("text_title")
    if canGradeUp then
        text_title:setString(StringRes.can_gradeUp)
    else
        text_title:setString(StringRes.noItem_gradeUp)
    end

    panel_outline:getChildByName("btn_grade_up"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if canGradeUp then
                Connect:sendMsg("WarCollegeAction","updateCommanderQue",{ uuid = self.generalData.uuid ,
                    itemId1 = self.data.commandBookId
                    , itemId2 = self.data.elitemedalId
                    , itemId3 = self.data.violetmedalId},
                function (data)
                    self:getParent():getParent():updateviews(self,data)
                end)
            else
                FlyWordPrompt:prompt(StringRes.noItem_gradeUp)
            end
        end
    end)

    function initGeneralItem(item)
        local tmpQue = self.generalData.que
        local strLv = ""
        if "panel_general_low" == item:getName() then
            strLv = string.format(StringRes.aca_lv3,self.generalData.lv,self.generalData.maxlv)
        elseif "panel_general_high" == item:getName() then
            tmpQue = tmpQue +1
            strLv = string.format(StringRes.aca_lv3,self.generalData.lv-10,self.generalData.maxlv+10)
        end
        Common:changePic(item:getChildByName("panel_avatar"):getChildByName("icon_avatar"),tmpInfo.icon)
        Common:changePic(item:getChildByName("panel_avatar"):getChildByName("panel_outline"),gGeneralQualityIcon[tmpQue])
        AcademyCommon:showStar(item:getChildByName("Image_star_back"),"panel_star_",tmpQue)
        item:getChildByName("text_name"):setString(tmpInfo.generalname)
        local ColorMgr = require("src/app/util/ColorMgr")
        item:getChildByName("text_name"):setColor(ColorMgr:getByQuality(tmpQue))
        item:getChildByName("text_lv"):setString(strLv)


    end

    initGeneralItem(panel_outline:getChildByName("panel_general_low"))
    initGeneralItem(panel_outline:getChildByName("panel_general_high"))

    local panel_skill = panel_outline:getChildByName("panel_skill")
--   从4星升到5星时没有新技能解锁
    if self.generalData.que>=4 then
        panel_skill:setVisible(false)
    else
        panel_skill:setVisible(true)
        local info =self.data.tag_skillData
        Common:changePic(panel_skill:getChildByName("icon_skill"),info.icon)
        panel_skill:getChildByName("text_skill_name"):setString(info.skillname)
    end

end


return AcademyManageGradeUp