local AcademyManageLevelUp = class("AcademyManageLevelUp",function(data)
    return CCUILoader:load("res/csd/academy/manage/ui_academy_level_upgrade.csb")
end)

function AcademyManageLevelUp:ctor(data)
    self.data = data
    self.generalData = data.recruitCommanderVOs[data.tag_index]
    self:initView()
end

function AcademyManageLevelUp:show(parent,data)
    local layer = AcademyManageLevelUp.new(data)
    parent:addChild(layer)
    NodeTranslator:transUp(layer,nil)
end

function AcademyManageLevelUp:close()
    require("src/app/util/NodeTranslator"):transDown(self,function()
        self:removeFromParent()
    end)
end

--初始化界面
function AcademyManageLevelUp:initView()

    self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.maname_2)

    --关闭按钮
    self:getChildByName("panel_bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)
    local panel_outline = self:getChildByName("panel_outline")
    local panel_general_bg = panel_outline:getChildByName("panel_general_bg")
    local info = gGeneral[self.generalData.templateId]
    local text_name = panel_general_bg:getChildByName("text_name")
    text_name:setString(info.generalname)
    local ColorMgr = require("src/app/util/ColorMgr")
    text_name:setColor(ColorMgr:getByQuality(self.generalData.que))
    local icon_general = panel_general_bg:getChildByName("icon_general")
    Common:changePic(icon_general:getChildByName("panel_outline"),gGeneralQualityIcon[self.generalData.que])
    Common:changePic(icon_general:getChildByName("icon_general"),info.icon)
    AcademyCommon:showStar(panel_general_bg:getChildByName("icon_star_bg"),"panel_star_0",self.generalData.que)
    
    self:updateViews(false)
end

local bookIds = {
    "juniorExpBookId",
    "middleExpBookId",
    "seniorExpBookId",
}

local bookNums = {
    "juniorExpBookCount",
    "middleExpBookCount",
    "seniorExpBookCount",
}

local tmpBookIds ={67,68,69} --经验书模板id

function AcademyManageLevelUp:updateViews(notInit)
    local panel_outline = self:getChildByName("panel_outline")
    local panel_general_bg = panel_outline:getChildByName("panel_general_bg")
    local lv = panel_outline:getChildByName("listview_desc")
    AcademyCommon:Attribute(panel_general_bg,{"icon_item_0","icon_item","text_desc","icon_arrow","num_desc"},self.generalData)
    panel_general_bg:getChildByName("text_grade_desc"):setString(string.format(StringRes.aca_levelup_need,self.generalData.maxexp))
    panel_general_bg:getChildByName("text_grade"):setString(string.format(StringRes.army_group_lv,self.generalData.lv))
    local percent = self.generalData.exp/(self.generalData.exp+self.generalData.maxexp)*100
    if self.generalData.exp == 0 and self.generalData.maxexp ==0 then
        percent = 100
    end
    panel_general_bg:getChildByName("icon_loadingbar_bg"):getChildByName("loadingbar_desc"):setPercent(percent)

    if notInit then
        for i,v in ipairs(bookNums) do
            local item = lv:getItem(i-1)
            item:getChildByName("text_desc_03"):setString(string.format(StringRes.aca_have,self.data[v]))
            if self.data[bookNums[i]] > 0 then
                item:getChildByName("text_desc_03"):setColor(CommonColor.White)
            else
                item:getChildByName("text_desc_03"):setColor(CommonColor.Red)
            end
        end
	else
        self:initExpBooks()
	end
end

function AcademyManageLevelUp:initExpBooks()
    local panel_outline = self:getChildByName("panel_outline")
    local tmpItem = panel_outline:getChildByName("panel_item_bg")
    local lv = panel_outline:getChildByName("listview_desc")
    for i,v in ipairs(tmpBookIds) do
        local item = tmpItem:clone()
        lv:pushBackCustomItem(item)
        local info = gItem[v] 
        Common:changePic(item:getChildByName("icon_item"),info.icon)
        item:getChildByName("text_desc_01"):setString(StringRes[info.name])
        item:getChildByName("text_desc_02"):setString(StringRes[info.desc])
        item:getChildByName("text_desc_03"):setString(string.format(StringRes.aca_have,self.data[bookNums[i]]))
        if self.data[bookNums[i]] > 0 then
            item:getChildByName("text_desc_03"):setColor(CommonColor.White)
        else
            item:getChildByName("text_desc_03"):setColor(CommonColor.Red)
        end
        item:getChildByName("btn_use"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                if self.data[bookNums[i]] > 0 then
                    if self.generalData.lv >= self.generalData.maxlv then
                        FlyWordPrompt:prompt(StringRes.cannot_LevelUp)                        
                    else
                        Connect:sendMsg("WarCollegeAction","updateCommanderLv",{ uuid = self.generalData.uuid , itemId = self.data[bookIds[i]]},
                            function (data)
                                AcademyCommon:copyValues(self.generalData,data.commanderVO)
                                GeneralData:set(data.commanderVO)
                                for i,v in ipairs(bookNums) do
                                    self.data[v] = data[v]
                                end
                                if self.generalData.lv >= self.generalData.maxlv then
                                    FlyWordPrompt:prompt(StringRes.cannot_LevelUp)
                                end
                                self:updateViews(true)
                                self:getParent():updateLevel()
                            end)
                    end
                else
                    FlyWordPrompt:prompt(StringRes.aca_promt1)
                end
            end
        end)
    end
end

return AcademyManageLevelUp