local AcademyManageSkillUp = class("AcademyManageSkillUp",function(data)
    return CCUILoader:load("res/csd/academy/manage/layer_popout_skill_upgrade.csb")
end)

function AcademyManageSkillUp:ctor(data)
    self.data = data
    local content = self:getChildByName("panel_mask"):getChildByName("panel_bg")
    NodeTranslator:transZoomOut(content,nil)
    
    --关闭按钮
    self.panel_bg = self:getChildByName("panel_mask"):getChildByName("panel_bg")
    self.panel_bg:getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transZoomOut(content,function()
                self:removeFromParent()
            end)
        end
    end)
        
    self:initView()
end

function AcademyManageSkillUp:show(parent,data)
    Connect:sendMsg("WarCollegeAction","openCommanderSkillUp",{uuid = data.generalUuid,skillId = data.templateId},
        function (sdata)
            data.sdata = sdata
            local layer = AcademyManageSkillUp.new(data)
            parent:addChild(layer)
        end)
    
end


--初始化界面
function AcademyManageSkillUp:initView()
    local info = self.data
    Common:changePic(self.panel_bg:getChildByName("icon_item"),info.icon)
    self.panel_bg:getChildByName("text_desc_01"):setString(string.format(StringRes.aca_name,info.skillname))
    self.panel_bg:getChildByName("text_desc_02"):setString(string.format(StringRes.aca_lv2,info.skillname,info.lv,info.maxlv))
    local text_desc_04 = self.panel_bg:getChildByName("text_desc_04")
    local text_desc_05 = self.panel_bg:getChildByName("text_desc_05")
    if info.mType == "point" then
        text_desc_04:setString(string.format(StringRes.aca_effect,string.format("%d",info.effect)))
        text_desc_05:setString(string.format("%d",info.effect+info.mEffect))
    else
        text_desc_04:setString(string.format(StringRes.aca_effect,string.format("%0.2f%%",info.effect)))
        text_desc_05:setString(string.format("%0.2f%%",info.effect+info.mEffect))
    end
    local icon_arrow = self.panel_bg:getChildByName("icon_arrow")
    AcademyCommon:nodesFormatX({text_desc_04,icon_arrow,text_desc_05})
    local key = "idLv_"..info.templateId.."_"..(info.lv+1)
    local ids , num = AcademyCommon:splitFormat(gGeneralskillup[key].cost,",",":")
    local panel_desc_bg = self.panel_bg:getChildByName("panel_desc_bg")
    local canLevelUp = true
    local serverData = self.data.sdata
    local commanderSkillUpVOs = serverData.commanderSkillUpVOs
    local sNums = {}
    for i,v in ipairs(commanderSkillUpVOs) do
        sNums["id"..v.templateId] = v.count
    end
    for i = 1 , 4 do 
        local item = panel_desc_bg:getChildByName("btn_item_0"..i)
        if ids[i] then
            local itemInfo = gItem[tonumber(ids[i])]
            item:loadTextures(itemInfo.icon,itemInfo.icon,"",ResType)
            local have = sNums["id"..ids[i]] or 0
            item:getChildByName("num_desc"):setString(string.format("%d/%d",have,num[i]))
            item:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    ItemDetail:show(gWorldScene,{icon = itemInfo.icon,title = StringRes[itemInfo.name],
                        des = StringRes[itemInfo.desc],count = have})
                end
            end)
            if have<tonumber(num[i]) then 
                canLevelUp = false 
                item:getChildByName("num_desc"):setColor(CommonColor.Red)
            else
                item:getChildByName("num_desc"):setColor(CommonColor.White)
            end 
        else
            item:setVisible(false)  
        end
    end
    
    local text_title = panel_desc_bg:getChildByName("text_info_01")
    if canLevelUp then
        text_title:setString(StringRes.can_gradeUp)
    else
        text_title:setString(StringRes.noItem_gradeUp)
    end

    self.panel_bg:getChildByName("btn_upgrade"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if canLevelUp then
            Connect:sendMsg("WarCollegeAction","commanderSkilllvUp",{ uuid = self.data.generalUuid , 
                    skillId = serverData.skillTemplateId},
                function (data)
                    FlyWordPrompt:prompt(StringRes.aca_levelup_success)
                    GeneralData:set(data.commanderVO)
                    self:getParent():refreshSkills(data)
                    self:removeFromParent()
                end)
            else
                FlyWordPrompt:prompt(StringRes.noItem_levelUp)
            end
        end
    end)
end

return AcademyManageSkillUp