local AcademyRecruit = class("AcademyRecruit",function(data)
    return CCUILoader:load("csd/academy/recruit/ui_academy_recruit.csb")
end)

function AcademyRecruit:ctor(data)
    self.data = data
    self:initView()
    
    self.updateId = cc.Director:getInstance():getScheduler():scheduleScriptFunc(handler(self,self.update), 1, false)

    local function onNodeEvent(tag)
        if tag == "exit" then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.updateId)
        end
    end

    self:registerScriptHandler(onNodeEvent)
    
end

function AcademyRecruit:update(dt)
	if self.data.freeCommonRecruitTime > 0 then
        self.data.freeCommonRecruitTime = self.data.freeCommonRecruitTime - dt
        if self.data.freeCommonRecruitTime < 0 then self.data.freeCommonRecruitTime = 0 end
        self:initItem(self.lv:getItem(0))
	end
	
    if self.data.freeEliteRecruitTime > 0 then
        self.data.freeEliteRecruitTime = self.data.freeEliteRecruitTime - dt
        if self.data.freeEliteRecruitTime <= 0 then 
            self.data.freeEliteRecruitTime = 0 
            self.data.freeEliteRecruitCount = self.data.freeEliteRecruitCount + 1
        end
        self:initItem(self.lv:getItem(1))
    end
	
end

function AcademyRecruit:show(parent)
    Connect:sendMsg("WarCollegeAction","openCommanderRecruit",{ },
        function (data)
            local layer = AcademyRecruit.new(data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)

end

function AcademyRecruit:close()
    require("src/app/util/NodeTranslator"):transDown(self,function()
        self:removeFromParent()
    end)
end

--初始化界面
function AcademyRecruit:initView()

    self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.maname_1)

    self:getChildByName("panel_item"):getChildByName("panel_line"):getChildByName("text_activity"):setString(StringRes.recruittitle_1)

    --关闭按钮
    self:getChildByName("panel_bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)

    self:initItems()

end

function AcademyRecruit:initItems()
    local panel_item = self:getChildByName("panel_item")
    local lv = panel_item:getChildByName("listview_line")
    self.lv  = lv
    local panel_linebg = panel_item:getChildByName("panel_linebg")
    for i,v in ipairs(gRecruit) do
        local item = panel_linebg:clone()
        item:setTag(v.id)
        item.tempData = v
        Common:changePic(item:getChildByName("panel_outline"):getChildByName("icon_recruit"),v.icon)
        item:getChildByName("text_info"):setString(v.recruitdes)

        item:getChildByName("icon_tab"):getChildByName("text_recruit"):setString(v.trecruittitle)
        showShader:buttonToGray(item:getChildByName("btn_recruit"))
        lv:pushBackCustomItem(item)
        self:initItem(item)
    end
end

function AcademyRecruit:initItem(item)
    local id  = item:getTag()
    local gold = PlayerData:getInstanse().basicData.gold  
    --goto
    local btn_recruit = item:getChildByName("btn_recruit")
    local btn_recruit_2 = item:getChildByName("btn_recruit_2")
    local text_free = item:getChildByName("text_free")
    local panel_linecross = item:getChildByName("panel_linecross")
    if id == 1 then
        btn_recruit:setVisible(true)
        btn_recruit_2:setVisible(false)
        local text_num = btn_recruit:getChildByName("text_num")
        text_num:setString(string.format("%d/%d",self.data.freeCommonRecruitCount,item.tempData.price))
        if self.data.freeCommonRecruitCount > 0 and self.data.freeCommonRecruitTime == 0 then
            text_free:setVisible(true)
            panel_linecross:setVisible(true)
            text_free:setString(StringRes.free_recruiting)
            text_num:setColor(CommonColor.Yellow)
            Common:setBtnTouchEnable(btn_recruit,true)
        elseif self.data.freeCommonRecruitCount > 0 and self.data.freeCommonRecruitTime > 0 then
            text_free:setVisible(true)
            panel_linecross:setVisible(true)
            text_free:setString(string.format(StringRes.time_to_free,StringTemp:toTime(self.data.freeCommonRecruitTime)))
            text_num:setColor(CommonColor.Yellow)
            Common:setBtnTouchEnable(btn_recruit,false)
        elseif self.data.freeCommonRecruitCount == 0 then
            text_free:setVisible(false)
            panel_linecross:setVisible(false)
            text_num:setColor(CommonColor.Red)
            Common:setBtnTouchEnable(btn_recruit,false)
        end
    elseif id == 2 then
        btn_recruit:setVisible(false)
        btn_recruit_2:setVisible(true)
        local text_num = btn_recruit_2:getChildByName("text_num")
        text_num:setString(item.tempData.price)
        if item.tempData.price > gold then
            text_num:setColor(CommonColor.Red)
        else
            text_num:setColor(CommonColor.Yellow)
        end
        if self.data.freeEliteRecruitCount > 0 and self.data.freeEliteRecruitTime == 0 then
            text_free:setVisible(true)
            panel_linecross:setVisible(true)
            text_free:setString(StringRes.aca_free_recruit)
        elseif self.data.freeEliteRecruitTime > 0 then
            text_free:setVisible(true)
            panel_linecross:setVisible(true)
            text_free:setString(string.format(StringRes.time_to_free,StringTemp:toTime(self.data.freeEliteRecruitTime)))
        end
        
    elseif id == 3 then
        text_free:setVisible(false)
        panel_linecross:setVisible(false)
        btn_recruit:setVisible(false)
        btn_recruit_2:setVisible(true)
        local text_num = btn_recruit_2:getChildByName("text_num")
        text_num:setString(item.tempData.price)
        if item.tempData.price > gold then
            text_num:setColor(CommonColor.Red)
        else
            text_num:setColor(CommonColor.Yellow)
        end
    end
    btn_recruit:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:recruitCommander(item,id)
        end
    end)
    btn_recruit_2:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if id == 2 and self.data.freeEliteRecruitCount > 0 and self.data.freeEliteRecruitTime == 0 then
                self:recruitCommander(item,id)
            else
                if gold < item.tempData.price then
                    PromptView:goldUnenought(item.tempData.price,gold)
                else
                    self:recruitCommander(item,id)
                end
            end
        end
    end)
end

function AcademyRecruit:recruitCommander(item,id)
    Connect:sendMsg("WarCollegeAction","recruitCommander",{recruitType  = id},
        function (data)
            self.data.freeCommonRecruitCount = data.freeCommonRecruitCount
            self.data.freeCommonRecruitTime = data.freeCommonRecruitTime
            self.data.freeEliteRecruitCount = data.freeEliteRecruitCount
            self.data.freeEliteRecruitTime = data.freeEliteRecruitTime
            PlayerData:getInstanse().basicData.gold  = data.gold
            self:getParent():updateHaveFree(self.data)
            self:initItem(item)
            local recruitVOs = data.recruitVOs
            local size = #recruitVOs
            local index = 1
            function showRecruit()
                if index > size then return end
                local recruit = recruitVOs[index]
                local type = recruit.type
                local des1 = ""
                local des2 = ""
                local des3 = ""
                local icon = ""
                local tmpdata = {}
                if type == 1 then
                    des1 = string.format(StringRes.aca_get_success,StringRes.prop)
                    des2 = string.format("%sx%d",StringRes[gItem[recruit.templateId].name],recruit.count)
                    icon = gItem[recruit.templateId].icon
                elseif type == 2 then
                    des1 = string.format(StringRes.aca_get_success,StringRes.aca_item)
                    des2 = string.format("%sx%d",gGeneral[recruit.templateId].generalname..StringRes.aca_item2,recruit.count)
                    icon = gGeneral[recruit.templateId].icon
                    tmpdata.que = 0
                    GeneralData:init()
                elseif type == 3 or type == 4 then
                    des1 = string.format(StringRes.aca_get_success,StringRes.aca_general)
                    if recruit.ispirace and recruit.ispirace == 1 then
                        des2 = gGeneral[recruit.templateId].generalname
                        des3 = string.format(StringRes.aca_hava_general,recruit.piraceCount)
                    else
                        des2 = string.format("%sx%d",gGeneral[recruit.templateId].generalname,recruit.count)
                    end
                    icon = gGeneral[recruit.templateId].icon
                    tmpdata.que = type-2
                    GeneralData:init()
                end
                
                local tmp = AcademyCommon:initRecruitScsData(
                    des1,
                    des2,
                    des3,
                    icon,
                    function()
                        index = index+1
                        showRecruit()
                    end,
                    tmpdata)
                require("src/app/views/academy/AcademyRecruitSuccess"):show(self,tmp)
            
            end
            showRecruit()
        end)
end

return AcademyRecruit