local AcademyRecruitSuccess = class("AcademyRecruitSuccess",function(data)
    return CCUILoader:load("res/csd/academy/recruit/ui_academy_recruit_success.csb")
end)

function AcademyRecruitSuccess:ctor(data)
    self.data = data
    self:initView()
end

function AcademyRecruitSuccess:show(parent,data)
    local layer = AcademyRecruitSuccess.new(data)
    parent:addChild(layer)
--    NodeTranslator:transUp(layer,nil)
end

function AcademyRecruitSuccess:close()
--    require("src/app/util/NodeTranslator"):transDown(self,function()
        self:removeFromParent()
--    end)
end

--初始化界面
function AcademyRecruitSuccess:initView()
    
    local panel_bg = self:getChildByName("panel_bg")
    local text_gain = panel_bg:getChildByName("text_gain")
    local icon_reward = panel_bg:getChildByName("icon_reward")
    local text_medal = panel_bg:getChildByName("text_medal")
    local text_des = panel_bg:getChildByName("text_des")
    local btn_confirm = panel_bg:getChildByName("btn_confirm")
    
    text_gain:setString(self.data.des1)
    text_medal:setString(self.data.des2)
    text_des:setString(self.data.des3)
    local icon_medal = icon_reward:getChildByName("icon_medal")
    local icon_general = icon_reward:getChildByName("icon_general")
    if self.data.data and self.data.data.que then
        icon_medal:setVisible(false)
        icon_general:setVisible(true)
        Common:changePic(icon_general:getChildByName("icon_general"),self.data.icon)
        if self.data.data.que == 0 then
            icon_general:getChildByName("icon_star_bg"):setVisible(false)
            Common:changePic(icon_general:getChildByName("panel_outline"),gGeneralQualityIcon[1])
        else
            Common:changePic(icon_general:getChildByName("panel_outline"),gGeneralQualityIcon[self.data.data.que])
            AcademyCommon:showStar(icon_general:getChildByName("icon_star_bg"),"panel_star_0",self.data.data.que)
        end
    else
        icon_medal:setVisible(true)
        icon_general:setVisible(false)
        Common:changePic(icon_reward:getChildByName("icon_medal"),self.data.icon)
    end
    local text_desc = panel_bg:getChildByName("text_desc")
    if self.data.data.recruitStar then
        text_desc:setVisible(true)
        if self.data.data.recruitStar == 1 then
            text_desc:setString(StringRes.newgeneral009)
        else
            text_desc:setString(StringRes.newgeneral010)
        end
    else
        text_desc:setVisible(false)
    end
    
    btn_confirm:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self.data.callback then
                self.data.callback()
            end
            self:close()
        end
    end)
    self:startAction()
end

function AcademyRecruitSuccess:startAction()
    local action = cc.CSLoader:createTimeline("res/csd/academy/recruit/ui_academy_recruit_success.csb")
    if action then
        self:runAction(action)
        action:gotoFrameAndPlay(0, 59, false)
    end
end

return AcademyRecruitSuccess