
--配件工厂
local AccessoriesCfg = require("src/app/cfg/AccessoriesCfg")
local AccessoryView = require("src/app/views/accessories/AccessoryView")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local AccessoriesView = class("AccessoriesView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.Building_Name_12})
end)

function AccessoriesView:ctor(scene,data)
    self.MainPage = CCUILoader:load("csd/AccessoriesLayer.csb")
    self:addChild(self.MainPage)

    self.UIList = self.MainPage:getChildByName("ListView_list")
    self.UIItem = self.UIList:getChildByName("Panel_item")
    self.UIItem:retain()

    self:registerTabEvent("close",function()
        self:closeBack()
    end)

    self.Data = data
    self.SwithEnterFun = {
        function()
            AccessoryView:open(self)
        end,
        function()

        end,
        function()

        end
    }
    ViewManager:OpenView(self)
end

--配件中的一项
function AccessoriesView:setItem(item,info,canEnter,canHandle)
    local UIIcon = item:getChildByName("Image_icon")
    local UIName = item:getChildByName("Text_name")
    local UIDescript = item:getChildByName("Button_descript")
    local UIGo = item:getChildByName("Button_go")
    local UIPrompt = UIGo:getChildByName("icon_tip")
    UIIcon:loadTexture(info.icon,ResType)
    UIName:setString(info.name)
    UIPrompt:setVisible(canHandle)
    UIDescript:addTouchEventListener(eventListner(ended,function()
        local DescriptView = require("src/app/views/prompt/DescriptView")
        DescriptView:open(self,info.descript)
    end))
    SpecialView:setEnabled(UIGo,canEnter)
    UIGo:addTouchEventListener(eventListner(ended,self.SwithEnterFun[info.id]))
end

--主要是列表的刷新
function AccessoriesView:update()
    self.UIList:removeAllChildren()
    local pdata = PlayerData:getInstanse().basicData or {lv=13}
    local tips = PlayerData:getInstanse().getGametipsVO or {partTips=0,supplyTips=0}
    local haveTips = {tips.partTips>0}--,tips.supplyTips>0}
    for index,info in ipairs(AccessoriesCfg) do
        if info.show <= pdata.lv then
            local item = self.UIItem:clone()
            self.UIList:pushBackCustomItem(item)
            self:setItem(item,info,pdata.lv>=info.unlock,haveTips[index] or false)
        end
    end
end

function AccessoriesView:closeBack()
    self.UIItem:release()
end

function AccessoriesView:open(scene)
    local newPage = self.new(scene,{})
    newPage:update()
    scene:addChild(newPage)
end

return AccessoriesView