
--PageView: 1.getCurPageIndex(),2.scrollToPage(index)
local AccessoryClassCfg = require("src/app/cfg/AccessoryClassCfg")
local AccessoryItem = require("src/app/views/accessories/AccessoryItem")
local PartsQualityCfg = require("src/app/cfg/PartsQualityCfg")
local DescriptView = require("src/app/views/prompt/DescriptView")
local PartPromptView = require("src/app/views/accessories/PartPromptView")

local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then
            if ended == t then
                MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            end
            func()
        end
    end
end

--获取最好的配件
local function getMaxWell(parts)
    local re = nil
    for _,item in ipairs(parts) do
        if re then
            if item.data.que > re.data.que then
                re = item
            elseif item.data.que == re.data.que and (item.strLv+item.relv) > (re.strLv+re.relv) then
                re = item
            end
        else
            re = item
        end
    end
    return re
end

gAccessoryPage = nil
local AccessoryPage = class("AccessoryPage",function(parent)
    return display.newLayer()
end)

function AccessoryPage:ctor(parent,data)
    gAccessoryPage = self
    self:addChild(self.MainPage)

    self._parent = parent
    local _t = {}
    for _,info in ipairs(data) do
        _t[info.type] = info
    end
    self.AllTankMsg = _t --坦克的所有属性

    self.AllTankAttr = {{},{},{},{}}

--    self:updatePage() --开始执行
    self:initTankInfo()
    self.UIPageList:scrollToPage(0)

    --播放动画
--    local action = cc.CSLoader:createTimeline("csd/AccessoryLayer.csb")
    self.MainPage:stopAllActions()
    self.MainPage:runAction(self.AnimationAction)
    self.AnimationAction:gotoFrameAndPlay(0,true)
end

function AccessoryPage:gotoPage(idx)
    for index,uiIndex in ipairs(self.UIIndexTable) do
        uiIndex:setBright(index==idx)
    end
end

--设置坦克属性和名字
function AccessoryPage:setAttrs(page,attrs)
    --兼容处理，非常接近0的值都转化成0
    for k,v in pairs(attrs) do
        if v < 0.000001 and v>-0.000001 then
            attrs[k] = 0
        end
    end
--    local addStr = "     "
    local UIList = page:getChildByName("ListView_attr")
    local UIItem1 = UIList:getChildByName("Text_item_1")
    UIItem1:setString(string.format(StringRes.atk_add,(attrs.atk or 0)*100))
    local UIItem2 = UIList:getChildByName("Text_item_2")
    UIItem2:setString(string.format(StringRes.hp_add,(attrs.hp or 0)*100))
    local UIItem3 = UIList:getChildByName("Text_item_3")
    UIItem3:setString(string.format(StringRes.def_add,(attrs.def or 0)*100))
    local UIItem4 = UIList:getChildByName("Text_item_4")
    UIItem4:setString(string.format(StringRes.pierce_add,(attrs.pierce or 0)*100))

--    local UIItem1 = UIList:getChildByName("Text_item_1")
--    UIItem1:setString(string.format(StringRes.atk_add,(attrs.atk or 0)*100)
--        ..addStr..string.format(StringRes.hp_add,(attrs.hp or 0)*100))
--    local UIItem2 = UIList:getChildByName("Text_item_2")
--    UIItem2:setString(string.format(StringRes.def_add,(attrs.def or 0)*100)
--        ..addStr..string.format(StringRes.pierce_add,(attrs.pierce or 0)*100))
--    local UIItem3 = UIList:getChildByName("Text_item_3")
--    UIItem3:setString(string.format(StringRes.armor_add,(attrs.armor or 0)*100)
--        ..addStr..string.format(StringRes.crit_add,(attrs.crit or 0)*100))
--    local UIItem4 = UIList:getChildByName("Text_item_4")
--    UIItem4:setString(string.format(StringRes.dodge_add,(attrs.dodge or 0)*100)
--        ..addStr..string.format(StringRes.hit_add,(attrs.hit or 0)*100))
--    local UIStrenth = page:getChildByName("Text_strenth")
--    UIStrenth:setString(140)
end

--打开配件的提示
function AccessoryPage:openPrompt(page,pageMsg,info,index,item)
    local attrs = self.AllTankAttr[pageMsg.type]
    local isEquip = item.eq
    if isEquip then
        local effects = StringTemp:toTableDecimal(item.data.effect)
        local strengthups = StringTemp:toTableDecimal(item.data.strengthup..",")
        local reformups = StringTemp:toTableDecimal(item.data.reformup..",")
        for k,v in pairs(effects) do
            local attrAdd = v + reformups[k]*item.relv + strengthups[k]*item.strLv
            attrs[k] = attrs[k] - attrAdd
        end
    end
    PartPromptView:open(self,item,function()
--        if item.eq then
--            local newAttr = v + item.data.reformup*item.relv + item.data.strengthup*item.strLv
--            attrs[k] = (attrs[k] or 0) + (isEquip and (newAttr-attrAdd) or newAttr )
--        else
--            attrs[k] = (attrs[k] or 0) - (isEquip and attrAdd or 0)
--        end
        self:setAccessoryInfo(page,pageMsg,info,index)
        self:setAttrs(page,attrs)
        self:setLabPrompt()
    end,true)
end

--设置某个页下面某个项的提示
function AccessoryPage:setInfoPrompt(item,type,index,isPrompt)
    local ui_item = self.TankPrompt[type][index]
    if ui_item and not isPrompt then
        item:removeChild(ui_item)
        self.TankPrompt[type][index] = nil
    elseif isPrompt and not ui_item then
        ui_item = gLittleUi:getChildByName("Image_7"):clone()
        ui_item:getChildByName("Text_num"):setVisible(false)
        local size = item:getContentSize()
        ui_item:setPosition(size.width,size.height)
        ui_item:setScale(0.8)
        item:addChild(ui_item)
        self.TankPrompt[type][index] = ui_item
    end
end

--设置标签的提示文字
function AccessoryPage:setLabPrompt()
    local count = 0
    for type,info in ipairs(self.TankPrompt) do
        for k,v in pairs(info) do
            count = count + 1
        end
    end
    self._parent:setWarningCount(1,count)
end

--设置单项配件
function AccessoryPage:setAccessoryInfo(page,pageMsg,info,index)
    local UILock = page:getChildByName("Image_lock"..index)
    local UIBack = page:getChildByName("Image_back"..index)
    local UIIcon = UIBack:getChildByName("Image_icon")
    local UITextLv = UIBack:getChildByName("Text_level")
    local UIReLvBack = UIBack:getChildByName("Image_level")
    local UIReLv = UIReLvBack:getChildByName("Text_level")
    local lock = pageMsg[string.format("set%dlock",index)]
    UILock:setVisible(lock)
    local qua,icon,text,visible=nil,nil,nil,false
    local item = AccessoryItem:getEquip(pageMsg.type,index)
    if lock or not item then
        qua,icon,text = PartsQualityCfg[0].icon,info.icon,string.format(StringRes.LV2,info.unlock)
    else
        visible = true
        UIReLv:setString(item.relv)
        qua,icon,text = PartsQualityCfg[item.data.que].icon,item.data.icon,
            string.format(StringRes.LV2,item.strLv)
        --属性计算(客户端自己计算)
        local attrs = self.AllTankAttr[pageMsg.type]
        local effects = StringTemp:toTableDecimal(item.data.effect)
        local strengthups = StringTemp:toTableDecimal(item.data.strengthup..",")
        local reformups = StringTemp:toTableDecimal(item.data.reformup..",")
        for k,v in pairs(effects) do
            local attrAdd = v + reformups[k]*item.relv + strengthups[k]*item.strLv
            attrs[k] = (attrs[k] or 0) + attrAdd
        end
    end
    UIReLvBack:setVisible(visible)
    UIBack:loadTexture(qua,ResType)
    UIIcon:loadTexture(icon,ResType)
    UITextLv:setString(text)

    local needPrompt = nil
    local items = AccessoryItem:getByTypeAndPos(pageMsg.type,index) --有可以装备的，改变数据
    if not lock and not item and items[1] then
        needPrompt = true
    end
    self:setInfoPrompt(UIBack,pageMsg.type,index,needPrompt)

    UIBack:addTouchEventListener(eventListner(ended,function()
        if lock then --锁住
            --提示暂时还未开放
            FlyWordPrompt:prompt(string.format(StringRes.part_unlock,info.unlock))
        elseif item then
            self:openPrompt(page,pageMsg,info,index,item)
        else
--            local items = AccessoryItem:getByTypeAndPos(pageMsg.type,index)
            if items[1] then
                local maxItem = getMaxWell(items)
                self:openPrompt(page,pageMsg,info,index,maxItem)
            else
                PromptView:type2(nil,StringRes.have_not_part,StringRes.ok,StringRes.cancel,function()
--                    self._parent:setTabSelect(2)
                    require("src/app/views/accessories/SupplyLineView"):open(self._parent)
                end)
            end
        end
    end))
end

--设置配件
function AccessoryPage:setAccessory(page,list,pageMsg)
    self.AllTankAttr[pageMsg.type] = {}
    for index,info in ipairs(list) do
        self:setAccessoryInfo(page,pageMsg,info,index)
    end
end

--名字，图片和描述
function AccessoryPage:setTankInfo(page,typeInfo)
    local UIName = page:getChildByName("Text_name")
    local UIIcon = page:getChildByName("Image_tank")
    local UIDescript = page:getChildByName("Button_descript")
    UIName:setString(typeInfo.name)
    UIIcon:loadTexture(typeInfo.icon,ResType)
    UIDescript:addTouchEventListener(eventListner(ended,function()
        DescriptView:open(self,typeInfo.descript)
    end))
end

--刷新某一个界面
function AccessoryPage:updatePageInfo(type,typeInfo)
    local page = self.UIPageList:getPage(type-1)
    local pageMsg = self.AllTankMsg[type]
    self:setAccessory(page,typeInfo.accessory,pageMsg)
    self:setAttrs(page,self.AllTankAttr[pageMsg.type])
end

function AccessoryPage:updateAllPage()
    for type,typeInfo in ipairs(AccessoryClassCfg) do
        self:updatePageInfo(type,typeInfo)
    end
    self:setLabPrompt()
end

--切换页面的时候调用
function AccessoryPage:doSelect()
--    local type = self.UIPageList:getCurPageIndex()+1
--    self:updatePageInfo(type,AccessoryClassCfg[type])
    self:updateAllPage()
end

--整个列表的刷新(尽量不要整体刷新)
function AccessoryPage:updatePage()
    self.UIPageList:removeAllPages()
    for type,typeInfo in ipairs(AccessoryClassCfg) do
        local page = self.UIPageItem:clone()
        self.UIPageList:addPage(page)
--        self:updatePageInfo(type,typeInfo)
--        self:setTankInfo(page,typeInfo)
    end
--    self:setLabPrompt()
end

function AccessoryPage:initTankInfo()
    for type,typeInfo in ipairs(AccessoryClassCfg) do
        local page = self.UIPageList:getPage(type-1)
        self:setTankInfo(page,typeInfo)
    end
end

function AccessoryPage:destroy()
--    self.UIPageItem:release()
    local count = 0
    for type,tankP in pairs(self.TankPrompt) do
        for k,v in pairs(tankP) do
            count = 1
            break
        end
    end

    PlayerData:getInstanse().getGametipsVO.partTips = count

    self._parent:removeChild(self)
    gAccessoryPage = nil
end

function AccessoryPage:uiLoad()
    self.MainPage = CCUILoader:load("csd/AccessoryLayer.csb")
    self.MainPage:retain()

    self.UIIndexTable = {
        self.MainPage:getChildByName("btn_page_1"),
        self.MainPage:getChildByName("btn_page_2"),
        self.MainPage:getChildByName("btn_page_3"),
        self.MainPage:getChildByName("btn_page_4")
    }
    self.UILast = self.MainPage:getChildByName("ani_left")
    self.UINext = self.MainPage:getChildByName("ani_right")
    self.UIPageList = self.MainPage:getChildByName("PageView_tank")
    self.UIPageItem = self.UIPageList:getChildByName("Panel_item")
    self.UIPageItem:retain()
    self.UIPageList:addEventListener(eventListner(ccui.PageViewEventType.turning,function()
        self.CurSelectPageIndex = self.UIPageList:getCurPageIndex() + 1
        self:gotoPage(self.CurSelectPageIndex)
    end))
    self.UILast:addTouchEventListener(eventListner(ended,function()
        local idx = self.CurSelectPageIndex%4-1
        self.UIPageList:scrollToPage((idx==0 and 4 or idx)-1)
    end))
    self.UINext:addTouchEventListener(eventListner(ended,function()
        self.UIPageList:scrollToPage(self.CurSelectPageIndex%4)
    end))

    self.AnimationAction = cc.CSLoader:createTimeline("csd/AccessoryLayer.csb")
    self.AnimationAction:retain()

    self.TankPrompt = {{},{},{},{} }

    self:updatePage()
end

return AccessoryPage