
-- 配件
local AccessoryItem = require("src/app/views/accessories/AccessoryItem")
local AccessoryPage = require("src/app/views/accessories/AccessoryPage")
local WareHourseView = require("src/app/views/accessories/WareHourseView")

local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local AccessoryView = class("AccessoryView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.accessories,
        tabs={StringRes.accessories,StringRes.part_store}})
end)

function AccessoryView:ctor(parent,data)
    AccessoryItem:initAll(data)

    self.Labels = {
        AccessoryPage.new(self,data.openPartsStateVOs),
        WareHourseView.new(self)
    }
    for index,label in ipairs(self.Labels) do
        self:addChild(label)
        self:registerTabEvent(index,function()
            self:selectLable(index)
        end)
    end
    self:registerTabEvent("close",function(parent)
        self:closeBack()
    end)
    ViewManager:OpenView(self)
end

--选择某个项
function AccessoryView:selectLable(lab)
    for type , label in ipairs(self.Labels) do
        label:setVisible(type==lab)
    end
    --如果又需要的处理做处理
    self.Labels[lab]:doSelect()
end

function AccessoryView:closeBack()
    for index,label in ipairs(self.Labels) do
        label:destroy()
    end
    AccessoryItem:clear()
    if self._parent.update and type(self._parent.update)=="function" then
        self._parent:update()
    end
end

function AccessoryView:open(parent,lab)
    Connect:sendMsg("PartsAction","openPartsState",nil,function(data)
        local newPage = self.new(parent,data)
        parent:addChild(newPage)
        newPage:setTabSelect(lab or 1)
    end,true)
end

return AccessoryView