

-- 配件(强化或者改造)
local AccessoryItem = require("src/app/views/accessories/AccessoryItem")
local StrenthView = require("app/views/accessories/StrengthView")
local RemakeView = require("app/views/accessories/RemakeView")

local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local AddAttributeView = class("AddAttributeView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.accessories,tabs=
    {StringRes.strength,StringRes.reform}})
end)

function AddAttributeView:ctor(parent,item,callback)
    self.Labels = {
        StrenthView.new(self,item),
        RemakeView.new(self,item) 
    }
    for index,label in ipairs(self.Labels) do
        self:addChild(label)
        self:registerTabEvent(index,function()
            self:selectLable(index)
        end)
    end
    self:registerTabEvent("close",function(parent)
        self:closeBack()
    end)
    
    
    self.item = item
    self.callback = callback
end

--选择某个项
function AddAttributeView:selectLable(lab)
    for type , label in ipairs(self.Labels) do
        local visible = type==lab
        label:setVisible(visible)
        if visible then
            label:update(self.item)
        end
    end
end

function AddAttributeView:closeBack()
    for index,label in ipairs(self.Labels) do
        label:destroy()
    end
    self.callback()
end

function AddAttributeView:open(parent,item,callback,lab)
    local newPage = self.new(parent,item,callback) 
    parent:addChild(newPage)
    newPage:setTabSelect(lab or 1)
end

return AddAttributeView