
--配件的提示
local AccessoryItem = require("src/app/views/accessories/AccessoryItem")
local AddAttributeView = require("src/app/views/accessories/AddAttributeView")
local AccessoryClassCfg = require("src/app/cfg/AccessoryClassCfg")
local NodeTranslator = require("src/app/util/NodeTranslator")
local PartsQualityCfg = require("src/app/cfg/PartsQualityCfg")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local function getUserLevel(itemdata)
    local curLv = PlayerData:getInstanse().basicData.lv
    local needLv = 0
    if itemdata.type <= 4 then
        needLv = AccessoryClassCfg[itemdata.type].accessory[itemdata.pos].unlock
    elseif itemdata.type == 5 then
        local reformData = AccessoryItem:getDataById(itemdata.upId)
        needLv = AccessoryClassCfg[reformData.type].accessory[reformData.pos].unlock
    end
    return needLv,(curLv > needLv)
end

local PartPromptView = class("PartPromptView",function()
    return display.newLayer()
end)

function PartPromptView:ctor(parent,item,callback,isPartLabel)
    self.MainPage = CCUILoader:load("csd/public/PartPromptLayer.csb")
    self:addChild(self.MainPage)

    self.UIPanelBack = self.MainPage:getChildByName("Image_back")
    local UIParent = self.UIPanelBack:getChildByName("Panel_back")
    self.UIClose = UIParent:getChildByName("Button_close")
    self.UIBackImage = UIParent
    self.UIQuality = UIParent:getChildByName("Image_quality")
    self.UIIcon = self.UIQuality:getChildByName("Image_icon")
    self.UITitle = UIParent:getChildByName("Text_title")
    self.UIReformText = UIParent:getChildByName("Text_rebuild")
    self.UIStrengthText = UIParent:getChildByName("Text_strength")
    self.UIAddAttrText1 = UIParent:getChildByName("Text_addattr")
    self.UIAddAttrText2 = UIParent:getChildByName("Text_entrench")
    self.UIDescript = UIParent:getChildByName("Text_descript")
    self.UIUserLevel = UIParent:getChildByName("Text_property")

    self.UIEquipBtn = UIParent:getChildByName("Button_equip")
    self.UIRecountBtn = UIParent:getChildByName("Button_recount")
    self.UIStrengthBtn = UIParent:getChildByName("Button_strength")
    self.UIReformBtn = UIParent:getChildByName("Button_reform")
    self.UIName = UIParent:getChildByName("Text_name")
    self.UICount = UIParent:getChildByName("Text_count")
--
--    local size = self.UIPanelBack:getContentSize()
--    if item.data.type <= 4 then
--        size.height = 570
--    else
--        size.height = 470
--    end
--    self.UIPanelBack:setContentSize(size)

    --装备提示图标
    local ui_item = gLittleUi:getChildByName("Image_7"):clone()
    ui_item:getChildByName("Text_num"):setVisible(false)
    local size = self.UIEquipBtn:getContentSize()
    ui_item:setPosition(size.width,size.height)
    ui_item:setScale(0.8)
    self.UIEquipBtn:addChild(ui_item)
    self.UIEquipPrompt = ui_item

    self.UIClose:addTouchEventListener(eventListner(ended,function()
        self.CallBack()
        self:close()
    end))
    self.UIEquipBtn:addTouchEventListener(eventListner(ended,function() --卸载或者装备
        if item.data.type <=4 then
            --装备的时候判断解锁没？
            local canEquip,info = AccessoryItem:canEquipItem(item)
            if not item.eq and not canEquip then
                return FlyWordPrompt:prompt(string.format(StringRes.part_unlock,info.unlock))
            end
            local msg = {id=item.id,eqtype=item.eq and 2 or 1}
            Connect:sendMsg("PartsAction","eqParts2Parts",msg,function(newdata)
                if newdata.state == 1 then
                    local str = nil
                    if item.eq then
                        str = StringRes.succ_takeoff
                        AccessoryItem:unloadItem(item)
                    else
                        AccessoryItem:equipItem(item)
                        str = StringRes.succ_equip
                    end
                    callback()
                    self:close()
                    FlyWordPrompt:prompt(str)
                end
            end,true)
        else
            if item.count + self.UniversaCount < item.data.comcount then
                local SupplyLineView = require("src/app/views/accessories/SupplyLineView")
                local newParent = parent._parent._parent
                parent._parent:close()
                SupplyLineView:open(newParent)
            else
                --合成
                local function syn(unuseruniversal)
                    Connect:sendMsg("PartsAction","composeParts",{id=item.id,wanneng=unuseruniversal and 0 or 1},function(newdata)
                        if newdata.state == 1 then
                            callback()
                        end
                    end,true)
                    if not unuseruniversal then
                        self:close()
                    end
                end
                if item.count >= item.data.comcount then
                    syn(true)
                else
                    return PromptView:type2(nil,StringRes.frament_unenough,StringRes.ok,StringRes.cancel,syn)
                end
            end
            self:close()
        end
    end))
    self.UIRecountBtn:addTouchEventListener(eventListner(ended,function()
        if item.eq then
            -- 提示只能在仓库分解
            FlyWordPrompt:prompt(StringRes.only_in_hourse)
        else
            --todo 分解
            local ReformGetView = require("src/app/views/accessories/ReformGetView")
            local prompt
            prompt = ReformGetView:open(self,{item},false,function()
                Connect:sendMsg("PartsAction","decomposeParts",{id=item.id},function(newdata)
                    local pd = PlayerData:getInstanse().basicData
                    pd.crystal = newdata.crystal
                    callback()
                    self:close()
                    FlyWordPrompt:prompt(prompt)
                end,true)
            end)
        end
    end))
    local function update()
        self:update(item)
    end
    self.UIStrengthBtn:addTouchEventListener(eventListner(ended,function()
        --打开强化界面
        AddAttributeView:open(parent,item,update,1)
    end))
    self.UIReformBtn:addTouchEventListener(eventListner(ended,function()
        --打开改造界面
        AddAttributeView:open(parent,item,update,2)
    end))

    local posx,posy = self.UIBackImage:getPosition()
    local size = self.UIPanelBack:getContentSize()
    local visible = false
    if item.data.type == 5 then
        size.height = 590
    else
        visible = true
        size.height = 680
    end

    self.UICount:setString("")
    self.UIStrengthBtn:setVisible(visible)
    self.UIReformBtn:setVisible(visible)
    self.UIBackImage:setPosition(posx,size.height)
    self.UIPanelBack:setContentSize(size)

    self.CallBack = callback
    self._parent = parent
    self.IsPartLabel = not isPartLabel

    self:update(item)

    NodeTranslator:transZoomOut(self.UIPanelBack,function()

        end)
end

--判断是否为万能碎片并初始化万能碎片的个数
function PartPromptView:initUniversalFrament(item)
    if item.data.id ~= 237 then
        local universaFramentItem = AccessoryItem:getByDataId(237)
        self.UniversaCount = universaFramentItem and universaFramentItem.count or 0
        return true
    else
        return false
    end
end

function PartPromptView:update(item)
    self.UIIcon:loadTexture(item.data.icon)
    self.UIName:setString(item.data.name)
    self.UIReformText:setString(string.format(StringRes.reform_lv,item.relv))
    self.UIStrengthText:setString(string.format(StringRes.strength_lv,item.strLv))
    local userLv,isUp = getUserLevel(item.data)
    self.UIUserLevel:setString(string.format(StringRes.user_lv,userLv))
    self.UIUserLevel:setColor(isUp and CommonColor.White or CommonColor.Red)
    --属性
    local effects = StringTemp:toTableDecimal(item.data.effect)
    local strengthups = StringTemp:toTableDecimal(item.data.strengthup..",")
    local reformups = StringTemp:toTableDecimal(item.data.reformup..",")
    local k,v = nil,nil
    for pos = 1 , 2 do
        local visible = false
        local uiAddAttrText = self["UIAddAttrText"..pos]
        k,v = next(effects,k)
        if k then
            visible = true
            local attrAdd = v + (reformups[k] or 0)*item.relv + (strengthups[k] or 0)*item.strLv
            uiAddAttrText:setString(string.format(StringRes[k.."_add"],attrAdd*100))
        end
        uiAddAttrText:setVisible(visible)
    end
    self.UIDescript:setString(item.data.decript)
    local str,title = nil,nil
    if item.data.type <= 4 then
        str = item.eq and StringRes.unload or StringRes.equip
        title = StringRes["part_quality_"..item.data.que]..StringRes.accessories
        self.UIQuality:loadTexture(PartsQualityCfg[item.data.que].icon,ResType)
    else
        self.UICount:setString(item.count.."/"..item.data.comcount)
        str = ((item.count + self.UniversaCount) < item.data.comcount) and StringRes.get or StringRes.Synthesis
        self.UIQuality:loadTexture(PartsQualityCfg[item.data.que].pieceicon,ResType)
        title = StringRes["part_quality_"..item.data.que]..StringRes["part_type_"..item.data.type]
    end
    self.UIEquipPrompt:setVisible(AccessoryItem:compareEquip(item))
    self.UIEquipBtn:setTitleText(str)
    self.UITitle:setString(title)
    self.UIRecountBtn:setBright(self.IsPartLabel)
end

function PartPromptView:close()
    NodeTranslator:transZoomIn(self.UIPanelBack,function()
        self._parent:removeChild(self)
    end)
end

function PartPromptView:open(parent,item,callback,isPartLabel)
    if self:initUniversalFrament(item) then
        local newPage = self.new(parent,item,callback,isPartLabel)
        newPage:update(item)
        parent:addChild(newPage)
--        local size = newPage:getContentSize()
--        newPage:setAnchorPoint(0.5,0.5)
--        newPage:setPosition(size.width/2,size.height/2)
    else
        FlyWordPrompt:prompt(StringRes.universal_prompt)
    end
end

return PartPromptView