
--分解
local NodeTranslator = require("src/app/util/NodeTranslator")
local AccessoryItem = require("src/app/views/accessories/AccessoryItem")
local AddAttrCost = require("src/app/views/accessories/AddAttrCost")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

--碎片分解
local framReformCfg = {50,100,200,300}
local partReformCfg = {150,500,1600,2400}
local partReformCry = {5,75,300,2000}
local costStringCfg = {
    StringRes.parts_name_241,
    StringRes.common_cry,
    StringRes.crystal,
    StringRes.parts_name_238,
    StringRes.parts_name_239,
    StringRes.parts_name_240,
}

local function getCryQuality(pos)
    if pos <= 4 then
        return 1
    elseif pos <=6 then
        return 2
    elseif pos <= 8 then
        return 3
    end
end

local function getCryForPart(data)
    return partReformCry[data.que]*data.pos
end

--获取消耗
local function getReformGet(items)
    local get = {0,0,0,0,0,0}
    for _,item in ipairs(items) do
        if item.data.type > 4 then
            get[1] = get[1] + framReformCfg[item.data.que]*item.count
            get[2] = get[2] + item.count*math.ceil(getCryForPart(AccessoryItem:getDataById(item.data.upId))/item.data.comcount)
        else
            get[1] = get[1] + partReformCfg[item.data.que]
            get[2] = get[2] + getCryForPart(item.data)
            local cost = AddAttrCost:getAllCost(item)
            for i=3,6 do
                get[i] = get[i] + cost[i]
            end
        end
    end
    for i= 3, 6 do
        get[i] = math.ceil(get[i]/3)
    end

    --获取位置（碎片不同）
    local first = items[1].data
    local pos
    if first.type > 4 then
        pos = AccessoryItem:getDataById(first.upId).pos
    else
        pos = first.pos
    end
    return get,pos
end

local ReformGetView = class("ReformGetView",function()
    return display.newLayer()
end)

function ReformGetView:ctor(parent,items,callback)
    self.MainPage = CCUILoader:load("csd/public/ReformGetLayer.csb")
    self:addChild(self.MainPage)

    self.UIBackPanel = self.MainPage:getChildByName("Panel_3")
    self.UIOK = self.UIBackPanel:getChildByName("Button_ok")
    self.UICancel = self.UIBackPanel:getChildByName("Button_cancel")
    self.UIWhowPanel = self.UIBackPanel:getChildByName("Panel_2")
    self.UIClose = self.UIWhowPanel:getChildByName("Button_close")
    self.UITitleText = self.UIWhowPanel:getChildByName("Text_title")

    self.UIClose:addTouchEventListener(eventListner(ended,function()
        self:close()
    end))
    self.UICancel:addTouchEventListener(eventListner(ended,function()
        self:close()
    end))
    self.UIOK:addTouchEventListener(eventListner(ended,callback))

    self.PanelPosx,self.PanelPosy = self.UIWhowPanel:getPosition()
    self.BackSize = self.UIBackPanel:getContentSize()
    local title = nil
    local item = items[1]
    if item.data.type <=4 then
        title = StringRes["part_quality_"..item.data.que]..StringRes.accessories
    else
        title = StringRes["part_quality_"..item.data.que]..StringRes["part_type_"..item.data.type]
    end
    self.UITitleText:setString(title)

    self._parent = parent
end

function ReformGetView:update(cost,pos)
    local costCount = 0
    for index = 1, 6 do
        local count = cost[index]
        local visible = false
        local UIitem = self.UIWhowPanel:getChildByName("Image_get_"..index)
        if count then
            visible = true
            costCount = costCount + 1
            local UIName = UIitem:getChildByName("Text_name")
            local UICount = UIitem:getChildByName("Text_count")
            if index == 2 then
                local UIIcon = UIitem:getChildByName("Image_icon")
                UIIcon:loadTexture(crystalIcon[getCryQuality(pos)],ResType)
            end
            UICount:setString("x"..count)
        end
        UIitem:setVisible(visible)
    end
    --大小位置
    self.BackSize.height = 295 + 125*math.ceil(costCount/2)
    self.PanelPosy = self.BackSize.height
    self.UIBackPanel:setContentSize(self.BackSize)
    self.UIWhowPanel:setPosition(self.PanelPosx,self.PanelPosy)
end

function ReformGetView:close()
--    NodeTranslator:transZoomIn(self,function()
        self._parent:removeChild(self)
--    end)
end

local function handleCost(cost)
    if cost[4] == 0 then
        for i = 3 , #cost do
            if cost[i] == 0 then
                cost[i] = nil
            end
        end
    end
    return cost
end

function ReformGetView:open(parent,items,isAll,callback)
    local cost,pos = getReformGet(items)
    local content = ""
    for index,count in ipairs(cost) do
        if count > 0 then
            content = content.." "..costStringCfg[index].."x"..count
        end
    end
    if isAll then
        local contentPrompt = StringRes.recount_get..content.."\n"..StringRes.recount_descript
        PromptView:type2(nil,contentPrompt,StringRes.ok,StringRes.cancel,callback)
    else
        local newPage = self.new(parent,items,callback)
        newPage:update(handleCost(cost),pos)
        parent:addChild(newPage)
    end
    return content
--    local size = newPage:getContentSize()
--    newPage:setAnchorPoint(0.5,0.5)
--    newPage:setPosition(size.width/2,size.height/2)
--    NodeTranslator:transZoomOut(newPage,function()
--
--        end)
end

return ReformGetView
