
--强化
local ScalePosition = {{x=200.57,y=825.66},{x=200.57,y=786.66}}
local PartsQualityCfg = require("src/app/cfg/PartsQualityCfg")
local AccessoryItem = require("src/app/views/accessories/AccessoryItem")
local AddAttrCost = require("src/app/views/accessories/AddAttrCost")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local qualityScaleCfg = {1,0.95,0.9,0.85}
--1-（当前等级+1）*1.5% * 品质参数
local function getSuccScale(lv,que)
    local strenghPro = PlayerData:getInstanse().PlayerAddition.strenghPro
    return (1-(lv+1)*0.015)*qualityScaleCfg[que]*(1+strenghPro) + gVIP[PlayerData:getInstanse().basicData.vipLv].strengthScale
end

local StrengthView = class("StrengthView",function(parent)
    return display.newLayer()
end)

function StrengthView:ctor(parent,item)
    self.MainPage = CCUILoader:load("csd/StrengthLayer.csb")
    self:addChild(self.MainPage)

    self.UIQuality = self.MainPage:getChildByName("Image_quality")
    self.UIIcon = self.UIQuality:getChildByName("Image_icon")
    self.UIName = self.MainPage:getChildByName("Text_name")
    self.UIReformLv = self.MainPage:getChildByName("Text_reform_lv")
    self.UIStrengthLv = self.MainPage:getChildByName("Text_stren_lv")
    self.UIAttrAdd1 = self.MainPage:getChildByName("Text_add_attr")
    self.UIAttrAdd2 = self.MainPage:getChildByName("Text_entrench")
    self.UISuccScale = self.MainPage:getChildByName("Text_succscale")
    self.UIStrenthPerAdd = self.UIStrengthLv:getChildByName("Text_upgrade")
    self.UIAttrPerAdd1 = self.UIAttrAdd1:getChildByName("Text_upgrade")
    self.UIAttrPerAdd2 = self.UIAttrAdd2:getChildByName("Text_upgrade")
    self.UIScalePerAdd = self.UISuccScale:getChildByName("Text_upgrade")

    self.UIBoxOwnCount = self.MainPage:getChildByName("Text_own_count")
    self.UICostCount = self.MainPage:getChildByName("Text_cost_count")
    self.UIAddCount = self.MainPage:getChildByName("Button_add")
    self.UISubCount = self.MainPage:getChildByName("Button_sub")
    self.UICryMsg = self.MainPage:getChildByName("Text_cost_cry")
    self.UICostItem = self.MainPage:getChildByName("Image_cost_icon")

    self.UIIsMaxLv = self.MainPage:getChildByName("Text_isMaxLv")
    self.UIStrength = self.MainPage:getChildByName("Button_strength")

    self.UICostCount:addEventListener(eventListner(ccui.TextFiledEventType.insert_text,function()
        local str = self.UICostCount:getString()
        local num = tonumber(str)
        if num and num<=self.OwnBoxCount then
            self:updateSuccScale(num)
        else
            self.UICostCount:setString(self.SelectBoxCount)
        end
    end))
    self.UIStrength:addTouchEventListener(eventListner(ended,function()
        if item.strLv >= PlayerData:getInstanse().basicData.lv then
            return FlyWordPrompt:prompt(StringRes.rolelv_unenough_str )--不能超过玩家的等级
        end
        if not self.ResourceEnough then
            return FlyWordPrompt:prompt(StringRes.crystal_unenougth)--资源不够
        end
        local msg = {id=item.id,count=self.SelectBoxCount}
        Connect:sendMsg("PartsAction","strengthenParts",msg,function(data)
            local str = StringRes.fail_strength
            if data.state == 1 then
                str = StringRes.succ_strength
                item.strLv = item.strLv + 1
            elseif data.state == 2 then
                str = StringRes.text_world00034
            end
            local pd = PlayerData:getInstanse().basicData
            pd.crystal = data.crystal
            local boxItem = AccessoryItem:getByDataId(243)
            if boxItem then
                boxItem.count = data.boxCount
            end
            self:update()
            FlyWordPrompt:prompt(str)
        end,true)
    end))

    self.Item = item
    self.SelectBoxCount = 0
    self.OwnBoxCount = nil
    self.ResourceEnough = nil

    self:setBaseMsg()
    self:update()
end

--设置基础信息
function StrengthView:setBaseMsg()
    local item = self.Item
    self.UIQuality:loadTexture(PartsQualityCfg[item.data.que].icon,ResType)
    self.UIIcon:loadTexture(item.data.icon,ResType)
    self.UIName:setString(item.data.name)

    local data = AccessoryItem:getDataById(243)
    self.UICostItem:addTouchEventListener(eventListner(ended,function()
        PromptView:partInfo(data,2)
    end))
    self.UISubCount:addTouchEventListener(eventListner(ended,function()
            if self.SelectBoxCount > 0 then
                self:updateSuccScale(self.SelectBoxCount - 1)
            end
        end))
    self.UIAddCount:addTouchEventListener(eventListner(ended,function()
            if self.OwnBoxCount == 0 then
                PromptView:partInfo(data,2)
            end
            if self.SelectBoxCount < self.OwnBoxCount then
                self:updateSuccScale(self.SelectBoxCount + 1)
            end
        end))
end

--刷新成功概率
function StrengthView:updateSuccScale(count)
    local item = self.Item
    self.SelectBoxCount = count
    local scale=getSuccScale(item.strLv,item.data.que) + 0.05*count
    if item.strLv > 60 then
        scale = getSuccScale(60,item.data.que) + 0.05*count
    end
    self.UICostCount:setString(count)
    self.UISuccScale:setString(string.format(StringRes.succ_scale,((scale>1) and 1 or scale)*100))
end

--刷新
function StrengthView:update()
    local item = self.Item
    local commonStr = "  "
    local boxItem = AccessoryItem:getByDataId(243)
    self.OwnBoxCount = boxItem and boxItem.count or 0 --工具箱id 243
    self.UIReformLv:setString(string.format(StringRes.reform_lv,item.relv))
    self.UIStrengthLv:setString(string.format(StringRes.strength_lv,item.strLv))
    self.UIStrenthPerAdd:setString(commonStr.."↑ +1")

    --属性
    local effects = StringTemp:toTableDecimal(item.data.effect)
    local strengthups = StringTemp:toTableDecimal(item.data.strengthup..",")
    local reformups = StringTemp:toTableDecimal(item.data.reformup..",")
    local k,v = nil,nil
    for pos = 1 , 2 do
        local visible = false
        local uiAddAttrText = self["UIAttrAdd"..pos]
        k,v = next(effects,k)
        if k then
            visible = true
            local uiAttrPerAdd = self["UIAttrPerAdd"..pos]
            local attrAdd = v + reformups[k]*item.relv + strengthups[k]*item.strLv
            uiAddAttrText:setString(string.format(StringRes[k.."_add"],attrAdd*100))
            local size = uiAddAttrText:getContentSize()
            uiAttrPerAdd:setPosition(size.width,0)
            uiAttrPerAdd:setString(string.format(commonStr.."↑ +%s%%",strengthups[k]*100))
            self.UISuccScale:setPosition(ScalePosition[pos].x,ScalePosition[pos].y)
        end
        uiAddAttrText:setVisible(visible)
    end

    self.UIBoxOwnCount:setString(self.OwnBoxCount)
    local pd = PlayerData:getInstanse().basicData
    local cryCost = AddAttrCost:getStrenCost(item.strLv,item.data.que)[3]
    self.UICryMsg:setString(string.format(
        StringRes.ownAndneed_crystal,StringTemp:toNum(pd.crystal),
        StringTemp:toNum(cryCost)))
    self:updateSuccScale(0)
    self.ResourceEnough = (pd.crystal>=cryCost)
    self.UICryMsg:setColor((pd.crystal>=cryCost) and CommonColor.Green or CommonColor.Red)
    local visible = item.strLv >= item.data.strengthlv
    self.UIIsMaxLv:setVisible(visible)
    self.UIStrength:setVisible(not visible)
end

function StrengthView:destroy()

end

return StrengthView