
--补给线
local DescriptCfg = require("app.cfg.DescriptCfg")
local supply_mission = require("app/data/supply_mission")
local AccessoryItem = require("src/app/views/accessories/AccessoryItem")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local function setButtonEnabled(button,enable)
    button:setBright(enable)
    button:setEnabled(enable)
    button:setTouchEnabled(enable)
end

local SupplyLineView = class("SupplyLineView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.supply_line,tabs={}})
end)

function SupplyLineView:ctor(parent)

    self:addChild(self.MainPage)

    self.LinesListData = nil

    self:registerTabEvent("close",function()
        self:closeCallback()
    end)

    self.UIReset:addTouchEventListener(eventListner(ended,function() --重置
        local cost = self.AlreadyResetCount  --98+100*self.AlreadyResetCount
        local own = PlayerData:getInstanse().basicData.gold
        if own >= cost then
            local function reset()
                PromptView:type2(nil,string.format(StringRes.reset_supplyline,cost),StringRes.ok,StringRes.cancel,function()
                    Connect:sendMsg("SupplyAction","reset",nil,function(newdata)
                        PlayerData:getInstanse().basicData.gold = PlayerData:getInstanse().basicData.gold - cost
                        self:update(newdata)
                    end,true)
                end)
            end
            if self:haveNotChallenge() then
                PromptView:type2(nil,StringRes.have_not_challenge,StringRes.ok,StringRes.cancel,reset)
            else
                reset()
            end
        else
            PromptView:goldUnenought(cost,own,function()

            end)
        end
    end))


    self.UISweep:addTouchEventListener(eventListner(ended,function() --扫荡
            local unLockLv = 4
            if PlayerData:getInstanse().basicData.vipLv >= unLockLv then
                local sendPos = 1
                SpecialView:setEnabled(self.UISweep,false)
                local list = self.LinesListData
                local function loopSweep()
                    for i = sendPos,#list do
                        local info = list[i]
                        if info.unlock then
                            if info.state == 0 and info.star == 3 then
                                sendPos = i
                                Connect:sendMsg("SupplyAction","cleanOut",{mid=info.missionId},
                                    function(newdata)
                                        --刷新可攻打关卡
                                        self.AtkCount = self.AtkCount - 1
                                        PlayerData:getInstanse().getGametipsVO.supplyTips = self.AtkCount
                                        self.UIRemainAtk:setString(string.format(StringRes.remain_atk,self.AtkCount))

                                        PlayerData:getInstanse().basicData.energy = newdata.energy
                                        info.state = newdata.state
                                        self:updateItemInfo(sendPos)
                                        local moban = "%sx%d "
                                        local reStr = string.format(moban..moban,StringRes.exp,newdata.exp,StringRes.prestige,newdata.pre)
                                        for _,id in ipairs(newdata.drops) do
                                            local itemdata = AccessoryItem:getDataById(id.baseId)
                                            reStr = reStr..string.format(moban,itemdata.name,id.num)
                                        end
                                        FlyWordPrompt:prompt(reStr)
                                        --漂字提示获得的奖励字符串
                                        NodeTranslator:showInterceptView(1.5,function()
                                            loopSweep()
                                        end)
                                    end)
                                break
                            end
                        else
                            return self:updateSweep()
                        end
                    end
                end
                loopSweep()
            else
                PromptView:type1(nil,string.format(StringRes.sweep_lock,unLockLv),StringRes.ok)
            end
        end))

    self.UIFunDescript:addTouchEventListener(eventListner(ended,function() --副本描述
            local DescriptView = require("app/views/prompt/DescriptView")
            DescriptView:open(self,DescriptCfg.SupplyLine,20)
        end))
end

function SupplyLineView:closeCallback()
--    self.UILineItem:release()
    if self._parent.__cname == "CombatCenterView" then
        self._parent:update()
    end
end

function SupplyLineView:updateSweep()
    local canSweep = false
    for i,info  in ipairs(self.LinesListData) do
        if info.unlock then
            if info.state == 0 and info.star == 3 then
                canSweep = true
                break
            end
        else
            break
        end
    end
    SpecialView:setEnabled(self.UISweep,canSweep)
end

--是否有关卡未打
function SupplyLineView:haveNotChallenge()
    for _,info in ipairs(self.LinesListData) do
        if info.unlock then
            if info.state == 0 then
                return true
            end
        else
            break
        end
    end
    return false
end

local function getStringData(info,playerLv,unLock,star)
    local strData = {interval=50}
    if info.unlock > playerLv then
        table.insert(strData,{{str=string.format(StringRes.level_unlock,info.unlock),
            color=CommonColor.Red,size=24}})
    end
    if star == 3 then
        table.insert(strData,{{str=StringRes.already_failed,color=CommonColor.White,size=24}})
    else
        table.insert(strData,{{str=StringRes.saodang_limit,color=CommonColor.Red,size=24}})
    end
    table.insert(strData,{{str=StringRes.random_things,color=CommonColor.White,size=24}})
    for k,v in ipairs(info.descript) do
        v.intervalEnabled = true
        table.insert(strData,v)
    end
    return strData
end

--扫荡刷新一项
function SupplyLineView:updateItemInfo(pos)
    local ui_item = self.UILinesList:getItem(pos-1)
    local canAtk = false
    local lineInfo = self.LinesListData[pos]
    local UIAtk = ui_item:getChildByName("Button_attack")
    if lineInfo.unlock and lineInfo.state == 0 then
        canAtk = true
    end
    SpecialView:setEnabled(UIAtk,canAtk)
end

function SupplyLineView:initList()
    self.UILinesList:removeAllChildren()
    for index,info in ipairs(supply_mission) do
        local item = self.UILineItem:clone()
        self.UILinesList:pushBackCustomItem(item)
        local tankInfo = Tank[info.maintank]
        local UIIcon = item:getChildByName("Image_icon")
        UIIcon:loadTexture(tankInfo.icon,ResType)
        local UIAtk = item:getChildByName("Button_attack")
        showShader:buttonToGray(UIAtk)
    end
end

--列表
function SupplyLineView:updateList(list)
    self.AtkCount = 0
    self.LinesListData = list
    local playerLv = PlayerData:getInstanse().basicData.lv
    for index,lineInfo in ipairs(list) do
        local item = self.UILinesList:getItem(index-1)--self.UILineItem:clone()
--        self.UILinesList:pushBackCustomItem(item)
        local UIIcon = item:getChildByName("Image_icon")
        local UIName = item:getChildByName("Text_name")
        local UILock = UIIcon:getChildByName("Image_lock")
        local UIDecript = item:getChildByName("Button_descript")
        local UIAtk = item:getChildByName("Button_attack")

        --评分
        for i=1,3 do
            local ui = item:getChildByName("Button_star_"..i)
            showShader:buttonToGray(ui)
            ui:setBright(lineInfo.star >= i) --(4-i) )
        end

        local canAtk = false
        if lineInfo.unlock and lineInfo.state == 0 then
            canAtk = true
            self.AtkCount = self.AtkCount + 1
            UIAtk:addTouchEventListener(eventListner(ended,function()
                local TroopstView = require("app/views/troops/TroopsView")
                TroopstView:open(self,4,lineInfo)
            end))
        end

        SpecialView:setEnabled(UIAtk,canAtk)
        UILock:setVisible(not lineInfo.unlock)--锁
        local cfgInfo = supply_mission[lineInfo.missionId]
        UIName:setString(cfgInfo.name)

        UIDecript:addTouchEventListener(eventListner(ended,function()
            local DescriptView = require("app/views/prompt/DescriptView")
            DescriptView:open(self,getStringData(cfgInfo,playerLv,lineInfo.unlock,lineInfo.star))
        end))
    end
    PlayerData:getInstanse().getGametipsVO.supplyTips = self.AtkCount
end

--列表之外的
function SupplyLineView:updateOther(reset)
    self.UIRemainAtk:setString(string.format(StringRes.remain_atk,self.AtkCount))
    self.UIResetCount:setString(reset)
    self:updateSweep()
    setButtonEnabled(self.UIReset,reset>0)
end

--刷新
function SupplyLineView:update(newdata)
    self.AlreadyResetCount = newdata.cost--newdata.haveReset or 0
    self:updateList(newdata.missions)
    self:updateOther(newdata.reset)
    self.UILinesList:setVisible(true)
end

--从服务器获取数据
function SupplyLineView:updateFromServer()
    Connect:sendMsg("SupplyAction","getSupplyInfo",nil,function(newdata)
        self:update(newdata)
    end,false)
end

function SupplyLineView:open(parent,data)
    local newPage = self.new(parent)
    parent:addChild(newPage)
    newPage.UILinesList:setVisible(false)--removeAllChildren()
    newPage:updateFromServer()
end

function SupplyLineView:uiLoad()
    self.MainPage = CCUILoader:load("csd/SupplyLineLayer.csb")
    self.MainPage:retain()

    self.UIRemainAtk = self.MainPage:getChildByName("Text_canatk")
    self.UIFunDescript = self.MainPage:getChildByName("Button_descript")
    self.UIReset = self.MainPage:getChildByName("Button_reset")
    self.UISweep = self.MainPage:getChildByName("Button_sweep")
    self.UIResetCount = self.MainPage:getChildByName("Text_count")

    showShader:buttonToGray(self.UIReset)

    self.UILinesList = self.MainPage:getChildByName("ListView_lines")
    self.UILineItem = self.UILinesList:getChildByName("Panel_item")
    self.UILineItem:retain()

    self:initList()
end

return SupplyLineView