
local AGUpgradeReward = class("AGUpgradeReward",function(scene,data)
    return PanelTabLayer.new(scene,{title=StringRes.activitydes_13,tabs={StringRes.new_activity_dd1,StringRes.ranking_list}})
end)

local ids = {1,2,3,4,6}

function AGUpgradeReward:show(parent)

    Connect:sendMsg("ActivityGuildLvAction","openActivityGuildLv",{},
        function(data)
            local layer = AGUpgradeReward.new(parent,data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)
end

function AGUpgradeReward:ctor(parent,data)
    self.data = data
    self:initView()
end

function AGUpgradeReward:initView()
    self.content = CCUILoader:load("csd/mainmap_left/activity_announcement/activity/army_group_upgrade_reward/ui_army_group_upgrade_reward_main.csb")
    self:addChild(self.content)
    self.tabs = {self.content:getChildByName("panel_bg"),self.content:getChildByName("panel_ranking")}
    self:registerTabEvent(1,function()
        self:showTab(1)            
    end)
    self:registerTabEvent(2,function()
        if self:checkAm() then
            self:showTab(2)
        else
            self:setTabSelect(1)
        end     
    end)
    self:setTabSelect(1)
    self:initIntro()
    self:initRank()
end

function AGUpgradeReward:initRank()
    self.panel_attack_1st = self.tabs[2]:getChildByName("panel_attack_1st")
    self.panel_attack_2nd = self.tabs[2]:getChildByName("panel_attack_2nd")
    self.panel_attack_3rd = self.tabs[2]:getChildByName("panel_attack_3rd")
    self.panel_attack_other = self.tabs[2]:getChildByName("panel_attack_other")
    self.listview_ranking = self.tabs[2]:getChildByName("listview_ranking")
    self.listview_ranking:removeAllItems()
    if self.data.activityGuildLvRankInfo then
        self:addRankItem(self.data.activityGuildLvRankInfo,true)
    end
    for i,v in ipairs(self.data.guildLvRankInfos) do
        self:addRankItem(v,false)
    end
end

function AGUpgradeReward:addRankItem(v,isSelf)
    local item = nil
    if v.rank == 1 then
        item = self.panel_attack_1st:clone()
    elseif v.rank == 2 then
        item = self.panel_attack_2nd:clone()
    elseif v.rank == 3 then
        item = self.panel_attack_3rd:clone()
    elseif v.rank > 3 or v.rank == 0 then
        item = self.panel_attack_other:clone()
        local tmp = v.rank
        if v.rank == 0 then tmp = "10+" end
        item:getChildByName("text_ranking"):setString(tmp)
    end
    item:getChildByName("text_army_group_name"):setString(v.guildName)
    item:getChildByName("text_num"):setString(v.count)
    item:getChildByName("text_level"):setString(v.lv)
    item:getChildByName("panel_line"):setVisible(isSelf)
    item:getChildByName("panel_bg"):setVisible(not isSelf)
	self.listview_ranking:pushBackCustomItem(item)
end

function AGUpgradeReward:initIntro()
    self.panel_line = self.tabs[1]:getChildByName("panel_item"):clone()
    local panel_bg = self.panel_line:getChildByName("panel_bg")
    panel_bg:getChildByName("text_time"):setString(string.format(StringRes.act_timeFormat,self.data.startTime,self.data.endTime))
    panel_bg:getChildByName("text_time_award"):setString(string.format(StringRes.act_timeFormat,self.data.getStartTime,self.data.getEndTime))
    panel_bg:getChildByName("text_content_info"):setString(StringRes.act_agreward_des)
    panel_bg:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.act_agreward_notice))              
        end
    end)
    self.listview_line = self.tabs[1]:getChildByName("listview_line")
    self.listview_line:pushBackCustomItem(self.panel_line)
   
    self.listview_line:pushBackCustomItem(self.tabs[1]:getChildByName("panel_bg_start"):clone())
    
    local panel_linebg = self.tabs[1]:getChildByName("panel_linebg")
    
    for i,v in ipairs(ids) do 
        local item = panel_linebg:clone()
        local parent = item:getChildByName("panel_outline")
        local tmp = gActivityGuildLvReward[v]
        for index = 1 , 3 do 
            parent:getChildByName("icon_medal_0"..index):setVisible(index == i)
        end
        local text_ranknum = parent:getChildByName("text_ranknum")
        text_ranknum:setVisible(i>3)
        local lastNum = nil
        if i == #ids then
            lastNum = #gActivityGuildLvReward
        else
            lastNum = ids[i+1]-1
        end
        text_ranknum:setString(string.format(StringRes.act_rank_des,ids[i],lastNum))
        self:initItems(tmp,parent)
        self.listview_line:pushBackCustomItem(item)
    end
    
    self.listview_line:pushBackCustomItem(self.tabs[1]:getChildByName("panel_bg_end"):clone())
    
    self.btn_get = self.tabs[1]:getChildByName("btn_get")
    showShader:buttonToGray(self.btn_get)
    self.btn_get:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self.data.state == 1 then
                Connect:sendMsg("ActivityGuildLvAction","getGuildLvRankReward",{},
                    function(data)
                        local pd = PlayerData:getInstanse()
                        pd.basicData.gold = data.gold
                        self.data.state = data.state
                        self:updateState()
                        local str = StringRes.exchange_get_reward
                        local tmpData = gActivityGuildLvReward[data.rank]
                        if tmpData then
                            if data.job == 1 then    --军团长
                                str = str..ActUtils:getItemStrLifei(self:initTmpData(tmpData.leader))
                            else --成员
                                str = str..ActUtils:getItemStrLifei(self:initTmpData(tmpData.members))
                            end
                            FlyWordPrompt:prompt(str)
                        end
                    end)
            else
                FlyWordPrompt:prompt(StringRes.new_server_combat1)
            end
            
        end
    end)
    self:updateState()
    
end

function AGUpgradeReward:initTmpData(data)
    local datas = string.split(data,",")
    local tbs = {}
    for i,v in ipairs(datas) do
        local tmp = {}
        local arr = string.split(v,"_")
        local ids = string.split(arr[1],":")
        local nums = string.split(arr[2],":")
        if arr[1] == "res:0" then
            tmp.type  = 4
            tmp.count = tonumber(nums[2])
        elseif string.find(arr[1],"item") then
            tmp.type  = 1
            tmp.templateId = tonumber(ids[2])
            tmp.count = tonumber(nums[2])
        end
        table.insert(tbs,tmp)
    end
    return tbs
end

function AGUpgradeReward:initItems(tmp,parent)
    local ldata = self:initTmpData(tmp.leader)
    for i,v in ipairs(ldata) do
        local cur = parent:getChildByName("icon_leader"..i)
        cur.tag_data = v
        require("src/app/views/activity/ActUtils"):initSignItemLifei(cur)
    end 
    local mdata = self:initTmpData(tmp.members)
    for i,v in ipairs(mdata) do
        local cur = parent:getChildByName("icon_member"..i)
        cur.tag_data = v
        require("src/app/views/activity/ActUtils"):initSignItemLifei(cur)
    end 
    
end

function AGUpgradeReward:updateState()
    local panel_bg = self.panel_line:getChildByName("panel_bg")
    local text_activity = panel_bg:getChildByName("text_activity")
    local text_time = panel_bg:getChildByName("text_time")
    local text_desc = panel_bg:getChildByName("text_desc")
    if self.data.state == 2 then
        self.btn_get:setTitleText(StringRes.already_attach)   
	else
        self.btn_get:setTitleText(StringRes.act_get)   
	end
    Common:setBtnTouchEnable(self.btn_get,self.data.state == 1 or self.data.state == 3)
    if self.data.state == 1 then
        text_desc:setVisible(true)
        text_desc:setString(StringRes.new_server_combat5)
        text_activity:setVisible(false)
        text_time:setVisible(false)
    elseif self.data.state == 2 then
        text_desc:setVisible(false)
        text_activity:setVisible(false)
        text_time:setVisible(false)
    elseif self.data.state == 3 then
        text_desc:setVisible(true)
        text_desc:setString(StringRes.new_server_combat1)
        text_activity:setVisible(false)
        text_time:setVisible(false)
    elseif self.data.state == 0 then
        text_desc:setVisible(false)
        text_activity:setVisible(true)
        text_time:setVisible(true)
    end
end

function AGUpgradeReward:showTab(index)
	for i,v in ipairs(self.tabs) do
        v:setVisible(i == index)
	end
end

function AGUpgradeReward:checkAm()
    local pd = PlayerData:getInstanse()
    if pd.basicData.guildId == 0 then
        FlyWordPrompt:prompt(StringRes.act_noAm)
        return false
    else
        return true
    end
end

function AGUpgradeReward:close()
	NodeTranslator:transDown(self,function()
        self:getParent():getActivityList()
                self:removeFromParent()
            end)
end

return AGUpgradeReward