local AcademyGeneralCollection = class("AcademyGeneralCollection",function(data)
    return display.newLayer()
end)

function AcademyGeneralCollection:ctor(data)
    self.data = data
    self.tmpGeneral = gGeneral[self.data.commanderId]
    self.panelBg = CCUILoader:load("res/csd/public/PanelBgLarge.csb")
    self:addChild(self.panelBg)

    self.panelBg:getChildByName("text_title"):setString(StringRes.activitydes_39)

    --关闭
    local close = self.panelBg:getChildByName("btn_close")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect) 
            if self:getParent() and self:getParent().getActivityList then
                self:getParent():getActivityList()
            end
            self:removeFromParent()
        end
    end)

    self.panelInfo = CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/general_part_collection/ui_general_part_collection_main.csb")
    self:addChild(self.panelInfo)
    
    self.panel_main_bg = self.panelInfo:getChildByName("panel_main_bg")
    self.panel_title_bg = self.panel_main_bg:getChildByName("panel_title_bg")
    self.panel_desc_bg = self.panel_main_bg:getChildByName("panel_desc_bg")
    self.panel_title_bg:getChildByName("text_time"):setString(self.data.ac_time)
    self.panel_title_bg:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.newgeneral006))
        end
    end)
    self.panel_title_bg:getChildByName("text_info"):setString(StringRes.newgeneral001)
    self.panel_desc_bg:getChildByName("text_info"):setString(string.format(StringRes.newgeneral002,self.tmpGeneral.generalname))
    
    self.actStars = {self.panel_desc_bg:getChildByName("icon_01"),self.panel_desc_bg:getChildByName("icon_02"),self.panel_desc_bg:getChildByName("icon_03"),self.panel_desc_bg:getChildByName("icon_04")}
    self:updateActStar(self.data.start)
    self:updateActGeneral({id=self.data.commanderId,que =self.tmpGeneral.que})
    
    self.panel_main_bg:getChildByName("num_need_02"):setString(self.data.tencost)
    self.panel_main_bg:getChildByName("num_need_01"):setString(self.data.cost)
    self:updateCostInfo()
    
    self.panel_main_bg:getChildByName("text_recruit"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:recruitGeneral(self.singleRecruitType)
        end
    end)
    
    self.panel_main_bg:getChildByName("text_recruit_ten"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:recruitGeneral(3)
        end
    end)
    self:updateRecordInfo()
    
    self.panel_main_bg:getChildByName("panel_info_bg"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            require("src/app/views/activity/AcademyGeneralCollectionRecord"):show(self,self.data.warCommanderRecodVOs)
        end
    end)
    self.panel_main_bg:getChildByName("icon_book"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            require("src/app/views/activity/AcademyGeneralCollectionRecord"):show(self,self.data.warCommanderRecodVOs)
        end
    end)
    
end

function AcademyGeneralCollection:updateActStar(star)
    
    for i,v in ipairs(self.actStars)do
        if star>=i then
            showShader:toNormal(v)
        else 
            showShader:toGray(v)
        end
    end
end

function AcademyGeneralCollection:show(parent,ac_id,ac_time)

    Connect:sendMsg("ActivityWarCommanderAction","openWarCommander",{type = ac_id},
        function(data)
            data.ac_time = ac_time
            data.ac_id = ac_id
            local layer = AcademyGeneralCollection.new(data)
            parent:addChild(layer)
--            NodeTranslator:transUp(layer,nil)
        end)

end

function AcademyGeneralCollection:updateCostInfo()
    local tmpBtn = self.panel_main_bg:getChildByName("text_recruit")
    local tmpNum = self.panel_main_bg:getChildByName("num_need_01")
    local tmpIcon = self.panel_main_bg:getChildByName("icon_coin_01")
    if self.data.freeCount > 0 then
        self.singleRecruitType = 1
        tmpBtn:loadTextureNormal(ResIconCfg.btn_positive)
        tmpBtn:loadTexturePressed(ResIconCfg.btn_positivePress)
        tmpBtn:setTitleText(StringRes.newgeneral008)
        tmpNum:setVisible(false)
        tmpIcon:setVisible(false)
    else
        self.singleRecruitType = 2
        tmpBtn:loadTextureNormal(ResIconCfg.btn_negative)
        tmpBtn:loadTexturePressed(ResIconCfg.btn_negativePress)
        tmpBtn:setTitleText(StringRes.newgeneral007)
        tmpNum:setVisible(true)
        tmpIcon:setVisible(true)
    end
end

function AcademyGeneralCollection:updateActGeneral(data)
    local panel_outline = self.panel_desc_bg:getChildByName("panel_outline")
    local panel_general_low = self.panel_desc_bg:getChildByName("panel_general_low")
    local info = gGeneral[data.id]
    local name = panel_outline:getChildByName("text_name")
    name:setString(info.generalname)
    local ColorMgr = require("src/app/util/ColorMgr")
    name:setColor(ColorMgr:getByQuality(data.que))
    panel_outline:getChildByName("panel_desc_bg"):getChildByName("listview_info"):getChildByName("text_info"):setString(info.lifedes)
    
    local panel_avatar = panel_general_low:getChildByName("panel_avatar")
    Common:changePic(panel_avatar:getChildByName("panel_outline"),gGeneralQualityIcon[data.que])
    Common:changePic(panel_avatar:getChildByName("icon_avatar"),info.icon)
    
    local panel_star_bg = panel_outline:getChildByName("panel_star_bg")
    for i = 1 , 5 do 
        local icon = panel_star_bg:getChildByName("icon_star_0"..i)
        if icon then
            icon:setVisible(data.que>=i)
        end
    end
    AcademyCommon:showStar(panel_general_low:getChildByName("Image_star_back"),"panel_star_",data.que)
    panel_general_low:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local GeneralDetailView = require("src/app/views/troops/GeneralDetailView4Cfg")
            GeneralDetailView:open(self,data.id)
        end
    end)
end

function AcademyGeneralCollection:initRecordInfo(recruit)
    local des = ""
    if recruit.itemsId > 0 then
        des = string.format("%sx%d",StringRes[gItem[recruit.itemsId].name],recruit.count)

    elseif recruit.commanderId > 0 then
        if recruit.pirace and recruit.pirace == 1 then
            des = string.format("%sx%d",gGeneral[recruit.commanderId].generalname..StringRes.aca_item2,recruit.count)
        else
            des = string.format("%sx%d",gGeneral[recruit.commanderId].generalname,recruit.count)
        end

    end

    return StringRes.get_reward..des
end

function AcademyGeneralCollection:updateRecordInfo()
    local text_info = self.panel_main_bg:getChildByName("panel_info_bg"):getChildByName("text_info")
    if self.data.warCommanderRecodVOs == nil or #(self.data.warCommanderRecodVOs) == 0 then
        text_info:setString(StringRes.newgeneral005)
    else
        local recruit = self.data.warCommanderRecodVOs[1]
        text_info:setString(recruit.reTime.." "..self:initRecordInfo(recruit))
    end
end

function AcademyGeneralCollection:recruitGeneral(type)
    Connect:sendMsg("ActivityWarCommanderAction","recruit",{recruitType  = type,type = self.data.ac_id},
        function (data)
            PlayerData:getInstanse().basicData.gold  = data.gold
            self.data.freeCount = data.freeCount
            self.data.start = data.start
            self:updateActStar(self.data.start)
            self:updateCostInfo()
            self.data.warCommanderRecodVOs = data.warCommanderRecodVOs
            self:updateRecordInfo()
            local recruitVOs = data.recruitVOs
            local size = #recruitVOs
            local index = 1
            function showRecruit()
                if index > size then return end
                local recruit = recruitVOs[index]
                local type = recruit.type
                local des1 = ""
                local des2 = ""
                local des3 = ""
                local icon = ""
                local tmpdata = {}
                tmpdata.recruitStar = recruit.start
                if type == 1 then
                    des1 = string.format(StringRes.aca_get_success,StringRes.prop)
                    des2 = string.format("%sx%d",StringRes[gItem[recruit.templateId].name],recruit.count)
                    icon = gItem[recruit.templateId].icon
                elseif type == 2 then
                    des1 = string.format(StringRes.aca_get_success,StringRes.aca_item)
                    des2 = string.format("%sx%d",gGeneral[recruit.templateId].generalname..StringRes.aca_item2,recruit.count)
                    icon = gGeneral[recruit.templateId].icon
                    tmpdata.que = 0
                    GeneralData:init()
                elseif type == 3 or type == 4 then
                    des1 = string.format(StringRes.aca_get_success,StringRes.aca_general)
                    if recruit.ispirace and recruit.ispirace == 1 then
                        des2 = gGeneral[recruit.templateId].generalname
                        des3 = string.format(StringRes.aca_hava_general,recruit.piraceCount)
                    else
                        des2 = string.format("%sx%d",gGeneral[recruit.templateId].generalname,recruit.count)
                    end
                    icon = gGeneral[recruit.templateId].icon
                    tmpdata.que = gGeneral[recruit.templateId].que
                    GeneralData:init()
                end

                local tmp = AcademyCommon:initRecruitScsData(
                    des1,
                    des2,
                    des3,
                    icon,
                    function()
                        index = index+1
                        showRecruit()
                    end,
                    tmpdata)
                require("src/app/views/academy/AcademyRecruitSuccess"):show(self,tmp)

            end
            showRecruit()
        end)
end

return AcademyGeneralCollection