
local AcademyGeneralCollectionRecord = class("AcademyGeneralCollectionRecord",function(data)
    return CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/general_part_collection/layer_general_part_info.csb")
end)

function AcademyGeneralCollectionRecord:show(parent,data)

    if data and (#data) > 0 then
        local layer = AcademyGeneralCollectionRecord.new(data)
        parent:addChild(layer)
--        NodeTranslator:transZoomOut(layer:getChildByName("panel_background"),nil)
    else
        FlyWordPrompt:prompt(StringRes.text_world00035)
    end
end

function AcademyGeneralCollectionRecord:ctor(data)
    self.data = data
    self:initView()
end

function AcademyGeneralCollectionRecord:initView()
    local panel_bg = self:getChildByName("panel_background")
    self.listView = panel_bg:getChildByName("listview_desc")
    self.listItem = panel_bg:getChildByName("panel_event")
    panel_bg:getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)
    panel_bg:getChildByName("btn_ok"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)
    self:updateListItems()
end

function AcademyGeneralCollectionRecord:updateListItems()
    local AcademyGeneralCollectionRecord =  require("src/app/views/activity/AcademyGeneralCollection")
    for i , v in ipairs(self.data) do
        local item = self.listItem:clone()
        item:getChildByName("text_time"):setString(v.reTime)
        item:getChildByName("text_event"):setString(AcademyGeneralCollectionRecord:initRecordInfo(v))
        self.listView:pushBackCustomItem(item)
    end
end

function AcademyGeneralCollectionRecord:close()
--    NodeTranslator:transZoomOut(self:getChildByName("panel_background"),function()
        self:removeFromParent()
--    end)
end

return AcademyGeneralCollectionRecord