
local AttackRaise = class("AttackRaise",function(canGet,data)
    return CCUILoader:load("csd/mainmap_popout/layer_popout_attack_raise_tomorrow.csb")
end)

function AttackRaise:show(parent,canGet,data)
    local layer = AttackRaise.new(canGet,data)
    parent:addChild(layer,200)
    NodeTranslator:transZoomOut(layer:getChildByName("panel_mask"):getChildByName("panel_bg"),nil)
end

function AttackRaise:ctor(canGet,data)
    self.strContent = ""
    self.tag_canGet = canGet
    if canGet and data ==  nil then
        local pd = PlayerData:getInstanse()
        self.tag_data = pd.combatGiftVOs
    else
        self.tag_data = data
    end
    self:initView()
end

function AttackRaise:initView()
    local panel_bg = self:getChildByName("panel_mask"):getChildByName("panel_bg")
    local btn_confirm = panel_bg:getChildByName("btn_confirm")
    local text_title = panel_bg:getChildByName("text_title")
    local text_desc = panel_bg:getChildByName("panel_desc_bg"):getChildByName("text_desc")
    
    if self.tag_canGet then
        btn_confirm:setTitleText(StringRes.attach)
        text_title:setString(StringRes.attack_raise)
        text_desc:setString(StringRes.attack_raise_des)
    else
        btn_confirm:setTitleText(StringRes.ok)
        text_title:setString(StringRes.attack_raise_tomorrow)
        text_desc:setString(StringRes.attack_raise_tomorrow_des)
    end
    
    btn_confirm:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            
            function close()
                NodeTranslator:transZoomIn(self:getChildByName("panel_mask"):getChildByName("panel_bg"),function()
                    self:removeFromParent()
                end)
            end
        
            if self.tag_canGet then
                Connect:sendMsg("GiftAction","getCombatGift",{},
                    function (data)
                        if data.state == 1 then
                            FlyWordPrompt:prompt(string.format(StringRes.exchange_success,self.strContent))
                            local pd = PlayerData:getInstanse()
                            pd.combatGiftVOs = nil
                            close()
                        end
                    end)
            else
                close()
            end
            
        end
    end)
    
    
    
    self:updateItems()
end

function AttackRaise:updateItems()
    local panel_tank_bg = self:getChildByName("panel_mask"):getChildByName("panel_bg"):getChildByName("panel_tank_bg"):getChildByName("listview_mask")
    local listview = panel_tank_bg:getChildByName("listview_resource")
    local oriListviewSize = listview:getContentSize()
    listview:setContentSize(0,oriListviewSize.height)
    local tmpItem = panel_tank_bg:getChildByName("panel_item_bg")
    for i,v in ipairs(self.tag_data) do
        local info = nil
        if v.giftType == 1 then
            info = gItem[v.giftId]
            self.strContent = self.strContent..StringRes[info.name].."x"..v.giftCount.." "
        elseif v.giftType == 2 then
            local parts = require("src/app/data/parts")
            info = parts[v.giftId]
            self.strContent = self.strContent..info.name.."x"..v.giftCount.." "
        elseif v.giftType == 3 then
            info = Tank[v.giftId]
            self.strContent = self.strContent..StringRes[info.name].."x"..v.giftCount.." "
        end
        if info then
            local item = tmpItem:clone()
            local icon_item = item:getChildByName("icon_item")
            Common:changePic(icon_item,info.icon)
            icon_item:getChildByName("num_desc"):setString("x"..v.giftCount)
            listview:pushBackCustomItem(item)
            local size = listview:getContentSize()
            local width = size.width+item:getContentSize().width+listview:getItemsMargin()
            if width > oriListviewSize.width then
                width = oriListviewSize.width
            end
            listview:setContentSize(width,size.height)
        end
    end
   
end

return AttackRaise