
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local AwardingTableView = class("AwardingTableView",function()
    return display.newLayer()
end)

function AwardingTableView:ctor(parent,data)
    self.MainPage = CCUILoader:load("csd/mainmap_left/activity_announcement/activity/tank_slots/layer_popout_reward_list.csb")
    self:addChild(self.MainPage)

    local ui_back = self.MainPage:getChildByName("panel_mask"):getChildByName("panel_bg")
    self.UIClose = ui_back:getChildByName("btn_close")
    self.UIList = ui_back:getChildByName("listview_line")
    self.UITitleItem = ui_back:getChildByName("panel_line")
    self.UIRewardItem = ui_back:getChildByName("panel_item")

    self.UIClose:addTouchEventListener(eventListner(ended,function()
            self:close()
        end))

    self.type = data

    self:initList()
end

function AwardingTableView:initList()
    local TankPullPaCfg = require("src/app/data/tank_pullpa"..self.type) or {}
    for index,idGroup in ipairs( TankPullPaCfg.ids) do
        local desc = TankPullPaCfg.descripts[index]
        local ui_title = self.UITitleItem:clone()
        ui_title:getChildByName("text_reward"):setString(desc)
        self.UIList:pushBackCustomItem(ui_title)
        local count,comCount = TankPullPaCfg.counts[index],TankPullPaCfg.comCounts[index]
        for idIndex,id in ipairs(idGroup) do
            local ui_item = self.UIRewardItem:clone()
            local uiIcon = ui_item:getChildByName("icon_tanke")
            local uiCount = uiIcon:getChildByName("text_num")
            local tankInfo = Tank[id]
            Common:changePic(uiIcon,tankInfo.icon)
            SpecialView:registerEvent(uiIcon,ended,function()
                require("app/views/activity/ItemDetail"):show(self,{icon=tankInfo.icon,title=StringRes[tankInfo.name],
                des=StringRes[tankInfo.dec],count=count,titleColor=Common:getUnitTitleColor(tankInfo)})
            end)
            uiCount:setString(string.format("x %s",count))
            for i = 1 , 3 do
                local visible = (i > 3-comCount)
                local tIcon = ui_item:getChildByName("icon_reward_"..i)
                tIcon:setVisible(visible)
                if visible then
                    Common:changePic(tIcon,gTankPullPaIcon[idIndex])
                end
            end
            self.UIList:pushBackCustomItem(ui_item)
        end
    end
end

function AwardingTableView:close()
    self:removeFromParent()
end

function AwardingTableView:open(parent,data)
   local newPage = self.new(parent,data)
   parent:addChild(newPage)
end

return AwardingTableView