
local ContinuousRecharge = class("ContinuousRecharge",function(scene,data)
    return CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/continuous_recharge/ui_continuous_recharge_main.csb")
end)



function ContinuousRecharge:show(parent,id)

    Connect:sendMsg("RunningPayAction","openRunningPay",{type = id},
        function(data)
            local layer = ContinuousRecharge.new(parent,data)
            layer.dataType = id
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)
end

function ContinuousRecharge:ctor(parent,data)
    self.data = data
    self:initView()
end

function ContinuousRecharge:initView()
    --关闭
    --根据活动id设置不同的名字
    if self.dataType==29 then
        self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.activitydes_18)
    elseif self.dataType==85 then
        self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.activitydes_18002)
    end
    self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.activitydes_18)
    local close = self:getChildByName("panel_bg"):getChildByName("btn_close")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)

    local panel_main_bg = self:getChildByName("panel_main_bg")
    self.panel_title_bg = panel_main_bg:getChildByName("panel_title_bg")

    --信息
    self.panel_title_bg:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.activity_descript_26))
        end
    end)

    self.panel_title_bg:getChildByName("text_time"):setString(string.format(StringRes.act_timeFormat,self.data.startTime,self.data.endTime))
    local tmpIcon = self.panel_title_bg:getChildByName("icon_item")
    Animation:playAnimation(tmpIcon,gUIeffect[9].effect,true,15)
    --奖励显示内容
    tmpIcon.tag_data = {type = 1,baseId = self.data.gift,num = 1}
    self.giftInfo = require("src/app/views/activity/ActUtils"):initSignItem(tmpIcon)
    local listview_info = self.panel_title_bg:getChildByName("listview_info")
    local text_info = listview_info:getChildByName("text_info")
    text_info:setString("")
    SpecialView:addRichText(text_info,StringTemp:Descript(StringRes.activity_descript_27,text_info:getFontSize()),0)

    self.panel_item_bg = panel_main_bg:getChildByName("panel_item_bg")
    self.listview_item = self.panel_item_bg:getChildByName("listview_item")
    self.btn_get = panel_main_bg:getChildByName("btn_get")
    showShader:buttonToGray(self.btn_get)
    self:updateItems()
    Common:setBtnTouchEnable(self.btn_get,self.data.state == 1)
    self.btn_get:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            Connect:sendMsg("RunningPayAction","getRunningPayGift",{type = self.dataType},
                function(data)
                    if data.state == 1 then
                        FlyWordPrompt:prompt(StringRes.exchange_get_reward..self.giftInfo.title.."x"..self.giftInfo.count)
                        Common:setBtnTouchEnable(self.btn_get,false)
                    end
                end)
        end
    end)
    panel_main_bg:getChildByName("btn_recharge"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:getParent():removeFromParent()
            Recharge:show(gWorldScene)
        end
    end)
end

function ContinuousRecharge:updateItems()
    self.listview_item:removeAllItems()
    for i,v in ipairs(self.data.days) do
        local item = self.panel_item_bg:getChildByName("panel_item"):clone()
        item:getChildByName("text_desc"):setString(string.format(StringRes.activity_descript_24,v.day))
        item:getChildByName("text_num"):setString(v.gold)
        item:getChildByName("icon_get"):setVisible(v.gold>=self.data.needGold)
        AcademyCommon:nodesFormatX({item:getChildByName("text_info"),item:getChildByName("text_num"),item:getChildByName("icon_coin")})
        item:getChildByName("progress_bg"):getChildByName("loadingbar_progress"):setPercent(v.gold/self.data.needGold*100)
        self.listview_item:pushBackCustomItem(item)
    end
end

function ContinuousRecharge:close()
    NodeTranslator:transDown(self,function()
        self:getParent():getActivityList()
        self:removeFromParent()
    end)
end

return ContinuousRecharge