
local DailyRechargeReward = class("DailyRechargeReward",function(scene,data)
    return CCUILoader:load("csd/mainmap_left/activity_announcement/activity/daily_recharge_reward/ui_daily_recharge_reward_main.csb")
end)



function DailyRechargeReward:show(parent,id)

    Connect:sendMsg("DailyPayAction","openDailyPay",{type = id},
        function(data)
            local layer = DailyRechargeReward.new(parent,data)
            layer.dataType = id
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)
end

function DailyRechargeReward:ctor(parent,data)
    self.data = data
    self.maxGold = 0
    self:initView()
end

function DailyRechargeReward:initView()
    --关闭
    if self.dataType==41 then
        self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.activitydes_29)
    elseif self.dataType==95 then
        self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.activitydes_95)
    end
    local close = self:getChildByName("panel_bg"):getChildByName("btn_close")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect) 
            self:close()
        end
    end)
    
    
    local panel_mask = self:getChildByName("panel_mask")
    self.panel_title_bg = panel_mask:getChildByName("panel_title_bg")
    --信息
    self.panel_title_bg:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.activity_descript_20))
        end
    end)
    self.panel_title_bg:getChildByName("text_time"):setString(string.format(StringRes.act_timeFormat,self.data.startTime,self.data.endTime))
    self.panel_title_bg:getChildByName("text_desc_01"):setString(StringRes.activity_descript_19)
    self.panel_title_bg:getChildByName("text_desc_02"):setString(string.format(StringRes.activity_descript_23,self.data.gold))
    
    self.panel_reward = panel_mask:getChildByName("panel_reward")
    self.listview_reward = self.panel_reward:getChildByName("listview_reward")
    self.btn_get = panel_mask:getChildByName("btn_get")
    showShader:buttonToGray(self.btn_get)
    self:updateItems()
    self.btn_get:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect) 
            if self.attachData.id then
                Connect:sendMsg("DailyPayAction","getDailyPayGift",{id = self.attachData.id,type = self.dataType},
                    function(data)
                        if data.state == 1 then
                            self.data.gifts[self.attachData.index].state = 2
                            FlyWordPrompt:prompt(self.attachData.textInfo)
                            self:updateItems()
                        end
                    end)
            end
        end
    end)
end

local TextInfos ={
    StringRes.activity_descript_22,
    StringRes.activity_descript_72,
    StringRes.already_attach,
}
local TextColors ={
    CommonColor.Red,
    CommonColor.Green,
    CommonColor.White,
}

function DailyRechargeReward:updateItems()
	self.listview_reward:removeAllItems()
	self.attachData = {}
	for i,v in ipairs(self.data.gifts) do
	   if v.gold > self.maxGold then self.maxGold = v.gold end
       local item = self.panel_reward:getChildByName("panel_reward_bg"):clone()
       item:getChildByName("num_info"):setString(v.gold)
       local text_info = item:getChildByName("text_info")
       text_info:setString(TextInfos[v.state+1])
       text_info:setColor(TextColors[v.state+1])
       item.textInfo = StringRes.exchange_get_reward
       for ii,vv in ipairs(v.gift) do
            local tmpItem = item:getChildByName("icon_item_0"..ii)
            tmpItem.tag_data = vv
            local tmpInfo = require("src/app/views/activity/ActUtils"):initSignItem(tmpItem)
            item.textInfo = item.textInfo.." "..tmpInfo.title.."x"..tmpInfo.count
       end
       if v.state == 1 and self.attachData.id == nil then 
            self.attachData.id = v.id
            self.attachData.textInfo = item.textInfo
            self.attachData.index = i
       end
       self.listview_reward:pushBackCustomItem(item)
	end
    self.panel_reward:getChildByName("progress_bg"):getChildByName("progressbar"):setPercent(self.data.gold/self.maxGold*100)
    Common:setBtnTouchEnable(self.btn_get,self.attachData.id ~= nil)
end

function DailyRechargeReward:close()
    NodeTranslator:transDown(self,function()
        self:getParent():getActivityList()
        self:removeFromParent()
    end)
end

return DailyRechargeReward