--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
--每日轮盘

local Scheduler = cc.Director:getInstance():getScheduler()
local timeKey = nil
local ended = ccui.TouchEventType.ended

--时间终止
local function endTime()
    if timeKey then
        Scheduler:unscheduleScriptEntry(timeKey)
        timeKey = nil
    end
end

--生成时间轴
local function gernerateTable(pos)
    local _t = {}
    local cfg = {0.05*3,0.05*3,0.05*3,0.05*2,0.05*2,0.05*2,0.05*2,0.05*1,0.05*1,0.05*1,0.05*1,0.05*1}
    local time = 0
    local max = (#cfg)*2+pos
    for i = 1,max do
        local add = cfg[#cfg]
        if cfg[i] then
            add = cfg[i]
        elseif cfg[max-i+1] then
            add = cfg[max-i+1]
        end
        time = time + add
        _t[i] = time
    end
    return _t
end

local DailyWheelView = class("DailyWheelView",function(parent,data)
    return PanelTabLayer.new(parent,{title=StringRes.activitydes_38,
    tabs={StringRes.dailyrotarytable010,StringRes.dailyrotarytable011,StringRes.dailyrotarytable012}})
end)

function DailyWheelView:ctor(parent,data,activityId)
    self.UIMainPage = CCUILoader:load("csd/mainmap_left/activity_announcement/activity/daily_roulette_extra/ui_daily_roulette_extra_main.csb")
    self:addChild(self.UIMainPage)

    local uiPanelBack = self.UIMainPage:getChildByName("panel_roulette")
    self.Labels = {
        uiPanelBack:getChildByName("panel_tab_01"),
        uiPanelBack:getChildByName("panel_tab_03"),
        uiPanelBack:getChildByName("panel_tab_02"),
    }

    for labIndex , lab in ipairs(self.Labels) do
        self:registerTabEvent(labIndex,function()
            self:selectLabel(labIndex)
        end)
    end

    self.ActivityId = activityId
    self.SwitchLabelFunc = {
        function()

        end,
        function()

        end,
        function()

        end
    }

    self:initLotteryLab(data)
    self:initSomethingLabel(data)
    self:initRankLabel(data)

    self:setTabSelect(1)
end

function DailyWheelView:selectLabel(labIndex)
    for index,lab in ipairs(self.Labels) do
        lab:setVisible(index == labIndex)
    end

    self.SwitchLabelFunc[labIndex]()
end

--初始化第一个标签抽奖
function DailyWheelView:initLotteryLab(data)
    local uiParent = self.Labels[1]
    self.LotteryData = data
    uiParent:getChildByName("text_time"):setString(data.startTime.."~"..data.endTime)
    uiParent:getChildByName("text_time_award"):setString(data.getStartTime.."~"..data.getEndTime)
    local uiListParent = uiParent:getChildByName("panel_desc_bg")
    local uiItem = uiListParent:getChildByName("panel_desc")
    uiItem:retain()
    uiItem:removeFromParent()
    uiListParent:getChildByName("listview_desc"):pushBackCustomItem(uiItem)
    uiItem:release()
    SpecialView:addRichText(uiItem:getChildByName("text_desc_03"),StringTemp:Descript(StringRes.dailyrotarytable003))
    self.UISelected  = uiParent:getChildByName("Image_selected")
    self.UIRewardBack = uiParent:getChildByName("panel_item")
    self.UIRewardIconBack = self.UIRewardBack:getChildByName("panel_item_desc")
    self.RewardIconPos = cc.p(self.UIRewardIconBack:getPosition())

    local uiIconParent = uiParent:getChildByName("panel_item_bg")
    local uiTenLottery = uiIconParent:getChildByName("btn_lottery_continue")
    local uiLottery = uiIconParent:getChildByName("btn_lottery")
    local uiTenCost = uiIconParent:getChildByName("num_desc_02")
    local uiOneCost = uiIconParent:getChildByName("num_desc_01")
    uiTenCost:setString(data.tenCost)
    uiOneCost:setString(data.normalCost)
    showShader:buttonToGray(uiLottery)
    showShader:buttonToGray(uiTenCost)
    SpecialView:registerEvent(uiTenLottery,ended,function()
        self:draw(10)
    end)
    SpecialView:registerEvent(uiLottery,ended,function()
        self:draw(data.freeCount > 0 and 0 or 1)
    end)
    SpecialView:registerEvent(self.UIRewardBack:getChildByName("btn_confirm"),ended,function()
        self:getReward()
    end)

    self.UIRewardBack:setVisible(false)
    function self:updateLotteryLab(updata)
        uiItem:getChildByName("num_info"):setString(updata.dayGoldCost)
        uiItem:getChildByName("text_desc_02"):setString(string.format(StringRes.dailyrotarytable002,updata.dayDrawTimes))
        uiIconParent:getChildByName("panel_time_bg"):getChildByName("num_time"):setString(updata.freeCount)
        local isFree = updata.freeCount>0
        uiLottery:setTitleText(isFree and StringRes.free_search_part or StringRes.activity_descript_55)
        uiTenCost:setVisible(not isFree)
        uiOneCost:setVisible(not isFree)
        SpecialView:setEnabled(uiLottery,not self.IsDrawing)
        SpecialView:setEnabled(uiTenLottery,not (self.IsDrawing or isFree))
    end
    self:updateLotteryLab(data)
    self:initRewardList(data.gifts)
end

--抽奖表现
function DailyWheelView:drawEffect(pos)
    local timeTable = gernerateTable(pos)
    local time = 0
    local curPos = 0
    self.IsDrawing = true
    self.CurDrawPos = pos
    self.CurDrawingTh = self.CurDrawingTh + 1

    -- 下一步处理
    local function nextHandle()
        curPos = curPos + 1
        self.UISelected:retain()
        self.UISelected:removeFromParent()
        self.UISelected:setPosition(0,0)
        local ui_item = self.Labels[1]:getChildByName("panel_item_bg"):getChildByName(string.format("icon_item_%02d",((curPos-1)%12+1)))
        ui_item:addChild(self.UISelected)
        self.UISelected:release()
    end

    nextHandle()
    timeKey = Scheduler:scheduleScriptFunc(function()
        time = time + 0.05
        local posTime = timeTable[curPos]
        if time > posTime-0.001 and time < posTime + 0.001 then
            if curPos >= #timeTable then
                endTime()
                self.IsDrawing = false
                self:setRewardInfo(pos)
                return
            end
            nextHandle()
        end
    end,0.05,false)
end

--抽奖
function DailyWheelView:draw(count)
    local ownGold = PlayerData:getInstanse().basicData.gold
    local spendGold = (count == 10) and self.LotteryData.tenCost or count*self.LotteryData.normalCost
    if ownGold < spendGold then
        PromptView:goldUnenought(spendGold,ownGold)
    else
        self.CurDrawingTh = 0
        local msg = {aType=self.ActivityId ,type=(count>1) and 2 or 1}
        Connect:sendMsg("EveryDayRouletteAction","draw",msg,function(newMsg)
            self.LotteryData.freeCount = newMsg.freeCount or 0
            self.LotteryData.dayGoldCost = newMsg.dayGoldCost
            self.LotteryData.dayDrawTimes = newMsg.dayDrawTimes
            self.LotteryData.daySupplies = newMsg.daySupplies
            self.LotteryData.dayRewardState = newMsg.dayRewardState
            PlayerData:getInstanse().basicData.gold = newMsg.gold
            self.DrawListData = newMsg.rewards
            local pos = self.DrawListData[1].id
            self:drawEffect(pos)
            self:updateLotteryLab(self.LotteryData)
            self:updateSomethingLabel(self.LotteryData)
        end,true)
    end
end

--奖励的时候点击确定
function DailyWheelView:getReward()
    self.UIRewardBack:setVisible(false)
    if self.CurDrawingTh == #self.DrawListData then
        self:updateLotteryLab(self.LotteryData)
    else
        self.CurDrawingTh = self.CurDrawingTh+1
        local pos = self.DrawListData[self.CurDrawingTh].id
        self:setRewardInfo(pos)
    end
end

--奖励信息设置
function DailyWheelView:setRewardInfo(pos)
    local addThings = self.DrawListData[self.CurDrawingTh].supplies
    self.LotteryData.rankInfo.supplies = self.LotteryData.rankInfo.supplies + addThings
    self:updateMyThings(self.LotteryData.rankInfo)

    self.UIRewardBack:setVisible(true)
    local infoMsg = self.RewardsListInfo[pos]
    Common:changePic(self.UIRewardIconBack:getChildByName("icon_item"),infoMsg.icon)
    --    self.UIRewardIcon:loadTexture(infoMsg.icon,ResType)
    local uiRewardParent = self.Labels[1]:getChildByName("panel_item_bg")
    self.UIRewardBack:getChildByName("text_info"):setString(infoMsg.title..string.format(" x%d",infoMsg.count)
    ..string.format(" %s%s",StringRes.text_world00044,addThings)) --增加物资
    self.UIRewardBack:getChildByName("text_desc"):setString(infoMsg.des)
    local posx,posy = uiRewardParent:getChildByName(string.format("icon_item_%02d",pos)):getPosition()
    NodeTranslator:transMove(self.UIRewardIconBack,cc.p(posx,posy),self.RewardIconPos,function()
        end)
end

function DailyWheelView:initRewardList(rewards)
    local uiRewardParent = self.Labels[1]:getChildByName("panel_item_bg")
    local gifts = StringUtil.getRewardsData(rewards)
    self.RewardsListInfo = gifts
    local cfg = require("src/app/data/everydayroulette"..(self.ActivityId-69)) --70,71是该活动
    for index,info in ipairs(gifts) do
        info.extra = string.format(StringRes.dailyrotarytable014,cfg[index].minThing,cfg[index].maxThing)
        local uiItem = uiRewardParent:getChildByName(string.format("icon_item_%02d",index))
        local uiName = uiItem:getChildByName(string.format("text_desc_%02d",index))
        Common:changePic(uiItem,info.icon)
        uiName:setString("x "..info.count)
        SpecialView:registerEvent(uiItem,ended,function()
            require("app/views/activity/ItemDetail"):show(self,info)
        end)
    end
end

------------------------------------------------------------------------------------------------------------------------
--第二个标签（物资奖励）
function DailyWheelView:initSomethingLabel(data)
    local uiLabelParent = self.Labels[2]
    local uiTitleback = uiLabelParent:getChildByName("panel_title_bg"):getChildByName("loadingbar_bg")
    local uiThingScale = uiTitleback:getChildByName("loadingbar_force")
    local uiThingScaleText = uiTitleback:getChildByName("num_info")

    local uiItemBack = uiLabelParent:getChildByName("panel_desc_bg")
    local rewards = StringUtil.getRewardsData(data.dayRewards)
    for index, info in ipairs(rewards) do
        local uiItem = uiItemBack:getChildByName("panel_item_0"..index)
        local uiIcon = uiItem:getChildByName("icon_item")
        local uiName = uiItem:getChildByName("text_name")
        local uiCount = uiItem:getChildByName("num_info")
        Common:changePic(uiIcon,info.icon)
        uiName:setString(info.title)
        uiCount:setString(info.count)
    end

    local uiCondition = uiItemBack:getChildByName("text_01")
    local uiWarning = uiItemBack:getChildByName("text_02")
    local uiGetReward = uiItemBack:getChildByName("btn_get")
    uiCondition:setString(StringRes.dailyrotarytable005)
    uiWarning:setString(StringRes.dailyrotarytable006)
    SpecialView:registerEvent(uiGetReward,ended,function()
        self:getSomethingReweard()
    end)
    function self:updateSomethingLabel(updata)
        local maxThing = updata.daySuppliesMax
        uiThingScale:setPercent(100*updata.daySupplies/maxThing)
        uiThingScaleText:setString(updata.daySupplies.."/"..maxThing)
        SpecialView:setEnabled( uiGetReward,updata.dayRewardState==1 and updata.daySupplies >= maxThing)
    end

    function self:getSomethingReweard()
        Connect:sendMsg("EveryDayRouletteAction","getDayReward",{aType=self.ActivityId},function(newMsg)
            if newMsg.state == 1 then
                data.dayRewardState = 2
                FlyWordPrompt:prompt(StringRes.pull_pa_gain..StringUtil.getRewardString(self.LotteryData.dayRewards))
                SpecialView:setEnabled( uiGetReward,false)
            end
        end)
    end

    self:updateSomethingLabel(data)
end

-------------------------------------------------------------------------------------------------------------------------


-------------------------------------------------------------------------------------------------------------------------
--初始化第三个标签排行榜
function DailyWheelView:initRankLabel(data)
    local uiRankParent = self.Labels[3]
    local uiTitleBack = uiRankParent:getChildByName("panel_title_bg")
    local uiCurThings = uiTitleBack:getChildByName("text_desc_01")
    local uiCondition = uiTitleBack:getChildByName("text_desc_02")
    local uiPromptBtn = uiTitleBack:getChildByName("btn_info")
    uiCondition:setString(string.format(StringRes.dailyrotarytable008,200))

    local uiRankingBack = uiRankParent:getChildByName("panel_ranking_bg")
    local uiList = uiRankingBack:getChildByName("listview_desc")
    local uiItem = uiRankingBack:getChildByName("panel_player_bg")
    local uiGetReward = uiRankingBack:getChildByName("btn_get")

    SpecialView:registerEvent(uiGetReward,ended,function()
        Connect:sendMsg("EveryDayRouletteAction","getRankReward",{aType=self.ActivityId},function(newMsg)
            if newMsg.state == 1 then
                data.getRankReward = 2
                self:updateRankReward()
                FlyWordPrompt:prompt(StringRes.pull_pa_gain..StringUtil.getRewardString(newMsg.gift))
            end
        end,true)
    end)
    SpecialView:registerEvent(uiPromptBtn,ended,function()
        require("src/app/views/prompt/DescriptView"):open(self,StringTemp:Descript(StringRes.dailyrotarytable009))
    end)

    function self:updateRankReward()
        SpecialView:setEnabled(uiGetReward,data.rankRewardState == 1)
    end

    function self:setRankingItem(uiInfoItem,info)
        local uiRank = uiInfoItem:getChildByName("num_ranking")
        local uiName = uiInfoItem:getChildByName("text_name")
        local uiLevel = uiInfoItem:getChildByName("num_grade")
        local uiFight = uiInfoItem:getChildByName("num_fight")
        local uiThing = uiInfoItem:getChildByName("num_goods")
        local uiRankIcon = uiInfoItem:getChildByName("icon_medal")
        local icon = gRankListIcon[info.rank]
        if icon then
            uiRankIcon:setVisible(true)
            uiRank:setVisible(false)
            Common:changePic(uiRankIcon,icon)
        else
            uiRankIcon:setVisible(false)
            uiRank:setVisible(true)
            uiRank:setString((info.rank > 10 or info.rank<0) and "10+" or info.rank)
        end
        uiName:setString(info.playerName)
        uiLevel:setString(info.lv)
        uiFight:setString(info.combat)
        uiThing:setString(info.supplies)
    end

    function self:updateRankingList(rankData)
        uiList:removeAllChildren()
        --table.sort() --排序
        table.insert(rankData.ranks,1,rankData.rankInfo)

        for index,info in ipairs(rankData.ranks) do
            local uiInfoItem = uiItem:clone()
            self:setRankingItem(uiInfoItem:getChildByName("panel_player"),info)
            uiList:pushBackCustomItem(uiInfoItem)
        end
        table.remove(rankData.ranks,1)
    end

    function self:updateMyThings(mydata)
        uiCurThings:setString(string.format(StringRes.dailyrotarytable007,mydata.supplies))
        local uiItem = uiList:getItem(0)
        uiItem:getChildByName("panel_player"):getChildByName("num_goods"):setString(mydata.supplies)
    end

    self:updateRankReward()
    self:updateRankingList(data)
    self:updateMyThings(data.rankInfo)
end





--------------------------------------------------------------------------------------------------------------------------
function DailyWheelView:open(parent,time,activityId)
    Connect:sendMsg("EveryDayRouletteAction","open",{aType=activityId},function(newMsg)
--        newMsg.time = time
        local newPage = self.new(parent,newMsg,activityId)
        parent:addChild(newPage)
    end,true)
    
end

--重构关闭方法
function DailyWheelView:close()
    if self.IsDrawing then
        endTime()
        self.IsDrawing = false
        self:setRewardInfo(self.CurDrawPos)
    else
        self:removeFromParent()
    end
end

return DailyWheelView
--endregion
