
---------------------------
--军资派送
---------------------------
local Scheduler = cc.Director:getInstance():getScheduler()
local timeKey = nil
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

--时间终止
local function endTime()
    if timeKey then
        Scheduler:unscheduleScriptEntry(timeKey)
        timeKey = nil
    end
end

--获取道具信息
local function getInfoMsg(id,type,count)
    local re = {count = count,id=id,type=type}
    local funcs = {
        [1] = function()
            local m = gItem[id]
            re.name = StringRes[m.name]
            re.des = StringRes[m.desc]
            re.icon = m.icon
        end,
        [2] = function()
            local m = Tank[id]
            re.name = StringRes[m.name]
            re.icon = m.icon
            re.titleColor =  Common:getUnitTitleColor(m)
            re.des = string.format(StringRes[m.dec],m.load)
            re.title = StringRes[m.name]
        end,
    }
    funcs[type]()
    return re
end

local DollarsSendView = class("DollarsSendView",function(parent)
    return PanelTabLayer.new(parent,{title=StringRes.activitydes_1,tabs={}})
end)

function DollarsSendView:ctor(parent,data)
    local fileName = "csd/mainmap_left/activity_announcement/activity/military_supplies_reward/ui_military_supplies_reward_main.csb"
    self.MainPage = CCUILoader:load(fileName)
    self:addChild(self.MainPage)

    self.UISelected = self.MainPage:getChildByName("Image_selected")
    local uiBack = self.MainPage:getChildByName("panel_bg")
    local uiHeadBack = uiBack:getChildByName("panel_map"):getChildByName("panel_title_bg")
    self.UITime = uiHeadBack:getChildByName("text_time")
    self.UIDescript = uiHeadBack:getChildByName("text_info")

    self.UIItemBack = uiBack:getChildByName("panel_item_bg")
    self.UIOnceCostCount = self.UIItemBack:getChildByName("num_coin_01")
    self.UIManyCostCount = self.UIItemBack:getChildByName("num_coin_02")
    self.UIOnceCostIcon = self.UIItemBack:getChildByName("icon_coin_01")
    self.UIManyCostIcon = self.UIItemBack:getChildByName("icon_coin_02")
    self.UIOnceDraw = self.UIItemBack:getChildByName("btn_lottery")
    self.UIFreeDraw = self.UIItemBack:getChildByName("btn_free")
    self.UIManyDraw = self.UIItemBack:getChildByName("btn_lottery_continue")
    showShader:buttonToGray(self.UIOnceDraw)
    showShader:buttonToGray(self.UIFreeDraw)
    showShader:buttonToGray(self.UIManyDraw)

    self.UIRewardBack = uiBack:getChildByName("panel_item")
    self.UIRewardIconBack = self.UIRewardBack:getChildByName("panel_item_desc")
    self.UIRewardIcon = self.UIRewardIconBack:getChildByName("icon_item")
    self.UIRewardName = self.UIRewardBack:getChildByName("text_info")
    self.UIRewardDesc = self.UIRewardBack:getChildByName("text_desc")
    self.UIRewardOk = self.UIRewardBack:getChildByName("btn_confirm")

    self.UIOnceDraw:addTouchEventListener(eventListner(ended,function()
            self:draw(1)
        end))
    self.UIFreeDraw:addTouchEventListener(eventListner(ended,function()
            self:draw(0)
        end))
    self.UIManyDraw:addTouchEventListener(eventListner(ended,function()
            self:draw(10)
        end))
    self.UIRewardOk:addTouchEventListener(eventListner(ended,function()
            self:getReward()
        end))

    local function onNodeEvent(tag)
        if tag == "exit" then
            endTime()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    self.endPos = cc.p(self.UIRewardIconBack:getPosition())
    self.IsDrawing = false --正在抽奖
    self.CurDrawingTh = 0 --当前正在进行的抽奖代号
    self.DrawListData = {} --抽奖获取到的东西编号列表

    self:initData(data)
    self.UIRewardBack:setVisible(false)
end

--初始化数据
function DollarsSendView:initData(data)
    self.Data = data

    local itemList = {}
--    local items = StringTemp:toReward(data.resource)
    for index,info in ipairs(data.gifts) do
        itemList[info.id] = getInfoMsg(info.baseId,info.type,info.num)
    end
    self.ItemList = itemList

    self:initHead(data)
    self:initItemList()
    self:updateOther()
end

--奖励信息设置
function DollarsSendView:setRewardInfo(pos)
    self.UIRewardBack:setVisible(true)
    local infoMsg = self.ItemList[pos]
    Common:changePic(self.UIRewardIcon,infoMsg.icon)
    --    self.UIRewardIcon:loadTexture(infoMsg.icon,ResType)
    self.UIRewardName:setString(infoMsg.name..string.format(" x%d",infoMsg.count))
    self.UIRewardDesc:setString(infoMsg.des)
    local posx,posy = self.UIItemBack:getChildByName("icon_item_"..pos):getPosition()
    NodeTranslator:transMove(self.UIRewardIconBack,cc.p(posx,posy),self.endPos,function()
        end)
end

--初始化道具列表
function DollarsSendView:initItemList()
    local list = self.ItemList
    for index = 1 , 10 do
        local ui_item = self.UIItemBack:getChildByName("icon_item_"..index)
        local ui_count = ui_item:getChildByName("text_desc")
        local info = list[index]
        Common:changePic(ui_item,info.icon)
        ui_count:setString(string.format("x %d",info.count))
        local funcs = {
            [1] = function()
                ItemInfo:show(self,1,info.id,info.count)
            end,
            [2] = function()
                require("app/views/activity/ItemDetail"):show(gWorldScene,info)
            end
        }
        ui_item:addTouchEventListener(eventListner(ended,funcs[info.type]))
    end
end

--初始化ui上部分
function DollarsSendView:initHead(data)
    self.UITime:setString(string.format("%s~%s",
        StringTemp:serverTimetoDate(data.beginTime),StringTemp:serverTimetoDate(data.endTime)))
    self.UIDescript:setString(StringRes.tdes_1)
end

--刷新除了道具和ui上部分的内容
function DollarsSendView:updateOther()
    local data = self.Data
    local isFree = data.free > 0
    local visible,enable1,enable2 = true,true,true
    if self.IsDrawing then --
        visible,enable1,enable2 = false,false,false
    elseif isFree then
        visible,enable2 = false,false
    end
    if visible then
        local playerInfo = PlayerData:getInstanse().basicData
        self.UIOnceCostCount:setString(data.normalCost)
        self.UIManyCostCount:setString(data.tenCost)
        self.UIOnceCostCount:setColor(
            (playerInfo.gold<data.normalCost) and CommonColor.Red or CommonColor.White)
        self.UIManyCostCount:setColor(
            (playerInfo.gold<data.tenCost) and CommonColor.Red or CommonColor.White)
    end
    self.UIOnceCostCount:setVisible(visible)
    self.UIOnceCostIcon:setVisible(visible)
    self.UIManyCostIcon:setVisible(visible)
    self.UIManyCostCount:setVisible(visible)
    SpecialView:setEnabled(self.UIOnceDraw,enable1)
    SpecialView:setEnabled(self.UIFreeDraw,enable1)
    SpecialView:setEnabled(self.UIManyDraw,enable2)
    self.UIOnceDraw:setVisible(not isFree)
    self.UIFreeDraw:setVisible(isFree)
end

--生成时间轴
local function gernerateTable(pos)
    local _t = {}
    local cfg = {0.05*3,0.05*3,0.05*2,0.05*2,0.05*2,0.05*1,0.05*1,0.05*1,0.05*1,0.05*1}
    local time = 0
    local max = (#cfg)*2+pos
    for i = 1,max do
        local add = cfg[#cfg]
        if cfg[i] then
            add = cfg[i]
        elseif cfg[max-i+1] then
            add = cfg[max-i+1]
        end
        time = time + add
        _t[i] = time
    end
    return _t
end

--抽奖
function DollarsSendView:draw(count)
    local ownGold = PlayerData:getInstanse().basicData.gold
    local spendGold = (count == 10) and self.Data.tenCost or count*self.Data.normalCost
    if ownGold < spendGold then
        PromptView:goldUnenought(spendGold,ownGold)
    else
        self.CurDrawingTh = 0
        local msg = {atype=self.Data.activityId ,type=(count>1) and 2 or 1}
        Connect:sendMsg("MilitarySupplyAction","draw",msg,function(newMsg)
            self.Data.free = newMsg.free or 0
            PlayerData:getInstanse().basicData.gold = newMsg.gold
            self.DrawListData = newMsg.ids
            local pos = self.DrawListData[1]
            self:drawEffect(pos)
            self:updateOther()
        end,true)
    end
end

--抽奖表现
function DollarsSendView:drawEffect(pos)
    local timeTable = gernerateTable(pos)
    local time = 0
    local curPos = 0
    self.IsDrawing = true
    self.CurDrawPos = pos
    self.CurDrawingTh = self.CurDrawingTh + 1

    -- 下一步处理
    local function nextHandle()
        curPos = curPos + 1
        self.UISelected:retain()
        self.UISelected:removeFromParent()
        self.UISelected:setPosition(0,0)
        local ui_item = self.UIItemBack:getChildByName("icon_item_"..((curPos-1)%10+1))
        ui_item:addChild(self.UISelected)
        self.UISelected:release()
    end

    nextHandle()
    timeKey = Scheduler:scheduleScriptFunc(function()
        time = time + 0.05
        local posTime = timeTable[curPos]
        if time > posTime-0.001 and time < posTime + 0.001 then
            if curPos >= #timeTable then
                endTime()
                self.IsDrawing = false
                self:setRewardInfo(pos)
                return
            end
            nextHandle()
        end
    end,0.05,false)
end

--奖励的时候点击确定
function DollarsSendView:getReward()
    self.UIRewardBack:setVisible(false)
    if self.CurDrawingTh == #self.DrawListData then
        self:updateOther()
    else
        self.CurDrawingTh = self.CurDrawingTh+1
        local pos = self.DrawListData[self.CurDrawingTh]
        self:setRewardInfo(pos)
    end
end

function DollarsSendView:open(parent,data)
    Connect:sendMsg("MilitarySupplyAction","open",{atype=data},function(newMsg)
        newMsg.activityId = data
        local newPage = self.new(parent,newMsg)
        parent:addChild(newPage)
    end,true)
end

--重构关闭方法
function DollarsSendView:close()
    if self.IsDrawing then
        endTime()
        self.IsDrawing = false
        self:setRewardInfo(self.CurDrawPos)
    else
        self:removeFromParent()
    end
end

return DollarsSendView
