
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local ExchangeView = class("ExchangeView",function() 
    return display.newLayer()
end)

function ExchangeView:ctor(parent,data)
    self.MainPage = CCUILoader:load("csd/exchange/ui_exchange_main.csb")
    self:addChild(self.MainPage)
    
    local uiback = self.MainPage:getChildByName("panel_mask"):getChildByName("panel_bg")
    self.UIString = uiback:getChildByName("panel_code_bg"):getChildByName("input_code")
    self.UIExchange = uiback:getChildByName("btn_exchange")
    self.UIClose = uiback:getChildByName("btn_close")
    
    self.UIClose:addTouchEventListener(eventListner(ended,function() 
            self:close()
        end))
    self.UIExchange:addTouchEventListener(eventListner(ended,function() 
        self:exchange()
    end))
end

function ExchangeView:exchange()
    local str = self.UIString:getString()
    if str and str ~= "" then
        local msg = {code = str}
        print("调用领取礼包码")
        Connect:sendMsg("ExchangeAction","exchange",msg,function(newMsg)
            --兑换结果0兑换失败 -1兑换码不存在，-2兑换码已失效，-3已经兑换过,-4礼品码渠道不匹配,-5玩家已经领取过同类礼包
            if newMsg.code == 1 then
                FlyWordPrompt:prompt(StringRes.exchange_get_reward..StringUtil.getRewardString(newMsg.gifts))
                self:close()
            elseif newMsg.code == 0 then
                PromptView:type1(nil,StringRes.exchange_not_pipei,StringRes.ok)
            elseif newMsg.code == -1 then
                PromptView:type1(nil,StringRes.exchange_not_ok,StringRes.ok)
            elseif newMsg.code == -2 then --失效
                PromptView:type1(nil,StringRes.exchange_over_time,StringRes.ok)
            elseif newMsg.code == -3 then
                PromptView:type1(nil,StringRes.exchange_already_reward,StringRes.ok)
            elseif newMsg.code == -4 then
                PromptView:type1(nil,StringRes.exchange_not_pipei,StringRes.ok)
            elseif newMsg.code == -5 then
                PromptView:type1(nil,StringRes.you_exchanged,StringRes.ok)
            end
        end,true)
    else
        PromptView:type1(nil,StringRes.exchange_not_null,StringRes.ok)
    end
end

function ExchangeView:close()
    self:removeFromParent()
end

function ExchangeView:open(parent,data)
    local newPage = self.new(parent,data)
    parent:addChild(newPage)
end

return ExchangeView