
local TaskInfo = require("src/app/views/task/TaskInfo")
local cjson = require("cjson")
local UserDefault = cc.UserDefault:getInstance()
local Scheduler = cc.Director:getInstance():getScheduler()


local myActivityId = 6


local FightingCompetitionActivity = class("FightingCompetitionActivity",function(scene)
    return PanelTabLayer.new(scene,{title=gActivity[myActivityId].name,tabs={StringRes.new_activity_dd1,StringRes.ranking_list}})
end)










function FightingCompetitionActivity:ctor(scene)
    
    
    
    self.page = cc.uiload:load("res/csd/mainmap_left/activity_announcement/activity/fighting_competition/ui_fighting_competition_main.csb")
    self:addChild(self.page)
    
    
    
    self.info = self.page:getChildByName("panel_item") -- 活动
    self.rank = self.page:getChildByName("panel_ranking") --每日活动
    
    
    Connect:sendMsg("RankActivityAction","openCombatRank",nil,
        function(data)
            local pd = PlayerData:getInstanse()
            --更新数据
            self.data = data

            self:freshRank()
            self:initTabs()

        end)
    
    
    
end

function FightingCompetitionActivity:resetContent()
    if self.info then self.info:setVisible(false) end
    if self.rank then self.rank:setVisible(false) end
end

function FightingCompetitionActivity:ViewPage(page)
    if self.info then self.info:setVisible(false) end
    if self.rank then self.rank:setVisible(false) end

    page:setVisible(true)
end


--跳转
function FightingCompetitionActivity:gotoHere(dest)
    if TaskInfo:StaticGotoHere(dest) then
        self:getParent():removeFromParent()
        --self:removeFromParent()
    end
end



--获取道具名字
function FightingCompetitionActivity:getItemStr(gift)
    --local str = StringRes.new_server_combat2.." "
    local str = ""
    for key, var in pairs(gift) do
        --奖励类型 1背包道具 2战斗单位 3声望  4金币 5配件
        if var.type == 1 then
            str = str..StringRes[gItem[var.baseId].name].."x"..var.num
        elseif var.type == 2 then
            str = str..StringRes[Tank[var.baseId].name].."x"..var.num
        elseif var.type == 3 then
            str = str..StringRes.prestige.."x"..var.num
        elseif var.type == 4 then
            str = str..StringRes.coin.."x"..var.num
        elseif var.type == 5 then
            str = str..parts[var.baseId].name.."x"..var.num
        elseif var.type == 6 then
            str = str..StringRes.rank_title_3.."x"..var.num
    	end
    end
    return str
    
end

----获取图标路径
--function FightingCompetitionActivity:getItemOneIcon(var)
--    --local str = StringRes.new_server_combat2.." "
--    local str = ""
--    if true then
--        --奖励类型 1背包道具 2战斗单位 3声望  4金币 5配件
--        if var.type == 1 then
--            str = gItem[var.baseId].icon
--        elseif var.type == 2 then
--            str = Tank[var.baseId].icon
--        elseif var.type == 3 then
--            str = ResIconCfg.prestige
--        elseif var.type == 4 then
--            str = ResIconCfg.gold
--        elseif var.type == 5 then
--            str = parts[var.baseId].icon
--        end
--    end
--    return str
--
--end






--刷新战力比拼信息
function FightingCompetitionActivity:freshInfo()
    local list = self.info:getChildByName("listview_item")
    list:removeAllItems()
    
    --活动时间
    local timeItem = self.info:getChildByName("panel_time"):clone()
    timeItem:getChildByName("num_time"):setString(self.data.beginTime.."-"..self.data.endTime )
    list:pushBackCustomItem(timeItem)
    
    --活动说明
    local desItem = self.info:getChildByName("panel_rule"):clone()
    desItem:getChildByName("text_desc"):setString(gActivity[myActivityId].desc)
    list:pushBackCustomItem(desItem)
    
    
    --奖励排行
    local rewardItem = self.info:getChildByName("panel_reward"):clone()
    
    
    local rewardStr = {}

    for key, var in pairs(self.data.gifts) do
        local rankStr = ""
        if var.rankmin == var.rankmax then
            rankStr = tostring(var.rankmin)
        else
            rankStr = tostring(var.rankmin).."-"..tostring(var.rankmax)
        end
        rankStr = string.format(StringRes.new_activity_dd2,rankStr)
        
        rankStr = rankStr..":  "..FightingCompetitionActivity:getItemStr(var.gifts)
        rewardStr[key] = {{}}
        rewardStr[key][1].str = rankStr
        rewardStr[key][1].color = CommonColor.White
        rewardStr[key][1].size = 24
    end
    SpecialView:addRichText(rewardItem:getChildByName("text_desc"),rewardStr,1)
    
    --rewardItem:getChildByName("text_desc"):setString("fdsfadasfds")
    list:pushBackCustomItem(rewardItem)
    
    --标题
    local titleItem = self.info:getChildByName("panel_title"):clone()
    list:pushBackCustomItem(titleItem)
    
    --32930
    for key, var in pairs(gZldbp) do
        local item = self.info:getChildByName("panel_method"):clone()
        list:pushBackCustomItem(item)
        item:getChildByName("text_desc"):setString(var.desc)
        
        
        item:getChildByName("btn_upgrade"):setTitleText(var.name)
        --
        
        item:getChildByName("btn_upgrade"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                
                self:gotoHere({gotothere = var.jump,jumptip = var.jumptip})
                
            end
        end)
        
        
        
    end
    
    
    --领奖按钮
    local getbtn = self.info:getChildByName("btn_upgrade_Copy")
    showShader:buttonToGray(getbtn)
    if self.data.type == 1 then
        Common:setBtnTouchEnable(getbtn,false)
    else
        --setTitleText
        if self.data.info.isget == 0 then
            --FlyWordPrompt:prompt(StringRes.new_server_combat1)
            Common:setBtnTouchEnable(getbtn,true)
            getbtn:setTitleText(StringRes.new_server_combat6)
            
            timeItem:getChildByName("num_time"):setString( StringRes.new_server_combat1)
            timeItem:getChildByName("num_time"):setColor(CommonColor.Red)
        elseif self.data.info.isget == 1 then
            Common:setBtnTouchEnable(getbtn,true)
            getbtn:setTitleText(StringRes.new_server_combat6)
            timeItem:getChildByName("num_time"):setString( StringRes.new_server_combat5)
            timeItem:getChildByName("num_time"):setColor(CommonColor.Red)
        elseif self.data.info.isget == 2 then
            Common:setBtnTouchEnable(getbtn,false)
            getbtn:setTitleText(StringRes.new_server_combat3)
            timeItem:getChildByName("num_time"):setString( StringRes.new_server_combat5)
            timeItem:getChildByName("num_time"):setColor(CommonColor.Red)
        end
    
        
    end
    getbtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self.data.info.isget == 0 then
                FlyWordPrompt:prompt(StringRes.new_server_combat1)
            else
                Connect:sendMsg("RankActivityAction","getCombatRankGift",nil,
                    function(data)
                        local pd = PlayerData:getInstanse()
                        --更新数据
                        
                        if data.state == 1 then
                            
                            --处理提示
                            local str = StringRes.new_server_combat2.." "..FightingCompetitionActivity:getItemStr(data.gift)
                            FlyWordPrompt:prompt(str)
                            --已领取标志
                            self.data.info.isget = 2
                            
                            --刷新
                            self:freshInfo()
                            
                            --
                            local pd = PlayerData:getInstanse()
                            --更新数据
                            pd.basicData.gold = data.gold
                        end
                        
                        
                    end)
            end
           

        end
    end)
end



--刷新排行榜
function FightingCompetitionActivity:freshRank()
    local list = self.rank:getChildByName("listview_ranking")
    list:removeAllItems()
    
    local function rank(num)
    	if num <= 0 then
    		return "30+"
    	else
    	   return tostring(num)
    	end
    end
    
    local function guidName(name)
        if name == "" then
            return StringRes.null
        else
            return name
        end
    end
    
    
    --自己
    local myitem = self.rank:getChildByName("panel_honor_player"):clone()
    myitem:getChildByName("panel_bg"):getChildByName("text_ranking"):setString( rank(self.data.info.rownum) )
    --名字
    myitem:getChildByName("panel_bg"):getChildByName("text_name"):setString( self.data.info.name )
    --等级
    myitem:getChildByName("panel_bg"):getChildByName("text_lev"):setString( StringTemp:toNum(self.data.info.num) )
    --值
    myitem:getChildByName("panel_bg"):getChildByName("text_army"):setString( guidName(self.data.info.guildName) )
    list:pushBackCustomItem(myitem)
    
    
    for var=1, 30 do

        if self.data.rank[var] == nil then
            break
        end

        local item = nil
        --自己
        if var == 1 then
            item = self.rank:getChildByName("panel_honor_1st"):clone()
        elseif var == 2 then
            item = self.rank:getChildByName("panel_honor_2nd"):clone()
        elseif var == 3 then
            item = self.rank:getChildByName("panel_honor_3rd"):clone()
        else
            item = self.rank:getChildByName("panel_honor_other"):clone()
            item:getChildByName("panel_bg"):getChildByName("text_ranking"):setString( self.data.rank[var].rownum )
        end

        --名字
        item:getChildByName("panel_bg"):getChildByName("text_name"):setString( self.data.rank[var].name )
        --等级
        item:getChildByName("panel_bg"):getChildByName("text_lev"):setString( StringTemp:toNum(self.data.rank[var].num) )
        --值
        item:getChildByName("panel_bg"):getChildByName("text_army"):setString( guidName(self.data.rank[var].guildName) )

        list:pushBackCustomItem(item)
    end
    
    
    
    --差距
    local head = self.rank:getChildByName("panel_head")
    head:getChildByName("text_desc"):setString(string.format(StringRes.new_server_combat7 ,StringTemp:toNum(self.data.rank[1].num-self.data.info.num)) )
    
end



function FightingCompetitionActivity:initTabs()
    self:registerTabEvent(1,function()
        
        self:freshInfo()
        self:ViewPage(self.info)
    end)
    self:registerTabEvent(2,function()
        
        --self:FreshSkill()
        self:ViewPage(self.rank)

    end)
    self:setTabSelect(1)
end

return FightingCompetitionActivity