
local GoldTank = class("GoldTank",function(scene,data)
    return CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/gold_tank/ui_gold_tank_main.csb")
end)



function GoldTank:show(parent)

    Connect:sendMsg("GoldTankAction","open",{},
        function(data)
            local layer = GoldTank.new(parent,data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)
end

function GoldTank:ctor(parent,data)
    self.data = data
    self.mTanks = {}
    self.isDrawing = false
    self:initView()
end

function GoldTank:initView()
    --关闭
    self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.activitydes_23)
    local close = self:getChildByName("panel_bg"):getChildByName("btn_close")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)


    local panel_main_bg = self:getChildByName("panel_main_bg")
    local panel_header = panel_main_bg:getChildByName("panel_header")

    panel_header:getChildByName("panel_desc_bg"):getChildByName("text_desc"):setString(StringRes.activity_descript_63)
    --信息
    panel_header:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(string.format(StringRes.activity_descript_65,StringRes[Tank[self.data.tanks[1].templateId].name],StringRes[Tank[self.data.tanks[2].templateId].name])))
        end
    end)

    panel_header:getChildByName("text_time"):setString(string.format(StringRes.act_timeFormat,self.data.startTime,self.data.endTime))

    self.panel_tank_bg = panel_main_bg:getChildByName("panel_tank_bg")
    self:setLeftTank()
    self:setRightTank()

    local icon_loadingbar_01 = self.panel_tank_bg:getChildByName("icon_loadingbar_01")
    self.loadingbar_01 = icon_loadingbar_01:getChildByName("loadingbar_01")
    self.num_desc_01 = icon_loadingbar_01:getChildByName("num_desc_01")
    local icon_loadingbar_02 = self.panel_tank_bg:getChildByName("icon_loadingbar_02")
    self.loadingbar_02 = icon_loadingbar_02:getChildByName("loadingbar_02")
    self.num_desc_02 = icon_loadingbar_02:getChildByName("num_desc_02")
    self.btn_assembly_01 = self.panel_tank_bg:getChildByName("btn_assembly_01")
    self.btn_assembly_02 = self.panel_tank_bg:getChildByName("btn_assembly_02")
    showShader:buttonToGray(self.btn_assembly_01)
    showShader:buttonToGray(self.btn_assembly_02)
    self.btn_assembly_01:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:install(self.data.tanks[1].id)
        end
    end)
    self.btn_assembly_02:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:install(self.data.tanks[2].id)
        end
    end)

    local panel_lottery_bg = panel_main_bg:getChildByName("panel_lottery_bg")
    Common:changePic(panel_lottery_bg:getChildByName("panel_vip"):getChildByName("icon_vip"),"pic/vip/icon/icon_vip_"..PlayerData:getInstanse().basicData.vipLv..".png")

    panel_lottery_bg:getChildByName("text_num_01"):setString(self.data.drawCost)
    panel_lottery_bg:getChildByName("text_num_02"):setString(self.data.cDrawCost)

    self.btn_0 = panel_lottery_bg:getChildByName("btn_free")
    self.btn_1 = panel_lottery_bg:getChildByName("btn_item")
    self.btn_10 = panel_lottery_bg:getChildByName("btn_10_continue")
    self.gold_text_num_01 = panel_lottery_bg:getChildByName("text_num_01")
    self.gold_icon_coin_01 = panel_lottery_bg:getChildByName("icon_coin_01")
    showShader:buttonToGray(self.btn_0)
    showShader:buttonToGray(self.btn_1)
    showShader:buttonToGray(self.btn_10)
    self.btn_0:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:draw(0)
        end
    end)
    self.btn_1:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:draw(1)
        end
    end)
    self.btn_10:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:draw(10)
        end
    end)

    self:updateView()

end

--抽奖
function GoldTank:draw(count)
    local ownGold = PlayerData:getInstanse().basicData.gold
    local spendGold = (count == 10) and self.data.cDrawCost or count*self.data.drawCost
    if ownGold < spendGold then
        PromptView:goldUnenought(spendGold,ownGold)
    else
        if count == 0  then
            count = 1
        elseif count == 10 then
            count = 2
        end
        local msg = {type=count}
        Connect:sendMsg("GoldTankAction","draw",msg,function(newMsg)
            self.data.freeTimes = newMsg.freeTimes or 0
            PlayerData:getInstanse().basicData.gold = newMsg.gold
            self.data.tanks = newMsg.tanks

            self.rewards = newMsg.rewards
            self:showResult()
        end,true)
    end
end

local TIME_TO_DELAY = 1.2

function GoldTank:showResult()
    local index  = 0
    self.isDrawing = true
    self:updateBtn()
    function show(dt)
        index = index +1
        if index > #self.rewards then
            self.isDrawing = false
            self:updateBtn()
            self:updateView()
            return
        end
        local tmp = self.rewards[index]
        local str = StringRes.exchange_get_reward..":"
        if tmp.rewardType == 1 then
            str = str..StringRes[gItem[tmp.baseId].name].."x"..tmp.num
        elseif tmp.rewardType == 15 then
            str = str..string.format(StringRes.activity_descript_64,StringRes[Tank[tmp.baseId].name]).."x"..tmp.num
            self:updateForAct(tmp.baseId,tmp.num)
        end
        FlyWordPrompt:prompt(str)
        self:runAction(cc.Sequence:create(cc.DelayTime:create(TIME_TO_DELAY),cc.CallFunc:create(show)))
    end
    show(0)
end


function GoldTank:updateForAct(id,count)
    local tmp = self.mTanks[id]
    tmp.nowPiece = tmp.nowPiece+count

    tmp.moveIcon:setVisible(true)
    tmp.moveIcon:runAction(cc.Sequence:create(cc.MoveTo:create(0.5,tmp.moveEndPos),cc.CallFunc:create(function(dt)
        tmp.moveIcon:setVisible(false)
        tmp.moveIcon:setPosition(tmp.moveBeginPos)
        tmp.loadingbar:setPercent(tmp.nowPiece/tmp.maxPiece*100)
        tmp.num_desc:setString(tmp.nowPiece.."/"..tmp.maxPiece)
    end)))

end

--组装
function GoldTank:install(tmpid)
    local msg = {id=tmpid}
    Connect:sendMsg("GoldTankAction","install",msg,function(data)
        if data.state == 1 then
            self.data.tanks[data.id].nowPiece = data.nowPiece
            self:updateView()
            local tmp = {}
            tmp.count = data.num
            tmp.templateId = data.templateId
            tmp.type = 2
            local tab = {}
            table.insert(tab,tmp)
            local str = StringRes.exchange_get_reward..":"..ActUtils:getItemStrLifei(tab)
            FlyWordPrompt:prompt(str)
        end
    end,true)
end

function GoldTank:setTankLv(lv,data,flip)
    flip = flip or 1
    local text_name = lv:getChildByName("text_name")
    text_name:setString(StringRes[data.name])
    Common:setUnitTitleColor(text_name,data)
    --    SpecialView:addRichText(text_name,StringTemp:Descript(StringRes[data.name],text_name:getFontSize()),0)
    local panel_tank = lv:getChildByName("panel_tank")
    local icon_tank = panel_tank:getChildByName("icon_tank")
    Common:changePic(icon_tank,data.pic)
    local scale = panel_tank:getContentSize().height/icon_tank:getContentSize().height
    icon_tank:setScaleX(flip*scale)
    icon_tank:setScaleY(scale)
    local text_desc = lv:getChildByName("text_desc")
    text_desc:setString("")
    SpecialView:addRichText(text_desc,StringTemp:Descript(string.format(StringRes[data.dec],data.load),text_desc:getFontSize()),0)
end

function GoldTank:setLeftTank()
    local sData = self.data.tanks[1]
    local tmpInfo = Tank[sData.templateId]
    self:setTankLv(self.panel_tank_bg:getChildByName("listview_L"),tmpInfo,-1)
    self.panel_tank_bg:getChildByName("text_item_01"):setString(string.format(StringRes.activity_descript_64,StringRes[tmpInfo.name]))
end

function GoldTank:initData()
    self.mTanks = {}
    for i,v in ipairs(self.data.tanks) do
        v.moveIcon = self.panel_tank_bg:getChildByName("icon_item_0"..i.."_move")
        v.moveBeginPos = {x = v.moveIcon:getPositionX(),y= v.moveIcon:getPositionY()}
        local endNode = self.panel_tank_bg:getChildByName("icon_item_0"..i)
        v.moveEndPos = {x = endNode:getPositionX(),y= endNode:getPositionY()}
        v.moveIcon:setVisible(false)
        v.loadingbar = self["loadingbar_0"..i]
        v.num_desc = self["num_desc_0"..i]
        self.mTanks[v.templateId] = v
    end
end

function GoldTank:setRightTank()
    local sData = self.data.tanks[2]
    local tmpInfo = Tank[sData.templateId]
    self:setTankLv(self.panel_tank_bg:getChildByName("listview_R"),tmpInfo)
    self.panel_tank_bg:getChildByName("text_item_02"):setString(string.format(StringRes.activity_descript_64,StringRes[tmpInfo.name]))
end

function GoldTank:updateView()
    local enable = self.data.freeTimes and self.data.freeTimes > 0
    self.btn_0:setVisible(enable)
    self.btn_1:setVisible(not enable)
    self.gold_text_num_01:setVisible(not enable)
    self.gold_icon_coin_01:setVisible(not enable)

    local sData1 = self.data.tanks[1]
    self.loadingbar_01:setPercent(sData1.nowPiece/sData1.maxPiece*100)
    self.num_desc_01:setString(sData1.nowPiece.."/"..sData1.maxPiece)
    local sData2 = self.data.tanks[2]
    self.loadingbar_02:setPercent(sData2.nowPiece/sData2.maxPiece*100)
    self.num_desc_02:setString(sData2.nowPiece.."/"..sData2.maxPiece)


    Common:setBtnTouchEnable(self.btn_assembly_01,sData1.nowPiece>=sData1.maxPiece)
    Common:setBtnTouchEnable(self.btn_assembly_02,sData2.nowPiece>=sData2.maxPiece)
    self:initData()
end

function GoldTank:updateBtn()
    local enable = not self.isDrawing
    self.btn_0:setEnabled(enable)
    self.btn_1:setEnabled(enable)
    self.btn_10:setEnabled(enable)
    self.btn_assembly_01:setEnabled(enable)
    self.btn_assembly_02:setEnabled(enable)
end

function GoldTank:close()
    NodeTranslator:transDown(self,function()
        self:getParent():getActivityList()
        self:removeFromParent()
    end)
end

return GoldTank