
local TaskInfo = require("src/app/views/task/TaskInfo")
local cjson = require("cjson")
local UserDefault = cc.UserDefault:getInstance()
local Scheduler = cc.Director:getInstance():getScheduler()


local myActivityId = 6


Investment_Plan = class("Investment_Plan",function(scene,time,id)
    return PanelTabLayer.new(nil,{title=gActivity[id].name,tabs={StringRes.activitydes_41,StringRes.investplan005}})
end)








local myActivityId = 5

function Investment_Plan:ctor(scene,time,id)
    
    
    self.time = time
    myActivityId = id
    self.page = cc.uiload:load("res/csd/mainmap_left/activity_announcement/activity/investment_plan/ui_investment_plan_main.csb")
    self:addChild(self.page)
    
    
    
    self.info = self.page:getChildByName("panel_tab_01") -- 活动
    self.rank = self.page:getChildByName("panel_tab_02") --每日活动
    
    local msg = {aType = myActivityId}
    Connect:sendMsg("InvestmentPlanAction","open",msg,
        function(data)
            local pd = PlayerData:getInstanse()
            --更新数据
            self.data = data

            --self:freshRank()
            self:initTabs()

        end)
    
    
    
end

function Investment_Plan:resetContent()
    if self.info then self.info:setVisible(false) end
    if self.rank then self.rank:setVisible(false) end
end

function Investment_Plan:ViewPage(page)
    if self.info then self.info:setVisible(false) end
    if self.rank then self.rank:setVisible(false) end

    page:setVisible(true)
end







--刷新战力比拼信息
function Investment_Plan:freshInfo()
    --时间
    local time = self.info:getChildByName("text_time")
    time:setString(self.time)

    --描述
    local desc = self.info:getChildByName("text_desc")
    desc:setString(StringRes.investplan001)
    
    --充值数量
    local chongzhinum = self.info:getChildByName("panel_reward"):getChildByName("num_info")
    chongzhinum:setString(self.data.investGold)
    
    --进度条
    local progress = self.info:getChildByName("panel_reward"):getChildByName("progress_bg"):getChildByName("progressbar")
    progress:setPercent(self.data.investGold/self.data.investInfos[1].needGold*100)
    
    --充值金额和奖励金额
    local list = self.info:getChildByName("panel_reward"):getChildByName("listview_reward")
    list:removeAllItems()
    
    for key, var in pairs(self.data.investInfos) do
        local item = self.info:getChildByName("panel_reward"):getChildByName("panel_reward_bg"):clone()
        list:pushBackCustomItem(item)
        
        item:getChildByName("num_info_01"):setString(var.needGold)
        item:getChildByName("num_info_02"):setString(var.rebateGold)
    	
    end
    
    
    --充值按钮
    local chongzhibtn = self.info:getChildByName("panel_reward"):getChildByName("btn_recharge")
    
    showShader:buttonToGray(chongzhibtn)
    if self.data.activityType == 0 then
        Common:setBtnTouchEnable(chongzhibtn,true)
    else
        Common:setBtnTouchEnable(chongzhibtn,false)
    end
    chongzhibtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
        
            local rec = Recharge:show(gWorldScene)
            rec:setRemoveNoticeParent(function(eventType)
                if eventType ==  "exit" then
                    local msg = {aType = myActivityId}
                    Connect:sendMsg("InvestmentPlanAction","open",msg,
                        function(data)
                            local pd = PlayerData:getInstanse()
                            --更新数据
                            self.data = data
                            self:freshInfo()
                        end)
                end
            end)
            
            
        end
    end)
    
    
    
    --关于
    local aboutbtn = self.info:getChildByName("btn_info")
    aboutbtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

           local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.investplan003))

        end
    end)

--    local list = self.info:getChildByName("listview_item")
--    list:removeAllItems()
--    
--    --活动时间
--    local timeItem = self.info:getChildByName("panel_time"):clone()
--    timeItem:getChildByName("num_time"):setString(self.data.beginTime.."-"..self.data.endTime )
--    list:pushBackCustomItem(timeItem)
    
    
end



--刷新排行榜
function Investment_Plan:freshRank()
    local list = self.rank:getChildByName("listview_item")
    list:removeAllItems()
    
    for key, var in pairs(self.data.rebates) do
        local item = self.rank:getChildByName("panel_item_bg"):clone()
        list:pushBackCustomItem(item)
        
        --天数
        item:getChildByName("text_day"):setString(string.format(StringRes.investplan002,var.day))
        
        --奖励
        item:getChildByName("text_cion"):setString(var.rebateGold..StringRes.gold)
        
        local getbtn = item:getChildByName("btn_get")
        showShader:buttonToGray(getbtn)
        if var.state == 1 then
            Common:setBtnTouchEnable(getbtn,true)
            getbtn:setTitleText(StringRes.attach)
        elseif var.state == 0 then
            Common:setBtnTouchEnable(getbtn,false)
            getbtn:setTitleText(StringRes.attach)
        elseif var.state == 2 then
            Common:setBtnTouchEnable(getbtn,false)
            getbtn:setTitleText(StringRes.already_attach)
        else
        
        end
        
        
        
        getbtn:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                local msg = {aType = myActivityId,day = var.day}
                Connect:sendMsg("InvestmentPlanAction","getRebate",msg,
                    function(data)
                        local pd = PlayerData:getInstanse()
                        --更新数据
                        if data.state == 1 then
                        	var.state = 2
                            pd.basicData.gold = data.gold
                            FlyWordPrompt:prompt(StringRes.exchange_get_reward..StringRes.gold..":"..var.rebateGold)
                            self:freshRank()
                        end
                        

                    end)

            end
        end)
    end
   
    
end



function Investment_Plan:initTabs()
    self:registerTabEvent(1,function()
        
        self:freshInfo()
        self:ViewPage(self.info)
    end)
    self:registerTabEvent(2,function()
        
        
        if self.data.activityType == 0 then
            FlyWordPrompt:prompt(StringRes.investplan004)
        else
            
        end
            self:freshRank()
            self:ViewPage(self.rank)
        

    end)
    self:setTabSelect(1)
end



return Investment_Plan