ItemDetail = class("ItemDetail",function(data)
    return CCUILoader:load("csd/common/layer_popout_item_desc.csb")
end)

--{icon = ,title = ,des = ,count = ,bg = }origional
function ItemDetail:show(parent,data)
    local layer = ItemDetail.new(data)
    parent:addChild(layer,201)
    local panel_mask = layer:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    layer.removable = false
    NodeTranslator:transZoomOut(panel_bg,function()
        layer.removable = true
    end)
    DialogUtil:addClickEvent(panel_mask,function()
        if layer.removable then
            require("src/app/util/NodeTranslator"):transZoomOut(panel_bg,function()
                layer:removeFromParent()
            end)
        end
    end)
    
end

function ItemDetail:ctor(data)
    self.data = data
    self:initView()
end

function ItemDetail:initView()
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")

    local data = self.data
    local icon_item = panel_bg:getChildByName("icon_item")
    local icon_item_origional = panel_bg:getChildByName("icon_item_origional")
    local text_item_desc = panel_bg:getChildByName("text_item_desc")
    local text_item_amount = panel_bg:getChildByName("text_item_amount")
    local text_item_info = panel_bg:getChildByName("text_item_info")
    local text_item_extra = panel_bg:getChildByName("text_item_other")
    
    if data.bg then
        local sp = ccui.ImageView:create()
        sp:setScale9Enabled(true)
        sp:setContentSize(icon_item:getContentSize())
        Common:changePic(sp,data.bg)
        sp:setPosition(icon_item:getPosition())
        icon_item:setLocalZOrder(2)
        icon_item:getParent():addChild(sp,1)
    end
    
    if data.origional then
        icon_item:setVisible(false)
        icon_item_origional:setVisible(true)
        icon_item_origional:loadTexture(data.icon,ResType)
        if data.iconScale then
            icon_item_origional:setScale(data.iconScale)
        end
    else
        icon_item:setVisible(true)
        icon_item_origional:setVisible(false)  
        Common:changePic(icon_item,data.icon)
        if data.iconScale then
            icon_item:setScale(data.iconScale)
        end
    end
    text_item_desc:setString(data.title)
    if data.titleColor then
        text_item_desc:setColor(data.titleColor)
    end
    text_item_extra:setString(data.extra or "")
    text_item_amount:setString(string.format(StringRes.count,data.count))
    text_item_info:setString(data.des)
    
    
end



return ItemDetail