
local KingOfFB = class("KingOfFB",function(scene,data)
    return PanelTabLayer.new(scene,{title=StringRes.activitydes_10,tabs={StringRes.new_activity_dd1,StringRes.ranking_list}})
end)



function KingOfFB:show(parent)

    Connect:sendMsg("ActivityGuildFBAction","openActivityGuildFB",{},
        function(data)
            local layer = KingOfFB.new(parent,data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)
end

function KingOfFB:ctor(parent,data)
    self.data = data
    self:initView()
end

function KingOfFB:initView()
    self.content = CCUILoader:load("csd/mainmap_left/activity_announcement/activity/king_of_copy_challenge/ui_king_of_copy_challenge_main.csb")
    self:addChild(self.content)
    self.tabs = {self.content:getChildByName("panel_item"),self.content:getChildByName("panel_ranking")}
    self:registerTabEvent(1,function()
        self:showTab(1)
    end)
    self:registerTabEvent(2,function()
        if self:checkAm() then
            self:showTab(2)
        else
            self:setTabSelect(1)
        end
    end)
    self:setTabSelect(1)
    self:initIntro()
    self:initRank()
end

function getStr()
    local str =""
    for i,v in ipairs(gKingofguid)do
        str = str..string.format(StringRes.act_des_6.."\n"..StringRes.act_des_7.."\n"..StringRes.act_des_8,v.id,v.guildexp,v.resourse)
        if i ~= #gKingofguid then
            str = str.."\n"
        end
    end
    return str
end

local intros = {
    {type = 1},
    {type = 2,str = StringRes.act_des_1},
    {type = 3,str = StringRes.act_des_2},
    {type = 1},
    {type = 2,str = StringRes.act_des_3},
    {type = 3,str = StringRes.act_des_4},
    {type = 1},
    {type = 2,str = StringRes.act_des_5},--奖励
    {type = 3,str = string.format(getStr())},
    {type = 1},
    {type = 2,str = StringRes.act_des_9},
    {type = 3,str = StringRes.act_des_10},
    {type = 1},
    {type = 2,str = StringRes.act_des_11},
    {type = 3,str = StringRes.act_des_12},
    {type = 1},
    {type = 4,str = StringRes.act_des_13},
    {type = 3,str = StringRes.act_des_14},
    {type = 1},
    {type = 5,str = StringRes.act_des_15},
    {type = 3,str = StringRes.act_des_16},
    {type = 1},
}

function KingOfFB:initRank()
    self.panel_attack_1st = self.tabs[2]:getChildByName("panel_attack_1st")
    self.panel_attack_2nd = self.tabs[2]:getChildByName("panel_attack_2nd")
    self.panel_attack_3rd = self.tabs[2]:getChildByName("panel_attack_3rd")
    self.panel_attack_other = self.tabs[2]:getChildByName("panel_attack_other")
    self.listview_ranking = self.tabs[2]:getChildByName("listview_ranking")
    self.listview_ranking:removeAllItems()
    if self.data.activityGuildFBRankInfo then
        self:addRankItem(self.data.activityGuildFBRankInfo,true)
    end
    for i,v in ipairs(self.data.guildFbRankInfos) do
        self:addRankItem(v,false)
    end
end

function KingOfFB:addRankItem(v,isSelf)
    local item = nil
    if v.rank == 1 then
        item = self.panel_attack_1st:clone()
    elseif v.rank == 2 then
        item = self.panel_attack_2nd:clone()
    elseif v.rank == 3 then
        item = self.panel_attack_3rd:clone()
    elseif v.rank > 3 or v.rank == 0 then
        item = self.panel_attack_other:clone()
        local tmp = v.rank
        if v.rank == 0 then tmp = "10+" end
        item:getChildByName("text_ranking"):setString(tmp)
    end
    item:getChildByName("text_army_group_name"):setString(v.guildName)
    item:getChildByName("text_num"):setString(v.count)
    item:getChildByName("text_level"):setString(v.lv)
    item:getChildByName("panel_line"):setVisible(isSelf)
    item:getChildByName("panel_bg"):setVisible(not isSelf)
    self.listview_ranking:pushBackCustomItem(item)
end

function KingOfFB:initIntro()
    self.panel_line = self.tabs[1]:getChildByName("panel_line"):clone()
    local panel_linecross = self.tabs[1]:getChildByName("panel_linecross")
    local panel_content = self.tabs[1]:getChildByName("panel_content")
    local text_desc = self.tabs[1]:getChildByName("text_desc")
    local panel_bg = self.tabs[1]:getChildByName("panel_bg")
    local panel_bg_2 = self.tabs[1]:getChildByName("panel_bg_2")
    local lv = self.tabs[1]:getChildByName("listview_desc")
    lv:pushBackCustomItem(self.panel_line)
    self.panel_line:getChildByName("text_copy_challenge"):setString(StringRes.activitydes_10)
    self.panel_line:getChildByName("text_time"):setString(string.format(StringRes.act_timeFormat,self.data.startTime,self.data.endTime))
    self.panel_line:getChildByName("text_time_2"):setString(string.format(StringRes.act_timeFormat,self.data.getStartTime,self.data.getEndTime))

    for i,v in ipairs(intros) do
        if v.type == 1 then
            lv:pushBackCustomItem(panel_linecross:clone())
        elseif v.type == 2 then
            local item = panel_content:clone()
            local text = item:getChildByName("text_content")
            text:setString(v.str)
            lv:pushBackCustomItem(item)
        elseif v.type == 3 then
            local item = text_desc:clone()
            item:setString("")
            SpecialView:addRichText(item,StringTemp:Descript(v.str,item:getFontSize()),0)
            lv:pushBackCustomItem(item)
        elseif v.type == 4 then
            local item = panel_bg:clone()
            item:getChildByName("text_box"):setString(v.str)
            lv:pushBackCustomItem(item)
        elseif v.type == 5 then
            local item = panel_bg_2:clone()
            item:getChildByName("text_key"):setString(v.str)
            lv:pushBackCustomItem(item)
        end
    end

    self.tabs[1]:getChildByName("btn_goto"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self:checkAm() then
                Buildings:gotoArmyGroupFB(gWorldScene)
                self:getParent():removeFromParent()
            end
        end
    end)

    self.btn_get = self.tabs[1]:getChildByName("btn_get")
    showShader:buttonToGray(self.btn_get)
    self.btn_get:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self.data.state == 1 then
                Connect:sendMsg("ActivityGuildFBAction","getGuildFBRankReward",{},
                    function(data)
                        local pd = PlayerData:getInstanse().basicData
                        pd.crystal = data.crystal
                        pd.ferrum = data.fe
                        pd.oil = data.oil
                        pd.lead = data.lead
                        pd.titanium = data.titan
                        self.data.state = data.state
                        self:updateState()
                        local str = StringRes.exchange_get_reward
                        local rankData = gKingofguid[data.rank]
                        if rankData then
                            str = str.."   "..StringRes.crystal.."x"..rankData.resourse
                            str = str.."   "..StringRes.iron_ore.."x"..rankData.resourse
                            str = str.."   "..StringRes.vanadium.."x"..rankData.resourse
                            str = str.."   "..StringRes.oil.."x"..rankData.resourse
                            str = str.."   "..StringRes.titanium.."x"..rankData.resourse
                            if data.job == 1 then
                                str = str.."   "..StringRes.army_group_exp.."x"..rankData.guildexp
                            end
                            FlyWordPrompt:prompt(str)
                        end
                    end)
            else
                FlyWordPrompt:prompt(StringRes.new_server_combat1)
            end

        end
    end)
    self:updateState()
end

function KingOfFB:updateState()
    local text_activity = self.panel_line:getChildByName("text_activity")
    local text_time = self.panel_line:getChildByName("text_time")
    local text_desc = self.panel_line:getChildByName("text_desc")
    if self.data.state == 2 then

        self.btn_get:setTitleText(StringRes.already_attach)
    else
        self.btn_get:setTitleText(StringRes.act_get)
    end
    Common:setBtnTouchEnable(self.btn_get,self.data.state == 1 or self.data.state == 3)
    if self.data.state == 1 then
        text_desc:setVisible(true)
        text_desc:setString(StringRes.new_server_combat5)
        text_activity:setVisible(false)
        text_time:setVisible(false)
    elseif self.data.state == 2 then
        text_desc:setVisible(false)
        text_activity:setVisible(false)
        text_time:setVisible(false)
    elseif self.data.state == 3 then
        text_desc:setVisible(true)
        text_desc:setString(StringRes.new_server_combat1)
        text_activity:setVisible(false)
        text_time:setVisible(false)
    elseif self.data.state == 0 then
        text_desc:setVisible(false)
        text_activity:setVisible(true)
        text_time:setVisible(true)
    end
end

function KingOfFB:showTab(index)
    for i,v in ipairs(self.tabs) do
        v:setVisible(i == index)
    end
end

function KingOfFB:checkAm()
    local pd = PlayerData:getInstanse()
    if pd.basicData.guildId == 0 then
        FlyWordPrompt:prompt(StringRes.act_noAm)
        return false
    else
        return true
    end
end

function KingOfFB:close()
    NodeTranslator:transDown(self,function()
        self:getParent():getActivityList()
        self:removeFromParent()
    end)
end

return KingOfFB