
local MilitaryExerciseAward = class("MilitaryExerciseAward",function(scene,data)
    return CCUILoader:load("res/csd/operation_center/layer_military_exercise_award.csb")
end)



function MilitaryExerciseAward:show(parent)
    Connect:sendMsg("RewardAction","getRewardList",{},
        function(data)
            local layer = MilitaryExerciseAward.new(parent,data)
            parent:addChild(layer)
        end)
end

function MilitaryExerciseAward:ctor(parent,data)
    self.data = data
    self:initView()
    self._parent = parent
end

function MilitaryExerciseAward:initView()
    self.panel_bg = self:getChildByName("panel_mask"):getChildByName("panel_bg")
    --关闭
    self.panel_bg:getChildByName("btn_off"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)

    --全部领取
    self.panel_bg:getChildByName("btn_get_all"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            Connect:sendMsg("RewardAction","getAllReward",{},
                function(data)
                    if data.state == 1 then
                        FlyWordPrompt:prompt(StringRes.activity_descript_71)
                        self:close()
                    end
                end)
        end
    end)

    self.text_num = self.panel_bg:getChildByName("icon_gift"):getChildByName("text_num")
    self.listview_item = self.panel_bg:getChildByName("listview_item")
    self.panel_item = self.panel_bg:getChildByName("panel_item")
    self.panel_desc = self.panel_bg:getChildByName("panel_desc")
    self:updateView()
end

function MilitaryExerciseAward:updateView()
    self.text_num:setString(#(self.data.list))
    self.listview_item:removeAllItems()
    for i,v in ipairs(self.data.list) do
        local item = self.panel_item:clone()
        item:getChildByName("text_time"):setString(v.createTime)
        local lv = item:getChildByName("panel_item_desc"):getChildByName("listview_item")
        for ii,vv in ipairs(v.gifts) do
            local lvit = self.panel_desc:clone()
            local icon = lvit:getChildByName("icon_item")
            icon.tag_data = vv
            ActUtils:initSignItem(icon)
            lv:pushBackCustomItem(lvit)
        end
        item:getChildByName("btn_get"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                Connect:sendMsg("RewardAction","getReward",{id = v.id},
                    function(data)
                        if data.state == 1 then
                            local str = StringRes.exchange_get_reward..":"..ActUtils:getItemStrLifei(data.gifts)
                            FlyWordPrompt:prompt(str)
                            table.remove(self.data.list,i)
                            if #(self.data.list) > 0 then
                                self:updateView()
                            else
                                self:close()
                            end
                        end
                    end)
            end
        end)
        self.listview_item:pushBackCustomItem(item)
    end
end

function MilitaryExerciseAward:close()
    gWorldScene:getGametips()
    if self._parent.updateRank then
        self._parent:updateRank()
    end
    self:removeFromParent()
end

return MilitaryExerciseAward