local PanelTabLayer = require("src/app/views/public/PanelTabLayer")
local MilitaryForum = class("MilitaryForum",function(scene,data)
    return PanelTabLayer.new(scene,{title=StringRes.activitydes_42,tabs={StringRes.militarypulpit001,StringRes.ranking_list}})
end)

function MilitaryForum:show(parent,ac_id,ac_time)

    Connect:sendMsg("ActivityMilitaryforumAction","openActivityMilitaryforum",{},
        function(data)
            local layer = MilitaryForum.new(parent,data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)

end

function MilitaryForum:addRankItem(data)
    if data.playerId == 0 then return end
    local item = self.rankItem:clone()
    local icon_medal = item:getChildByName("icon_medal")
    local text_ranking = item:getChildByName("text_ranking")
    local text_name = item:getChildByName("text_name")
    local text_level = item:getChildByName("text_level")
    local text_fighting = item:getChildByName("text_fighting")
    local text_credit = item:getChildByName("text_credit")
    local strIcon = gRankListIcon[data.rank]
    if strIcon then
        icon_medal:setVisible(true)
        text_ranking:setVisible(false)
        Common:changePic(icon_medal,strIcon)
    else
        icon_medal:setVisible(false)
        text_ranking:setVisible(true)
        local tmpRank = data.rank == 0 and "30+" or data.rank
        text_ranking:setString(tmpRank)
    end
    text_name:setString(data.name)
    text_level:setString(data.lv)
    text_fighting:setString(data.combat)
    text_credit:setString(data.credit)
    self.rankList:pushBackCustomItem(item)
end

function MilitaryForum:updateRankInfo()
    self.text_own:setString(string.format(StringRes.militarypulpit006,self.data.activityMilitaryforumRankVO.credit))
    self.rankList:removeAllItems()
    self:addRankItem(self.data.activityMilitaryforumRankVO)
    for i,v in ipairs(self.data.activityMilitaryforumRankVOs) do
        self:addRankItem(v)
    end
end

function MilitaryForum:study(pTen)
    local pFreeCount = (self.data.freeCount > 0 and self.curIndex == 2 and pTen == 0) and 1 or 0
    Connect:sendMsg("ActivityMilitaryforumAction","study",{group = self.curIndex , freeCount = pFreeCount , ten = pTen},
        function(data)
            PlayerData:getInstanse().basicData.gold  = data.gold
            self.data.freeCount = data.freeCount
            self.data.activityMilitaryforumRankVOs = data.activityMilitaryforumRankVOs
            self.data.activityMilitaryforumRankVO = data.activityMilitaryforumRankVO
            self:updateFreeInfo()
            self:updateRankInfo()
            PromptView:reward4MilitaryForum(StringRes.militarypulpit008,1,data.studyVOs)
        end)
end

function MilitaryForum:ctor(scene,data)
    self.data = data
    self.cfgData = require("src/app/data/militaryforum")
    self.curIndex = 1
    local panelInfo = CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/army_education/ui_army_education_main.csb")
    self:addChild(panelInfo)
    self.tabs = {panelInfo:getChildByName("panel_study"),panelInfo:getChildByName("panel_raking")}
    self:initTabs()

    local panel_line = self.tabs[1]:getChildByName("panel_line")
    panel_line:getChildByName("text_info"):setString(StringRes.militarypulpit003)
    panel_line:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.militarypulpit004))
        end
    end)

    panel_line:getChildByName("text_time"):setString(data.startTime.."~"..data.endTime)
    panel_line:getChildByName("text_time_2"):setString(data.getStartTime.."~"..data.getEndTime)

    self.panel_shades = {self.tabs[1]:getChildByName("panel_shade_L"),self.tabs[1]:getChildByName("panel_shade_M"),self.tabs[1]:getChildByName("panel_shade_R")}
    self.btn_checks = {self.tabs[1]:getChildByName("panel_theory"),self.tabs[1]:getChildByName("panel_course"),self.tabs[1]:getChildByName("panel_check")}

    for i,v in ipairs (self.btn_checks) do
        v:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
--                if self.data.freeCount > 0 then return end
                self.curIndex = i
                self:selectIndex()
            end
        end)
    end

    local panel_bg = self.tabs[1]:getChildByName("panel_item"):getChildByName("panel_bg")
    self.listview = panel_bg:getChildByName("listview_line")
    self.tmpItem = panel_bg:getChildByName("icon_madal")

    self.btn_recruit = self.tabs[1]:getChildByName("btn_recruit")
    local btn_recruit_ten = self.tabs[1]:getChildByName("btn_recruit_2")
    self.num_need = self.btn_recruit:getChildByName("num_need")
    self.num_need_ten = btn_recruit_ten:getChildByName("num_need")
    local btns = {self.btn_recruit,btn_recruit_ten}
    for i,v in ipairs(btns) do
        v:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                self:study(i-1)
            end
        end)
    end

    local panel_item = self.tabs[2]:getChildByName("panel_item")
    local panel_line = self.tabs[2]:getChildByName("panel_line")
    self.text_own = panel_item:getChildByName("text_own")
    self.rankList = panel_line:getChildByName("listview_line")
    self.rankItem = panel_line:getChildByName("panel_bg")
    self.btn_get = panel_line:getChildByName("btn_get")
    showShader:buttonToGray(self.btn_get)
    Common:setBtnTouchEnable(self.btn_get,self.data.rankGet == 1)
    self.btn_get:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            Connect:sendMsg("ActivityMilitaryforumAction","getRankReward",{},
                function(data)
                    if data.rankRewardGet == 1 then
                        self.data.rankGet = 0
                        Common:setBtnTouchEnable(self.btn_get,self.data.rankGet == 1)
                        for i,v in ipairs(data.activityMilitaryforumRankGetVOs) do
                            if v.type ==2 then
                                v.type = 5
                            elseif v.type == 3 then
                                v.type = 2
                            end
                            v.num = v.count
                            v.baseId = v.templateId
                        end
                        PromptView:showRewards(StringRes.militarypulpit009,data.activityMilitaryforumRankGetVOs)
                    end
                end)
        end
    end)
    panel_item:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.militarypulpit007))
        end
    end)
    if self.data.freeCount > 0 then
        self.curIndex = 2
    end
    self:selectIndex()
    self:updateRankInfo()
end

function MilitaryForum:updateFreeInfo()
    local isFree = self.data.freeCount > 0 and self.curIndex == 2
    local icons = isFree and gButtonTextures[5] or gButtonTextures[4]
    local str = isFree and StringRes.free_search_part or StringRes.militarypulpit001
    self.btn_recruit:loadTextures(icons[1],icons[2])
    self.btn_recruit:getChildByName("text_study"):setString(str)
    self:selectIndexCost()
end

function MilitaryForum:selectIndexCost()
    local costs = {self.data.costone,self.data.costtwo,self.data.costthree}
    local index = self.curIndex 
    local isFree = self.data.freeCount > 0 and self.curIndex == 2
    if isFree then
        self.num_need:setString("0")
    else
        self.num_need:setString(costs[index])
    end
    self.num_need_ten:setString(costs[index]*9)
end

function MilitaryForum:selectIndex()
    local index = self.curIndex
    for i,v in ipairs(self.btn_checks) do
        v:getChildByName("btn_check"):setSelected(i == index)
        self.panel_shades[i]:setVisible(i == index)
    end

    self.listview:removeAllItems()
    local items = self.cfgData[index]
    for i,v in ipairs(items) do
        local item = self.tmpItem:clone()
        item.tag_data = {type = 1,baseId = v.id,num = v.count,textNodeName = "text_num"}
        self.giftInfo = require("src/app/views/activity/ActUtils"):initSignItem(item)
        self.listview:pushBackCustomItem(item)
    end
    self:selectIndexCost()
    self:updateFreeInfo()
end

function MilitaryForum:showTab(index)
    for i,v in ipairs(self.tabs) do
        v:setVisible(i == index)
    end
end

function MilitaryForum:initTabs()
    self:registerTabEvent(1,function()
        self:showTab(1)
    end)

    self:registerTabEvent(2,function()
        self:showTab(2)
    end)
    self:setTabSelect(1)
end

return MilitaryForum