--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local ended = ccui.TouchEventType.ended
local DescriptView = require("src/app/views/prompt/DescriptView")

local MonthGeneralStarView = class("MonthGeneralStarView",function(parent,data)
    return PanelTabLayer.new(parent,{title=StringRes.activitydes_35,tabs={}})
end)

function MonthGeneralStarView:ctor(parent,data,type)
    self.MainPage = CCUILoader:load("csd/mainmap_left/activity_announcement/activity/monthly_super_general/ui_monthly_super_general_main.csb")
    self:addChild(self.MainPage)

    local uiHeadBack = self.MainPage:getChildByName("panel_monthly_bg")
    self.UITimeText = uiHeadBack:getChildByName("text_time")
    self.UIPrompt = uiHeadBack:getChildByName("btn_info")

    self.UIMissions = {
        uiHeadBack:getChildByName("panel_mission_01"),
        uiHeadBack:getChildByName("panel_mission_02")
    }

    self:registerTabEvent("close",function()
        self:destroy()
    end)

    SpecialView:registerEvent(self.UIPrompt,ended,function()
        DescriptView:open(self,StringTemp:Descript(StringRes.text_world00023))
    end)

    self.type = type

    self:setBaseInfo(data)
    self:updateMissions(data.list)
end

--显示奖励列表
function MonthGeneralStarView:showReward(index,rewards)
    PromptView:showRewards(nil,rewards,function()
        Connect:sendMsg("ActivityMonthCommanderAction","getReward",{atype=self.type,type=index},function(newMsg)
            if newMsg.state == 1 then
                SpecialView:setEnabled(self.UIMissions[index]:getChildByName("btn_get"),false)
            end
        end)
    end)
end

--领取奖励
function MonthGeneralStarView:getReward(index,rewards,state)
    local funcs = {
        function()
            PromptView:type1(nil,StringRes.text_world00036,StringRes.ok)
        end,
        function()
            self:showReward(index,rewards)
        end,
        function()
            
        end
    }
    funcs[state+1]()
end

--设置基本信息
function MonthGeneralStarView:setBaseInfo(data)
    self.UITimeText:setString(data.time)
end

--设置奖励信息
function MonthGeneralStarView:setRewardInfo(uiParent,rewards)
    local gifts = StringUtil.getRewardsData(rewards)
    for i = 1 , 4 do
        local reward = gifts[i]
        local uiRewardBack = uiParent:getChildByName("icon_0"..i)
        if reward then
            local uiIcon = uiRewardBack:getChildByName("icon_reward")
            local uiOutline = uiRewardBack:getChildByName("panel_outline")
            local uiNum = uiRewardBack:getChildByName("num_info")
            local uiName = uiRewardBack:getChildByName("text_name")
            if uiName then
                uiName:setString(reward.title)
            end
            if uiOutline then
                uiIcon:setVisible(true)
                Common:changePic(uiIcon,reward.icon)
                Common:changePic(uiOutline,reward.outIcon)
            else
                uiIcon:setVisible(false)
                Common:changePic(uiRewardBack,reward.icon)
            end
            uiNum:setString("x "..reward.count)
--            if reward.backIcon then
--                uiRewardBack:loadTexture(reward.backIcon,ResType)
--            end

            SpecialView:registerEvent(uiRewardBack,ended,function()
                if reward.outIcon then
                    require("src/app/views/academy/AcademyGeneralInfo"):show(self,reward) 
                else
                    require("app/views/activity/ItemDetail"):show(self,reward)
                end
            end)
        end
        if uiRewardBack then
            uiRewardBack:setVisible(reward and true or false)
        end
    end
end

--设置一个任务信息
function MonthGeneralStarView:setMissionInfo(index,uiMission,missiondata)
    local uiAims = uiMission:getChildByName("text_mission_desc")
    local uiToComplete = uiMission:getChildByName("btn_to_complete")
    local uiRate = uiMission:getChildByName("num_rate")
    local uiGet = uiMission:getChildByName("btn_get")
    showShader:buttonToGray(uiGet)
    
    uiAims:setString(string.format(missiondata.type == 1 and StringRes.text_world00021 or StringRes.text_world00022,missiondata.needNum))
    uiRate:setString(string.format("%s/%s",missiondata.nowNum,missiondata.needNum))
    SpecialView:registerEvent(uiGet,ended,function()
        self:getReward(index,missiondata.gifts,missiondata.state)
    end)
    SpecialView:registerEvent(uiToComplete,ended,function()
        local parent = self._parent
        self:close()
        if missiondata.type == 1 then
            parent:removeFromParent()
            gWorldScene:toField()
        else
            Recharge:show(gWorldScene)
        end
    end)
    SpecialView:setEnabled(uiGet,missiondata.state <= 1)
    self:setRewardInfo(uiMission,missiondata.gifts)
end

function MonthGeneralStarView:updateMissions(data)
    for index,uiMission in ipairs(self.UIMissions) do
        local missionData = data[index]
        self:setMissionInfo(index,uiMission,missionData)
    end
end

function MonthGeneralStarView:destroy()

end

function MonthGeneralStarView:open(parent,activityId,timeStr)
    Connect:sendMsg("ActivityMonthCommanderAction","open",{atype=activityId},function(newData)
        newData.time = timeStr
        local newPage = self.new(parent,newData,activityId)
        parent:addChild(newPage)
    end,true)

end

return MonthGeneralStarView
--endregion
