
local NewPlayerPkg = class("NewPlayerPkg",function()
    return CCUILoader:load("csd/mainmap_popout/layer_popout_new_player_package.csb")
end)

function NewPlayerPkg:show(parent)
    local layer = NewPlayerPkg.new()
    parent:addChild(layer,200)
    NodeTranslator:transZoomOut(layer:getChildByName("panel_mask"):getChildByName("panel_bg"),nil)
end

function NewPlayerPkg:ctor()
    self.strContent = ""
    self:initView()
end

function NewPlayerPkg:initView()
    self:getChildByName("panel_mask"):getChildByName("panel_bg"):getChildByName("btn_confirm"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
        
            Connect:sendMsg("GiftAction","getNewGift",{},
                function (data)
                    if data.state == 1 then
                        FlyWordPrompt:prompt(string.format(StringRes.exchange_success,self.strContent))
                        local pd = PlayerData:getInstanse()
                        pd.newGiftVOs = nil
                        require("src/app/views/activity/AttackRaise"):show(self:getParent(),false,data.combatGiftVOs)
                        self:removeFromParent()
                    end
                end)
        end
    end)
    
    self:updateItems()
end

function NewPlayerPkg:updateItems()
    local panel_tank_bg = self:getChildByName("panel_mask"):getChildByName("panel_bg"):getChildByName("panel_tank_bg"):getChildByName("listview_mask")
    local listview = panel_tank_bg:getChildByName("listview_resource")
    local oriListviewSize = listview:getContentSize()
    listview:setContentSize(0,oriListviewSize.height)
    local tmpItem = panel_tank_bg:getChildByName("panel_item_bg")
	local pd = PlayerData:getInstanse()
    for i,v in ipairs(pd.newGiftVOs) do
        local info = nil
        if v.giftType == 1 then
            info = gItem[v.giftId]
            self.strContent = self.strContent..StringRes[info.name].."x"..v.giftCount.." "
        elseif v.giftType == 2 then
            local parts = require("src/app/data/parts")
            info = parts[v.giftId]
            self.strContent = self.strContent..info.name.."x"..v.giftCount.." "
        elseif v.giftType == 3 then
            info = Tank[v.giftId]
            self.strContent = self.strContent..StringRes[info.name].."x"..v.giftCount.." "
        end
        if info then
            local item = tmpItem:clone()
            local icon_item = item:getChildByName("icon_item")
            Common:changePic(icon_item,info.icon)
            icon_item:getChildByName("num_desc"):setString("x"..v.giftCount)
            listview:pushBackCustomItem(item)
            local size = listview:getContentSize()
            local width = size.width+item:getContentSize().width+listview:getItemsMargin()
            if width > oriListviewSize.width then
                width = oriListviewSize.width
            end
            listview:setContentSize(width,size.height)
        end
    end
end

return NewPlayerPkg