
local NewPlayerUpgrade = class("NewPlayerUpgrade",function(data)
    return CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/new_player_upgrade_reward/ui_new_player_upgrade_reward_main.csb")
end)

function NewPlayerUpgrade:show(parent)

    Connect:sendMsg("LvupActivityAction","OpenActivity",{},
        function(data)
            local layer = NewPlayerUpgrade.new(data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)
end

function NewPlayerUpgrade:ctor(data)
    self.data = data
    self:initView()
    self:update(0)
    local Scheduler = cc.Director:getInstance():getScheduler()
    self.updateId = Scheduler:scheduleScriptFunc(handler(self,self.update), 0.8, false)
    local function onNodeEvent(tag)
        if tag == "exit" then
            Scheduler:unscheduleScriptEntry(self.updateId)
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

function NewPlayerUpgrade:update(dt)
    if self.data.time > 0 then
        self.data.time = self.data.time - dt
        if self.data.time < 0 then
            self.data.time = 0
        end
    end
    self.text_time:setString(StringTemp:toTime2(self.data.time))
end

function NewPlayerUpgrade:initView()
    self:getChildByName("bg"):getChildByName("text_title"):setString(StringRes.activitydes_4)--StringRes.activitydes_4)
    self:getChildByName("bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)

    local panel_mission_task = self:getChildByName("panel_bg"):getChildByName("panel_mission_task")
    self.text_time = panel_mission_task:getChildByName("text_time")
    panel_mission_task:getChildByName("text_content"):setString(StringRes.tdes_4)


    panel_mission_task:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            local DescriptCfg = require("src/app/cfg/DescriptCfg")
            DescriptView:open(self,DescriptCfg.New_Player_Upgrade_Des)
        end
    end)
    self:updateListItem()
end

function NewPlayerUpgrade:close()
    NodeTranslator:transDown(self,function()
        --                gWorldScene:getGametips()
        self:removeFromParent()
    end)
end

function NewPlayerUpgrade:updateListItem()
    local panel_linebg = self:getChildByName("panel_bg"):getChildByName("panel_linebg")
    local listview_get = panel_linebg:getChildByName("listview_get")
    local tItem = panel_linebg:getChildByName("panel_bg")
    for i , v in ipairs(self.data.activityVOs) do
        local item = tItem:clone()
        item.tag_data = v
        self:initItem(item)
        listview_get:pushBackCustomItem(item)
    end
end

function NewPlayerUpgrade:initItem(item)
    local data = item.tag_data
    item.tag_data.tag_strContent = ""

    local text_level = item:getChildByName("text_level")
    text_level:setString(string.format(StringRes.LV2,data.lv))
    
    local index = 0
    if data.gold > 0 then
        index = index + 1
        local it = item:getChildByName("icon_resoure_"..index)
        local info  = {}
        info.num = data.gold
        info.type = 4
        it.tag_data = info
        local tmpData = require("app/views/activity/ActUtils.lua"):initSignItem(it)
        item.tag_data.tag_strContent = item.tag_data.tag_strContent..tmpData.title.."x"..tmpData.count.." "
        it:setVisible(true)
    end

    for i = 1 , 3-index, 1 do
        local it = item:getChildByName("icon_resoure_"..(i+index))
        local info  = data.rewarItemsVOs[i]
        if info then
            it.tag_data = info
            it.tag_data.num = it.tag_data.count
            it.tag_data.baseId = it.tag_data.id
--            it.tag_data.type = 1
            local tmpData = require("app/views/activity/ActUtils.lua"):initSignItem(it)
            item.tag_data.tag_strContent = item.tag_data.tag_strContent..tmpData.title.."x"..tmpData.count.." "
            self:updateItemState(item)
            it:setVisible(true)
        else
            it:setVisible(false)
        end
    end

    --可领取
    if data.state == 1 then
        item:getChildByName("btn_get"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                Connect:sendMsg("LvupActivityAction","getActivityLvUpReward",{lv = data.lv},
                    function(v)
                        if v.state == 1 then
                            data.state = 2
                            self:updateItemState(item)
                            FlyWordPrompt:prompt(string.format(StringRes.exchange_success,item.tag_data.tag_strContent))
                        end
                    end)
            end
        end)
    end
end

function NewPlayerUpgrade:updateItemState(item)
    local data = item.tag_data
    local icon_get = item:getChildByName("icon_checkmark")
    local btn_get = item:getChildByName("btn_get")

    if data.state == 0 then
        icon_get:setVisible(false)
        btn_get:setVisible(true)
        btn_get:setEnabled(false)
        showShader:buttonToGray(btn_get)
        btn_get:setBright(false)
    elseif data.state == 1 then
        icon_get:setVisible(false)
        btn_get:setVisible(true)
        btn_get:setEnabled(true)
        btn_get:setBright(true)
    elseif data.state == 2 then
        icon_get:setVisible(true)
        btn_get:setVisible(false)
    end
end

return NewPlayerUpgrade