--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

local uiCfg = {
    {
        csb = "csd/mainmap_left/activity_announcement/activity/new_year_blessing/ui_new_year_blessing_main.csb",
        panel= {title=StringRes.springBlessing_14,tabs={StringRes.springBlessing_15,StringRes.springBlessing_16}},
        prompts = {StringRes.springBlessing_24,StringRes.springBlessing_25},
        descript = StringRes.springBlessing_28,
        remain = StringRes.springBlessing_29,
        gain = StringRes.springBlessing_30,
        lab1left = StringRes.springBlessing_31,
        lab1right = StringRes.springBlessing_26,
        rewardprompt = StringRes.blessing_get_coin, --奖励提示
        blesscount = StringRes.springBlessing_18, --可祈福次数
        lab2btn = StringRes.springBlessing_19,
        lab2rwdprompt = StringRes.blessing_get_item,
        action = "SpringBlessingAction"
    },
    {
        csb = "csd/mainmap_left/activity_announcement/activity/new_year_lucky_chest/ui_new_year_lucky_chest_main.csb",
        panel= {title=StringRes.luckyTreasure_6,tabs={StringRes.luckyTreasure_6,StringRes.luckyTreasure_7}},
        prompts = {StringRes.luckyTreasure_8,StringRes.luckyTreasure_9},
        descript = StringRes.luckyTreasure_12,
        remain = StringRes.luckyTreasure_2,
        gain = StringRes.luckyTreasure_3,
        lab1left = StringRes.luckyTreasure_5,
        lab1right = StringRes.luckyTreasure_4,
        rewardprompt = StringRes.lucky_get_coin, --奖励提示
        blesscount = StringRes.luckyTreasure_2, --
        lab2btn = StringRes.luckyTreasure_4,
        lab2rwdprompt = StringRes.lucky_get_item,
        action = "LuckyTreasureAction"
    },
}

local ended = ccui.TouchEventType.ended
local NewYearTask = {
    require("src/app/data/blessing_task"),
    require("src/app/data/lucky_task")
}

local NewYearActivityView = class("NewYearActivityView",function(parent,data)
    local uiData = uiCfg[data]
    return PanelTabLayer.new(parent,uiData.panel)
end)

function NewYearActivityView:ctor(parent,type)
    local uiData = uiCfg[type]
    self.MainPage = CCUILoader:load(uiData.csb)
    self:addChild(self.MainPage)

    local label1 = self.MainPage:getChildByName("panel_lucky_box")
    local label2 = self.MainPage:getChildByName("panel_task")
    self.Labels = {
        {
            UIMain = label1,
            UITime = label1:getChildByName("panel_title_bg"):getChildByName("text_time"),
            UIPrompt = label1:getChildByName("panel_title_bg"):getChildByName("btn_info"),
            UIDescript = label1:getChildByName("panel_title_bg"):getChildByName("text_desc"),
            UIRemain = label1:getChildByName("panel_box_bg"):getChildByName("text_search_today"),
            UIGain = label1:getChildByName("text_search"),
            UIRange = label1:getChildByName("num_desc"),
            UICost = label1:getChildByName("num_item"),
            UILeftBtn = label1:getChildByName("btn_search_record"),
            UIRightBtn = label1:getChildByName("btn_search")
        },
        {
            UIMain = label2,
            UIPrompt = label2:getChildByName("panel_bg"):getChildByName("btn_info"),
            UIMissions = label2:getChildByName("panel_bg"):getChildByName("panel_text"),
            UICount = label2:getChildByName("text_search"),
            UIBtn = label2:getChildByName("btn_search"),
        }
    }

    self._type = type

    self:setBaseView(uiData)
end

local function initLabel1(self,uiInfo,uiData)
    uiInfo.UIDescript:setString(uiData.descript)
    uiInfo.UIGain:setString(uiData.gain)
    uiInfo.UILeftBtn:setTitleText(uiData.lab1left)
    uiInfo.UIRightBtn:setTitleText(uiData.lab1right)
    SpecialView:registerEvent(uiInfo.UILeftBtn,ended,function() --记录
        PromptView:rewardRecord(self._type,self._data.logs)
    end)
end

local function initLabel2(self,uiInfo,uiData)
    uiInfo.UIBtn:setTitleText(uiData.lab2btn)
    SpecialView:registerEvent(uiInfo.UIBtn,ended,function()
        self:blessing(2,0,uiData,"taskTreasure")
    end)
end

function NewYearActivityView:setBaseView(uiData)
    local funcs = {initLabel1,initLabel2}
    for labIndex,uiInfo in ipairs(self.Labels) do
        self:registerTabEvent(labIndex,function()
            self:selectLabel(labIndex)
        end)
        SpecialView:registerEvent(uiInfo.UIPrompt,ended,function()
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(uiData.prompts[labIndex]))
        end)
        funcs[labIndex](self,uiInfo,uiData)
    end
end

function NewYearActivityView:selectLabel(labIndex)
    for index,uiInfo in ipairs(self.Labels) do
        uiInfo.UIMain:setVisible(index == labIndex)
    end
end

function NewYearActivityView:blessing(labIndex,cost,uiData,msgName)
    local basicData = PlayerData:getInstanse().basicData
    if basicData.gold >= cost then
        Connect:sendMsg(uiData.action,msgName,nil,function(newMsg)
            if newMsg.gold then
                basicData.gold = newMsg.gold
            end
            table.insert(self._data.logs,newMsg.log)
            self:update(labIndex,newMsg)
            if cost > 0 then
                FlyWordPrompt:prompt(string.format(uiData.rewardprompt,newMsg.get))
            else
                FlyWordPrompt:prompt(string.format(uiData.lab2rwdprompt,StringUtil.getRewardString(newMsg.gifts)))
            end
        end,true)
    else
        PromptView:goldUnenought(cost,basicData.gold)
    end
end

function NewYearActivityView:update(labIndex,data,missionupdate)
    local uiInfo = self.Labels[labIndex]
    local uiData = uiCfg[self._type]

    local funcs = {
        function()
            local costGold = data.cost
            uiInfo.UIRemain:setString(string.format(uiData.remain,data.remainTimes))
            uiInfo.UIRange:setString(string.format("%s-%s",data.min,data.max))
            uiInfo.UICost:setString(costGold)
--            uiInfo.UIRightBtn:setTitleColor((PlayerData:getInstanse().basicData.gold<costGold) and CommonColor.Red or
--                    CommonColor.White)
            uiInfo.UICost:setColor((PlayerData:getInstanse().basicData.gold<costGold) and CommonColor.Red or
                    CommonColor.Golden)
            SpecialView:setEnabled(uiInfo.UIRightBtn,data.remainTimes > 0)
            SpecialView:registerEvent(uiInfo.UIRightBtn,ended,function()
                self:blessing(labIndex,costGold,uiData,"goldTreasure")
            end)
        end,
        function()
            local count = data.remainTreasureTimes
            uiInfo.UICount:setString(string.format(uiData.blesscount,count))
            SpecialView:setEnabled(uiInfo.UIBtn,(count > 0))
            if missionupdate then
                local task = NewYearTask[self._type]
                local uiTitle = uiInfo.UIMissions:getChildByName("text_title")
                uiTitle:setString(StringRes["newyear_task_round"..data.round])
                for i,info in ipairs(data.tasks) do
                    local msg = task[info.taskId]
                    local uiDesc = uiInfo.UIMissions:getChildByName("text_desc_0"..i)
                    local uiProgress = uiInfo.UIMissions:getChildByName("text_info_0"..i)
                    uiDesc:setString(string.format(msg.desc,StringTemp:toNum(msg.count)))
                    if info.state == 1 then
                        uiProgress:setString(StringRes.springBlessing_10)
                        uiProgress:setColor(CommonColor.Green)
                    else
                        uiProgress:setString(string.format(msg.progress,StringTemp:toNum(info.count),StringTemp:toNum(info.total)))
                        uiProgress:setColor(CommonColor.Red)
                    end

                end
            end
        end
    }

    funcs[labIndex]()
end

function NewYearActivityView:initData(data)
    self._data = data
    for index,uiInfo in ipairs(self.Labels) do
        self:update(index,data,true)
        if index == 1 then
            uiInfo.UITime:setString(string.format("%s~%s",data.startTime,data.endTime))
        end
    end
end

function NewYearActivityView:open(parent,type,label)
    Connect:sendMsg(uiCfg[type].action,"open",nil,function(newMsg)
        local newPage = self.new(parent,type)
        newPage:initData(newMsg)
        parent:addChild(newPage)
        newPage:setTabSelect(label or 1)
    end)
end

return NewYearActivityView
--endregion
