--配件探索
-- Created by IntelliJ IDEA.
-- User: HS18
-- Date: 2015/11/19
-- Time: 17:27
-- To change this template use File | Settings | File Templates.
--每次颁奖为其中一种
local parts = require("src/app/data/parts")

local ended = ccui.TouchEventType.ended

local PartSearchView = class("PartSearchView",function(parent,data)
    return PanelTabLayer.new(parent,{title=StringRes.activitydes_20,tabs={StringRes.search_part,
        StringRes.ranking_list}})
end)

function PartSearchView:ctor(parent,data,id)
    self.MainPage = CCUILoader:load("csd/mainmap_left/activity_announcement/activity/treasure_exploration/ui_treasure_exploration_main.csb")
    self:addChild(self.MainPage)

    local label1 = self.MainPage:getChildByName("panel_treasure_exploration")
    local label2 = self.MainPage:getChildByName("panel_ranking")
    self.UILabels = {
        {
            MainPage = label1,
            TimeList = label1:getChildByName("panel_line"):getChildByName("listview_line"),
            TimeItem = label1:getChildByName("panel_line"):getChildByName("panel_bg"),
            Descript = label1:getChildByName("panel_line"):getChildByName("btn_info"),
            ImagesParent = label1:getChildByName("panel_linebg"),
            OneGold = label1:getChildByName("panel_itembg"):getChildByName("num_need"),
            OneSearch = label1:getChildByName("btn_free"),
            TenSearch = label1:getChildByName("btn_exploration"),
            TenGoldNeed = label1:getChildByName("panel_bg"):getChildByName("num_need"),
            TenGoldTrue = label1:getChildByName("panel_bg"):getChildByName("num_need_2"),
        },
        {
            MainPage = label2,
            Own = label2:getChildByName("panel_bg"):getChildByName("text_own"),
            Need = label2:getChildByName("panel_bg"):getChildByName("text_ranking"),
            Descript = label2:getChildByName("panel_bg"):getChildByName("btn_info"),
            RankList = label2:getChildByName("panel_line"):getChildByName("listview_line"),
            RankItem = label2:getChildByName("panel_line"):getChildByName("panel_itembg"),
            GetReward = label2:getChildByName("panel_line"):getChildByName("btn_get"),
        }
    }

    for index,info in ipairs(self.UILabels) do
        self:registerTabEvent(index,function()
            self:selectLabel(index)
        end)
    end
    if id==90 then
    	self.activityparts = require("src/app/data/activityparts2")
    else
    	self.activityparts = require("src/app/data/activityparts")
    end
    self.Data = data
    self:initBaseData(data,id)
end

local function initPartSeach(self,uiInfo,data,id)

    for index,info in ipairs(self.activityparts) do
        local r,h = math.ceil(index/5),(index-1)%5 + 1
        local uiIcon,uiEvent = nil,nil
        if h >= 5 then
            uiIcon = uiInfo.ImagesParent:getChildByName("panel_line_"..r):getChildByName("icon_material")
            uiEvent = uiIcon
        else
            local uiItem = uiInfo.ImagesParent:getChildByName("panel_line_"..r):getChildByName("icon_fragmentbg_"..h)
            uiEvent = uiItem
           	uiIcon = uiItem:getChildByName("icon_accessory")
           	if id==90 then 
           		if r<4 then
           			Common:changePic(uiItem,"res/pic/accessory/warehouse/incomplete_peace/icon_fragmentBg_purple.png")
           		else
           			Common:changePic(uiItem,"res/pic/accessory/warehouse/incomplete_peace/icon_fragmentBg_orange.png")
           		end	
           	end 
        end
        SpecialView:registerEvent(uiEvent,ended,function()
            local rewards = StringTemp:toPartByStr(info.rewards,"rewardId","rewardCount","supplies")
            PromptView:reward(StringRes.per_reward_one,2,rewards)
        end)
        Common:changePic(uiIcon,parts[info.templateId].icon)
        
    end
    uiInfo.OneGold:setString(data.costGold)
    uiInfo.TenGoldNeed:setString(data.costGold*10)
    uiInfo.TenGoldTrue:setString(data.costGold*9)

    uiInfo.TenGoldTrue:ignoreContentAdaptWithSize(false)
    uiInfo.TenGoldTrue:setTextAreaSize(cc.size(100, 30))

    uiInfo.TenGoldNeed:ignoreContentAdaptWithSize(false)
    uiInfo.TenGoldNeed:setTextAreaSize(cc.size(100, 30))

    SpecialView:registerEvent(uiInfo.OneSearch,ended,function()
        self:search(0)
    end)
    SpecialView:registerEvent(uiInfo.TenSearch,ended,function()
        self:search(1)
    end)

    local _t = nil
    uiInfo.TimeItem:retain()
    uiInfo.TimeItem:removeFromParent()
    if data.state == 3 then
        _t = {
            {{str=StringRes.activitydes_103.."："..data.time,color=CommonColor.Blue2,size=24}},
            {{str=string.format(StringRes.search_time,data.getStartTime,data.getEndTime),color=CommonColor.White,size=24}},
        }
    elseif data.state == 0 then
        _t = {{{str=StringRes.not_in_rank_list,color=CommonColor.Red,size=24}} }
    else
        _t = {{{str=StringRes.good_get_reward,color=CommonColor.Blue2,size=24}} }
    end
    SpecialView:addRichText(uiInfo.TimeItem,_t)
    uiInfo.TimeList:pushBackCustomItem(uiInfo.TimeItem)
    uiInfo.TimeItem:release()

    self:updateByFree(uiInfo,data)
end

local function initRankList(self,uiInfo,data,id)
    local function addItem(itemData,isMe)
        local uiItem = uiInfo.RankItem:clone()
        local uiIsSelf = uiItem:getChildByName("panel_item")
        local uiIcon = uiItem:getChildByName("icon_medal")
        local uiRank = uiItem:getChildByName("text_ranking")
        local uiName = uiItem:getChildByName("text_name")
        local uiLevel = uiItem:getChildByName("text_level")
        local uiFight = uiItem:getChildByName("text_fighting")
        local uiThings = uiItem:getChildByName("text_materials")
        uiIsSelf:setVisible(isMe)
        local icon = gRankListIcon[itemData.rank]
        local v =  false
        if icon then
            v =  true
            Common:changePic(uiIcon,icon)
        end
        uiIcon:setVisible(v)
        uiRank:setVisible(not v)
        uiRank:setString((itemData.rank > 10 or itemData.rank<0) and "10+" or itemData.rank)
        uiName:setString(itemData.playerName)
        uiLevel:setString(itemData.lv)
        uiFight:setString(itemData.combat)
        uiThings:setString(itemData.supplies)
        uiInfo.RankList:pushBackCustomItem(uiItem)
    end

    addItem(data.activityPartsVO,true)
--    table.sort() --排序
    for _,info in ipairs(data.activityPartsVOs) do
        addItem(info,false)
    end

    self.updateWonSuplies = function()
        local own = data.activityPartsVO.supplies
        uiInfo.Own:setString(string.format(StringRes.cur_own_things,own))
        local uiItem = uiInfo.RankList:getItem(0)
        uiItem:getChildByName("text_materials"):setString(own)
    end

    self.updateWonSuplies()
    uiInfo.Need:setString(string.format(StringRes.rank_name_things,CommonData.search_metail))
    showShader:buttonToGray(uiInfo.GetReward)

    local function update()
        uiInfo.GetReward:setBright(data.state == 1)
        uiInfo.GetReward:setTitleText(data.state == 2 and StringRes.already_attach or StringRes.attach)
    end

    update()
    SpecialView:registerEvent(uiInfo.GetReward,ended,function()
        if data.state == 1 then
            Connect:sendMsg("ActivityPartsAction","getActivityPartsRankReward",{type = self.dataType},function(newMsg)
                if newMsg.state == 1 then
                    local m = "%sx%s"
                    local str = ""
                    for i = 1 , 2 do
                        local type = newMsg["type"..i]
                        local id = newMsg["templateId"..i]
                        local count = newMsg["count"..i]
                        if type == 1 then
                            str = str..string.format(m,StringRes[gItem[id].name],count)
                        else
                            str = str..string.format(m,parts[id].name,count)
                        end
                    end
                    FlyWordPrompt:prompt(string.format(StringRes.exchange_success,str))
                    data.state = 2
                    update()
                end
            end,true)
        elseif data.state == 0 then
            FlyWordPrompt:prompt(StringRes.not_in_rank_list)
        end
    end)
end

function PartSearchView:updateByFree(uiInfo,data)
    if data.freeCount < 0 then
        data.freeCount = 0
    end
    uiInfo.OneSearch:setTitleText((data.freeCount>0) and StringRes.free_search_part or StringRes.search_part)

end

function PartSearchView:search(ten)
    local function search()
        Connect:sendMsg("ActivityPartsAction","buyActivityParts",{ten=ten,type = self.dataType},function(msg)
            PlayerData:getInstanse().basicData.gold = msg.gold
            self.Data.freeCount = msg.freeCount
            self.Data.activityPartsVO.supplies = msg.supplies
            self:showRewards(msg.partsEndVO or {})
            self.updateWonSuplies()
            self:updateByFree(self.UILabels[1],self.Data)
        end,true)
    end
    if ten == 0 and self.Data.freeCount > 0 then
        search()
    else
        local costGold = self.Data.costGold*(ten==1 and 9 or 1)
        PromptView:spendGold(costGold,search,string.format(StringRes.part_search_prompt,costGold,(ten==1 and 10 or 1)))
    end
end

function PartSearchView:showRewards(rewards)
    local reward = rewards[1]
    if reward then --探索奖励总览
--        local part = parts[reward.rewardId]
--        local desc = string.format(StringRes.search_reward_desc,part.name,reward.rewardCount,reward.supplies)--%s*%s，同时获得物资%s。
--        PromptView:reward(StringRes.search_all_reward,part.icon,desc,function()
--            table.remove(rewards,1)
--            self:showRewards(rewards)
--        end)
        PromptView:reward(StringRes.search_all_reward,1,rewards)
    end
end

function PartSearchView:selectLabel(labIndex)
    for index,info in ipairs(self.UILabels) do
        info.MainPage:setVisible(index == labIndex)
    end
end

function PartSearchView:initBaseData(data,id)
    local funcs = {initPartSeach,initRankList }
    for index,info in ipairs(self.UILabels) do
        funcs[index](self,info,data,id)
        SpecialView:registerEvent(info.Descript,ended,function()
            local DescriptView = require("src/app/views/prompt/DescriptView")
            --local DescriptCfg = require("src/app/cfg/DescriptCfg")
            DescriptView:open(self,self.Search_Labels_Descript[index])
        end)
    end
end

function PartSearchView:open(parent,label,data,id)
    Connect:sendMsg("ActivityPartsAction","openActivityParts",{type = id},function(newData)
        newData.time = data
        local newPage = self.new(parent,newData,id)
        newPage.dataType = id
        local DescriptCfg = require("src/app/cfg/DescriptCfg")
        if id==31 then 
        	newPage.Search_Labels_Descript = DescriptCfg.Search_Labels_Descript
        else
        	newPage.Search_Labels_Descript = DescriptCfg.Search_Labels_Descript2
        end      
        parent:addChild(newPage)
        newPage:setTabSelect(label or 1)
    end,true)
end

return PartSearchView