
local RussianRoulette = class("RussianRoulette",function(scene,data,id)
    if id==36 then
        return PanelTabLayer.new(scene,{title=StringRes.activitydes_24,tabs={StringRes.activity_descript_55,StringRes.ranking_list}})
    else
        return PanelTabLayer.new(scene,{title=StringRes.activitydes_96,tabs={StringRes.activity_descript_55,StringRes.ranking_list}})
    end
end)

local timeKey = nil
local Scheduler = cc.Director:getInstance():getScheduler()

--时间终止
local function endTime()
    if timeKey then
        Scheduler:unscheduleScriptEntry(timeKey)
        timeKey = nil
    end
end

--生成时间轴
local function gernerateTable(pos)
    local _t = {}
    local cfg = {0.05*3,0.05*3,0.05*2,0.05*2,0.05*2,0.05*1,0.05*1,0.05*1,0.05*1,0.05*1,0.05*1,0.05*1}
--    local cfg = {0.05*10,0.05*10,0.05*10,0.05*9,0.05*8,0.05*7,0.05*6,0.05*5,0.05*4,0.05*3,0.05*2,0.05*1}
    local time = 0
    local max = #cfg*2+pos
    for i = 1,max do
        local add = cfg[#cfg]
        if cfg[i] then
            add = cfg[i]
        elseif cfg[max-i+1] then
            add = cfg[max-i+1]
        end
        time = time + add
        _t[i] = time
    end
    return _t
end

--抽奖
function RussianRoulette:draw(count)
    local ownGold = PlayerData:getInstanse().basicData.gold
    local spendGold = (count == 10) and self.mulCostGold or count*self.data.costGold
    if ownGold < spendGold then
        PromptView:goldUnenought(spendGold,ownGold)
    else
        self.CurDrawingTh = 0
        if count == 1  then 
            count = 0
        elseif count == 10 then
            count = 1 
        end
        local msg = {ten=count,type = self.dataType}
        Connect:sendMsg("ActivityRouletteAction","buyRoulette",msg,function(newMsg)
            self.data.freeCount = newMsg.freeCount or 0
            PlayerData:getInstanse().basicData.gold = newMsg.gold
            self.data.supplies = newMsg.supplies
            self.DrawListData = newMsg.rouletteEndVOs
            local tmp = self.DrawListData[1]
            local tmpType = tmp.type
            if tmpType == 2 then tmpType = 5 end
            local pos = self.keyTabs[tmpType.."_"..tmp.rewardId.."_"..tmp.rewardCount]
            self:drawEffect(pos)
        end,true)
    end
end

--抽奖表现
function RussianRoulette:drawEffect(pos)
    self.tag_pos = pos
    local timeTable = gernerateTable(pos)
    local time = 0
    local curPos = 0
    self.IsDrawing = true
    self:updateOther()
    self.CurDrawingTh = self.CurDrawingTh + 1

    -- 下一步处理
    local function nextHandle()
        self.UISelected:retain()
        self.UISelected:removeFromParent()
        self.UISelected:setPosition(0,0)
        local tmpIndex = curPos%12+1
        if tmpIndex < 10 then tmpIndex = "0"..tmpIndex end
        local ui_item = self.panel_item_bg:getChildByName("icon_item_"..tmpIndex)
        ui_item:addChild(self.UISelected)
        self.UISelected:release()
        curPos = curPos + 1
    end

    nextHandle()
    timeKey = Scheduler:scheduleScriptFunc(function()
        time = time + 0.05
        local posTime = timeTable[curPos]
        if time > posTime-0.001 and time < posTime + 0.001 then
            if curPos >= #timeTable then
                endTime()
                self.IsDrawing = false
                self:setRewardInfo(pos)
                return
            end
            nextHandle()
        end
    end,0.05,false)
end

--奖励信息设置
function RussianRoulette:setRewardInfo(pos)
    self:setResultViewVis(true)
    local tmp = self.DrawListData[self.CurDrawingTh]
    local infoMsg = self.posDatas[pos]
    
    Common:changePic(self.UIRewardIcon,infoMsg.icon)
    self.UIRewardName:setString(string.format(StringRes.search_reward_desc,infoMsg.title,""..infoMsg.count,""..tmp.supplies))
    self.UIRewardDesc:setString(infoMsg.des)
    local tmpPos = pos
    if tmpPos < 10 then tmpPos = "0"..tmpPos end 
    local posx,posy = self.panel_item_bg:getChildByName("icon_item_"..tmpPos):getPosition()
    NodeTranslator:transMove(self.UIRewardIconBack,cc.p(posx,posy),self.endPos,function()
        end)
end

function RussianRoulette:updateOther()
    if self.IsDrawing then
        self.btn_0:setEnabled(false)
        self.btn_1:setEnabled(false)
        self.btn_10:setEnabled(false)
    else
        self:updateLotteryBtn()
        self:updateSupplies()
    end
end

--奖励的时候点击确定
function RussianRoulette:getReward()
    self:setResultViewVis(false)
    if self.CurDrawingTh == #self.DrawListData then
        self:updateOther()
    else
        self.CurDrawingTh = self.CurDrawingTh+1
        local tmp = self.DrawListData[self.CurDrawingTh]
        local tmpType = tmp.type
        if tmpType == 2 then tmpType = 5 end
        local pos = self.keyTabs[tmpType.."_"..tmp.rewardId.."_"..tmp.rewardCount]
        self:setRewardInfo(pos)
    end
end

function RussianRoulette:show(parent,id)

    Connect:sendMsg("ActivityRouletteAction","openActivityRoulette",{type = id},
        function(data)
            data.state = data.rankRewardState
            local layer = RussianRoulette.new(parent,data,id)
            layer.dataType=id
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)
end

function RussianRoulette:ctor(parent,data,id)
    if id==36 then
        self.gActivityroulettereward=gActivityroulettereward
    else
        self.gActivityroulettereward=gActivityroulettereward2
    end
    self.data = data
    self.IsDrawing = false --正在抽奖
    self.CurDrawingTh = 0 --当前正在进行的抽奖代号
    self.DrawListData = {} --抽奖获取到的东西编号列表
    self.keyTabs = {}
    self.posDatas = {}
    self:initView()
    self.endPos = cc.p(self.UIRewardIconBack:getPosition())
end

function RussianRoulette:initView()
    self.content = CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/russian_roulette/ui_russian_roulette_main.csb")
    self:addChild(self.content)
    local panel_roulette = self.content:getChildByName("panel_roulette")
    self.tabs = {panel_roulette:getChildByName("panel_tab_01"),panel_roulette:getChildByName("panel_tab_02")}
    self:registerTabEvent(1,function()
        self:showTab(1)
    end)
    self:registerTabEvent(2,function()
        self:showTab(2)
    end)
    self:setTabSelect(1)
    self:initIntro()
    self:initRank()
    self:updateState()
end

function RussianRoulette:initRank()
    local panel_ranking_bg = self.tabs[2]:getChildByName("panel_ranking_bg")
    self.panel_attack_1st = panel_ranking_bg:getChildByName("panel_attack_1st")
    self.panel_attack_2nd = panel_ranking_bg:getChildByName("panel_attack_2nd")
    self.panel_attack_3rd = panel_ranking_bg:getChildByName("panel_attack_3rd")
    self.panel_attack_other = panel_ranking_bg:getChildByName("panel_attack_other")
    self.listview_ranking = panel_ranking_bg:getChildByName("listview_desc")
    self.listview_ranking:removeAllItems()
    if self.data.activityRouletteVO then
        self:addRankItem(self.data.activityRouletteVO,true)
    end
    for i,v in ipairs(self.data.activityRouletteVOs) do
        self:addRankItem(v,false)
    end
    
    local panel_title_bg = self.tabs[2]:getChildByName("panel_title_bg")
    panel_title_bg:getChildByName("text_desc_01"):setString(string.format(StringRes.cur_own_things,StringTemp:toNum(self.data.supplies)))
    panel_title_bg:getChildByName("text_desc_02"):setString(string.format(StringRes.rank_name_things,"200"))
    panel_title_bg:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.activity_descript_51))              
        end
    end)
    
    self.btn_get = panel_ranking_bg:getChildByName("btn_get")
    showShader:buttonToGray(self.btn_get)
    self.btn_get:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self.data.state == 1 then
                Connect:sendMsg("ActivityRouletteAction","getRouletteRankReward",{type=self.dataType},
                    function(data)
                        if data.state == 1 then
                            self.data.state = 2
                            self:updateState()
                            local tmp = {}
                            table.insert(tmp,{templateId = data.templateId1 , count = data.count1 , type = 1})
                            table.insert(tmp,{templateId = data.templateId2 , count = data.count2 , type = 1})
                            local str = StringRes.already_attach..":"..ActUtils:getItemStrLifei(tmp)
                            FlyWordPrompt:prompt(str)
                        end
                    end)
            else
                FlyWordPrompt:prompt(StringRes.new_server_combat1)
            end

        end
    end)
    
end

function RussianRoulette:addRankItem(v,isSelf)
    local item = nil
    if v.rank == 1 then
        item = self.panel_attack_1st:clone()
    elseif v.rank == 2 then
        item = self.panel_attack_2nd:clone()
    elseif v.rank == 3 then
        item = self.panel_attack_3rd:clone()
    elseif v.rank > 3 or v.rank == 0 then
        item = self.panel_attack_other:clone()
        local tmp = v.rank
        if v.rank == 0 then tmp = "10+" end
        item:getChildByName("text_ranking"):setString(tmp)
    end
    item:getChildByName("text_army_group_name"):setString(v.playerName)
    item:getChildByName("text_num"):setString(v.lv)
    item:getChildByName("text_level"):setString(StringTemp:toNum(v.combat))
    item:getChildByName("text_desc"):setString(StringTemp:toNum(v.supplies))
    item:getChildByName("panel_line"):setVisible(isSelf)
    item:getChildByName("panel_bg"):setVisible(not isSelf)
    self.listview_ranking:pushBackCustomItem(item)
end

function RussianRoulette:initIntro()
    self.panel_desc = self.tabs[1]:getChildByName("panel_desc_bg"):getChildByName("listview_desc"):getChildByName("panel_desc")
    self.panel_desc:getChildByName("time_time_Copy"):setString(string.format(StringRes.act_timeFormat,self.data.startTime,self.data.endTime))
    self.panel_desc:getChildByName("time_time"):setString(string.format(StringRes.act_timeFormat,self.data.getStartTime,self.data.getEndTime))

    local text_desc = self.tabs[1]:getChildByName("panel_desc_bg"):getChildByName("listview_desc"):getChildByName("text_desc")
    text_desc:setString("")
    SpecialView:addRichText(text_desc,StringTemp:Descript(StringRes.activity_descript_48,text_desc:getFontSize()),0)

    self.UISelected = self.tabs[1]:getChildByName("Image_selected")
    
    self.panel_info_bg = self.tabs[1]:getChildByName("panel_info_bg")
    local panel_item = self.panel_info_bg:getChildByName("panel_item")
    self.UIRewardIcon = panel_item:getChildByName("panel_item_desc"):getChildByName("icon_item")
    self.UIRewardIconBack = panel_item:getChildByName("panel_item_desc")
    self.UIRewardName = panel_item:getChildByName("text_info")
    self.UIRewardDesc = panel_item:getChildByName("text_desc")
    self.UIRewardOk = panel_item:getChildByName("btn_confirm")
    self.UIRewardOk:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:getReward()
        end
    end)
        
    self:setResultViewVis(false)
    
    self.panel_item_bg = self.tabs[1]:getChildByName("panel_item_bg")
    for i,v in ipairs(self.gActivityroulettereward) do
        local tmpIndex = i 
        if tmpIndex < 10 then tmpIndex = "0"..tmpIndex end
        local item = self.panel_item_bg:getChildByName("icon_item_"..tmpIndex)
        item:setTouchEnabled(true)
        if v.type == 2 then v.type = 5 end
        v.textNodeName = "text_desc_"..tmpIndex
        item.tag_data = v
        local tmpData = ActUtils:initSignItemLifei(item)
        self.keyTabs[v.type.."_"..v.templateId.."_"..v.count] = i
        self.posDatas[i] = tmpData
    end
    
    self.panel_item_bg:getChildByName("panel_time_bg"):getChildByName("num_time"):setString(self.data.supplies)
    
    self.mulCostGold = self.data.mulCostGold or self.data.costGold*9
    self.panel_item_bg:getChildByName("text_num_01"):setString(self.mulCostGold)
    self.gold_text_num_02 = self.panel_item_bg:getChildByName("text_num_02")
    self.gold_icon_coin_02 = self.panel_item_bg:getChildByName("icon_coin_02")
    self.gold_text_num_02:setString(self.data.costGold)
    
    self.btn_0 = self.panel_item_bg:getChildByName("btn_lottery_free")
    self.btn_1 = self.panel_item_bg:getChildByName("btn_lottery")
    self.btn_10 = self.panel_item_bg:getChildByName("btn_lottery_continue")
    showShader:buttonToGray(self.btn_0)
    showShader:buttonToGray(self.btn_1)
    showShader:buttonToGray(self.btn_10)
    self.btn_0:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                self:draw(0)
            end
        end)
    self.btn_1:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:draw(1)
        end
    end)
    self.btn_10:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:draw(10)
        end
    end)
    self:updateLotteryBtn()
end

function RussianRoulette:updateSupplies()
	self.panel_item_bg:getChildByName("panel_time_bg"):getChildByName("num_time"):setString(self.data.supplies)
    local panel_title_bg = self.tabs[2]:getChildByName("panel_title_bg")
    panel_title_bg:getChildByName("text_desc_01"):setString(string.format(StringRes.cur_own_things,StringTemp:toNum(self.data.supplies)))
end

function RussianRoulette:updateLotteryBtn()
    Common:setBtnTouchEnable(self.btn_0,self.data.activityState == 0)
    Common:setBtnTouchEnable(self.btn_1,self.data.activityState == 0)
    Common:setBtnTouchEnable(self.btn_10,self.data.activityState == 0)
    local enable = self.data.freeCount and self.data.freeCount > 0
    self.btn_0:setVisible(enable)
    self.btn_1:setVisible(not enable)
    self.gold_text_num_02:setVisible(not enable)
    self.gold_icon_coin_02:setVisible(not enable)
end

function RussianRoulette:setResultViewVis(vis)
	self.panel_info_bg:setVisible(vis)
end

function RussianRoulette:updateState()
    local text_activity = self.panel_desc:getChildByName("text_time_Copy")
    local text_time = self.panel_desc:getChildByName("time_time_Copy")
    local text_desc = self.panel_desc:getChildByName("time_time_Copy_Copy")
    if self.data.state == 2 then
        self.btn_get:setTitleText(StringRes.already_attach)
    else
        self.btn_get:setTitleText(StringRes.act_get)
    end
    Common:setBtnTouchEnable(self.btn_get,self.data.state == 1 or self.data.state == 3)
    if self.data.state == 1 or self.data.state == 3 or self.data.activityState == 1 then
        text_desc:setVisible(true)
        text_desc:setString(StringRes.activity_descript_56)
        text_activity:setVisible(false)
        text_time:setVisible(false)
    elseif self.data.state == 2 then
        text_desc:setVisible(false)
        text_activity:setVisible(false)
        text_time:setVisible(false)
    elseif self.data.state == 0 then
        text_desc:setVisible(false)
        text_activity:setVisible(true)
        text_time:setVisible(true)
    end
end

function RussianRoulette:showTab(index)
    for i,v in ipairs(self.tabs) do
        v:setVisible(i == index)
    end
end

function RussianRoulette:close()
    if self.IsDrawing then
        endTime()
        self.IsDrawing = false
        self:setRewardInfo(self.tag_pos)
    else
        NodeTranslator:transDown(self,function()
            self:getParent():getActivityList()
            self:removeFromParent()
        end)
    end
end

return RussianRoulette