
local days = {7,15,30}

local Sign30Days = class("Sign30Days",function(data)
    return CCUILoader:load("csd/mainmap_left/daily_check_in/ui_30days_sign_in_main.csb")
end)

function Sign30Days:show(parent)

    Connect:sendMsg("SignAction","openSign",{},
        function(data)
            local layer = Sign30Days.new(data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)
end

function Sign30Days:ctor(data)
    self.data = data
    self:initView()

    ViewManager:OpenView(self)
end

function Sign30Days:initView()
    self:getChildByName("bg"):getChildByName("text_title"):setString(StringRes.sign30days)--StringRes.army_group_log)
    self:getChildByName("bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)
    self:updateListItem()
    self:initPageView()
    self:updateView()
    self:getChildByName("panel_bg"):getChildByName("btn_get"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            Connect:sendMsg("SignAction","getGift",{day = days[self.tag_index]},
                function(data)
                    if data.state == 1 then
                        self.data.totalSign = data.totalDay
                        self.data.totalGift = data.totalGift
                        if e.tag_strContent then
                            FlyWordPrompt:prompt(string.format(StringRes.exchange_success,e.tag_strContent))
                        end
                        self:updateListItem()
                        self:updateView()
                    end
                end)
        end
    end)

    self:getChildByName("panel_bg"):getChildByName("panel_header"):getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            local DescriptCfg = require("src/app/cfg/DescriptCfg")
            DescriptView:open(self,DescriptCfg.Sign_Info)
        end
    end)

end

function Sign30Days:initPageView()
    local panel_bg = self:getChildByName("panel_bg")
    self.pageView = panel_bg:getChildByName("pageview_desc")
    local panel_total_reward = panel_bg:getChildByName("panel_total_reward")
    for i,v in ipairs(self.data.totalGift) do
        local page = panel_total_reward:clone()
        local panel_item = page:getChildByName("panel_item_2")
        if days[i] then
            panel_item:getChildByName("text_days"):setString(string.format(StringRes.day_info,days[i]))
        end
        panel_item:getChildByName("icon_item"):setVisible(i == 3)
        panel_item:getChildByName("icon_item2"):setVisible(i ~= 3)
        local panel_items = page:getChildByName("panel_items")
        for j = 1 , 4, 1 do
            local it = panel_items:getChildByName("icon_reward_"..j)
            local info  = v.gifts[j]
            if info then
                it.tag_data = info
                local tmpData = require("app/views/activity/ActUtils.lua"):initSignItem(it)
            else
                it:setVisible(false)
            end
        end
        self.pageView:addPage(page)
    end
    --left
    panel_bg:getChildByName("btn_left"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self.pageView:scrollToPage(self.pageView:getCurPageIndex()-1)
        end
    end)
    --right
    panel_bg:getChildByName("btn_right"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self.pageView:scrollToPage(self.pageView:getCurPageIndex()+1)
        end
    end)
    
    local timeline = cc.CSLoader:createTimeline("csd/mainmap_left/daily_check_in/ui_30days_sign_in_main.csb")
    self:runAction(timeline)
    timeline:gotoFrameAndPlay(0, 80, true)
end

function Sign30Days:updateView()
    local panel_bg = self:getChildByName("panel_bg")
    panel_bg:getChildByName("panel_check_in"):getChildByName("text_checked_days"):setString(string.format(StringRes.sign_days,self.data.totalSign))
    local panel_total_reward = panel_bg:getChildByName("panel_total_reward")
    self.tag_index = 0
    local btn_get = panel_bg:getChildByName("btn_get")
    btn_get:setEnabled(false)
    showShader:buttonToGray(btn_get)
    btn_get:setBright(false)

    for i,v in ipairs(self.data.totalGift) do
        if self.tag_index == 0 and v.state ~= 2 then --第一个未领取
            self.tag_index = i
            local panel_items = panel_total_reward:getChildByName("panel_items")
            btn_get.tag_strContent = ""
            for j = 1 , 4, 1 do
                local it = panel_items:getChildByName("icon_reward_"..j)
                local info  = v.gifts[j]
                if info then
                    it.tag_data = info
                    local tmpData = require("app/views/activity/ActUtils.lua"):initSignItem(it)
                    btn_get.tag_strContent = btn_get.tag_strContent..tmpData.title.."x"..tmpData.count.." "
                else
                    it:setVisible(false)
                end
            end
            local state = (v.state == 1)
            btn_get:setEnabled(state)
            btn_get:setBright(state)
        end
        
        --        item.tag_strContent = ""
        --        for index,value in ipairs(v.gifts) do
        --            item.isOnlyGetData = true
        --            item.tag_data = value
        --            local tmpData = require("app/views/activity/ActUtils.lua"):initSignItem(item)
        --            item.tag_strContent = item.tag_strContent..tmpData.title.."x"..tmpData.count..", "
        --        end
        --        item:addTouchEventListener(function(e, t)
        --            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
        --                local icons = {ResIconCfg.icon_commonBox,ResIconCfg.icon_commonBox,ResIconCfg.icon_seniorBox}
        --                local tmp = {}
        --                tmp.icon = icons [i]
        --                tmp.count = 1
        --                tmp.title = string.format(StringRes.sign_pkg,v.day)
        --                tmp.des = item.tag_strContent
        --                tmp.origional = true
        --                require("app/views/activity/ItemDetail"):show(gWorldScene,tmp)
        --            end
        --        end)

    end
    
    local pageIndex = self.tag_index
    if pageIndex > 0 then
        pageIndex = pageIndex -1
    end
    self.pageView:scrollToPage(pageIndex)

end

function Sign30Days:close()
    NodeTranslator:transDown(self,function()
        gWorldScene:getGametips()
        self:removeFromParent()
    end)
end

function Sign30Days:updateListItem()
    self.hasFirst = false --第一个不能领取
    self.tag_strContent = {}
    local panel_bg = self:getChildByName("panel_bg")
    local listview_reward = panel_bg:getChildByName("listview_reward")
    listview_reward:removeAllItems()
    local panel_reward = panel_bg:getChildByName("panel_reward")
    for i , v in ipairs(self.data.signStates) do
        local item = panel_reward:clone()
        item.tag_data = v
        self:initItem(item)
        listview_reward:pushBackCustomItem(item)
    end
    if self.data.nowDays > 3 then
        listview_reward:scrollToBottom(0.01,false)
    end
end

function Sign30Days:initItem(item)
    local data = item.tag_data
    item.tag_data.tag_strContent = ""
    if data.state == 0 and not self.hasFirst then
        self.hasFirst = true
        data.state = 4 --明日签到
    end
    local text_day = item:getChildByName("text_day")
    text_day:setString(string.format(StringRes.day_info,data.day))
    for i = 1 , 3, 1 do
        local it = item:getChildByName("icon_reward_"..i)
        local info  = data.gifts[i]
        if info then
            it.tag_data = info
            local tmpData = require("app/views/activity/ActUtils.lua"):initSignItem(it)
            item.tag_data.tag_strContent = item.tag_data.tag_strContent..tmpData.title.."x"..tmpData.count.." "
            self:updateItemState(item)
        else
            it:setVisible(false)
        end
    end

    self.tag_strContent["day"..data.day] = item.tag_data.tag_strContent

    --可领取
    if data.state == 1 then
--        item:setBackGroundImage(ResIconCfg.bg_7daysLight,ResType)
        Common:changePic(item:getChildByName("panel_reward_bg"),ResIconCfg.bg_7daysLight)
        --签到
        item:getChildByName("btn_get"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                Connect:sendMsg("SignAction","sign",{day = data.day},
                    function(v)
                        if v.state == 1 then
                            self.data.totalSign = v.totalDay
                            self.data.signStates = v.signStates
                            self.data.totalGift = v.totalGift
                            item.tag_data.state = 2
                            self:updateItemState(item)
                            FlyWordPrompt:prompt(string.format(StringRes.exchange_success,item.tag_data.tag_strContent))
                            self:updateView()
                        elseif v.state == 2 then --有断签
                            PromptView:type2green(StringRes.notice,
                                string.format(StringRes.sign_mend_info,self.data.mendSign,math.pow(self.data.mendSign,1.5)*8)*15
                                ,StringRes.sign_mend,StringRes.sign_reset,
                                function()
                                    self:mendSign()
                                end,
                                function()
                                    self:reset()
                                end)
                        return
                        end
                    end)
            end
        end)
    end
end

function Sign30Days:mendSign()
    Connect:sendMsg("SignAction","mendSign",{},
        function(data)
            if data.state == 1 then
                self:showMendInfos(data.mendDays)
                self.data.totalSign = data.totalDay
                self.data.signStates = data.signStates
                self.data.totalGift = data.totalGift
                self:updateListItem()
                self:updateView()
            end
        end)
end

function Sign30Days:showMendInfos(days)
    local strContent = Common:copyTab(self.tag_strContent)
    local index = 0
    function show(dt)
        index=index+1
        if index > #days then
            return
        end
        FlyWordPrompt:prompt(string.format(StringRes.exchange_success,strContent["day"..days[index]]))
        self:runAction(cc.Sequence:create(cc.DelayTime:create(1),cc.CallFunc:create(show)))
    end
    show(0)
end

function Sign30Days:reset()
    Connect:sendMsg("SignAction","reset",{},
        function(data)
            self.data = data
            self:updateListItem()
            self:updateView()
        end)
end

function Sign30Days:updateItemState(item)
    local data = item.tag_data
    if data.state == 0 or data.state == 3 then
        self:setItemState(item,false,false,false)
    elseif data.state == 1 then
        self:setItemState(item,false,false,true)
    elseif data.state == 2 then
        self:setItemState(item,false,true,false)
    elseif data.state == 4 then
        self:setItemState(item,true,false,false)
    end
end

function Sign30Days:setItemState(item,b1,b2,b3)
    local text_tomorrow = item:getChildByName("text_tomorrow")
    local icon_get = item:getChildByName("icon_get")
    local btn_get = item:getChildByName("btn_get")
    text_tomorrow:setVisible(b1)
    icon_get:setVisible(b2)
    btn_get:setVisible(b3)
end

return Sign30Days