
local Sign7Days = class("Sign7Days",function(data)
    return CCUILoader:load("res/csd/mainmap_left/daily_check_in/ui_7days_sign_in_main.csb")
end)

function Sign7Days:show(parent)

    Connect:sendMsg("SevenDaysAction","open7daysGift",{},
        function(data)
            local layer = Sign7Days.new(data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)
end

function Sign7Days:ctor(data)
    self.data = data.gifts
    self.hasFirst = false --第一个不能领取
    self:initView()

    ViewManager:OpenView(self)
end

function Sign7Days:initView()
    self:getChildByName("bg"):getChildByName("text_title"):setString(StringRes.sign7days)--StringRes.army_group_log)
    self:getChildByName("bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)
    self:updateListItem()
end

function Sign7Days:close()
	NodeTranslator:transDown(self,function()
                gWorldScene:getGametips()
                self:removeFromParent()
            end)
end

function Sign7Days:updateListItem()
    local panel_bg = self:getChildByName("panel_bg")
    local listview_reward = panel_bg:getChildByName("listview_reward")
    local panel_reward = panel_bg:getChildByName("panel_reward")
    for i , v in ipairs(self.data) do
        local item = panel_reward:clone()
        item.tag_data = v
        self:initItem(item)
        listview_reward:pushBackCustomItem(item)
    end
end

function Sign7Days:initItem(item)
    local data = item.tag_data
    item.tag_data.tag_strContent = ""
    if data.state == 0 and not self.hasFirst then
        self.hasFirst = true
        data.state = 3
    end
    local text_day = item:getChildByName("text_day")
    text_day:setString(string.format(StringRes.day_info,data.day))
    for i = 1 , 5, 1 do
        local it = item:getChildByName("icon_reward_"..i)
        local info  = data.gifts[i]
        if info then
            it.tag_data = info
            local tmpData = require("app/views/activity/ActUtils.lua"):initSignItem(it)
            item.tag_data.tag_strContent = item.tag_data.tag_strContent..tmpData.title.."x"..tmpData.count.." "
            self:updateItemState(item)
        else
            it:setVisible(false)
        end
    end

    --可领取
    if data.state == 1 then
--        item:setBackGroundImage(ResIconCfg.bg_7daysLight,ResType)
        Common:changePic(item:getChildByName("panel_reward_bg"),ResIconCfg.bg_7daysLight)
        item:getChildByName("btn_get"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                Connect:sendMsg("SevenDaysAction","get7daysGift",{day = data.day},
                    function(v)
                        if v.state == 1 then
                            local pd = PlayerData:getInstanse()
                            pd.basicData.comat = v.combat
                            pd.basicData.gold = v.gold
                            pd.basicData.prestige = v.pre
                            pd.basicData.prestigeLv = v.preLv
                            item.tag_data.state = 2
                            self:updateItemState(item)
                            FlyWordPrompt:prompt(string.format(StringRes.exchange_success,item.tag_data.tag_strContent))
                            --7天领完 自动关闭 刷新按钮
                            if v.openSign == 2 then
                                gWorldScene:refreshSignIcon(v.openSign)
                                self:close()
                            end
                        end
                    end)
            end
        end)
    end
end

function Sign7Days:updateItemState(item)
    local data = item.tag_data
    if data.state == 0 then
        self:setItemState(item,false,false,false)
    elseif data.state == 1 then
        self:setItemState(item,false,false,true)
    elseif data.state == 2 then
        self:setItemState(item,false,true,false)
    elseif data.state == 3 then
        self:setItemState(item,true,false,false)
    end
end

function Sign7Days:setItemState(item,b1,b2,b3)
    local text_tomorrow = item:getChildByName("text_tomorrow")
    local icon_get = item:getChildByName("icon_get")
    local btn_get = item:getChildByName("btn_get")
    text_tomorrow:setVisible(b1)
    icon_get:setVisible(b2)
    btn_get:setVisible(b3)
end

return Sign7Days