--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
local ended = ccui.TouchEventType.ended

local SupplyInterceptView = class("SupplyInterceptView",function(parent,data)
    return PanelTabLayer.new(parent,{title=StringRes.activitydes_44})
end)

function SupplyInterceptView:ctor(parent,data,activityId)
    self.UIMainPage = CCUILoader:load("csd/mainmap_left/activity_announcement/activity/intercept_supply_line/ui_intercept_supply_line_main.csb")
    self:addChild(self.UIMainPage)

    local uiPanelBack = self.UIMainPage:getChildByName("panel_main_bg"):getChildByName("panel_bg")
    self.UIList = uiPanelBack:getChildByName("listview_info")
    self.UIMsgItem = uiPanelBack:getChildByName("panel_title_bg")
    self.UIMsgItem:retain()
    self.UIMsgItem:removeFromParent()
    self.UIList:pushBackCustomItem(self.UIMsgItem)
    self.UIMsgItem:release()

    self.UIRewardItem = uiPanelBack:getChildByName("panel_item_bg")
    self.UIRewardItem:retain()
    self.UIRewardItem:removeFromParent()
    self.UIList:pushBackCustomItem(self.UIRewardItem)
    self.UIRewardItem:release()

    self.UIDescItem = uiPanelBack:getChildByName("panel_info_bg")
    self.UIDescItem:retain()
    self.UIDescItem:removeFromParent()
    self.UIList:pushBackCustomItem(self.UIDescItem)
    self.UIDescItem:release()

    self:setBaseInfo(data)
    self:updateRewards(data.rewards)
end

function SupplyInterceptView:setBaseInfo(data)
    self.UIMsgItem:getChildByName("text_time"):setString(data.time)
    self.UIMsgItem:getChildByName("text_info"):setString(StringRes.attacksupply001)
    SpecialView:addRichText(self.UIDescItem:getChildByName("text_info_01"),StringTemp:Descript(StringRes.attacksupply008))
    SpecialView:addRichText(self.UIDescItem:getChildByName("text_info_02"),StringTemp:Descript(StringRes.attacksupply016,nil,CommonColor.Red))
end

function SupplyInterceptView:updateRewards(gifts)
    local rewards = StringUtil.getRewardsData(gifts,1)
    for index,reward in ipairs(rewards) do
        local uiItem = self.UIRewardItem:getChildByName("panel_item_0"..index)
        local uiName = uiItem:getChildByName("text_name")
        local uiButton = uiItem:getChildByName("btn_get")
        local uiIcon = uiItem:getChildByName("icon_item")
        local uiCount = uiIcon:getChildByName("num_desc")
        SpecialView:registerEvent(uiIcon,ended,function()
            require("app/views/activity/ItemDetail"):show(self,reward)
        end)
        SpecialView:registerEvent(uiButton,ended,function()
            if reward.count > 0 then
                Connect:sendMsg("ActivitySupplyInterceptAction","useBox",{baseId=gifts[index].baseId},function(newMsg)
                    if newMsg.state == 1 then
                        reward.count = newMsg.remainNum
                        uiCount:setString(newMsg.remainNum)
                        uiButton:setTitleText(reward.count>0 and StringRes.use or StringRes.get)
                        PromptView:showRewards(string.format(StringRes.attacksupply009,reward.title),{newMsg.gift},function() end)
                    end
                end)
            else
                self:close()
                gWorldScene:gotoPve()
            end
        end)
        uiName:setString(reward.title)
        uiCount:setString(reward.count)
        Common:changePic(uiIcon,reward.icon)
        uiButton:setTitleText(reward.count>0 and StringRes.use or StringRes.get)
    end
end

function SupplyInterceptView:open(parent,time,activityId)
    Connect:sendMsg("ActivitySupplyInterceptAction","open",nil,function(newMsg)
        newMsg.time = time
        local newPage = self.new(parent,newMsg,activityId)
        parent:addChild(newPage)
    end)
end

return SupplyInterceptView

--endregion
