
local SupplyLineChallenge = class("SupplyLineChallenge",function(scene,data)
    return CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/supply_line_challenge/ui_supply_line_challenge_main.csb")
end)



function SupplyLineChallenge:show(parent,data)
    local layer = SupplyLineChallenge.new(parent,data)
    parent:addChild(layer)
    NodeTranslator:transUp(layer,nil)
end

function SupplyLineChallenge:ctor(parent,data)
    self.data = data
    self:initView()
end

function SupplyLineChallenge:initView()
    --关闭
    self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.activitydes_30)
    local close = self:getChildByName("panel_bg"):getChildByName("btn_close")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)


    local panel_line = self:getChildByName("panel_line")

    --信息
    panel_line:getChildByName("panel_dialog"):getChildByName("text_desc"):setString(StringRes.activity_descript_68)
    panel_line:getChildByName("btn_supply_line"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:getParent():removeFromParent()
            local pd = PlayerData:getInstanse()
            if Buildings:isCanEnter(pd:getBaseBuildData(12)) then
                local SupplyLineView = require("src/app/views/accessories/SupplyLineView")
                SupplyLineView:open(gWorldScene)
            else
                FlyWordPrompt:prompt(StringRes.jumptip_2)
                return false
            end
        end
    end)
    panel_line:getChildByName("text_time"):setString(self.data)
end

function SupplyLineChallenge:close()
    NodeTranslator:transDown(self,function()
        self:getParent():getActivityList()
        self:removeFromParent()
    end)
end

return SupplyLineChallenge