
local TankBuildReward = class("TankBuildReward",function(data)
    return CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/tank_build_reward_competition/ui_tank_build_reward_competition_main.csb")
end)

function TankBuildReward:show(parent,ac_id,ac_time)

    Connect:sendMsg("ActivityArmsRaceAction","open",{type = ac_id},
        function(data)
            data.ac_time = ac_time
            data.ac_id = ac_id
            local layer = TankBuildReward.new(data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)
end

function TankBuildReward:ctor(data)
    self.data = data
    self:initView()
end

function TankBuildReward:initView()
    self:getChildByName("bg"):getChildByName("text_title"):setString(StringRes.activitydes_36)
    self:getChildByName("bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)

    local panel_reward_bg = self:getChildByName("panel_reward_bg")
    local panel_title_bg = panel_reward_bg:getChildByName("panel_title_bg")
    local panel_bg = panel_reward_bg:getChildByName("panel_bg")
    panel_title_bg:getChildByName("text_time"):setString(self.data.ac_time)
    panel_title_bg:getChildByName("text_info"):setString(StringRes.text_world00011)
    panel_title_bg:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.text_world00014))
        end
    end)
    
    panel_bg:getChildByName("btn_reward"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            require("src/app/views/activity/TankBuildRewardRecord"):show(self)
        end
    end)
    
    panel_bg:getChildByName("btn_produce"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:getParent():removeFromParent()
            Buildings:openMaxTankFactory(gWorldScene,2)
        end
    end)
    
    self.listView = panel_bg:getChildByName("listview_item")
    self.listItem = panel_bg:getChildByName("panel_item_bg")
    
    self:updateListItems()
end

function TankBuildReward:close()
    NodeTranslator:transDown(self,function()
        self:removeFromParent()
    end)
end

function TankBuildReward:updateItem(item)
    local data = item.tag_data
    local build_tank = Tank[data.produceId]
    local reward_tank = Tank[data.rewardId]
    local pane_item = item:getChildByName("pane_item")
    local icon_item = pane_item:getChildByName("icon_item")
    
    local tmp = {}
    tmp.type = 2
    tmp.num = data.rewardNum
    tmp.baseId = data.rewardId
    tmp.textNodeName = "num_info"
    icon_item.tag_data = tmp
    require("app/views/activity/ActUtils.lua"):initSignItem(icon_item)
    
    local text_name = pane_item:getChildByName("text_name")
    text_name:setString(StringRes[reward_tank.name])
    local text_desc = pane_item:getChildByName("text_desc")
    text_desc:setString(string.format(StringRes.text_world00012,data.produceNum,StringRes[build_tank.name]))
    local num_desc = pane_item:getChildByName("num_desc")
    num_desc:setString(data.num.."/"..data.produceNum)
    local btn_get = pane_item:getChildByName("btn_get")
    showShader:buttonToGray(btn_get)
    Common:setBtnTouchEnable(btn_get,(data.state and data.state == 1))
    data.str_fly = StringRes.exchange_get_reward..StringRes[reward_tank.name].."x"..data.rewardNum
end

function TankBuildReward:updateListItems()
    for i , v in ipairs(self.data.list) do
        local item = self.listItem:clone()
        item.tag_data = v
        item:getChildByName("pane_item"):getChildByName("btn_get"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                Connect:sendMsg("ActivityArmsRaceAction","getReward",{id = item.tag_data.id ,type = self.data.ac_id},
                    function(data)
                        if data.state == 1 then
                            FlyWordPrompt:prompt(item.tag_data.str_fly)
                            item.tag_data = data.option
                            self:updateItem(item)
                        end
                    end)
            end
        end)
        self:updateItem(item)
        self.listView:pushBackCustomItem(item)
    end
end

return TankBuildReward