
local TankBuildRewardRecord = class("TankBuildRewardRecord",function(data)
    return CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/tank_build_reward_competition/layer_tank_build_info.csb")
end)

function TankBuildRewardRecord:show(parent)

    Connect:sendMsg("ActivityArmsRaceAction","getLogs",{type = parent.data.ac_id},
        function(data)
            if data and (#data.logs) > 0 then
                local layer = TankBuildRewardRecord.new(data)
                parent:addChild(layer)
                NodeTranslator:transZoomOut(layer:getChildByName("panel_mask"):getChildByName("panel_bg"),nil)
            else
                FlyWordPrompt:prompt(StringRes.text_world00035)            
            end
        end)
end

function TankBuildRewardRecord:ctor(data)
    self.data = data
    self:initView()
end

function TankBuildRewardRecord:initView()
    local panel_bg = self:getChildByName("panel_mask"):getChildByName("panel_bg")
    self.listView = panel_bg:getChildByName("ListView_2")
    self.listItem = panel_bg:getChildByName("Panel_2")
    panel_bg:getChildByName("Button_5"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)
    self:updateListItems()
end

function TankBuildRewardRecord:updateListItems()
    for i , v in ipairs(self.data.logs) do
        local item = self.listItem:clone()
        item:getChildByName("Text_22"):setString(v.time.." "..string.format(StringRes.text_world00013,StringRes[Tank[v.baseId].name],v.num))
        self.listView:pushBackCustomItem(item)
    end
end

function TankBuildRewardRecord:close()
    NodeTranslator:transZoomOut(self:getChildByName("panel_mask"):getChildByName("panel_bg"),function()
        self:removeFromParent()
    end)
end

return TankBuildRewardRecord