
---------------------------
--坦克垃霸
---------------------------
local Scheduler = cc.Director:getInstance():getScheduler()
local timeKey = nil
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

--时间终止
local function endTime()
    if timeKey then
        Scheduler:unscheduleScriptEntry(timeKey)
        timeKey = nil
    end
end

local function isExist(_t,value)
    for _,v in ipairs(_t) do
        if v == value then
            return true
        end
    end
    return false
end

--从一个表中获取相同的位置
local function getCommonPos(_t)
    local re = {}
    for i = 1 , (#_t)-1 do
        for j = i+1 ,#_t do
            if _t[i] == _t[j] then
                if not isExist(re,i) then
                    table.insert(re,i)
                end
                if not isExist(re,j) then
                    table.insert(re,j)
                end
            end
        end
    end
    return re
end

--处理服务器过来的id列表
local function handleIds(ids)
    for i,id in ipairs(ids) do
        ids[i] = tonumber(id) - 4
    end
end

local TankPullPaView = class("TankPullPaView",function(parent)
    return PanelTabLayer.new(parent,{title=StringRes.activitydes_17,tabs={}})
end)

function TankPullPaView:ctor(parent,data)
    local fileName = "csd/mainmap_left/activity_announcement/activity/tank_slots/ui_tank_slots_main.csb"
    self.MainPage = CCUILoader:load(fileName)
    self:addChild(self.MainPage)

    local ui_back = self.MainPage:getChildByName("panel_tanke_slots")
    local ui_head = ui_back:getChildByName("panel_activity")
    self.UITime = ui_head:getChildByName("text_time")
    self.UIIntroduce = ui_head:getChildByName("btn_info")
    self.UIContent = ui_head:getChildByName("panel_bg"):getChildByName("text_content")

    local ui_bottom = ui_back:getChildByName("panel_outline")
    local ui_list_back = ui_bottom:getChildByName("panel_greenbg")
    self.UITankList1 = ui_list_back:getChildByName("listview_tanke_1")
    self.UITankList2 = ui_list_back:getChildByName("listview_tanke_2")
    self.UITankList3 = ui_list_back:getChildByName("listview_tanke_3")
    self.UITankItem = ui_list_back:getChildByName("Image_tank")

    self.UIRocker = ui_bottom:getChildByName("panel_slot"):getChildByName("btn_slot") --摇杆
    self.UIProfitBack = ui_bottom:getChildByName("panel_bg") --收益背景
    self.UIProfitCheck = self.UIProfitBack:getChildByName("btn_check") -- 收益勾选

    self.UIGoldCount = ui_bottom:getChildByName("num_need")
    self.UIGoldIcon = ui_bottom:getChildByName("icon_coin")
    self.UIExtraction = ui_bottom:getChildByName("btn_free")  --抽取  开始抽取，免费抽取
    self.UILottery = ui_bottom:getChildByName("btn_slotinfor")  --兑奖表
    showShader:buttonToGray(self.UIExtraction)

    self.UIIntroduce:addTouchEventListener(eventListner(ended,function()
        local strData = require("src/app/cfg/DescriptCfg").Tank_Pull_Pa
        require("src/app/views/prompt/DescriptView"):open(parent,strData)
    end))

    self.UIProfitCheck:addEventListener(function(s,e)
        if e == ccui.CheckBoxEventType.selected or e == ccui.CheckBoxEventType.unselected then
            self:updateOther()
        end
    end)

    self.UIExtraction:addTouchEventListener(eventListner(ended,function()
            self:draw()
        end))
    self.UIRocker:addTouchEventListener(eventListner(ended,function()
            self:draw()
        end))
    self.UILottery:addTouchEventListener(eventListner(ended,function()
            require("app/views/activity/AwardingTableView.lua"):open(self,self.type)
        end))

    self.IsRunning = false
    self.type = data.type
    self.MoveVec2 = cc.p(0,-120)
    self.CurGainData = nil --这个获得数据
    self.AniData = {} --相同坦克的动画数据
    self.PerGoldCost = require("src/app/data/tank_pullpa"..self.type).gold

    self:initList()

    self:initData(data)
end

--初始化数据
function TankPullPaView:initData(data)
    self.Data = data

    self:initHead(data)
    for i=1,3 do
        self:showPos(i,1)
    end
    self:updateOther()
end

--活动上半部分
function TankPullPaView:initHead(data)
    self.UITime:setString(string.format("%s~%s",
        StringTemp:toMailTime(data.startTime),StringTemp:toMailTime(data.endTime)))
    self.UIContent:setString(StringRes.tdes_2)
end

--其它刷新
function TankPullPaView:updateOther()
    local perGold = self.PerGoldCost
    self.UIRocker:setBright(not self.IsRunning)
    local isSelect = self.UIProfitCheck:isSelected()
    local count = perGold*(isSelect and 9 or 1)
    local isFree = self.Data.freeCount>0
    self.UIGoldCount:setString(isFree and 0 or count)
    self.UIProfitBack:setVisible(not isFree)
    SpecialView:setEnabled(self.UIExtraction,not self.IsRunning)
    self.UIExtraction:setTitleText(isFree and StringRes.free_lottery_tank or StringRes.start_lottery_tank)
    local icons = isFree and gButtonTextures[2] or gButtonTextures[1]
    self.UIExtraction:loadTextures(icons[1],icons[2])
end

--初始化列表
function TankPullPaView:initList()
    local ui_list,ui_item = nil,nil
    local iconCount = #gTankPullPaIcon
    local posTable = {}
    for i = 1 , 3 do
        ui_list = self["UITankList"..i]
        for j = 1, iconCount do
            ui_item = self.UITankItem:clone()
            ui_list:pushBackCustomItem(ui_item)
        end
        posTable[i] = cc.p(ui_list:getPosition())
    end
    self.ListPos = posTable
end

--显示出位置出来
function TankPullPaView:showPos(listIndex,pos)
    local ui_list = self["UITankList"..listIndex]
    ui_list:setPosition(self.ListPos[listIndex])
    local iconCount = #gTankPullPaIcon
    for j = 1, iconCount do
        local icon = gTankPullPaIcon[(iconCount-j%iconCount+pos-2)%iconCount + 1]
        local ui_item = ui_list:getItem(j-1)
        Common:changePic(ui_item,icon)
    end
end

--抽取奖励
function TankPullPaView:draw()
    if self.IsRunning then
        self:endDraw()
    else
        self:commonEffect()
        local isTen = self.UIProfitCheck:isSelected()
        local playerInfo = PlayerData:getInstanse().basicData
        local own,need = playerInfo.gold,(self.Data.freeCount>0) and 0 or (isTen and 9 or 1)*self.PerGoldCost
        if own < need then
            PromptView:goldUnenought(need,own)
        else
            local msg = {type=self.type,ten = isTen and 1 or 0}
            Connect:sendMsg("ActivityTankLabaAction","pullLaba",msg,function(newMsg)
                playerInfo.gold = newMsg.gold
                self.CurGainData = newMsg
                self.IsRunning = true
                self:updateOther()
                local ids = StringTemp:toArray(newMsg.tankIds..",")
                handleIds(ids)
                self:drawEffect({40+ids[1],100+ids[2],80+ids[3]},{0.2,0.1,0.12},function()
                    self:endDraw()
                end)
            end,true)
        end
    end
end

--抽取动画
function TankPullPaView:drawEffect(nums,timeT,callback)
    local curIndex = 0
    local function callbackIndex(index)
        curIndex = curIndex + 1
        if curIndex >= 3 then
            callback()
        end
    end

    local curPosTable = {0,0,0}
    for i = 1, 3 do
        local func = nil
        func = function()
            local node = self["UITankList"..i]
            local next = curPosTable[i] + 1
            local multiple = ((nums[i]-next) <= 10) and (11-(nums[i]-next)) or 1
            NodeTranslator:transMoveBy(node,timeT[i]*multiple,self.MoveVec2,function()
                curPosTable[i] = next
                self:showPos(i,(next-1)%(#gTankPullPaIcon) + 1)
                if curPosTable[i] < tonumber(nums[i]) then
                    func()
                else
                    callbackIndex(i)
                end
            end)
        end
        func()
    end
end

--私有结束抽取方法
function TankPullPaView:endDraw()
    if not self.IsRunning then
        return
    end

    local data = self.CurGainData
    local ids = StringTemp:toArray(data.tankIds..",")
    handleIds(ids)
    for i = 1 , 3 do   --结束动画把设置成最后一个的位置
        self["UITankList"..i]:stopAllActions()
        self:showPos(i,ids[i])
    end
--    SpecialView:setEnabled(self.UIRocker,false) --让其在出来结果的时候不能点击
--    self:drawEffect(ids,{0.4,0.5,0.6},function(index)
        self.IsRunning = false
        self:commonEffect(ids)
--        SpecialView:setEnabled(self.UIRocker,true)
        if self.Data.freeCount > 0 then
            self.Data.freeCount = self.Data.freeCount - 1
        end
        local modelStr,promptStr = "%s x%s",StringRes.pull_pa_gain
        for _,info in ipairs(data.labaEnds) do
            promptStr = promptStr .. string.format(modelStr,StringRes[Tank[info.rewardTankId].name],info.rewardTankCount)
        end
        FlyWordPrompt:prompt(promptStr)
        self:updateOther()
--    end)
end

--相同坦克动画改变
function TankPullPaView:commonEffect(ids)
    --结束
    for _, v in ipairs(self.AniData) do
        v.item:removeChild(v.ani)
    end
    self.AniData = {}
    if ids then
        local posTable = getCommonPos(ids)
        for _,pos in ipairs(posTable) do
            local ui_item = self["UITankList"..pos]:getItem(2)
            local aniNode = Animation:createAnimation("art/UI/effect/rotating;rotating;rotating","rotating")
            local size = ui_item:getContentSize()
            aniNode:setPosition(size.width/2,size.height/2)
            aniNode:setScale(1.3)
            ui_item:addChild(aniNode)
            table.insert(self.AniData,{item=ui_item,ani=aniNode})
        end
    end
end

--打开
function TankPullPaView:open(parent,data)
    Connect:sendMsg("ActivityTankLabaAction","openLaba",{type=data},function(newMsg)
        newMsg.type = data
        local newPage = self.new(parent,newMsg)
        parent:addChild(newPage)
    end,true)

end

return TankPullPaView