local ArmyGroupCheckInfo = class("ArmyGroupCheckInfo",function(data)
    return CCUILoader:load("csd/army_group/layer_army_group_checkinfo.csb")
end)

function ArmyGroupCheckInfo:show(parent,data,pos)
    local layer = ArmyGroupCheckInfo.new(data)
    if pos then
        layer:setPosition(pos)
    end
    parent:addChild(layer)
    local panel_mask = layer:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    NodeTranslator:transZoomOut(panel_bg,nil)
end

function ArmyGroupCheckInfo:ctor(data)
    self.fromNode = data
    self.data = data.infoData
    self:initView()
end

function ArmyGroupCheckInfo:initView()
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")

    local btn_close = panel_bg:getChildByName("btn_close")
    btn_close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transZoomIn(panel_bg,function()
                self:removeFromParent()
            end)
        end
    end)

    --军团名
    panel_bg:getChildByName("text_name"):setString(self.data.guildName)
    --团长名
    panel_bg:getChildByName("text_leader"):setString(self.data.leaderName)
    --排名
    panel_bg:getChildByName("text_ranking"):setString(self.data.rank)
    --等级
    panel_bg:getChildByName("text_lev"):setString(self.data.lv)
    --人数
    panel_bg:getChildByName("text_people"):setString(self.data.count.."/"..self.data.countMax)
    --加入方式
    if self.data.joinType == 1 then
        panel_bg:getChildByName("text_join"):setString(StringRes.no_confirm)
    elseif self.data.joinType == 2 then
        panel_bg:getChildByName("text_join"):setString(StringRes.need_comfirm)
    end
    --加入条件
    if self.data.joincond == nil or ""==self.data.joincond then
        self.data.joincond = "0,0"
    end
    local datas = string.split(self.data.joincond,",")
    if "0,0"==self.data.joincond then
        panel_bg:getChildByName("text_condition"):setString(StringRes.have_not)
    else
        local strTmp = ""
        if datas[1]~= "0" then
            strTmp = strTmp..string.format(StringRes.army_group_lv,tonumber(datas[1]))
        end
        if datas[2]~= "0" then
            strTmp = strTmp.."  "..string.format(StringRes.attack_limit,StringTemp:toNum(tonumber(datas[2])))
        end
        panel_bg:getChildByName("text_condition"):setString(strTmp)
    end
    local pd = PlayerData:getInstanse().basicData

    --宣言
    panel_bg:getChildByName("panel_outline"):getChildByName("listview_desc"):getChildByName("text_desc"):setString(self.data.decl)

    local btn_join = panel_bg:getChildByName("btn_join")
    --    if self.data.count >= self.data.countMax or tonumber(datas[1])> pd.lv or tonumber(datas[2])>pd.comat then
    --        btn_join:loadTextureNormal(ResIconCfg.btn_negative)
    --        btn_join:loadTexturePressed(ResIconCfg.btn_negativePress)
    --        panel_bg:getChildByName("text_condition"):setColor(CommonColor.Red)
    --    end


    if self.data.hasArmyGroup then--是否有军团
        btn_join:setVisible(false)
    end

    if tonumber(datas[1])> pd.lv or tonumber(datas[2])>pd.comat then
        btn_join:setEnabled(false)
        showShader:buttonToGray(btn_join)
        btn_join:setBright(false)
        panel_bg:getChildByName("text_condition"):setColor(CommonColor.Red)
        return
    end

    if self.data.count >= self.data.countMax then --人数满不能申请
        showShader:buttonToGray(btn_join)
        btn_join:setEnabled(false)
        btn_join:setBright(false)
        return
    end


    if self.data.operate == 2 then --申请中
        btn_join:loadTextureNormal(ResIconCfg.btn_negative)
        btn_join:loadTexturePressed(ResIconCfg.btn_negativePress)
        btn_join:setTitleText(StringRes.cancel_apply)

        btn_join:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                Connect:sendMsg("GuildAction","cancelApplyGuild",{guildId = self.data.guildId},function(data)

                        self.data.operate = 1
                        local btn_check = self.fromNode
                        btn_check:loadTextureNormal(ResIconCfg.btn_positive)
                        btn_check:loadTexturePressed(ResIconCfg.btn_positivePress)
                        btn_check:setTitleText(StringRes.check)

                        FlyWordPrompt:prompt(string.format(StringRes.cancel_apply_info,self.data.guildName))

                        NodeTranslator:transZoomIn(panel_bg,function()
                            self:removeFromParent()
                        end)

                end)
            end
        end)

    else
        btn_join:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                Connect:sendMsg("GuildAction","applyGuild",{guildId = self.data.guildId},function(data)
                    if data.state == 1 then
                        local pd = PlayerData:getInstanse()
                        pd.basicData.guildId = data.guildId
                        pd.basicData.guildLv = 1
                        self:getParent():close()
                        FlyWordPrompt:prompt(StringRes.join_success)
                    elseif data.state == 2 then
                        self.data.operate = 2
                        local btn_check = self.fromNode
                        btn_check:loadTextureNormal(ResIconCfg.btn_negative)
                        btn_check:loadTexturePressed(ResIconCfg.btn_negativePress)
                        btn_check:setTitleText(StringRes.applying)
                        NodeTranslator:transZoomIn(panel_bg,function()
                            self:removeFromParent()
                        end)
                        FlyWordPrompt:prompt(string.format(StringRes.wait_approval,self.data.guildName))
                    end

                end)
            end
        end)
    end

end



return ArmyGroupCheckInfo