
local ArmyGroupFB = class("ArmyGroupFB",function(data)
    return CCUILoader:load("csd/army_group/ui_army_group_copy.csb")
end)

function ArmyGroupFB:show(parent)
    
    Connect:sendMsg("GuildAction","openGuildFb",msg,
        function (data)
            local layer = ArmyGroupFB.new(data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end,nil)
end

function ArmyGroupFB:ctor(data)
    self:initView()
--    self:getFBData()
    self.nowCharId = data.nowCharId
    self.data = data
    self:updateView(data)
end

function ArmyGroupFB:initView()
    self:getChildByName("bg"):getChildByName("text_title"):setString(StringRes.army_group_fb)
    self:getChildByName("bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transDown(self,function()
                self:removeFromParent()
            end)
        end
    end)
    self.listview = self:getChildByName("listview_copy")
    local btn_info = self:getChildByName("panel_base"):getChildByName("btn_info")
    btn_info:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            local DescriptCfg = require("src/app/cfg/DescriptCfg")
            DescriptView:open(self,DescriptCfg.AGFB_Info)
        end
    end)

    ViewManager:OpenView(self)
end

function ArmyGroupFB:getFBData(showLoading)
    local msg = {}
    Connect:sendMsg("GuildAction","openGuildFb",msg,
        function (data)
            self.nowCharId = data.nowCharId
            self.data = data
            self:updateView(data)
            local child = self:getChildByTag(56789)
            if child then child:setData(data) end
        end,showLoading)
end

function ArmyGroupFB:updateView(data)
    self.listview:removeAllItems()
    local tmpItem = self:getChildByName("panel_copy")
    self:getChildByName("panel_base"):getChildByName("text_times"):setString(string.format(StringRes.atk_count_info,data.atkCount,data.atkCountMax))
    for i , v in ipairs(data.guildFBVOs) do
        local item = tmpItem:clone()
        item.tag_atkData = v
        item.tag_getData = data.guildFBMissionVOs[i]
        self:updateItem(item)
        self.listview:pushBackCustomItem(item)
    end
end

function ArmyGroupFB:updateItem(item)
    local tag_atkData = item.tag_atkData
    local tag_getData = item.tag_getData
    local btn_check = item:getChildByName("btn_check")
    local text_name = item:getChildByName("text_name")
    text_name:setString(StringRes["guildchap_"..tag_atkData.charId])
    local star_bg = item:getChildByName("icon_copy")
    local icon_lock = star_bg:getChildByName("icon_lock")
    local text_round = item:getChildByName("text_round")
    text_round:setString(string.format(StringRes.round_info,string.format("%d/%d",tag_atkData.winCount,5)))
    local text_reward = item:getChildByName("text_reward")
    text_reward:setString(string.format(StringRes.reward_info,string.format("%d/%d",tag_getData.getCount,5)))
    if tag_atkData.charId > self.nowCharId then--未解锁
        icon_lock:setVisible(true)
        text_name:setColor(CommonColor.Grey)
        btn_check:setEnabled(false)
        showShader:buttonToGray(btn_check)
        btn_check:setBright(false)
    else
        icon_lock:setVisible(false)
        text_name:setColor(CommonColor.Blue2)
        btn_check:setEnabled(true)
        btn_check:setBright(true)
        btn_check:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                self.data.tag_charId = tag_atkData.charId
                require("src/app/views/armygroup/ArmyGroupFBDetail"):show(self,self.data)
            end
        end)
    end
    self:showItemStar(star_bg,tag_atkData.charId)
end

function ArmyGroupFB:showItemStar(view,index)
    for i=1,5,1 do
        local v = view:getChildByName("panel_star_"..i)
        v:setVisible(i == index)
    end
end

return ArmyGroupFB