
local ArmyGroupFBDetail = class("ArmyGroupFBDetail",function(data)
    return CCUILoader:load("csd/army_group/ui_army_group_copy_detail.csb")
end)

function ArmyGroupFBDetail:show(parent,data)
    local layer = ArmyGroupFBDetail.new(data)
    layer:setTag(56789)
    parent:addChild(layer)
    NodeTranslator:transUp(layer,nil)
end

function ArmyGroupFBDetail:ctor(data)
    self.data = data
    self:initView()
    self:getFBDetailData()
end

function ArmyGroupFBDetail:initView()
    self:getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transDown(self,function()
                self:removeFromParent()
            end)
        end
    end)
    local btn_info = self:getChildByName("btn_info")
    btn_info:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            local DescriptCfg = require("src/app/cfg/DescriptCfg")
            DescriptView:open(self,DescriptCfg.AGFB_Detail_Info)
        end
    end)
end

function ArmyGroupFBDetail:getFBDetailData(showLoading)
    local msg = {charId = self.data.tag_charId}
    Connect:sendMsg("GuildAction","openFbInfo",msg,
        function (data)
            self:updateViews(data)
        end,showLoading)
end

--最后一关贡献花费
local COST = {2,6,15,20,30}

function ArmyGroupFBDetail:updateViews(data)
    for i,v in ipairs(data)do
        local panel_chapter = self:getChildByName("panel_chapter_"..v.missionId)
        if panel_chapter then
            local tagId = self.data.tag_charId.."_"..v.missionId
            local icon_unlock = panel_chapter:getChildByName("icon_lock")
            local text_title = panel_chapter:getChildByName("panel_title_bg"):getChildByName("text_title_box")
            local icon_item = panel_chapter:getChildByName("icon_copy")
            local panel_progress_bg = panel_chapter:getChildByName("panel_progress_bg")
            if not v.unlock then --未解锁
                icon_unlock:setVisible(true)
                panel_progress_bg:setVisible(true)
                panel_progress_bg:getChildByName("loadingbar_attack"):setPercent(v.hp/v.hpMax*100)
                text_title:setString(gGuildFb[tagId].fbname)
                local str_icons = string.split(gGuildFb[tagId].icon,";")
                icon_item:loadTexture(str_icons[1]..".png",ResType)
                if #str_icons > 1 then
                    for k =2 , #str_icons , 1 do
                        local item = icon_item:getChildByName("icon_copy_"..k)
                        if item then 
                            local zorder = -1
                            if k == 5 then 
                                zorder = -2
                            end
                            item:setLocalZOrder(zorder)
                            item:loadTexture(str_icons[k]..".png",ResType) 
                        end
                    end
                end
                panel_chapter:setEnabled(false)
            elseif v.boxState == 2 then --已打开
                icon_unlock:setVisible(false)
                panel_progress_bg:setVisible(false)
                text_title:setString(gGuildFbReward[tagId].boxname)
                icon_item:loadTexture(gGuildFbReward[tagId].icon2,ResType)
                local str_icons = string.split(gGuildFb[tagId].icon,";")
                if #str_icons > 1 then
                    icon_item:setPositionY(140)
                    for k =2 , #str_icons , 1 do
                        local item = icon_item:getChildByName("icon_copy_"..k)
                        if item then item:setVisible(false) end
                    end
                end
                panel_chapter:setEnabled(false)
            elseif v.boxState == 1 then --可打开
                icon_unlock:setVisible(false)
                panel_progress_bg:setVisible(false)
                text_title:setString(gGuildFbReward[tagId].boxname)
                icon_item:loadTexture(gGuildFbReward[tagId].icon1,ResType)
                local str_icons = string.split(gGuildFb[tagId].icon,";")
                if #str_icons > 1 then
                    icon_item:setPositionY(140)
                    for k =2 , #str_icons , 1 do
                        local item = icon_item:getChildByName("icon_copy_"..k)
                        if item then item:setVisible(false) end
                    end
                end
                panel_chapter:setEnabled(true)
                panel_chapter:addTouchEventListener(function(e, t)
                    if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                        
                        function getBox()
                            --获取军团奖励箱子
                            local msg = {charId = self.data.tag_charId,missionId = v.missionId}
                            Connect:sendMsg("GuildAction","getBoxReward",msg,
                                function (data)
                                    panel_chapter:setEnabled(false)
                                    icon_item:loadTexture(gGuildFbReward[tagId].icon2,ResType)
                                    self:getParent():getFBData(false)
                                    FlyWordPrompt:prompt(StringRes[gItem[data.templatId].name].."*"..data.count)
                                end)
                        end
                        
                        if v.missionId == 5 then
                            PromptView:type2(StringRes.notice,
                                string.format(StringRes.get_box_info,COST[self.data.tag_charId])
                                ,StringRes.ok,StringRes.cancel,
                                function()
                                    getBox()
                                end)
                        else
                            getBox()
                        end
                    
                        
                    end
                end)
            elseif v.boxState == 0 then --可挑战
                icon_unlock:setVisible(false)
                panel_progress_bg:setVisible(true)
                panel_progress_bg:getChildByName("loadingbar_attack"):setPercent(v.hp/v.hpMax*100)
                text_title:setString(gGuildFb[tagId].fbname)
                local str_icons = string.split(gGuildFb[tagId].icon,";")
                icon_item:loadTexture(str_icons[1]..".png",ResType)
                if #str_icons > 1 then
                    for k =2 , #str_icons , 1 do
                        local item = icon_item:getChildByName("icon_copy_"..k)
                        if item then 
                            local zorder = -1
                            if k == 5 then 
                                zorder = -2
                            end
                            item:setLocalZOrder(zorder)
                            item:loadTexture(str_icons[k]..".png",ResType) 
                        end
                    end
                end
                panel_chapter:setEnabled(true)
                panel_chapter:addTouchEventListener(function(e, t)
                    if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                        NodeTranslator:changeColor(icon_item,function()
                                v.tag_FBData = self.data
                                require("src/app/views/armygroup/ArmyGroupFBDetailInfo"):show(self,v)
                            end)
                    end
                end)
            end


        end
    end
end

function ArmyGroupFBDetail:updateFromServer()
    self:getParent():getFBData(false)
end

function ArmyGroupFBDetail:setData(data)
    data.tag_charId = self.data.tag_charId
    self.data = data
    self:getFBDetailData(false)
end

return ArmyGroupFBDetail