
local ArmyGroupFBDetailInfo = class("ArmyGroupFBDetailInfo",function(data)
    return CCUILoader:load("csd/army_group/ui_army_group_copy_detail_info.csb")
end)

function ArmyGroupFBDetailInfo:show(parent,data)
    local layer = ArmyGroupFBDetailInfo.new(data)
    parent:addChild(layer)
    NodeTranslator:transUp(layer,nil)
end

function ArmyGroupFBDetailInfo:ctor(data)
    self.data = data
    self:initView()
end

function ArmyGroupFBDetailInfo:initView()
    local fbData = self.data.tag_FBData
    local tagId = fbData.tag_charId.."_"..self.data.missionId
    self:getChildByName("bg"):getChildByName("text_title"):setString(gGuildFb[tagId].fbname)
    self:getChildByName("bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transDown(self,function()
                self:removeFromParent()
            end)
        end
    end)
    self.listview = self:getChildByName("listview")
    local btn_challenge = self:getChildByName("btn_challenge")
    if fbData.atkCount>=fbData.atkCountMax then
        btn_challenge:setEnabled(false)
        showShader:buttonToGray(btn_challenge)
        btn_challenge:setBright(false)
    else
        btn_challenge:setEnabled(true)
        btn_challenge:setBright(true)
        btn_challenge:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                local TroopsView = require("src/app/views/troops/TroopsView")
                local msg = {cid = fbData.tag_charId , mid = self.data.missionId , avoid = self.jd_item.state , support = self.kz_item.state}
                TroopsView:open(self:getParent(),6,msg)
                NodeTranslator:transDown(self,function()
                    self:removeFromParent()
                end)
            end
        end)
    end
    
    self:getChildByName("text_round"):setString(string.format(StringRes.atk_count_info,fbData.atkCount,fbData.atkCountMax))
    
    local panel_item_header = self:getChildByName("panel_item_header")
    panel_item_header:removeFromParent()
    self.listview:pushBackCustomItem(panel_item_header)
    
    local panel_item = self:getChildByName("panel_item")
    local jd_item = panel_item:clone()
    self.jd_item = jd_item
    jd_item.id = self.data.jdId
    jd_item.tid = self.data.jdtempId
    jd_item.count = self.data.jdcount
    jd_item.state = 0
    self:updateProp(jd_item)
    self.listview:pushBackCustomItem(jd_item)
    
    local kz_item = panel_item:clone()
    self.kz_item = kz_item
    kz_item.id = self.data.kzId
    kz_item.tid = self.data.kztempId
    kz_item.count = self.data.kzcount
    kz_item.state = 0
    self:updateProp(kz_item)
    self.listview:pushBackCustomItem(kz_item)
    
    --击败奖励
    local panel_reward_header = self:getChildByName("panel_reward_header")
    panel_reward_header:removeFromParent()
    self.listview:pushBackCustomItem(panel_reward_header)
    
    local panel_reward = self:getChildByName("panel_reward")
    panel_reward:removeFromParent()
    self.listview:pushBackCustomItem(panel_reward)
    panel_reward:getChildByName("text_desc_1"):setString(string.format(StringRes.army_group_exp_info,gGuildFb[tagId].expguild))
    panel_reward:getChildByName("text_desc_2"):setString(gGuildFbReward[tagId].boxname)
    
    local panel_enemy_header = self:getChildByName("panel_enemy_header")
    panel_enemy_header:removeFromParent()
    self.listview:pushBackCustomItem(panel_enemy_header)
    
    local panel_enemy = self:getChildByName("panel_enemy")
    panel_enemy:removeFromParent()
    self.listview:pushBackCustomItem(panel_enemy)
    self:updateTroops(panel_enemy)
end

function ArmyGroupFBDetailInfo:updateBtn(btn_use,state)
    if state == 0 then
        btn_use:setTitleText(StringRes.use)
        btn_use:loadTextureNormal(ResIconCfg.btn_positive)
        btn_use:loadTexturePressed(ResIconCfg.btn_positivePress)
    elseif state ==1 then
        btn_use:setTitleText(StringRes.cancel)
        btn_use:loadTextureNormal(ResIconCfg.btn_delete)
        btn_use:loadTexturePressed(ResIconCfg.btn_deletePress)
    end
end

function ArmyGroupFBDetailInfo:updateProp(item)
    local info = gItem[item.tid]
    local icon_item = item:getChildByName("icon_item")
    icon_item:loadTexture(info.icon,ResType)
    local text_have = item:getChildByName("text_have")
    text_have:setString(string.format(StringRes.have_count,item.count))
    local text_name = item:getChildByName("text_name")
    text_name:setString(StringRes[info.name])
    local text_desc = item:getChildByName("text_desc")
    text_desc:setString(StringRes[info.desc])
    local btn_use = item:getChildByName("btn_use")
    
    self:updateBtn(btn_use,item.state)
    btn_use:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if item.count>0 then--有该道具
                if item.state == 0 then
                    item.state = 1
                elseif item.state == 1 then
                    item.state = 0
                end
                self:updateBtn(btn_use,item.state)
            else
                DialogUtil:buy(gStore[item.tid].price*15,StringRes[gItem[item.tid].name],function()
                    local pd = PlayerData:getInstanse()
                    local senddata = {id = item.tid}
                    Connect:sendMsg("ShopAction","buyShopItems",senddata,
                        function(data)
                            if data.state == 1 then
                                pd.basicData.gold = data.gold
                                item.state = 1
                                item.count = 1
                                if self.kz_item == item then
                                    self.data.kzcount = 1
                                elseif self.jd_item == item then
                                    self.data.jdcount = 1
                                end
                                self:updateProp(item)
                            else
                            --购买失败

                            end

                        end)
                end)
            end
        end
    end)
end

function ArmyGroupFBDetailInfo:updateTroops(view)
    for i,v in ipairs(self.data.troopsInfoVOs) do
        local item = view:getChildByName("panel_enemy_"..i)
        if item then 
            local info = Tank[v.tankTempId]
            local text_name = item:getChildByName("text_name")
            text_name:setString(StringRes[info.name])
            local icon_tank = item:getChildByName("icon_tank")
            icon_tank:loadTexture(info.icon,ResType)
            local text_num = icon_tank:getChildByName("text_num")
            text_num:setString(string.format(StringRes.item_num,v.count,v.countMax))
            local text_attack = item:getChildByName("icon_attack"):getChildByName("text_attack")
            text_attack:setString(v.atk)
            local text_hp = item:getChildByName("icon_hp"):getChildByName("text_hp")
            text_hp:setString(v.hp)
        end
    end
    if #(self.data.troopsInfoVOs) < 6 then
        for i=#(self.data.troopsInfoVOs)+1,6,1 do
            local item = view:getChildByName("panel_enemy_"..i)
            if item then item:setVisible(false) end
        end
    end
end

return ArmyGroupFBDetailInfo