
local ArmyGroupInfo = class("ArmyGroupInfo",function(node)
    return node
end)

function ArmyGroupInfo:ctor(node)
    --简介数据
    self.armyGroupInfoData = nil
    --成员列表数据
    self.armyGroupMemberData = nil
    --贡献排名数据
    self.armyGroupDonationData = nil
    --申请列表数据
    self.armyGroupApplicationData = nil
    self:initInfoTabs()
    --    self:getArmyGroupInfoData()
    --    self:getArmyGroupMemberData()
    --    self:getArmyGroupDonationData()
--    self:showInfoTab(1)

    --活跃度推送
    self:registGuildActive()

end

function ArmyGroupInfo:registGuildActive()
    local function registerGuildActiveNotification()
        Connect:register("notifyGuildActive",function(data)
            if data then
                AcademyCommon:copyValues(self.armyGroupInfoData,data)
                --活跃等级
                local listview = self.infoTabViews[1]:getChildByName("listview_announcement")
                local btn_activity = listview:getChildByName("panel_activity"):getChildByName("btn_activity")
                btn_activity:getChildByName("icon_patch"):getChildByName("text_num"):setString(self.armyGroupInfoData.activeLv)
                btn_activity:getChildByName("text_num"):setString(self.armyGroupInfoData.active.."/"..self.armyGroupInfoData.activeMax)
                btn_activity:getChildByName("progress_bg"):getChildByName("progress_bar_xp"):setPercent(self.armyGroupInfoData.active/self.armyGroupInfoData.activeMax*100)
            end
        end)
    end
    registerGuildActiveNotification()
    local function onNodeEvent(tag)
        if tag == "exit" then
            Connect:unregister("notifyGuildActive")
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

--===============================简介
function ArmyGroupInfo:getArmyGroupInfoData()
    if self.armyGroupInfoData == nil then
        Connect:sendMsg("GuildAction","openGuild",{},function(data)
            self.armyGroupInfoData = data
            self:updateOverview()
            self:getArmyGroupApplicationData()
        end)
    end
end

function ArmyGroupInfo:updateOverview()

    local listview = self.infoTabViews[1]:getChildByName("listview_announcement")
    listview:setGravity(2)
    --活跃等级
    local btn_activity = listview:getChildByName("panel_activity"):getChildByName("btn_activity")
    btn_activity:getChildByName("icon_patch"):getChildByName("text_num"):setString(self.armyGroupInfoData.activeLv)

    btn_activity:getChildByName("text_num"):setString(self.armyGroupInfoData.active.."/"..self.armyGroupInfoData.activeMax)
    btn_activity:getChildByName("progress_bg"):getChildByName("progress_bar_xp"):setPercent(self.armyGroupInfoData.active/self.armyGroupInfoData.activeMax*100)
    btn_activity:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:btnEffect(btn_activity,function()
                require("src/app/views/armygroup/ArmyGroupActivity"):show(self:getParent(),self.armyGroupInfoData)
            end)
        end
    end)

    --公告
    local panel_announcement = listview:getChildByName("panel_announcement"):getChildByName("panel_announcement")
    panel_announcement:getChildByName("listview_announcement"):setPropagateTouchEvents(false)
    panel_announcement:getChildByName("listview_announcement"):getChildByName("text_desc"):setString(self.armyGroupInfoData.notice)

    --军团名
    local panel_name = self.infoTabViews[1]:getChildByName("panel_name")
    local text_name = panel_name:getChildByName("text_name")
    text_name:setString(self.armyGroupInfoData.guildName)

    --军团长
    local text_leader = panel_name:getChildByName("text_leader")
    text_leader:setString(string.format(StringRes.army_group_leader,self.armyGroupInfoData.leaderName))

    --军团等级
    local text_lev = panel_name:getChildByName("text_lev")
    text_lev:setString(string.format(StringRes.army_group_lv,self.armyGroupInfoData.guildLv))

    --战斗力
    local text_attack = panel_name:getChildByName("icon_attack"):getChildByName("text_num")
    text_attack:setString(StringTemp:toNum(self.armyGroupInfoData.combat))

    --人数
    local text_member = panel_name:getChildByName("icon_member"):getChildByName("text_num")
    text_member:setString(self.armyGroupInfoData.count.."/"..self.armyGroupInfoData.countMax)
    self.infoTabViews[2]:getChildByName("text_member"):setString(string.format(StringRes.member_info,self.armyGroupInfoData.count.."/"..self.armyGroupInfoData.countMax))

    --军团资金
    local text_fortune = panel_name:getChildByName("icon_fortune"):getChildByName("text_num")
    text_fortune:setString(StringTemp:toNum(self.armyGroupInfoData.capital))

    --排名
    local text_ranking = panel_name:getChildByName("icon_ranking"):getChildByName("text_num")
    text_ranking:setString(self.armyGroupInfoData.rank)

    --加入方式，加入条件
    local panel_join = listview:getChildByName("panel_join")
    local text_desc_1 = panel_join:getChildByName("text_desc_1")
    if self.armyGroupInfoData.joinType == 1 then
        text_desc_1:setString(StringRes.no_confirm)
    elseif self.armyGroupInfoData.joinType == 2 then
        text_desc_1:setString(StringRes.need_comfirm)
    end

    local datas = string.split(self.armyGroupInfoData.joincond,",")
    local text_desc_2 = panel_join:getChildByName("text_desc_2")
    local strTmp = ""

    if self.armyGroupInfoData.joincond == "" or self.armyGroupInfoData.joincond == "0,0" then
        strTmp = StringRes.have_not
    else
        if datas[1]~= "0" then
            strTmp = strTmp..string.format(StringRes.army_group_lv,tonumber(datas[1]))
        end
        if datas[2]~= "0" then
            strTmp = strTmp.."  "..string.format(StringRes.attack_limit,StringTemp:toNum(tonumber(datas[2])))
        end
    end

    text_desc_2:setString(strTmp)

    --退出军团
    local btn_quite = self.infoTabViews[1]:getChildByName("btn_quite")
    btn_quite:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self.armyGroupInfoData.job == 1 and self.armyGroupInfoData.count > 1 then --团长
                FlyWordPrompt:prompt(StringRes.leader_cannot_quite)
            else

                local info = StringRes.ok_quite_army_group

                if self.armyGroupInfoData.job == 1 then
                    info = StringRes.leader_quite
                end

                PromptView:inputOK(
                    function()
                        local msg = {}
                        Connect:sendMsg("GuildAction","quitGuild",msg,
                            function (data)
                                if data.state == 1 then
                                    local pd = PlayerData:getInstanse()
                                    pd.basicData.guildId = 0
                                    pd.basicData.guildLv = 0
                                    self:getParent():getParent():close()
                                    FlyWordPrompt:prompt(StringRes.quite_army_group_success)
                                end
                            end)
                    end,info)
            end
        end
    end)

    --编辑
    local btn_edit = self.infoTabViews[1]:getChildByName("btn_edit")
    if self.armyGroupInfoData.job == 1 then --团长
        btn_edit:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                require("src/app/views/armygroup/ArmyGroupEdit"):show(self,self.armyGroupInfoData)
            end
        end)
    else
        btn_edit:setVisible(false)
    end
end

--===============================简介

--===============================成员列表

function ArmyGroupInfo:getArmyGroupMemberData()
    if self.armyGroupMemberData == nil then
        Connect:sendMsg("GuildAction","getGuildPlayerInfo",{},function(data)
            self.armyGroupMemberData = data
            self:updateMemberView()
        end)
    end
end

function ArmyGroupInfo:updateMemberView()

    local btn_sendAll = self.infoTabViews[2]:getChildByName("btn_edit_Copy")
    if self.armyGroupMemberData.guildPlayerVO.job == 1 then
        btn_sendAll:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                require("src/app/views/mail/MailWriteView"):open(self:getParent(),{resver=StringRes.army_group_all_member,type=3})
            end
        end)
    else
        btn_sendAll:setVisible(false)
    end


    local listview_member = self.infoTabViews[2]:getChildByName("listview_member")
    listview_member:removeAllItems()

    local itemTmp = self.infoTabViews[2]:getChildByName("panel_player")

    local itemSelf = itemTmp:clone()
    self.armyGroupMemberData.guildPlayerVO.isSelf = true
    self:updateMemberItem(itemSelf,self.armyGroupMemberData.guildPlayerVO)
    listview_member:pushBackCustomItem(itemSelf)

    for i,v in ipairs(self.armyGroupMemberData.guildPlayerVOs) do
        local item= itemTmp:clone()
        v.isSelf = false
        self:updateMemberItem(item,v)
        listview_member:pushBackCustomItem(item)
    end

end

function ArmyGroupInfo:updateMemberItem(item,data)
    item:getChildByName("panel_bg"):setVisible(data.isSelf)
    local text_ranking = item:getChildByName("text_ranking")
    text_ranking:setString(data.rank)
    local text_list = item:getChildByName("text_list")
    text_list:setString(data.playerName)
    local text_lev = item:getChildByName("text_lev")
    text_lev:setString(data.lv)
    local text_attack = item:getChildByName("text_attack")
    text_attack:setString(StringTemp:toNum(data.combat))

    local icon_job = item:getChildByName("icon_job")
    if data.job == 1 then
        icon_job:loadTexture(ResIconCfg.icon_leader,ResType)
    elseif data.job == 2 then
        icon_job:loadTexture(ResIconCfg.icon_deputy,ResType)
    elseif data.job == 3 then
        icon_job:loadTexture(ResIconCfg.icon_soldier,ResType)
    end
    --是否在线
    if data.online == 1 then
        text_ranking:setColor(CommonColor.White)
        text_list:setColor(CommonColor.White)
        text_lev:setColor(CommonColor.White)
        text_attack:setColor(CommonColor.White)
    elseif data.online == 2 then
        text_ranking:setColor(CommonColor.Lightgrey)
        text_list:setColor(CommonColor.Lightgrey)
        text_lev:setColor(CommonColor.Lightgrey)
        text_attack:setColor(CommonColor.Lightgrey)
    end

    local btn_check = item:getChildByName("btn_check")
    btn_check:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            data.selfData = self.armyGroupInfoData
            require("src/app/views/armygroup/ArmyGroupMemberInfo"):show(self,data)
        end
    end)

end

--===============================成员列表


--===============================捐献排名

function ArmyGroupInfo:getArmyGroupDonationData()
--    if self.armyGroupDonationData == nil then
        Connect:sendMsg("GuildAction","getContrRank",{},function(data)
            self.armyGroupDonationData = data
            self:updateDonationView()
        end)
--    end
end

function ArmyGroupInfo:updateDonationView()
    local listview_donation = self.infoTabViews[3]:getChildByName("listview_donation")
    listview_donation:removeAllItems()

    local itemTmp = self.infoTabViews[3]:getChildByName("panel_player")

    local itemSelf = itemTmp:clone()
    self.armyGroupDonationData.guildPlayerVO.isSelf = true
    self:updateDonationItem(itemSelf,self.armyGroupDonationData.guildPlayerVO)
    listview_donation:pushBackCustomItem(itemSelf)

    for i,v in ipairs(self.armyGroupDonationData.guildPlayerVOs) do
        local item= itemTmp:clone()
        v.isSelf = false
        self:updateDonationItem(item,v)
        listview_donation:pushBackCustomItem(item)
    end
end

function ArmyGroupInfo:updateDonationItem(item,data)
    item:getChildByName("panel_bg"):setVisible(data.isSelf)
    local text_ranking = item:getChildByName("text_ranking")
    text_ranking:setString(data.rank)
    local text_list = item:getChildByName("text_list")
    text_list:setString(data.playerName)
    local text_lev = item:getChildByName("text_lev")
    text_lev:setString(data.lv)
    local text_donation = item:getChildByName("text_donation")
    text_donation:setString(data.lastweekContr)

    local icon_job = item:getChildByName("icon_job")
    if data.job == 1 then
        icon_job:loadTexture(ResIconCfg.icon_leader)
    elseif data.job == 2 then
        icon_job:loadTexture(ResIconCfg.icon_deputy)
    elseif data.job == 3 then
        icon_job:loadTexture(ResIconCfg.icon_soldier)
    end
    --是否在线
    if data.online == 1 then
        text_ranking:setColor(CommonColor.White)
        text_list:setColor(CommonColor.White)
        text_lev:setColor(CommonColor.White)
        text_donation:setColor(CommonColor.White)
    elseif data.online == 2 then
        text_ranking:setColor(CommonColor.Lightgrey)
        text_list:setColor(CommonColor.Lightgrey)
        text_lev:setColor(CommonColor.Lightgrey)
        text_donation:setColor(CommonColor.Lightgrey)
    end

end

--===============================捐献排名


--===============================申请列表

function ArmyGroupInfo:getArmyGroupApplicationData()
    if self.armyGroupApplicationData == nil then
        Connect:sendMsg("GuildAction","getGuildApplyList",{},function(data)
            self.armyGroupApplicationData = data
            self:updateApplicationView()
        end)
    end
end

function ArmyGroupInfo:updateApplicationView()
    self.listview_application = self.infoTabViews[4]:getChildByName("listview_application")
    self.listview_application:removeAllItems()

    local text_no_application = self.infoTabViews[4]:getChildByName("text_no_application")
    if self.armyGroupApplicationData == nil or #(self.armyGroupApplicationData)==0 then
        text_no_application:setVisible(true)
    else
        text_no_application:setVisible(false)
        local itemTmp = self.infoTabViews[4]:getChildByName("panel_player")
        for i,v in ipairs(self.armyGroupApplicationData) do
            if not v.isDel then
                local item= itemTmp:clone()
                self:updateApplicationItem(item,v)
                self.listview_application:pushBackCustomItem(item)
            end
        end
    end

    local btn_reject_all = self.infoTabViews[4]:getChildByName("btn_reject_all")
    if self.armyGroupInfoData and (self.armyGroupInfoData.job == 1 or self.armyGroupInfoData.job ==2 ) and #self.armyGroupApplicationData > 0 then
        btn_reject_all:setEnabled(true)
        btn_reject_all:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                --                if #self.listview_application:getItems() > 0 then
                Connect:sendMsg("GuildAction","refuseAllApply",{},function(data)
                    if data.state == 1 then
                        self.armyGroupApplicationData = {}
                        self:updateApplicationView()
                    end
                end)
                --                else
                --                    FlyWordPrompt:prompt("fanyi")
                --                end
            end
        end)
    else
        btn_reject_all:setEnabled(false)
        showShader:buttonToGray(btn_reject_all)
        btn_reject_all:setBright(false)
    end

end

function ArmyGroupInfo:checkHasApplication()
    local counter = 0
    for i,v in ipairs(self.armyGroupApplicationData) do
        if not v.isDel then
            counter = counter+1
        end
    end
    if counter== 0 then
        local text_no_application = self.infoTabViews[4]:getChildByName("text_no_application")
        text_no_application:setVisible(true)
        local btn_reject_all = self.infoTabViews[4]:getChildByName("btn_reject_all")
        btn_reject_all:setEnabled(false)
        showShader:buttonToGray(btn_reject_all)
        btn_reject_all:setBright(false)
    end
end

function ArmyGroupInfo:updateApplicationItem(item,data)
    item:getChildByName("panel_bg"):setVisible(data.isSelf)
    local text_list = item:getChildByName("text_list")
    text_list:setString(data.playerName)
    local text_lev = item:getChildByName("text_lev")
    text_lev:setString(data.lv)
    local text_attack = item:getChildByName("text_attack")
    text_attack:setString(StringTemp:toNum(data.combat))
    local btn_reject = item:getChildByName("btn_reject")
    local btn_approve = item:getChildByName("btn_approve")
    if self.armyGroupInfoData and (self.armyGroupInfoData.job == 1 or self.armyGroupInfoData.job ==2 ) then
        btn_reject:setEnabled(true)
        btn_reject:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                Connect:sendMsg("GuildAction","refuseApply",{applyPlayerId = data.playerId},function(sdata)
                    if sdata.state == 1 then
                        --                        item:removeFromParent()
                        data.isDel = true
                        self:updateApplicationView()
                        self:checkHasApplication()
                    end
                end)
            end
        end)
        btn_approve:setEnabled(true)
        btn_approve:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                Connect:sendMsg("GuildAction","agreeGuildApply",{applyPlayerId = data.playerId},function(sdata)
                    if sdata.state == 1 then
                        --                        item:removeFromParent()
                        data.isDel = true
                        self:updateApplicationView()
                        self:checkHasApplication()
                        self:refreshArmyGroupInfo()
                    elseif sdata.state == 2 then
                        FlyWordPrompt:prompt(StringRes.player_cancel)
                        data.isDel = true
                        self:updateApplicationView()
                        self:checkHasApplication()
                    end
                end)
            end
        end)
    else
        btn_reject:setEnabled(false)
        btn_approve:setEnabled(false)
        btn_reject:setVisible(false)
        btn_approve:setVisible(false)
    end

end

--===============================申请列表

function ArmyGroupInfo:showInfoTab(index)
    for i,v in ipairs(self.infoTabs) do
        Common:setButtonEnabled(v,i~=index)
        self.infoTabViews[i]:setVisible(i == index)
    end
    if index == 1 then
        self:getArmyGroupInfoData()
    elseif index == 2 then
        self:getArmyGroupMemberData()
    elseif index == 3 then
        self:getArmyGroupDonationData()
    end
end

function ArmyGroupInfo:setTabVisible(vis)
    self:setVisible(vis)
    self:showInfoTab(1)
    --    if vis then self:refreshArmyGroupInfo() end

end

--初始化军团信息中的选项卡
function ArmyGroupInfo:initInfoTabs()
    local tab_overview = self:getChildByName("tab_overview")
    local tab_member  = self:getChildByName("tab_member")
    local tab_donation = self:getChildByName("tab_donation")
    self.tab_apply = self:getChildByName("tab_apply")
    self.infoTabs = {tab_overview,tab_member,tab_donation,self.tab_apply}
    for i,v in ipairs(self.infoTabs) do
        v:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                self:showInfoTab(i)
            end
        end)
    end

    self.gInfo_overview = self:getChildByName("panel_overview")
    self.gInfo_member = self:getChildByName("panel_member")
    self.gInfo_donation = self:getChildByName("panel_donation")
    self.gInfo_apply = self:getChildByName("panel_application")
    self.infoTabViews = {self.gInfo_overview,self.gInfo_member,self.gInfo_donation,self.gInfo_apply}

end

function ArmyGroupInfo:refreshArmyGroupInfo()
    self.armyGroupInfoData = nil
    self.armyGroupMemberData = nil
    self.armyGroupDonationData = nil
    self.armyGroupApplicationData = nil
    self:getArmyGroupInfoData()
    self:getArmyGroupMemberData()
    self:getArmyGroupDonationData()

end

return ArmyGroupInfo