
local ArmyGroupList = class("ArmyGroupList",function(node)
    return node
end)

function ArmyGroupList:ctor(node)
    self.nowPage = 1
    self.isShowSearchView = false
    self.refreshList = true
    self.searchName = nil
    self:initView()
--    self:getArmyGroupListData()
end

function ArmyGroupList:setTabVisible(vis,data)
    self:setVisible(vis)

    local listview = self:getChildByName("listview_ranking")
--    if vis and self.isShowSearchView then
--        self.isShowSearchView = false
--        self.nowPage = 1
--        listview:removeAllItems()
--        local tmp = {}
--        tmp.data = {}
--        data.lv = data.guildLv
--        tmp.data[1] = data
--        tmp.hasNext = false
--        tmp.isSelf = true
--        if data then self:pushItems(tmp) end
--        self:getArmyGroupListData()
--    elseif vis and self.refreshList then
--        self.refreshList = false
--        self.nowPage = 1
--        listview:removeAllItems()
--        local tmp = {}
--        tmp.data = {}
--        data.lv = data.guildLv
--        tmp.data[1] = data
--        tmp.hasNext = false
--        tmp.isSelf = true
--        if data then self:pushItems(tmp) end
--        self:getArmyGroupListData()
--    elseif vis then
--        local item = listview:getItem(1)
--        if item then
--            self:updateItem(item,data)
--        end
--    end
    
    if self.isShowSearchView then
        self.isShowSearchView = false
    elseif self.isShowSearchView then
        self.refreshList = false
    end
    
    if vis then
        self.nowPage = 1
        listview:removeAllItems()
        local tmp = {}
        tmp.data = {}
        data.lv = data.guildLv
        tmp.data[1] = data
        tmp.hasNext = false
        tmp.isSelf = true
        if data then self:pushItems(tmp) end
        self:getArmyGroupListData()
    end

end

function ArmyGroupList:initView()
    self:getChildByName("text_no_info"):setVisible(false)
    local btn_search = self:getChildByName("btn_search")
    btn_search:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            require("src/app/views/armygroup/ArmyGroupSearch"):show(self)
            self.isShowSearchView = true
        end
    end)
end

function ArmyGroupList:getArmyGroupListData()
    Connect:sendMsg("GuildAction","noOpenGuildList",{nowPage = self.nowPage},function(data)
        local text_no_info = self:getChildByName("text_no_info")
        text_no_info:setVisible(false)
        self:getChildByName("text_searching"):setVisible(false)
        if data then self:pushItems(data) end
    end)
end

function ArmyGroupList:updateItem(item,v)
    item:getChildByName("text_name"):setString(v.guildName)
    item:getChildByName("text_lev"):setString(v.count)
    item:getChildByName("text_attack"):setString(StringTemp:toNum(v.combat))
    local btn_check = item:getChildByName("btn_check")

    if v.operate == 2 then
        btn_check:loadTextureNormal(ResIconCfg.btn_negative)
        btn_check:loadTexturePressed(ResIconCfg.btn_negativePress)
        btn_check:setTitleText(StringRes.applying)
    end

    btn_check.infoData = v
    btn_check.infoData.hasArmyGroup = true
    btn_check:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            require("src/app/views/armygroup/ArmyGroupCheckInfo"):show(self,e,{x=-self:getPositionX(),y=-self:getPositionY()})
        end
    end)



end

function ArmyGroupList:pushItems(data)
    local panel_attack_1st = self:getChildByName("panel_attack_1st")
    local panel_attack_2nd = self:getChildByName("panel_attack_2nd")
    local panel_attack_3rd = self:getChildByName("panel_attack_3rd")
    local panel_attack_other = self:getChildByName("panel_attack_other")
    local panel_attack_more = self:getChildByName("panel_attack_more")
    local listview = self:getChildByName("listview_ranking")
    for i,v in ipairs(data.data) do
        local item = nil
        if v.rank == 1 then
            item = panel_attack_1st:clone()
        elseif v.rank ==2 then
            item = panel_attack_2nd:clone()
        elseif v.rank ==3 then
            item = panel_attack_3rd:clone()
        elseif data.isSelf or self.nowPage ~= 1 then --更多和自己 item  不使用预加载
            item = panel_attack_other:clone()
            item:getChildByName("text_ranking"):setString(v.rank)
        else
            item = preLoad:getPanel("ArmyGroupListItem")--panel_attack_other:clone()
            item:getChildByName("text_ranking"):setString(v.rank)
        end
        --自己军团高亮
        if data.isSelf then
            item:setBackGroundImageScale9Enabled(true)
            item:setBackGroundImage(ResIconCfg.bg_panel_fadeBg,ResType)
            item:setBackGroundImageCapInsets(cc.rect(0, 0, 112, 16));
        end
        item:getChildByName("text_name"):setString(v.guildName)
        item:getChildByName("text_lev"):setString(v.count)
        item:getChildByName("text_attack"):setString(StringTemp:toNum(v.combat))
        local btn_check = item:getChildByName("btn_check")

        if v.operate == 2 then
            btn_check:loadTextureNormal(ResIconCfg.btn_negative)
            btn_check:loadTexturePressed(ResIconCfg.btn_negativePress)
            btn_check:setTitleText(StringRes.applying)
        end

        btn_check.infoData = v
        btn_check.infoData.hasArmyGroup = true
        btn_check:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                require("src/app/views/armygroup/ArmyGroupCheckInfo"):show(self,e,{x=-self:getPositionX(),y=-self:getPositionY()})
            end
        end)

        listview:pushBackCustomItem(item)
    end

    if data.hasNext then
        local btn_more = panel_attack_more:clone()
        btn_more:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                e:removeFromParent()
                self.nowPage = self.nowPage + 1

                if self.isShowSearchView then
                    self:searchArmyGroupData(self.searchName)
                else
                    self:getArmyGroupListData()
                end

            end
        end)
        listview:pushBackCustomItem(btn_more)
    end

end

--搜索军团
function ArmyGroupList:searchArmyGroupData(name)
    if name == nil or "" == name or string.len(name)==0 then return end
    self.searchName = name
    local listview = self:getChildByName("listview_ranking")
    listview:removeAllItems()
    local text_no_info = self:getChildByName("text_no_info")
    text_no_info:setVisible(false)
    local text_searching = self:getChildByName("text_searching")
    text_searching:setVisible(true)
    text_searching:setString(string.format(StringRes.search_result,self.searchName))

    Connect:sendMsg("GuildAction","searchGuild",{nowPage = self.nowPage,guildName = name},function(data)
        if data == nil or data.data == nil or #(data.data)==0 then
            text_no_info:setVisible(true)
            text_no_info:setString(StringRes.no_match_result)
        end
        if data then self:pushItems(data) end
    end)
end

return ArmyGroupList