
local ArmyGroupLog = class("ArmyGroupLog",function()
    return CCUILoader:load("res/csd/army_group/ui_army_group_log.csb")
end)

function ArmyGroupLog:show(parent)
    local layer = ArmyGroupLog.new(parent)
    parent:addChild(layer)
    NodeTranslator:transUpBefore(layer)
end

function ArmyGroupLog:ctor()
    self.nowPage = 1
    self:initView()
    self:getLogData()
end

function ArmyGroupLog:initView()
    self:getChildByName("bg"):getChildByName("text_title"):setString(StringRes.army_group_log)
    self:getChildByName("bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transDown(self,function() 
                self:removeFromParent()
            end)
        end
    end)
end

function ArmyGroupLog:getLogData()
    local msg = {nowPage = self.nowPage,type = 1}
    Connect:sendMsg("GuildAction","openGuildInfo",msg,function(data)
        NodeTranslator:transUpBegin(self,nil)
        self:pushItems(data)
    end)
end

function ArmyGroupLog:pushItems(data)
    if data then
        local temItem = self:getChildByName("panel_event")
        local listview = self:getChildByName("listview_log")
        local panel_more = self:getChildByName("panel_more")
        for i,v in ipairs(data.data) do
            local item = temItem:clone()
            local text_time = item:getChildByName("text_time")
            text_time:setString(StringTemp:serverTimetoDate(v.recordTime))
            local text_event = item:getChildByName("text_event")
            if v.type == 1 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.joinName))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 2 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.outName))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 3 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.kickName))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 4 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.upName))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 5 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.downName))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 6 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],gGuildtech[v.techId].name,v.techlv))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 7 then
                local armyGuild = v.armyGuild
                if armyGuild ~= "" then
                    armyGuild= "("..armyGuild..")"
                end
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.guildPlayerName,v.armyName,armyGuild,StringTemp:toNum(v.robCount)))
            elseif v.type == 8 then
                local tagId = v.charId.."_"..v.missionId
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.guildPlayerName,gGuildFb[tagId].fbname,v.addGuildExp,gGuildFbReward[tagId].boxname))
            end
            
            listview:pushBackCustomItem(item)
        end

        if data.hasNext then
            local btn_more = panel_more:clone()
            btn_more:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    e:removeFromParent()
                    self.nowPage = self.nowPage + 1
                    self:getLogData()
                end
            end)
            listview:pushBackCustomItem(btn_more)
        end
    end
end

return ArmyGroupLog