local PanelTabLayer = require("src/app/views/public/PanelTabLayer")

local ArmyGroupMain = class("ArmyGroupMain",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes[gBuilding[4].name],tabs={StringRes.army_group_info,StringRes.army_group_function,StringRes.army_group_list}})
end)

function ArmyGroupMain:show(parent)
    local layer = ArmyGroupMain.new(parent)
    parent:addChild(layer)
    NodeTranslator:transUp(layer,nil)
end

function ArmyGroupMain:ctor(parent)
    self:initView()

    ViewManager:OpenView(self)
end

local preCsb = nil

function ArmyGroupMain:preload()
    if preCsb == nil then
        preCsb = CCUILoader:load("csd/army_group/ui_army_group_main.csb")
        preCsb:retain()
    end 
end

function ArmyGroupMain:getCsb()
    if preCsb == nil then
        ArmyGroupMain:preload()
    end
    return preCsb
end

function ArmyGroupMain:initView()
    local uis = ArmyGroupMain:getCsb()--CCUILoader:load("csd/army_group/ui_army_group_main.csb")
    self.uis = uis
    self:addChild(uis)
    --军团信息
    self.group_info = require("src/app/views/armygroup/ArmyGroupInfo").new(uis:getChildByName("panel_info"))
    --军团功能
    self.group_function = require("src/app/views/armygroup/ArmyGroupFunction").new(uis:getChildByName("panel_group_function"))
    --军团列表
    self.group_list = require("src/app/views/armygroup/ArmyGroupList").new(uis:getChildByName("panel_group_list"))
    self.mainTabs = {self.group_info,self.group_function,self.group_list}
    self:initMainTabs()
end

function ArmyGroupMain:initMainTabs()

    for i,v in ipairs(self.mainTabs)do
        self:registerTabEvent(i,function()
            self:showMainTab(i)
        end)
    end
    self:setTabSelect(1)
end


function ArmyGroupMain:showMainTab(index)
    for i,v in ipairs(self.mainTabs) do
        v:setTabVisible(i == index,self.group_info.armyGroupInfoData)
    end
end

return ArmyGroupMain