local ArmyGroupMemberInfo = class("ArmyGroupMemberInfo",function(data)
    return CCUILoader:load("csd/army_group/layer_army_group_member_info.csb")
end)

function ArmyGroupMemberInfo:show(parent,data)
    local layer = ArmyGroupMemberInfo.new(data)
    parent:addChild(layer)
    layer:setPosition(-parent:getPositionX(),-parent:getPositionY())
    local panel_mask = layer:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    NodeTranslator:transZoomOut(panel_bg,nil)
end

function ArmyGroupMemberInfo:ctor(data)
    self.data = data
    self:initView()
end

function ArmyGroupMemberInfo:initView()
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")

    --玩家名
    panel_bg:getChildByName("text_player_name"):setString(self.data.playerName)
    --等级
    panel_bg:getChildByName("text_player_lev"):setString(self.data.lv)
    --战斗力
    panel_bg:getChildByName("text_player_attack"):setString(self.data.combat)
    --贡献
    panel_bg:getChildByName("text_player_donation"):setString(self.data.contr)
    --职位
    panel_bg:getChildByName("text_player_position"):setString(StringTemp:getJob(self.data.job))
    --在线时间
    panel_bg:getChildByName("text_player_login"):setString(StringTemp:lastLoginTime(self.data.onlineTime))


    local btn_edit = panel_bg:getChildByName("btn_edit")
    local input_player_sign = panel_bg:getChildByName("panel_sign_bg"):getChildByName("input_player_sign")
    local btn_email = panel_bg:getChildByName("btn_email")
    local btn_chat = panel_bg:getChildByName("btn_chat")

    if self.data.isSelf then --修改签名
        btn_edit:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                local strSignature =  input_player_sign:getString()
                Connect:sendMsg("GuildAction","editGuildPlayerInfo",{signature=strSignature},function(data)
                    if data.state == 1 then
                        self.data.signature = strSignature
                        FlyWordPrompt:prompt(StringRes.sign_success)
                        NodeTranslator:transZoomIn(panel_bg,function()
                            self:removeFromParent()
                        end)
                    end
                end)
            end
        end)
        btn_email:setEnabled(false)
        showShader:buttonToGray(btn_email)
        btn_email:setBright(false)
        btn_chat:setEnabled(false)
        showShader:buttonToGray(btn_chat)
        btn_chat:setBright(false)
    else
        --邮件
        btn_email:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                require("src/app/views/mail/MailWriteView"):open(self,{resver=self.data.playerName})
            end
        end)
        
        --私聊
        btn_chat:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                ChatMainView:getInstanse():priveteChat(self.data.playerName)
            end
        end)
    end

    input_player_sign:setString(self.data.signature)
    input_player_sign:setEnabled(self.data.isSelf)
    btn_edit:setVisible(self.data.isSelf)

    local  panel_member_other =  panel_bg:getChildByName("panel_member_other")
    local btn1 = panel_member_other:getChildByName("btn_1")
    local btn2 = panel_member_other:getChildByName("btn_2")
    local btn3 = panel_member_other:getChildByName("btn_3")
    local btn4 = panel_member_other:getChildByName("btn_4")
    showShader:buttonToGray(btn1)
    showShader:buttonToGray(btn2)
    showShader:buttonToGray(btn3)
    showShader:buttonToGray(btn4)
    if self.data.selfData.job ==1 then --团长
        if self.data.isSelf then --团长查看自己
            btn1:setTitleText(StringRes.quite_army_group)
            self:quiteArmyGroup(btn1)
            btn2:setVisible(false)
            btn3:setVisible(false)
            btn4:setVisible(false)
    elseif self.data.job == 2 then --团长查看副团长
        btn1:setTitleText(StringRes.transfer_leader)
        self:transferLeader(btn1)
        btn2:setVisible(false)
        btn3:setTitleText(StringRes.kick_army_group)
        self:kick(btn3)
        btn4:setTitleText(StringRes.kick_2_leader)
        self:kick2Leader(btn4)
    elseif self.data.job == 3 then --团长查看成员
        btn1:setTitleText(StringRes.transfer_leader)
        self:transferLeader(btn1)
        btn2:setVisible(false)
        btn3:setTitleText(StringRes.kick_army_group)
        self:kick(btn3)
        btn4:setTitleText(StringRes.promote)
        self:promote(btn4)
    end
    elseif self.data.selfData.job  ==2 then--副团长
        if self.data.isSelf then --副团长查看自己
            btn1:setTitleText(StringRes.quite_army_group)
            self:quiteArmyGroup(btn1)
            btn2:setVisible(false)
            btn3:setVisible(false)
            btn4:setVisible(false)
    elseif self.data.job == 1 then --副团长查看团长
        btn1:setTitleText(StringRes.transfer_leader)
        btn1:setEnabled(false)
        btn1:setBright(false)
        btn2:setTitleText(StringRes.accuse)
        self:accuse(btn2)
        btn3:setTitleText(StringRes.kick_army_group)
        btn3:setEnabled(false)
        btn3:setBright(false)
        btn4:setTitleText(StringRes.promote)
        btn4:setEnabled(false)
        btn4:setBright(false)
    elseif self.data.job == 2 then --副团长查看副团长
        btn1:setTitleText(StringRes.transfer_leader)
        btn1:setEnabled(false)
        btn1:setBright(false)
        btn2:setVisible(false)
        btn3:setTitleText(StringRes.kick_army_group)
        btn3:setEnabled(false)
        btn3:setBright(false)
        btn4:setTitleText(StringRes.promote)
        btn4:setEnabled(false)
        btn4:setBright(false)
    elseif self.data.job == 3 then --副团长查看成员
        btn1:setTitleText(StringRes.transfer_leader)
        btn1:setEnabled(false)
        btn1:setBright(false)
        btn2:setVisible(false)
        btn3:setTitleText(StringRes.kick_army_group)
        self:kick(btn3)
        btn4:setTitleText(StringRes.promote)
        btn4:setEnabled(false)
        btn4:setBright(false)
    end

    elseif self.data.selfData.job ==3 then--成员
        if self.data.isSelf then --成员查看自己
            btn1:setTitleText(StringRes.quite_army_group)
            self:quiteArmyGroup(btn1)
            btn2:setTitleText(StringRes.promote2)
            self:promote2(btn2)
            btn3:setVisible(false)
            btn4:setVisible(false)
    elseif self.data.job == 1 then --成员查看团长
        btn1:setTitleText(StringRes.transfer_leader)
        btn1:setEnabled(false)
        btn1:setBright(false)
        btn2:setTitleText(StringRes.accuse)
        btn2:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                FlyWordPrompt:prompt(StringRes.accuse_info)
            end
        end)
        btn3:setTitleText(StringRes.kick_army_group)
        btn3:setEnabled(false)
        btn3:setBright(false)
        btn4:setTitleText(StringRes.promote)
        btn4:setEnabled(false)
        btn4:setBright(false)
    elseif self.data.job == 2 then --成员查看副团长
        btn1:setTitleText(StringRes.transfer_leader)
        btn1:setEnabled(false)
        btn1:setBright(false)
        btn2:setTitleText(StringRes.accuse)
        self:accuse(btn2)
        btn3:setTitleText(StringRes.kick_army_group)
        btn3:setEnabled(false)
        btn3:setBright(false)
        btn4:setTitleText(StringRes.promote)
        btn4:setEnabled(false)
        btn4:setBright(false)
    elseif self.data.job == 3 then --成员查看成员
        btn1:setTitleText(StringRes.transfer_leader)
        btn1:setEnabled(false)
        btn1:setBright(false)
        btn2:setVisible(false)
        btn3:setTitleText(StringRes.kick_army_group)
        btn3:setEnabled(false)
        btn3:setBright(false)
        btn4:setTitleText(StringRes.promote)
        btn4:setEnabled(false)
        btn4:setBright(false)
    end
    end

    local btn_close = panel_bg:getChildByName("btn_close")
    btn_close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transZoomIn(panel_bg,function()
                self:removeFromParent()
            end)
        end
    end)
end

--离开军团
function ArmyGroupMemberInfo:quiteArmyGroup(btn)
    btn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self.data.selfData.job  == 1 and self.data.selfData.count > 1 then --团长
                FlyWordPrompt:prompt(StringRes.leader_cannot_quite)
            else

                local info = StringRes.ok_quite_army_group

                if self.data.selfData.job == 1 then
                    info = StringRes.leader_quite
                end

                PromptView:inputOK(
                    function()
                        local msg = {}
                        Connect:sendMsg("GuildAction","quitGuild",msg,
                            function (data)
                                if data.state == 1 then
                                    local pd = PlayerData:getInstanse()
                                    pd.basicData.guildId = 0
                                    self:getParent():getParent():getParent():close()
                                    FlyWordPrompt:prompt(StringRes.quite_army_group_success)
                                end
                            end)
                    end,info)
            end
        end
    end)
end

--提拔
function ArmyGroupMemberInfo:promote(btn)
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    btn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local msg = {promoteId = self.data.playerId}
            Connect:sendMsg("GuildAction","promoteGuildPlayer",msg,
                function (data)
                    if data.state == 1 then
                        self:getParent():refreshArmyGroupInfo()
                        NodeTranslator:transZoomIn(panel_bg,function()
                            self:removeFromParent()
                        end)
                        FlyWordPrompt:prompt(StringRes.promote_success)
                    end
                end)
        end
    end)
end

--辞掉副团长
function ArmyGroupMemberInfo:kick2Leader(btn)
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    btn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local msg = {resignId = self.data.playerId}
            Connect:sendMsg("GuildAction","resignationDeputy",msg,
                function (data)
                    if data.state == 1 then
                        self:getParent():refreshArmyGroupInfo()
                        NodeTranslator:transZoomIn(panel_bg,function()
                            self:removeFromParent()
                        end)
                        FlyWordPrompt:prompt(StringRes.kick_2_leader_success)
                    end
                end)
        end
    end)
end

--团长转让
function ArmyGroupMemberInfo:transferLeader(btn)
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    btn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            PromptView:inputOK(
                function()
                    local msg = {attornId = self.data.playerId,ok = "ok"}
                    Connect:sendMsg("GuildAction","attornGuild",msg,
                        function (data)
                            if data.state == 1 then
                                self:getParent():refreshArmyGroupInfo()
                                NodeTranslator:transZoomIn(panel_bg,function()
                                    self:removeFromParent()
                                end)
                                FlyWordPrompt:prompt(StringRes.transfer_leader_success)
                            end
                        end)
                end,string.format(StringRes.comfirm_transfer_leader,self.data.playerName))
        end
    end)
end

--踢出军团
function ArmyGroupMemberInfo:kick(btn)
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    btn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            PromptView:inputOK(
                function()
                    local msg = {kickId = self.data.playerId}
                    Connect:sendMsg("GuildAction","kickGuildPlayer",msg,
                        function (data)
                            if data.state == 1 then
                                self:getParent():refreshArmyGroupInfo()
                                NodeTranslator:transZoomIn(panel_bg,function()
                                    self:removeFromParent()
                                end)
                                FlyWordPrompt:prompt(StringRes.kick_success)
                            end
                        end)
                end,string.format(StringRes.comfirm_kick,self.data.playerName))
        end
    end)
end

--弹劾
function ArmyGroupMemberInfo:accuse(btn)
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    btn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local msg = {resignId = self.data.playerId}
            Connect:sendMsg("GuildAction","impeGuildLeader",msg,
                function (data)
                    if data.state == 1 then
                        self:getParent():refreshArmyGroupInfo()
                        NodeTranslator:transZoomIn(panel_bg,function()
                            self:removeFromParent()
                        end)
                        FlyWordPrompt:prompt(StringRes.accuse_success)
                    end
                end)
        end
    end)
end

--晋升
function ArmyGroupMemberInfo:promote2(btn)
    local accuseCost = 100
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    btn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self.data.contr < accuseCost then --贡献不足100，无法晋升
                FlyWordPrompt:prompt(string.format(StringRes.contribution_not_enough,accuseCost))
            else
                PromptView:type2(StringRes.notice,
                    string.format(StringRes.contribution_need,accuseCost)
                    ,StringRes.ok,StringRes.cancel,
                    function()
                        local msg = {}
                        Connect:sendMsg("GuildAction","promotion",msg,
                            function (data)
                                if data.state == 1 then
                                    self:getParent():refreshArmyGroupInfo()
                                    NodeTranslator:transZoomIn(panel_bg,function()
                                        self:removeFromParent()
                                    end)
                                    FlyWordPrompt:prompt(StringRes.promote2_successs)
                                end
                            end)
                    end)
            end
        end
    end)
end

return ArmyGroupMemberInfo