local ArmyGroupSearch = class("ArmyGroupSearch",function(parent)
    return CCUILoader:load("csd/army_group/layer_army_group_search_group.csb")
end)

function ArmyGroupSearch:show(parent)
    local layer = ArmyGroupSearch.new(parent)
    layer:setPosition(-parent:getPositionX(),-parent:getPositionY())
    parent:addChild(layer)
    local panel_mask = layer:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    NodeTranslator:transZoomOut(panel_bg,nil)
end

function ArmyGroupSearch:ctor(parent)
    self.parent = parent
	self:initView()
end

function ArmyGroupSearch:initView()
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    
    local input_name = panel_bg:getChildByName("panel_search_bg"):getChildByName("input_name")
    
    local btn_search = panel_bg:getChildByName("btn_search")
    btn_search:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self.parent:searchArmyGroupData(input_name:getString())
            NodeTranslator:transZoomIn(panel_bg,function() 
                self:removeFromParent()
            end)
        end
    end)
    
    local btn_close = panel_bg:getChildByName("btn_close")
    btn_close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transZoomIn(panel_bg,function() 
                self:removeFromParent()
            end)
        end
    end)
end



return ArmyGroupSearch