
local ArmyGroupSetting = class("ArmyGroupSetting",function()
    return CCUILoader:load("res/csd/army_group/ui_army_group_duty_setting.csb")
end)

function ArmyGroupSetting:show(parent)
    local layer = ArmyGroupSetting.new(parent)
    parent:addChild(layer)
    NodeTranslator:transUp(layer,nil)
end

function ArmyGroupSetting:ctor()
    self:initView()
    self.selectIndex = nil
end

function ArmyGroupSetting:initView()
    self:getChildByName("bg"):getChildByName("text_title"):setString(StringRes.army_group_setting)
    self:getChildByName("bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            
            if self.selectIndex ~= nil then
                Connect:sendMsg("GuildAction","setGarrison",{garrison = self.selectIndex},function(data)
                    if data.state == 1 then
                        PlayerData:getInstanse().basicData.garrison = self.selectIndex
                        NodeTranslator:transDown(self,function()
                            self:removeFromParent()
                        end)
                    end
                end)
            else
                NodeTranslator:transDown(self,function()
                    self:removeFromParent()
                end)
            end
        end
    end)

    local panel_duty = self:getChildByName("panel_duty")

    panel_duty:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.duty_setting_notice))
        end
    end)

    local checkbox_option_1 = panel_duty:getChildByName("checkbox_option_1")
    local checkbox_option_2 = panel_duty:getChildByName("checkbox_option_2")
    local checkbox_option_3 = panel_duty:getChildByName("checkbox_option_3")

    local options = {checkbox_option_1,checkbox_option_2,checkbox_option_3}
    
    function selectOptions(index)
    	for i,v  in ipairs(options) do
            v:setSelected(index==v.index)
    	end
    end
    
    for i,v in ipairs(options)do
        v.index = i 
        v:addEventListener(function(e, t)
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self.selectIndex = e.index
            selectOptions(self.selectIndex)
            FlyWordPrompt:prompt(StringRes.save_success)
        end)
    end
    
    selectOptions(PlayerData:getInstanse().basicData.garrison)

end

return ArmyGroupSetting