
local PanelTabLayer = require("src/app/views/public/PanelTabLayer")

local ArmyGroupStore = class("ArmyGroupStore",function(scene,data)
    return PanelTabLayer.new(scene,{title=StringRes.army_group_store,tabs={StringRes.prop,StringRes.gem}})
end)

function ArmyGroupStore:show(parent)
    Connect:sendMsg("GuildAction","openGuildShop",{},function(data)
        local layer = ArmyGroupStore.new(parent,data)
        parent:addChild(layer)
        NodeTranslator:transUp(layer,nil)
    end)
end

function ArmyGroupStore:ctor(parent,data)
    self:initView()
    --获取商店数据
--    self:getData()
    if data.contr then
        self:setContr(data.contr,true)
        self.contr = data.contr
    end
    self:updateViews(data)

    ViewManager:OpenView(self)
end

function ArmyGroupStore:initView()
    self.uis = CCUILoader:load("csd/army_group/ui_army_group_store.csb")
    self:addChild(self.uis)

    --道具
    self.shopView = self.uis:getChildByName("panel_item")
    --珍品
    self.gemView = self.uis:getChildByName("panel_value")
    self.mainTabs = {self.shopView,self.gemView}

    self:initMainTabs()
    
    self.listShop = self.shopView:getChildByName("listview_item")
    self.listGem = self.gemView:getChildByName("listview_value")
--    self.tmpItem = self.uis:getChildByName("panel_tmpitem")
    
    self.shopView:getChildByName("panel_head"):getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            local DescriptCfg = require("src/app/cfg/DescriptCfg")
            DescriptView:open(self,DescriptCfg.AGStore_props_rule)
--            DescriptView:open(self,StringTemp:Descript(StringRes.army_group_prop_rule,24))
        end
    end)
    
    self.gemView:getChildByName("panel_head"):getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            local DescriptCfg = require("src/app/cfg/DescriptCfg")
            DescriptView:open(self,DescriptCfg.AGStore_gem_rule)
        end
    end)
    
end

function ArmyGroupStore:initMainTabs()

    for i,v in ipairs(self.mainTabs)do
        self:registerTabEvent(i,function()
            self:showMainTab(i)
        end)
    end
    self:setTabSelect(1)
end


function ArmyGroupStore:showMainTab(index)
    for i,v in ipairs(self.mainTabs) do
        v:setVisible(i == index)
    end
end

function ArmyGroupStore:getData()
    Connect:sendMsg("GuildAction","openGuildShop",{},function(data)
        if data.contr then
            self:setContr(data.contr,true)
            self.contr = data.contr
        end
        self:updateViews(data)
    end)
end

function ArmyGroupStore:updateViews(data)
    if data then
        self:updateItemView(data.shopVOs,true)
        self:updateItemView(data.gemVOs,false)
    end
end

function ArmyGroupStore:updateItemView(data,showUnlock)
    local tmp = "0"
    if not showUnlock then
        tmp = "1"
    end
    if data then
--        table.sort(data,function(a,b)
--            return gGuildstore[a.templateId.."_"..tmp].order < gGuildstore[b.templateId.."_"..tmp].order
--                        end)
        table.sort(data,function(a,b)
                   if gGuildstore[a.templateId.."_"..tmp].unlocklv == gGuildstore[b.templateId.."_"..tmp].unlocklv then
                        return gGuildstore[a.templateId.."_"..tmp].order < gGuildstore[b.templateId.."_"..tmp].order
                   else 
                        return gGuildstore[a.templateId.."_"..tmp].unlocklv < gGuildstore[b.templateId.."_"..tmp].unlocklv 
                   end
                        end)
        for i,v in ipairs(data) do
            local item = preLoad:getPanel("ArmyGroupStoreItem")--self.tmpItem:clone()
            if item:getChildByName("tag_addBg") then
                item:getChildByName("tag_addBg"):removeFromParent()
                item:getChildByName("icon_item"):setScale(1)
            end
            self:updateItem(item,v,showUnlock)
            if showUnlock then
                self.listShop:pushBackCustomItem(item)
            else
                self.listGem:pushBackCustomItem(item)
            end
        end
    end
end

function ArmyGroupStore:updateItem(item,data,showUnlock)
    local tmp = "0"
    if not showUnlock then
        tmp = "1"
    end
    local gsInfo = gGuildstore[data.templateId.."_"..tmp]
    if gsInfo == nil then return end
    local text_name = item:getChildByName("text_name")    
    local text_num = item:getChildByName("text_num")    
    local icon_item = item:getChildByName("icon_item")    
    local text_desc = item:getChildByName("text_desc")    
    local text_donation_num = item:getChildByName("text_donation_num")    
    local btn_exchange = item:getChildByName("btn_exchange")    
    local panel_mask = item:getChildByName("panel_mask")
    panel_mask:setLocalZOrder(10)  
    if gsInfo.type == 1 then
        local iInfo = gItem[data.templateId]
        text_name:setString(StringRes[iInfo.name].."x"..StringTemp:toNum(gsInfo.count))
        icon_item:loadTexture(iInfo.icon,ResType)
        text_desc:setString(StringRes[iInfo.desc])
    elseif gsInfo.type == 2 then
        local parts = require("src/app/data/parts")
        local iInfo = parts[data.templateId]
        text_name:setString(iInfo.name.."x"..StringTemp:toNum(gsInfo.count))
--        icon_item:loadTexture(iInfo.icon,ResType)
        --使用ActUtils设置图标
        local tmp = {}
        tmp.type =5
        tmp.baseId = data.templateId
        icon_item.tag_data = tmp
        require("app/views/activity/ActUtils.lua"):initSignItem(icon_item)
        if iInfo.type< 5 then
            icon_item:setScale(SCALE_PART)
        end
        text_desc:setString(iInfo.decript)
    elseif gsInfo.type == 3 then
        local iInfo = Tank[data.templateId]
        text_name:setString(StringRes[iInfo.name].."x"..StringTemp:toNum(gsInfo.count))
        Common:changePic(icon_item,iInfo.icon)
        text_desc:setString(string.format(StringRes[iInfo.dec],iInfo.load))
    end
    text_num:setPositionX(text_name:getPositionX()+text_name:getContentSize().width)
    text_num:setString(string.format(StringRes.item_num,data.excount,gsInfo.excount))
    text_donation_num:setString(gsInfo.contr)
    if gsInfo.contr>self.contr then
        text_donation_num:setColor(CommonColor.Red)
    else
        text_donation_num:setColor(CommonColor.White)
    end
    
    local actionMethod = "exChangeGuildShop"
    if showUnlock then
        if data.unlock then
            panel_mask:setVisible(false)
        else
            panel_mask:setVisible(true)
            local text_unlock = panel_mask:getChildByName("text_unlock")
            text_unlock:setString(string.format(StringRes.unlock_info,gsInfo.unlocklv))
        end

    else
        panel_mask:setVisible(false)
        actionMethod = "exChangeGuildGemShop"
    end
    
    btn_exchange:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if gsInfo.contr>self.contr then
                FlyWordPrompt:prompt(StringRes.not_enough_contr)
            else
                Connect:sendMsg("GuildAction",actionMethod,{shopId = data.templateId},function(value)
                    if value then
                        text_num:setString(string.format(StringRes.item_num,value.exCount,gsInfo.excount))
                        self.contr = value.contr
                        self:setContr(value.contr)
                        self:updateListViewContr()
                        FlyWordPrompt:prompt(string.format(StringRes.exchange_success,text_name:getString()))
                    end
                end)
            end
        end
    end)
    
    
end

--设置贡献
function ArmyGroupStore:setContr(num,isFirst)
    for i,v in ipairs(self.mainTabs) do
        local panel_head = v:getChildByName("panel_head")
        local num_donation = panel_head:getChildByName("num_donation")
        if isFirst then
            local text_donation = panel_head:getChildByName("text_donation")
            num_donation:setPositionX(text_donation:getPositionX()+text_donation:getContentSize().width)
        end
        num_donation:setString(num)
    end
end

function ArmyGroupStore:updateListViewContr()
    for i,v in ipairs(self.listShop:getItems()) do
        local text_donation_num = v:getChildByName("text_donation_num")
        if tonumber(text_donation_num:getString())>self.contr then
            text_donation_num:setColor(CommonColor.Red)
        else
            text_donation_num:setColor(CommonColor.White)
        end
    end
    for i,v in ipairs(self.listGem:getItems()) do
        local text_donation_num = v:getChildByName("text_donation_num")
        if tonumber(text_donation_num:getString())>self.contr then
            text_donation_num:setColor(CommonColor.Red)
        else
            text_donation_num:setColor(CommonColor.White)
        end
    end
end

return ArmyGroupStore