local ArmyGroupTechDonation = class("ArmyGroupTechDonation",function(data,callback)
    return CCUILoader:load("csd/army_group/layer_army_group_tech_donation.csb")
end)

function ArmyGroupTechDonation:show(parent,data,callback)
    local layer = ArmyGroupTechDonation.new(data,callback)
    parent:addChild(layer)
    local panel_mask = layer:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    NodeTranslator:transZoomOut(panel_bg,nil)
end

function ArmyGroupTechDonation:ctor(data,callback)
    self.data = data
    self.callback = callback
    self:initView()
end

function ArmyGroupTechDonation:initView()

    local info = self.data.info
    local type = self.data.type
    local guildDonationVO = self.data.guildDonationVO
    
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    local panel_crystal = panel_bg:getChildByName("panel_crystal")
    local panel_coin = panel_bg:getChildByName("Panel_2_Copy")
    local icon_resource = panel_crystal:getChildByName("icon_resource")
    
    panel_bg:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.donation_notice))
        end
    end)
    
    function close()
        NodeTranslator:transZoomIn(panel_bg,function()
            self:removeFromParent()
        end)
    end
    
    local pd = PlayerData:getInstanse().basicData
    local ArmyGroupTechCfg = require("src/app/cfg/ArmyGroupTechCfg")
    local have =0
    local count = 0
    self.strNotice = {"",""}
    if type ==  1 then
        panel_bg:getChildByName("text_desc"):setString(string.format(StringRes.donation_count_info,StringRes.crystal,guildDonationVO.crystalcount,guildDonationVO.donationMax))
        have = pd.crystal
        count = guildDonationVO.crystalcount
        icon_resource:loadTexture(ResIconCfg.crystal,ResType)
        panel_crystal:getChildByName("text_money"):setString(string.format(StringRes.add_money,ArmyGroupTechCfg.getAddMoney(count,1)))
        panel_coin:getChildByName("text_money"):setString(string.format(StringRes.add_money,ArmyGroupTechCfg.getAddMoney(count,2)))
        local _tmp = info.id == 17 and 2 or 1
        self.strNotice[1] = string.format(StringRes.add_money,ArmyGroupTechCfg.getAddMoney(count,1)*_tmp)
        self.strNotice[2] = string.format(StringRes.add_money,ArmyGroupTechCfg.getAddMoney(count,2)*_tmp)
        
        panel_crystal:getChildByName("text_money_2"):setString("")
        panel_coin:getChildByName("text_money_2"):setString("")
    elseif type == 2 then
        panel_bg:getChildByName("text_desc"):setString(string.format(StringRes.donation_count_info,StringRes.iron_ore,guildDonationVO.fecount,guildDonationVO.donationMax))
        have = pd.ferrum
        count = guildDonationVO.fecount
        icon_resource:loadTexture(ResIconCfg.ferrum,ResType)
    elseif type == 3 then
        panel_bg:getChildByName("text_desc"):setString(string.format(StringRes.donation_count_info,StringRes.oil,guildDonationVO.oilcount,guildDonationVO.donationMax))
        have = pd.oil
        count = guildDonationVO.oilcount
        icon_resource:loadTexture(ResIconCfg.oil,ResType)
    elseif type == 4 then
        panel_bg:getChildByName("text_desc"):setString(string.format(StringRes.donation_count_info,StringRes.vanadium,guildDonationVO.leadcount,guildDonationVO.donationMax))
        have = pd.lead
        count = guildDonationVO.leadcount
        icon_resource:loadTexture(ResIconCfg.lead,ResType)
    elseif type == 5 then
        panel_bg:getChildByName("text_desc"):setString(string.format(StringRes.donation_count_info,StringRes.titanium,guildDonationVO.titancount,guildDonationVO.donationMax))
        have = pd.titanium
        count = guildDonationVO.titancount
        icon_resource:loadTexture(ResIconCfg.titanium,ResType)
    end
    
    if type ~= 1 then
        panel_crystal:getChildByName("text_money_2"):setString(string.format(StringRes.add_money,ArmyGroupTechCfg.getAddMoney(count,1)))
        panel_coin:getChildByName("text_money_2"):setString(string.format(StringRes.add_money,ArmyGroupTechCfg.getAddMoney(count,2)))
        
        panel_crystal:getChildByName("text_money"):setString(string.format(StringRes.add_honor,ArmyGroupTechCfg.getAddHonor(count)))
        panel_coin:getChildByName("text_money"):setString(string.format(StringRes.add_honor,ArmyGroupTechCfg.getAddHonor(count)))
        
        local _tmp = info.id == 17 and 2 or 1
        self.strNotice[1] = string.format(StringRes.add_money,ArmyGroupTechCfg.getAddMoney(count,1)*_tmp)
        self.strNotice[1] = string.format(StringRes.add_honor,ArmyGroupTechCfg.getAddHonor(count)).." "..self.strNotice[1]
        self.strNotice[2] = string.format(StringRes.add_money,ArmyGroupTechCfg.getAddMoney(count,2)*_tmp)
        self.strNotice[2] = string.format(StringRes.add_honor,ArmyGroupTechCfg.getAddHonor(count)).." "..self.strNotice[2]
    end
    
    panel_crystal:getChildByName("text_tech"):setString(string.format(StringRes.add_tech,ArmyGroupTechCfg.getAddTech(count,1)))
    panel_crystal:getChildByName("text_donation"):setString(string.format(StringRes.add_donation,ArmyGroupTechCfg.getAddDonation(count,1)))
    panel_crystal:getChildByName("text_reputation"):setString(string.format(StringRes.add_reputation,ArmyGroupTechCfg.getAddReputation(count,1)))
    self.strNotice[1] = string.format(StringRes.add_reputation,ArmyGroupTechCfg.getAddReputation(count,1)).." "..self.strNotice[1]
    self.strNotice[1] = string.format(StringRes.add_donation,ArmyGroupTechCfg.getAddDonation(count,1)).." "..self.strNotice[1]
    self.strNotice[1] = string.format(StringRes.add_tech,ArmyGroupTechCfg.getAddTech(count,1)).." "..self.strNotice[1]
    
    panel_coin:getChildByName("text_tech"):setString(string.format(StringRes.add_tech,ArmyGroupTechCfg.getAddTech(count,2)))
    panel_coin:getChildByName("text_donation"):setString(string.format(StringRes.add_donation,ArmyGroupTechCfg.getAddDonation(count,2)))
    panel_coin:getChildByName("text_reputation"):setString(string.format(StringRes.add_reputation,ArmyGroupTechCfg.getAddReputation(count,2)))
    self.strNotice[2] = string.format(StringRes.add_reputation,ArmyGroupTechCfg.getAddReputation(count,2)).." "..self.strNotice[2]
    self.strNotice[2] = string.format(StringRes.add_donation,ArmyGroupTechCfg.getAddDonation(count,2)).." "..self.strNotice[2]
    self.strNotice[2] = string.format(StringRes.add_tech,ArmyGroupTechCfg.getAddTech(count,2)).." "..self.strNotice[2]
    
    count = count+1 
    if count>6 then count = 6 end
    local need = ArmyGroupTechCfg.DonationRes[count]
    panel_crystal:getChildByName("text_request"):setString(string.format(StringRes.need_info,StringTemp:toNum(need)))
    panel_crystal:getChildByName("text_have"):setString(string.format(StringRes.have_info,StringTemp:toNum(have)))
    local btn_donation = panel_crystal:getChildByName("btn_donation")
    if need > have then
        btn_donation:setEnabled(false)
        showShader:buttonToGray(btn_donation)
        btn_donation:setBright(false)
        panel_crystal:getChildByName("text_have"):setColor(CommonColor.Red)
    else
        btn_donation:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                self:donate(type,1,info)
            end
        end)
    end
    
    local needCoin = ArmyGroupTechCfg.DonationCoin[count]*15
    local haveCoin = pd.gold
    panel_coin:getChildByName("text_request"):setString(string.format(StringRes.need_info,StringTemp:toNum(needCoin)))
    panel_coin:getChildByName("text_have"):setString(string.format(StringRes.have_info,StringTemp:toNum(haveCoin)))
    local btn_donationCoin = panel_coin:getChildByName("btn_donation")
    btn_donationCoin:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:donate(type,2,info)
        end
    end)
    if needCoin > haveCoin then
        panel_coin:getChildByName("text_have"):setColor(CommonColor.Red)
    end
    
    local btn_close = panel_bg:getChildByName("btn_close")
    btn_close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            close()
        end
    end)
end

function ArmyGroupTechDonation:donate(stype,sdonaType,info)
    Connect:sendMsg("GuildAction","donationTech",{type = stype , donaType = sdonaType ,id = info.id},function(data)
--    {["crycount"] = 3,["crystal"] = 0,["exp"] = 7,["fe"] = 10800,["fecount"] = 0,["gold"] = 9999225,["lead"] = 10800,
--["leadcount"] = 0,["lv"] = 0,["oil"] = 10800,["oilcount"] = 0,["techId"] = 2,["titan"] = 10800,["titancount"] = 0}

        --  {["crystalcount"] = 0,["fecount"] = 0,["leadcount"] = 0,["oilcount"] = 0,["titancount"] = 0}
        local pd = PlayerData:getInstanse().basicData
        pd.gold = data.gold
        pd.crystal = data.crystal
        pd.ferrum = data.fe
        pd.oil = data.oil
        pd.lead = data.lead
        pd.titanium = data.titan
        
        self.data.guildDonationVO.crystalcount = data.crycount
        self.data.guildDonationVO.fecount = data.fecount
        self.data.guildDonationVO.leadcount = data.leadcount
        self.data.guildDonationVO.oilcount = data.oilcount
        self.data.guildDonationVO.titancount = data.titancount
        
        self.data.info.exp = data.exp
--        self.data.info.lv = data.lv
        
        FlyWordPrompt:prompt(string.format(StringRes.donate_success,self.strNotice[sdonaType]))
        
        self:initView()
        if data.lv > info.lv then
            local panel_mask = self:getChildByName("panel_mask")
            local panel_bg = panel_mask:getChildByName("panel_bg")
            NodeTranslator:transZoomIn(panel_bg,function()
                self:removeFromParent()
            end)
            data.refresh = true
        else
            data.refresh = false
        end
        self.callback(data)
    end)
end

return ArmyGroupTechDonation