
local ArmyGroupTechnology = class("ArmyGroupTechnology",function(data)
    return CCUILoader:load("csd/army_group/ui_army_group_technology.csb")
end)

function ArmyGroupTechnology:show(parent)
    Connect:sendMsg("GuildAction","openGuildTech",{},function(data)
        local layer = ArmyGroupTechnology.new(data)
        parent:addChild(layer)
        NodeTranslator:transUp(layer,nil)
    end)
end

function ArmyGroupTechnology:ctor(data)
    self.listView = nil
    self:initView()
--    self:getTechData()
    self.data = data
    self:initItems(data)

    ViewManager:OpenView(self)
end

function ArmyGroupTechnology:getTechData()
    Connect:sendMsg("GuildAction","openGuildTech",{},function(data)
        self.data = data
        self:initItems(data)
    end)
end

function ArmyGroupTechnology:initView()
    self:getChildByName("bg"):getChildByName("text_title"):setString(StringRes.army_group_tech)
    self:getChildByName("bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transDown(self,function()
                self:removeFromParent()
            end)
        end
    end)
    self.listView = ExpandListView.new(self:getChildByName("listview_tech"),handler(self,self.lvListener))
end

function ArmyGroupTechnology:lvListener(listview,item,index,type)
    if type == ExpandListView_Type_Open then
        item:getChildByName("checkbox_spand"):setSelected(true)
        self.listView:insertExpandContent(self:createExpandItem(item),index+1)
    elseif type == ExpandListView_Type_Close then
        item:getChildByName("checkbox_spand"):setSelected(false)
    end
end

function ArmyGroupTechnology:createExpandItem(item)
    local content = self:getChildByName("panel_tech_detail"):clone()
    local data = item.tag_data
    local text_summery_desc = content:getChildByName("text_summery_desc")
    text_summery_desc:setString(gGuildtech[data.id].des)
    content.tag_isFirst = true
    content.tag_data = data
    self:updateResItem(content)
    content.isMain = false
    return content
end

function ArmyGroupTechnology:updateResItem(item)
    local panel_crystal = item:getChildByName("panel_crystal")
    local panel_copper = item:getChildByName("panel_copper")
    local panel_oil = item:getChildByName("panel_oil")
    local panel_iron = item:getChildByName("panel_iron")
    local panel_ore = item:getChildByName("panel_ore")

    --  {["crystalcount"] = 0,["fecount"] = 0,["leadcount"] = 0,["oilcount"] = 0,["titancount"] = 0}
    local ArmyGroupTechCfg = require("src/app/cfg/ArmyGroupTechCfg")
    local guildDonationVO = self.data.guildDonationVO
    local pd = PlayerData:getInstanse().basicData

    local count1 = guildDonationVO.crystalcount+1
    if count1 > 6 then count1=6 end
    local need1 = ArmyGroupTechCfg.DonationRes[count1]
    if need1 > pd.crystal then
        panel_crystal:getChildByName("icon_state"):loadTexture(ICON_FALT,ResType)
    else
        panel_crystal:getChildByName("icon_state"):loadTexture(ICON_CHECK,ResType)
    end
    panel_crystal:getChildByName("text_request"):setString(StringTemp:toNum(need1))
    panel_crystal:getChildByName("text_have"):setString(StringTemp:toNum(pd.crystal))
    panel_crystal:getChildByName("text_tech"):setString("+"..ArmyGroupTechCfg.getAddTech(guildDonationVO.crystalcount,1))
    panel_crystal:getChildByName("text_donation"):setString("+"..ArmyGroupTechCfg.getAddDonation(guildDonationVO.crystalcount,1))
    --    if item.tag_isFirst then
    --        panel_crystal:getChildByName("btn_donation"):addTouchEventListener(function(e, t)
    --            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
    --                local tmp = {}
    --                tmp.guildDonationVO = self.data.guildDonationVO
    --                tmp.info = item.tag_data
    --                tmp.type = 1
    --                require("src/app/views/armygroup/ArmyGroupTechDonation"):show(self,tmp,handler(self,self.donateCallBack))
    --            end
    --        end)
    --    end

    local count2 = guildDonationVO.fecount+1
    if count2 > 6 then count2=6 end
    local need2 = ArmyGroupTechCfg.DonationRes[count2]
    if need2 > pd.ferrum then
        panel_copper:getChildByName("icon_state"):loadTexture(ICON_FALT,ResType)
    else
        panel_copper:getChildByName("icon_state"):loadTexture(ICON_CHECK,ResType)
    end
    panel_copper:getChildByName("text_request"):setString(StringTemp:toNum(need2))
    panel_copper:getChildByName("text_have"):setString(StringTemp:toNum(pd.ferrum))
    panel_copper:getChildByName("text_tech"):setString("+"..ArmyGroupTechCfg.getAddTech(guildDonationVO.fecount,1))
    panel_copper:getChildByName("text_donation"):setString("+"..ArmyGroupTechCfg.getAddDonation(guildDonationVO.fecount,1))
    --    if item.tag_isFirst then
    --        panel_copper:getChildByName("btn_donation"):addTouchEventListener(function(e, t)
    --            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
    --                local tmp = {}
    --                tmp.guildDonationVO = self.data.guildDonationVO
    --                tmp.info = item.tag_data
    --                tmp.type = 2
    --                require("src/app/views/armygroup/ArmyGroupTechDonation"):show(self,tmp,handler(self,self.donateCallBack))
    --            end
    --        end)
    --    end

    --石油
    local count3 = guildDonationVO.oilcount+1
    if count3 > 6 then count3=6 end
    local need3 = ArmyGroupTechCfg.DonationRes[count3]
    if need3 > pd.oil then
        panel_oil:getChildByName("icon_state"):loadTexture(ICON_FALT,ResType)
    else
        panel_oil:getChildByName("icon_state"):loadTexture(ICON_CHECK,ResType)
    end
    panel_oil:getChildByName("text_request"):setString(StringTemp:toNum(need3))
    panel_oil:getChildByName("text_have"):setString(StringTemp:toNum(pd.oil))
    panel_oil:getChildByName("text_tech"):setString("+"..ArmyGroupTechCfg.getAddTech(guildDonationVO.oilcount,1))
    panel_oil:getChildByName("text_donation"):setString("+"..ArmyGroupTechCfg.getAddDonation(guildDonationVO.oilcount,1))
    --    if item.tag_isFirst then
    --        panel_oil:getChildByName("btn_donation"):addTouchEventListener(function(e, t)
    --            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
    --                local tmp = {}
    --                tmp.guildDonationVO = self.data.guildDonationVO
    --                tmp.info = item.tag_data
    --                tmp.type = 3
    --                require("src/app/views/armygroup/ArmyGroupTechDonation"):show(self,tmp,handler(self,self.donateCallBack))
    --            end
    --        end)
    --    end

    --铅矿
    local count4 = guildDonationVO.leadcount+1
    if count4 > 6 then count4=6 end
    local need4 = ArmyGroupTechCfg.DonationRes[count4]
    if need4 > pd.lead then
        panel_iron:getChildByName("icon_state"):loadTexture(ICON_FALT,ResType)
    else
        panel_iron:getChildByName("icon_state"):loadTexture(ICON_CHECK,ResType)
    end
    panel_iron:getChildByName("text_request"):setString(StringTemp:toNum(need4))
    panel_iron:getChildByName("text_have"):setString(StringTemp:toNum(pd.lead))
    panel_iron:getChildByName("text_tech"):setString("+"..ArmyGroupTechCfg.getAddTech(guildDonationVO.leadcount,1))
    panel_iron:getChildByName("text_donation"):setString("+"..ArmyGroupTechCfg.getAddDonation(guildDonationVO.leadcount,1))
    --    if item.tag_isFirst then
    --        panel_iron:getChildByName("btn_donation"):addTouchEventListener(function(e, t)
    --            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
    --                local tmp = {}
    --                tmp.guildDonationVO = self.data.guildDonationVO
    --                tmp.info = item.tag_data
    --                tmp.type = 4
    --                require("src/app/views/armygroup/ArmyGroupTechDonation"):show(self,tmp,handler(self,self.donateCallBack))
    --            end
    --        end)
    --    end

    --钛矿
    local count5 = guildDonationVO.titancount+1
    if count5 > 6 then count5=6 end
    local need5 = ArmyGroupTechCfg.DonationRes[count5]
    if need5 > pd.titanium then
        panel_ore:getChildByName("icon_state"):loadTexture(ICON_FALT,ResType)
    else
        panel_ore:getChildByName("icon_state"):loadTexture(ICON_CHECK,ResType)
    end
    panel_ore:getChildByName("text_request"):setString(StringTemp:toNum(need5))
    panel_ore:getChildByName("text_have"):setString(StringTemp:toNum(pd.titanium))
    panel_ore:getChildByName("text_tech"):setString("+"..ArmyGroupTechCfg.getAddTech(guildDonationVO.titancount,1))
    panel_ore:getChildByName("text_donation"):setString("+"..ArmyGroupTechCfg.getAddDonation(guildDonationVO.titancount,1))
    --    if item.tag_isFirst then
    --        panel_ore:getChildByName("btn_donation"):addTouchEventListener(function(e, t)
    --            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
    --                local tmp = {}
    --                tmp.guildDonationVO = self.data.guildDonationVO
    --                tmp.info = item.tag_data
    --                tmp.type = 5
    --                require("src/app/views/armygroup/ArmyGroupTechDonation"):show(self,tmp,handler(self,self.donateCallBack))
    --            end
    --        end)
    --    end

    local panels = {panel_crystal,panel_copper,panel_oil,panel_iron,panel_ore}
    if item.tag_isFirst then
        for i,v in ipairs(panels) do

            v:getChildByName("btn_donation"):addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    local tmp = {}
                    tmp.guildDonationVO = self.data.guildDonationVO
                    tmp.info = item.tag_data
                    tmp.type = i
                    require("src/app/views/armygroup/ArmyGroupTechDonation"):show(self,tmp,handler(self,self.donateCallBack))
                end
            end)

            if not item.tag_data.unlock then
                v:getChildByName("btn_donation"):setEnabled(false)
                showShader:buttonToGray(v:getChildByName("btn_donation"))
                v:getChildByName("btn_donation"):setBright(false)
            end
        end
    end
    if item.tag_isFirst then item.tag_isFirst = false end
end

function ArmyGroupTechnology:initItems(data)
    local tmpItemBase = self:getChildByName("panel_base")
    local tmpItemTech = self:getChildByName("panel_tech")
    table.sort(data.guildTechVOs,function(a,b)
        return a.id<b.id
    end)
    for k,v in ipairs(data.guildTechVOs) do
        local curItem = nil
        local info = gGuildtech[v.id]
        if v.id == 1 then
            curItem = tmpItemBase:clone()
        else
            curItem = tmpItemTech:clone()
        end
        local icon_tech = curItem:getChildByName("icon_tech")
        icon_tech:loadTexture(info.icon,ResType)
        local text_name = curItem:getChildByName("text_name")
        local tmpName = info.name..string.format(StringRes.LV,v.lv)
        if v.maxLv and v.maxLv == 0 then
            tmpName = info.name
        end
        text_name:setString(tmpName)
        local panel_progress_bg = curItem:getChildByName("panel_progress_bg")
        local text_unlock = curItem:getChildByName("text_unlock")
        if v.unlock then
            panel_progress_bg:setVisible(true)
            text_unlock:setVisible(false)
            local loadingbar_tech = panel_progress_bg:getChildByName("loadingbar_tech")
            local text_lev = loadingbar_tech:getChildByName("text_lev")
            loadingbar_tech:setPercent(v.exp/v.expMax*100)
            local tmpLvInfo = string.format("%d/%d",v.exp,v.expMax)
            if v.maxLv and v.lv >= v.maxLv then
                tmpLvInfo = StringRes.text_world0003
                loadingbar_tech:setPercent(100)
            end
            text_lev:setString(tmpLvInfo)
        else
            panel_progress_bg:setVisible(false)
            text_unlock:setVisible(true)
            text_unlock:setString(string.format(StringRes.unlock_info,info.unlocklv))
        end
        curItem.tag_data = v
        curItem.isMain = true
        self.listView:pushExpandItem(curItem)
    end
end

function ArmyGroupTechnology:donateCallBack(data)

    if data.refresh then
        self.listView:removeAllChildren()
        self:getTechData()
        return
    end

    for i,v in ipairs(self.listView:getItems())do
        if v.isMain then
            local info = v.tag_data
--            local text_name = v:getChildByName("text_name")
--            text_name:setString(gGuildtech[info.id].name..string.format(StringRes.LV,info.lv))
            local panel_progress_bg = v:getChildByName("panel_progress_bg")
            local loadingbar_tech = panel_progress_bg:getChildByName("loadingbar_tech")
            local text_lev = loadingbar_tech:getChildByName("text_lev")
            loadingbar_tech:setPercent(info.exp/info.expMax*100)
            local tmpLvInfo = string.format("%d/%d",info.exp,info.expMax)
            if v.maxLv and v.lv >= v.maxLv then
                tmpLvInfo = StringRes.text_world0003
                loadingbar_tech:setPercent(100)
            end
            text_lev:setString(tmpLvInfo)
        else
            self:updateResItem(v)
        end
    end
end

return ArmyGroupTechnology