local BattleSkill ={}

function BattleSkill:use(parent)
    --空中支援
    if parent.battleData.gfbSkill.type == 1 then
        parent:runAction(cc.Sequence:create(cc.DelayTime:create(B_TIME_INPOS),cc.CallFunc:create(function() 
            self:jetSupport(parent)
        end)))
    end
end

function BattleSkill:jetSupport(parent)
    local curIndex = 0
    function createJet(dt)
        curIndex = curIndex+1
        if curIndex > #(parent.battleData.gfbSkill.eff) then return end
        for i , v in ipairs(parent.battleData.gfbSkill.eff[curIndex]) do
            local ipos = parent.content:getChildByName("tb"..v.index)
            local jet = Animation:createAnimation(B_JET_ANI)
            jet:setPosition(ipos:getPositionX()-400,ipos:getPositionY()-200)
            parent.topBg:addChild(jet,200)
            local seq = cc.Sequence:create(cc.DelayTime:create(B_TIME_PERFLY),cc.CallFunc:create(createJet))
            jet:runAction(cc.Sequence:create(cc.MoveTo:create(B_TIME_ONFLY,cc.p(ipos:getPositionX()+400,ipos:getPositionY()+200)),cc.CallFunc:create(function()
                jet:removeFromParent()
            end)))
            jet:runAction(cc.Sequence:create(cc.DelayTime:create(B_TIME_ONFLY*0.6),cc.CallFunc:create(function()
                local unit = parent.units[UNITTOP..v.index]
                if unit then
                    unit:hitCallBack(v,MusicAndEffect.jetHit)
                else 
                    --攻击地面
                    --被击音效
                    MyAudio:PlayEffect(MusicAndEffect.jetHit)

                    local hole = Animation:createAnimation(B_JET_HOLE)
                    hole:setPosition(ipos:getPositionX(),ipos:getPositionY())
                    parent.topBg:addChild(hole,90)
                    hole:runAction(cc.Sequence:create(cc.MoveBy:create(B_TIME_DEAD_RM,cc.p(B_SPEED_X*B_TIME_DEAD_RM,B_SPEED_Y*B_TIME_DEAD_RM)),cc.CallFunc:create(function() 
                        hole:removeFromParent()
                    end)))

                    local node = Animation:createAnimation(B_JET_HIT)
                    node:getArmature():registerAnimationEventHandler(
                        function (t)
                            node:removeFromParent()
                        end
                    )
                    hole:addChild(node)

                end
            end)))
        end
    end
    createJet(0)
    local seq = cc.Sequence:create(cc.DelayTime:create(B_TIME_PERFLY),cc.CallFunc:create(createJet))
    parent:runAction(seq)




end

return BattleSkill