local BuffInfo = class("BuffInfo",function()
    return CCUILoader:load("csd/public/UI_BUFF.csb")
end)

function BuffInfo:show(parent)
    Connect:sendMsg("BuffAction","openBuff",{},
        function (data)
            local pd = PlayerData:getInstanse()
            pd.buffInfos = data
            table.sort(pd.buffInfos,function(a,b)
                if a.time == b.time then
                    return a.templateId < b.templateId
                else
                    return a.time > b.time
                end
            end)
            local layer = BuffInfo.new()
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)

end

function BuffInfo:ctor()
    self.listView = nil
    self:initView()
    --    self:getBuffInfos()
    self:initItems()

    local function update(delta)
        self:updateTime(delta)
    end

    self.updateId = cc.Director:getInstance():getScheduler():scheduleScriptFunc(update, 1, false)

    local function onNodeEvent(tag)
        if tag == "exit" then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.updateId)
            if gWorldScene ~= nil then
                gWorldScene:freshQuick()
                gWorldScene:getGametips()
            end
        end
    end

    self:registerScriptHandler(onNodeEvent)

    ViewManager:OpenView(self)
end

--function BuffInfo:getBuffInfos()
--    Connect:sendMsg("BuffAction","openBuff",{},
--        function (data)
--            local pd = PlayerData:getInstanse()
--            pd.buffInfos = data
--            table.sort(pd.buffInfos,function(a,b)
--                if a.time == b.time then
--                    return a.templateId < b.templateId
--                else
--                    return a.time > b.time
--                end
--            end)
--            self:initItems()
--        end,true)
--end

--初始化界面
function BuffInfo:initView()
    --增益信息
    self:getChildByName("node_bg"):getChildByName("text_title"):setString(StringRes.buff_info)
    --关闭按钮
    self:getChildByName("node_bg"):getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            require("src/app/util/NodeTranslator"):transDown(self,function()
                self:removeFromParent()
            end)
        end
    end)
    self.listView = ExpandListView.new(self:getChildByName("node_bg"):getChildByName("listView_content"),handler(self,self.lvListener))
end

function BuffInfo:initItems()
    local pd = PlayerData:getInstanse()
    local item = self:getChildByName("item_main")
    for k,v in pairs(pd.buffInfos) do
        local info = gBuff[v.templateId]
        local curItem = item:clone()
        local icon_item = curItem:getChildByName("icon_item")
        icon_item:loadTexture(info.icon,ResType)
        local text_info = curItem:getChildByName("text_info")
        text_info:setString(StringRes[info.desc])
        curItem.serverData = v
        curItem.isMainItem = true
        if v.templateId == 10 then
            curItem:getChildByName("check_detail"):setVisible(false)
            local icon_time = curItem:getChildByName("icon_time")
            icon_time:setVisible(true)
            if v.time == -1 then
                icon_time:getChildByName("text_time"):setString(StringRes.earawar_32)
                text_info:setString(string.format(StringRes[info.desc],v.effect*100))
            else
                icon_time:getChildByName("text_time"):setString(StringRes.earawar_31)
                text_info:setString(string.format(StringRes[info.desc],0))
            end
            self.listView:pushBackCustomItem(curItem)
        else
            self.listView:pushExpandItem(curItem)
        end
    end
    self:updateTime(0)
end

function BuffInfo:lvListener(listview,item,index,type)
    print("index: "..index.."  type:"..type)
    if item.serverData.templateId == 10 then return end
    if type == ExpandListView_Type_Open then
        item:getChildByName("check_detail"):setSelected(true)
        self.listView:insertExpandContent(self:createExpandItem(item),index+1)
    elseif type == ExpandListView_Type_Close then
        item:getChildByName("check_detail"):setSelected(false)
    end
end

function BuffInfo:createExpandItem(item)
    local content = self:getChildByName("content_dtl"):clone()
    local data = item.serverData

    function getItemNum(id)
        for k,v in pairs(data.buffItemsVOs)do
            if id == v.templateId then
                return v.count,v.id
            end
        end
        return 0,0
    end

    local tmp = self:getChildByName("item_detail")
    for i,v in ipairs(string.split(gBuff[data.templateId].item,","))do
        local height = content:getContentSize().height-(tmp:getContentSize().height*i)
        local curItem = tmp:clone()
        curItem:setPosition(cc.p(0,height))
        local id = tonumber(v)
        curItem.tagId = id
        local tmpInfo = gItem[id]
        local icon_dtl = curItem:getChildByName("icon_dtl")
        icon_dtl:loadTexture(tmpInfo.icon,ResType)
        local text_title = curItem:getChildByName("text_title")
        text_title:setString(StringRes[tmpInfo.name])
        local text_info = curItem:getChildByName("text_info")
        text_info:setString(StringRes[tmpInfo.desc])
        local num_coin = curItem:getChildByName("num_coin")
        num_coin:setString(gStore[id].price*15)
        local text_num = curItem:getChildByName("text_num")
        local count,sid = getItemNum(id)
        text_num:setString(string.format(StringRes.cur_num,count))

        local btn_buy = curItem:getChildByName("btn_buy")
        local btn_use = curItem:getChildByName("btn_use")

        --使用道具
        function useItem(item,sid)
            local senddata = {id = sid,count = 1}
            Connect:sendMsg("BagAction","useBagItems",senddata,
                function(data)
                    if data.state == 1 then

                        item:getChildByName("text_num"):setString(string.format(StringRes.cur_num,data.count))
                        local btnBuy = item:getChildByName("btn_buy")
                        local btnUse = item:getChildByName("btn_use")
                        if data.count <= 0 then
                            --购买并使用
                            btnBuy:setVisible(true)
                            btnUse:setVisible(false)
                            btnBuy:addTouchEventListener(function(e, t)
                                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                                    buyAndUseItem(item)
                                end
                            end)
                        end

                        --使用后重新刷新显示
                        Connect:sendMsg("BuffAction","openBuff",{},
                            function (data)
                                local pd = PlayerData:getInstanse()
                                pd.buffInfos = data
                                table.sort(pd.buffInfos,function(a,b)
                                    if a.time == b.time then
                                        return a.templateId < b.templateId
                                    else
                                        return a.time > b.time
                                    end
                                end)
                                self:refreshItemData()
                                self:updateTime(0)
                                FlyWordPrompt:prompt(string.format(StringRes.use_success,StringRes[gItem[item.tagId].name]))
                            end)

                    else
                    --使用失败

                    end

                end)
        end

        --购买并使用
        function buyAndUseItem(item)
            DialogUtil:buy(gStore[item.tagId].price*15,StringRes[gItem[item.tagId].name],function()
                local pd = PlayerData:getInstanse()
                local senddata = {id = item.tagId    }
                Connect:sendMsg("ShopAction","buyShopItems",senddata,
                    function(data)
                        if data.state == 1 then
                            pd.basicData.gold = data.gold
                            useItem(item,data.id)
                        else
                        --购买失败

                        end

                    end)
            end)

        end

        if count > 0 then
            --使用
            btn_buy:setVisible(false)
            btn_use:setVisible(true)
            btn_use:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    useItem(curItem,sid)
                end
            end)
        else
            --购买并使用
            btn_buy:setVisible(true)
            btn_use:setVisible(false)
            btn_buy:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    buyAndUseItem(curItem)
                end
            end)
        end

        content:addChild(curItem)
    end
    return content
end

function BuffInfo:updateTime(dt)
    for k,v in pairs(self.listView:getItems()) do
        if v.isMainItem then
            if v.serverData.templateId ~= 10 then
                if v.serverData.time > 0 then
                    local icon_time = v:getChildByName("icon_time")
                    icon_time:setVisible(true)
                    icon_time:getChildByName("text_time"):setString(StringTemp:toTime2(v.serverData.time))
                else
                    v:getChildByName("icon_time"):setVisible(false)
                end
            end
        end
    end
end

--更新每项数据
function BuffInfo:refreshItemData()
    local pd = PlayerData:getInstanse()
    for k,v in pairs(self.listView:getItems()) do
        if v.isMainItem then
            for k2,v2 in pairs(pd.buffInfos) do
                if v.serverData.templateId == v2.templateId then
                    v.serverData = v2
                    break
                end
            end

        end
    end
end

return BuffInfo