BuildView = class("BuildView",function(scene,data,isResBld)
    return CCUILoader:load("res/csd/public/TabBuild.csb")
end)

function BuildView:ctor(scene,data,isResBld)
    self:initView(data,isResBld)

    ViewManager:OpenView(self)
end

function BuildView:setTitleAndInfo(data)
    
    if self:getParent() then
        self:getParent().setTitle(self:getParent(),string.format(StringRes[gBuilding[data.templateId].name]..StringRes.LV,data.buildLv))
    end
    
    local templateId = data.templateId

    local bInfo = self:getChildByName("ScrollView"):getChildByName("bInfo")

    local info = bInfo:getChildByName("text_info")
    if templateId == 1 or templateId == 10 or templateId == 14 or templateId == 15 or templateId == 16 or templateId == 17 then
        info:setString(string.format(StringRes[gBuilding[templateId].dec],StringTemp:toNum(gDataResourse[data.buildLv][templateId]),StringTemp:toNum(gDataResourse[data.buildLv][templateId]*36)))
    elseif templateId == 6 or templateId == 7 then --仓库
        info:setString(string.format(StringRes[gBuilding[templateId].dec],StringTemp:toNum(math.ceil(gDataResourse[data.buildLv][10]*0.4*24*(data.buildLv*0.05+1)))))
    else
        info:setString(StringRes[gBuilding[templateId].dec])
    end
end

function BuildView:showMax(data,isResBld)
    local content = self:getChildByName("ScrollView")
    local con= content:getChildByName("resNeed"):getChildByName("content")
    con:getChildByName("title"):setVisible(false)
    con:getChildByName("list"):setVisible(false)
    con:getChildByName("textInfo"):setVisible(true)
    content:getChildByName("btnRight"):setVisible(false)
    content:getChildByName("bInfo"):getChildByName("text_time"):setVisible(false)
    content:getChildByName("bInfo"):getChildByName("Image_3"):setVisible(false)
    content:getChildByName("progressBg"):setVisible(false)

    local btnLeft = content:getChildByName("btnLeft")
    local btnMiddle = content:getChildByName("btnMiddle")
    btnMiddle:setVisible(false)

    require("src/app/util/SDKPlatform")
    -- 是否可拆除
    if isResBld then
        btnLeft:setTitleText(StringRes.remove)
        btnLeft:setVisible(true)
        btnLeft:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                PromptView:inputOK(function()
                    SDKPlatform:printLog("inputOK")
                    local msg = { blockId = data.blockId,buildType = data.buildType , dbId=data.dbId}
                    Connect:sendMsg("BuildAction","removeOutskirtsBuilding",msg,
                        function (sdata)
                            local pd = PlayerData:getInstanse()
                            pd:removeResBuilding(sdata)
                            self:getParent():close()
                            self:removeFromParent()
                        end)
                end,StringRes.ok_removeRes)
            end
        end)
    else
        btnLeft:setVisible(false)
    end

end
function BuildView:initView(data,isResBld)
    local templateId = data.templateId
    local upgradeLv= data.buildLv+1
    local content = self:getChildByName("ScrollView")

    local bInfo = content:getChildByName("bInfo")
    local resNeed = content:getChildByName("resNeed")


    local icon = bInfo:getChildByName("icon_building")
    icon:loadTexture(gBuilding[templateId].icon,ResType)

    local title = bInfo:getChildByName("text_title")
    title:setString(StringRes[gBuilding[templateId].name])

    self:setTitleAndInfo(data)

    local tempId = templateId.."_"..upgradeLv
    --不需要建造的
    if gBuilding[templateId].lv == 0 or Buildings:CheckUpgrade(templateId,data.buildLv) == 3 then
        self:showMax(data,isResBld)
        return
    end

    self.text_time = bInfo:getChildByName("text_time")

    local btnLeft = content:getChildByName("btnLeft")
    local btnMiddle = content:getChildByName("btnMiddle")
    local btnRight = content:getChildByName("btnRight")
    self.rBtnText_time=btnRight:getChildByName("Node_Time"):getChildByName("Text_time")
    if not isResBld then
        btnLeft:setVisible(false)
        Common:setButtonEnabled(btnLeft, false)

        btnMiddle:setPositionX(content:getChildByName("Position_Left"):getPositionX())
        btnRight:setPositionX(content:getChildByName("Position_Right"):getPositionX())
    end
    local progressBg = content:getChildByName("progressBg")
    local progress = progressBg:getChildByName("progress")
    local proTime = progressBg:getChildByName("time")

    --刷新所需资源
    local listView = resNeed:getChildByName("content"):getChildByName("list")
--    local item = CCUILoader:load("res/csd/public/ResNeedItem.csb"):getChildByName("content")
    local pd = PlayerData:getInstanse()

    --指挥中心
    local temp={}

    if templateId ~= 1 then
        temp.icon = nil
        temp.name = StringRes.Building_Name_1
        temp.require = upgradeLv
        temp.own = pd:getBaseBuildLv(1)
        self.lvItem1 = preLoad:getPanel("BuildingResItem")--item:clone()
        self:refreshResItem(listView,self.lvItem1,temp)
    end


--    --特殊处理
--    if templateId == 3 then
--        tempId = "2_"..upgradeLv
--    end
--    if templateId == 7 then
--        tempId = "6_"..upgradeLv
--    end
    --其他资源
    temp={}
    temp.icon = ResIconCfg.ferrum
    temp.name = StringRes.iron_ore
    temp.require = gBuilding_Consumption[tempId].fe
    temp.own = pd.basicData.ferrum
    self.lvItem2 = preLoad:getPanel("BuildingResItem")
    self.lvItem2.tagId = 2
    self:refreshResItem(listView,self.lvItem2,temp)
    
    temp={}
    temp.icon = ResIconCfg.oil
    temp.name = StringRes.oil
    temp.require = gBuilding_Consumption[tempId].oil
    temp.own = pd.basicData.oil
    self.lvItem3 = preLoad:getPanel("BuildingResItem")
    self.lvItem3.tagId = 3
    self:refreshResItem(listView,self.lvItem3,temp)

    temp={}
    temp.icon = ResIconCfg.lead
    temp.name = StringRes.vanadium
    temp.require = gBuilding_Consumption[tempId].lead
    temp.own = pd.basicData.lead
    self.lvItem4 = preLoad:getPanel("BuildingResItem")
    self.lvItem4.tagId = 4
    self:refreshResItem(listView,self.lvItem4,temp)


    --刷新
    progressBg:setVisible(false)

    local bldData = nil

    function self.update(dt)
        if isResBld then
            bldData = pd:getResBuildData(data.blockId)
        else
            bldData = pd:getBaseBuildData(templateId)
        end
        self:setTitleAndInfo(bldData)
        
        local pd = PlayerData:getInstanse()
        local visiable = bldData.time > 0
        progressBg:setVisible(visiable)
        btnLeft:setVisible(visiable)
        if visiable then
            --显示进度条
            local tmpPercent = (bldData.allTime-bldData.time)/bldData.allTime*100
            if bldData.time < 1 then
                tmpPercent = 100
            end
            progress:setPercent(tmpPercent)
            proTime:setString(StringTemp:toTime(bldData.time))
            
            if isResBld and data.buildLv==0 then
            --资源建筑 建造中  不显示 加速 和取消,
                btnRight:setVisible(false)
                btnLeft:setVisible(false)
                btnMiddle.setVisible(false)
                return            
            end

            
            --建造\升级按钮监听
            btnRight:setTitleText(StringRes.speedup)
            btnLeft:setTitleText(StringRes.cancel)
            btnRight:getChildByName("Node_gold"):setVisible(true)
            btnRight:getChildByName("Node_Time"):setVisible(false)
            btnRight:getChildByName("Text_Tips"):setVisible(false)
            local need = Common:getSpendByTime(bldData.time)
            need = need>PlayerData:getInstanse().basicData.lvUpFreeGold and need or 0
            local text_gold = btnRight:getChildByName("Node_gold"):getChildByName("Text_gold")
            if need > 0 then
                text_gold:setString(need)
            else
                text_gold:setString(StringRes.Text_Free)
            end
            if need > PlayerData:getInstanse().basicData.gold then
                --金币不足
                text_gold:setColor(CommonColor.Red)
            else
                text_gold:setColor(CommonColor.White)
            end
            local btn
            if isResBld then
                btn = btnLeft
                btnMiddle:setVisible(false)
            else
                btn = btnMiddle
                btnMiddle:getChildByName("Text_gold"):setVisible(false)
                btnMiddle:getChildByName("Sprite_gold"):setVisible(false)
                btnLeft:setVisible(false)
            end
            btn:setTitleText(StringRes.cancel)
            btn:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    --取消
                    require("src/app/util/DialogUtil"):cancel(function()
                        local msg = { type = data.buildType , dbId=data.dbId}
                        Connect:sendMsg("BuildAction","cancelBuildLvup",msg,
                            function (sdata)
                                local pd = PlayerData:getInstanse()
                                pd:cancelBuildFresh(sdata)
                                self.update(0)
                            end)
                    end)
                end
            end)
            btnRight:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    --加速
                    function SpeedUp()
                        local msg = { type = data.buildType , dbId=data.dbId}
                        Connect:sendMsg("BuildAction","buildOverSpeedUpFree",msg,
                            function (v)
                                local pd = PlayerData:getInstanse()
                                pd:BuildTimeOverFresh(v)
                                self.update(0)

                                if v.templateId == 1 then
                                    gWorldScene:BaseQuest()
                                end

                                FlyWordPrompt:prompt(string.format(StringRes.levelup_info,StringRes[gBuilding[templateId].name],v.lv))

                            end)
                    end
                    if need > 0 then
                        require("src/app/util/DialogUtil"):speedUp(bldData.time, SpeedUp)
                    else
                        SpeedUp()
                    end


                end
            end)
        else
            --建造\升级按钮监听
            if data.buildLv == 0 then
                btnRight:setTitleText(StringRes.build)
            else
                btnRight:setTitleText(StringRes.levelup)
            end
            btnRight:setVisible(true)
            btnRight:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    local msg = { type = data.buildType , dbId=data.dbId}
                    Connect:sendMsg("BuildAction","buildinglvup",msg,
                        function (sdata)
                            if sdata.type == 0 then
                                --队列满
                                local bld = PlayerData:getInstanse():getMinTimeLevelUpBld()
                                ManyDialogInfo:more_produce_queues(bld.time,"buildQueue",PlayerData:getInstanse().basicData.lvUpFreeGold,function()
                                    local msg = { type = bld.buildType , dbId=bld.dbId}
                                    Connect:sendMsg("BuildAction","buildOverSpeedUpFree",msg,
                                        function (v)
                                            local pd = PlayerData:getInstanse()
                                            pd:BuildTimeOverFresh(v)
                                            self.update(0)

                                            if v.templateId == 1 then
                                                gWorldScene:BaseQuest()
                                            end

                                            FlyWordPrompt:prompt(string.format(StringRes.levelup_info,StringRes[gBuilding[v.templateId].name],v.lv))

                                        end)
                                end)
                            else
                                local pd = PlayerData:getInstanse()
                                pd:BuildFresh(sdata)
                                self.update(0)
                            end
                        end)
                end
            end)

            -- 是否可拆除
            if isResBld then
                btnLeft:setTitleText(StringRes.remove)
                btnLeft:setVisible(true)
                btnLeft:addTouchEventListener(function(e, t)
                    if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                        PromptView:inputOK(function()
                            local msg = { blockId = data.blockId,buildType = data.buildType , dbId=data.dbId}
                            Connect:sendMsg("BuildAction","removeOutskirtsBuilding",msg,
                                function (sdata)
                                    local pd = PlayerData:getInstanse()
                                    pd:removeResBuilding(sdata)
                                    self:getParent():close()
                                    self:removeFromParent()
                                end)
                        end,StringRes.ok_removeRes)
                    end
                end)
            end

            btnMiddle:setTitleText(StringRes.upgradeNow)
            btnMiddle:setVisible(true)
            btnMiddle:getChildByName("Text_gold"):setVisible(true)
            btnMiddle:getChildByName("Sprite_gold"):setVisible(true)
            local need = Common:getGoldNeedForBuild(bldData)
            local text_gold = btnMiddle:getChildByName("Text_gold")
            text_gold:setString(need)
            if need > PlayerData:getInstanse().basicData.gold then
                --金币不足
                text_gold:setColor(CommonColor.Red)
            else
                text_gold:setColor(CommonColor.White)
            end
            btnMiddle:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    function SpeedUpNow()
                        local msg = { type = data.buildType , dbId=data.dbId }
                        Connect:sendMsg("BuildAction","buildinglvupNow",msg,
                            function (v)
                                local pd = PlayerData:getInstanse()
                                pd:BuildTimeOverFresh(v)
                                pd:BuildFresh(v)
                                self.update(0)

                                if v.templateId == 1 then
                                    gWorldScene:BaseQuest()
                                end

                                FlyWordPrompt:prompt(string.format(StringRes.levelup_info,StringRes[gBuilding[templateId].name],v.lv))

                            end)

                    end
                    local spend  = Common:getGoldNeedForBuild(bldData)
                    DialogUtil:LvupNow(spend, function()
                        --立刻完成
                        SpeedUpNow()
                    end)
                end
            end)
        end


        --刷新资源数据
        local state = self:refreshAllView(bldData,isResBld)
        if state == 0 or visiable then
            btnRight:setBright(true)
            btnRight:setEnabled(true)
            if not visiable then
                --不显示进度条
                self.text_time:setString(StringTemp:toTime(Common:getBuildingUpTime(bldData.buildLv+1,templateId)))
                self.rBtnText_time:setString(StringTemp:toTime(Common:getBuildingUpTime(bldData.buildLv+1,templateId)))
                btnRight:getChildByName("Node_gold"):setVisible(false)
                btnRight:getChildByName("Node_Time"):setVisible(true)
                btnRight:getChildByName("Text_Tips"):setVisible(false)
                Common:setBtnTouchEnable(btnMiddle, true and data.buildLv > 0)
                btnMiddle:setVisible(true and data.buildLv > 0)
            end
        else
            showShader:buttonToGray(btnRight)
            btnRight:setBright(false)
            btnRight:setEnabled(false)
            --等级达到最大的情况在showmax里处理， 这里不再处理
            if state == 2 then
                --等级不足
                btnRight:getChildByName("Text_Tips"):setString(StringRes.Text_NeedLevel)
                btnRight:getChildByName("Node_gold"):setVisible(false)
                btnRight:getChildByName("Node_Time"):setVisible(false)
                btnRight:getChildByName("Text_Tips"):setVisible(true)
                Common:setBtnTouchEnable(btnMiddle, false)
                btnMiddle:setVisible(false)
            elseif state == 3 then
                --资源不足
                btnRight:getChildByName("Text_Tips"):setString(StringRes.Text_NeedRes)
                btnRight:getChildByName("Node_gold"):setVisible(false)
                btnRight:getChildByName("Node_Time"):setVisible(false)
                btnRight:getChildByName("Text_Tips"):setVisible(true)
                Common:setBtnTouchEnable(btnMiddle, true and data.buildLv > 0)
                btnMiddle:setVisible(true and data.buildLv > 0)
            end
        end

    end
    self.update(0)
    self.updateId = cc.Director:getInstance():getScheduler():scheduleScriptFunc(self.update, 1, false)

    local function onNodeEvent(tag)
        if tag == "exit" then
            if self.updateId then
                cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.updateId)
            end
        end
    end

    self:registerScriptHandler(onNodeEvent)

end

function BuildView:refreshResItem(listView,item,data)
    listView:pushBackCustomItem(item)
    local iIcon = item:getChildByName("Image_1")
    local iName = item:getChildByName("category")
    local iRequire = item:getChildByName("require")
    local iCheck = item:getChildByName("Image_8")
    local iOwn = item:getChildByName("own")
    local iMore = item:getChildByName("more")
    iMore:setVisible(false)
    if data.icon then
        iIcon:setVisible(true)
        iIcon:loadTexture(data.icon,ResType)
        iRequire:setString(StringTemp:toNum(data.require))
        iOwn:setString(StringTemp:toNum(data.own))
    else
        iIcon:setVisible(false)
        iRequire:setString(string.format(StringRes.LV2,data.require))
        iOwn:setString(string.format(StringRes.LV2,data.own))
    end
    iName:setString(data.name)
    if data.require > data.own then
        --资源不足
        iCheck:loadTexture(ICON_FALT,ResType)
        if data.icon then
            iMore:setVisible(true)
            iMore:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    MoreRes:show(self,item.tagId,function() 
                        self.update(0) 
                    end)
                end
            end)
        end
    else
        iCheck:loadTexture(ICON_CHECK,ResType)
        if data.icon then
            iMore:setVisible(false)
        end
    end
end

--0:可以建造升级
--1:达到最大等级
--2:等级不足
--3:资源不足
function BuildView:refreshAllView(data,isResBld)
    local pd = PlayerData:getInstanse()
    local templateId = data.templateId
    local upgradeLv = data.buildLv+1

    if Buildings:CheckUpgrade(templateId,data.buildLv) == 3 then
        self:showMax(data,isResBld)
        return 1
    end

    self.text_time:setString(StringTemp:toTime(Common:getBuildingUpTime(upgradeLv,templateId)))
    self.rBtnText_time:setString(StringTemp:toTime(Common:getBuildingUpTime(upgradeLv,templateId)))


    local needMore = false
    local tempId = templateId.."_"..upgradeLv
    --    --特殊处理
    --    if templateId == 3 then
    --        tempId = "2_"..upgradeLv
    --    end
    --    if templateId == 7 then
    --        tempId = "6_"..upgradeLv
    --    end
    local temp={}
    temp.icon = ""
    temp.require = gBuilding_Consumption[tempId].fe
    temp.own = pd.basicData.ferrum
    tempNM = self:refreshResData(self.lvItem2,temp)
    if not needMore and tempNM then
        needMore = tempNM
    end

    temp={}
    temp.icon = ""
    temp.require = gBuilding_Consumption[tempId].oil
    temp.own = pd.basicData.oil
    tempNM = self:refreshResData(self.lvItem3,temp)
    if not needMore and tempNM then
        needMore = tempNM
    end

    temp={}
    temp.icon = ""
    temp.require = gBuilding_Consumption[tempId].lead
    temp.own = pd.basicData.lead
    tempNM = self:refreshResData(self.lvItem4,temp)
    if not needMore and tempNM then
        needMore = tempNM
    end


    temp={}
    temp.icon = nil
    temp.require = upgradeLv
    temp.own = pd:getBaseBuildLv(1)

    local tempNM = false
    if templateId ~= 1 then
        tempNM = self:refreshResData(self.lvItem1,temp)
        if tempNM then
            --等级不足
            return 2
        end
    end

    if needMore then
        --资源不足
        return 3
    end

    return 0
end

function BuildView:refreshResData(item,data)

    local needMore = false

    local iRequire = item:getChildByName("require")
    local iCheck = item:getChildByName("Image_8")
    local iOwn = item:getChildByName("own")
    local iMore = item:getChildByName("more")

    if data.icon then
        iRequire:setString(StringTemp:toNum(data.require))
        iOwn:setString(StringTemp:toNum(data.own))
    else
        iRequire:setString(string.format(StringRes.LV2,data.require))
        iOwn:setString(string.format(StringRes.LV2,data.own))
    end

    if data.require > data.own then
        needMore = true
        --资源不足
        iCheck:loadTexture(ICON_FALT,ResType)
        if data.icon then
            iMore:setVisible(true)
            iMore:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    MoreRes:show(self,item.tagId,function() 
                        self.update(0) 
                    end)
                end
            end)
        end
    else
        iCheck:loadTexture(ICON_CHECK,ResType)
        if data.icon then
            iMore:setVisible(false)
        end
    end

    return needMore
end


return BuildView