Buildings = {}

--1 指挥中心（默认1级解锁）
--2 坦克工厂1（默认1级解锁）
--3 坦克工厂2（默认13级解锁）
--4 军团（默认5级解锁）
--5 科技中心（默认3级解锁）
--6 仓库1（默认9级解锁）
--7 仓库2（默认17级解锁）
--8 装置车间（默认10级解锁）
--9 军事学院（默认20级解锁）
--10 水晶工厂（默认7级解锁）
--11 改造车间（默认15级解锁）
--12 配件工厂（默认12级解锁）
--13 作战中心（默认20级解锁）
--14 铁矿
--15 石油
--16 铅矿
--17 钛矿

function Buildings:isCanEnter(vo)
    if vo == nil then
    	return false
    end
	 --判断是否可以进入建筑
    if vo.canBuild or vo.buildLv > 0 or vo.time > 0  then
        return true
    else
        return false
    end
end

function Buildings:enter( vo , parent )
    
    
    --判断是否可以进入建筑
    if vo.canBuild or vo.buildLv > 0 or vo.time > 0  then
        MyAudio:PlayEffect(gBuilding[vo.templateId].openAudio)
        --坦克工厂 / 改造车间(11)
        if vo.templateId == 2 or vo.templateId == 3 or vo.templateId == 11 then
            local layer = require("src/app/views/buildings/TankFactory").new(parent,vo)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end
        
        --科研中心
        if vo.templateId == 5 then
            --            local TroopsView = require("src/app/views/troops/TroopsView")
            --            TroopsView:open(parent,1)
            local ScienceCenterView = require("src/app/views/study/ScienceCenterView")
            ScienceCenterView:open(parent,vo)
        end
        
        --指挥中心Command centre
        if vo.templateId == 1 then
            local layer = require("src/app/views/buildings/CommandCentre.lua").new(parent,vo)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end
        
        --装置车间
        if vo.templateId == 8 then
            local layer = require("src/app/views/buildings/DeviceFactory").new(parent,vo)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end
        
        --仓库、水晶工厂
        if vo.templateId == 6 or vo.templateId == 7 or vo.templateId == 10 then
            local layer = require("src/app/views/buildings/BuildingOnlyBuild.lua").new(parent,vo)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end
        
        if vo.templateId == 12 then
            local AccessoriesView = require("src/app/views/accessories/AccessoriesView")
            AccessoriesView:open(parent)
        end
        
        --军团
        if vo.templateId == 4 then
            local pd = PlayerData:getInstanse()
            --判断是否有军团
            if pd.basicData.guildId == 0 then
                local ArmyGroupApply = require("src/app/views/armygroup/ArmyGroupApply")
                ArmyGroupApply:show(parent)
            else
                local ArmyGroupMain = require("src/app/views/armygroup/ArmyGroupMain")
                ArmyGroupMain:show(parent)
            end
        end
        
        if vo.templateId == 13 then
            local CombatCenterView = require("src/app/views/combat/CombatCenterView")
            CombatCenterView:open(parent)
        end
        
        if vo.templateId == 9 then
            require("src/app/views/academy/AcademyMain"):show(parent)
        end
	else
        PromptView:type1(StringRes.notice,
            string.format( StringRes[gBuilding[vo.templateId].unlockdes],gBuilding[vo.templateId].unlock)
            ,StringRes.ok)
    end


end


function Buildings:CheckUpgrade(tmpId,Lv)
    -- 1：可升级
    -- 2：资源不足
    -- 3：已达最大等级
    local pd = PlayerData:getInstanse()
    local templateId = tmpId
    local upgradeLv= Lv+1
    
    local tempData = gBuilding_Consumption[templateId.."_"..upgradeLv]
    if (pd.basicData.buildLimit and Lv >= pd.basicData.buildLimit) or tempData == nil then
        return 3
    end
    
    local temp={}

    if templateId ~= 1 then
        temp.require = upgradeLv
        temp.own = pd:getBaseBuildLv(1)
        if temp.require > temp.own then
        	return 2
        end
    end


    --其他资源
    temp={}
    temp.require = tempData.fe
    temp.own = pd.basicData.ferrum
    if temp.require > temp.own then
        return 2
    end

    temp={}
    temp.require = tempData.oil
    temp.own = pd.basicData.oil
    if temp.require > temp.own then
        return 2
    end
    temp={}
    temp.require = tempData.lead
    temp.own = pd.basicData.lead
    if temp.require > temp.own then
        return 2
    end
    return 1
end

function Buildings:getNeedTime( buildLv, needTime,templateId)
    local sadd = 0
    local pd =  PlayerData:getInstanse().PlayerAddition
    if templateId == 2 then --坦克工厂
        sadd  = pd.tankAdd
    elseif templateId == 11 then --改装车间
        sadd = pd.reformAdd
    end
    local  add = buildLv * 0.05
    local costTime = math.ceil(needTime / (1 + add + sadd))
    return costTime
end

function Buildings:getTankNeedTime( buildLv, tag,templateId) --重工，改装   坦克所需时间
    local needTime = 0
    local sadd = 0
    local pd =  PlayerData:getInstanse().PlayerAddition
    if templateId == 2 or templateId == 3 then --坦克工厂
        sadd  = pd.tankAdd
        needTime = Tank[tag].needTime
    elseif templateId == 11 then --改装车间
        sadd = pd.reformAdd
        needTime = Tank[tag].reformTime
    end
    local  add = buildLv * 0.05
    local costTime = math.ceil(needTime / (1 + add + sadd))
    return costTime
end

function Buildings:checkArmyGroup(parent,index)
    local pd =  PlayerData:getInstanse()
    if pd.basicData.lv < 3 then--指挥中心5级开放
        PromptView:type1(StringRes.notice,
            string.format( StringRes[gBuilding[4].unlockdes],gBuilding[4].unlock)
            ,StringRes.ok)
    else
        --判断是否有军团
        if pd.basicData.guildId == 0 then
            local ArmyGroupApply = require("src/app/views/armygroup/ArmyGroupApply")
            ArmyGroupApply:show(parent,index)
        else
            return true
        end
    end
    return false
end

function Buildings:gotoArmyGroupStore(parent)
    if Buildings:checkArmyGroup(parent) then
        require("src/app/views/armygroup/ArmyGroupStore"):show(parent)
	end
end

function Buildings:gotoArmyGroupTechnology(parent)
    if Buildings:checkArmyGroup(parent) then
        require("src/app/views/armygroup/ArmyGroupTechnology"):show(parent)
    end
end

function Buildings:gotoArmyGroupFB(parent)
    if Buildings:checkArmyGroup(parent) then
        require("src/app/views/armygroup/ArmyGroupFB"):show(parent)
    end
end

function Buildings:openMaxTankFactory(parent,index)
    local pd = PlayerData:getInstanse()
    local maxLvbuild = pd:getBaseBuildMaxLvData("2,3")
    
    if not (maxLvbuild and maxLvbuild.buildLv>0) then 
        index = 1
    end
    
    local layer = require("src/app/views/buildings/TankFactory").new(parent,maxLvbuild)
    parent:addChild(layer)
    require("src/app/util/NodeTranslator"):transUp(layer,nil)
    layer:setTabSelect(index)
end

return Buildings