local PanelTabLayer = require("src/app/views/public/PanelTabLayer")
local Connect = require("src/app/util/Connect")
local CommandCentre = class("CommandCentre",function(scene,data)
    return PanelTabLayer.new(scene,{title=string.format(StringRes.Building_Name_1..StringRes.LV,data.buildLv),tabs={StringRes.build,StringRes.explain}})
end)

function CommandCentre:ctor(scene,data)
    self.build = nil
    self.explain = nil
    self:initTabs(scene,data)

    ViewManager:OpenView(self)
end

function CommandCentre:initTabs(scene,data)
    self:registerTabEvent(1,function()
        --建造
        if self.build == nil then
            self.build = BuildView.new(scene,data)
            self:addChild(self.build)
        end
        if self.build then self.build:setVisible(true) end
        if self.explain then self.explain:setVisible(false) end
    end)
    
    self:registerTabEvent(2,function()
        --说明
        if self.explain == nil then
            self.explain = CCUILoader:load("csd/public/CommandExplain.csb")
            self.explain:getChildByName("text_explain"):setString(StringRes.center_des)
            self:addChild(self.explain)
        end
        if self.explain then self.explain:setVisible(true) end
        if self.build then self.build:setVisible(false) end
    end)
    self:setTabSelect(1)
end

return CommandCentre