local PanelTabLayer = require("src/app/views/public/PanelTabLayer")

local DeviceFactory = class("DeviceFactory",function(scene,data)
    return PanelTabLayer.new(scene,{title=string.format(StringRes[gBuilding[data.templateId].name],data.buildLv),tabs={StringRes.create_device,StringRes.producing}})
end)

function DeviceFactory:ctor(scene,data)
--    self.cBuild = nil
    self.cProduce = nil
    self.cProducing = nil
    self.data = data
    self:initTabs(scene,data)

    self:getData()
    local function update(delta)
        local pd = PlayerData:getInstanse()
        --生产道具倒计时
        if pd.producingProps then
            for k,v in pairs(pd.producingProps) do
                --时间减少
                if v.remainTime > 0 then
                    v.remainTime = v.remainTime - delta
                    if v.remainTime < 0 then
                        v.remainTime = 0
                        self:getItemsCount()
                        FlyWordPrompt:prompt(string.format(StringRes.produce_complt,StringRes[gItem[v.baseId].name]))
                    end
                end
            end
        end

        self:refreshProduceQueue()
    end

    self.updateId = cc.Director:getInstance():getScheduler():scheduleScriptFunc(update, 0.8, false)

    local function onNodeEvent(tag)
        if tag == "exit" then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.updateId)
        end
    end

    self:registerScriptHandler(onNodeEvent)

    ViewManager:OpenView(self)
end

function DeviceFactory:addProduceQueue()
    if self.cProducing then
        local listview = self.cProducing:getChildByName("listview")
        local item = CCUILoader:load("res/csd/public/ProducingItem.csb"):getChildByName("content")
        item = item:clone()
        showShader:buttonToGray(item:getChildByName("btn_speed"))
        listview:pushBackCustomItem(item)
        return item
    end
end

--刷新生产队列中某项
function DeviceFactory:updateProduceQueue(item,data)
    local name = item:getChildByName("text_title")
    name:setString(StringRes[gItem[data.baseId].name].."*"..data.num)
    local time = item:getChildByName("text_time")
    local pro = (data.totalTime - data.remainTime)/(data.totalTime-1)*100
    local progress = item:getChildByName("progress")
    local icon = item:getChildByName("icon_item")
--    icon:loadTexture(gItem[data.baseId].icon,ResType)
    local btnRight = item:getChildByName("btn_speed")
    local Text_Coin = item:getChildByName("Text_coin")
    Text_Coin:setVisible(false)
    item:getChildByName("Sprite_coin"):setVisible(false)
    Common:changePic(icon,gItem[data.baseId].icon)
    if pro < 0 then
        progress:setPercent(0)
        time:setString(StringRes.waiting)
        showShader:buttonToGray(btnRight)
        btnRight:setBright(false)
        btnRight:setEnabled(false)
    else
        time:setString(StringTemp:toTime(data.remainTime))
        progress:setPercent(pro)
        btnRight:setBright(true)
        btnRight:setEnabled(true)
    end
    --取消
    local btnNo = item:getChildByName("btn_cancel")
    btnNo:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            require("src/app/util/DialogUtil"):cancel(function()
                local msg = {buildId=self.data.templateId,id=data.id}
                Connect:sendMsg("DeviceFactoryAction","cancel",msg,function(data)
                    local pd = PlayerData:getInstanse()
                    pd.basicData = data.info
                    pd.producingProps = data.produces.list
                    if pd.producingProps == nil then
                        pd.producingProps = {}
                    end
                    self:refreshProduceQueue()
                end)
            end)
        end
    end)
    --加速
    
    btnRight:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            require("src/app/util/DialogUtil"):speedUp(data.remainTime,function()
                local msg = {buildId=self.data.templateId,id=data.id}
                Connect:sendMsg("DeviceFactoryAction","speedUp",msg,
                    function (v)
                        local pd = PlayerData:getInstanse()
                        pd.producingProps = v.produces.list
                        pd.basicData = v.info
                        self:getItemsCount()
                        FlyWordPrompt:prompt(string.format(StringRes.produce_complt,StringRes[gItem[data.baseId].name]))
                    end)
            end)

        end
    end)
end

function DeviceFactory:refreshProduceQueue()
    if self.cProducing and self.cProducing:isVisible() then
        local pd = PlayerData:getInstanse()
        local counter = 0
        local listview = self.cProducing:getChildByName("listview")
        local listINum= #listview:getItems()

        for k ,v in ipairs(pd.producingProps) do
            if v.remainTime > 0 then
                local lvItem = listview:getItem(counter)
                if lvItem== nil then
                    lvItem = self:addProduceQueue()
                end
                self:updateProduceQueue(lvItem,v)
                counter = counter+1
            end
        end
        for i = counter ,listINum , 1 do
            listview:removeItem(i)
        end
        --没有生产对象显示内容
        local text_info = self.cProducing:getChildByName("text_info")
        local btn_ok = self.cProducing:getChildByName("btn_ok")
        if #listview:getItems() == 0 then
            text_info:setVisible(true)
            btn_ok:setVisible(true)
        else
            text_info:setVisible(false)
            btn_ok:setVisible(false)
        end
    end

end

function DeviceFactory:getData()

    local msg = {buildId=self.data.templateId}
    --获取生产队列
    Connect:sendMsg("DeviceFactoryAction","getProduceQueue",msg,function(data)
        print("11")
        local pd = PlayerData:getInstanse()
        pd.producingProps = data.list
        self:refreshProduceQueue()
    end)
    --获取当前道具数量
    local msg2 = {}
    Connect:sendMsg("DeviceFactoryAction","getItemsNum",msg2,function(data)
        self.props = data
        self:refreshProduceNum()
    end)
end

--刷新資源需求
function DeviceFactory:refreshCrystal(item,num)
    local id = item.tagId
    local pd = PlayerData:getInstanse()
    local need = gItemcreat[id].crystal
    local own = pd.basicData.crystal
    if num == 0 then
        num =1
    end
    local require = item.tag_citem:getChildByName("require")
    local enough = item.tag_citem:getChildByName("Image_8")
    local text_own = item.tag_citem:getChildByName("own")
    require:setString(StringTemp:toNum(need*num))
    text_own:setString(StringTemp:toNum(own))
    if need*num > own then
        enough:loadTexture(ICON_FALT,ResType)
    else
        enough:loadTexture(ICON_CHECK,ResType)
    end
end

function DeviceFactory:refreshHonor(item,num)
    local id = item.tagId
    local pd = PlayerData:getInstanse()
    local need = gItemcreat[id].medal
    local own = pd.basicData.medal
    if num == 0 then
        num =1
    end
    local require = item.tag_hitem:getChildByName("require")
    local enough = item.tag_hitem:getChildByName("Image_8")
    local text_own = item.tag_hitem:getChildByName("own")
    require:setString(need*num)
    text_own:setString(own)
    if need*num > own then
        enough:loadTexture(ICON_FALT,ResType)
    else
        enough:loadTexture(ICON_CHECK,ResType)
    end
end

--资源不够生产
function DeviceFactory:refreshBtn(pItem,maxPro)
    local id = pItem.tagId
    if maxPro == 0 then
        pItem.tag_pTime:setString(StringTemp:toTime(Buildings:getNeedTime(0,gItemcreat[id].time)))
        pItem.tag_btnLess:setEnabled(false)
        pItem.tag_btnMore:setEnabled(false)
        pItem.tag_slider:setEnabled(false)
        pItem.tag_btnOk:setEnabled(false)
        showShader:buttonToGray(pItem.tag_btnOk)
        pItem.tag_btnOk:setBright(false)
    else
        pItem.tag_pTime:setString(StringTemp:toTime(Buildings:getNeedTime(0,gItemcreat[id].time)*maxPro))
        pItem.tag_btnLess:setEnabled(true)
        pItem.tag_btnMore:setEnabled(true)
        pItem.tag_slider:setEnabled(true)
        pItem.tag_slider:setPercent(0) --默认最小生产数
--        pItem.tag_slider:setPercent(100)
        pItem.tag_btnOk:setEnabled(true)
        pItem.tag_btnOk:setBright(true)
    end
end

--刷新所需资源信息
function DeviceFactory:refreshItemInfo(item)
    local tNum = self:getMaxNum(item.tagId)
    if tNum > 0 then --默认最小生产数
        tNum = 1
    end
    item.tag_tNum = tNum
    if item.tag_proNum then
        item.tag_proNum:setString(tNum)
        self:refreshCrystal(item,tNum)
        self:refreshHonor(item,tNum)
        self:refreshBtn(item,tNum)
    end
    
end

function DeviceFactory:lvListener(listview,pItem,index,type)
    print("index: "..index.."  type:"..type)
    if type == ExpandListView_Type_Open then
        pItem:getChildByName("check_detail"):setSelected(true)
        local item2 = CCUILoader:load("res/csd/public/PropsInfoItem.csb"):getChildByName("content"):clone()
        local item1 = CCUILoader:load("res/csd/public/ProduceNeed.csb"):getChildByName("content"):clone()
        local layout = ccui.Layout:create()
        layout:setContentSize(cc.size(item1:getContentSize().width, item1:getContentSize().height+item2:getContentSize().height))
        item1:setPosition(cc.p(0,0))
        layout:addChild(item1)
        item2:setPosition(cc.p(0,item1:getContentSize().height))
        layout:addChild(item2)

        local id = pItem.tagId
        local icon = item2:getChildByName("icon")
        icon:loadTexture(gItem[id].icon,ResType)
        local text_info = item2:getChildByName("text_info")
        text_info:setString(StringRes[gItem[id].desc])

        local lv = item2:getChildByName("listview")
        
        local maxPro = self:getMaxNum(id)
        local tempNum = maxPro
        if tempNum > 0 then
            tempNum = 1
        end
        
        --资源需求
        local item = CCUILoader:load("res/csd/public/ResNeedItem.csb"):getChildByName("content")
        local resContent = item1:getChildByName("listview")
        local posY = resContent:getContentSize().height
        local iH = item:getContentSize().height

        local pd = PlayerData:getInstanse()

        --水晶
        pItem.tag_citem = item:clone()
        posY = posY -iH
        pItem.tag_citem:setPosition(cc.p(0,posY))
        resContent:addChild(pItem.tag_citem)
        local icon = pItem.tag_citem:getChildByName("Image_1")
        local category = pItem.tag_citem:getChildByName("category")
        category:setString(StringRes.crystal)
        icon:loadTexture(ResIconCfg.crystal,ResType)
        self:refreshCrystal(pItem,tempNum)

        --荣誉勋章
        pItem.tag_hitem = item:clone()
        posY = posY -iH
        pItem.tag_hitem:setPosition(cc.p(0,posY))
        resContent:addChild(pItem.tag_hitem)
        local icon = pItem.tag_hitem:getChildByName("Image_1")
        local category = pItem.tag_hitem:getChildByName("category")
        category:setString(StringRes.Item_Name_42)
        icon:loadTexture(ResIconCfg.honor,ResType)
        self:refreshHonor(pItem,tempNum)

        --最大可生产数显示
        pItem.tag_proNum = item1:getChildByName("num_tank")
        pItem.tag_proNum:setString(tempNum)
        --生产时间
        pItem.tag_pTime = item1:getChildByName("text_time")
        pItem.tag_slider = item1:getChildByName("slider")
        --        pItem.tag_slider:setPercent(tempNum/maxPro*100)--默认最小生产数

        function refreshInfo(pItem)
            local tNum = pItem.tag_tNum
            pItem.tag_proNum:setString(tNum)
            pItem.tag_pTime:setString(StringTemp:toTime(Buildings:getNeedTime(0,gItemcreat[pItem.tagId].time)*tNum))
            self:refreshCrystal(pItem,tNum)
            self:refreshHonor(pItem,tNum)
        end

        --最终生产数
        pItem.tag_tNum = tempNum
        pItem.tag_slider.pItem = pItem
        pItem.tag_slider:addEventListener(function(sender,eventType)
            if eventType == ccui.SliderEventType.percentChanged then
                sender.pItem.tag_tNum = math.floor(sender:getPercent()/100*self:getMaxNum(sender.pItem.tagId))
                if sender.pItem.tag_tNum < 1 then
                    sender.pItem.tag_tNum = 1
                end
                refreshInfo(sender.pItem)
            end
        end)

        pItem.tag_btnLess = item1:getChildByName("btn_less")
        pItem.tag_btnLess.pItem = pItem
        pItem.tag_btnLess:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                e.pItem.tag_tNum = e.pItem.tag_tNum -1
                if e.pItem.tag_tNum < 1 then
                    e.pItem.tag_tNum = 1
                end
                e.pItem.tag_slider:setPercent(e.pItem.tag_tNum/self:getMaxNum(e.pItem.tagId)*100)
                refreshInfo(e.pItem)
            end
        end)

        pItem.tag_btnMore = item1:getChildByName("btn_more")
        pItem.tag_btnMore.pItem = pItem
        pItem.tag_btnMore:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                e.pItem.tag_tNum = e.pItem.tag_tNum +1
                if e.pItem.tag_tNum > self:getMaxNum(e.pItem.tagId) then
                    e.pItem.tag_tNum = self:getMaxNum(e.pItem.tagId)
                end
                e.pItem.tag_slider:setPercent(e.pItem.tag_tNum/self:getMaxNum(e.pItem.tagId)*100)
                refreshInfo(e.pItem)
            end
        end)


        --生产按钮
        pItem.tag_btnOk = item1:getChildByName("btn_ok")
        pItem.tag_btnOk.pItem = pItem
        pItem.tag_btnOk:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                local msg = {buildId=self.data.templateId,baseId=e.pItem.tagId,num=e.pItem.tag_tNum}
                Connect:sendMsg("DeviceFactoryAction","produce",msg,function(data)
                    if data.state == 1 then
                        local pd = PlayerData:getInstanse()
                        pd.basicData = data.info
                        table.insert(pd.producingProps,data.produce)
                        self:refreshProduceQueue()
                        self:setTabSelect(2)
                    elseif data.state ==2 then
                        local pd = PlayerData:getInstanse()
                        function getSpeedUpItem()
                            for k ,v in ipairs(pd.producingProps) do
                                if v.remainTime > 0 then
                                    return v
                                end
                            end
                            return nil
                        end
                        local idata = getSpeedUpItem()
                        if idata then
                            ManyDialogInfo:more_produce_queues(idata.remainTime,"queueNum",0,function()
                                local msg = {buildId=self.data.templateId,id=idata.id}
                                Connect:sendMsg("DeviceFactoryAction","speedUp",msg,
                                    function (v)
                                        local pd = PlayerData:getInstanse()
                                        pd.producingProps = v.produces.list
                                        pd.basicData = v.info
                                        self:getItemsCount()
                                        FlyWordPrompt:prompt(string.format(StringRes.produce_complt,StringRes[gItem[idata.baseId].name]))
                                    end)
                            end)
                        end
                    end
                    
                end)
            end
        end)

        self:refreshBtn(pItem,tempNum)

        listview:insertExpandContent(layout,index+1)
        pItem.tag_slider:setPercent(0)--默认最小生产数
    elseif type == ExpandListView_Type_Close then
        pItem.tag_proNum  = nil
        pItem:getChildByName("check_detail"):setSelected(false)
    end
end

--获取道具数量
function DeviceFactory:getPropCount(id)
    if self.props == nil then return 0 end
    for k,v in pairs(self.props) do
        if id == v.templateId then
            return v.count
        end
    end
    return 0
end

--刷新道具数量
function DeviceFactory:refreshProduceNum()
    if self.cProduce and self.cProduce:isVisible() then
        for k,item in pairs(self.listview:getItems()) do
            if item.tagIsMainItem then
                local info = item:getChildByName("text_info")
                info:setString(string.format(StringRes.cur_num,self:getPropCount(item.tagId)))
                self:refreshItemInfo(item)
            end
        end
    end

end

function DeviceFactory:getMaxNum(id)
    local item = gItemcreat[id]
    local pd = PlayerData:getInstanse()
    local num = math.floor(pd.basicData.crystal/item.crystal)
    num = math.min(num,math.floor(pd.basicData.medal/item.medal))
    if num >100 then
        num =100
    end
    return num
end

function DeviceFactory:initTabs(scene,data)
--    self:registerTabEvent(1,function()
--        --建造
--        if self.cBuild == nil then
--            self.cBuild = BuildView.new(scene,data)
--            self:addChild(self.cBuild)
--        end
--        self:resetContent()
--        self.cBuild:setVisible(true)
--    end)
    self:registerTabEvent(1,function()
        --生产
        if self.cProduce == nil then
            self.cProduce = CCUILoader:load("res/csd/public/TabProduce.csb")
            self:addChild(self.cProduce)
            self:initProduce()
        end
        self:resetContent()
        self.cProduce:setVisible(true)
        self:refreshProduceNum()
    end)
    self:registerTabEvent(2,function()
        --生产中
        if self.cProducing == nil then
            self.cProducing = CCUILoader:load("res/csd/public/TabProduce.csb")
            self:addChild(self.cProducing)
            self.cProducing:getChildByName("text_info"):setString(StringRes.no_produce_prop)
            self.cProducing:getChildByName("btn_ok"):addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    self:setTabSelect(1)
                end
            end)
            local pd = PlayerData:getInstanse()
        end
        self:refreshProduceQueue()
        self:resetContent()
        self.cProducing:setVisible(true)
    end)
    self:setTabSelect(1)
end

--function DeviceFactory:addProduceItem(listview,item)
--    item = item:clone()
--    listview:pushExpandItem(item)
--end

function DeviceFactory:initProduce()
    self.listview = self.cProduce:getChildByName("listview")
    self.listview = ExpandListView.new(self.listview,handler(self,self.lvListener))
    local tItem = CCUILoader:load("res/csd/public/ProduceItem.csb"):getChildByName("content")
    
    local vipLv = PlayerData:getInstanse().basicData.vipLv
    
    for i,k in ipairs(gItemcreatKeys) do
        local v = gItemcreat[k]
        if vipLv>=v.unlockvip then --VIP不足不显示
            local item = tItem:clone()
            item.tagIsMainItem = true
            item.tagId = v.id
            local icon =  item:getChildByName("icon_tank")
            Common:changePic(icon,gItem[v.id].icon)
            --        icon:loadTexture(gItem[v.id].icon,ResType)
            local title = item:getChildByName("text_title")
            title:setString(StringRes[gItem[v.id].name])
            local info = item:getChildByName("text_info")
            info:setString(string.format(StringRes.cur_num,0))
            local needTime = item:getChildByName("text_time")
            needTime:setString(StringTemp:toTime(Buildings:getNeedTime(0,v.time)))
            item:getChildByName("text_need"):setVisible(false)
            self.listview:pushExpandItem(item)
        end 
    end
end

--获取服务器道具数量
function DeviceFactory:getItemsCount()
    --获取当前道具数量
    local msg2 = {}
    Connect:sendMsg("DeviceFactoryAction","getItemsNum",msg2,function(data)
        self.props = data
        self:refreshProduceNum()
    end)
end

function DeviceFactory:resetContent()
--    if self.cBuild then self.cBuild:setVisible(false) end
    if self.cProduce then self.cProduce:setVisible(false) end
    if self.cProducing then self.cProducing:setVisible(false) end
end

return DeviceFactory