local PanelTabLayer = require("src/app/views/public/PanelTabLayer")
local Connect = require("src/app/util/Connect")
local ResBuild = class("ResBuild",function(scene,data)
    return PanelTabLayer.new(scene,{title=StringRes.res_building,tabs={StringRes.build}})
end)

function ResBuild:ctor(scene,data)
    self.expanding = false
    self.tag_data = data
    self:initTabs(data)
    
end

function ResBuild:buildCallBack(data)
    local pd = PlayerData:getInstanse()
    
    pd.basicData = data.playerInfoVO
    
    pd:changeOutSideBuild(data.outskirtsBlockVO)
    
    self:close() 
end

function ResBuild:refreshExpData(exp,tag,sData)
	local data = Build[tag]
    local con = exp:getChildByName("bg")
    --需求
    con:getChildByName("tN2"):setString(StringTemp:toNum(data["ferrum"]))
    con:getChildByName("tN3"):setString(StringTemp:toNum(data["oil"]))
    con:getChildByName("tN4"):setString(StringTemp:toNum(data["lead"]))
    --当前拥有
    local pd = PlayerData:getInstanse() 
    con:getChildByName("tO1"):setString(string.format(StringRes.LV2,pd:getBaseBuildLv(1)))
    con:getChildByName("tO2"):setString(StringTemp:toNum(pd.basicData.ferrum))
    con:getChildByName("tO3"):setString(StringTemp:toNum(pd.basicData.oil))
    con:getChildByName("tO4"):setString(StringTemp:toNum(pd.basicData.lead))
    
    local canBuild = true
    
    --检测资源是否足够
    if data["ferrum"]> pd.basicData.ferrum then
        canBuild = false
        con:getChildByName("iC2"):loadTexture(ICON_FALT,ResType)
        local btn = con:getChildByName("bM2")
--        btn:setVisible(true)
--        btn:addTouchEventListener(function(e, t)
--            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
--                print("more ferrum")
--            end
--        end)
    end
    if data["oil"]> pd.basicData.oil then
        canBuild = false
        con:getChildByName("iC3"):loadTexture(ICON_FALT,ResType)
        local btn = con:getChildByName("bM3")
--        btn:setVisible(true)
--        btn:addTouchEventListener(function(e, t)
--            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
--                print("more oil")
--                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
--                    MoreRes:show(self,item.tagId,function()
--                        self.update(0)
--                    end)
--                end
--            end
--        end)
    end
    if data["lead"]> pd.basicData.lead then
        canBuild = false
        con:getChildByName("iC4"):loadTexture(ICON_FALT,ResType)
        local btn = con:getChildByName("bM4")
--        btn:setVisible(true)
--        btn:addTouchEventListener(function(e, t)
--            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
--                print("more lead")
--            end
--        end)
    end
    
    --建造按钮
    local btnBuild = exp:getChildByName("btnBuild")
    if canBuild then
        btnBuild:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                local msg = {buildType=tag,blockId=sData.blockId}
                Connect:sendMsg("BuildAction","buildingOutskirtsBuild",msg,
                    handler(self,self.buildCallBack),false)
            end
        end)
    else
        btnBuild:setEnabled(false)
        showShader:buttonToGray(btnBuild)
        btnBuild:setBright(false)
    end
    
    
end

function ResBuild:initListView(content,data)
    local listview = ExpandListView.new(content:getChildByName("listview"),handler(self,self.lvListener))
    self.tag_listview = listview
    local item = CCUILoader:load("res/csd/public/ResBuildItem.csb"):getChildByName("content")
    local arr = string.split(data.canBuild,",")
    for k,v in pairs(arr) do
        local i = tonumber(v)
        item = item:clone()
        item:setTag(i)
        local icon = item:getChildByName("icon")
        icon:loadTexture(gBuilding[i].icon,ResType)
        local name = item:getChildByName("name")
        name:setString(StringRes[gBuilding[i].name])
        local info = item:getChildByName("info")
        local templateId = i
        info:setString(string.format(StringRes[gBuilding[templateId].dec],StringTemp:toNum(gDataResourse[1][templateId]),StringTemp:toNum(gDataResourse[1][templateId]*36)))
        local time = item:getChildByName("time")
        time:setString(StringTemp:toTime(Build[i].time))
        listview:pushExpandItem(item)
    end
end

function ResBuild:lvListener(listview,item,index,type)
    print("index: "..index.."  type:"..type)
    if type == ExpandListView_Type_Open then
        item:getChildByName("checkbox"):setSelected(true)
        local exp = CCUILoader:load("res/csd/public/ResBuildExpand.csb"):getChildByName("content"):clone()
        self:refreshExpData(exp,item:getTag(),self.tag_data) --加载数据
        listview:insertExpandContent(exp,index+1)
    elseif type == ExpandListView_Type_Close then
        item:getChildByName("checkbox"):setSelected(false)
    end
end

function ResBuild:initTabs(data)
    self:registerTabEvent(1,function()
        --建造
        local content = CCUILoader:load("res/csd/public/TabProduce.csb")
        self:addChild(content)
        self:initListView(content,data)
    end)
    self:setTabSelect(1)
end

function ResBuild:expandIndex(index)
    self.tag_listview:setCurSelectedIndex(index)
end

return ResBuild