local TankBasement = class("TankBasement",function(parent)
    return CCUILoader:load("res/csd/basement/ui_basement_main.csb")
end)

function TankBasement:show(parent)
    local layer = TankBasement.new()
    parent:addChild(layer)
end

function TankBasement:ctor()
    self:initView()

    ViewManager:OpenView(self)
end

function TankBasement:initView()
    self:getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:removeFromParent()
        end
    end)
    self.scrowview_basement = self:getChildByName("scrowview_basement")
    self:initAllTanks(false)  --初始隐藏 单位

    self:setAllTanksNum()

end

function TankBasement:setAllTanksNum()
    local pd = PlayerData:getInstanse()
    if pd.tanks then
        --坦克
        for i,v in pairs(pd.tanks) do
            if v.num > 0 then
                if v.baseId > NUM_OF_TANK_IN_BASE then
                    local item = self.scrowview_basement:getChildByName(tankId2Node[v.baseId])
                    item:setVisible(true)
                    item:loadTexture(Tank[v.baseId].pic,ResType)

                    --显示数量
                    local levelImage = item:getChildByName("Image_4")
                    if levelImage == nil then
                        levelImage = gLittleUi:getChildByName("Image_4"):clone()
                        item:addChild(levelImage)
                        local size = item:getContentSize()
                        levelImage:setPosition( cc.p(size.width*0.5,size.height+20) )
                    end
                    local text = levelImage:getChildByName("Text_level")
                    text:setString(v.num)
                    levelImage:setContentSize(cc.size(text:getContentSize().width+16,levelImage:getContentSize().height))
                    text:setPosition(cc.p(levelImage:getContentSize().width/2,levelImage:getContentSize().height/2))

                    if Tank[v.baseId] then
                        item:addTouchEventListener(function(e, t)
                            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                                require("src/app/views/prompt/TankInfoPanel"):show(self,v.baseId)
                            end
                        end)
                    end


                end

            else
                table.remove(pd.tanks,i)
            end

        end
    end
end

function TankBasement:initAllTanks(vis)
    for k,v in pairs(tankId2Node) do
        local item = self.scrowview_basement:getChildByName(v)
        item:setVisible(vis)
    end
end

return TankBasement