local PanelTabLayer = require("src/app/views/public/PanelTabLayer")

local TankFactory = class("TankFactory",function(scene,data)
    local strTemp = StringRes.produce
    if data.templateId ==11 then
        strTemp = StringRes.reform
    end
    return PanelTabLayer.new(scene,{title=string.format(StringRes[gBuilding[data.templateId].name]..StringRes.LV,data.buildLv),tabs={StringRes.build,strTemp,StringRes.producing}})
end)

function TankFactory:ctor(scene,data)
    self.cBuild = nil
    self.cProduce = nil
    self.cProducing = nil
    self.expanding = false --是否正在展开中
    self.buildingData = data
    self:initTabs(scene,data)
    self:getData()
    local pd = PlayerData:getInstanse()
    pd.producingTank["key"..self.buildingData.templateId]={}
    local function update(dt)
        if pd.producingTank["key"..self.buildingData.templateId] and self.cProducing and self.cProducing:isVisible() then
            local counter = 0
            local listview = self.cProducing:getChildByName("listview")
            local listINum= #listview:getItems()

            for i ,v in ipairs(pd.producingTank["key"..self.buildingData.templateId]) do
                if v.remainTime > 0 then
                    local lvItem = listview:getItem(counter)
                    if lvItem== nil then
                        self:refreshProduceQueue(pd.producingTank["key"..self.buildingData.templateId])
                        update(0)
                        return
                    end
                    self:refreshItem(lvItem,v)
                    counter = counter+1
                end
            end
            for i = counter ,listINum , 1 do
                listview:removeItem(i)
            end
        end
    end
    self.updateId = cc.Director:getInstance():getScheduler():scheduleScriptFunc(update, 0.8, false)

    local function onNodeEvent(tag)
        if tag == "exit" then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.updateId)
        end
    end

    self:registerScriptHandler(onNodeEvent)

end

--初始化资源需求项
function TankFactory:initResItem(parent,data,num)
    local Ferrum = 0
    local Oil = 0
    local Lead = 0
    local Titanium = 0
    if self.buildingData.templateId ==11 then
        --改造车间
        Ferrum = data.reformFerrum
        Oil = data.reformOil
        Lead = data.reformLead
        Titanium = data.reformTitanium
    else
        --坦克工厂
        Ferrum = data.needFerrum
        Oil = data.needOil
        Lead = data.needLead
        Titanium = data.needTitanium
    end
    for i=14,17,1 do
        local item = parent:getChildByTag(i)

        local icon = item:getChildByName("Image_1")
        local category = item:getChildByName("category")
        local require = item:getChildByName("require")
        local enough = item:getChildByName("Image_8")
        local own = item:getChildByName("own")
        local pd = PlayerData:getInstanse()
        local needNum = num
        if num ==0 then

            needNum =1
        end
        if i == 14 then
            icon:loadTexture(ResIconCfg.ferrum,ResType)
            category:setString(StringRes.iron_ore)
            own:setString(StringTemp:toNum(pd.basicData.ferrum))
            require:setString(StringTemp:toNum(Ferrum*needNum))
            if Ferrum*needNum > pd.basicData.ferrum then
                enough:loadTexture(ICON_FALT,ResType)
            else
                enough:loadTexture(ICON_CHECK,ResType)
            end
        elseif i ==15 then
            icon:loadTexture(ResIconCfg.oil,ResType)
            category:setString(StringRes.oil)
            own:setString(StringTemp:toNum(pd.basicData.oil))
            require:setString(StringTemp:toNum(Oil*needNum))
            if Oil*needNum > pd.basicData.oil then
                enough:loadTexture(ICON_FALT,ResType)
            else
                enough:loadTexture(ICON_CHECK,ResType)
            end
        elseif i ==16 then
            icon:loadTexture(ResIconCfg.lead,ResType)
            category:setString(StringRes.vanadium)
            own:setString(StringTemp:toNum(pd.basicData.lead))
            require:setString(StringTemp:toNum(Lead*needNum))
            if Lead*needNum > pd.basicData.lead then
                enough:loadTexture(ICON_FALT,ResType)
            else
                enough:loadTexture(ICON_CHECK,ResType)
            end
        elseif i ==17 then
            icon:loadTexture(ResIconCfg.titanium,ResType)
            category:setString(StringRes.titanium)
            own:setString(StringTemp:toNum(pd.basicData.titanium))
            require:setString(StringTemp:toNum(Titanium*needNum))
            if Titanium*needNum > pd.basicData.titanium then
                enough:loadTexture(ICON_FALT,ResType)
            else
                enough:loadTexture(ICON_CHECK,ResType)
            end
        end
    end

    local tmpCount = 17
    if Tank[data.id].needItem ~= "" and Tank[data.id].needItem ~= "0" then
        local info = self:getNeedItems(Tank[data.id])
        local index = 0
        for k,v in pairs(info.getNeedItems) do
            index = index + 1
            local item = parent:getChildByTag(index+tmpCount)
            local needInfo = gItem[tonumber(k)]
            local data ={}
            if num == 0 then
                num = 1
            end
            data.num = num * tonumber(v)
            data.icon = needInfo.icon
            data.own_num = self.ownItems[k]
            data.name = StringRes[needInfo.name]
            self:updateResItem(item,data)
        end
        tmpCount = tmpCount+info.getNeedItemsCount
    end

    if self.buildingData.templateId ==11 then
        --改造车间
        local item = parent:getChildByTag(tmpCount+1)

        local icon = item:getChildByName("Image_1")
        local category = item:getChildByName("category")
        local require = item:getChildByName("require")
        local enough = item:getChildByName("Image_8")
        local own = item:getChildByName("own")
        local pd = PlayerData:getInstanse()
        local needNum = num
        if num ==0 then
            needNum =1
        end
        local unit = Tank[Tank[data.id].reformNeed]
        icon:loadTexture(unit.icon,ResType)
        icon:setScale(0.5)
        category:setString(StringRes[unit.name])
        local own_num = pd:getUnitCountById(Tank[data.id].reformNeed)
        own:setString(own_num)
        require:setString(needNum)
        if needNum > own_num then
            enough:loadTexture(ICON_FALT,ResType)
        else
            enough:loadTexture(ICON_CHECK,ResType)
        end
    end
    
end

function TankFactory:getNeedItems(info)
    if info.needItem == "" or info.needItem == "0" then return end
    if info.getNeedItems == nil then
        local tmp = string.split(info.needItem, ",")
        info.getNeedItems = {}
        info.getNeedItemsCount = 0
        for i,v in ipairs(tmp) do
            local a = string.split(v,":")
            info.getNeedItems[a[1]] = a[2]
            info.getNeedItemsCount = info.getNeedItemsCount+1
        end
    end
    return info
end

function TankFactory:updateOwnItems(str)
    if str then
        local tmp = string.split(str, ",")
        self.ownItems = {}
        for i,v in ipairs(tmp) do
            local a = string.split(v,":")
            self.ownItems[a[1]] = tonumber(a[2])
        end
    end
end

function TankFactory:updateResItem(item,data)
    local icon = item:getChildByName("Image_1")
    local category = item:getChildByName("category")
    local require = item:getChildByName("require")
    local enough = item:getChildByName("Image_8")
    local own = item:getChildByName("own")
    local pd = PlayerData:getInstanse()
    local needNum = data.num
    icon:loadTexture(data.icon,ResType)
--    icon:setScale(0.35)
    category:setString(data.name)
    own:setString(data.own_num)
    require:setString(needNum)
    if needNum > data.own_num then
        enough:loadTexture(ICON_FALT,ResType)
    else
        enough:loadTexture(ICON_CHECK,ResType)
    end
end

--刷新资源需求项
function TankFactory:refreshResItem(parent,data,num)
    local Ferrum = 0
    local Oil = 0
    local Lead = 0
    local Titanium = 0
    if self.buildingData.templateId ==11 then
        --改造车间
        Ferrum = data.reformFerrum
        Oil = data.reformOil
        Lead = data.reformLead
        Titanium = data.reformTitanium
    else
        --坦克工厂
        Ferrum = data.needFerrum
        Oil = data.needOil
        Lead = data.needLead
        Titanium = data.needTitanium
    end
    for i=14,17,1 do
        local item = parent:getChildByTag(i)

        local require = item:getChildByName("require")
        local needNum = num
        if num ==0 then
            needNum =1
        end
        if i == 14 then
            require:setString(StringTemp:toNum(Ferrum*needNum))
        elseif i ==15 then
            require:setString(StringTemp:toNum(Oil*needNum))
        elseif i ==16 then
            require:setString(StringTemp:toNum(Lead*needNum))
        elseif i ==17 then
            require:setString(StringTemp:toNum(Titanium*needNum))
        end
    end
    local tmpCount = 17
    if data.needItem ~= "" and data.needItem ~= "0"then
        local index = 0
        for k,v in pairs(data.getNeedItems) do
            index = index + 1
            local item = parent:getChildByTag(index+tmpCount)
            local require = item:getChildByName("require")
            require:setString(num*tonumber(v))
        end
        tmpCount = tmpCount+data.getNeedItemsCount
    end
    if self.buildingData.templateId ==11 then
        --改造车间
        local item = parent:getChildByTag(tmpCount+1)
        local require = item:getChildByName("require")
        require:setString(num)
    end
end

--获取生产队列
function TankFactory:getData()
    if self.buildingData.buildLv > 0 then
        local msg = {buildId=self.buildingData.templateId}

        if self.buildingData.templateId ==11 then
            --改造车间
            Connect:sendMsg("ReformFactoryAction","getProduceQueue",msg,handler(self,self.producingCallback),false)
        else
            --坦克工厂
            Connect:sendMsg("TankFactoryAction","getProduceQueue",msg,handler(self,self.producingCallback),false)
        end
    end
end

function TankFactory:resetContent()
    if self.cBuild then self.cBuild:setVisible(false) end
    if self.cProduce then self.cProduce:setVisible(false) end
    if self.cProducing then self.cProducing:setVisible(false) end
end

function TankFactory:produceCallback(data)
    if data then
        if data.state == 1 then
            self:updateOwnItems(data.needItems) --生产或改装需要道具信息
            local pd = PlayerData:getInstanse()
            pd.basicData = data.info
            table.insert(pd.producingTank["key"..self.buildingData.templateId],data.produce)
            self:refreshProduceQueue(pd.producingTank["key"..self.buildingData.templateId])
            self:setTabSelect(3)
            --            self:addToProduceQueue(data.produce)
        elseif data.state ==2 then
            local pd = PlayerData:getInstanse()
            local list = pd.producingTank["key"..self.buildingData.templateId]
            function getSpeedUpItem()
                for i,v in ipairs(list) do
                    if v.remainTime > 0 then
                        return v
                    end
                end
                return nil
            end
            local idata = getSpeedUpItem()
            if idata then
                ManyDialogInfo:more_produce_queues(idata.remainTime,"queueNum",PlayerData:getInstanse().basicData.produceFreeGold,function()
                    local msg = {buildId=self.buildingData.templateId,id=idata.id}
                    local sAction = "TankFactoryAction"
                    local sMethod = "speedUp"
                    local tmpString = StringRes.produce_complt
                    if self.buildingData.templateId ==11 then
                        --改造车间
                        sAction = "ReformFactoryAction"
                        tmpString = StringRes.reform_complt
                    end
                    Connect:sendMsg(sAction,sMethod,msg,
                        function (v)
                            local pd = PlayerData:getInstanse()
                            pd.producingTank["key"..self.buildingData.templateId] = v.produces.list
                            self:refreshProduceQueue(pd.producingTank["key"..self.buildingData.templateId])
                            pd.basicData = v.info
                            pd.tanks = v.troops
                            FlyWordPrompt:prompt(string.format(tmpString,StringRes[Tank[idata.baseId].name]))
                        end,false)
                end)
            end
        else
            print("error code !")
        end
    else
        print("data nil")
    end

end

function TankFactory:producingCallback(data)
    self:updateOwnItems(data.needItems) --生产或改装需要道具信息
    local pd = PlayerData:getInstanse()
    pd.producingTank["key"..self.buildingData.templateId] = data.list
    self:refreshProduceQueue(pd.producingTank["key"..self.buildingData.templateId])
    
end

function TankFactory:cancel(data)
    self:updateOwnItems(data.needItems) --生产或改装需要道具信息
    local pd = PlayerData:getInstanse()
    pd.basicData = data.info
    pd.producingTank["key"..self.buildingData.templateId] = data.produces.list
    if pd.producingTank["key"..self.buildingData.templateId] == nil then
        pd.producingTank["key"..self.buildingData.templateId] = {}
    end
    self:refreshProduceQueue(pd.producingTank["key"..self.buildingData.templateId])
end

--生产队列每一项数据
function TankFactory:refreshItem(item,data)
    local name = item:getChildByName("text_title")
    name:setString(StringRes[Tank[data.baseId].name].."*"..data.num)
    local time = item:getChildByName("text_time")
    local pro = (data.totalTime - data.remainTime)/(data.totalTime-1)*100
    local progress = item:getChildByName("progress")

    local icon = item:getChildByName("icon_item")
--    icon:loadTexture(Tank[data.baseId].icon,ResType)
    Common:changePic(icon,Tank[data.baseId].icon)
    local btnRight = item:getChildByName("btn_speed")

    local Text_Coin = item:getChildByName("Text_coin")
    local spend = Common:getSpendByTime(data.remainTime)
--    item:getChildByName("Sprite_coin"):setVisible(false)
--    有免费额度
    spend = spend>PlayerData:getInstanse().basicData.produceFreeGold and spend or 0
    Text_Coin:setString(spend)
    Text_Coin:setColor(spend>PlayerData:getInstanse().basicData.gold and CommonColor.Red or CommonColor.White)
    if pro < 0 then
        progress:setPercent(0)
        time:setString(StringRes.waiting)
        showShader:buttonToGray(btnRight)
        btnRight:setBright(false)
        btnRight:setEnabled(false)
        Text_Coin:setVisible(false)
        item:getChildByName("Sprite_coin"):setVisible(false)
    else
        time:setString(StringTemp:toTime(data.remainTime))
        progress:setPercent(pro)
        btnRight:setBright(true)
        btnRight:setEnabled(true)
        Text_Coin:setVisible(true)
        item:getChildByName("Sprite_coin"):setVisible(true)
    end
    --取消
    local btnNo = item:getChildByName("btn_cancel")
    btnNo:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            require("src/app/util/DialogUtil"):cancel(function()
                local msg = {buildId=self.buildingData.templateId,id=data.id}
                if self.buildingData.templateId ==11 then
                    --改造车间
                    Connect:sendMsg("ReformFactoryAction","cancel",msg,handler(self,self.cancel),false)
                else
                    --坦克工厂
                    Connect:sendMsg("TankFactoryAction","cancel",msg,handler(self,self.cancel),false)
                end
            end)
        end
    end)
    --加速
    btnRight:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

--            require("src/app/util/DialogUtil"):speedUp(data.remainTime,function()
--                local msg = {buildId=self.buildingData.templateId,id=data.id}
--                local sAction = "TankFactoryAction"
--                local sMethod = "speedUp"
--                local tmpString = StringRes.produce_complt
--                if self.buildingData.templateId ==11 then
--                    --改造车间
--                    sAction = "ReformFactoryAction"
--                    tmpString = StringRes.reform_complt
--                end
--                Connect:sendMsg(sAction,sMethod,msg,
--                    function (v)
--                        local pd = PlayerData:getInstanse()
--                        pd.producingTank["key"..self.buildingData.templateId] = v.produces.list
--                        self:refreshProduceQueue(pd.producingTank["key"..self.buildingData.templateId])
--                        pd.basicData = v.info
--                        pd.tanks = v.troops
--                        FlyWordPrompt:prompt(string.format(tmpString,StringRes[Tank[data.baseId].name]))
--                    end,false)
--            end)
            function SpeedUp()
                local msg = {buildId=self.buildingData.templateId,id=data.id}
                local sAction = "TankFactoryAction"
                local sMethod = "speedUp"
                local tmpString = StringRes.produce_complt
                if self.buildingData.templateId ==11 then
                    --改造车间
                    sAction = "ReformFactoryAction"
                    tmpString = StringRes.reform_complt
                end
                Connect:sendMsg(sAction,sMethod,msg,
                    function (v)
                        local pd = PlayerData:getInstanse()
                        pd.producingTank["key"..self.buildingData.templateId] = v.produces.list
                        self:refreshProduceQueue(pd.producingTank["key"..self.buildingData.templateId])
                        pd.basicData = v.info
                        pd.tanks = v.troops
                        FlyWordPrompt:prompt(string.format(tmpString,StringRes[Tank[data.baseId].name]))
                    end,false)
            end
            local need = Common:getSpendByTime(data.remainTime)
            need = need>PlayerData:getInstanse().basicData.produceFreeGold and need or 0
            if need > 0 then
                require("src/app/util/DialogUtil"):speedUp(data.remainTime,SpeedUp)
            else
                SpeedUp()
            end
        end
    end)

end

function TankFactory:refreshProduceQueue(data)
    if self.cProducing and data then
        local listview = self.cProducing:getChildByName("listview")
        listview:removeAllChildren()
        local item = CCUILoader:load("res/csd/public/ProducingItem.csb"):getChildByName("content")
        for i,v in ipairs(data) do
            if v.remainTime > 0 then
                item = item:clone()
                showShader:buttonToGray(item:getChildByName("btn_speed"))
                self:refreshItem(item,data[i])
                listview:pushBackCustomItem(item)
            end
        end
        --没有生产对象显示内容
        local text_info = self.cProducing:getChildByName("text_info")
        local btn_ok = self.cProducing:getChildByName("btn_ok")
        if #listview:getItems() == 0 then
            text_info:setVisible(true)
            btn_ok:setVisible(true)
        else
            text_info:setVisible(false)
            btn_ok:setVisible(false)
        end
    end
end

function TankFactory:checkMaxProduce(tag)
    local Ferrum = 0
    local Oil = 0
    local Lead = 0
    local Titanium = 0
    local data = Tank[tag]
    if self.buildingData.templateId ==11 then
        --改造车间
        Ferrum = data.reformFerrum
        Oil = data.reformOil
        Lead = data.reformLead
        Titanium = data.reformTitanium
    else
        --坦克工厂
        Ferrum = data.needFerrum
        Oil = data.needOil
        Lead = data.needLead
        Titanium = data.needTitanium
    end
    --计算最大可生产数
    local pd = PlayerData:getInstanse()
    local maxPro = math.floor(pd.basicData.ferrum/Ferrum)
    maxPro = math.min(maxPro,math.floor(pd.basicData.oil/Oil))
    maxPro = math.min(maxPro,math.floor(pd.basicData.lead/Lead))
    maxPro = math.min(maxPro,math.floor(pd.basicData.titanium/Titanium))

    if data.needItem ~= "" and data.needItem ~= "0" then
        for k,v in pairs(data.getNeedItems) do
            maxPro = math.min(maxPro,math.floor(self.ownItems[k]/tonumber(v)))
        end
    end
    
    if self.buildingData.templateId ==11 then
        maxPro = math.min(maxPro,pd:getUnitCountById(Tank[tag].reformNeed))
    end

    if maxPro >100 then
        maxPro = 100
    end
    if self.tag_maxPro then
        maxPro = self.tag_maxPro
    end
    return maxPro
end

function TankFactory:setMaxProduceNum(num)
	self.tag_maxPro = num
end

--function TankFactory:lvListener(listview,item,index,type)
--    if type == ExpandListView_Type_Open then
--        item:getChildByName("check_detail"):setSelected(true)
--        self.listView:insertExpandContent(self:createExpandItem(item),index+1)
--    elseif type == ExpandListView_Type_Close then
--        item:getChildByName("check_detail"):setSelected(false)
--    end
--end

function TankFactory:initTabs(scene,data)
    self:registerTabEvent(1,function()
        --建造
        if self.cBuild == nil then
            self.cBuild = BuildView.new(scene,data)
            self:addChild(self.cBuild)
        end
        self:resetContent()
        self.cBuild:setVisible(true)
    end)
    self:registerTabEvent(2,function()
        if not self:canProduce() then return end
        --生产
        if self.cProduce == nil then
            self.cProduce = self:getPrePro(self.buildingData.templateId)--CCUILoader:load("res/csd/public/TabProduce.csb")
            self:addChild(self.cProduce)
            local listview = self.cProduce:getChildByName("listview")
            self:registerTabEvent("close",function()
                for i,v in ipairs(listview:getItems())do
                    if v:getTag() == -2 or v:getTag() == -1 then
                        v:removeFromParent()
                        listview:removeItem(listview:getIndex(v))
                    else
                        v:getChildByName("check_detail"):setSelected(false)
                    end
                end
            end)
            self.tag_listview = listview
            local function listViewEvent(sender, eventType)
                if eventType == ccui.ListViewEventType.ONSELECTEDITEM_END then
                    if not self.expanding then
                        local index = sender:getCurSelectedIndex()
                        print("select child index = ",index)
                        local item = sender:getItem(index)
                        --坦克工厂等级不够 不响应
                        if item:getChildByName("text_time") and not item:getChildByName("text_time"):isVisible() then return end

                        local curParentY = sender:getInnerContainer():getPositionY()
                        local curY = item:getPositionY()
                        local curYInListView = curY+curParentY --在listview中的Y坐标
                        local time  = 0.25
                        if listview.tag_isGuild then
                            time = 0
                        end
                        local total = sender:getItems()
                        local checkbox = item:getChildByName("check_detail")
                        if checkbox then
                            if checkbox:isSelected() then
                                self.expanding = true

                                --假设listview中的items有一屏 ， 没有的情况未处理
                                local item1 = sender:getItem(index+1)
                                local item2 = sender:getItem(index+2)
                                item1:setVisible(false)
                                item2:setVisible(false)
                                local contentH = item1:getContentSize().height+item2:getContentSize().height
                                if -curParentY > contentH then --移除content的时候够高度向上move
                                    local curItem = sender:getItem(index+3)
                                    if curItem then
                                        curItem:runAction(cc.Sequence:create( cc.MoveBy:create(time,cc.p(0,contentH)),cc.CallFunc:create(function()
                                            listview:removeItem(index+1)
                                            listview:removeItem(index+1)
                                            checkbox:setSelected(false)
                                            self.expanding = false
                                        end)))
                                    else
                                        listview:removeItem(index+1)
                                        listview:removeItem(index+1)
                                        checkbox:setSelected(false)
                                        self.expanding = false
                                    end
                                    
                                    for i = index +4, #total -1 , 1 do
                                        local curItem = sender:getItem(i)
                                        curItem:runAction(cc.MoveBy:create(time,cc.p(0,contentH)))
                                    end
                                else    --移除content的时候不够高度向上move
                                    local temp = curYInListView+curParentY
                                    if index < #total-2 then
                                        for i = index+3, #total-1,1 do
                                            local curItem = sender:getItem(i)
                                            curItem:runAction(cc.MoveBy:create(time,cc.p(0,-curParentY)))
                                        end

                                        item:runAction(cc.Sequence:create( cc.MoveBy:create(time,cc.p(0,-contentH-curParentY)),cc.CallFunc:create(function()
                                            listview:removeItem(index+1)
                                            listview:removeItem(index+1)
                                            checkbox:setSelected(false)
                                            self.expanding = false
                                        end)))

                                        for i = 0 , index-1 ,1 do
                                            local curItem = sender:getItem(i)
                                            curItem:runAction(cc.MoveBy:create(time,cc.p(0,-contentH-curParentY)))
                                        end
                                    end
                                end

                            else
                                self.expanding = true
                                local moveTopY = listview:getContentSize().height -item:getContentSize().height - curYInListView
                                local moveBottomY = moveTopY-listview:getContentSize().height

                                item:runAction(cc.Sequence:create( cc.MoveBy:create(time,cc.p(0,moveTopY)),cc.CallFunc:create(function()
                                    local tag = item:getTag()
                                    local item1 = CCUILoader:load("res/csd/public/TankInfoItem.csb"):getChildByName("content"):clone()
                                    local item2 = CCUILoader:load("res/csd/public/ProduceNeed.csb"):getChildByName("content"):clone()
                                    item1:setTag(-1)
                                    item2:setTag(-2)
                                    listview:insertCustomItem(item2,index+1)
                                    listview:insertCustomItem(item1,index+1)

                                    --资源content
                                    local resContent = item2:getChildByName("listview")

                                    --基础数据
                                    local icon = item1:getChildByName("Image_1")
                                    icon:loadTexture(Tank[tag].icon,ResType)
                                    --血量
                                    local textLife = item1:getChildByName("textLife")
                                    textLife:setString(Tank[tag].hp)
                                    --攻击
                                    local textAttack = item1:getChildByName("textAttack")
                                    textAttack:setString(Tank[tag].atk)
                                    --伤害类型
                                    item1:getChildByName("Image_4"):loadTexture("res/pic/common/icon/tank/btn_tank_attribute_"..(Tank[tag].type+1)..".png",ResType)
                                    item1:getChildByName("textAttackType"):setString(StringRes["attacktype_"..Tank[tag].type])

                                    local lv = item2:getChildByName("listview")
                                    --                                    local it = CCUILoader:load("res/csd/public/ResNeedItem.csb"):getChildByName("content")

                                    --坦克详细信息查看按钮
                                    local btnDetail = item1:getChildByName("btnDetail")
                                    btnDetail:addTouchEventListener(function(e, t)
                                        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                                            require("src/app/views/prompt/TankInfoPanel"):show(self,tag)
                                        end
                                    end)

                                    --资源需求
                                    local posY = resContent:getContentSize().height
                                    local item = CCUILoader:load("res/csd/public/ResNeedItem.csb"):getChildByName("content")
                                    local itemNum = 17
                                    if data.templateId ==11 then
                                        itemNum = 18
                                    end
                                    if Tank[tag].needItem ~= "" and Tank[tag].needItem ~= "0"then
                                        itemNum = itemNum + self:getNeedItems(Tank[tag]).getNeedItemsCount
                                    end
                                    for i = 14,itemNum do
                                        item = item:clone()
                                        local iH = item:getContentSize().height
                                        posY = posY -iH
                                        item:setPosition(cc.p(0,posY))
                                        item:setTag(i)
                                        resContent:addChild(item)
                                    end
                                    --                                self:refreshResItem(resContent,Tank[tag],maxPro)
                                    self:refreshProduce()


                                    sender:getInnerContainer():setPositionY(curParentY+moveTopY)
                                    self.expanding = false
                                    if listview.tag_isGuild then
                                        listview.tag_isGuild = false
                                        listview:scrollToTop(0.01,false)
                                    end
                                end)))
                                for i = index-1 , 0 , -1 do
                                    local curItem = sender:getItem(i)
                                    curItem:runAction(cc.MoveBy:create(time,cc.p(0,moveTopY)))
                                end

                                if index < #total-1 then

                                    for i=index+1 , #total-1 ,1 do
                                        local curItem = sender:getItem(i)
                                        curItem:runAction(cc.MoveBy:create(time,cc.p(0,moveBottomY)))
                                    end
                                end

                                checkbox:setSelected(true)
                            end
                        end
                    end
                end
            end

--            local function scrollViewEvent(sender, evenType)
--                if evenType == ccui.ScrollviewEventType.scrollToBottom then
--                    print("SCROLL_TO_BOTTOM")
--                elseif evenType ==  ccui.ScrollviewEventType.scrollToTop then
--                    print("SCROLL_TO_TOP")
--                end
--            end
            listview:addEventListener(listViewEvent)
        end

        self:refreshProduce()

        self:resetContent()
        self.cProduce:setVisible(true)
    end)
    self:registerTabEvent(3,function()
        if not self:canProduce() then return end
        --生产中
        if self.cProducing == nil then
            self.cProducing = CCUILoader:load("res/csd/public/TabProduce.csb")
            self:addChild(self.cProducing)
            local pd = PlayerData:getInstanse()
            if data.templateId ==11 then
                --改造车间
                self.cProducing:getChildByName("text_info"):setString(StringRes.no_reform_tank)
            else
                --坦克工厂
                self.cProducing:getChildByName("text_info"):setString(StringRes.no_produce_tank)
            end
            self.cProducing:getChildByName("btn_ok"):addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    self:setTabSelect(2)
                end
            end)
            self:refreshProduceQueue(pd.producingTank["key"..self.buildingData.templateId])
        end
        self:resetContent()
        self.cProducing:setVisible(true)
    end)
    self:setTabSelect(1)
end

function TankFactory:getMaxFactoryLv()
    local pd = PlayerData:getInstanse()
    return math.max(pd:getBaseBuildLv(2),pd:getBaseBuildLv(3))
end

function TankFactory:refreshProduce()

    local listview = self.cProduce:getChildByName("listview")


    function refItem(v)
        local curItem = listview:getChildByTag(v.id)
        if curItem then
            local text_time = curItem:getChildByName("text_time")

            local text_need = curItem:getChildByName("text_need")
            
            local checkbox = curItem:getChildByName("check_detail")
            
            local needTime = curItem:getChildByName("text_info")
            needTime:setString(string.format(StringRes.cur_num,0))
            
            local pd = PlayerData:getInstanse()
            local curLv = pd:getBaseBuildLv(self.buildingData.templateId)
            if self.buildingData.templateId ==11 then
                curLv = self:getMaxFactoryLv()
            end

            if v.unlocklevel > curLv then
                text_need:setString(string.format(StringRes.need_tankfactory,v.unlocklevel))
                text_time:setVisible(false)
                text_need:setVisible(true)
                checkbox:setVisible(false)
            else
                text_time:setVisible(true)
                text_time:setString(StringTemp:toTime(Buildings:getTankNeedTime(self.buildingData.buildLv, v.id,self.buildingData.templateId)))
                text_need:setVisible(false)
                checkbox:setVisible(true)
            end
        end

    end

    for i,v in ipairs(Tank) do
        if self.buildingData.templateId ==11 then
            --改造车间
            if v.position ~= 1 then refItem(v) end
        else
            --坦克工厂
            if v.position ~= 2 then refItem(v) end
        end

    end

--    for i,v in ipairs(Tank) do
--
--    end

    --刷新当前拥有坦克数量
    local pd = PlayerData:getInstanse()
    for i,v in ipairs(pd.tanks) do
        local curItem = listview:getChildByTag(v.baseId)
        if curItem then
            local needTime = curItem:getChildByName("text_info")
            needTime:setString(string.format(StringRes.cur_num,v.num))

        end
    end

    for i,v in ipairs(listview:getItems())do
        if v:getTag() == -2 then
            local item = listview:getItem(i-3)
            if item then
                local tag = item:getTag()
                local item2 = v
                local resContent = item2:getChildByName("listview")
                --计算最大可生产数
                local maxPro = self:checkMaxProduce(tag)

                --最大可生产数显示
                local proNum = item2:getChildByName("num_tank")
                proNum:setString(maxPro)


                --生产时间
                local pTime = item2:getChildByName("text_time")


                local slider = item2:getChildByName("slider")
                slider:setPercent(100)

                --最终生产数
                local tNum = maxPro
                slider:addEventListener(function(sender,eventType)
                    if eventType == ccui.SliderEventType.percentChanged then
                        tNum = math.floor(sender:getPercent()/100*maxPro)
                        if tNum < 1 then
                            tNum = 1
                        end
                        proNum:setString(tNum)
                        pTime:setString(StringTemp:toTime(Buildings:getTankNeedTime(self.buildingData.buildLv, tag ,self.buildingData.templateId)*tNum))
                        self:refreshResItem(resContent,Tank[tag],tNum)
                    end
                end)

                local btnLess = item2:getChildByName("btn_less")
                btnLess:addTouchEventListener(function(e, t)
                    if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                        tNum = tNum -1
                        if tNum < 1 then
                            tNum = 1
                        end
                        proNum:setString(tNum)
                        slider:setPercent(tNum/maxPro*100)
                        pTime:setString(StringTemp:toTime(Buildings:getTankNeedTime(self.buildingData.buildLv, tag ,self.buildingData.templateId)*tNum))
                        self:refreshResItem(resContent,Tank[tag],tNum)
                    end
                end)

                local btnMore = item2:getChildByName("btn_more")
                btnMore:addTouchEventListener(function(e, t)
                    if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                        tNum = tNum +1
                        if tNum > maxPro then
                            tNum = maxPro
                        end
                        proNum:setString(tNum)
                        slider:setPercent(tNum/maxPro*100)
                        pTime:setString(StringTemp:toTime(Buildings:getTankNeedTime(self.buildingData.buildLv, tag ,self.buildingData.templateId)*tNum))
                        self:refreshResItem(resContent,Tank[tag],tNum)
                    end
                end)


                --生产按钮
                local btnOk = item2:getChildByName("btn_ok")
                if self.buildingData.templateId ==11 then
                    btnOk:setTitleText(StringRes.reform)
                else
                    btnOk:setTitleText(StringRes.produce)
                end
                btnOk:addTouchEventListener(function(e, t)
                    if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                        local msg = {buildId=self.buildingData.templateId,baseId=tag,num=tNum}
                        if self.buildingData.templateId ==11 then
                            --改造车间
                            Connect:sendMsg("ReformFactoryAction","reform",msg,handler(self,self.produceCallback),true)
                        else
                            --坦克工厂
                            Connect:sendMsg("TankFactoryAction","produce",msg,handler(self,self.produceCallback),true)
                        end
                    end
                end)

                --资源不够生产
                if maxPro == 0 then
                    pTime:setString(StringTemp:toTime(Buildings:getTankNeedTime(self.buildingData.buildLv, tag ,self.buildingData.templateId)))
                    btnLess:setEnabled(false)
                    btnMore:setEnabled(false)
                    slider:setEnabled(false)
                    btnOk:setEnabled(false)
                    showShader:buttonToGray(btnOk)
                    btnOk:setBright(false)
                else
                    pTime:setString(StringTemp:toTime(Buildings:getTankNeedTime(self.buildingData.buildLv, tag ,self.buildingData.templateId)*maxPro))
                    btnLess:setEnabled(true)
                    btnMore:setEnabled(true)
                    slider:setEnabled(true)
                    btnOk:setEnabled(true)
                    btnOk:setBright(true)
                end


                self:initResItem(resContent,Tank[tag],maxPro)
            end
        end
    end

end

function TankFactory:canProduce()
    local pd = PlayerData:getInstanse()
    local curLv = pd:getBaseBuildLv(self.buildingData.templateId)
    if curLv<1 then
        PromptView:type1(StringRes.notice,
            StringRes.build_notice3
            ,StringRes.ok)
        self:setTabSelect(1)
        return false
    end
    return true
end 

function TankFactory:expandIndex(index)
    self.tag_listview.tag_isGuild = true
    self.tag_listview:setCurSelectedIndex(index)
end

local mTankFactoryPro = nil
local mReformFactoryPro = nil

function TankFactory:preload()
    mTankFactoryPro = CCUILoader:load("res/csd/public/TabProduce.csb")
    mTankFactoryPro:retain()
    TankFactory:preloadList(mTankFactoryPro)
    mReformFactoryPro = CCUILoader:load("res/csd/public/TabProduce.csb")
    mReformFactoryPro:retain()
    TankFactory:preloadList(mReformFactoryPro,11)
end

function TankFactory:getPrePro(templateId)
    if mReformFactoryPro == nil or mTankFactoryPro == nil then self:preload() end
    if templateId ==11 then
        --改造车间
        return mReformFactoryPro
    else
        --坦克工厂
        return mTankFactoryPro
    end
end

function TankFactory:preloadList(parent,templateId)
    local listview = parent:getChildByName("listview")
    function addItem(v)
        local item = preLoad:getPanel("buildtank")--tItem:clone()
        item:setTag(v.id)
        local icon_tank =  item:getChildByName("icon_tank")
        Common:changePic(icon_tank,v.icon)
        local title = item:getChildByName("text_title")
        title:setString(StringRes[v.name])
        Common:setUnitTitleColor(title,v)
        local info = item:getChildByName("text_info")
        info:setString(string.format(StringRes.cur_num,0))
        listview:pushBackCustomItem(item)
    end


    for i,v in ipairs(Tank) do
        if templateId ==11 then
            --改造车间
            if v.position == 2 or v.position == 3 then addItem(v) end
        else
            --坦克工厂
            if v.position == 1 or v.position == 3 then addItem(v) end
        end

    end
    
end

return TankFactory