

local Scheduler = cc.Director:getInstance():getScheduler()


ChatAddress = class("ChatAddress",function()
    return display.newLayer()
end)


function ChatAddress:ctor()

    self.csb = cc.uiload:load("res/csd/chat/layer_chat_address_management.csb")
    self:addChild(self.csb)
    
    
    self.bg = self.csb:getChildByName("panel_mask"):getChildByName("panel_address_manage")
    
    --关闭
    local close = self.bg:getChildByName("btn_close")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            --NodeTranslator:transZoomIn(self , function()
                self:removeFromParent()
            --end)
            
        end
    end)
    
    self.page = {
        [1] = {title = self.bg:getChildByName("tab_block_list"),list = self.bg:getChildByName("listview_block")},
        [2] = {title = self.bg:getChildByName("tab_address_book"),list = self.bg:getChildByName("listview_address_book")},
    }
    --初始化选项按钮
    for key, var in pairs(self.page) do
        var.title:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                self:setSelectedPage(key)
            end
        end)
    end
    
    
    self:setSelectedPage(1)
end


--设置显示页面
function ChatAddress:setSelectedPage(index)
	self.selectedPage = index
	
	--
    for key, var in pairs(self.page) do
        if key == self.selectedPage then
            
            Common:setButtonEnabled(var.title,false)
            var.title:setColor(CommonColor.White)
            var.list:setVisible(true)
        else
            Common:setButtonEnabled(var.title,true)
            var.title:setColor(CommonColor.Grey)
            var.list:setVisible(false)
        end
        
	end
	
    if self.selectedPage == 1 then
        --发送消息
        ChatServer:sendMsg("ChatAction","showShield",nil,function(data)
            self:freshBlock(data)
        end)
	else
        Connect:sendMsg("FriendAction","getFriendList",nil,
            function(data)
                self:freshFriend(data)
            end,false)
	end
	
	
end

--刷新好友列表
function ChatAddress:freshFriend(data)

    local list = self.page[2].list
    list:removeAllItems()
    for key, var in pairs(data.friends) do
        local item = self.bg:getChildByName("panel_player"):clone()

        --名字
        item:getChildByName("text_name"):setString(var.fname)

        --移除按钮
        item:getChildByName("btn_remove"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                PromptView:type2(StringRes.notice,
                    StringRes.chat_address6
                    ,StringRes.ok,StringRes.cancel,
                    function()
                        --发送消息
                        local msg = {fid = var.fid}
                        Connect:sendMsg("FriendAction","delFriend",msg,
                            function(data1)
                                if data1.state == 1 then
                                    list:removeChild(item,true)
                                    list:requestRefreshView()
                                    
                                    FlyWordPrompt:prompt(StringRes.chat_address7)
                                else
                                
                                end
                            end,false)
                    end)


            end
        end)


        list:pushBackCustomItem(item)
    end


    self.bg:getChildByName("text_total"):setString(data.nowCount.."/"..data.allCount)

end

--刷新屏蔽列表
function ChatAddress:freshBlock(data)
    
    if data.shieldVOs ~= nil then
        local list = self.page[1].list
        list:removeAllItems()
        for key, var in pairs(data.shieldVOs) do
            local item = self.bg:getChildByName("panel_player"):clone()

            --名字
            item:getChildByName("text_name"):setString(var.name)

            --移除按钮
            item:getChildByName("btn_remove"):addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    PromptView:type2(StringRes.notice,
                        StringRes.chat_address5
                        ,StringRes.ok,StringRes.cancel,
                        function()
                            --发送消息
                            local msg = {unshieldId = var.shieldId}
                            ChatServer:sendMsg("ChatAction","unShieldChatPlayer",msg,function(data1)
                                --self:freshBlock(data)
                                if data1.state == 1 then
                                    list:removeChild(item,true)
                                    list:requestRefreshView()


                                end
                            end)
                        end)


                end
            end)


            list:pushBackCustomItem(item)
        end
    end
    
    
	
	
    self.bg:getChildByName("text_total"):setString(data.nowCount.."/"..data.allCount)
	
end




return ChatAddress