
local View = nil
local ChatListView = require("app/views/chat/ChatListView")

local ended = ccui.TouchEventType.ended

gChatMainView = nil


local function eventListner(event,func)
    return function(e,t)
        if t == event then 
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

ChatMainView = class("ChatMainView",function(scene)
    
    if PlayerData:getInstanse():getBaseBuildLv(1) < gBuilding[4].unlock then
            return PanelTabLayer.new(scene,{title=StringRes.chat,
                tabs={StringRes.btnword_world,StringRes.Building_Name_4,StringRes.private_chat}},true)
    else
            return PanelTabLayer.new(scene,{title=StringRes.chat,
                tabs={StringRes.btnword_world,StringRes.Building_Name_4,StringRes.private_chat}},true)
    end

    
end)

function ChatMainView:ctor(parent)
    gChatMainView = self
    
    self.isOpen = false

    local layer = CCUILoader:load("csd/chat/ui_chat_main.csb")
    self:addChild(layer)
    
    self.UINextLab = layer:getChildByName("btn_world")
    self.UISendChat = layer:getChildByName("btn_chat")
    self.UISendContent = layer:getChildByName("panel_chat_bg"):getChildByName("textfield_chat")
    
    
    --屏蔽
    layer:getChildByName("btn_blocked"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local t1 = ChatAddress.new()
            self:addChild(t1)
        end
    end)
    
    --好友列表
    layer:getChildByName("panel_chat_private"):getChildByName("btn_to"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            SelectFriendView:open(parent,function(t)
                self.Labels[3]:getChildByName("panel_to_bg"):getChildByName("textfile_to"):setString(t)
            end)
        end
    end)
    
    
    
    --一项某项
    self.UIChatItem = layer:getChildByName("panel_army_group_members")
    
    self.Labels = {
        layer:getChildByName("panel_chat_world"),
        layer:getChildByName("panel_chat_army_group"),
        layer:getChildByName("panel_chat_private"),
    }
    for index,label in ipairs(self.Labels) do
        self:registerTabEvent(index,function() 
            if index == 2 then
                local pd = PlayerData:getInstanse()
                --判断是否有军团
                if pd.basicData.guildId == 0 then
                    local t = ManyDialogInfo:chatNoticeJunTuan()
                    self:addChild(t)
                    
                    self:setTabSelect(1)
                    return
                end
            end
            
            if index == 1 then
                self:setContentHeight(888)
            elseif index == 2 then
                self:setContentHeight(888)
            else
                self:setContentHeight(822)
            end
        
            self:selectLabel(index)
        end)
    end
    --
    self:setTabSelect(1)
    
    --发送按钮
    self.UISendChat:addTouchEventListener(eventListner(ended,function() 
        local name = ""
        if self.CurLabIndex == 3 then
        	name = self.Labels[3]:getChildByName("panel_to_bg"):getChildByName("textfile_to"):getString()
        end
        
        if string.len(self.UISendContent:getString()) <= 0 then
            PromptView:type1(StringRes.notice,
                StringRes.no_send_nullmsg
                ,StringRes.ok,function()


                end)
            return
        end
        
        
        ChatServer:sendchat(self.CurLabIndex,self.UISendContent:getString(),name)
        self.UISendContent:setString("")
    end))
    
    
    --初始页面操作

    local function onNodeEvent(tag)
        if tag == "enter" then
            gChatMainView = self
        elseif tag == "exit" then
            gChatMainView = nil
        end
    end
    self:registerScriptHandler(onNodeEvent)
    
    
    self:registerTabEvent("close",function() 
        self:close()
    end)
    
    self.UINextLab:addTouchEventListener(eventListner(ended,function() 
        self:nextLab()
    end))
--    ViewManager:OpenView(self)
end




--下一个标签
function ChatMainView:nextLab()
    local index = self.CurLabIndex + 1
    index = (index-1)%#self.Labels + 1
    
    self:setTabSelect(index)
end

--选择标签
function ChatMainView:selectLabel(labIndex)
    for index,label in ipairs(self.Labels) do
        label:setVisible(index == labIndex)
    end
    local textures = gChatTypeBtnIcon[labIndex]
    self.UINextLab:loadTextures(textures[1],textures[2])
    self.CurLabIndex = labIndex
    
end



--获取一个克隆item


local chanelIcon = {
    [1] = "pic/chat/btn/btn_world.png",
    [2] = {
        [1] = ResIconCfg.icon_leader,
        [2] = ResIconCfg.icon_deputy,
        [3] = ResIconCfg.icon_soldier,
    },
    [3] = "pic/chat/btn/btn_friend.png"
}

local chanelIconworld = {
    [1] = "pic/chat/btn/btn_world.png",
    [2] = "pic/chat/btn/btn_alliance.png",
    [3] = "pic/chat/btn/btn_friend.png"
}


--根据频道和职位获取图标
function ChatMainView:getIconFromChanelAndJog(chanel,job)
    if chanel == 2 then
        return chanelIcon[2][job]
    else
        return chanelIcon[chanel]
    end
end

--根据频道获取显示颜色
local channelColor = {
    [1] = CommonColor.White,
    [2] = CommonColor.Blue,
    [3] = CommonColor.Purple,
}
function ChatMainView:getColorFromChannel(channel,type)
    if type == nil then
    	type = 1
    end
    
    if type == 1 then
        return channelColor[channel]
    else
        return CommonColor.Orange
    end
    
end


--
function ChatMainView:pushWordsToList(data,list,isworld)
    if list then
        local cloneItem = self.UIChatItem:clone()
        cloneItem.data = data



        --系统公告
        if data.fromId == -200 then
            --图标
            Common:changePic(cloneItem:getChildByName("icon_soldier"),"pic/chat/icon/icon_system.png")



            --名字
            cloneItem:getChildByName("listview_name"):getChildByName("text_member"):setString(data.fromName)

            cloneItem:getChildByName("listview_name"):getChildByName("text_member"):setColor(CommonColor.Yellow)
            cloneItem:getChildByName("listview_name"):getChildByName("icon_military_rank"):setVisible(false)
            cloneItem:getChildByName("listview_name"):getChildByName("icon_vip"):setVisible(false)

            cloneItem:getChildByName("listview_name"):requestRefreshView()

            --时间
            cloneItem:getChildByName("text_time"):setString(data.time)
            cloneItem:getChildByName("text_time"):setColor(CommonColor.Yellow)
            --内容SpecialView:addRichText(node,_t,interval)--间隔
            local riText  = {
                {{str=StringTemp:specialReplace(data.content),color=CommonColor.Yellow,size=28}},
            }
            --系统发送战报专用
            local riTextRed  = {
                {{str=StringTemp:specialReplace(data.content),color=CommonColor.Orange,size=28}},
            }
            local contentWord = cloneItem:getChildByName("text_content")
            local t1 = contentWord:getContentSize()
            --系统发送的战报改变文字颜色
            if data.type == 4 then
                SpecialView:addRichText(contentWord,riTextRed,0)
            else
                SpecialView:addRichText(contentWord,riText,0)
            end
            local t2 = contentWord:getContentSize()
            print("---height1:"..t1.height.."----height2:"..t2.height)
            --高度差
            local delta = t2.height-t1.height
            local srcSize = cloneItem:getContentSize()
            cloneItem:setContentSize(cc.size(srcSize.width,srcSize.height+delta))
            local children = cloneItem:getChildren()
            for key, var in pairs(children) do
                var:setPosition(cc.p(var:getPositionX(),var:getPositionY()+delta))
            end
            --点击
            cloneItem:addTouchEventListener(eventListner(ended,function()
                if data.type == 6 then
                    local msg = {redpacketId = data.redpacketId}
                    Connect:sendMsg("ActivityRedpacketAction","getActivityRedpacket",msg,
                        function(data)
                           if data.state == 1 then
                                FlyWordPrompt:prompt(string.format(StringRes.activity_descript_21,data.dgold))
                           else
                           
                           end


                        end)
                elseif  data.type == 4 then
                    ReportInterface:chatReport(self,data.recordId,data.toId,true)
                end

            end))
        else
            --图标
            if isworld == true then
                Common:changePic(cloneItem:getChildByName("icon_soldier"),chanelIconworld[data.channel])
            else
                Common:changePic(cloneItem:getChildByName("icon_soldier"),
                    ChatMainView:getIconFromChanelAndJog(data.channel,data.job))
            end



            --名字
            if data.channel == 3 then
                local function getName(fromname,toname)
                    local pd = PlayerData:getInstanse()
                    if fromname == pd.basicData.name then
                        fromname = StringRes.me
                    end
                    if toname == pd.basicData.name then
                        toname = StringRes.me
                    end
                    return string.format(StringRes.chat_to,fromname,toname)
                end
                cloneItem:getChildByName("listview_name"):getChildByName("text_member"):setString( getName(data.fromName,data.toName))
            else
                cloneItem:getChildByName("listview_name"):getChildByName("text_member"):setString(data.fromName)
            end

            cloneItem:getChildByName("listview_name"):getChildByName("text_member"):setColor(ChatMainView:getColorFromChannel(data.channel))

            --军衔
            Common:changePic(cloneItem:getChildByName("listview_name"):getChildByName("icon_military_rank"),gMilitary_rank[data.warLv].icon)
            -- cloneItem:getChildByName("listview_name"):getChildByName("icon_military_rank"):loadTexture(
            --     gMilitary_rank[data.warLv].icon,ResType)
            --vip
            if data.vip > 0 then
                cloneItem:getChildByName("listview_name"):getChildByName("icon_vip"):loadTexture(
                    "pic/vip/icon/icon_vip_"..data.vip..".png",ResType)
                cloneItem:getChildByName("listview_name"):getChildByName("icon_vip"):setVisible(true)
            else
                cloneItem:getChildByName("listview_name"):getChildByName("icon_vip"):setVisible(false)
            end

            cloneItem:getChildByName("listview_name"):requestRefreshView()

            --时间
            cloneItem:getChildByName("text_time"):setString(data.time)
            cloneItem:getChildByName("text_time"):setColor(ChatMainView:getColorFromChannel(data.channel))
            --内容SpecialView:addRichText(node,_t,interval)--间隔
            local riText  = {
                {{str=data.content,color=ChatMainView:getColorFromChannel(data.channel,data.type),size=28}},
            }
            local contentWord = cloneItem:getChildByName("text_content")
            local t1 = contentWord:getContentSize()
            SpecialView:addRichText(contentWord,riText,0)
            local t2 = contentWord:getContentSize()
            print("---height1:"..t1.height.."----height2:"..t2.height)
            --高度差
            local delta = t2.height-t1.height
            local srcSize = cloneItem:getContentSize()
            cloneItem:setContentSize(cc.size(srcSize.width,srcSize.height+delta))
            local children = cloneItem:getChildren()
            for key, var in pairs(children) do
                var:setPosition(cc.p(var:getPositionX(),var:getPositionY()+delta))
            end

            --点击
            cloneItem:addTouchEventListener(eventListner(ended,function()
                if data.type == 1 then
                    local t = ManyDialogInfo:chatplayerInfo(data)
                    self:addChild(t)
                elseif  data.type == 3 then
                    ReportInterface:chatReport(self,data.recordId,data.fromId,false)
                elseif  data.type == 4 then
                    ReportInterface:chatReport(self,data.recordId,data.fromId,true)
                end
            end))
        end
        
        
        
        
        
        local t = list:getChildrenCount()
        if t >= 30 then
        	list:removeItem(0)
        end

        list:pushBackCustomItem(cloneItem)
        
        --local contain = list:getInnerContainer()
        --list:jumpToPercentBothDirection(cc.p(0,0))
        --list:scrollToBottom(0.1,false)

        if self.isOpen then 
            --list:jumpToPercentBothDirection(cc.p(0,10000))
            list:jumpToBottom()
        end
        
    end
end

function ChatMainView:pushWords(data)
    local list = self.Labels[data.channel]:getChildByName("listview_chat")
    self:pushWordsToList(data,list)
    
    --世界频道
    if data.channel ~= 1 then
        local list = self.Labels[1]:getChildByName("listview_chat")
        self:pushWordsToList(data,list,true)
    end
end


--私聊
function ChatMainView:priveteChat(name)

    self:open()

    self:setTabSelect(3)
    
    self.Labels[3]:getChildByName("panel_to_bg"):getChildByName("textfile_to"):setString(name)
end
--

function ChatMainView:getInstanse()
    if gChatMainView == nil then
        gChatMainView = ChatMainView.new(gWorldScene)
        
        gWorldScene:addChild(gChatMainView,501)
        gChatMainView:setVisible(false)
        
    end
    return gChatMainView
end


--打开
function ChatMainView:open()
    -- local parent = self:getParent()
    -- self:retain()
    -- parent:removeChild(self)
    -- parent:addChild(self)
    -- self:release()

    if self.isOpen == false then
        self.isOpen = true

        self:setVisible(true)
        self:setPositionY(0)

        --
        local list = self.Labels[1]:getChildByName("listview_chat")


        --NodeTranslator:deltaDo(0.1,function()
            -- body
            --list:jumpToPercentBothDirection(cc.p(0,10000))
        --end)

        --list:scrollToBottom(0.1,false)
        if self.firstOpen == nil then
            NodeTranslator:transUp(self,function()
                --list:jumpToPercentBothDirection(cc.p(0,10000))
                --list:scrollToBottom(0.5,true)
                list:jumpToBottom()
            end)
            self.firstOpen = true
        else
            --list:jumpToPercentBothDirection(cc.p(0,10000))
            list:jumpToBottom()
        end
--          ViewManager:OpenView(self, false)
    end
end

--关闭
function ChatMainView:close()
    if self.isOpen == true then
--        ViewManager:CloseView(self)
        self.isOpen = false
        NodeTranslator:transDown(self,function()
            self:setVisible(false)
        end)
    end
    
end




return ChatMainView