

local cjson = require("cjson")
local uiloader = require("framework.cc.uiloader.uiloader")
local StringRes = require("src/app/cfg/StringRes")
local J20SocketTCP = require("src/app/J20Net/j20SocketTCP")
local Scheduler = cc.Director:getInstance():getScheduler()

--sessionkey
--
--user:getStringForKey("sessionKey")
--ip port
--user:getStringForKey("chatip")
--user:getStringForKey("chatport")

ChatServer = {_socket = nil,chat = nil}

gTopLay = 500

--全拼聊天显示local newPage = self.new(parent)parent:addChild(newPage)



--外部小聊天框显示
function ChatServer:showLittle(parent)
    local chatShowTopBtn = parent:getChildByName("chatShowTopBtn")

    if chatShowTopBtn == nil then
        local chatShowView = cc.uiload:load("csd/chat/ui_chat_panel.csb")

        chatShowTopBtn = chatShowView:getChildByName("Button_Chat"):clone()
        parent:addChild(chatShowTopBtn, gTopLay)
        chatShowTopBtn:setName("chatShowTopBtn")


        chatShow = chatShowView:getChildByName("panel_chat"):clone()
        parent:addChild(chatShow)
        --设置名字
        chatShow:setName("chatShow")

        --panel_chat
        chatShow:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                ChatMainView:getInstanse():open()
            end
        end)

        local btn_chat = chatShow:getChildByName("btn_chat")
        btn_chat:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                ChatMainView:getInstanse():open()
            end
        end)

        chatShowTopBtn:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                ChatMainView:getInstanse():open()
            end
        end)

        ViewManager:registerOpenFunction("chatShowTopBtn", function(node)
            require("src/app/util/SDKPlatform")
            SDKPlatform:printLog("registerOpenFunction")
            if gChatMainView and (node == gChatMainView or ViewManager:isViewOpen(gChatMainView)) then
                self:setLittleVisible(false)
            else
                self:setLittleVisible(true)
            end
        end)
        ViewManager:registerCloseFunction("chatShowTopBtn", function(node)
            require("src/app/util/SDKPlatform")
            SDKPlatform:printLog("registerCloseFunction")
            if (gChatMainView and ViewManager:isViewOpen(gChatMainView)) or ViewManager:getViewCount() == 0 then
                self:setLittleVisible(false)
            else
                self:setLittleVisible(true)
            end
        end)

        local function onNodeEvent(tag)
            if tag == "exit" then
                ViewManager:removeOpenFunctionByName("chatShowTopBtn")
                ViewManager:removeCloseFunctionByName("chatShowTopBtn")
            end
        end
        chatShowTopBtn:registerScriptHandler(onNodeEvent)

        self:setLittleVisible(false)
    end
end

function ChatServer:setLittleVisible(_isVisible)
    if NoviceGuide:getState() and _isVisible then
        return
    end
    if gWorldScene ~= nil then
        local chatShowTopBtn = gWorldScene:getChildByName("chatShowTopBtn")
        if chatShowTopBtn ~= nil then
            chatShowTopBtn:setVisible(_isVisible)
            Common:setButtonEnabled(chatShowTopBtn, _isVisible)
        end
    end
end

--设置最近一条消息
function ChatServer:setLittleWords(data)
	if gWorldScene ~= nil then
        ChatServer:showLittle(gWorldScene)
        local chatShow = gWorldScene:getChildByName("chatShow")
        
        if data.fromId == -200 then
        	--图标
            Common:changePic(chatShow:getChildByName("icon_chat"),
                "pic/chat/icon/icon_system.png")
            --内容
            local str = data.fromName..":"..StringTemp:specialReplace(data.content)
            
            chatShow:getChildByName("text_chat"):setString(str)
            
            chatShow:getChildByName("text_chat"):setColor(CommonColor.Yellow)
        else
            --图标
            Common:changePic(chatShow:getChildByName("icon_chat"),
            ChatMainView:getIconFromChanelAndJog(data.channel,data.job))
            --内容
            local str = data.fromName..":"..data.content
            
            chatShow:getChildByName("text_chat"):setString(str)
            
            chatShow:getChildByName("text_chat"):setColor(ChatMainView:getColorFromChannel(data.channel,data.type))
            local chatShowTopBtn = gWorldScene:getChildByName("chatShowTopBtn")
	        
            if chatShowTopBtn:isVisible() then
                chatShowTopBtn:setBrightStyle(1)
                local seq = cc.Sequence:create(cc.DelayTime:create(0.1), 
                                           cc.CallFunc:create(function()
                                                chatShowTopBtn:setBrightStyle(0)
                                            end))
                chatShowTopBtn:runAction(seq)
            end
        end
	end
end





--断开连接
function ChatServer:disconect()
    if ChatServer._socket == nil then
        return
    end
    
    ChatServer._socket:forceClose()
    ChatServer._socket = nil
    Scheduler:unscheduleScriptEntry(ChatServer.hearScheduler)
    ChatServer.hearScheduler = nil
end


--与某个服务器简历链接
function ChatServer:conect(succCallback)
    if ChatServer._socket ~= nil then
    	return
    end

    local user = cc.UserDefault:getInstance()

    local ip = user:getStringForKey("chatIp")
    local port = user:getStringForKey("chatPort")
    local _socket = J20SocketTCP.new(ip, port, false)
    SDKPlatform:printLog("chat chatIp="..ip.." port="..port)
    local function sesseionClose(data)
        ChatServer._socket = nil
        SDKPlatform:printLog("------------chat sesseionClose----------")
        print("------------chat sesseionClose----------")

    end
    
    local function sesseionConnectFaild(data)
        ChatServer._socket = nil
        self:conect(succCallback)
        print("------------chat sesseionConnectFaild----------")
        SDKPlatform:printLog("------------chat sesseionConnectFaild----------")
    end
    
    local function sesseionData(data)
        print("------------chat sesseionData----------")
        SDKPlatform:printLog("------------chat sesseionData----------")
        local dt = data.data
        if dt.state == 1 then
            if succCallback ~= nil then
                succCallback(dt)
            end
        end
    end
    
    local function sesseionSucc(data)
    
        --初始化消息
        local user = cc.UserDefault:getInstance()
        local pd = PlayerData:getInstanse()
        local msg = {sessionKey = user:getStringForKey("sessionKey"),guildId = pd.basicData.guildId,name = pd.basicData.name,
            warLv = pd.basicData.warLv,vip = pd.basicData.vipLv,lv = pd.basicData.lv,guildName = pd.basicData.guildName,
            combat = pd.basicData.comat,job = pd.basicData.job,state = pd.basicData.state }
        ChatServer._socket:send( J20NetDataSend:new("ChatAction","loginInit",cjson.encode(msg),"sesseionData",tonumber(SDKPlatform:getSDKId())):convert2chars())
        
    end
    
    _socket:addEventListener(J20SocketTCP.EVENT_CONNECTED,sesseionSucc)
    _socket:addEventListener(J20SocketTCP.EVENT_CLOSE,sesseionClose)
    _socket:addEventListener(J20SocketTCP.EVENT_CLOSED,sesseionClose)
    _socket:addEventListener("sesseionData",sesseionData)
    _socket:addEventListener(J20SocketTCP.EVENT_CONNECT_FAILURE,sesseionClose)
    _socket:connect()
    ChatServer._socket = _socket
    
    ChatServer.sendCount = 1
    
    ChatServer:rigesterChar()
    ChatServer:rigesterHeart()
    
    local function hearScheduler(delta)
        ChatServer:heart()
    end
    if ChatServer.hearScheduler ~= nil then
        Scheduler:unscheduleScriptEntry(ChatServer.hearScheduler)
        ChatServer.hearScheduler = nil
    end
    
    ChatServer.hearScheduler = Scheduler:scheduleScriptFunc(hearScheduler, 60, false)
    
end

function ChatServer:rigesterHeart()
    local function getHeartData(data)
        

    end

    ChatServer.heartDataEvent = self._socket:addEventListener("heart",getHeartData)
end
--发送聊天
function ChatServer:heart()
    if ChatServer._socket ~= nil then
        ChatServer._socket:send( J20NetDataSend:new("ChatAction","heart",nil,"heart",tonumber(SDKPlatform:getSDKId())):convert2chars())
    else
        ChatServer:conect(function()
            -- body
        end)
    end
    
end


function ChatServer:rigesterChar()
    local function getChatData(data)
        local t = data.data
        print("------------chat getChatData----------")
        
        if data.code == 1 then
            --转码
            t.content = string.urldecode(t.content)
            --t.fromId = -200
        
        
            ChatMainView:getInstanse():pushWords(t)
            
            ChatServer:setLittleWords(t)
        else
            Common:showCodeInfo(data.code)
        end
        
    end

    ChatServer.getDataEvent = self._socket:addEventListener("chat",getChatData)




    local function getChatListData(data)
        
        local t = data.data
        print("------------chat getChatListData----------")
        for key, var in pairs(t.infos) do
            var.content = string.urldecode(var.content)
            ChatMainView:getInstanse():pushWords(var)
            
            ChatServer:setLittleWords(var)
        end

        
    end

    ChatServer.getListDataEvent = self._socket:addEventListener("chatInfos",getChatListData)




end


--发送聊天
function ChatServer:sendchat(chn,ctt,nm)
    

    local msg = {channel = chn,content = ctt,toName = nm ,type = 1,recordId = ""}
    ChatServer._socket:send( J20NetDataSend:new("ChatAction","sendMsg",cjson.encode(msg),"chat",tonumber(SDKPlatform:getSDKId())):convert2chars())
end
--发送战报 -1普通消息 2语音消息 3战报 4战斗录像 5系统消息
function ChatServer:sendrecord(chn,ctt,nm,type,recordId)
    --string.match()

    local msg = {channel = chn,content = ctt,toName = nm ,type = type,recordId = recordId}
    ChatServer._socket:send( J20NetDataSend:new("ChatAction","sendMsg",cjson.encode(msg),"chat",tonumber(SDKPlatform:getSDKId())):convert2chars())
end


--发送其他消息
function ChatServer:sendMsg(action,method,msg,callback)
    
    
    local cbStr = action..method..ChatServer.sendCount
    ChatServer.sendCount = ChatServer.sendCount + 1
    
    self._socket:addEventListener(cbStr,
    function(data)
        if data.code ~= 1 then
            Common:showCodeInfo(data.code)
        else
            if callback ~= nil then
                callback(data.data)
            end
        end
    end)

    ChatServer._socket:send( J20NetDataSend:new(action,method,cjson.encode(msg),cbStr,tonumber(SDKPlatform:getSDKId())):convert2chars())
end



return ChatServer