
--作战中心
local CombatCenterCfg = require("src/app/cfg/CombatCenterCfg")
local SupplyLineView = require("src/app/views/accessories/SupplyLineView")
local Scheduler = cc.Director:getInstance():getScheduler()
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local CombatCenterView = class("CombatCenterView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.Building_Name_13})
end)

function CombatCenterView:ctor(scene,data)
    self.MainPage = CCUILoader:load("csd/AccessoriesLayer.csb")
    self:addChild(self.MainPage)

    self.UIList = self.MainPage:getChildByName("ListView_list")
    self.UIItem = self.UIList:getChildByName("Panel_item")
    self.UIItem:retain()

    self:registerTabEvent("close",function()
        self:closeBack()
    end)

    self.Data = data
    self.SwithEnterFun = {
        function()
            --第一个军事演习
            local MilitaryExerciseView = require("src/app/views/combat/MilitaryExerciseView")
            MilitaryExerciseView:open(self,nil,1)
        end,
        function()
            --第二个远征军
        end,
        function()
            SupplyLineView:open(self)
        end,
        function()
            --
            Connect:sendMsg("GuildwarAction","openGuildwar",nil,
                function(data)
                    local pd = PlayerData:getInstanse()
                    --更新数据
                    local fca = require("app/views/territories_war/TerritoriesWar").new(data)
                    self:addChild(fca)

                end)

        end
    }

    self.UpdatePromptScheduler = nil

    local function onNodeEvent(tag)
        if tag == "exit" then
            print("---------------exit------UpdatePromptSch")
            self:endUpdatePrompt()
        end
    end

    self:registerScriptHandler(onNodeEvent)

    ViewManager:OpenView(self)
end

function CombatCenterView:endUpdatePrompt()
    if self.UpdatePromptScheduler then
        Scheduler:unscheduleScriptEntry(self.UpdatePromptScheduler)
    end
    self.UpdatePromptScheduler = nil
end

function CombatCenterView:startUpdatePrompt()
    local update = function()
        local pos = 0
        local pdata = PlayerData:getInstanse().basicData or {lv=13}
        local tips = PlayerData:getInstanse().getGametipsVO or {arenaTips=0,supplyTips=0,guildWarTips=0}
        local tipsTable = {tips.arenaTips,0,tips.supplyTips,tips.guildWarTips}
        for index,info in ipairs(CombatCenterCfg) do
            if info.show <= pdata.lv then
                local item = self.UIList:getItem(pos)
                local UIPrompt = item:getChildByName("Button_go"):getChildByName("icon_tip")
                UIPrompt:setVisible(tipsTable[index]>0)
                pos = pos + 1
            end
        end
    end
    print("---------------start------UpdatePromptSch")
    update()
    self.UpdatePromptScheduler = Scheduler:scheduleScriptFunc(update, 1, false)
end

--设置一项
function CombatCenterView:setItem(item,info,canEnter)
    local UIIcon = item:getChildByName("Image_icon")
    local UIName = item:getChildByName("Text_name")
    local UIDescript = item:getChildByName("Button_descript")
    local UIGo = item:getChildByName("Button_go")
    UIIcon:loadTexture(info.icon,ResType)
    UIName:setString(info.name)
    UIDescript:addTouchEventListener(eventListner(ended,function()
        local DescriptView = require("src/app/views/prompt/DescriptView")
        DescriptView:open(self,info.descript)
    end))
    SpecialView:setEnabled(UIGo,canEnter)
    UIGo:addTouchEventListener(eventListner(ended,self.SwithEnterFun[info.id]))
end

--刷新
function CombatCenterView:update()
    self.UIList:removeAllChildren()
    local pdata = PlayerData:getInstanse().basicData or {lv=13}
    for index,info in ipairs(CombatCenterCfg) do
        if info.show <= pdata.lv then
            local item = self.UIItem:clone()
            self.UIList:pushBackCustomItem(item)
            self:setItem(item,info,pdata.lv>=info.unlock)
        end
    end
end

--关闭回调
function CombatCenterView:closeBack()
    self.UIItem:release()
end

function CombatCenterView:open(scene)
    local newPage = self.new(scene,{})
    newPage:update()
    newPage:startUpdatePrompt()
    scene:addChild(newPage)
end

return CombatCenterView