
local TimeBuffer = nil
local AddTimeBuffer = nil
local Scheduler = cc.Director:getInstance():getScheduler()

local ended = ccui.TouchEventType.ended
local function eventListner(event,func)
    return function(e,t)
        if t == event then 
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

--1000/名次*10
local function getRewardCount(rank,winStreak)
    return math.floor(math.ceil(1000*10/rank)(1+winStreak/10))
end

local MilitaryChallengeView = class("MilitaryChallengeView",function(parent,node)
    return node
end)

function MilitaryChallengeView:ctor(parent,node,data)
    self.UIBattleRecord:addTouchEventListener(eventListner(ended,function()  --战斗记录
            local CombatLogView = require("src/app/views/combat/CombatLogView")
            CombatLogView:open(self,self.BattleLogList,100)
        end))
    self.UIAdd:addTouchEventListener(eventListner(ended,function()  --增加次数
            self:addCount()
        end))
    self.UIGetReward:addTouchEventListener(eventListner(ended,function()  
        self:getReward()
    end))

    --数据
    self.PlayerId = PlayerData:getInstanse().basicData.playerId
    
    self._parent = parent
end

--数据初始化
function MilitaryChallengeView:initData(data)
    self.TotalChallenge = data.fightCount + data.ticket
    self.AlreadyChallenge = data.fightCount
    self.TotalBattle = #data.records
    self.WinningStreak = data.steak --连胜
    self.PreviousRank = data.oldRank
    self.BuyCount = data.buyTimes or 0
--    self.PreviousWinStreak = 3 --前一次的连胜
--    self.CurrentRank = 221
    self.Time = data.nextReward
    self.isGetReward = PlayerData:getInstanse().getGametipsVO.haveRewardGift ~= 1
    self.BattleLogList = data.records
    self.RefreshTime = data.fightRemain
    self.ListData = data.defiers
end

--增加次数
function MilitaryChallengeView:addCount()
    if self.RefreshTime > 0 then --加速
        local costGold = math.ceil(self.RefreshTime/60)*15
        PromptView:spendGold(costGold,function() 
            Connect:sendMsg("ArenaAction","speedUp",nil,function(newMsg) 
                   if newMsg.state == 1 then
                        PlayerData:getInstanse().basicData.gold = newMsg.remainGold
                        self.RefreshTime = 0
                        self:updateAddTime(true)
                   end
            end,true)
        end)
    else --增加
        PromptView:type2(nil,string.format(StringRes.add_exercise,(50*15+(self.BuyCount)*25)), --50+（已购买次数）*25
        StringRes.ok,StringRes.cancel,
        function() 
            Connect:sendMsg("ArenaAction","buyTicket",nil,function(newMsg)
                self.BuyCount = self.BuyCount + 1
                PlayerData:getInstanse().basicData.gold = newMsg.remainGold
                self.TotalChallenge = newMsg.ticket+self.AlreadyChallenge
                self:updateMilitaryCount()
                self:updateAtck()
            end,true)
        end)
    end
end

--获取奖励
function MilitaryChallengeView:getReward()
    local MilitaryExerciseAward = require("src/app/views/activity/MilitaryExerciseAward")
    MilitaryExerciseAward:show(self)
--    local content = string.format(StringRes.exercise_reward,self.PreviousRank)
--    PromptView:type2(nil,content,StringRes.ok,StringRes.cancel,
--        function() 
--            Connect:sendMsg("ArenaAction","getReward",nil,function(newMsg) 
--                FlyWordPrompt:prompt(StringRes.get_reward..StringRes.parts_name_241..
--                    string.format(" x%d",newMsg.reward))
--                self._parent:initData()
--            end,true)
--        end)
end

--某项的设置 --基础奖励 * （1+连胜次数/10）
function MilitaryChallengeView:setRankingItem(index,info)
    local item = self.UIRankingList:getItem(index-1)
    if info == nil then
        return item:setVisible(false)
    end
    local uiRank = item:getChildByName("num_rank")
    local uiName = item:getChildByName("text_player")
    local uiLevel = item:getChildByName("num_lv")
    local uiCount = item:getChildByName("num_reward")
    local uiAtk = item:getChildByName("btn_attack")
    uiRank:setString(info.rank)
    uiName:setString(info.name)
    uiLevel:setString(info.lv)
    uiCount:setString(info.reward)
    uiAtk:setVisible(info.id ~= self.PlayerId)
    uiAtk:addTouchEventListener(eventListner(ended,function()   --攻击
        local _msg = {tarId=info.id}
        Connect:sendMsg("ArenaAction","fight",_msg,function(data) 
            --最好重新获取数据刷新一次或者服务器重新给界面的数据
            require("src/app/views/battle/BattleUtils"):showResult(self._parent,data,function() self._parent:initData() end)
        end,true)
    end))
end

--刷新
function MilitaryChallengeView:refreshAdd()
    local visible = self.RefreshTime > 0
    self.UIAddTime:setVisible(visible)
    if visible then
        self.UIAddTime:setString(StringTemp:toTime(self.RefreshTime))  
    else
        self:updateAddTime(false)
        self:updateAtck()
    end
    self.UIAdd:setTitleText(visible and StringRes.speedup or StringRes.add)
    return not visible
end

--初始化列表
function MilitaryChallengeView:initList(count)
    self.ListCount = count
    self.UIRankingList:removeAllChildren()
    for i = 1 , count do
        local item = self.uiRankingItem:clone()
        local atkBtn = item:getChildByName("btn_attack")
        showShader:buttonToGray(atkBtn)
        self.UIRankingList:pushBackCustomItem(item)
    end
end

--刷新列表
function MilitaryChallengeView:updateList(list)
    for i = 1 , self.ListCount do
        self:setRankingItem(i,list[i])
    end
end

--刷新攻击按钮
function MilitaryChallengeView:updateAtck()
    local canAtk = (self.TotalChallenge > self.AlreadyChallenge) and (self.RefreshTime<=0)
    for i = 1 , self.ListCount do
        local item = self.UIRankingList:getItem(i-1)
        local atkBtn = item:getChildByName("btn_attack")
        SpecialView:setEnabled(atkBtn,canAtk)
    end
end

--刷新名次
function MilitaryChallengeView:updateRank()
    self.UILastRank:setString(self.PreviousRank)
    SpecialView:setEnabled(self.UIGetReward,not self.isGetReward)
end

--刷新增加次数的间隔时间
function MilitaryChallengeView:updateAddTime(reStart)
    if AddTimeBuffer then
        Scheduler:unscheduleScriptEntry(AddTimeBuffer)
        AddTimeBuffer = nil   
    end
    if reStart then
        if not self:refreshAdd() then
            AddTimeBuffer = Scheduler:scheduleScriptFunc(function(dt) 
                self.RefreshTime = self.RefreshTime - dt
                if self:refreshAdd() then
                    self:updateAddTime()
                end  
            end,1,false)
        end
    end
end

--刷新时间
function MilitaryChallengeView:updateTime(reStart,time)
    if TimeBuffer then
        Scheduler:unscheduleScriptEntry(TimeBuffer)
        TimeBuffer = nil        
    end
    if reStart then
        local timeStr = (time<=0) and "" or StringTemp:toTime(time)
        self.UITime:setString(timeStr)
        if time>0 then
            TimeBuffer = Scheduler:scheduleScriptFunc(function(dt) 
                time = time - dt
                self.UITime:setString(StringTemp:toTime(time))
                if time <= 0 then
                    self:updateTime()
                    self._parent:initData()
                end
            end,1,false)
        end
    end
end

--演习次数
function MilitaryChallengeView:updateMilitaryCount()
    self.UIMilitaryCount:setString(self.AlreadyChallenge)
    self.UIRemainCount:setString(self.TotalChallenge-self.AlreadyChallenge)
end

--获取未读邮件数量
---------------------------
--@param
--@return number
function MilitaryChallengeView:getUnReadLogCount()
    local count = 0
	for _,info in ipairs(self.BattleLogList) do
	   if info.state == 0 then
	       count = count + 1
	   end
	end
	return count
end

--次数
function MilitaryChallengeView:updateCount()
    self.UIWinCount:setString(self.WinningStreak)
    local totalBattleCount = self:getUnReadLogCount()
    local visible = (totalBattleCount > 0)
    self.UIBattleCountBack:setVisible(visible)
    if visible then
        self.UIBattleCount:setString(totalBattleCount)
    end
end

--刷新
function MilitaryChallengeView:update(data)
    self:initData(data)
    self:updateCount()
    self:updateMilitaryCount()
    self:updateList(data.defiers)
    self:updateAtck()
    self:updateRank()
    self:updateTime(true,self.Time)
    self:updateAddTime(true)
end

function MilitaryChallengeView:destroy()
    self:updateTime()
    self:updateAddTime()
end

function MilitaryChallengeView:uiLoad(node)
    self.UIRankingList = node:getChildByName("listview_rank")
    self.uiRankingItem = node:getChildByName("panel_player")

    local ui_head = node:getChildByName("panel_header")
    self.UIWinCount = ui_head:getChildByName("num_win")
    self.UIBattleRecord = ui_head:getChildByName("btn_record")
    self.UIBattleCountBack = self.UIBattleRecord:getChildByName("icon_bg")
    self.UIBattleCount = self.UIBattleCountBack:getChildByName("num_record")

    local ui_foot = node:getChildByName("panel_footer")
    self.UIMilitaryCount = ui_foot:getChildByName("num_round")
    self.UIRemainCount = ui_foot:getChildByName("num_left")
    self.UILastRank = ui_foot:getChildByName("num_last")
    self.UITime = ui_foot:getChildByName("text_time")
    self.UIAdd = ui_foot:getChildByName("btn_more")
    self.UIGetReward = ui_foot:getChildByName("btn_get_reward")
    self.UIAddTime = ui_foot:getChildByName("text_add_time")

    self:initList(8)
end

return MilitaryChallengeView