
--军事演习
local View = nil
local TroopsSetView = require("src/app/views/troops/TroopsSetView")
local militaryRankingView = require("src/app/views/combat/MilitaryRankingView")
local MilitaryChallengeView = require("src/app/views/combat/MilitaryChallengeView")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then 
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local MilitaryExerciseView = class("MilitaryExerciseView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.military_exercise,tabs=
        {StringRes.dekaron,StringRes.troops_set,StringRes.ranking_list}})
end)

function MilitaryExerciseView:ctor(parent,data)
    self:addChild(self.MainPage)
    
    self.Labels = {
        MilitaryChallengeView.new(self,self.UIChallenge),
        TroopsSetView.new(self),
        militaryRankingView.new(self,self.UIRanking),
    }
    self:addChild(self.Labels[2]) --把部队添进来
    
    for index,label in ipairs(self.Labels) do
        self:registerTabEvent(index,function() 
            self:selectLabel(index)
        end)
    end
    
    self:registerTabEvent("close",function() 
        self:closeCallback()
    end)
    
    --选中标签的处理
    local RankInit = false
    self.SwitchFun = {
        function()
            
        end,
        function()
        
        end,
        function()
            if not RankInit then
                self.Labels[3]:initData()
                RankInit = true
            end
        end
    }
    
    self:initData(true)
    View = self
    self:registerConnectFun()
end

--界面关闭回调
function MilitaryExerciseView:closeCallback()
    for index,label in ipairs(self.Labels) do
        label:destroy()
    end
    View = nil
end

--初始化数据
function MilitaryExerciseView:initData(need)
    Connect:sendMsg("ArenaAction","openArena",nil,function(newMsg) 
        self.Labels[1]:update(newMsg)
        local troops = {type=5,defTroops=newMsg.defTroops}
        self.Labels[2]:initData(troops,need)
        self.Labels[2]:promptLimitCount()
    end,need or false)
end

-- --服务器主动推送
function MilitaryExerciseView:registerConnectFun()
    Connect:register("RefreshMilitaryExercise",function(data)
        if View then
            View.Labels[1]:update(data)
        end
    end)
end

--选择哪个标签
function MilitaryExerciseView:selectLabel(index)
    for i,label in ipairs(self.Labels) do
        self.Labels[i]:setVisible(i==index)
    end
    self.SwitchFun[index]()
end

function MilitaryExerciseView:open(parent,data,label)
    local newPage = self.new(parent)
    parent:addChild(newPage)
    newPage:setTabSelect(label or 1)
end

RegisterCleanUp:register(function() 
    if View then
        View:_destroy()
    end
    View = nil
end)

function MilitaryExerciseView:uiLoad()
    self.MainPage = CCUILoader:load("csd/operation_center/ui_military_exercise.csb")
    self.MainPage:retain()

    self.UIChallenge = self.MainPage:getChildByName("panel_chanellenge")
    self.UIRanking = self.MainPage:getChildByName("panel_rank")

    MilitaryChallengeView:uiLoad(self.UIChallenge)
    militaryRankingView:uiLoad(self.UIRanking)
end

return MilitaryExerciseView