
local Scheduler = cc.Director:getInstance():getScheduler()
local ended = ccui.TouchEventType.ended
local function eventListner(event,func)
    return function(e,t)
        if t == event then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local function setSelect(btn,select)
    SpecialView:setEnabled(btn,not select,true)
    btn:setTitleColor(select and CommonColor.White or CommonColor.White)
end

local MilitaryRankingView = class("MilitaryRankingView",function(parent,node)
    return node
end)

function MilitaryRankingView:ctor(parent,node)
    --注册事件
    for index,info in ipairs(self.Labels) do
        info.label:addTouchEventListener(eventListner(ended,function()  --战斗记录
            self:selectLab(index)
        end))
    end

    local function onNodeEvent(tag)
        if tag == "exit" then
            self:endTime()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    self.TimeSch = nil

--    self:initData()
    --默认选中第一个
    self:selectLab(1)
end

function MilitaryRankingView:initData()
    Connect:sendMsg("ArenaAction","getRank",nil,function(newMsg)
        self:Top100List(newMsg.rank)
        self:lastLuckList(newMsg.lastLuckRank or {})
        self:curLuckList(newMsg.thisLuckRank or {})
        self:setTime(newMsg.nextCashUp)
    end,true)
end

--选择某一项
function MilitaryRankingView:selectLab(labIndex)
    for index,info in ipairs(self.Labels) do
        local select = index == labIndex
        setSelect(info.label,select)
        info.layer:setVisible(select)
    end
end

---------前100名
--设置一项
function MilitaryRankingView:setTop100Info(item,info)
    local ui_rank = item:getChildByName("num_rank")
    local ui_name = item:getChildByName("text_player")
    local ui_level = item:getChildByName("num_lv")
    local ui_fight = item:getChildByName("num_attack")
    ui_rank:setString(info.rownum)
    ui_name:setString(info.name)
    ui_level:setString(info.lv)
    ui_fight:setString(StringTemp:toNum(info.num))
end

function MilitaryRankingView:initTop100List()
    for index = 1, 100 do
        local item = self.UITop100Item:clone()
        self.UITop100List:pushBackCustomItem(item)
    end
end

--前100名
function MilitaryRankingView:Top100List(list)
    for index = 1 , 100 do
        local info = list[index]
        local item = self.UITop100List:getItem(index-1)--self.UITop100Item:clone()
        local visible = false
        if info then
            visible = true
            self:setTop100Info(item,info)
        end
        item:setVisible(visible)
    end
--    for index,info in ipairs(list) do
--        if index > 100 then
--            return
--        end
--        self:setTop100Info(item,info)
--        self.UITop100List:pushBackCustomItem(item)
--    end
end

---------幸运排行
--设置一项
function MilitaryRankingView:setLuckInfo(item,info,now)
    local ui_rank = item:getChildByName("num_rank")
    local ui_reward = item:getChildByName("num_reward")
    ui_rank:setString(info.rank)
    ui_reward:setString(info.gold)
    if not now then
        local ui_name = item:getChildByName("text_player")
        ui_name:setString(info.name)
    end
end

function MilitaryRankingView:initLastLuckList()
    for index = 1 , 10  do
        local item = self.UILastLuckItem:clone()
        self.UILastLuckList:pushBackCustomItem(item)
    end
end

--上期幸运排行
function MilitaryRankingView:lastLuckList(list)
    for index = 1 , 10 do
        local info = list[index]
        local item = self.UILastLuckList:getItem(index-1)--self.UILastLuckItem:clone()
        local visible = false
        if info then
            visible = true
            self:setLuckInfo(item,info)
        end
        item:setVisible(visible)
    end

--    for index,info in ipairs(list) do
--        if index > 10 then
--           return
--        end
--        self:setLuckInfo(item,info)
----        self.UILastLuckList:pushBackCustomItem(item)
--    end
end

function MilitaryRankingView:initCurLuckList()
    for i = 1 , 10 do
        local item = self.UICurLuckItem:clone()
        self.UICurLuckList:pushBackCustomItem(item)
    end
end

--这期期幸运排行
function MilitaryRankingView:curLuckList(list)
    for index = 1 , 10 do
        local info = list[index]
        local item = self.UICurLuckList:getItem(index-1)
        local visible = false
        if info then
            visible = true
            self:setLuckInfo(item,info,true)
        end
        item:setVisible(visible)
    end
--    for index,info in ipairs(list) do
--        if index > 10 then
--            return
--        end
--        local item = self.UICurLuckList:getItem(index-1)--self.UICurLuckItem:clone()
--        self:setLuckInfo(item,info,true)
----        self.UICurLuckList:pushBackCustomItem(item)
--    end
end

function MilitaryRankingView:setTime(time)
    self.UITime:setString(StringTemp:toTime(time))
    self.TimeSch = Scheduler:scheduleScriptFunc(function(dt)
        time = time - dt
        if time <= 0 then
            self:endTime()
            self:initData()
        end
        self.UITime:setString(StringTemp:toTime(time))
    end,1,false)
end

function MilitaryRankingView:endTime()
    if self.TimeSch then
        Scheduler:unscheduleScriptEntry(self.TimeSch)
        self.TimeSch = nil
    end
end

function MilitaryRankingView:destroy()

end

function MilitaryRankingView:uiLoad(node)
    local ui_top1000 = node:getChildByName("panel_top_100")
    local ui_lucky = node:getChildByName("panel_lucky")

    --前100名
    self.UITop100List = ui_top1000:getChildByName("listview_top_100")
    self.UITop100Item = ui_top1000:getChildByName("panel_player")

    --幸运排名
    self.UILastLuckList = ui_lucky:getChildByName("listview_last")
    self.UICurLuckList = ui_lucky:getChildByName("listview_this")
    self.UILastLuckItem = ui_lucky:getChildByName("panel_last_player")
    self.UICurLuckItem = ui_lucky:getChildByName("panel_this_player")
    self.UITime = ui_lucky:getChildByName("panel_header"):getChildByName("panel_bg"):getChildByName("text_timing")

    self.Labels = {
        {
            label = node:getChildByName("tab_top_100"),
            layer = ui_top1000
        },
        {
            label = node:getChildByName("tab_lucky"),
            layer = ui_lucky
        }
    }

    self:initTop100List()
    self:initLastLuckList()
    self:initCurLuckList()
end

return MilitaryRankingView