
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then 
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local FriendMainView = class("FriendMainView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.friend,
        tabs={}},true)
end)

function FriendMainView:ctor(parent,msg)
    self.MainPage = CCUILoader:load("csd/friend/ui_friend_main.csb")
    self:addChild(self.MainPage)
    
    local layer = self.MainPage:getChildByName("panel_friend_outline")
    self.UIFriendList = layer:getChildByName("listview_friend")
    self.UIFriendItem = layer:getChildByName("btn_player_bg")
    
    self.UIResearch = layer:getChildByName("btn_search")
    
    self.UIResearch:addTouchEventListener(eventListner(ended,function() 
        PromptView:research(function(name) --搜索
            local _msg = {name = name} 
            Connect:sendMsg("FriendAction","searchFriend",_msg,function(newMsg) 
                newMsg = (newMsg.fid~=0) and newMsg or nil
                self:updateList({newMsg},false)
            end,true)
        end)
    end))
    
    self:getFriends()
end

--设置角色信息
function FriendMainView:setRoleItem(item,info,isFriend)
    local ui_military = item:getChildByName("icon_army") --军衔
    local ui_name = item:getChildByName("text_player_name")
    local ui_level = item:getChildByName("text_rank")
    local ui_fight = item:getChildByName("text_attack")
    ui_military:loadTexture(gMilitary_rank[info.warLv].icon,ResType)
    ui_name:setString(info.fname)
    ui_level:setString(string.format(StringRes.LV2,info.lv))
    ui_fight:setString(StringTemp:toNum(info.combat))
    item:addTouchEventListener(eventListner(ended,function()
        local RoleInfoView = require("src/app/views/friend/RoleInfoView")
        RoleInfoView:open(self,info,isFriend)
    end))
end

--刷新列表
function FriendMainView:updateList(list,isFriend)
    local newT = {}
    if isFriend then
        for _,info in ipairs(list) do
            newT[info.fid] = info
        end
    end
    self.UIFriendList:removeAllChildren()
    for index,info in ipairs(list) do
        local item = self.UIFriendItem:clone()
        self:setRoleItem(item,info,newT[info.fid] and true or false)
        self.UIFriendList:pushBackCustomItem(item)
    end
end

--拉去好友数据
function FriendMainView:getFriends()
    Connect:sendMsg("FriendAction","getFriendList",nil,function(newMsg) 
        self:updateList(newMsg.friends,true)
    end,true)
end

function FriendMainView:open(parent,data)
    local newPage = self.new(parent)
    parent:addChild(newPage)
end

return FriendMainView