--
-- Created by IntelliJ IDEA.
-- User: HS18
-- Date: 2015/12/4
-- Time: 15:06
-- To change this template use File | Settings | File Templates.
--
local ended = ccui.TouchEventType.ended

local AssistantStepView = class("AssistantStepView",function()
    return display.newLayer()
end)

function AssistantStepView:ctor(parent,data)
    self.touchState = false
    self.listenner = cc.EventListenerTouchOneByOne:create()
    self.listenner:setSwallowTouches(true)
    self.listenner:registerScriptHandler(function(touch, event)
        self.touchState = true
        return self:touchBegin(touch,event)
    end,cc.Handler.EVENT_TOUCH_BEGAN )
    self.listenner:registerScriptHandler(function(touch, event)
        self.touchState = false
        self.listenner:setSwallowTouches(true)
    end,cc.Handler.EVENT_TOUCH_MOVED)
    self.listenner:registerScriptHandler(function(touch, event)
        self:touchBegin(touch,event)
        if self.touchState then
            AssistantGuide:complete("0","0")
            self.touchState = false
        else
            AssistantGuide:endStep()
            AssistantGuide:over()
        end
    end,cc.Handler.EVENT_TOUCH_ENDED)
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(self.listenner,self)

    self.UILight = self:createLightArea()

    self.MainPage = CCUILoader:load("csd/common/layer_arrow_animation.csb")
    local uiParent = (data.type==1 and self or self.UILight)
    uiParent:addChild(self.MainPage)

    self.UIParent = self.MainPage:getChildByName("panel_mask")

    self.UIWomenParent = self.UIParent:getChildByName("panel_title_bg")
    self.UIWomenText = self.UIWomenParent:getChildByName("text_desc")
    self.UIWTextEffect = self.UIWomenParent:getChildByName("Panel_ok")

    self.UIArrow = self.UIParent:getChildByName("icon_arrow")
    self.UISelect = self.UIParent:getChildByName("icon_target")

    self.UIAutoTextPa = self.UIParent:getChildByName("panel_desc")
    self.UIAutoText = self.UIAutoTextPa:getChildByName("taext_desc")

--    SpecialView:registerEvent(self.UIParent,ended,function(touch,event)
--        AssistantGuide:endStep()
--        AssistantGuide:over()
--    end)

    self:setLightData(data)
    self:setShowText(data)
    self:setArrowData(data)
end

--创建高亮区域
function AssistantStepView:createLightArea()
    local light  = cc.ClippingNode:create()
    light:setAlphaThreshold(1)
    light:setInverted(true)
    self:addChild(light)
    return light
end

--高亮区域的设置
function AssistantStepView:setLightData(data)
    if data.type ~= 1 then
        local stencil = cc.Sprite:create("pic/tank_factory/tank/icon_tank_1.png")
        local ssize = stencil:getContentSize()
        stencil:setAnchorPoint(0.5,0.5)
        stencil:setPosition(data.pos)
        local xscale , yscale = data.size.width/ssize.width,data.size.height/ssize.height
        stencil:setScale(xscale,yscale)
        self.UILight:setStencil(stencil)

        self.UISelect:retain()
        self.UISelect:removeFromParent()
        self:addChild(self.UISelect)
        self.UISelect:release()
    end
    self.UISelect:setPosition(data.pos)
    self.UISelect:setContentSize(data.size)
end

--文字的设置
function AssistantStepView:setShowText(data)
    local showWomen = (data.type == 1)
    self.UIWomenParent:setVisible(showWomen)
    self.UIAutoTextPa:setVisible(not showWomen)
    if showWomen then
        self.UIWomenText:setString(data.desc)
        self.UIWomenParent:setPosition(data.textpos)
        if data.pos.x < 0 then
            local UIAnimationNode  = Animation:createAnimation("art/UI/effect/arrows;arrow;arrow","arrow")
            self.UIWTextEffect:addChild(UIAnimationNode)
        end
    else
        self.UIAutoTextPa:setPosition(data.textpos)
        self.UIAutoText:setString(data.desc)
        local size = self.UIAutoText:getContentSize()
        local newSize = cc.size(size.width+20,size.height+10)
        self.UIAutoTextPa:setContentSize(newSize)
        self.UIAutoText:setPosition(newSize.width/2,newSize.height/2)
    end
end

--箭头数据
function AssistantStepView:setArrowData(data)
    self.UIArrow:setPosition(data.arrowpos)
    local angle = math.pi*data.arrowangle/180
    self.UIArrow:setRotation(data.arrowangle)
    NodeTranslator:transUpAndDown(self.UIArrow,angle)
end

function AssistantStepView:touchBegin(touch,event)
    local point = cc.Director:getInstance():convertToGL(touch:getLocationInView()) --获得当前触摸的坐标
    local rect = self.UISelect:getBoundingBox()
    if cc.rectContainsPoint(rect,point) then --如果触点处于rect中
        self.touchState = true
        self.listenner:setSwallowTouches(false)
    else
        self.touchState = false
        self.listenner:setSwallowTouches(true)
    end
    return true
end

function AssistantStepView:touchEnded(touch,event)

end

function AssistantStepView:close()
    self:removeFromParent()
end

function AssistantStepView:open(parent,data)
    local newPage = self.new(parent,data)
    parent:addChild(newPage,20)
    return newPage
end

return AssistantStepView
