--
-- Created by IntelliJ IDEA.
-- User: HS18
-- Date: 2015/12/3
-- Time: 14:10
-- To change this template use File | Settings | File Templates.
--

local ended = ccui.TouchEventType.ended
local assistantdata = require("src/app/data/assistantdata")
local assistantstepdata = require("src/app/data/assistantstepdata")

local AssistantView = class("AssistantView",function()
    return display.newLayer()
end)

function AssistantView:ctor(parent,title,type,data)
    self.MainPage = CCUILoader:load("csd/common/layer_assistant.csb")
    self:addChild(self.MainPage)

    self.UIParent = self.MainPage:getChildByName("panel_mask")
    self.UIBack = self.UIParent:getChildByName("panel_bg")
    self.UITitle = self.UIBack:getChildByName("text_title")
    self.UIDescript = self.UIBack:getChildByName("text_desc")
    self.UIWomen = self.UIBack:getChildByName("icon_women")

    local uiListBack = self.UIBack:getChildByName("panel_desc")
    self.UIList = uiListBack:getChildByName("ListView_1")
    self.UIItem = uiListBack:getChildByName("btn_01")

    self.type = type
    self._parent = parent

    self.switchFuncs = {
        function(info)
            self:close(function()
                AssistantView:open(parent,info.name,2,info.events)
            end)
        end,
        function(info)
            self:close(function() --进入第一步
                AssistantGuide:handle(info)
            end)
        end
    }

    SpecialView:registerEvent(self.UIWomen,ended,function() self:returnBack() end)
    SpecialView:registerEvent(self.UIParent,ended,function() self:close() end)

    self:showList(data)
    self.UITitle:setString(title or StringRes.little_assistant)
    NodeTranslator:transZoomOut(self.UIBack,function()end)
end

--跳转
function AssistantView:getJumpFun(info)
    return function()
        self.switchFuncs[self.type](info)
    end
end

function AssistantView:showList(data)
    self.UIList:setColumnCount(3)
    local list = data or assistantdata
    for _,info in ipairs(list) do
        local uiItem = self.UIItem:clone()
        local title = data and assistantstepdata[info].name or info.name
        uiItem:setTitleText(title)
        SpecialView:registerEvent(uiItem,ended,self:getJumpFun(info))
        self.UIList:pushBackCustomItem(uiItem)
    end
end

function AssistantView:returnBack()
    local parent = self._parent
    local callback = (self.type == 2) and function()
        AssistantView:open(parent,nil,1,nil)
    end or nil
    self:close(callback)
end

function AssistantView:close(callback)
    NodeTranslator:transZoomIn(self.UIBack , function()
        self:removeFromParent()
        if callback then
            callback()
        end
    end)
end

--@type 1 小助手 2 二级菜单
function AssistantView:open(parent,title,type,data)
    local newPage = self.new(parent,title,type,data)
    parent:addChild(newPage)
end

return AssistantView