
---如果新手引导结束已经取了名字999  99:代表名字未取，但是已经结束引导了
local FirstId = 1
local EndId = 32
local UserKey = "NoviceGuidePos"
NoviceGuide = {curId=nil,state=nil,funcs={}}
--local UserDefault = cc.UserDefault:getInstance()
local NoviceGuideCfg = require("app/cfg/NoviceGuideCfg")
local SpecailGuideCfg = require("app/cfg/SpecailGuideCfg")
local NoviceGuideView = require("app/views/guide/NoviceGuideView")
local CreateRoleView = require("src/app/views/login/CreateRoleView")
local FilmAnimationView = require("app/views/login/FilmAnimationView")

--因为new场景的时候拿到的当前场景不对，所以传进来
function NoviceGuide:start(scene)
    if self:canStart() then
        self.curId = self:getSavePos()
        self.state = true
        if FirstId == self.curId then
            FilmAnimationView:open(scene)
        else
            self:handle()
        end
    else
        self:handleAfterGuideEnd()
    end
end

function NoviceGuide:next(id)
    self.curId = id
    self:handle()
end

function NoviceGuide:getState()
    return self.state
end

function NoviceGuide:handleAfterGuideEnd()
    if not self.state then
        for k,v in ipairs(self.funcs) do
            v()
        end
    end
end

function NoviceGuide:isEndId()
    return self.curId == EndId
end

function NoviceGuide:registerGuideEnd(func)
    table.insert(self.funcs,func)
end

--需要判断结束不？
function NoviceGuide:endGuide()
    self.state = false
    NoviceGuideView:destroy()
    self:handleAfterGuideEnd()
    if self.curId ~= 99 then
        NoviceGuide:savePos(99)
    end
end

--处理一小步
function NoviceGuide:handle()
    if self.curId == 99 then --引导结束打开角色取名界面
        return self:endGuide()
    end
    local guideData = NoviceGuideCfg[self.curId]
    if guideData  then
        self:handleSpecial()
        NodeTranslator:showInterceptView(0.5,function()
            NoviceGuideView:open(guideData.ui)
        end,gWorldScene)
    end
end

function NoviceGuide:handleSpecial(isEnd,instance,callback)
    local func = SpecailGuideCfg[self.curId]
    if func then
        func(isEnd,instance,callback)
    else
        if callback then
            callback()
        end
    end
end

--获取保存的位置
function NoviceGuide:getSavePos()
    local pos = PlayerData:getInstanse().basicData.guide
    if pos ~= 0 then
        return pos
    end
    return FirstId
end

function NoviceGuide:savePos(pos)
    if pos and pos ~= 0 then
--        UserDefault:setIntegerForKey(UserKey,pos)
        PlayerData:getInstanse().basicData.guide = pos
        Connect:sendMsg("PlayerAction","recordGuide",{guide=pos},function(newMsg)
        end,false)
    end
end

--完成一小步
function NoviceGuide:complete(actionName,msgName,instance)
    if not self.state then
        return AssistantGuide:complete(actionName,msgName)
    end
    local guideData = NoviceGuideCfg[self.curId]
    if not guideData then
        return
    end
    local endCondition = guideData.endCondition
    if endCondition.actionName==actionName and endCondition.msgname==msgName then
        self:savePos(guideData.savePos)
        self:handleSpecial(true,instance,function()
            self:next(guideData.next)
        end)
        NoviceGuideView:close()
    end
end

--判断是否能开始  （已经改过名字不能执行）
function NoviceGuide:canStart()
    return (PlayerData:getInstanse().basicData.guide < 999) and not self.state
end

--重新开始进行下一个流程的引导
function NoviceGuide:reStartNext()
    if self.state then
        self:next(11)
    end
end

--片头战斗场景结束
function NoviceGuide:firstBattleEnd(isJump)
    local curScene = display.getRunningScene():getChildByName("Battle")
    local function func()
        curScene:popScene()
        NodeTranslator:showInterceptView(0.01,function()
            self:handle()
        end,gWorldScene)
    end
    if isJump then
        func()
    else
        local FirstBattleView = require("app/views/guide/FirstBattleView")
        FirstBattleView:open(curScene,StringRes.first_battle_end,func)
    end
end

function NoviceGuide:clearState()
    self.state = nil
end

RegisterCleanUp:register(function()
    NoviceGuide:clearState()
end)

NoviceGuide:registerGuideEnd(function()
    --SDKPlatform:initRole()
end)

return NoviceGuide