
--新手引导
local View = nil
local ClipIcon = "pic/common/panel/outline_arrange_orange.png"

local ended = ccui.TouchEventType.ended
local function eventListner(event,func)
    return function(e,t)
        if t == event then 
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local NoviceGuideView = class("NoviceGuideView",function() 
    return display.newLayer()
end)

function NoviceGuideView:ctor()
    self.touchState = false
    self.listenner = cc.EventListenerTouchOneByOne:create()
    self.listenner:setSwallowTouches(true)
    self.listenner:registerScriptHandler(function(touch, event)
            self.touchState = true
            return self:touchBegin(touch,event)
        end,cc.Handler.EVENT_TOUCH_BEGAN )
    self.listenner:registerScriptHandler(function(touch, event)
            self.touchState = false
            self.listenner:setSwallowTouches(true)
        end,cc.Handler.EVENT_TOUCH_MOVED)
    self.listenner:registerScriptHandler(function(touch, event)
        self:touchBegin(touch,event)
        if self.touchState then
                NoviceGuide:complete("0","0")
                self.touchState = false
            end
        end,cc.Handler.EVENT_TOUCH_ENDED)
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(self.listenner,self)  

    self.MainPage = CCUILoader:load("csd/startup/layer_newplayer_guide.csb")
    self:addChild(self.MainPage)
    
    self.UIHead = self.MainPage:getChildByName("panel_guide_bg")
    self.UIRoleHead = self.UIHead:getChildByName("panel_girl")
    self.UIDescript = self.UIHead:getChildByName("text_desc")
    self.UIClose = self.UIHead:getChildByName("btn_close")
    self.UIArrow = self.MainPage:getChildByName("icon_arrow")
    
    self.UIClose:addTouchEventListener(eventListner(ended,function()
        PromptView:type2(nil,StringRes.jump_guide,StringRes.ok,StringRes.cancel,function() 
            NoviceGuide:endGuide()
            -- self:destroy()
            -- app:enterScene("WorldScene")
            -- NodeTranslator:deltaDo(0.01,function()
            --     NoviceGuide:endGuide()
            -- end)
        end)
    end))

    local function onNodeEvent(tag)
        if tag == "exit" then
            if View then
                View:release()
                View = nil
            end
        end
    end
    self:registerScriptHandler(onNodeEvent)

    --裁剪掉的部分
    self.UIClipSprite = self.MainPage:getChildByName("icon_outline")
end

function NoviceGuideView:setData(data)
    self:setArrow(data.arrow)
    self:setClipRect(data.frame)
    self:setHeadInfo(data.head)
end

--head={visible=true,pos={x=320,y=800},str="1"}
function NoviceGuideView:setHeadInfo(head)
    self.UIRoleHead:setVisible(head.visible)
    self.UIClose:setVisible(head.visible)
    self.UIDescript:setString(StringRes[head.str])
    self.UIHead:setPosition(head.pos)
end

--frame={pos={x=320,y=100},size={width=200,height=100}}
function NoviceGuideView:setClipRect(frame)
    self.UIClipSprite:setPosition(frame.pos)
    self.UIClipSprite:setContentSize(frame.size)
    NodeTranslator:transAlpha(self.UIClipSprite)
end

--淡入淡出
function NoviceGuideView:fadeAnimation(isOpen,callback)
    NodeTranslator:transAlphaOnce(self.UIRoleHead,isOpen,callback)
end

--arrow={pos={x=320,y=200},angle=0}
function NoviceGuideView:setArrow(arrow)
    self.UIArrow:setPosition(arrow.pos)
    local angle = math.pi*arrow.angle/180
    self.UIArrow:setRotation(arrow.angle)
    NodeTranslator:transUpAndDown(self.UIArrow,angle)
end

function NoviceGuideView:stopAllAnimation()
    self.UIArrow:stopAllActions()
    self.UIClipSprite:stopAllActions()
end

function NoviceGuideView:touchBegin(touch,event)
    local point = cc.Director:getInstance():convertToGL(touch:getLocationInView()) --获得当前触摸的坐标  
    local rect = self.UIClipSprite:getBoundingBox()
    if cc.rectContainsPoint(rect,point) then --如果触点处于rect中  
        self.touchState = true
        self.listenner:setSwallowTouches(NoviceGuide:isEndId())
    else
        self.touchState = false
        self.listenner:setSwallowTouches(true)
    end
    return true
end

function NoviceGuideView:touchEnded(touch,event)

end

function NoviceGuideView:close()
    if View then
        View:fadeAnimation(false,function()
        end)
        View:setVisible(false)
        View:stopAllAnimation()
    end
end

function NoviceGuideView:destroy()
    if View then
        View:removeFromParent()
    end
end

function NoviceGuideView:open(data)
    if View == nil then
        View = self.new()
        View:retain()
        local curScene = display.getRunningScene()
        curScene:addChild(View,300)
    end
    View:setVisible(true)
    View:setData(data)
    View:fadeAnimation(true)
end

return NoviceGuideView