
local ended = ccui.TouchEventType.ended

local RoleNameCfg = require("src/app/cfg/RoleNameCfg")
local CommonColor = require("src/app/cfg/CommonColorCfg")

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local CreateRoleView = class("CreateRoleView", function()
    return display.newLayer()
end)

function CreateRoleView:ctor(scene,callback)
    self.MainPage = CCUILoader:load("res/csd/CreateRoleLayer.csb")
    self:addChild(self.MainPage)
    
    self.InputText = self.MainPage:getChildByName("TextField_name")
    self.CreateBtn = self.MainPage:getChildByName("Button_create")
    self.SelectImage1 = self.MainPage:getChildByName("Image_nan") -- 左边图片
    self.SelectImage2 = self.MainPage:getChildByName("Image_nv")
    self.UIRandomName = self.MainPage:getChildByName("Text_4_Copy")
    
    self.CreateBtn:addTouchEventListener(eventListner(ended,function() 
        self:createRole(scene)
    end))
    self.UIRandomName:addTouchEventListener(eventListner(ended,function() 
        self:randomName(self.SelectType)
    end))
    self.InputText:addTouchEventListener(eventListner(ccui.TouchEventType.began,function() 
        self.InputText:setString("")
    end))
    
    for i=1,2 do
        self["SelectImage"..i]:addTouchEventListener(eventListner(ended,function() 
            self:selectType(i)
        end))
    end
    
    
    self.CallBack = callback
    self.SelectType = nil
end

--1 男，2 女
function CreateRoleView:randomName(type)
    local name = RoleNameCfg(type)
    self.InputText:setString(name)
end

--1 男，2 女
function CreateRoleView:selectType(type)
    for i=1,2 do
        local UIImage = self["SelectImage"..i]
        UIImage:setScale((i==type) and 1 or 0.7)
        UIImage:setColor((i==type) and CommonColor.White or CommonColor.Lightgrey)
    end
    self.SelectType = type
end

--点击创建角色的按钮
function CreateRoleView:createRole(scene)
    local name,type = self.InputText:getString(),self.SelectType
    if StringUtil.haveSpecialCode(name) then
        return PromptView:type1(nil,StringRes.error_input01,StringRes.ok)
    end
    if StringUtil.getLength(name) > 16 then
        local c = PromptView:type1(nil,StringRes.name_length_limit,StringRes.ok)
        return c:setTextColor(CommonColor.Red)
    end
    if name ~= "" then
        self.CallBack(name,type,self)
    end
end

function CreateRoleView:open(scene,callback)
    local newpage = self.new(scene,callback)
    scene:addChild(newpage)
    newpage:selectType(1)
    newpage:randomName(1)
end

return CreateRoleView