

local FirstBattleCfg = require("app/cfg/FirstBattleCfg")
local FirstBattleView = require("app/views/guide/FirstBattleView")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local FilmAnimationView = class("FilmAnimationView",function() 
    return display.newLayer()
end)

function FilmAnimationView:ctor(parent,callback)
    local fileName = "csd/startup/ui_openscene_main.csb"
    self.MainPage = CCUILoader:load(fileName)
    self:addChild(self.MainPage)
    
    self.Action = cc.CSLoader:createTimeline(fileName)
    self.Action:setLastFrameCallFunc(function() 
        self:close()
        local cjson = require("cjson")
        local scene = require("app/scenes/BattleScene").new(cjson.decode(FirstBattleCfg))
        scene:pushScene()
        FirstBattleView:open(scene,StringRes.first_battle_start,function() 
            scene:playUnitsAction()
        end)
    end)
    self.MainPage:runAction(self.Action)
    self.Action:gotoFrameAndPlay(0,false)
end

function FilmAnimationView:open(parent)
    local newPage = self.new(parent)
    parent:addChild(newPage)
end

function FilmAnimationView:close()
    self:removeFromParent()
end

return FilmAnimationView