 
local ended = ccui.TouchEventType.ended
local UserDefault = cc.UserDefault:getInstance()

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local LoginView = class("LoginView", function()
    return display.newLayer()
end)

function LoginView:ctor(scene,autoLogin)
    self.MainPage = CCUILoader:load("res/csd/LoginLayer.csb")
    self:addChild(self.MainPage)
    self.UIClose = self.MainPage:getChildByName("Button_close")
    self.UILogin = self.MainPage:getChildByName("Button_login")
    self.UIRegister = self.MainPage:getChildByName("Button_register")
    self.UIUser = self.MainPage:getChildByName("TextField_user")
    self.UIPassworld = self.MainPage:getChildByName("TextField_passworld")

    --事件
    self.UIClose:addTouchEventListener(eventListner(ended,function()
        self:close(scene)
    end))
    self.UILogin:addTouchEventListener(eventListner(ended,function()
        self:Login()
    end))
    self.UIRegister:addTouchEventListener(eventListner(ended,function()
        local RegisterView = require("src/app/views/login/RegisterView")
        RegisterView:open(scene)
    end))

    if UserDefault:getStringForKey("type")=="1" then
        self.UIUser:setString(UserDefault:getStringForKey("account"))
        self.UIPassworld:setString(UserDefault:getStringForKey("password"))
        if autoLogin then
            self:Login()
        end
    end
end

function LoginView:Login()
    local name,password = nil,nil
    local function onRequestSucc(response)
        --print(response.port)
        if response.status and response.code == 0 then
            --保存服务器返回的信息
            UserDefault:setStringForKey("account",name)
            UserDefault:setStringForKey("password",password)
            for k,v in pairs(response.data) do
                UserDefault:setStringForKey(k,v)
                SDKPlatform:setData(k,v)
            end
            UserDefault:flush()
            local Player = require("src/app/unit/Player")
            Player.initSocket()
        elseif response.code == 1006 then
            PromptView:type1(nil,StringRes.login_error,StringRes.ok)
        elseif response.code == 1005 then
            PromptView:type1(nil,StringRes.paran_error,StringRes.ok)
        elseif response.code == 1002 then
            PromptView:type1(nil,StringRes.a_or_p_error,StringRes.ok)
        end
    end
    if SDKPlatform:isSelfProgram() then
        name = self.UIUser:getString()
        password = self.UIPassworld:getString()
        if StringUtil.haveChanese(name) or StringUtil.haveChanese(password) then
            return PromptView:type1(nil,StringRes.can_not_chanese,StringRes.ok)
        end
        if name ~= "" and password ~= "" then
            local _msg = {action="login.do",
                m = "login",
                account = name,
                password = password,
                channelId = SDKPlatform:getSDKId()
            }
            Connect:requestHttp(_msg,onRequestSucc)
            
        end
    else
        name,password = SDKPlatform:get("id"),SDKPlatform:get("token")
        local _msg = {action="login.do",
            m = "sdkLogin",
            sid = name,
            sign = password,
            param1 = SDKPlatform:get("productCode"),
            param2 = SDKPlatform:get("channelId"),
            param3 = SDKPlatform:get("channelUserId"),
            channelId = SDKPlatform:getSDKId()
        }
        Connect:requestHttp(_msg,onRequestSucc)
    end
end

function LoginView:close(scene)
    scene:removeChild(self)
end

function LoginView:open(scene,autoLogin)
    if SDKPlatform:isSelfProgram() then
        local newPage = self.new(scene,autoLogin)
        scene:addChild(newPage)
    else
        SDKPlatform:login(function(succ)
            if succ then
                LoginView:Login()
            else
                app:enterScene("LoginScene")
            end
        end)
    end
end

return LoginView