
local ended = ccui.TouchEventType.ended
local UserDefault = cc.UserDefault:getInstance()

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local RegisterView = class("RegisterView", function()
    return display.newLayer()
end)

function RegisterView:ctor(scene,isBind)
    self.MainPage = CCUILoader:load("csd/RegisterLayer.csb")
    self:addChild(self.MainPage)
    
    self.UIClose = self.MainPage:getChildByName("Button_close")
    self.UIName = self.MainPage:getChildByName("TextField_name")
    self.UIPassword = self.MainPage:getChildByName("TextField_passworld")
    self.UIRegister = self.MainPage:getChildByName("Button_register")
    self.UIPassworldCopy = self.MainPage:getChildByName("TextField_passworld_Copy")
    self.UISelectPro = self.MainPage:getChildByName("checkbox_desc")
    self.UIUserProtocol = self.MainPage:getChildByName("btn_agreement")
    self.UISelectPro:setSelected(true)
    
    self.Parent = scene
    
    self.UIClose:addTouchEventListener(eventListner(ended,function() 
        self:close(scene)
    end))
    self.UIRegister:addTouchEventListener(eventListner(ended,function() 
        self:register()
    end))
    self.UIUserProtocol:addTouchEventListener(eventListner(ended,function() 
        local protocolStr = require("app/cfg/UserProtocolCfg")
        local TextPromptView = require("app/views/public/TextPromptView")
        TextPromptView:open(self,2,protocolStr)
    end))
    
    self.isBind = isBind
end

--点击注册
function RegisterView:register()
    local state = self.UISelectPro:isSelected()
    if not state then
        return PromptView:type2(nil,StringRes.select_protocal,StringRes.ok,StringRes.cancel)
    end
    local name = self.UIName:getString()
    local password = self.UIPassword:getString()
    local passwordCopy = self.UIPassworldCopy:getString()
    if name~="" and password~="" and passwordCopy==password then
        local msg = {action="login.do",m=self.isBind and "bindAccount" or "register",
            account=name,password=password,channelId = SDKPlatform:getSDKId() }
        if self.isBind then
            msg.oldAccount =UserDefault:getStringForKey("account")
            msg.oldPassword = UserDefault:getStringForKey("password")
        end
        Connect:requestHttp(msg,function(response) 
            if response.status and response.code == 0 then
                --保存服务器返回的信息
                UserDefault:setStringForKey("account",name) 
                UserDefault:setStringForKey("password",password)
                UserDefault:setStringForKey("type",response.data.type)
                UserDefault:flush()
                local isBind = self.isBind
                self:close()
                if isBind then
                    FlyWordPrompt:prompt(StringRes.account_bind_succ)
                else
                    UserDefault:setStringForKey("sessionKey",response.data.sessionKey)
                    local Player = require("src/app/unit/Player")
                    Player.initSocket()
                end
            elseif response.code == 1001 then
                PromptView:type1(nil,StringRes.account_exist,StringRes.ok)
            else
                PromptView:type1(nil,StringRes.register_error,StringRes.ok)
            end
        end)
    end
end

function RegisterView:close()
    local scene = self.Parent
    if self.isBind and (self.canUpdate and self:canUpdate()) then
        scene:update()
    end
    scene:removeChild(self)
end

function RegisterView:open(scene,isBind)
    local newPage = self.new(scene,isBind)
    scene:addChild(newPage)
end

return RegisterView