
--幸运抽奖
local LotteryView = require("src/app/views/lottery/LotteryView")

local LotteryMainView = class("LotteryMainView",function(parent) 
    return PanelTabLayer.new(scene,{title=StringRes.lottery,
        tabs={StringRes.normal_lottery,StringRes.senior_lottery}})
end)

function LotteryMainView:ctor(parent,data)
    self.LukyMoneyInfo = {baseId=0,count=0}
    self.Labels = {
        LotteryView.new(self,1,self.LukyMoneyInfo),
        LotteryView.new(self,2,self.LukyMoneyInfo)
    }
    for index,label in ipairs(self.Labels) do
        self:addChild(label)
        self:registerTabEvent(index,function() 
            self:selectLabel(index)
        end)
    end
    self:registerTabEvent("close",function()
        self:closeCallBack()
    end)

    ViewManager:OpenView(self)
end

function LotteryMainView:initData(callback)
    Connect:sendMsg("DrawAction","getCostItemNum",nil,function(newMsg) 
        self.LukyMoneyInfo.baseId = newMsg.baseId
        self.LukyMoneyInfo.count = newMsg.count
        if callback then
            callback()
        end
    end,true)
end

--选择
function LotteryMainView:selectLabel(labIndex)
    for index,label in ipairs(self.Labels) do
        local visible = index==labIndex
        label:setVisible(visible)
    end
    self.Labels[labIndex]:update()
    if labIndex == 2 then
        self._Tabs[labIndex]:getTitleRenderer():stopAllActions()
    elseif not self:isLocked(2) then
        NodeTranslator:transColorLoop(self._Tabs[2]:getTitleRenderer())
    end
end

--关闭回调
function LotteryMainView:closeCallBack()
    
end

--打开
function LotteryMainView:open(parent,data,label)
    local newPage = self.new(parent,data)
    parent:addChild(newPage)
    newPage:initData(function() 
        newPage:setTabSelect(label or 1)
    end)
end

return LotteryMainView