
--邮件列表
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local function setEnabled(button,enable)
    button:setBright(enable)
    button:setEnabled(enable)
    button:setTouchEnabled(enable)
--    button:setTitleColor(enable and CommonColor.Green2 or CommonColor.White)
end

local MailListView = class("MailListView",function()
    return display.newLayer()
end)

--type(1,2,3分别代表着三个标签)
function MailListView:ctor(parent,type,list,maxcount)
    local layer = CCUILoader:load("csd/email/ui_email_main.csb")
    self:addChild(layer)

    self.UIMailList = layer:getChildByName("panel_bg"):getChildByName("listview_maillist")
    self.UIMailItem1 = layer:getChildByName("panel_mail_noicon") --不是军团
    self.UIMailItem2 = layer:getChildByName("panel_mail_withicon") --军团
    self.UINextMail = layer:getChildByName("panel_next_mail")
    self.UINextMail:removeFromParent()
    self.UINextMail:retain()

    self.UIUnreadCount = layer:getChildByName("text_unread_mess")
    self.UIAllCount = layer:getChildByName("text_total_mess")
    self.UIWrite = layer:getChildByName("btn_write")
    self.UIClear = layer:getChildByName("btn_del")
    showShader:buttonToGray(self.UIClear)

    self.UINextMail:addTouchEventListener(eventListner(ended,function()
        self:updateList()
    end))
    self.UIWrite:addTouchEventListener(eventListner(ended,function()
        --打开写邮件的界面
        local MailWriteView = require("src/app/views/mail/MailWriteView")
        MailWriteView:open(self,{})
    end))
    self.UIClear:addTouchEventListener(eventListner(ended,function()
        local strTable = {StringRes.email,StringRes.report,StringRes.already_send_mail}
        local content = string.format(StringRes.clear_all_mail,strTable[type])
        PromptView:type2(nil,content,StringRes.ok,StringRes.cancel,function()
            self:removeAll()
        end)

    end))
    --清除列表
    self.UIMailList:removeAllChildren()

    self._parent = parent
    self.type = type
    self.MaxMailCount = maxcount
    self.OnceShowCount = 10 --一次显示的数量
end

--每项邮件的设置
function MailListView:setListItem(item,mail)
    local isRead = mail.state ~= 0
    local uiState = item:getChildByName("icon_state")
    local uiUnread = item:getChildByName("panel_unread")
    local uiFrom = item:getChildByName("text_title") --ui弄反了
    local uiTitle = item:getChildByName("text_from")
    local uiTime = item:getChildByName("text_time")
    local uiResult = item:getChildByName("text_result")
    if uiResult then
       local isWin = (mail.result==1)
       if mail.result == 0 or not mail.result then
            uiResult:setString("")
       else
            uiResult:setString(isWin and StringRes.win or StringRes.fail)
            uiResult:setColor(isWin and CommonColor.Green or CommonColor.Red)
       end
    end
    uiState:loadTexture(gReadStateCfg[isRead],ResType)
    uiUnread:setVisible(not isRead)
    uiTitle:setString(mail.title)
    local str = (self.type==3) and StringRes.mail_to..mail.receiver or
        StringRes.mail_from..mail.sender
    uiFrom:setString(str)
    uiTime:setString(StringTemp:toMailTime(mail.sendTime))
    item:addTouchEventListener(eventListner(ended,function()
        self:openMail(item,mail)
    end))
end

--刷新10项
function MailListView:updateList()
    local needShow = true
    local start = self.ShowIndex + 1
    local ended = start + self.OnceShowCount -1
    if ended >= self.MailCount then
        needShow = false
        ended = self.MailCount
    end
    self.UIMailList:removeChild(self.UINextMail)
    for i = start , ended do
        local mail = self.ListData[i]
        local item = (mail.type==3 and self.UIMailItem2 or self.UIMailItem1):clone()
        self:setListItem(item,mail)
        self.UIMailList:pushBackCustomItem(item)
    end
    self.ShowIndex = ended
    if needShow then
        self.UIMailList:pushBackCustomItem(self.UINextMail)
    end
end

--初始化
function MailListView:init(list)
    self.UnReadCount = 0
    self.MailCount = #list --所有数量
    self.ListData = list
    self.ShowIndex = 0 --显示到了什么位置

    --做超出处理(怕服务器没做处理)
    if self.MailCount > self.MaxMailCount then
        for i=self.MailCount,self.MaxMailCount+1,-1 do
            table.remove(self.ListData,i)
        end
    end

    self:reset()

    NodeTranslator:deltaDo(0.01,function()
        self.UIMailList:scrollToTop(0.01,false)
    end)

     --jumpToTop()--scrollToTop(0.1,false)
end

function MailListView:canFindId(id)
    for k,v in ipairs(self.ListData) do
        if v.id == id then
            return true
        end
    end
    return false
end

--重新设置列表
function MailListView:reSetList(list)
    for i = #list , 1 , -1 do
        local id = list[i].id
        if not self:canFindId(id) then
            self:recvMail(list[i])
        end
    end
end

--重置
function MailListView:reset()
    self.ShowIndex = 0
    self.MailCount = #self.ListData
    self.UnReadCount = self:calculateRead()
    self.UIMailList:removeAllChildren()
    self:updateList()
    self:updateOther()
end

--刷新列表--{isRead}
function MailListView:calculateRead()
    local unReadCount = 0
    for _,mail in ipairs(self.ListData) do
        if mail.state == 0 then --未读
            unReadCount = unReadCount + 1
        end
    end
    return unReadCount
end

--刷新列表之外的
function MailListView:updateOther()
    setEnabled(self.UIClear,self.MailCount>0)
    self.UIAllCount:setString(string.format(StringRes.have_mail,self.MailCount))
    local visible = false
    if self.type ~= 3 then
        visible = true
        self._parent:setWarningCount(self.type,self.UnReadCount)
        self.UIUnreadCount:setString(string.format(StringRes.unread_mail,self.UnReadCount))
    end
    self.UIUnreadCount:setVisible(visible)
end

--打开一封邮件
function MailListView:openMail(item,mail)
    local isRead = mail.state ~= 0
    if not isRead then
        self.UnReadCount = self.UnReadCount - 1
        mail.state = 1
        self:updateOther()
        item:getChildByName("icon_state"):loadTexture(gReadStateCfg[true],ResType)
        item:getChildByName("panel_unread"):setVisible(false)
    end
    --同时向服务器发送邮件阅读的消息
    local MailReadView = require("src/app/views/mail/MailReadView")
    -- 跳转到阅读界面
    MailReadView:open(self,self.type,mail)
end

--删除一封邮件
function MailListView:remove(mail)
    local pos = nil
    for index,data in ipairs(self.ListData) do
        if data.id==mail.id then
            pos = index
            break
        end
    end
    self:removeInfo(pos)
    self:updateOther()
    local _msg = {id=mail.id,type=self.type}
    Connect:sendMsg("MailAction","delMail",_msg,function()

    end,true)
end

--删除所有邮件
function MailListView:removeAll()
    for i=#self.ListData,1,-1 do
        table.remove(self.ListData,i)
    end
    self:reset()
    local _msg = {type=self.type}
    Connect:sendMsg("MailAction","clear",_msg,function()
            local strTable = {StringRes.email,StringRes.report,StringRes.already_send_mail}
            local content = strTable[self.type]..StringRes.already_clear
            FlyWordPrompt:prompt(content)
        end,true)
end

--移除一项（如果多项移除请从最大的开始移除）
function MailListView:removeInfo(pos)
    local info = self.ListData[pos]
    local isRead = info.state ~= 0
    if not isRead then
        self.UnReadCount = self.UnReadCount - 1
    end
    self.MailCount = self.MailCount - 1
    table.remove(self.ListData,pos)
    if pos <= self.ShowIndex then
        self.ShowIndex = self.ShowIndex - 1
        self.UIMailList:removeItem(pos-1)
    end
end

--添加一项
function MailListView:addInfo(mail,pos)
    table.insert(self.ListData,pos,mail)
    self.MailCount = #self.ListData
    self.ShowIndex = self.ShowIndex + 1
    if mail.state == 0 then
        self.UnReadCount = self.UnReadCount + 1
    end
    local item = (mail.type==3 and self.UIMailItem2 or self.UIMailItem1):clone()
    self:setListItem(item,mail)
    self.UIMailList:insertCustomItem(item,pos-1)
end

--收到邮件
function MailListView:recvMail(mail)
    --删除
    local preCount = self.UnReadCount
    local count = #self.ListData
    if count > self.MaxMailCount - 1 then
        for i=count,self.MaxMailCount-1,-1 do
            self:removeInfo(i)
        end
    end
    --- 添加
    self:addInfo(mail,1)
    self:updateOther()
    return self.UnReadCount-preCount
end

--界面移除
function MailListView:destroy()
    self.UINextMail:release()
end

return MailListView