
local View = nil
local MailListView = require("src/app/views/mail/MailListView")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local MailMainView = class("MailMainView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.mail,
        tabs={StringRes.email,StringRes.report,StringRes.outbox}},true)
end)

function MailMainView:ctor(parent,msg)
    View = self
    self.Labels = {
        MailListView.new(self,1,{},50),
        MailListView.new(self,2,{},100),
        MailListView.new(self,3,{},50),
    }

    for index,label in ipairs(self.Labels) do
        self:addChild(label)
        self:registerTabEvent(index,function()
            self:selectLabel(index)
        end)
    end
    self:registerTabEvent("close",function()
        self:closeCallBack()
    end)

    local function onNodeEvent(tag)
        if tag == "exit" then
            self:destroy()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    self.CurLab = nil
    self.init2 = nil
    self.SwitchFun = {
        function()

        end,
        function()
            --实时
            Connect:sendMsg("MailAction","getRecordList",nil,function(newMsg)
                if self.init2 then
                    self.Labels[2]:reSetList(newMsg.mails)
                else
                    self.Labels[2]:init(newMsg.mails)
                    self.init2 = true
                end
            end,true)
        end,
        function()

        end
    }
end

function MailMainView:initData()
    --收件箱处理
    Connect:sendMsg("MailAction","getMailList",nil,function(newMsg)
        self.Labels[1]:init(newMsg.mails)
    end,true)

    --报告
    self.SwitchFun[2]()

    --发件箱数据
    Connect:sendMsg("MailAction","getOutbox",nil,function(newMsg)
        self.Labels[3]:init(newMsg.mails)
    end,true)
    Connect:register("clientRecvMail",function(msg)
        MailMainView:recvMail(msg)
    end)
end

function MailMainView:closeCallBack()

end

function MailMainView:selectLabel(labIndex)
    self.CurLab = labIndex
    for index,label in ipairs(self.Labels) do
        label:setVisible(index == labIndex)
    end
    self.SwitchFun[labIndex]()
end

---公用(不需要new就可以调用)
function MailMainView:open(parent,data,label)
    if View then
        View:setVisible(true)
    else
        local newPage = self.new(parent)
        parent:addChild(newPage,2)
        newPage:initData()
        newPage:setTabSelect(label or 1)
    end
    return View
end

--SYSMAIL(1,"系统邮件"),
--USERMAIL(2,"玩家邮件"),
--GUILDMAIL(3,"公会邮件"),
--RECORD(4,"战报");
function MailMainView:recvMail(mail)
    local labIndex = 1
    if mail.type == 4 then
        labIndex = 2
    elseif mail.type > 4 then
        labIndex = 3
    end
    if View then
        local bCount = View.Labels[labIndex]:recvMail(mail)
        if bCount > 0 then
            local pd = PlayerData:getInstanse()
            pd.getGametipsVO.mailTips = pd.getGametipsVO.mailTips + bCount
            gWorldScene:freshGametips()
        end
    end

end

function MailMainView:removeMail(type,mail)
    local labIndex = 1
    if mail.type == 4 then
        labIndex = 2
    elseif mail.type > 4 then
        labIndex = 3
    end
    if View and labIndex~=2 then
         View.Labels[labIndex]:remove(mail)
    end
end

function MailMainView:destroy()
    View = nil
end

return MailMainView

