
local parts = require("src/app/data/parts")
local ReportView = require("src/app/views/mail/ReportView")
local PartsQualityCfg = require("src/app/cfg/PartsQualityCfg")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then 
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local function setEnabled(button,enable)
    button:setBright(enable)
    button:setEnabled(enable)
    button:setTouchEnabled(enable)
    --    button:setTitleColor(enable and CommonColor.Green2 or CommonColor.White)
end

local MailReadView = class("MailReadView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.read_mail,
        tabs={}})
end)

function MailReadView:ctor(parent,type,mail)
    local layer,newType = nil,1 --newType 只是代表ui的加载，加载后的有差异的处理，用这个识别
    if mail.type == 3 then --军团邮件
        newType = 2
        layer = CCUILoader:load("csd/email/ui_email_read_group_mail.csb")
    elseif (mail.resource and mail.resource ~= "") or (mail.items and mail.items ~= "") then --有奖励
        newType = 3 
        layer = CCUILoader:load("csd/email/ui_email_read_system_mail.csb")
    else
        layer = CCUILoader:load("csd/email/ui_email_read_email.csb")
    end
    self:addChild(layer)
    self.MainPage = layer
    local uihead = layer:getChildByName("panel_header")
    self.UIPeople = uihead:getChildByName("panel_player_name_bg"):getChildByName("text_player_name")
    self.UIPeopleBtn = uihead:getChildByName("btn_from")
    self.UITime = uihead:getChildByName("text_time")
    self.UITitle = uihead:getChildByName("panel_title_bg"):getChildByName("text_title")
    self.UIContent = layer:getChildByName("panel_body"):getChildByName("text_body")
    self.UIReply = layer:getChildByName("btn_reply")
    self.UIRemove = layer:getChildByName("btn_del")
    showShader:buttonToGray(self.UIReply)
    showShader:buttonToGray(self.UIRemove)
    
    self.NewType = newType
    self._parent = parent
    local indexFuncs = {
        function() 
            local uiWarning = self.UIPeople:getChildByName("icon_notice")
            local size = self.UIPeople:getContentSize()
            local posx,posy = uiWarning:getPosition()
            uiWarning:setPosition(size.width,posy)
            uiWarning:setVisible(mail.warning==1 and type~=3) --认识的人
            self.UIPeopleBtn:setTitleText((type==3) and StringRes.resver or StringRes.sender)
            uiWarning:addTouchEventListener(eventListner(ended,function() 
                local DescriptView = require("src/app/views/prompt/DescriptView")
                local DescriptCfg = require("src/app/cfg/DescriptCfg")
                DescriptView:open(self,DescriptCfg.MailWarning)
            end))
        end,
        function() 
            
        end,
        function() 
            -- 奖励处理
            local uiReward = layer:getChildByName("Button_5")
            showShader:buttonToGray(uiReward)
            self:setReward(mail)
            self:updateAttach(mail)
            uiReward:addTouchEventListener(eventListner(ended,function() 
                -- 领取奖励
                local _msg = {id=mail.id}
                Connect:sendMsg("MailAction","getAttachment",_msg,
                    function(newMsg) 
                        if newMsg.state == 1 then
                            mail.state = 1
                            self:updateAttach(mail)
                            local pd = PlayerData:getInstanse()
                            pd.basicData = newMsg.info
                            pd.tanks = newMsg.troops
                            FlyWordPrompt:prompt(StringRes.get_reward..self.rewardText)
                        end
                    end,true)
            end))
        end
    }
    self:setBaseMsg(type,mail)
    indexFuncs[newType]()
end

--附近是否获取
function MailReadView:updateAttach(mail)
    local uiReward = self.MainPage:getChildByName("Button_5")
    setEnabled(uiReward,mail.state==0)
    uiReward:setTitleText(mail.state==1 and StringRes.already_attach or StringRes.attach)
end

--一项奖励
function MailReadView:setRewardInfo(uiList,uiItem,info,isRes)
    local item = uiItem:clone()
    local uiCount = item:getChildByName("Text_9")
    local uiIcon = item:getChildByName("icon_item")
--    uiIcon:setVisible(false)
    local _t = {} --字符串和图片
    if isRes then  
        _t.icon = ResIconCfg[info.id]
        _t.name = StringRes[info.id]
    else
        if info.type == 1 then
            local data = gItem[info.id]
            _t.icon = data.icon
            _t.name = StringRes[data.name]
        elseif info.type == 2 then
            local data = parts[info.id]
            _t = data
            if data.type <= 4 then
                _t.back = PartsQualityCfg[data.que].pieceicon
            elseif data.type == 5 then
                _t.back = PartsQualityCfg[data.que].icon
            end
        elseif info.type == 3 then
            local data = Tank[info.id]
            _t.icon = data.icon
            _t.name = StringRes[data.name]
        end
    end
--    item:loadTexture(_t.icon,ResType)
    Common:changePic(item,_t.back or _t.icon)
    uiIcon:setVisible(_t.back and true or false)
    if _t.back then
        uiIcon:loadTexture(_t.icon)
    end
    self.rewardText=self.rewardText..string.format(" %sx%s",_t.name,info.count)
    uiCount:setString(StringTemp:toNum(info.count))
    uiList:pushBackCustomItem(item)
end

--奖励
function MailReadView:setReward(mail)
    self.rewardText = ""
    local uiList = self.MainPage:getChildByName("ListView_1")
    local uiItem = uiList:getChildByName("Image_12")
    uiList:removeAllChildren()
    local resource = StringTemp:toArrayRes(mail.resource)
    for _,info in ipairs(resource) do
        self:setRewardInfo(uiList,uiItem,info,true)
    end
    local items = StringTemp:toTabByStr2(mail.items,"id","type","count")
    for _,info in ipairs(items) do
        self:setRewardInfo(uiList,uiItem,info)
    end
end

--基础内容
function MailReadView:setBaseMsg(type,mail)
    self.UITime:setString(StringTemp:toMailTime(mail.sendTime))
    self.UITitle:setString(mail.title)
    self.UIContent:setString(mail.content)
    local isTreeType = type == 3
    self.UIPeople:setString(isTreeType and mail.receiver or mail.sender)
    setEnabled(self.UIReply,not ((mail.type==1) or isTreeType))
    self.UIReply:addTouchEventListener(eventListner(ended,function() 
        -- 回复
        local MailReadView = require("src/app/views/mail/MailWriteView")
        MailReadView:open(self,{resver=mail.sender,title="re:"..mail.sender})
    end))
    self.UIRemove:addTouchEventListener(eventListner(ended,function() 
        --删除
        self._parent:remove(mail)
        self:removeFromParent()
    end))
end

function MailReadView:open(parent,type,mail)
    if type == 2 then
        ReportView:open(parent,1,mail)
    else
        local _msg = {id=mail.id,type=type}
        Connect:sendMsg("MailAction","readMail",_msg,function(newMsg) 
            -- 跳转到阅读界面
            local newPage = self.new(parent,type,newMsg)
            parent:addChild(newPage)
        end,true)
    end
end

return MailReadView