

local ReportView = require("src/app/views/mail/ReportView")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then 
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local function setEnabled(button,enable)
    button:setBright(enable)
    button:setEnabled(enable)
    button:setTouchEnabled(enable)
    --    button:setTitleColor(enable and CommonColor.Green2 or CommonColor.White)
end

local MailWriteView = class("MailWriteView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.write_mail,
        tabs={}})
end)

function MailWriteView:ctor(parent,mail)
    local layer = CCUILoader:load("csd/email/ui_email_write_mail.csb")
    self:addChild(layer)
    local uihead = layer:getChildByName("panel_header")
    self.UIPeople = uihead:getChildByName("panel_player_name_bg"):getChildByName("text_player_name")
    self.UIPeopleBtn = uihead:getChildByName("btn_from")
    self.UITitle = uihead:getChildByName("panel_title_bg"):getChildByName("text_title")
    self.UIContent = layer:getChildByName("panel_body"):getChildByName("text_body")
    self.UIReply = layer:getChildByName("btn_reply")
    showShader:buttonToGray(self.UIReply)
    
    self.type = mail.type
    self:initBaseMsg(mail)
end

function MailWriteView:initBaseMsg(mail)
    self.UIPeople:setString(mail.resver or "")
    self.UITitle:setString(mail.title or "")
    self.UIContent:setString(mail.content or "")
    
    self.UIReply:addTouchEventListener(eventListner(ended,function() 
        self:reply()
    end))
    self.UIPeopleBtn:addTouchEventListener(eventListner(ended,function() 
        --goto 选择玩家界面 
        local SelectFriendView = require("src/app/views/mail/SelectFriendView")
        SelectFriendView:open(self,function(name)
            self.UIPeople:setString(name)
        end)
    end))
end

--发送消息
function MailWriteView:reply()
    local resver = self.UIPeople:getString()
    if resver == "" then
        return PromptView:type1(nil,StringRes.print_sender,StringRes.ok)
    end
    local content = self.UIContent:getString()
    if content == "" then
        return PromptView:type1(nil,StringRes.Content_null,StringRes.ok)
    end
    local title = self.UITitle:getString()
    local _msg = {receiver=resver,title=title,content=content,type=self.type}
    Connect:sendMsg("MailAction","sendMail",_msg,
        function(newMsg)
            if newMsg.state ==1 then
                _msg.id,_msg.type,_msg.sendTime = newMsg.id,5,os.date("%Y-%m-%d %H:%M:%S",os.time())
                require("src/app/views/mail/MailMainView"):recvMail(_msg)
                self:close()
            end
        end,true)  
end

function MailWriteView:open(parent,mail)
    local newPage = self.new(parent,mail)
    parent:addChild(newPage)
end

return MailWriteView