
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then 
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

SelectFriendView = class("SelectFriendView",function()
    return display.newLayer()
end)

function SelectFriendView:ctor(parent,callback)
    local layer = CCUILoader:load("csd/email/ui_email_address_list.csb")
    self:addChild(layer)
    
    local UIPanelBack = layer:getChildByName("panel_address_bg")
    self.UIClose = UIPanelBack:getChildByName("btn_close")
    self.UINoFriend = UIPanelBack:getChildByName("text_no_friend")
    
    self.UIFriendList = UIPanelBack:getChildByName("listview_address")
    self.UIFriendItem = self.UIFriendList:getChildByName("panel_player_address_bg")
    self.UIFriendItem:retain()
    
    self.UIClose:addTouchEventListener(eventListner(ended,function()
        self:close()
    end))
    
    self.CallBack = callback
    
    self.UIFriendList:removeAllChildren()
end

function SelectFriendView:updateList(list)
    self.UIFriendList:removeAllChildren()
    self.UINoFriend:setVisible(#list==0)
    for index,friend in ipairs(list) do
        local item = self.UIFriendItem:clone()
        self.UIFriendList:pushBackCustomItem(item)
        local uiName = item:getChildByName("text_player_name")
        local uiAdd = item:getChildByName("btn_add")
        uiName:setString(friend.fname)
        uiAdd:addTouchEventListener(eventListner(ended,function() 
                self.CallBack(friend.fname)
                self:close()
            end))
    end
end

function SelectFriendView:close()
    self.UIFriendItem:release()
    self:removeFromParent()
end

function SelectFriendView:open(parent,callback)
    local newPage = self.new(parent,callback)
    parent:addChild(newPage)
    Connect:sendMsg("FriendAction","getFriendList",nil,function(newMsg) 
        newPage:updateList(newMsg.friends,true)
    end,true)
end

return SelectFriendView