
--侦查报告
local ResStrCfg = {hc="crystal",hf="ferrum",ho="oil",hl="lead",ht="titanium"}
local ended = ccui.TouchEventType.ended
local function eventListner(event,func)
    return function(e,t)
        if t == event then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local function jiexiTable(_t)
    local re = {}
    for index,info in ipairs(_t) do
        if ResStrCfg[info.id] then
            info.id = ResStrCfg[info.id]
            table.insert(re,info)
        else
            table.insert(re,1,info)
        end
    end
    return re
end

local SpyReportView = class("SpyReportView",function(parent)
    return PanelTabLayer.new(parent,{title=StringRes.spy_report ,tabs={}})
end)

function SpyReportView:ctor(parent,mail,report)
    self.MainPage = CCUILoader:load("csd/report/ui_spy_report.csb")
    self:addChild(self.MainPage)

    self.UIReportList = self.MainPage:getChildByName("listview_spy_report")
    self.UITargetInfo = self.MainPage:getChildByName("panel_target_info")
    self.UIResInfo = self.MainPage:getChildByName("panel_resource_info")
    self.UIPlayerInfo = self.MainPage:getChildByName("panel_player_resource_info")
    self.UITroops = self.MainPage:getChildByName("panel_troops_info")
    self.UIAttack = self.MainPage:getChildByName("btn_attack")
    self.UIRemove = self.MainPage:getChildByName("btn_del")

    self.UIAttack:addTouchEventListener(eventListner(ended,
        function()
            if report.type == 8 then
                self:close()
                local TerritoriesContend = require("src/app/views/territories_war/TerritoriesContend")
                TerritoriesContend:checkCanAtk(gWorldScene,report.x,report.y)
            else
                local _msg = {x=report.tarX,y=report.tarY}
                Connect:sendMsg("WorldAction","getMoveTime",_msg,function(newMsg)
                    local pview = self._parent
                    self:close()
                    local TroopsVies = require("src/app/views/troops/TroopsView")
                    TroopsVies:open(pview,2,{time=newMsg.time,
                        pos={terrainId=report.tarTerrain,x=report.tarX,y=report.tarY}})
                end,true)
            end
        end))
    self.UIRemove:addTouchEventListener(eventListner(ended,
        function()
            self._parent:remove(mail)
            self:close()
        end))

    self:setTargetInfo(report)
    self:setResInfo(report)
    self:setTroopsInfo(report.tarTroops)
end

--目标信息
function SpyReportView:setTargetInfo(report)
    local uiInfo = self.UITargetInfo:clone()
    local isCity = report.type~=1
    local _t = {
        string.format(StringRes.spy_address,report.tarName..(isCity and
        (report.tarGuildName~="" and string.format("(%s)",report.tarGuildName) or "") or
            string.format(StringRes.LV2,report.tarLv)),report.tarX,report.tarY),
        string.format(StringRes.spy_terrain,StringRes["terrain_"..report.terrain]),
        string.format(StringRes.spy_time,StringTemp:toMailTime(report.recordTime)),
        --显示该城市驻守的玩家名称（军团功能），若无，则显示（无）
        --显示该资源点驻守的玩家的昵称，若无，则显示（无）
        (report.type==8) and string.format(StringRes.occupier,report.tarPlayerName~="" and
        report.tarPlayerName..(report.tarGuildName~="" and string.format("(%s)",report.tarGuildName) or "") or StringRes.not_troops) or
        string.format(isCity and StringRes.garrison or StringRes.game_player,report.defender~="" and
        report.defender..(report.tarGuildName~="" and string.format("(%s)",report.tarGuildName) or "") or StringRes.not_troops)
    }
    for index,text in ipairs(_t) do
        local uiText = uiInfo:getChildByName("text_spy_"..index)
        uiText:setString(text)
    end
    self.UIReportList:pushBackCustomItem(uiInfo)
end

--资源信息
function SpyReportView:setResInfo(report)
    local uiInfo,add,_t = nil,0,nil
    local resource = StringTemp:toTableDecimal(report.resource)
    if report.type == 2 then
        uiInfo,add = self.UIPlayerInfo:clone(),1
        _t = {
        string.format(StringRes.res_max_rob,StringRes.ferrum,StringTemp:toNum(resource.ferrum)),
        string.format(StringRes.res_max_rob,StringRes.oil,StringTemp:toNum(resource.oil)),
        string.format(StringRes.res_max_rob,StringRes.lead,StringTemp:toNum(resource.lead)),
        string.format(StringRes.res_max_rob,StringRes.titanium,StringTemp:toNum(resource.titanium)),
        string.format(StringRes.res_max_rob,StringRes.crystal,StringTemp:toNum(resource.crystal)),
        }
    else
        local str = ""
        local resource = StringTemp:toArrayRes(report.resource)
        resource = jiexiTable(resource)
        for index,info in ipairs(resource) do
            if info.count > 0 then
                if report.type == 8 then
                    str = str..string.format(StringRes["occupy_per_add"..index],info.count*100,StringRes[info.id]).."\n"
                else
                    if info.id == "exp" then
                        str = str..string.format(StringRes.Rebel_report,info.count.."\n")
                    else
                        str = str..string.format(StringRes["spy_resource"..index],StringRes[info.id],info.count).."\n"
                    end
                end
            end
        end
        _t = {str}
        uiInfo = self.UIResInfo:clone()
    end
    for index,str in ipairs(_t) do
        local uiText = uiInfo:getChildByName("text_spy_"..(index+add+4))
        uiText:setString(str)
    end
    self.UIReportList:pushBackCustomItem(uiInfo)
end

--兵力信息
function SpyReportView:setTroopsInfo(troops)
    local uiInfo = self.UITroops:clone()
    troops = StringTemp:toTabByStr2(troops,"id","count","pos")
    for _,info in ipairs(troops) do
        local msg = Tank[info.id]
        if msg and info.count > 0 then
            local uiImage = uiInfo:getChildByName("icon_troop_"..info.pos)
            local uiText = uiImage:getChildByName("text_troops_"..info.pos)
            uiImage:loadTexture(msg.icon,ResType)
            uiText:setString(string.format(StringRes.troops_name_count,StringRes[msg.name],info.count))
        end
    end
    self.UIReportList:pushBackCustomItem(uiInfo)
end

return SpyReportView