
local ReportInterface = require("src/app/views/mail/ReportInterface")
local ended = ccui.TouchEventType.ended
local function eventListner(event,func)
    return function(e,t)
        if t == event then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local WarReportView = class("WarReportView",function(parent,mail,report)
    local title = (report.type>7) and StringRes.battle_report or StringRes.war_report
    return PanelTabLayer.new(parent,{title=title ,tabs={}})
end)

function WarReportView:ctor(parent,mail,report,formId,isChat)
    self.MainPage = CCUILoader:load("csd/report/ui_war_report.csb")
    self:addChild(self.MainPage)

    self.UIReportList = self.MainPage:getChildByName("listview_war_report")
    self.UIBattleInfo = self.MainPage:getChildByName("panel_war_info")
    self.UIRewardInfo = self.MainPage:getChildByName("panel_reward_info")
    self.UIPlayerInfo = self.MainPage:getChildByName("panel_player_resource_info")
    self.UIRoleInfo = self.MainPage:getChildByName("panel_general_info")
    self.UITankLost = self.MainPage:getChildByName("panel_tank_lost")
    self.UIAtkLost = self.MainPage:getChildByName("panel_tank_lost_us")
    self.UILostList = self.MainPage:getChildByName("listview_tank_lost")
    self.UIDefenseLost = self.MainPage:getChildByName("panel_tank_lost_defense")
    self.UIAccessory = self.MainPage:getChildByName("panel_accessory")
    self.UIBattleInfo2 = self.MainPage:getChildByName("panel_military_exercise_info")

    local uiAccessoryPrompt = self.UIAccessory:getChildByName("Button_Prompt")
    uiAccessoryPrompt:addTouchEventListener(eventListner(ended,function()
            local DescriptCfg = require("src/app/cfg/DescriptCfg")
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,DescriptCfg.ReportPartCompare)
        end))

    local ui_beAtk = self.MainPage:getChildByName("panel_footer_been_attack")
    local ui_benotAtk = self.MainPage:getChildByName("panel_footer_attack")
    local ui_battle = self.MainPage:getChildByName("panel_footer_military_exercise")
    local isAtker = (report.type%2 ~= 0)
    ui_beAtk:setVisible(report.type<=7 and not isAtker)
    ui_benotAtk:setVisible(report.type<=7 and isAtker)
    ui_battle:setVisible(report.type>7)
    local btnParent = (report.type>7) and ui_battle or (isAtker and ui_benotAtk or ui_beAtk)
    self.UIRemove = btnParent:getChildByName("btn_del")
    self.UIPlay = btnParent:getChildByName("btn_replay")
    self.UIWriteMail = btnParent:getChildByName("btn_write_email")
    self.UISendMsg = btnParent:getChildByName("btn_share") --发送消息

    if not isAtker then
        local UIAttack = ui_beAtk:getChildByName("btn_attack")
        showShader:buttonToGray(UIAttack)
        UIAttack:addTouchEventListener(eventListner(ended,
        function()
            local _msg = {x=report.tarX,y=report.tarY}
            Connect:sendMsg("WorldAction","getMoveTime",_msg,function(newMsg)
                local pview = self._parent
                self:close()
                local TroopsVies = require("src/app/views/troops/TroopsView")
                TroopsVies:open(pview,2,{time=newMsg.time,
                    pos={terrainId=report.tarTerrain,x=report.tarX,y=report.tarY}})
            end,true)
        end))
        SpecialView:setEnabled(UIAttack,not isChat)
    end
    showShader:buttonToGray(self.UIPlay)
    showShader:buttonToGray(self.UIRemove)
    showShader:buttonToGray(self.UISendMsg)

    self.UIRemove:addTouchEventListener(eventListner(ended,
        function()
            self._parent:remove(mail)
            self:close()
        end))

    self.UIPlay:addTouchEventListener(eventListner(ended,
        function() --播放
            ReportInterface:play(report,formId,isChat)
        end))
    if self.UIWriteMail then
        showShader:buttonToGray(self.UIWriteMail)
        self.UIWriteMail:addTouchEventListener(eventListner(ended,
            function() --写邮件
                self:close()
                --打开写邮件的界面
                local MailWriteView = require("src/app/views/mail/MailWriteView")
                MailWriteView:open(parent,{resver=report.tarPlayerName})
            end))
        SpecialView:setEnabled(self.UIWriteMail,--[[isChat and ]]report.type > 4)
    end
    self.UISendMsg:addTouchEventListener(eventListner(ended,
        function() --聊天
            PromptView:chat(function(label)
                --发送战报到聊天
                local msg = {id = report.id,pid=PlayerData:getInstanse().basicData.playerId }
                local msgAction,msgName = "MailAction","addPubRecord"
                if report.type >= 98 then
                    msgAction,msgName = "ArenaAction","addPubRecord"
                end
                Connect:sendMsg(msgAction,msgName,msg,function(newMsg)end)
                --直接掉聊天接口？
                local content,chatType = self:getChatMsg(mail,report)
                FlyWordPrompt:prompt(StringRes.already_chat)
                ChatServer:sendrecord(label,content,nil,chatType,report.id)
            end)
        end))
    SpecialView:setEnabled(self.UIRemove,not isChat)
    SpecialView:setEnabled(self.UISendMsg,not isChat)
    SpecialView:setEnabled(self.UIPlay,report.haveReplay==1) --有无录像

    self:showForType(report)
end

--获取聊天信息
function WarReportView:getChatMsg(mail,report)
    if report.type == 98 then
        return string.format(StringRes.challenge_report,report.tarPlayerName,
            report.result==1 and StringRes.win or StringRes.fail),4
    elseif report.type == 99 then
        return string.format(StringRes["be_challenged_"..report.result],report.tarPlayerName),4
    else
        return mail.title,3
    end
end

--目标字符串
local function getTargetStr(report)
    local showGarrion = (report.type == 5 and report.garrionName and report.garrionName ~= "")
    local junName = (report.tarGuildName and report.tarGuildName~="") and string.format("(%s)",
        report.tarGuildName) or ""
    local tstr = (report.type>4) and (showGarrion and report.garrionName or report.tarPlayerName)..junName
     or report.tarName..string.format(StringRes.LV2,report.tarLv)
    if report.type == 4 then
        return string.format(StringRes["attack_target"..report.type],report.tarPlayerName,tstr)
    else
        return string.format(StringRes["attack_target"..report.type],tstr)
    end

end

--战斗地点
local function getAddressStr(report)
    -- 防守 or 进攻
    local isAtker = (report.type%2 ~= 0)
    local address = (isAtker and report.tarPlayerName or report.playerName)
    if report.type > 2 then
        if isAtker then
            address = address..(report.tarGuildName~="" and
            string.format("(%s)",report.tarGuildName) or "")
        else
            address = address..(report.guildName~="" and
                string.format("(%s)",report.guildName) or "")
        end
    end
    local re = string.format("%s(%d,%d)",address,report[isAtker and "tarX" or "x"],
    report[isAtker and "tarY" or "y"])
    return string.format(StringRes.battle_address,re)
end

--阵容字符串
local function getAtkerStr(report)
    local re1,re2 = nil,nil
    local isAtker = (report.type%2 ~= 0)
    local myStr,tarStr = report.terrain,report.tarTerrain
    if isAtker then
        re1 = string.format(StringRes.depart_terrain,StringRes.us,StringRes["terrain_"..myStr])
        re2 = string.format(StringRes.defense_terrain,StringRes.target,StringRes["terrain_"..tarStr])
    else
        re1 = string.format(StringRes.depart_terrain,StringRes.target,StringRes["terrain_"..myStr])
        re2 = string.format(StringRes.defense_terrain,StringRes.us,StringRes["terrain_"..myStr])
    end
    return re1,re2
end

--战斗信息(军事演习中的)
function WarReportView:setBattleInfo2(report)
    local uiInfo = self.UIBattleInfo2:clone()
    local str,color = nil,nil
    if report.rankChange>0 then
        str,color = string.format(StringRes.myrank_change,StringRes.up),CommonColor.Green2
    elseif report.rankChange == 0 then
        str,color = string.format(StringRes.myrank_change,StringRes.no_change),CommonColor.White
    else
        str,color = string.format(StringRes.myrank_change,StringRes.down),CommonColor.Red
    end
    local _t = {
        string.format(StringRes["attack_target"..report.type],report.tarPlayerName),
        string.format(StringRes.combat_result,report.result==1 and StringRes.win or StringRes.fail),
        string.format(StringRes.battle_time,StringTemp:toMailTime(report.recordTime)),
        str
    }

    local uiText = nil
    for index,text in ipairs(_t) do
        uiText = uiInfo:getChildByName("text_report_"..index)
        uiText:setString(text)
        if index == 4 then
            uiText:setColor(color)
        end
    end
    self.UIReportList:pushBackCustomItem(uiInfo)
end

--战斗信息
function WarReportView:setBattleInfo(report)
    local uiInfo = self.UIBattleInfo:clone()
    local lineup1,lineup2 = getAtkerStr(report) --生成两个
    local _t = {
        getTargetStr(report),
        getAddressStr(report),
        lineup1,lineup2,
        string.format(StringRes.battle_time,StringTemp:toMailTime(report.recordTime)),
        string.format(StringRes.battle_result,(report.result==1) and StringRes.win
        or StringRes.fail),
        string.format(StringRes.honour,report.honour),
        string.format(StringRes.exploit,report.warCon), --军功
    }

    local uiText = nil
    for index,text in ipairs(_t) do
        uiText = uiInfo:getChildByName("text_report_"..index)
        uiText:setString(text)
        if index == 6 then
            uiText:setColor((report.result==1) and CommonColor.Green2 or CommonColor.Red)
        end
    end
    self.UIReportList:pushBackCustomItem(uiInfo)
end

--战力品
function WarReportView:setRewardInfo(report)
    local uiInfo = self.UIRewardInfo:clone()
    local uiMove = uiInfo:getChildByName("Panel_pos_set")
    local uiList = uiInfo:getChildByName("ListView_reward")
    local uiItem = uiList:getChildByName("Panel_reward")
    uiList:setColumnCount(2)
    uiList:removeAllChildren()
    local rewards = StringTemp:toArrayRes(report.booty)
    for index,info in ipairs(rewards) do
        local item = uiItem:clone()
        local uiIcon = item:getChildByName("icon_xp")
        local uiCount = item:getChildByName("text_xp_num")
        local uiName = item:getChildByName("text_xp")
        local id = tonumber(info.id)
        local data = id and gItem[id] or {icon=ResIconCfg[info.id],name=info.id}
        uiIcon:loadTexture(data.icon,ResType)
        uiCount:setString(info.count)
        uiName:setString(StringRes[data.name])
        uiList:pushBackCustomItem(item)
    end
    local Num = math.ceil(#rewards/2)
    uiList:setContentSize(cc.size(560,120*Num))
    local size = uiInfo:getContentSize()
    size.height = 60+Num*120
    uiInfo:setContentSize(size)
    uiMove:setPosition(0,size.height)
    self.UIReportList:pushBackCustomItem(uiInfo)
    --没有战利品文字要变
    if rewards[1] == nil then
        uiMove:getChildByName("panel_header"):getChildByName("text_reward"):setString(
            string.format(StringRes.spoils,StringRes.have_not))
    end
end

--资源信息
function WarReportView:setResInfo(report)
    local uiInfo = self.UIPlayerInfo:clone()
    local resource = StringTemp:toTableDecimal(report.resource)
    local isAtker = (report.type%2 ~= 0)
    local isWin = report.result == 1
    local addStr = (isAtker and isWin) and "+" or "-"
    local _t = {"ferrum","oil","lead","titanium","crystal"}
    for index,key in ipairs(_t) do
        local count = resource[key] or 0
        local s = count~=0 and addStr or ""
        local str = string.format("%s %s%s",StringRes[key],s,count)
        local color = count==0 and CommonColor.White or ((isAtker and isWin) and
        CommonColor.Green2 or CommonColor.Red)
        local uiText = uiInfo:getChildByName("text_report_"..(index+8))
        uiText:setString(str)
        uiText:setColor(color)
    end
    self.UIReportList:pushBackCustomItem(uiInfo)
end

--玩家信息
local function setPlayerInfo(pos,info,uiInfo)
    local uiback = uiInfo:getChildByName("icon_general_"..pos)
    local uiIcon = uiback:getChildByName("icon_general")
    local visible = false
    if info.id > 0 then
        visible = true
        local uiQuality = uiback:getChildByName("icon_general_quality")
        Common:changePic(uiIcon,gGeneral[info.id].icon)
        Common:changePic(uiQuality,gGeneralQualityIcon[info.quality])
    end
    uiIcon:setVisible(visible)
end

--将领信息
function WarReportView:setPlayersInfo(report)
    local uiInfo = self.UIRoleInfo:clone()
    local uiMyFight = uiInfo:getChildByName("text_general_strength_us_num")
    uiMyFight:setString(report.intensity)
    local list = StringTemp:toTabByStr2(report.commander,"pos","id","quality")
    for index,info in ipairs(list) do
        setPlayerInfo(info.pos,info,uiInfo)
    end
    --敌方
    local uiEnemyFight = uiInfo:getChildByName("text_general_strength_enemy_num")
    uiEnemyFight:setString(report.tarIntensity)
    list = StringTemp:toTabByStr2(report.tarCommander,"pos","id","quality")
    for index,info in ipairs(list) do
        setPlayerInfo(info.pos+6,info,uiInfo)
    end
    self.UIReportList:pushBackCustomItem(uiInfo)
end

--列表处理
function WarReportView:setLostList(list)
    local uiInfo = self.UILostList:clone()
    local uiItem = uiInfo:getChildByName("panel_tank_lost")
    local itemSize = uiItem:getContentSize()
    uiInfo:removeAllChildren()
    local size = uiInfo:getContentSize()
    for index,info in ipairs(list) do
        local item = uiItem:clone()
        local uiName = item:getChildByName("text_name")
        local uiAllNum = item:getChildByName("text_num_1")
        local uiLostNum = item:getChildByName("text_num_2")
        local uiRemainNum = item:getChildByName("text_num_3")
        uiName:setString(StringRes[Tank[info.id].name])
        uiAllNum:setString(info.all)
        uiLostNum:setString(info.lost)
        uiRemainNum:setString(info.all-info.lost)
        uiInfo:pushBackCustomItem(item)
    end
    size.height = (#list) * itemSize.height + 10
    uiInfo:setContentSize(size)
    self.UIReportList:pushBackCustomItem(uiInfo)
end

--攻击方损失
function WarReportView:setAtkLost(report)
    local uiInfo = self.UIAtkLost:clone()
    local uiName = uiInfo:getChildByName("text_attack_side")
    local isAtker = (report.type < 50 and report.type%2 ~= 0) or (report.type == 98)
    uiName:setString(string.format(StringRes.atker,isAtker and
    report.playerName or report.tarPlayerName))
    self.UIReportList:pushBackCustomItem(uiInfo)
    local troopsStr = isAtker and report.costTroops or report.tarCostTroops
    local list = StringTemp:toTabByStr2(troopsStr,"id","all","lost")
    self:setLostList(list)
end

--防御放损失
function WarReportView:setDefenseLost(report)
    local uiInfo = self.UIDefenseLost:clone()
    local uiName = uiInfo:getChildByName("text_defense_side")
    local isAtker = (report.type < 50 and report.type%2 ~= 0) or (report.type == 98)
    uiName:setString(string.format(StringRes.defenser,(report.garrionName and report.garrionName ~= "") and report.garrionName or
        (isAtker and report.tarPlayerName or report.playerName)))
    self.UIReportList:pushBackCustomItem(uiInfo)
    local troopsStr = isAtker and report.tarCostTroops or report.costTroops
    local list = StringTemp:toTabByStr2(troopsStr,"id","all","lost")
    self:setLostList(list)
end


--损失
function WarReportView:setLostInfo(report)
    self.UIReportList:pushBackCustomItem(self.UITankLost:clone())
    self:setAtkLost(report)
    self:setDefenseLost(report)
end

--配件
function WarReportView:setPartInfo(report)
    self.UIAccessory:removeFromParent()
    local parts = StringTemp:toTable(report.parts,"quality","count")
    for index,info in ipairs(parts) do
        local uiInfo = self.UIAccessory:getChildByName("icon_accessory_"..info.quality)
        uiInfo:getChildByName("text_strength"):setString(info.count)
    end
    local tarParts = StringTemp:toTable(report.tarParts,"quality","count")
    for index,info in ipairs(tarParts) do
        local uiInfo = self.UIAccessory:getChildByName("icon_accessory_"..(info.quality+4))
        uiInfo:getChildByName("text_strength"):setString(info.count)
    end
    self.UIReportList:pushBackCustomItem(self.UIAccessory)
end

--
function WarReportView:showForType(report)
    if report.type > 7 then
        self:setBattleInfo2(report)
        self:setPlayersInfo(report)
        self:setPartInfo(report)
        self:setLostInfo(report)
    else
        self:setBattleInfo(report)
        self:setRewardInfo(report)
        self:setResInfo(report)
        self:setPartInfo(report)
        self:setPlayersInfo(report)
        self:setLostInfo(report)
    end
end

return WarReportView