
local NodeTranslator = require("src/app/util/NodeTranslator")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local DescriptView = class("DescriptView",function() 
    local layer = display.newColorLayer(cc.c4b(0,0,0,255*0.3)) --.newLayer()
    return layer
end)

function DescriptView:ctor(parent,data,interval)
    self.MainPage = CCUILoader:load("csd/public/DescriptLayer.csb")
    self.MainPage:setAnchorPoint(0.5,0.5)
    self.MainPage:setPosition(CONFIG_SCREEN_WIDTH/2,CONFIG_SCREEN_HEIGHT/2)
    self:addChild(self.MainPage)
    
    
    self.UIGround = self.MainPage:getChildByName("Panel_back")
    self.UIRichParent = self.MainPage:getChildByName("Panel_rich")
    self.UIBackImage = self.MainPage:getChildByName("Panel_image")
    
    self.UIGround:addTouchEventListener(eventListner(ended,function() 
        self:close()
    end))
    
    self.RichSize = self.UIRichParent:getContentSize()
    self.BackSize = self.UIBackImage:getContentSize()
    
    self.Data = data
    self.interval = interval
    self._parent = parent
    
    NodeTranslator:transZoomOut(self.MainPage,function()

        end)
end

function DescriptView:update()
    SpecialView:addRichText(self.UIRichParent,self.Data,self.interval)
    local newSize = self.UIRichParent:getContentSize()
    local backSize = self.BackSize
    self.UIBackImage:setContentSize(backSize.width,newSize.height+(backSize.height-self.RichSize.height))
end

function DescriptView:close()
    NodeTranslator:transZoomIn(self.MainPage,function()
        self._parent:removeChild(self)
    end)
end

function DescriptView:open(parent,data,interval)
    interval = data.interval or interval
    local newPage = self.new(parent,data,interval)
    newPage:update()
    parent:addChild(newPage)
    return newPage
--    local size = newPage:getContentSize()
--    newPage:setAnchorPoint(0.5,0.5)
--    newPage:setPosition(size.width/2,size.height/2)
end

return DescriptView
