local DialogUtil = require("src.app.util.DialogUtil")

MoreRes = {}

function MoreRes:show(parent,id,callback)
    local content = CCUILoader:load("res/csd/public/MoreRes.csb")
    local cont = content:getChildByName("content")
    self.listview = cont:getChildByName("listView")
    self.listview:setSwallowTouches(false)
    
    Connect:sendMsg("PlayerAction","getPlayerItemsByResourse",{type = id-1},
        function (data)
            self.itemsData = data
            self:initItems(content,id,callback)
        end,false)


    cont.removable = false
    require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
        cont.removable = true
    end)
    DialogUtil:addClickEvent2(content,function()
        if cont.removable then
            require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
                content:removeFromParent()
            end)
        end
    end)
    parent:addChild(content)
end

function MoreRes:getItemCount(id)
    for k,v in pairs(self.itemsData)do
        if id == v.templateId then
            return v.count,v.id
        end
    end
    return 0,0
end

function MoreRes:initItems(content,buyId,callback)
    local tmp = content:getChildByName("item_detail")
    for i,v in ipairs(string.split(gQuickbuy[buyId].item,","))do
        local curItem = tmp:clone()
        local id = tonumber(v)
        curItem.tagId = id
        local tmpInfo = gItem[id]
        local icon_dtl = curItem:getChildByName("icon_dtl")
        icon_dtl:loadTexture(tmpInfo.icon,ResType)
        local text_title = curItem:getChildByName("text_title")
        text_title:setString(StringRes[tmpInfo.name])
        local text_info = curItem:getChildByName("text_info")
        text_info:setString(StringRes[tmpInfo.desc])
        local num_coin = curItem:getChildByName("num_coin")
        num_coin:setString(gStore[id].price*15)
        local text_num = curItem:getChildByName("text_num")
        local count,sid = self:getItemCount(id)
        text_num:setString(string.format(StringRes.cur_num,count))

        local btn_buy = curItem:getChildByName("btn_buy")
        local btn_use = curItem:getChildByName("btn_use")

        --使用道具
        function useItem(item,sid)
            local senddata = {id = sid,count = 1}
            Connect:sendMsg("BagAction","useBagItems",senddata,
                function(data)
                    if data.state == 1 then

                        item:getChildByName("text_num"):setString(string.format(StringRes.cur_num,data.count))
                        local btnBuy = item:getChildByName("btn_buy")
                        local btnUse = item:getChildByName("btn_use")

                        if data.count <= 0 then
                            --购买并使用
                            btnBuy:setVisible(true)
                            btnUse:setVisible(false)
                            btnBuy:addTouchEventListener(function(e, t)
                                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                                    buyAndUseItem(item)
                                end
                            end)
                        end

                        --使用后重新刷新显示
                        Connect:sendMsg("PlayerAction","getPlayerInfo",{},
                            function (data)
                                local pd = PlayerData:getInstanse()
                                pd.basicData = data
                                if callback then callback()end
                                NodeTranslator:transZoomOut(content:getChildByName("content"),function()
                                    content:removeFromParent()
                                end)
                                FlyWordPrompt:prompt(string.format(StringRes.use_success,StringRes[gItem[item.tagId].name]))
                            end,false)

                    else
                    --使用失败

                    end

                end)
        end

        --购买并使用
        function buyAndUseItem(item)
            local tmpId = item.tagId
            DialogUtil:buy(gStore[tmpId].price*15,StringRes[gItem[tmpId].name],function()
                local pd = PlayerData:getInstanse()
                local senddata = {id = tmpId    }
                Connect:sendMsg("ShopAction","buyShopItems",senddata,
                    function(data)
                        if data.state == 1 then
                            pd.basicData.gold = data.gold
                            useItem(item,data.id)
                        else
                        --购买失败

                        end

                    end)
            end)
           
        end

        if count > 0 then
            --使用
            btn_buy:setVisible(false)
            btn_use:setVisible(true)
            btn_use:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    useItem(curItem,sid)
                end
            end)
        else
            --购买并使用
            btn_buy:setVisible(true)
            btn_use:setVisible(false)
            btn_buy:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    buyAndUseItem(curItem)
                end
            end)
        end

        self.listview:pushBackCustomItem(curItem)
    end
end

return MoreRes