
local display = display
local CCUILoader = CCUILoader

--弹框提示
PromptView = {CurrentView=nil}

local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local function destroyLast()
    local CurrentView = PromptView.CurrentView
    if CurrentView then
        CurrentView.page:removeFromParent()
        PromptView.CurrentView = nil
    end
end

local function loadPage(file,floor)
    destroyLast()
    floor = floor or 900
    local scene = display.getRunningScene()
    local page = CCUILoader:load(file)
    if floor then
        scene:addChild(page,floor)
    else
        scene:addChild(page)
    end

    local function onNodeEvent(tag)
        if tag == "exit" then
            PromptView.CurrentView = nil
        end
    end
    page:registerScriptHandler(onNodeEvent)
    return page
end

-- 类型1的提示:只有文字和中间一个按钮的
function PromptView:type1(title,content,btnText,btnFun,floor)
    local page = loadPage("csd/public/OneBtnPromptLayer.csb",floor)

    local tClass = {}
    local btn = page:getChildByName("Button_ok")
    local textTitle = page:getChildByName("Text_title")
    local textContent = page:getChildByName("Text_content")
    btn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        if btnFun then
            btnFun()
        end
    end))
    function tClass:setTextColor(color)
        textContent:setColor(color)
    end
    --textTitle:setString(title)
    tClass:setTextColor(CommonColor.White)
    btn:setTitleText(btnText)
    textContent:setString(content)
    self.CurrentView = {scene=scene,page=page}
    return tClass
end

-- 类型2的提示：提示文字和两个按钮（左右两个按钮）
function PromptView:type2(title,content,leftText,rightText,leftFun,rightFun,floor)
    local page = loadPage("csd/public/PromptTwoBtnLayer.csb",floor)

    --逻辑
    local leftBtn = page:getChildByName("Button_ok")
    local rightBtn = page:getChildByName("Button_cancel")
    local textTitle = page:getChildByName("Text_title")
    local textContent = page:getChildByName("Text_content")
    leftBtn:setTitleText(leftText)
    rightBtn:setTitleText(rightText)
    textTitle:setString(title)
    textContent:setString(content)
    leftBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        if leftFun then
            leftFun()
        end
    end))
    rightBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        if rightFun then
            rightFun()
        end
    end))

    self.CurrentView = {scene=scene,page=page}
end

-- 类型2的提示：提示文字和两个按钮,带二次确认选项（左右两个按钮）
function PromptView:type2WithConfirm(title,content,leftText,rightText,leftFun,rightFun,floor)
    local pd = PlayerData:getInstanse()
    if pd.basicData.useGoldConfirm and pd.basicData.useGoldConfirm ~= 1 then
        if leftFun then
            leftFun()
            return
        end
    end

    local page = loadPage("csd/tankuang1.csb",floor)
    local panel_bg = page:getChildByName("panel_mask"):getChildByName("panel_bg")
    local checkBox = page:getChildByName("CheckBox_1")
    checkBox:setSelected(false)
    --逻辑

    local leftBtn = panel_bg:getChildByName("btn_confirm")
    local rightBtn = panel_bg:getChildByName("btn_cancel")
    local textTitle = panel_bg:getChildByName("text_remind")
    local textContent = panel_bg:getChildByName("text_remind_content")
    leftBtn:setTitleText(leftText)
    rightBtn:setTitleText(rightText)
    textTitle:setString(title)
    textContent:setString(content)
    leftBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        if leftFun then
            leftFun()
        end
    end))
    rightBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        if rightFun then
            rightFun()
        end
    end))

    checkBox:addEventListener(function(e, t)
        MyAudio:PlayEffect(MusicAndEffect.btnEffect)
        if t == ccui.CheckBoxEventType.selected then
            pd.basicData.useGoldConfirm = 0
        elseif t == ccui.CheckBoxEventType.unselected then
            pd.basicData.useGoldConfirm = 1
        end

        Connect:sendMsg("PlayerAction","setUseGoldConfirm",{useGoldConfirm = pd.basicData.useGoldConfirm},function(newMsg)

        end,false)
    end)

    self.CurrentView = {scene=scene,page=page}
end

-- 类型2的提示：提示文字和两个按钮（左右两个按钮）
function PromptView:type2green(title,content,leftText,rightText,leftFun,rightFun,floor)
    local page = loadPage("csd/public/PromptTwoBtnLayer.csb",floor)

    --逻辑
    local leftBtn = page:getChildByName("Button_ok")
    local rightBtn = page:getChildByName("Button_cancel")
    rightBtn:loadTextures(ResIconCfg.btn_positive,ResIconCfg.btn_positivePress)
    local textTitle = page:getChildByName("Text_title")
    local textContent = page:getChildByName("Text_content")
    leftBtn:setTitleText(leftText)
    rightBtn:setTitleText(rightText)
    --textTitle:setString(title)
    textContent:setString(content)
    leftBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        if leftFun then
            leftFun()
        end
    end))
    rightBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        if rightFun then
            rightFun()
        end
    end))

    self.CurrentView = {scene=scene,page=page}
end

-- 类型3的提示：提示文字和一个按钮和一个xx按钮
function PromptView:type3(title,content,btnText,btnFun,xFunc,floor)
    local page = loadPage("",floor)

    --逻辑
    local btn = page:getChildByName("Button_ok")
    local closeBtn = page:getChildByName("Button_close")
    local textTitle = page:getChildByName("Text_title")
    local textContent = page:getChildByName("Text_content")
    textContent:setString(content)
    --textTitle:setString(title)
    btn:setTitleText(btnText)
    btn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        if btnFun then
            btnFun()
        end
    end))
    closeBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        if xFunc then
            xFunc()
        end
    end))

    self.CurrentView = {scene=scene,page=page}
end


--场景提示
function PromptView:sceneNotice(parent,content)

    local notice = parent:getChildByName("sceneNotice")
    if notice ~= nil then

    else
        notice = cc.uiload:load("res/csd/common/layer_header_notification.csb")
        notice:setName("sceneNotice")
        parent:addChild(notice)--,100)


        local node = notice:getChildByName("panel_bg"):getChildByName("panel_notification")

        node:setPositionY(70)

        local action1 = cc.MoveBy:create(0.3,cc.p(0,-70))
        local action2 = cc.DelayTime:create(1)
        local action3 = cc.MoveBy:create(0.3,cc.p(0,70))
        local action = cc.Sequence:create(action1,action2,action3,cc.CallFunc:create(function()
            notice:removeFromParent()
        end))
        node:runAction(action)

    end

    notice:getChildByName("panel_bg"):getChildByName("panel_notification"):getChildByName("text_coordinate"):setString(content)



end



--分解提示框
function PromptView:reform(data,okFunc)
    local scene = display.getRunningScene()
    local page = CCUILoader:load("csd/public/ReformLayer.csb")
    scene:addChild(page)
    local UIClose = page:getChildByName("Button_1")
    local UIOk = page:getChildByName("Button_7")
    local UISelectAll = page:getChildByName("Button_All")
    UIClose:addTouchEventListener(eventListner(ended,function() --取消
        scene:removeChild(page)
    end))
    local UIselects = {}
    for index,name in ipairs(data) do
        local item = page:getChildByName("Panel_quality_"..index)
        local itemName = item:getChildByName("Text_name")
        local itemSelect = item:getChildByName("Button_select")
        showShader:buttonToGray(itemSelect)
        itemSelect:setBright(false)
        itemName:setString(name)
        UIselects[index] = itemSelect
        item:addTouchEventListener(eventListner(ended,function()
            local bright = itemSelect:isBright()
            itemSelect:setBright(not bright)
        end))
    end
    UISelectAll:addTouchEventListener(eventListner(ended,function() --全选
        local notSelect = true
        for index,uiselect in ipairs(UIselects) do
            if not uiselect:isBright() then
                notSelect = false
                break
            end
        end
        for index,uiselect in ipairs(UIselects) do
            uiselect:setBright(not notSelect)
        end
    end))
    UIOk:addTouchEventListener(eventListner(ended,function() --确定
        local selectT = {}
        for index,uiselect in ipairs(UIselects) do
            if uiselect:isBright() then
                selectT[index] = true
            end
        end
        if okFunc(selectT) then
            scene:removeChild(page)
        end
    end))
end

-- 类型 拆除
function PromptView:inputOK(btnFun,info,xFunc,floor)
    local page = loadPage("csd/public/PromptDeleteLayer.csb",floor)
    --逻辑
    local btn_ok = page:getChildByName("btn_ok")
    local btn_close = page:getChildByName("btn_close")
    local textfield = page:getChildByName("textfield")
    textfield:setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
    textfield:setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER)
    page:getChildByName("Text_3"):setString(info)
    btn_ok:addTouchEventListener(eventListner(ended,function()
        local input = string.lower(textfield:getString())
        print("input:"..input)
        destroyLast()
        if input == "ok" then
            if btnFun then
                btnFun()
            end
        else
            FlyWordPrompt:prompt(StringRes.error_input)
        end
    end))
    btn_close:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        if xFunc then
            xFunc()
        end
    end))

    self.CurrentView = {scene=scene,page=page}
end

--消耗金币提示
function PromptView:spendGold(costGold,callBack,content)
    local own = PlayerData:getInstanse().basicData.gold
    if costGold > own then --不够
        self:goldUnenought(costGold,own)
    else
        local content = content or string.format(StringRes.complete_cost,costGold,StringRes.gold)
        self:type2(nil,content,StringRes.ok,StringRes.cancel,callBack)
    end
end

--金币不足的提示
function PromptView:goldUnenought(need,own,callback)
    local content = string.format(StringRes.gold_not_enough,need,own,need-own)
    PromptView:type2(nil,content,StringRes.ok,StringRes.cancel,
        function()
            --前往购买
            Recharge:show(gWorldScene)
        end)
end

--聊天提示
function PromptView:chat(callback,floor)
    local page = loadPage("csd/report/layer_share_report.csb",floor)

    --逻辑
    local uiPanel = page:getChildByName("panel_share_to")
    local closeBtn = uiPanel:getChildByName("btn_close")
    local worldBtn = uiPanel:getChildByName("btn_share_to_world")
    local groupBtn = uiPanel:getChildByName("btn_share_to_group") --军团

    closeBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
    end))
    worldBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        callback(1)
    end))
    groupBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
        callback(2)
    end))
    self.CurrentView = {page=page}
end

--返回函数带有输入的字符串
function PromptView:research(callback,floor)
    local page = loadPage("csd/friend/layer_friend_search.csb",floor)

    local parent = page:getChildByName("panel_mask"):getChildByName("panel_friend_search")

    local NodeTranslator = require("src/app/util/NodeTranslator")
    NodeTranslator:transUp(parent,function()

    end)

    local uiClose = parent:getChildByName("btn_delete")
    local uiResearch = parent:getChildByName("btn_search")
    local uiContent = parent:getChildByName("panel_name"):getChildByName("textfield_name")

    uiClose:addTouchEventListener(eventListner(ended,function()
        destroyLast()
    end))

    uiResearch:addTouchEventListener(eventListner(ended,function()
        callback(uiContent:getString())
        NodeTranslator:transDown(parent,function()
            destroyLast()
        end)
    end))
    self.CurrentView = {page=page}
end

--配件材料详情
function PromptView:partInfo(data,type,floor)
    local page = loadPage("csd/accessory/accessory/layer_accessory_part_info.csb",floor)

    --逻辑
    local uiPanel = page:getChildByName("panel_mask"):getChildByName("panel_bg")
    local closeBtn = uiPanel:getChildByName("btn_close")
    local uiName = uiPanel:getChildByName("text_part")
    local uiOkBtn = uiPanel:getChildByName("btn_confirm")
    local uiWay = uiPanel:getChildByName("Text_way")
    local uiDescript = uiPanel:getChildByName("text_desc")
    local uiQuality = uiPanel:getChildByName("icon_bg")
    local uiIcon = uiQuality:getChildByName("icon_part")

    closeBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
    end))
    uiOkBtn:addTouchEventListener(eventListner(ended,function()
        destroyLast()
    end))
    uiName:setString(data.name)
    uiDescript:setString(data.decript)
    uiQuality:loadTexture(data.icon,ResType)
    uiWay:setString(type==1 and StringRes.supply_line or StringRes.activity)
    uiIcon:setVisible(false)
    self.CurrentView = {page=page}
end

--type 1，确定关闭 2 空白关闭
function PromptView:reward(title,type,_t,callback,floor)
    local page = loadPage("csd/common/layer_popout_item_desc_confirm.csb",floor)

    local uiBackParent = page:getChildByName("panel_mask"):getChildByName("panel_outline")
    local uiTitle = uiBackParent:getChildByName("text_award")
    local uiOk = uiBackParent:getChildByName("btn_confirm")
    local uiList = uiBackParent:getChildByName("listview_info")
    local uiItem = uiBackParent:getChildByName("panel_desc")

    local function okFunc()
        NodeTranslator:transZoomIn(uiBackParent,function()
            page:removeFromParent()
            if callback then
                callback()
            end
        end)
    end
    local funcs = {
        function()
            uiList:setContentSize(cc.size(510,420))
            uiOk:setVisible(true)
            SpecialView:registerEvent(uiOk,ended,okFunc)
        end,
        function()
            uiList:setContentSize(cc.size(510,500))
            uiOk:setVisible(false)
            uiList:addTouchEventListener(function(e,t)
                if t == ended then
                    local  bPos = e:getTouchBeganPosition()
                    local  ePos = e:getTouchEndPosition()
                    if cc.pGetDistance(bPos,ePos) < 20 then
                        MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                        okFunc()
                    end
                end
            end)
            SpecialView:registerEvent(page:getChildByName("panel_mask"),ended,okFunc)
        end,
    }

    local PartsQualityCfg  = require("src/app/cfg/PartsQualityCfg")
    for _,info in ipairs(_t) do
        local part = parts[info.rewardId]
        local item = uiItem:clone()
        local uiQuality = item:getChildByName("icon_item")
        local uiIcon = item:getChildByName("icon_resource")
        local uiDesc = item:getChildByName("text_content")
        local quaIcon = (part.type <=4 ) and PartsQualityCfg[part.que].icon or PartsQualityCfg[part.que].pieceicon
        local desc = string.format(StringRes.search_reward_desc,part.name,info.rewardCount,info.supplies)
        Common:changePic(uiQuality,quaIcon)
        Common:changePic(uiIcon,part.icon)
        uiDesc:setString(desc)
        uiList:pushBackCustomItem(item)
    end

    uiTitle:setString(title)
    funcs[type or 1]()
    NodeTranslator:transZoomOut(uiBackParent , function() end)
end

--type 1，确定关闭 2 空白关闭
function PromptView:reward4MilitaryForum(title,type,_t,callback,floor)
    local page = loadPage("csd/common/layer_popout_item_desc_confirm.csb",floor)

    local uiBackParent = page:getChildByName("panel_mask"):getChildByName("panel_outline")
    local uiTitle = uiBackParent:getChildByName("text_award")
    local uiOk = uiBackParent:getChildByName("btn_confirm")
    local uiList = uiBackParent:getChildByName("listview_info")
    local uiItem = uiBackParent:getChildByName("panel_desc")

    local function okFunc()
        NodeTranslator:transZoomIn(uiBackParent,function()
            page:removeFromParent()
            if callback then
                callback()
            end
        end)
    end
    local funcs = {
        function()
            uiList:setContentSize(cc.size(510,420))
            uiOk:setVisible(true)
            SpecialView:registerEvent(uiOk,ended,okFunc)
        end,
        function()
            uiList:setContentSize(cc.size(510,500))
            uiOk:setVisible(false)
            uiList:addTouchEventListener(function(e,t)
                if t == ended then
                    local  bPos = e:getTouchBeganPosition()
                    local  ePos = e:getTouchEndPosition()
                    if cc.pGetDistance(bPos,ePos) < 20 then
                        MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                        okFunc()
                    end
                end
            end)
            SpecialView:registerEvent(page:getChildByName("panel_mask"),ended,okFunc)
        end,
    }
    --    {["count"] = 2,["credit"] = 8,["templateId"] = 74}
    for _,info in ipairs(_t) do
        local item = uiItem:clone()
        local uiQuality = item:getChildByName("icon_item")
        local uiIcon = item:getChildByName("icon_resource")
        local uiDesc = item:getChildByName("text_content")
        local data = gItem[info.templateId]
        uiQuality:setVisible(false)
        Common:changePic(uiIcon,data.icon)
        uiDesc:setString(string.format(StringRes.militarypulpit005,StringRes[data.name],info.count,info.credit))
        uiList:pushBackCustomItem(item)
    end

    uiTitle:setString(title)
    funcs[type or 1]()
    NodeTranslator:transZoomOut(uiBackParent , function() end)
end

-- 补给线扫荡奖励提示
-- type 1，确定关闭 2 空白关闭
function PromptView:reward4Supply(title,type,_t,callback,floor)
    local page = loadPage("csd/common/layer_popout_item_desc_confirm.csb",floor)

    local uiBackParent = page:getChildByName("panel_mask"):getChildByName("panel_outline")
    local uiTitle = uiBackParent:getChildByName("text_award")
    local uiOk = uiBackParent:getChildByName("btn_confirm")
    local uiList = uiBackParent:getChildByName("listview_info")
    local uiItem = uiBackParent:getChildByName("panel_desc")

    local function okFunc()
        NodeTranslator:transZoomIn(uiBackParent,function()
            page:removeFromParent()
            if callback then
                callback()
            end
        end)
    end
    local funcs = {
        function()
            uiList:setContentSize(cc.size(510,420))
            uiOk:setVisible(true)
            SpecialView:registerEvent(uiOk,ended,okFunc)
        end,
        function()
            uiList:setContentSize(cc.size(510,500))
            uiOk:setVisible(false)
            uiList:addTouchEventListener(function(e,t)
                if t == ended then
                    local  bPos = e:getTouchBeganPosition()
                    local  ePos = e:getTouchEndPosition()
                    if cc.pGetDistance(bPos,ePos) < 20 then
                        MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                        okFunc()
                    end
                end
            end)
            SpecialView:registerEvent(page:getChildByName("panel_mask"),ended,okFunc)
        end,
    }
    --    {["count"] = 2,["credit"] = 8,["templateId"] = 74}
    for _, info in ipairs(_t) do
        local item = uiItem:clone()
        item:getChildByName("icon_item"):hide()
        local uiIcon = item:getChildByName("icon_resource")
        Common:changePic(uiIcon, info.icon)
        local uiDesc = item:getChildByName("text_content")
        uiDesc:setString(info.text)
        uiList:pushBackCustomItem(item)
    end

    uiTitle:setString(title)
    funcs[type or 1]()
    NodeTranslator:transZoomOut(uiBackParent , function() end)
end

function PromptView:rewardRecord(type,list,floor)
    local page = loadPage("csd/common/layer_popout_item_coin.csb",floor)

    local typeNothingCfg = {StringRes.springBlessing_20,StringRes.luckyTreasure_12}
    local typeTitileCfg = {StringRes.springBlessing_26,StringRes.luckyTreasure_4}

    local uiBackParent = page:getChildByName("panel_mask"):getChildByName("panel_outline")
    local uiListBack = uiBackParent:getChildByName("panel_info")
    local uiList = uiListBack:getChildByName("listview_info")
    local uiItem = uiListBack:getChildByName("panel_desc")
    local uiNothing = uiListBack:getChildByName("text_content")
    local uiOk = uiBackParent:getChildByName("btn_confirm")

    local function okFunc()
        NodeTranslator:transZoomIn(uiBackParent,function()
            page:removeFromParent()
        end)
    end

    SpecialView:registerEvent(uiOk,ended,okFunc)

    uiNothing:setString(typeNothingCfg[type])
    uiNothing:setVisible(#list == 0)

    for index,info in ipairs(list) do
        local newItem = uiItem:clone()
        local uiTitle = newItem:getChildByName("text_content")
        local uiLeftText = newItem:getChildByName("text_desc_01")
        local uiRightText = newItem:getChildByName("text_desc_02")
        uiLeftText:setString(string.format(StringRes.springBlessing_22,info.c))
        uiRightText:setString(string.format(StringRes.springBlessing_23,info.g))
        uiTitle:setString(string.format(StringRes["number_of_times_"..index],typeTitileCfg[type]))
        uiList:pushBackCustomItem(newItem)
    end

    NodeTranslator:transZoomOut(uiBackParent , function() end)
end

function PromptView:setRewardInfo(uiRewardBack,reward)
    local uiIcon = uiRewardBack:getChildByName("icon_reward")
    local uiOutline = uiRewardBack:getChildByName("panel_outline")
    local uiNum = uiRewardBack:getChildByName("num_info")
    local uiName = uiRewardBack:getChildByName("text_name")

    uiName:setString(reward.title)
    uiNum:setString("x "..reward.count)
    if uiOutline then
        uiIcon:setVisible(true)
        Common:changePic(uiIcon,reward.icon)
        Common:changePic(uiOutline,reward.outIcon)
    else
        uiIcon:setVisible(false)
        if reward.backIcon then
            uiIcon:setVisible(true)
            Common:changePic(uiRewardBack,reward.backIcon)
            Common:changePic(uiIcon,reward.icon)
        else
            uiIcon:setVisible(false)
            Common:changePic(uiRewardBack,reward.icon)
        end
    end
end

function PromptView:showRewards(title,rewards,func,floor)
    local page = loadPage("csd/mainmap_left/activity_announcement/activity_common/layer_monthly_super.csb",floor)

    local uiBack = page:getChildByName("panel_bg")
    local uiTitle = uiBack:getChildByName("text_title")
    local uiGeneralItem = uiBack:getChildByName("panel_01")
    local uiItemItem = uiBack:getChildByName("panel_02")
    local uiList = uiBack:getChildByName("listview_item")

    uiTitle:setString(title)
    SpecialView:registerEvent(uiBack:getChildByName("btn_confirm"),ended,function()
        page:removeFromParent()
        if func then
            func()
        end
    end)

    local listWidth = uiList:getContentSize().width
    local backWidth = uiBack:getContentSize().width
    local x,y = uiList:getPosition()
    local height = uiItemItem:getContentSize().height*math.ceil(#rewards/2)
    uiList:setContentSize(cc.size(listWidth,height+20))
    uiBack:setContentSize(cc.size(backWidth,height+190))
    uiTitle:setPositionY(height+y+20)

    uiList:setColumnCount(2)
    local gifts = StringUtil.getRewardsData(rewards)
    for index,gift in ipairs(gifts) do
        local uiItem = (gift.outIcon and uiGeneralItem or uiItemItem):clone()
        self:setRewardInfo(uiItem:getChildByName("icon"),gift)
        uiList:pushBackCustomItem(uiItem)
    end
end

function PromptView:openChangeName(changeCallback,floor)
    local page = loadPage("csd/player/layer_change_name.csb",floor)

    local uiParentBack = page:getChildByName("panel_mask"):getChildByName("panel_bg")
    local uiName = uiParentBack:getChildByName("panel_outline"):getChildByName("text_input_name")
    local uiCancel = uiParentBack:getChildByName("btn_delete")
    local uiOk = uiParentBack:getChildByName("btn_positive")
    local uiDescript = uiParentBack:getChildByName("text_info")

    local count = PlayerData:getInstanse().basicData.renameCard
    uiDescript:setString(string.format(StringRes.exchangename_003,count))
    uiDescript:setColor(count>0 and CommonColor.White or CommonColor.Red)
    SpecialView:registerEvent(uiOk,ended,function()
        if count > 0 then
            local name = uiName:getString()
            if StringUtil.haveSpecialCode(name) then
                return self:type1(nil,StringRes.error_input01,StringRes.ok)
            end
            if StringUtil.getLength(name) > 16 then
                local c = PromptView:type1(nil,StringRes.name_length_limit,StringRes.ok)
                return c:setTextColor(CommonColor.Red)
            end
            if name ~= "" then
                page:removeFromParent()
                changeCallback(name)
            end
        else
            destroyLast()
            self:type2(nil,StringRes.exchangename_004,StringRes.cancel,StringRes.ok,nil,function()
                Recharge:show(gWorldScene)
            end)
        end
    end)

    SpecialView:registerEvent(uiCancel,ended,function()
        page:removeFromParent()
    end)

    self.CurrentView = {page=page}
end

return PromptView