local DialogUtil = require("src.app.util.DialogUtil")

ResNeedPopInfo = {}

function ResNeedPopInfo:show(parent,data)
    local cont = CCUILoader:load("res/csd/public/ResNeedPopInfo.csb")
    --local cont = content:getChildByName("Image_1")
    Common:layerCenter(cont)
    cont.removable = false
    require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
        cont.removable = true
    end)
    DialogUtil:addClickEvent2(cont,function()
        if cont.removable then
            require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
                cont:removeFromParent()
            end)
        end
    end)
    parent:addChild(cont)
    
    local listView = cont:getChildByName("Image_bg"):getChildByName("ListView_1")
    listView.tagData = data
    self:updateAllView(cont,parent)
    
end

function ResNeedPopInfo:updateAllView(cont,parent)

    local listView = cont:getChildByName("Image_bg"):getChildByName("ListView_1")
    local data = listView.tagData
    --刷新所需资源
    local templateId = data.templateId
    local upgradeLv= data.buildLv+1
    
    if Buildings:CheckUpgrade(templateId,data.buildLv) == 3 then --最高等级
        cont:getChildByName("Image_bg"):getChildByName("ProjectNode_Title"):setVisible(false)
        cont:getChildByName("Image_bg"):getChildByName("ListView_1"):setVisible(false)
        cont:getChildByName("Image_bg"):getChildByName("text_max_lv"):setVisible(true)
        return
    else
        cont:getChildByName("Image_bg"):getChildByName("ProjectNode_Title"):setVisible(true)
        cont:getChildByName("Image_bg"):getChildByName("ListView_1"):setVisible(true)
        cont:getChildByName("Image_bg"):getChildByName("text_max_lv"):setVisible(false)
    end
    
    local item = CCUILoader:load("res/csd/public/ResNeedItem.csb"):getChildByName("content")
    local pd = PlayerData:getInstanse()

    local tempId = templateId.."_"..upgradeLv

    listView:removeAllItems()
    --指挥中心
    local temp={}

    if templateId ~= 1 then
        temp.icon = nil
        temp.name = StringRes.Building_Name_1
        temp.require = upgradeLv
        temp.own = pd:getBaseBuildLv(1)
        local lvItem1 = item:clone()
        self:refreshResItem(cont,lvItem1,temp,parent)
    end

    temp={}
    temp.icon = ResIconCfg.ferrum
    temp.name = StringRes.iron_ore
    temp.require = gBuilding_Consumption[tempId].fe
    temp.own = pd.basicData.ferrum
    local lvItem2 = item:clone()
    lvItem2.tagId = 2
    self:refreshResItem(cont,lvItem2,temp,parent)

    temp={}
    temp.icon = ResIconCfg.oil
    temp.name = StringRes.oil
    temp.require = gBuilding_Consumption[tempId].oil
    temp.own = pd.basicData.oil
    local lvItem3 = item:clone()
    lvItem3.tagId = 3
    self:refreshResItem(cont,lvItem3,temp,parent)

    temp={}
    temp.icon = ResIconCfg.lead
    temp.name = StringRes.vanadium
    temp.require = gBuilding_Consumption[tempId].lead
    temp.own = pd.basicData.lead
    --temp.own = 1
    local lvItem4 = item:clone()
    lvItem4.tagId = 4
    self:refreshResItem(cont,lvItem4,temp,parent)
end

function ResNeedPopInfo:refreshResItem(cont,item,data,parent)
        local listView = cont:getChildByName("Image_bg"):getChildByName("ListView_1")
        listView:pushBackCustomItem(item)
        local iIcon = item:getChildByName("Image_1")
        local iName = item:getChildByName("category")
        local iRequire = item:getChildByName("require")
        local iCheck = item:getChildByName("Image_8")
        local iOwn = item:getChildByName("own")
        local iMore = item:getChildByName("more")
        if data.icon then
            iIcon:loadTexture(data.icon,ResType)
            iRequire:setString(StringTemp:toNum(data.require))
            iOwn:setString(StringTemp:toNum(data.own))
        else
            iIcon:setVisible(false)
            iRequire:setString(string.format(StringRes.LV2,data.require))
            iOwn:setString(string.format(StringRes.LV2,data.own))
        end
        iName:setString(data.name)
        if data.require > data.own then
            --资源不足
            iCheck:loadTexture(ICON_FALT,ResType)
            if data.icon then
                iMore:setVisible(true)
                iMore:addTouchEventListener(function(e, t)
                    if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                        MoreRes:show(parent,item.tagId,function() self:updateAllView(cont,parent) end)
                    end
                end)
            end
        end
    end

return ResNeedPopInfo