local DialogUtil = require("src.app.util.DialogUtil")

TankInfoPanel = {}

function TankInfoPanel:show(parent,id)
    local content = CCUILoader:load("res/csd/public/TankInfoPanel.csb")
    local cont = content:getChildByName("content")
    local listview = cont:getChildByName("listview_info")
    local panel_01 = cont:getChildByName("panel_01")
    local panel_02 = cont:getChildByName("panel_02")
    local panel_03 = cont:getChildByName("panel_03")
    listview:setSwallowTouches(false)

    local pd = PlayerData:getInstanse()
    local addAttrs = pd.warUnitAddAttrs
    local tank = Tank[id]
    panel_01:retain()
    panel_01:removeFromParent()
    listview:pushBackCustomItem(panel_01)
    panel_01:release()
    if tank.skillid and gTankskill[tank.skillid] then --是否有技能
        panel_02:retain()
        panel_02:removeFromParent()
        
        local size = panel_02:getContentSize()
        local lvSize = listview:getContentSize()
        listview:setContentSize(lvSize.width,lvSize.height+size.height)
        local contSize = cont:getContentSize()
        cont:setContentSize(contSize.width,contSize.height+size.height)
        
        local tmp = gTankskill[tank.skillid]
        local icon_item = panel_02:getChildByName("icon_item")
        local text_name = panel_02:getChildByName("text_name")
        local text_level = panel_02:getChildByName("text_level")
        local text_info = panel_02:getChildByName("text_info")
        Common:changePic(icon_item,tmp.skillicon)
        text_name:setString(tmp.skillname)
        text_level:setString(string.format(StringRes.army_group_lv,tmp.lv))
        AcademyCommon:nodesFormatX({text_name,text_level},10)
        text_info:setString(tmp.skilldes)
        listview:pushBackCustomItem(panel_02)
        panel_02:release()
    end
    panel_03:retain()
    panel_03:removeFromParent()
    listview:pushBackCustomItem(panel_03)
    panel_03:release()
    local icon = panel_01:getChildByName("icon")
    icon:loadTexture(tank.icon,ResType)

    local title = panel_01:getChildByName("title")
    Common:setUnitTitleColor(title,tank)
    title:setString(StringRes[tank.name])

    local num = panel_01:getChildByName("icon_item_01"):getChildByName("text_num")
    num:setString(pd:getUnitCountById(id))
    panel_01:getChildByName("icon_item_02"):setVisible(false)

    local info = panel_01:getChildByName("info")
    info:setString(string.format(StringRes[tank.dec],tank.load))

    local num_atk = panel_03:getChildByName("num_atk")
    local tmpAddAtk = string.format("%0.2f",tank.atk*addAttrs[tank.type].addAtk)
    SpecialView:addRichTextDefault(num_atk,tank.atk,"+"..tmpAddAtk)

    local text_atkType = panel_03:getChildByName("text_atkType")
    text_atkType:setString(StringRes["attacktype_"..tank.type])

    panel_03:getChildByName("iAtkType"):loadTexture("res/pic/common/icon/tank/btn_tank_attribute_"..(tank.type+1)..".png",ResType)

    local num_life = panel_03:getChildByName("num_life")
    local tmpAddHp = string.format("%0.2f",tank.hp*addAttrs[tank.type].addHp)
    SpecialView:addRichTextDefault(num_life,tank.hp,"+"..tmpAddHp)

    local num_hit = panel_03:getChildByName("num_hit")
    SpecialView:addRichTextDefault(num_hit,tank.hit.."%","+"..(string.format("%0.2f",addAttrs[tank.type].addHit*100)).."%")

    local num_dodge = panel_03:getChildByName("num_dodge")
    SpecialView:addRichTextDefault(num_dodge,tank.dodge.."%","+"..(string.format("%0.2f",addAttrs[tank.type].addDodge*100)).."%")

    local num_crit = panel_03:getChildByName("num_crit")
    SpecialView:addRichTextDefault(num_crit,tank.crit.."%","+"..(string.format("%0.2f",addAttrs[tank.type].addCrit*100)).."%")

    local num_armor = panel_03:getChildByName("num_armor")
    SpecialView:addRichTextDefault(num_armor,tank.armor.."%","+"..(string.format("%0.2f",addAttrs[tank.type].addArmor*100)).."%")

    local num_pierce = panel_03:getChildByName("num_pierce")
    SpecialView:addRichTextDefault(num_pierce,"",(string.format("%0.2f",addAttrs[tank.type].addPierce*100)).."%")

    local num_def = panel_03:getChildByName("num_def")
    SpecialView:addRichTextDefault(num_def,"",(string.format("%0.2f",addAttrs[tank.type].addDef*100)).."%")

    local num_critAtk = panel_03:getChildByName("num_critAtk")
    SpecialView:addRichTextDefault(num_critAtk,"",(string.format("%0.2f",addAttrs[tank.type].addCritAtk*100)).."%")

    local num_tenacity = panel_03:getChildByName("num_tenacity")
    SpecialView:addRichTextDefault(num_tenacity,"",(string.format("%0.2f",addAttrs[tank.type].addTenacity*100)).."%")


    cont.removable = false
    require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
        cont.removable = true
    end)
    DialogUtil:addClickEvent2(content,function()
        if cont.removable then
            require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
                content:removeFromParent()
            end)
        end
    end)
    parent:addChild(content)
end

return TankInfoPanel