local DialogUtil = require("src.app.util.DialogUtil")
local TaskInfo = require("src/app/views/task/TaskInfo")
TaskReward = {}

function TaskReward:show(parent,data)
    local content = CCUILoader:load("res/csd/public/TaskReward.csb")
    local cont = content:getChildByName("Image_1")
    
    cont.removable = false
    require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
        cont.removable = true
    end)
    DialogUtil:addClickEvent2(content,function()
        if cont.removable then
            require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
                    content:removeFromParent()
            end)
        end
    end)
    parent:addChild(content)
    
    
    
    
    
    --
    
    
    
    --重新布局
    
    local oneHeight = 130
    
    
    local taskInfo = gTask[data.taskId]
    
    local height = 0
    
    
    local desc = cont:getChildByName("Text_1")
    if taskInfo.type == 3 then
        local num = StringTemp:Split(taskInfo.cond,":")
        num = tonumber( num[2])

        --标题
        --描述
        
        desc:setString( string.format( StringRes[taskInfo.desc] ,num ))
    else
        --坦克名字
        local tankName = StringTemp:strtoTable(taskInfo.cond)
        if tankName.id ~= nil then
            --标题
            desc:setString( string.format( StringRes[taskInfo.desc],StringRes[Tank[tankName.id].name]))
        else
            --描述
            desc:setString( StringRes[taskInfo.desc])
        end

    end
    
    
    
    height = height+desc:getContentSize().height
    
    --进度
    --进度
    if data.state ~= 0 then
        cont:getChildByName("Text_2"):setString(StringRes.task_finish)
    else
        --进度
        cont:getChildByName("Text_2"):setString( 
            string.format(StringRes[gTask[data.taskId].pro],TaskInfo:currentProduce(data) )  )
    end
    
    local rewardkey = {"exp","prestige","medal","ferrum","oil","lead","titan","crystal","tank"}
    
    
    
    
    local p1 = cont:getChildByName("Panel_1")
    local p2 = cont:getChildByName("Panel_2")
    p1:setVisible(false)
    p2:setVisible(false)
    
    --提取真实奖励
    local rewardCount = 0
    local realReward = {}--真实奖励
    for i,v in pairs(rewardkey) do
        if type(taskInfo.reward[v]) == "string" then
            local t = StringTemp:Split(taskInfo.reward[v],",")
            local len = #t
            if len >= 2 then
                rewardCount = rewardCount+1
                table.insert(realReward,rewardCount,v)
            end
    	else
           if taskInfo.reward[v] > 0 then
                rewardCount = rewardCount+1
                table.insert(realReward,rewardCount,v)
    	   end
    	end
    end
    
    if rewardCount > 2 then
        
        local pos = {x = 0,y = 0}
        --添加奖励图标
        local p3 = p1:clone()
        p3:setName("Panel_3")
        pos.x,pos.y = p3:getPosition()
        pos.y = pos.y-oneHeight
        p3:setPosition(pos)
        cont:addChild(p3)
        local p4 = p2:clone()
        p4:setName("Panel_4")
        pos.x,pos.y = p4:getPosition()
        pos.y = pos.y-oneHeight
        p4:setPosition(pos)
        cont:addChild(p4)
    	--调整高度
    	local cs = cont:getContentSize()
        cs.height = cs.height + oneHeight
        cont:setContentSize(cs)
        
        --调整坐标
        local children = cont:getChildren()
        for i,v in pairs(children) do
            pos.x,pos.y = v:getPosition()
            pos.y = pos.y + oneHeight
            v:setPosition(pos)
        end
        
    end
    
    --设置奖励显示
    for i,v in pairs(realReward) do
        local rewardobj = taskInfo.reward[v]
        
        local panelView = "Panel_"..i
        panelView = cont:getChildByName(panelView)
        panelView:setVisible(true)
        
        if type(rewardobj) == "string" then
            if string.len(rewardobj) > 0 then
                local t = StringTemp:Split(rewardobj,",")
                local type = 1--tonumber(StringTemp:Split(t[1],":")[2])
                local id = tonumber(StringTemp:Split(t[1],":")[2])
                local count = tonumber(StringTemp:Split(t[2],":")[2])
                --坦克
                if type == 1 then
                    local icon = panelView:getChildByName("Image_4")
                    Common:changePic(icon,Tank[tonumber(id)].icon)
                    --icon:loadTexture(Tank[tonumber(id)].icon,ResType)
                    local name = panelView:getChildByName("Text_5")
                    name:setString(StringRes[Tank[id].name])
                    local num = panelView:getChildByName("Text_6")
                    num:setString(""..count)
                end   
            end
           
        else
            
            if v == "titan" then
                local icon = panelView:getChildByName("Image_4")
                Common:changePic(icon,ResIconCfg["titanium"])
                --icon:loadTexture(ResIconCfg["titanium"],ResType)
                local name = panelView:getChildByName("Text_5")
                name:setString(StringRes["titanium"])
            elseif v == "medal" then
                local icon = panelView:getChildByName("Image_4")
                Common:changePic(icon,ResIconCfg["medal"])
                --icon:loadTexture(ResIconCfg["medal"],ResType)
                local name = panelView:getChildByName("Text_5")
                name:setString(StringRes["Item_Name_42"])
            else
                local icon = panelView:getChildByName("Image_4")
                Common:changePic(icon,ResIconCfg[v])
                --icon:loadTexture(ResIconCfg[v],ResType)
                local name = panelView:getChildByName("Text_5")
                name:setString(StringRes[v])
            end
        
        
            
            local num = panelView:getChildByName("Text_6")
            num:setString(""..rewardobj)
        end
    end
    
    
end



--日常任务信息显示
function TaskReward:showDaily(parent,data)
    local content = CCUILoader:load("res/csd/public/TaskReward.csb")
    local cont = content:getChildByName("Image_1")

    cont.removable = false
    require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
        cont.removable = true
    end)
    DialogUtil:addClickEvent2(content,function()
        if cont.removable then
            require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
                content:removeFromParent()
            end)
        end
    end)
    parent:addChild(content)





    --



    --重新布局

    local oneHeight = 130


    local taskInfo = gDailyTask[data.id]

    local height = 0


    local desc = cont:getChildByName("Text_1")
    --    if taskInfo.type == 3 then
    --        local num = StringTemp:Split(taskInfo.cond,":")
    --        num = tonumber( num[2])
    --
    --        --标题
    --        --描述
    --
    --        desc:setString( string.format( StringRes[taskInfo.desc] ,num ))
    --    else
    --描述
    desc:setString( StringRes[taskInfo.desc])

    --end



    height = height+desc:getContentSize().height

    --进度
    --进度
    if data.state ~= 0 then
        cont:getChildByName("Text_2"):setString(StringRes.task_over)
    else
        --进度
        cont:getChildByName("Text_2"):setString(StringRes.task_jindu..data.count.."/"..data.allCount )
    end

    local rewardkey = {"exp","prestige","medal","ferrum","oil","lead","titan","crystal","item"}




    local p1 = cont:getChildByName("Panel_1")
    local p2 = cont:getChildByName("Panel_2")
    p1:setVisible(false)
    p2:setVisible(false)

    --提取真实奖励
    local rewardCount = 0
    local realReward = {}--真实奖励
    for i,v in pairs(rewardkey) do
        if type(taskInfo.reward[v]) == "string" then
            local t = StringTemp:Split(taskInfo.reward[v],":")
            --local len = #t
            if tonumber(t[1]) ~= 0 then
                rewardCount = rewardCount+1
                table.insert(realReward,rewardCount,v)
            end
        else
            if taskInfo.reward[v] > 0 then
                rewardCount = rewardCount+1
                table.insert(realReward,rewardCount,v)
            end
        end
    end

    if rewardCount > 2 then

        local pos = {x = 0,y = 0}
        --添加奖励图标
        local p3 = p1:clone()
        p3:setName("Panel_3")
        pos.x,pos.y = p3:getPosition()
        pos.y = pos.y-oneHeight
        p3:setPosition(pos)
        cont:addChild(p3)
        local p4 = p2:clone()
        p4:setName("Panel_4")
        pos.x,pos.y = p4:getPosition()
        pos.y = pos.y-oneHeight
        p4:setPosition(pos)
        cont:addChild(p4)
        --调整高度
        local cs = cont:getContentSize()
        cs.height = cs.height + oneHeight
        cont:setContentSize(cs)

        --调整坐标
        local children = cont:getChildren()
        for i,v in pairs(children) do
            pos.x,pos.y = v:getPosition()
            pos.y = pos.y + oneHeight
            v:setPosition(pos)
        end

    end

    --设置奖励显示
    for i,v in pairs(realReward) do
        local rewardobj = taskInfo.reward[v]

        local panelView = "Panel_"..i
        panelView = cont:getChildByName(panelView)
        panelView:setVisible(true)

        if type(rewardobj) == "string" then
        
            local t = StringTemp:Split(rewardobj,":")
            local id = t[1]
            local count = t[2]
            if string.len(rewardobj) > 0 and tonumber(id) ~= 0 then
                
                
                --坦克
                --if type == 1 then
                local icon = panelView:getChildByName("Image_4")
                Common:changePic(icon,gItem[tonumber(id)].icon)
                --icon:loadTexture(gItem[tonumber(id)].icon,ResType)
                local name = panelView:getChildByName("Text_5")
                name:setString(StringRes[gItem[tonumber(id)].name])
                local num = panelView:getChildByName("Text_6")
                num:setString(""..count)
                --end   
            end

        else

            if v == "titan" then
                local icon = panelView:getChildByName("Image_4")
                Common:changePic(icon,ResIconCfg["titanium"])
                --icon:loadTexture(ResIconCfg["titanium"],ResType)
                local name = panelView:getChildByName("Text_5")
                name:setString(StringRes["titanium"])
            elseif v == "medal" then
                local icon = panelView:getChildByName("Image_4")
                Common:changePic(icon,ResIconCfg["medal"])
                --icon:loadTexture(ResIconCfg["medal"],ResType)
                local name = panelView:getChildByName("Text_5")
                name:setString(StringRes["Item_Name_42"])
            else
                local icon = panelView:getChildByName("Image_4")
                Common:changePic(icon,ResIconCfg[v])
                --icon:loadTexture(ResIconCfg[v],ResType)
                local name = panelView:getChildByName("Text_5")
                name:setString(StringRes[v])
            end



            local num = panelView:getChildByName("Text_6")
            num:setString(""..rewardobj)
        end
    end


end


--日常任务信息显示
function TaskReward:showBigDaily(parent,data)
    local content = CCUILoader:load("res/csd/public/TaskReward.csb")
    local cont = content:getChildByName("Image_1")

    cont.removable = false
    require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
        cont.removable = true
    end)
    DialogUtil:addClickEvent2(content,function()
        if cont.removable then
            require("src/app/util/NodeTranslator"):transZoomOut(cont,function()
                content:removeFromParent()
            end)
        end
    end)
    parent:addChild(content)





    --



    --重新布局

    local oneHeight = 130


    local taskInfo = gDailyReward[data.rewardId]

    local height = 0


    local desc = cont:getChildByName("Text_1")
    --    if taskInfo.type == 3 then
    --        local num = StringTemp:Split(taskInfo.cond,":")
    --        num = tonumber( num[2])
    --
    --        --标题
    --        --描述
    --
    --        desc:setString( string.format( StringRes[taskInfo.desc] ,num ))
    --    else
    --描述
    desc:setString( StringRes[taskInfo.desc])

    --end



    height = height+desc:getContentSize().height

    --进度
    --进度
    if data.state ~= 0 then
        cont:getChildByName("Text_2"):setString(StringRes.task_finish)
    else
        --进度
        cont:getChildByName("Text_2"):setString(StringRes.task_jindu..data.rewardCount.."/"..data.allCount )
    end

    local rewardkey = {"exp","guildcap","prestige","medal","ferrum","oil","lead","titan","crystal","item"}




    local p1 = cont:getChildByName("Panel_1")
    local p2 = cont:getChildByName("Panel_2")
    p1:setVisible(false)
    p2:setVisible(false)

    --提取真实奖励
    local rewardCount = 0
    local realReward = {}--真实奖励
    for i,v in pairs(rewardkey) do
        if type(taskInfo.reward[v]) == "string" then
            local t = StringTemp:Split(taskInfo.reward[v],":")
            --local len = #t
            if tonumber(t[1]) ~= 0 then
                rewardCount = rewardCount+1
                table.insert(realReward,rewardCount,v)
            end
        else
            if taskInfo.reward[v] > 0 then
                rewardCount = rewardCount+1
                table.insert(realReward,rewardCount,v)
            end
        end
    end

    if rewardCount > 2 then

        local pos = {x = 0,y = 0}
        --添加奖励图标
        local p3 = p1:clone()
        p3:setName("Panel_3")
        pos.x,pos.y = p3:getPosition()
        pos.y = pos.y-oneHeight
        p3:setPosition(pos)
        cont:addChild(p3)
        local p4 = p2:clone()
        p4:setName("Panel_4")
        pos.x,pos.y = p4:getPosition()
        pos.y = pos.y-oneHeight
        p4:setPosition(pos)
        cont:addChild(p4)
        --调整高度
        local cs = cont:getContentSize()
        cs.height = cs.height + oneHeight
        cont:setContentSize(cs)

        --调整坐标
        local children = cont:getChildren()
        for i,v in pairs(children) do
            pos.x,pos.y = v:getPosition()
            pos.y = pos.y + oneHeight
            v:setPosition(pos)
        end

    end

    --设置奖励显示
    for i,v in pairs(realReward) do
        local rewardobj = taskInfo.reward[v]

        local panelView = "Panel_"..i
        panelView = cont:getChildByName(panelView)
        panelView:setVisible(true)

        if type(rewardobj) == "string" then

            local t = StringTemp:Split(rewardobj,":")
            local id = t[1]
            local count = t[2]
            if string.len(rewardobj) > 0 and tonumber(id) ~= 0 then


                --坦克
                --if type == 1 then
                local icon = panelView:getChildByName("Image_4")
                icon:loadTexture(gItem[tonumber(id)].icon,ResType)
                local name = panelView:getChildByName("Text_5")
                name:setString(StringRes[gItem[tonumber(id)].name])
                local num = panelView:getChildByName("Text_6")
                num:setString(""..count)
                --end   
            end

        else

            if v == "titan" then
                local icon = panelView:getChildByName("Image_4")
                Common:changePic(icon,ResIconCfg["titanium"])
                --icon:loadTexture(ResIconCfg["titanium"],ResType)
                local name = panelView:getChildByName("Text_5")
                name:setString(StringRes["titanium"])
            elseif v == "medal" then
                local icon = panelView:getChildByName("Image_4")
                Common:changePic(icon,ResIconCfg["medal"])
                --icon:loadTexture(ResIconCfg["medal"],ResType)
                local name = panelView:getChildByName("Text_5")
                name:setString(StringRes["Item_Name_42"])
            else
                local icon = panelView:getChildByName("Image_4")
                Common:changePic(icon,ResIconCfg[v])
                --icon:loadTexture(ResIconCfg[v],ResType)
                local name = panelView:getChildByName("Text_5")
                name:setString(StringRes[v])
            end



            local num = panelView:getChildByName("Text_6")
            num:setString(""..rewardobj)
        end
    end


end




return TaskReward