
SpecialView = {}

function SpecialView:addRichTextDefault(node,str1,str2)
    if node.setString then node:setString("") end
    local temp={{{str=str1,color=CommonColor.White,size=20},{str=str2,color=CommonColor.Green,size=20}}}
    self:addRichText(node,temp)
end

--_t={{{str="12",color=CommonColor.White,size=24},{str="12",color=CommonColor.White,size=24}}}
function SpecialView:addRichText(node,_t,interval)--间隔
    interval = interval or 0
    node:removeAllChildren()
    local pos = 0
    local width = node:getContentSize().width
    --    local Text = ccui.Text:create()
    --    Text:ignoreContentAdaptWithSize(false)
    --    Text:setContentSize(width,300)
    local curInterval = 0
    local fontName = (cc.Application:getInstance():getCurrentLanguage() == 1) and "" or "fonts/arial.ttf"
    for index=#_t,1,-1 do
        local info = _t[index]
        --for index,info in ipairs(_t) do
        local RichText = ccui.RichText:create()
        RichText:ignoreContentAdaptWithSize(false)
        RichText:setContentSize(cc.size(width,10))
        --        local str,maxFontSize,elements = "",0,{}
        for k,v in ipairs(info) do
            if v.type == "image" then

                local t = ccui.RichElementImage:create(1,v.color,255,v.str)
                RichText:pushBackElement(t)
            elseif v.type == "node" then
                local t = ccui.RichElementCustomNode:create(1,v.color,255,v.str)
                RichText:pushBackElement(t)
            else
                local t = ccui.RichElementText:create(k,v.color,255,v.str, fontName,v.size)
                RichText:pushBackElement(t)
            end

            --            table.insert(elements,t)
            --            maxFontSize = (v.size > maxFontSize) and v.size or maxFontSize
            --            str = str..v.str
        end

        if info.gravity ~= nil then
            RichText:setGravity(info.gravity)
        end

        RichText:formatText()
        local size = RichText:getContentSize()
        print("------RichTextContentSize-----",size.width,size.height)
--        pos = pos + size.height/2
        RichText:setPosition(width/2,pos+7)
        local p = RichText:getAnchorPoint()

        print("-------------RichTextPosition--------",width/2,pos,p.x,p.y)
        curInterval = (info.intervalEnabled and 0 or interval)
        pos = pos + size.height + curInterval
        --        Text:setFontSize(maxFontSize)
        --        local height = 0
        --        for k in string.gmatch(str.."\n","(.-)\n") do
        --            Text:setString(k)
        --            local tS = Text:getVirtualRendererSize()
        --            height = height + tS.height*math.ceil(tS.width/width)
        --        end
        --        local size = cc.size(width,height)
        --        RichText:setContentSize(size)
        --        pos = pos + size.height/2
        --        RichText:setPosition(width/2,pos)
        --        curInterval = (info.intervalEnabled and 0 or interval)
        --        pos = pos + size.height/2 + curInterval
        --        for _,t in ipairs(elements) do
        --            RichText:pushBackElement(t)
        --        end
        node:addChild(RichText)
    end
    node:setContentSize(width,pos-curInterval)
end

--按钮禁用设置
function SpecialView:setEnabled(btn,enable,needNotHandle)
    if not needNotHandle and  not enable then showShader:buttonToGray(btn) end
    btn:setBright(enable)
    btn:setEnabled(enable)
    btn:setTouchEnabled(enable)
end

--注册ui事件
function SpecialView:registerEvent(node,event,func)
    local function touchListener(e,t)
        if t == event then
            if event == ccui.TouchEventType.ended then
                MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            end
            func(e,t)
        end
    end
    node:addTouchEventListener(touchListener)
end

--_t = {{type=1,content="显示文字内容或者图片地址",color="Red",size=24,func=function() end}} 一个RichText（会自动换行）
function SpecialView:createRichText(_t)
    local ui = ccui.RichText:create()
    for index,info in ipairs(_t) do
        local e = nil
        local color = CommonColor[info.color] or CommonColor.White
        if info.type==1 then
            e = ccui.RichElementText:create(index,color,255,info.content,"fonts/arial",info.size or 24)
        else
            e = ccui.RichElementImage:create(index,color,255,info.content)
        end
        ui:pushBackElement(e)
    end
    ui:setTouchEnabled(true)
    return ui
end

return SpecialView