

local Scheduler = cc.Director:getInstance():getScheduler()
local timeKey = nil
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local TextPromptView = class("TextPromptView",function() 
    return display.newLayer()
end)

--1 为公告，2为用户协议
function TextPromptView:ctor(parent,type,str)
    self.MainPage = CCUILoader:load("updatecsd/layer_popout_announcement.csb")
    self:addChild(self.MainPage)
    
    self.UIBack = self.MainPage:getChildByName("panel_mask"):getChildByName("panel_bg")
    self.UIList = self.UIBack:getChildByName("listview_announcement")
    self.UITitle = self.UIBack:getChildByName("title_announcement")
    self.UIText = self.UIBack:getChildByName("text_announcement")
    self.UIOk = self.UIBack:getChildByName("btn_confirm")
    
    self.UIOk:addTouchEventListener(eventListner(ended,function()  
        self:close()
    end))
    
    self:setTitileInfo(type)
    self:setTextInfo(str)
end

function TextPromptView:setTitileInfo(type)
    self.UITitle:setString(StringRes["text_prompt_"..type])
end

function TextPromptView:endTime()
    if timeKey then
        Scheduler:unscheduleScriptEntry(timeKey)
        timeKey = nil
    end
end

--根据自身大小设置长度
function TextPromptView:setTextInfo(str)
    self:endTime()
    local maxWidth = self.UIText:getContentSize().width
    self.UIText:setTextAreaSize(cc.size(maxWidth,0))
    local strTable = StringTemp:toTempEnter(str.."\n")
    local pos,perCount = 0,11
    local function timeHandle()
        local maxCount = (pos+perCount > #strTable) and #strTable or (pos+perCount)
        local _t = {}
        local ui_text = self.UIText:clone()
        for i=pos+1,maxCount do
            local s = strTable[i]
            table.insert(_t,{{str=(s=="" and " " or s),color=CommonColor.White,size=24}})
        end
        SpecialView:addRichText(ui_text,_t,nil)
        self.UIList:pushBackCustomItem(ui_text)
--            local ui_text = self.UIText:clone()
--            local _t = {{{}}}
--            if s == "" then
--                s = " "
--            end
--            ui_text:setString(s)
--            local size = ui_text:getVirtualRendererSize()
--            ui_text:setContentSize(size)
--            self.UIList:pushBackCustomItem(ui_text)
--        end
        pos = maxCount
        if pos == #strTable then
            self:endTime()
            return false
        end
        return true
    end
    if timeHandle() then
        timeKey = Scheduler:scheduleScriptFunc(timeHandle, 0.05, false)
    end
end

function TextPromptView:close()
    self:endTime()
    self:removeFromParent()
end

function TextPromptView:open(parent,type,str)
    local newpage = self.new(parent,type,str)
    parent:addChild(newpage)
end

return TextPromptView