
local ScienceCenterView = class("ScienceCenterView",function(scene,data)
    local title = StringRes.Building_Name_5..string.format(StringRes.LV,data.buildLv)
    return PanelTabLayer.new(scene,{title=title,
        tabs={StringRes.build,StringRes.study}})
end)

function ScienceCenterView:ctor(scene,vo)
    self.Labels = {
        BuildView.new(scene,vo),
        PublicViews.ScienceStudyView.new(self,vo)
    }
    for i=1,2 do
        self:addChild(self.Labels[i])
        self:registerTabEvent(i,function()
            self:selectLabel(i)
        end)
    end
    self:registerTabEvent("close",function(parent)
        self:closeCallBack(parent)
    end)
    
    self.SwitchSelectLabel = {
        function()
--            self.Labels[1]:update()
        end,
        function()
--            self.Labels[2]:update()
            self.Labels[2]:doSelect()
        end
    }
end

function ScienceCenterView:selectLabel(flag)
    for index,label in ipairs(self.Labels) do
        label:setVisible(index==flag)
    end
    self.SwitchSelectLabel[flag]()
end

function ScienceCenterView:closeCallBack(parent)
    for k, v in ipairs(self.Labels) do
        if v.destroy then
            v:destroy()
        end
    end
end

function ScienceCenterView:open(scene,vo,label)
    local newPage = self.new(scene,vo)
    newPage:setTabSelect(label or 1)
    scene:addChild(newPage)
end

function ScienceCenterView:limitOpen(scene,label)
    local vo = PlayerData:getInstanse():getBaseBuildMaxLvData(5)
    if vo.buildLv == 0 then
        label = 1
    end
    self:open(scene,vo,label)
end

return ScienceCenterView