
local TimeSches = {}
local ScienceStudyCfg = require("src/app/cfg/ScienceStudyCfg")
local Scheduler = cc.Director:getInstance():getScheduler()
local ended = ccui.TouchEventType.ended
local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local function setButtonEnabled(button,enable)
    button:setBright(enable)
    button:setEnabled(enable)
    button:setTouchEnabled(enable)
end

local function findTableMsg(_t,value,key)
    for k,v in pairs(_t) do
        if value == v[key] then
            return k,v
        end
    end
end

local function getResId(type)
    local id = 0
	if type == "crystal" then
	   id = 10
	elseif type == "ferrum" then
        id = 14
    elseif type == "oil" then
        id = 15
    elseif type == "lead" then
        id = 16
    elseif type == "titanium" then
        id = 17
	end
	return id
end

--科技升到某级需要的条件
local function getLevelInfo(typeInfo,level)
    local cost = {}
    table.insert(cost,{type="5",count=(typeInfo.unlock>level) and typeInfo.unlock or level })
    table.insert(cost,{type="prestige",count=level }) --typeInfo.unlock})
    for k,v in ipairs(typeInfo.cost) do
        if v.count > 0 then
            table.insert(cost,{type=v.type,count=math.ceil(gDataResourse[level][getResId(v.type)]*(1+level*0.05)*(level*0.15)*v.count)})
        end
    end
    local pd = PlayerData:getInstanse()
    local techAdd = pd.PlayerAddition.techAdd
    local buildLv = pd:getBaseBuildLv(5)
    local allTime = math.pow(level,1.5)*typeInfo.time*180
    return {time=math.ceil(allTime/(buildLv*0.05+1+techAdd)),cost=cost}
end

------------------------------------------------
--时间管理
--
local noRemainTime = nil

local function endTimes()
    for k,v in pairs(TimeSches) do
        Scheduler:unscheduleScriptEntry(v)
    end
    TimeSches = {}
end

local function updateScheduler(object,callback)
    if object and object.update then
        object:update()
    else
        endTimes()
        Singleton:get("TechnologyAction","getTechnologyList",function(data)
            local studing = {}
            for _, info in ipairs(data.techs) do
                if info.state == 1 then
                    table.insert(studing,info)
                    TimeSches[info.type] = Scheduler:scheduleScriptFunc(function(dt)
                        info.remainTime = info.remainTime - dt
                        if info.remainTime <=0 then
                            noRemainTime(object,ScienceStudyCfg[info.type],info)
                        end
                    end,1,false)
                end
            end
            if callback then
                callback(studing)
            end
        end)
    end
end

---剩余时间为0时的统一操作
noRemainTime =  function(object,info,serverInfo)--info 本地配置，服务器发过来的数据
    endTimes()
    Connect:sendMsg("TechnologyAction","getTechnologyList",nil,function(data)
        --提示完成
        FlyWordPrompt:prompt(string.format(StringRes.study_complete,StringRes[info.name]))
        Singleton:set("TechnologyAction","getTechnologyList",data)
        updateScheduler(object)
    end,true)
end
--------------------------------

local ScienceStudyView = class("ScienceStudyView",function() 
    return display.newLayer()
end)

function ScienceStudyView:ctor(parent,data)
    self:addChild(self.MainPage)
    
    self.IsStudingInfo = nil -- = {} --所有列表
    self.buildLv = data.buildLv
    self.data = data
    
    self:update()
    
    local function onNodeEvent(tag)
        if tag == "exit" then
            endTimes()
            Singleton:setFromServer("TechnologyAction","getTechnologyList")
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

--正在研究
function ScienceStudyView:setStudingItem(msg,info) --info是服务器数据
    local item = self.UIStudingItem:clone()
    self.UIStudyList:pushBackCustomItem(item)
    local UIIcon = item:getChildByName("Image_icon")
    local UIName = item:getChildByName("Text_name_level")
    local UIEndBtn = item:getChildByName("Button_end")
    local UIComplete = item:getChildByName("Button_at_once")
    local UIBack = item:getChildByName("Image_scale")
    local UIScale = UIBack:getChildByName("LoadingBar_scale")
    local UIRTime = item:getChildByName("Text_time")
    local Text_Coin = item:getChildByName("Text_coin")
    local Image_Coin = item:getChildByName("Image_coin")
    showShader:buttonToGray(UIComplete)
    
    local currentLevel = info.lv 
    local levelInfo = getLevelInfo(msg,currentLevel+1)
    UIIcon:loadTexture(msg.icon,ResType)
    UIName:setString(StringRes[msg.name]..string.format(StringRes.LV2,currentLevel).."->"
        ..string.format(StringRes.LV2,currentLevel+1))
        
    local function setTimeScale()
        if UIScale and UIRTime then
            UIScale:setPercent((info.totalTime-info.remainTime)*100/info.totalTime)
            UIRTime:setString(StringTemp:toTime(info.remainTime))
            local needGold=Common:getSpendByTime(info.remainTime);
            needGold = needGold>PlayerData:getInstanse().basicData.lvUpFreeGold and needGold or 0
            Text_Coin:setString(needGold)
        end
    end
    
    local function update(data)
        Singleton:set("TechnologyAction","getTechnologyList",data.techs)
        PlayerData:getInstanse().basicData = data.info
        self:update()
    end
    
    if info.state == 1 then --升级过程中
        setButtonEnabled(UIComplete,true)
        UIRTime:setColor(CommonColor.White)
        setTimeScale()
        self.IsStudingInfo = info
        TimeSches[info.type] = Scheduler:scheduleScriptFunc(function(dt)
            info.remainTime = info.remainTime - dt
            setTimeScale()
            if info.remainTime <=0 then
                noRemainTime(self,msg,info)
            end
        end,1,false)
        Image_Coin:setVisible(true)
        Text_Coin:setVisible(true)
    else
        UIScale:setPercent(0)
        setButtonEnabled(UIComplete,false)
        UIRTime:setString(StringRes.waiting)
        UIRTime:setColor(CommonColor.White)
        Image_Coin:setVisible(false)
        Text_Coin:setVisible(false)
    end
    
    local _m = {type=info.type}
    UIEndBtn:addTouchEventListener(eventListner(ended,function() 
        --取消  向服务器发送消息
        PromptView:type2(nil,StringRes.cancel_queue,StringRes.ok,StringRes.cancel,function()
            Connect:sendMsg("TechnologyAction","cancel",_m,update,true)
        end)
    end))
    UIComplete:addTouchEventListener(eventListner(ended,function() 
        --立即完成 向服务器发送消息
        --Connect:sendMsg(actionName,msgName,data,func,true)
--        local coin = math.ceil(info.remainTime/60)*1
--        PromptView:type2(nil,string.format(StringRes.complete_cost,coin,StringRes.coin)
--            ,StringRes.ok,StringRes.cancel,function()
--                Connect:sendMsg("TechnologyAction","speedUp",_m,function(newMsg)
--                    --提示完成
--                    FlyWordPrompt:prompt(string.format(StringRes.study_complete,StringRes[msg.name]))
--                    update(newMsg)
--                end,true)
--            end)

        --加速
        local needGold=Common:getSpendByTime(info.remainTime);
        needGold = needGold>PlayerData:getInstanse().basicData.lvUpFreeGold and needGold or 0
        function SpeedUp()
            require("src/app/util/SDKPlatform")
            SDKPlatform:printLog("SpeedUp")
            Connect:sendMsg("TechnologyAction","speedUp",_m,
                function (newMsg)
                    --提示完成
                    FlyWordPrompt:prompt(string.format(StringRes.study_complete,StringRes[msg.name]))
                    update(newMsg)
                end,true)
        end
        require("src/app/util/SDKPlatform")
        SDKPlatform:printLog("addTouchEventListener")
        if needGold > 0 then
            require("src/app/util/DialogUtil"):speedUp(info.remainTime, SpeedUp)
        else
            SpeedUp()
        end
    end))
end

local function isUnlock(unlockLevel)
    local pd = PlayerData:getInstanse()
    local buildLv = pd:getBaseBuildLv(5)
    return buildLv>=unlockLevel
end

local function canBuild(levelInfo,unlockLevel)
    local pd = PlayerData:getInstanse()
    for index,info in ipairs(levelInfo.cost) do
        local num = tonumber(info.type)
        local own = nil
        if num then
            own = pd:getBaseBuildLv(num)
        else
            local type = (info.type == "prestige") and "prestigeLv" or info.type
            own = pd.basicData[type]
        end
        if own <info.count then
            return false
        end
    end
    return true
end

--队列足够
function ScienceStudyView:queueEnough()
    local vip = PlayerData:getInstanse().basicData.vipLv
    local count = gVIP[vip].queueNum + 1
    if self.StudingCount >= count then --队列不够在研究了
        --暂时提示飞字飘
--        FlyWordPrompt:prompt("队列不够！")
        local _m = {type = self.IsStudingInfo.type}
        local function update(data)
            Singleton:set("TechnologyAction","getTechnologyList",data.techs)
            PlayerData:getInstanse().basicData = data.info
            self:update()
        end
        ManyDialogInfo:more_produce_queues(self.IsStudingInfo.remainTime,"queueNum",PlayerData:getInstanse().basicData.lvUpFreeGold,function()
                Connect:sendMsg("TechnologyAction","speedUp",_m,update,true)
        end)
        return false
    end
    return true
end

--可研究
function ScienceStudyView:setUnStudyItem(msg,info,pos) -- 服务器数据
    local item = self.UiUnStudyListItems[pos]--self.UINoStudyItem:clone()
    self.UIStudyList:pushBackCustomItem(item)
    local UIIcon = item:getChildByName("Image_icon")
    local UIName = item:getChildByName("Text_name_level")
    local UITime = item:getChildByName("Text_time")
    local UIDetails = item:getChildByName("Button_descript")
    local UIBuild = item:getChildByName("Button_build")
    local UITimeIcon = item:getChildByName("Image_time")
    local UIUnLock = item:getChildByName("Text_unlock")
    showShader:buttonToGray(UIBuild)
    
    --yangjie 2017-5-3 操作优化，添加直接完成
    local Btn_at_once = item:getChildByName("Button_at_once")
    local Image_coin = item:getChildByName("Image_coin")
    local Text_coin = item:getChildByName("Text_coin")


    showShader:buttonToGray(Btn_at_once)
    UIIcon:loadTexture(msg.icon,ResType)
    local curLevel = info.lv
    local lvInfo = getLevelInfo(msg,curLevel+1)
    UIName:setString(StringRes[msg.name]..string.format(StringRes.LV2,curLevel))
    
    -- 是否解锁
    local unlock = isUnlock(msg.unlock)
    if unlock then
        UITime:setString(StringTemp:toTime(lvInfo.time))
    else
        UIUnLock:setString(string.format(StringRes.need_tech_level,msg.unlock))
    end
    UIUnLock:setVisible(not unlock)
    UITime:setVisible(unlock)
    UITimeIcon:setVisible(unlock)
    
    --能建造
    local canBuild = canBuild(lvInfo,msg.unlock) --判断等级和消耗是否
    setButtonEnabled(UIBuild,canBuild)
    setButtonEnabled(Btn_at_once,canBuild)

    if canBuild then
        local needGold=Common:getSpendByTime(info.remainTime);
        needGold = needGold>PlayerData:getInstanse().basicData.lvUpFreeGold and needGold or 0
        Text_coin:setString(needGold)
        Image_coin:setVisible(true)
        Text_coin:setVisible(true)
    else
        Image_coin:setVisible(false)
        Text_coin:setVisible(false)
    end


    UIDetails:addTouchEventListener(eventListner(ended,function() 
            --详情
            local StudyPromptView = require("src/app/views/study/StudyPromptView")
        StudyPromptView:open(self,{msg=msg,lvInfo=lvInfo})
        end))
    UIBuild:addTouchEventListener(eventListner(ended,function() 
        --建造
            if self:queueEnough() then
                local _m = {type = info.type}
                Connect:sendMsg("TechnologyAction","techLvUp",_m,function(data) 
                    if data.state == 1 then
                        PlayerData:getInstanse().basicData = data.info
                        Singleton:set("TechnologyAction","getTechnologyList",data.techs)
                        self:update()
                    end
                end,true)
            end
        end))
    Btn_at_once:addTouchEventListener(eventListner(ended,function()
        --立即完成
        local needGold=Common:getSpendByTime(info.remainTime);
        needGold = needGold>PlayerData:getInstanse().basicData.lvUpFreeGold and needGold or 0
        function atOnceFinish()
            require("src/app/util/SDKPlatform")
            SDKPlatform:printLog("atOnceFinish")
            local _m = {type = info.type}
            Connect:sendMsg("TechnologyAction","atOnceFinish",_m,
                function (newMsg)
                    --提示完成
                    PlayerData:getInstanse().basicData = newMsg.info
                    Singleton:set("TechnologyAction","getTechnologyList",newMsg.techs)
                    self:update()
                    FlyWordPrompt:prompt(string.format(StringRes.study_complete,StringRes[msg.name]))
----                    刷新界面
--                    endTimes()
--                    Connect:sendMsg("TechnologyAction","getTechnologyList",nil,function(data)
--                        --提示完成
--                        Singleton:set("TechnologyAction","getTechnologyList",data)
--                        updateScheduler(object)
--                    end,true)
                end,true)
        end
        require("src/app/util/SDKPlatform")
        SDKPlatform:printLog("Btn_at_once:addTouchEventListener")
        if needGold > 0 then
            require("src/app/util/DialogUtil"):speedUp(info.remainTime, atOnceFinish)
        else
            atOnceFinish()
        end
    end))
end

--主界面调用这个获取研究队列
function ScienceStudyView:getStudingList(func)
    updateScheduler(nil,func)
end

--等级变化后
function ScienceStudyView:doSelect()
    if self.buildLv ~= self.data.buildLv then
        self.buildLv = self.data.buildLv
        self:update()
    end
end

--刷新
function ScienceStudyView:update()
    self.UIStudyList:removeAllChildren()
    endTimes()
--    if self.buildLv <= 0 then
--        return
--    end
    Singleton:get("TechnologyAction","getTechnologyList",function(data)
        self.StudingCount = 0
        local unStudyPos = 0
        for _,info in ipairs(data.techs) do
            if info.state ~= 2 then
                self.StudingCount = self.StudingCount + 1
                self:setStudingItem(ScienceStudyCfg[info.type],info)
            else
                unStudyPos = unStudyPos + 1
                self:setUnStudyItem(ScienceStudyCfg[info.type],info,unStudyPos)
            end
        end
--        local techs = {}
--        for _,info in ipairs(data.techs) do
--            techs[info.type] = info
--        end
--        local studing,unStudy = {},{}
--        for _, info in ipairs(ScienceStudyCfg) do
--            local serverData = techs[info.id]
--            if serverData and serverData.state ~= 2 then
--                table.insert(studing,info)
--            else
--                table.insert(unStudy,info)
--            end
--        end
--        for _, info in ipairs(studing) do
--            self:setStudingItem(info,techs[info.id])
--        end
--        for _ , info in ipairs(unStudy) do
--            self:setUnStudyItem(info,techs[info.id])
--        end
    end)
end

function ScienceStudyView:destroy()
    endTimes()
--    self.UINoStudyItem:release()
--    self.UIStudingItem:release()
end

function ScienceStudyView:initUnStudyList()
    self.UiUnStudyListItems = {}

    for _, info in ipairs(ScienceStudyCfg) do
        local item = self.UINoStudyItem:clone()
        item:retain()
        table.insert(self.UiUnStudyListItems,item)
    end
end

function ScienceStudyView:uiLoad()
    self.MainPage = CCUILoader:load("csd/public/ResearchListLayer.csb")
    self.MainPage:retain()

    self.UIStudyList = self.MainPage:getChildByName("ListView_study")
    self.UINoStudyItem = self.UIStudyList:getChildByName("Image_no_study")
    self.UIStudingItem = self.UIStudyList:getChildByName("Image_studing")
    self.UINoStudyItem:retain()
    self.UIStudingItem:retain()

    self:initUnStudyList()
end

PublicViews.ScienceStudyView = ScienceStudyView

return ScienceStudyView