
local ResIconCfg = require("src/app/cfg/ResIconCfg")
local NodeTranslator = require("src/app/util/NodeTranslator")
local ended = ccui.TouchEventType.ended
local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local StudyPromptView = class("StudyPromptView",function()
    return display.newColorLayer(cc.c4b(0,0,0,255*0.3))
end)

function StudyPromptView:ctor(parent,data)
    self.MainPage = CCUILoader:load("csd/public/StudyDetailLayer.csb")
    self:addChild(self.MainPage)
    
    self.UIPannel = self.MainPage:getChildByName("Panel_back")
    self.UINeedList = self.MainPage:getChildByName("ListView_need")
    self.UINeedItem = self.UINeedList:getChildByName("Panel_item")
    self.UINeedItem:retain()
    self.UIIcon = self.MainPage:getChildByName("Image_icon")
    self.UIDescript = self.MainPage:getChildByName("Text_descript")
    
    self.UIPannel:addTouchEventListener(eventListner(ended,function() 
        self:close()
    end))
    
    self.Data = data
    self._parent = parent
    
    local size = self.MainPage:getContentSize()
    self.MainPage:setAnchorPoint(0.5,0.5)
    self.MainPage:setPosition(size.width/2,size.height/2)
    NodeTranslator:transZoomOut(self.MainPage,function()

        end)
end

local function setItem(item,icon,typeText,needText,curHaveText,state)
    local UIIcon = item:getChildByName("Image_icon")
    local UIType = item:getChildByName("Text_type")
    local UINeed = item:getChildByName("Text_need")
    local UIHave = item:getChildByName("Text_have")
    local UIStateBtn = item:getChildByName("Button_state")
    local visible = false
    if icon then
        visible = true
        UIIcon:loadTexture(icon,ResType)
    end
    UIIcon:setVisible(visible)
    UIType:setString(typeText)
    UINeed:setString(needText)
    UIHave:setString(curHaveText)
    UIStateBtn:setBright(state)
end 

function StudyPromptView:update()
    self.UINeedList:removeAllChildren()
    self.UIIcon:loadTexture(self.Data.msg.icon,ResType)
    local pd = PlayerData:getInstanse()
    self.UIDescript:setString(StringRes[self.Data.msg.descript])
    for index,info in ipairs(self.Data.lvInfo.cost) do
        local item = self.UINeedItem:clone()
        self.UINeedList:pushBackCustomItem(item)
        local icon,cur,have,typeText,needText,curHaveText = nil,info.count,nil,nil,nil,nil,nil
        local num = tonumber(info.type)
        if num then
            have = pd:getBaseBuildLv(num)
            typeText = StringRes[gBuilding[num].name]
            needText = string.format(StringRes.LV2,cur)
            curHaveText = string.format(StringRes.LV2,have)
        else
            if info.type == "prestige" then
                have = pd.basicData["prestigeLv"]
                needText = string.format(StringRes.LV2,cur)
                curHaveText = string.format(StringRes.LV2,have)
            else
                have = pd.basicData[info.type]
                needText = StringTemp:toNum(cur)
                curHaveText = StringTemp:toNum(have)
            end
            icon = ResIconCfg[info.type]
            typeText = StringRes[info.type]
        end
        setItem(item,icon,typeText,needText,curHaveText,have>=cur)
    end
end

function StudyPromptView:close()
    NodeTranslator:transZoomIn(self.MainPage,function()
        self.UINeedItem:release()
        self._parent:removeChild(self)
    end)
end

function StudyPromptView:open(parent,data)
    local newPage = self.new(parent,data)
    newPage:update()
    parent:addChild(newPage)
--    local size = newPage:getContentSize()
    --newPage:setAnchorPoint(0.5,0.5)
    --newPage:setPosition(size.width/2,size.height/2)
end

return StudyPromptView