
local GuideList = class("GuideList",function(type)
    return CCUILoader:load("csd/guide/ui_guide_main.csb")
end)

function GuideList:show(parent)
    local layer = GuideList.new()
    parent:addChild(layer)
    NodeTranslator:transUp(layer,nil)
end

function GuideList:ctor()
    self:initView()
end

function GuideList:initView()
    local ui_bg = self:getChildByName("ProjectNode_1")

    local btn_close = ui_bg:getChildByName("btn_close")
    btn_close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)

    --title
    ui_bg:getChildByName("text_title"):setString(StringRes.guide)

    self:initItems()
end

function GuideList:initItems()
    local panel_bg = self:getChildByName("panel_bg")
    local tmp = panel_bg:getChildByName("panel_itembg")
    local lv = panel_bg:getChildByName("listview_guide")
    
    local pd = PlayerData:getInstanse()
    local playerLv = pd.basicData.lv
    
    function showItem(v)
    	local item = tmp:clone()
        item:getChildByName("text_guide"):setString(v.guide_des)
        item:getChildByName("btn_goto"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
--                1关卡当前进度图片
--                2玩家信息界面
--                3玩家技能界面
--                4世界地图
--                5装置车间
--                6科技中心
--                7充值界面
--                8VIP---VIP礼包界面
--                9充值--军需卡界面
--                10坦克工厂--生产界面
--                11补给线界面
--                12配件界面
                local parent = self:getParent()
                local PlayerInfo = require("src/app/views/PlayerInfo/PlayerInfo")
                if v.jump == 1 then
                    Connect:sendMsg("PveAction","openPve",nil,
                        function(data)
                            --更新数据

                            --PVE buf
                            pd:SetPveBuff(data)

                            local mission = Mission.new()
                            parent:addChild(mission)


--                            mission:enterInChar(pd.basicData.charId)

                        end)
                elseif v.jump == 2 then
                    parent.PlayerInfo = PlayerInfo.new(parent)
                    parent:addChild(parent.PlayerInfo)
                elseif v.jump == 3 then
                    parent.PlayerInfo = PlayerInfo.new(parent)
                    parent.PlayerInfo:setTabSelect(2)
                    parent:addChild(parent.PlayerInfo)
                elseif v.jump == 4 then
                    gWorldScene:toField()
                elseif v.jump == 5 then
                    local layer = require("src/app/views/buildings/DeviceFactory").new(parent,pd:getBaseBuildData(8))
                    parent:addChild(layer)
                    layer:setTabSelect(1)
                    NodeTranslator:transUp(layer,nil)
                elseif v.jump == 6 then
                    local ScienceCenterView = require("src/app/views/study/ScienceCenterView")
                    ScienceCenterView:open(parent,pd:getBaseBuildData(5),1)
                elseif v.jump == 7 then
                    Recharge:show(gWorldScene)
                elseif v.jump == 8 then
                    require("src/app/views/vip/VipInfo"):showPackageTab(parent)
--                    require("src/app/views/vip/VipInfo"):show(parent)
                elseif v.jump == 9 then
                    Recharge:show(gWorldScene,2)
                    self:removeFromParent()
                    return
                elseif v.jump == 10 then
                    local maxLvbuild = pd:getBaseBuildMaxLvData("2,3")
                    local layer = require("src/app/views/buildings/TankFactory").new(parent,maxLvbuild)
                    parent:addChild(layer)
                    require("app.util.NodeTranslator"):transUp(layer,nil)
                    layer:setTabSelect(2)
                elseif v.jump == 11 then
                    local SupplyLineView = require("src/app/views/accessories/SupplyLineView")
                    SupplyLineView:open(parent)
                elseif v.jump == 12 then
                    local AccessoryView = require("src/app/views/accessories/AccessoryView")
                    AccessoryView:open(parent)
                end
                self:close()
            end
        end)
        lv:pushBackCustomItem(item)
    end
    
    for i ,v in ipairs(gGuide) do
        local arr = string.split(v.c_display,":")
        if tonumber(arr[1]) == 1 then
            if playerLv >= tonumber(arr[2]) then
                showItem(v)
            end
        elseif tonumber(arr[1]) == 2 then
            local ids = string.split(arr[2],",")
            local flag = false
            for ii,id in ipairs(ids) do
                flag = flag or pd:getBuildingEnable(tonumber(id))
            end
            if flag then
                showItem(v)
            end
        elseif tonumber(arr[1]) == 0 then
            showItem(v)
        end
    end
    
end



function GuideList:close()
    NodeTranslator:transDown(self,function()
        self:removeFromParent()
    end)
end

return GuideList