
local ended = ccui.TouchEventType.ended
local UserDefault = cc.UserDefault:getInstance()

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local SystemSetView = class("SystemSetView", function()
    return display.newLayer()
end)

local function setButtonEnabled(button,enable)
    button:setBright(enable)
    button:setEnabled(enable)
    button:setTouchEnabled(enable)
end

function SystemSetView:ctor(parent)
    self.MainPage = CCUILoader:load("csd/SystemSetLayer.csb")
    self:addChild(self.MainPage)
    self.UIClose = self.MainPage:getChildByName("Button_close")
    self.UIBindAcount = self.MainPage:getChildByName("Button_bind")
    self.UIChangeAcount = self.MainPage:getChildByName("Button_changeuse")
    self.UIServerList = self.MainPage:getChildByName("Button_serverlist")
    self.UIGameSet = self.MainPage:getChildByName("Button_game_set")
    self.UIGuideList = self.MainPage:getChildByName("btn_guide")
    self.UIAcount = self.MainPage:getChildByName("Text_id")
    self.UIBuildTeam = self.MainPage:getChildByName("btn_guide_Copy")
    showShader:buttonToGray(self.UIBindAcount)

    --事件
    self.UIClose:addTouchEventListener(eventListner(ended,function()
        self:close(parent)
    end))
    self.UIBindAcount:addTouchEventListener(eventListner(ended,function()
        local RegisterView = require("src/app/views/login/RegisterView")
        RegisterView:open(self,true)
    end))
    self.UIChangeAcount:addTouchEventListener(eventListner(ended,function()
        if UserDefault:getStringForKey("type")~="1" and SDKPlatform:isSelfProgram() then
            PromptView:type2(nil,StringRes.changeIDprompt_1,StringRes.ok,StringRes.cancel,function()
                self:callBack()
            end)
        else
            self:callBack()
        end
    end))
    self.UIServerList:addTouchEventListener(eventListner(ended,function()
        local ServerListView = require("src/app/views/login/ServerListView")
        ServerListView:open(self)
    end))
    self.UIGameSet:addTouchEventListener(eventListner(ended,function()
        local GameSetView = require("src/app/views/system/GameSetView")
        GameSetView:open(self)
    end))
    self.UIGuideList:addTouchEventListener(eventListner(ended,function()
        require("app/views/system/GuideList"):show(parent)
        self:close(parent)
    end))
--    self.UIBuildTeam:addTouchEventListener(eventListner(ended,function()
--        require("app/views/system/UIBuildTeam"):show(parent)
--        self:close(parent)
--    end))
    ViewManager:OpenView(self)
end

function SystemSetView:callBack(server)
    SDKPlatform:logout()
    app:enterScene("LoginScene")
end

function SystemSetView:canUpdate()
    return true
end

function SystemSetView:update()
    local type = UserDefault:getStringForKey("type")
    setButtonEnabled(self.UIBindAcount,type~="1" and SDKPlatform:isSelfProgram())
    local playerId = PlayerData:getInstanse().basicData.playerId
    self.UIAcount:setString(playerId)
end

function SystemSetView:close(parent)
    parent:removeChild(self)
end

function SystemSetView:open(parent)
    local newPage = self.new(parent)
    newPage:update()
    parent:addChild(newPage)
end

return SystemSetView