local PanelTabLayer = require("src/app/views/public/PanelTabLayer")
local PlayerInfo = require("src/app/views/PlayerInfo/PlayerInfo")
local BagAndStore = require("src/app/views/bag/BagAndStore")
local TaskInfo = class("TaskInfo",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.task,tabs={StringRes.task,StringRes.dailyTask_Title}})
end)

function TaskInfo:ctor(scene)
    self.task = nil
    self.daytask = nil
    
    
    self.taskUIModel = cc.uiload:load("res/csd/public/TaskModel.csb")
    self.taskUIModel:retain()
    self:initTabs()
    
    self:registerTabEvent("close",function() 
        self.taskUIModel:release()
        if gWorldScene ~= nil then
            gWorldScene:BaseQuest()
        end
    end)
--    local function onNodeEvent(tag)
--        if tag == "exit" then
--            self.taskUIModel:release()
--            
--            if gWorldScene ~= nil then
--                if not NoviceGuide:getState() then
--                	gWorldScene:BaseQuest()
--                end
--            end
--        end
--    end
--
--    self:registerScriptHandler(onNodeEvent)

--    ViewManager:OpenView(instance, false)
end

function TaskInfo:resetContent()
    if self.task then self.task:setVisible(false) end
    if self.daytask then self.daytask:setVisible(false) end
end

function TaskInfo:ViewPage(page)
    if self.task then self.task:setVisible(false) end
    if self.daytask then self.daytask:setVisible(false) end
    
    page:setVisible(true)
end


--显示任务详细信息
function TaskInfo:showAboutInfo(taskVo)
    TaskReward:show(self,taskVo)
end


--获取等级最高的建筑
function TaskInfo:getBuild(ids)
    local pd = PlayerData:getInstanse()
    local maxLvbuild = pd:getBaseBuildMaxLvData(ids)
    if maxLvbuild == nil then
    	maxLvbuild = pd:getResBuildMaxLvData(ids)
    end
    
    return maxLvbuild
end


--前往
function TaskInfo:StaticGotoHere(taskInfo)
    local gotoStr = StringTemp:Split(taskInfo.gotothere,":")
    local type = tonumber(gotoStr[1])

    local parent = gWorldScene
    --    
    --    type:XX,pa:XX
    --1：代表前往大章关卡
    --2：前往世界地图
    --3：玩家信息界面
    --4:前往建筑建造。4：id
    --5：前往最高级坦克工厂
    --6：前往郊外地图
    --7前往配件详细界面
    --8补给线详细界面
    --9军演详细界面
    --10军团副本
    --11军团商店界面
    --12军团科技界面
    --13玩家信息--建造界面
    --14充值界面
    --15高级抽奖界面
    --16商店界面
    
    
    --20科技中心研发界面
    --21角色技能界面
    --22VIP主界面
    local pd = PlayerData:getInstanse() 

    if type == 1 then
        Connect:sendMsg("PveAction","openPve",nil,
            function(data)
                --更新数据

                --PVE buf
                pd:SetPveBuff(data)

                local mission = Mission.new()
                parent:addChild(mission)


                mission:enterInChar(pd.basicData.charId)

            end)
    elseif type == 2 then
        gWorldScene:toField()
    elseif type == 3 then
        parent.PlayerInfo = PlayerInfo.new(parent)
        parent:addChild(parent.PlayerInfo)
    elseif type == 4 then

        --        local build = tonumber(gotoStr[2])
        --        if build == 5 then
        --          
        --        else
        --        
        --        end



        local maxLvbuild = pd:getBaseBuildMaxLvData(gotoStr[2])
        if maxLvbuild ~= nil then
            Buildings:enter(maxLvbuild,parent)
        else
            maxLvbuild = pd:getResBuildMaxLvData(tonumber(gotoStr[2]))
            local layer = require("src/app/views/buildings/ResBuilding").new(parent,maxLvbuild)
            parent:addChild(layer)
            require("app.util.NodeTranslator"):transUp(layer,nil)
        end




    elseif type == 5 then

        local maxLvbuild = pd:getBaseBuildMaxLvData("2,3")
        local layer = require("src/app/views/buildings/TankFactory").new(parent,maxLvbuild)
        parent:addChild(layer)
        require("app.util.NodeTranslator"):transUp(layer,nil)

        layer:setTabSelect(2)
    elseif type == 6 then
        gWorldScene.BgPage = 2
        gWorldScene:TurnBgQuest()
    elseif type == 7 then

        if Buildings:isCanEnter(pd:getBaseBuildData(12)) then
            local AccessoryView = require("src/app/views/accessories/AccessoryView")
            AccessoryView:open(parent)
        else
            FlyWordPrompt:prompt(StringRes[taskInfo.jumptip])
            return false
        end


    elseif type == 8 then
        if Buildings:isCanEnter(pd:getBaseBuildData(12)) then
            local SupplyLineView = require("src/app/views/accessories/SupplyLineView")
            SupplyLineView:open(parent)
        else
            FlyWordPrompt:prompt(StringRes[taskInfo.jumptip])
            return false
        end

    elseif type == 9 then
        if Buildings:isCanEnter(pd:getBaseBuildData(13)) then

            local MilitaryExerciseView = require("src/app/views/combat/MilitaryExerciseView")
            MilitaryExerciseView:open(parent,nil,1)
        else
            FlyWordPrompt:prompt(StringRes[taskInfo.jumptip])
            return false
        end

    elseif type == 10 then
        --if pd.basicData.guildId ~= 0 then
        if pd:getBaseBuildLv(1) >= 5 then
            Buildings:gotoArmyGroupFB(parent)
        else
            FlyWordPrompt:prompt(StringRes[taskInfo.jumptip])
            return false
        end

    elseif type == 11 then
        --if pd.basicData.guildId ~= 0 then
        if pd:getBaseBuildLv(1) >= 5 then
            Buildings:gotoArmyGroupStore(parent)
        else
            FlyWordPrompt:prompt(StringRes[taskInfo.jumptip])
            return false
        end

    elseif type == 12 then
        --if pd.basicData.guildId ~= 0 then
        if pd:getBaseBuildLv(1) >= 5 then
            Buildings:gotoArmyGroupTechnology(parent)
        else
            FlyWordPrompt:prompt(StringRes[taskInfo.jumptip])
            return false
        end

    elseif type == 13 then
        parent.PlayerInfo = PlayerInfo.new(parent)
        parent.PlayerInfo:setTabSelect(3)
        parent:addChild(parent.PlayerInfo)
    elseif type == 14 then
        Recharge:show(gWorldScene)
    elseif type == 15 then
        require("src/app/views/lottery/LotteryMainView.lua"):open(parent,nil,2)

    elseif type == 16 then
        local bb = BagAndStore.new(parent,2)
        parent:addChild(bb)
    elseif type == 17 then
        if Buildings:isCanEnter(pd:getBaseBuildData(5)) then

            require("src/app/views/study/ScienceCenterView.lua"):limitOpen(parent,2)
        else
            FlyWordPrompt:prompt(StringRes[taskInfo.jumptip])
            return false
        end
    elseif type == 20 then
        if Buildings:isCanEnter(pd:getBaseBuildData(5)) then

            require("src/app/views/study/ScienceCenterView.lua"):limitOpen(parent,2)
        else
            FlyWordPrompt:prompt(StringRes[taskInfo.jumptip])
            return false
        end
    elseif type == 21 then
        parent.PlayerInfo = PlayerInfo.new(parent)
        parent.PlayerInfo:setTabSelect(2)
        parent:addChild(parent.PlayerInfo)
    elseif type == 22 then
        require("src/app/views/vip/VipInfo"):show(parent)

    end

    return true


end

--前往
function TaskInfo:GotoHere(taskInfo)
    if TaskInfo:StaticGotoHere(taskInfo) then
        
        self.taskUIModel:release()
        if gWorldScene ~= nil then
            gWorldScene:BaseQuest()
        end
        self:removeFromParent()
    end
end



function TaskInfo:currentProduce(taskinfo)
    if taskinfo.tankcount > 0 then
		return taskinfo.tankcount
    elseif taskinfo.buildingcount > 0 then
        return taskinfo.buildingcount
    elseif taskinfo.lv > 0 then
        return taskinfo.lv
    elseif taskinfo.collect > 0 then
        return taskinfo.collect
    else
        return 0
	end
end


--重置主线任务
function TaskInfo:resetMainTask()
    local pd = PlayerData:getInstanse()

    --没得任务
    if pd.task == nil then
        return
    end

    if pd.task.mainTaskShowVO ~= nil then
		--角色任务
		if pd.task.playerTasks then
            for key, var in pairs(pd.task.playerTasks) do
               if var.state ~= 0 then
		  	   	   pd.task.mainTaskShowVO = var
		  	   	   return
		  	   end
		    end
		end
		--建设任务
		if pd.task.buildingTasks then
            for key, var in pairs(pd.task.buildingTasks) do
               if var.state ~= 0 then
                   pd.task.mainTaskShowVO = var
                   return
               end
            end
        end
        --资源任务
        if pd.task.resourceTasks then
            for key, var in pairs(pd.task.resourceTasks) do
                if var.state ~= 0 then
                    pd.task.mainTaskShowVO = var
                    return
                end
            end
        end
	end
end

--获取任务完成数量
function TaskInfo:getTaskOverNum()
    local pd = PlayerData:getInstanse()
    local num = 0
    --没得任务
    if pd.task == nil then
        return num
    end

    --角色任务
    if pd.task.playerTasks then
        for key, var in pairs(pd.task.playerTasks) do
            if var.state ~= 0 then
                num = num + 1
            end
        end
    end
    --建设任务
    if pd.task.buildingTasks then
        for key, var in pairs(pd.task.buildingTasks) do
            if var.state ~= 0 then
                num = num + 1
            end
        end
    end
    --资源任务
    if pd.task.resourceTasks then
        for key, var in pairs(pd.task.resourceTasks) do
            if var.state ~= 0 then
                num = num + 1
            end
        end
    end
    
    return num
end





--刷新任务
function TaskInfo:freshTask()
    if self.task == nil then
        self.task = cc.uiload:load("res/csd/public/TabProduce.csb")
        self:addChild(self.task)
    end
    local lv = self.task:getChildByName("listview")
    lv:removeAllChildren(true)
    
    local pd = PlayerData:getInstanse()
    
    --没得任务
    if pd.task == nil then
        return
    end
    
    self:resetMainTask()
    
    --任务数量提示
    self:setWarningCount(1,self:getTaskOverNum())
    
    --主线任务
    if pd.task.mainTaskShowVO ~= nil then
        
        local taskshowvo = pd.task.mainTaskShowVO
        
        local mainTaskUI = self.taskUIModel:getChildByName("Panel_2"):clone()
        lv:pushBackCustomItem(mainTaskUI)
        
        
        
        --大类型判断
        local taskInfo = gTask[taskshowvo.taskId]
        if taskInfo.type == 3 then
            local num = StringTemp:Split(taskInfo.cond,":")
            num = tonumber( num[2])

            --标题
            mainTaskUI:getChildByName("Text_6"):setString( string.format(StringRes[taskInfo.name],num) )
        else
            --坦克名字
            local tankName = StringTemp:strtoTable(taskInfo.cond)
            if tankName.id ~= nil then
                --标题
                mainTaskUI:getChildByName("Text_6"):setString( string.format( StringRes[taskInfo.name],StringRes[Tank[tankName.id].name]))
            else
                --标题
                mainTaskUI:getChildByName("Text_6"):setString(StringRes[taskInfo.name])
            end
        
        
        
            --mainTaskUI:getChildByName("Text_6"):setString(StringRes[gTask[taskshowvo.taskId].name])
        end
        
        
        
        
        
        
        --进度
        if taskshowvo.state ~= 0 then
            mainTaskUI:getChildByName("Text_7"):setString(StringRes.task_finish)
        else
            --进度
            mainTaskUI:getChildByName("Text_7"):setString( 
                string.format(StringRes[gTask[taskshowvo.taskId].pro],self:currentProduce(taskshowvo) )  )
        end
        
        
        --描述
        local about  = mainTaskUI:getChildByName("Button_1")
        about.taskVo = taskshowvo
        about:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                self:showAboutInfo(about.taskVo)
            end
        end)
        
        
        local qianwang  = mainTaskUI:getChildByName("Button_2")
        qianwang.taskInfo = taskshowvo
        qianwang:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                self:GotoHere(gTask[e.taskInfo.taskId])

            end
        end)
        local getreward = mainTaskUI:getChildByName("Button_3")
        getreward.taskVo = taskshowvo
        getreward:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                self:getReward(e.taskVo.taskId)

            end
        end)
        if taskshowvo.state == 0 then
            qianwang:setVisible(true)
            getreward:setVisible(false)
            Animation:stopAnimation(getreward,gUIeffect[9].effect)
        elseif taskshowvo.state == 1 then
            qianwang:setVisible(false)
            getreward:setVisible(true)
            Animation:playAnimation(getreward,gUIeffect[9].effect,true,15)
        elseif taskshowvo.state == 2 then

        end

    end


    preLoad:updateRelese()

    --角色任务
    if pd.task.playerTasks and #pd.task.playerTasks > 0 then
        --大标题
        local biaoti = self.taskUIModel:getChildByName("Image_3"):clone()
        biaoti:getChildByName("Text_4"):setString(StringRes["player_task"])
        lv:pushBackCustomItem(biaoti)
        --具体任务
        local onetask = self.taskUIModel:getChildByName("Panel_1")
        for i,v in pairs(pd.task.playerTasks) do

            local taskInfo = gTask[v.taskId]

            local t = preLoad:getPanel("TaskModel")
            --更改图标
            t:getChildByName("Image_2"):loadTexture(taskInfo.icon,ResType)
            t:getChildByName("Image_2"):setScale(taskInfo.iconzoom)

            --标题
            t:getChildByName("Text_1"):setString(StringRes[taskInfo.name])

            --进度
            if v.state ~= 0 then
                t:getChildByName("Text_2"):setString(StringRes.task_finish)
            else
                --t:getChildByName("Text_3"):setString(StringRes.task_unfinish)
                --进度
                t:getChildByName("Text_2"):setString( 
                    string.format(StringRes[gTask[v.taskId].pro],self:currentProduce(v) )  )
            end
            
            
            --描述
            local about  = t:getChildByName("Button_1")
            about.taskVo = v
            about:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    self:showAboutInfo(about.taskVo)
                end
            end)
            
            
            --前往和领取
            local qianwang  = t:getChildByName("Button_2")
            qianwang.taskInfo = taskInfo
            qianwang:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    self:GotoHere(e.taskInfo)

                end
            end)
            local getreward = t:getChildByName("Button_3")
            getreward.taskVo = v
            getreward:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    self:getReward(e.taskVo.taskId)

                end
            end)
            if v.state == 0 then
                qianwang:setVisible(true)
                getreward:setVisible(false)
                Animation:stopAnimation(getreward,gUIeffect[9].effect)
            elseif v.state == 1 then
                qianwang:setVisible(false)
                getreward:setVisible(true)
                Animation:playAnimation(getreward,gUIeffect[9].effect,true,15)
                t.onrelease = function()
                    Animation:stopAnimation(getreward,gUIeffect[9].effect)
                end
            elseif v.state == 2 then

            end
            
            
        	
            lv:pushBackCustomItem(t)
        end
    end
    
    
    --建设任务
    if pd.task.buildingTasks and #pd.task.buildingTasks > 0  then
        --大标题
        local biaoti = self.taskUIModel:getChildByName("Image_3"):clone()
        biaoti:getChildByName("Text_4"):setString(StringRes["base_task"])
        lv:pushBackCustomItem(biaoti)
        --具体任务
        local onetask = self.taskUIModel:getChildByName("Panel_1")
        for i,v in pairs(pd.task.buildingTasks) do

            local taskInfo = gTask[v.taskId]

            local t = preLoad:getPanel("TaskModel")
            --更改图标
            t:getChildByName("Image_2"):loadTexture(taskInfo.icon,ResType)
            t:getChildByName("Image_2"):setScale(taskInfo.iconzoom)

            --坦克名字
            local tankName = StringTemp:strtoTable(taskInfo.cond)
            if tankName.id ~= nil then
                --标题
                t:getChildByName("Text_1"):setString( string.format( StringRes[taskInfo.name],StringRes[Tank[tankName.id].name]))
            else
                --标题
                t:getChildByName("Text_1"):setString(StringRes[taskInfo.name])
            end
            
            
            --进度
            if v.state ~= 0 then
                t:getChildByName("Text_2"):setString(StringRes.task_finish)
            else
                --t:getChildByName("Text_3"):setString(StringRes.task_unfinish)
                --进度
                t:getChildByName("Text_2"):setString( 
                    string.format(StringRes[gTask[v.taskId].pro],self:currentProduce(v) )  )
            end
            --进度
            --t:getChildByName("Text_3"):setString( self:currentProduce(v) )


            --描述
            local about  = t:getChildByName("Button_1")
            about.taskVo = v
            about:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    self:showAboutInfo(about.taskVo)
                end
            end)


            --前往和领取
            local qianwang  = t:getChildByName("Button_2")
            qianwang.taskInfo = taskInfo
            qianwang:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    self:GotoHere(e.taskInfo)

                end
            end)
            
            
            local getreward = t:getChildByName("Button_3")
            getreward.taskVo = v
            getreward:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    self:getReward(e.taskVo.taskId)

                end
            end)
            
            if v.state == 0 then
                qianwang:setVisible(true)
                getreward:setVisible(false)
                Animation:stopAnimation(getreward,gUIeffect[9].effect)
            elseif v.state == 1 then
                qianwang:setVisible(false)
                getreward:setVisible(true)
                Animation:playAnimation(getreward,gUIeffect[9].effect,true,15)
                t.onrelease = function()
                    Animation:stopAnimation(getreward,gUIeffect[9].effect)
                end
            elseif v.state == 2 then

            end



            lv:pushBackCustomItem(t)
        end
    end
    
    --资源任务
    if pd.task.resourceTasks and #pd.task.resourceTasks > 0 then
        --大标题
        local biaoti = self.taskUIModel:getChildByName("Image_3"):clone()
        biaoti:getChildByName("Text_4"):setString(StringRes["res_task"])
        lv:pushBackCustomItem(biaoti)
        --具体任务
        local onetask = self.taskUIModel:getChildByName("Panel_1")
        for i,v in pairs(pd.task.resourceTasks) do

            local taskInfo = gTask[v.taskId]

            local t = preLoad:getPanel("TaskModel")
            --更改图标
            t:getChildByName("Image_2"):loadTexture(taskInfo.icon,ResType)
            t:getChildByName("Image_2"):setScale(taskInfo.iconzoom)
            local icon = t:getChildByName("Image_2")
--            icon:setBright(true)
--            icon:setHighlighted(true)

            --资源数量
            local num = StringTemp:Split(taskInfo.cond,":")
            num = tonumber( num[2])

            --标题
            t:getChildByName("Text_1"):setString( string.format(StringRes[taskInfo.name],num) )

            --进度
            --进度
            if v.state ~= 0 then
                t:getChildByName("Text_2"):setString(StringRes.task_finish)
            else
                --t:getChildByName("Text_3"):setString(StringRes.task_unfinish)
                --进度
                t:getChildByName("Text_2"):setString( 
                    string.format(StringRes[gTask[v.taskId].pro],self:currentProduce(v) )  )
            end
            --t:getChildByName("Text_3"):setString( self:currentProduce(v) )


            --描述
            local about  = t:getChildByName("Button_1")
            about.taskVo = v
            about:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    self:showAboutInfo(about.taskVo)
                end
            end)


            --前往和领取
            local qianwang  = t:getChildByName("Button_2")
            qianwang.taskInfo = taskInfo
            qianwang:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    self:GotoHere(e.taskInfo)

                end
            end)
            
            local getreward = t:getChildByName("Button_3")
            getreward.taskVo = v
            getreward:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    
                    self:getReward(e.taskVo.taskId)
                    
                end
            end)
            
            
            
            
            if v.state == 0 then
                qianwang:setVisible(true)
                getreward:setVisible(false)
                Animation:stopAnimation(getreward,gUIeffect[9].effect)
            elseif v.state == 1 then
                qianwang:setVisible(false)
                getreward:setVisible(true)
                Animation:playAnimation(getreward,gUIeffect[9].effect,true,15)
                t.onrelease = function()
                    Animation:stopAnimation(getreward,gUIeffect[9].effect)
                end
            elseif v.state == 2 then

            end



            lv:pushBackCustomItem(t)
        end
    end


end

--奖励提示信息

local taskRewardName = {
    exp = "exp",
    guildcap = "guildcap",--军团资金
    prestige = "prestige",
    medal = "Item_Name_42",
    ferrum = "ferrum",
    oil = "oil",
    lead = "lead",
    titan = "titanium",
    crystal = "crystal",
}

--任务获取奖励提示
function TaskInfo:getNotice(id)
    local ti = gTask[id].reward
    local str = StringRes.task_get
    for key, var in pairs(taskRewardName) do
        if ti[key] ~= nil and ti[key] > 0 then
            local t = StringRes[var].." x"..StringTemp:toNum(ti[key]).." "
            str = str..t
		end
	end
	--坦克
	local tank = StringTemp:strtoTable(ti.tank)
	if tank ~= nil and #tank > 0 then
        local t = StringRes[Tank[tank.id].name].." x"..tank.count
        str = str..t
	end
	return str
end

--日常小任务奖励提示
function TaskInfo:getLittleDayNotice(id)
    local ti = gDailyTask[id].reward
    local str = StringRes.task_get
    for key, var in pairs(taskRewardName) do
        if ti[key] ~= nil and ti[key] > 0 then
            local t = StringRes[var].." x"..ti[key].." "
            str = str..t
        end
    end
    --道具
    --local item = StringTemp:strtoTable(ti.item)
    local t = StringTemp:Split(ti.item,":")
    if tonumber(t[1]) ~= 0 then
        local t = StringRes[gItem[tonumber(t[1])].name].." x"..t[2]
        str = str..t
    end
    return str
end


--日常大任务奖励提示
function TaskInfo:getBigDayNotice(id)
    local ti = gDailyReward[id].reward
    local str = StringRes.task_get
    for key, var in pairs(taskRewardName) do
        if ti[key] ~= nil and ti[key] > 0 then
            local t = StringRes[var].." x"..ti[key].." "
            str = str..t
        end
    end
    --道具
    --local item = StringTemp:strtoTable(ti.item)
    local t = StringTemp:Split(ti.item,":")
    if tonumber(t[1]) ~= 0 then
        local t = StringRes[gItem[tonumber(t[1])].name].." x"..t[2]
        str = str..t
    end
    return str
end





--获取奖励
function TaskInfo:getReward(ti)
	
	local msg = {taskId = ti}
    Connect:sendMsg("TaskAction","getTaskReward",msg,
        function(data)
            local pd = PlayerData:getInstanse()    
            --更新数据
            pd.task.mainTaskShowVO = data.openTaskItemVO.mainTaskShowVO
            pd.task.playerTasks = data.openTaskItemVO.playerTasks
            pd.task.buildingTasks = data.openTaskItemVO.buildingTasks
            pd.task.resourceTasks = data.openTaskItemVO.resourceTasks
            
            
            
            
            pd.basicData = data.playerInfoVO
            
            self:freshTask()
            
            
            FlyWordPrompt:prompt(self:getNotice(ti))
        end)
	
end


local csbName = {
    [1] = {btn = "btn_develop",list = "listview_develop",voName = "task1DailyVOs"},
    [2] = {btn = "btn_battle",list = "listview_battle",voName = "task2DailyVOs"},
    [3] = {btn = "btn_army_group",list = "listview_army_group",voName = "task3DailyVOs"},
    [4] = {btn = "btn_vip",list = "listview_vip",voName = "task4DailyVOs"},
}




--获取小任务标签页完成数量
function TaskInfo:getLittleDailyTaskOverNum(page)
    local pd = PlayerData:getInstanse()
    local num = 0


    for key, var in pairs(pd.task.taskDailyShowVOs) do
        --
        if var.rewardId == page then
            if var.state == 1 then
                num = num + 1
            end
            
            for key, var in pairs(pd.task[csbName[var.rewardId].voName]) do
                if var.state == 1 then
                    num = num + 1
                end
            end
            
            
        end
    end


    return num
end

--获取日常任务完成数量
function TaskInfo:getDailyTaskOverNum()
    local pd = PlayerData:getInstanse()
    local num = 0
    
    
    for key, var in pairs(pd.task.taskDailyShowVOs) do
        --
        if var.state == 1 then
            num = num + 1
        end
        
        for key, var in pairs(pd.task[csbName[var.rewardId].voName]) do
            if var.state == 1 then
                num = num + 1
            end
        end
    end
    

    return num
end

--显示日常任务小页面

function TaskInfo:viewLittleDayTask()

    local function setButtonEnabled(button,enable)
        button:setBright(enable)
        button:setEnabled(enable)
        button:setTouchEnabled(enable)
    end

    for key, var in pairs(csbName) do
        if self.daytask.page == key then
            local btn = self.daytask:getChildByName("panel_daily"):getChildByName(var.btn)
            setButtonEnabled(btn,false)
            
            local list = self.daytask:getChildByName("panel_daily"):getChildByName(var.list)
            list:setVisible(true)
		else
            local btn = self.daytask:getChildByName("panel_daily"):getChildByName(var.btn)
            setButtonEnabled(btn,true)
            local list = self.daytask:getChildByName("panel_daily"):getChildByName(var.list)
            list:setVisible(false)
		end
	end
    local pd = PlayerData:getInstanse()
	local data = nil
	for key, var in pairs(pd.task.taskDailyShowVOs) do
       if var.rewardId == self.daytask.page then
	   	   data = var
	   	   break
	   end
	end
	
	--显示大任务
    local titleShow = self.daytask:getChildByName("panel_daily"):getChildByName("panel_task_top")
    --进度条
    local loadingbar = titleShow:getChildByName("progress_daily"):getChildByName("loadingbar_progress")
    loadingbar:setPercent(data.rewardCount/data.allCount*100)
    --文字
    local loadingtxt = loadingbar:getChildByName("text_progress")
    loadingtxt:setString(data.rewardCount.."/"..data.allCount)
    
    
    --
    --描述
    local about  = titleShow:getChildByName("btn_info")
    about:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            --self:showAboutInfo(about.var)
            TaskReward:showBigDaily(self,data)
        end
    end)
	
    local getreward = titleShow:getChildByName("btn_get")
	--状态
	if data.state == 0 then
        titleShow:getChildByName("btn_get"):setVisible(false)
        titleShow:getChildByName("icon_task_complete"):setVisible(false)
        
        Animation:stopAnimation(getreward,gUIeffect[9].effect)
        
    elseif data.state == 1 then
        titleShow:getChildByName("btn_get"):setVisible(true)
        titleShow:getChildByName("icon_task_complete"):setVisible(false)
        
        Animation:playAnimation(getreward,gUIeffect[9].effect,true,15)
        
    elseif data.state == 2 then
        titleShow:getChildByName("btn_get"):setVisible(false)
        titleShow:getChildByName("icon_task_complete"):setVisible(true)
        
        Animation:stopAnimation(getreward,gUIeffect[9].effect)
	end
    titleShow:getChildByName("btn_get"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

            local msg = {id = self.daytask.page}
            Connect:sendMsg("TaskAction","getTaskDailyAllReward",msg,
                function(data1)
                    local pd = PlayerData:getInstanse()    
                    --更新数据
                    pd.basicData = data1.playerInfoVO
                    data.state = 2
                    self:freshDayTask()
                    FlyWordPrompt:prompt(self:getBigDayNotice(self.daytask.page))
                end)
        end
    end)
	
    
	
	
	
	
end


function TaskInfo:showLittleDailyTaskNum()

    for key, var in pairs(csbName) do
        
        local btn = self.daytask:getChildByName("panel_daily"):getChildByName(var.btn)
        if self:getLittleDailyTaskOverNum(key) > 0 then
        	Animation:showNum(btn,gLittleUi:getChildByName("Image_7"):clone(),self:getLittleDailyTaskOverNum(key))
        else
            Animation:hideNum(btn,gLittleUi:getChildByName("Image_7"))
        end
        
    end
end


--刷新日常任务
function TaskInfo:freshDayTask()
    if self.daytask == nil then
        
        self.daytask = cc.uiload:load("res/csd/mission/ui_mission_main.csb")
        self:addChild(self.daytask)
        self.daytask.page = 1
        
        --
        for key, var in pairs(csbName) do
            local btn = self.daytask:getChildByName("panel_daily"):getChildByName(var.btn)
            
            btn:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    self.daytask.page = key
                    self:viewLittleDayTask()
                end
            end)
            
        end
        
    end
    --没得任务
    local pd = PlayerData:getInstanse()
    if pd.task == nil then
        return
    end
    
    
    --任务数量提示
    self:setWarningCount(2,self:getDailyTaskOverNum())
    
    --显示任务数量
    self:showLittleDailyTaskNum()
    
    
    --设置显示
    self:viewLittleDayTask()

    

    --
    for key, var in pairs(pd.task.taskDailyShowVOs) do
        --

        local list = self.daytask:getChildByName("panel_daily"):getChildByName(csbName[var.rewardId].list)
        list:removeAllItems()
        --
        
        
        --任务排序值
        for key, var in pairs(pd.task[csbName[var.rewardId].voName]) do
            var.sortScore = 1
            if var.state == 0 then
                var.sortScore = 10000
            elseif var.state == 1 then
                var.sortScore = 1000000
            elseif var.state == 2 then
                var.sortScore = 100
            end
        
            var.sortScore = var.sortScore+50-var.id
        end
        --数据排序
        table.sort(pd.task[csbName[var.rewardId].voName],
            function(a,b)
                return a.sortScore > b.sortScore
            end)
        
        preLoad:updateRelese()
        
        for key, var in pairs(pd.task[csbName[var.rewardId].voName]) do
            local oneItem = preLoad:getPanel("daytask")--list:getItem(key-1)
            list:pushBackCustomItem(oneItem)
--            if oneItem == nil then
--                oneItem = self.daytask:getChildByName("panel_daily"):getChildByName("panel_daily"):clone()
--                list:pushBackCustomItem(oneItem)
--            end
            
            --图标
            local icon = oneItem:getChildByName("icon_task_item")
            icon:loadTexture(gDailyTask[var.id].icon,ResType)
            icon:setScale(gDailyTask[var.id].iconzoom)


            --名字
            oneItem:getChildByName("text_name"):setString( StringRes[gDailyTask[var.id].name])

            --进度
            if var.state ~= 0 then
                oneItem:getChildByName("text_status"):setString(StringRes.task_finish)
            else
                --t:getChildByName("Text_3"):setString(StringRes.task_unfinish)
                --进度
                oneItem:getChildByName("text_status"):setString(var.count.."/"..var.allCount)
            end
            

            
            --描述
            local about  = oneItem:getChildByName("btn_info")
            about:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    --self:showAboutInfo(about.var)
                    TaskReward:showDaily(self,var)
                end
            end)



            --前往和领取
            local qianwang  = oneItem:getChildByName("btn_go")
            qianwang:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)

                    self:GotoHere(gDailyTask[var.id])

                end
            end)
            local getreward = oneItem:getChildByName("btn_get")
            getreward:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                
                
                    local msg = {taskId = var.id}
                    Connect:sendMsg("TaskAction","getTaskDailyReward",msg,
                        function(data)
                            local pd = PlayerData:getInstanse()    
                            --更新数据
                            pd.basicData = data.playerInfoVO
                            
                            pd.task.taskDailyShowVOs = data.taskDailyShowVOs
                            
                            var.state = 2
                            self:freshDayTask()
                            FlyWordPrompt:prompt(self:getLittleDayNotice(var.id))
                        end)
                end
            end)
            if var.state == 0 then
                qianwang:setVisible(true)
                getreward:setVisible(false)
                oneItem:getChildByName("icon_task_complete"):setVisible(false)
                Animation:stopAnimation(getreward,gUIeffect[9].effect)
            elseif var.state == 1 then
                qianwang:setVisible(false)
                getreward:setVisible(true)
                oneItem:getChildByName("icon_task_complete"):setVisible(false)
                Animation:playAnimation(getreward,gUIeffect[9].effect,true,15)
            elseif var.state == 2 then
                qianwang:setVisible(false)
                getreward:setVisible(false)
                oneItem:getChildByName("icon_task_complete"):setVisible(true)
                Animation:stopAnimation(getreward,gUIeffect[9].effect)
            end
            
            
    	end
    end
    
    
    
end




function TaskInfo:initTabs()
    self:registerTabEvent(1,function()
        self:freshTask()
        self:freshDayTask()
        self:ViewPage(self.task)
    end)
    self:registerTabEvent(2,function()
        
        self:freshTask()
        self:freshDayTask()
        self:ViewPage(self.daytask)
       
    end)
    
    self:setTabSelect(1)
end

return TaskInfo