local TerritoriesContend = class("TerritoriesContend",function(parent,data)
    return PanelTabLayer.new(parent,{"",tabs={StringRes.earawar_5,StringRes.earawar_6}})
end)

function TerritoriesContend:show(parent,data_terrId)
    Connect:sendMsg("GuildwarAction","openTerritory",{terrId = data_terrId},
        function(data)
            local layer = TerritoriesContend.new(parent,data)
            parent:addChild(layer)
            NodeTranslator:transUp(layer,nil)
        end)
end

function TerritoriesContend:checkCanAtk(parent,data_terrId,data_sId,needUpdate)
    local msg = {terrId = data_terrId,sId = data_sId,needUpdate=needUpdate}
    Connect:sendMsg("GuildwarAction","canatkStrongpoint",msg,
        function(data)
            if data.state == 1 then
                local TroopsView = require("src/app/views/troops/TroopsView")
                TroopsView:open(parent,8,msg)
            end
        end)
end

function TerritoriesContend:initData(data)
    self.data = data
    for k,v in pairs(self.data.strongpointVOs) do
        AcademyCommon:copyValues(v,gStrongpoint[v.id])
    end
end

function TerritoriesContend:updateServer(dt)
    if not IS_BATTLING then --战斗中不刷新
        Connect:sendMsg("GuildwarAction","openTerritory",{terrId = self.data.terrId},
            function(data)
                self:initData(data)
                self:updateView()
            end)
    end
end

function TerritoriesContend:ctor(parent,data)
    self.nowPage = -1 -- -1为未来取过log
    self.data = {}
    self:initData(data)
    self.content = CCUILoader:load("res/csd/operation_center/territories_war/ui_territories_contend.csb")
    self:addChild(self.content)

    self.tabs = {self.content:getChildByName("panel_stronghold_bg"),self.content:getChildByName("panel_header_bg")}

    self:initTabs()
    self:initView()

    local Scheduler = cc.Director:getInstance():getScheduler()
    self.updateId = Scheduler:scheduleScriptFunc(handler(self,self.updateAtkTime), 1, false)
    self.updateServerId = Scheduler:scheduleScriptFunc(handler(self,self.updateServer), 30, false)
    local function onNodeEvent(tag)
        if tag == "exit" then
            Scheduler:unscheduleScriptEntry(self.updateId)
            Scheduler:unscheduleScriptEntry(self.updateServerId)
        end
    end
    self:registerScriptHandler(onNodeEvent)
    self:registerTabEvent("close",function()
        self:getParent():fresh()
    end)
end

function TerritoriesContend:initView()
    self.tabs[1]:getChildByName("btn_info"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.earawar_12))
        end
    end)
    self.mMap = self.tabs[1]:getChildByName("scrollview_map"):getChildByName("panel_map_bg")
    self.mMap:setBackGroundImage(gTerritory[self.data.terrId].t_map)

    self.content:getChildByName("text_name"):setString(StringRes[gTerritory[self.data.terrId].name])
    self.panel_gain_bg = self.tabs[1]:getChildByName("panel_gain_bg")
    for k,v in pairs(gGuildwarbuffshop) do
        local item = self.panel_gain_bg:getChildByName("icon_item_0"..v.id)
        Common:changePic(item,v.icon)
        item:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                v.title = v.name
                v.count = self.data["buff"..v.id]
                require("app/views/activity/ItemDetail"):show(self,v)
            end
        end)
    end

    self.panel_black_bg = self.content:getChildByName("panel_black_bg") --点击详细框
    self.panel_black_bg:setPosition(cc.p(-5000,-5000))
    self.panel_scout_bg = self.panel_black_bg:getChildByName("panel_scout_bg")
    self.panel_scout_bg:getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transZoomOut(self.panel_black_bg,function()
                self.panel_black_bg:setPosition(cc.p(-5000,-5000))
            end)
        end
    end)

    self.panel_gain_bg:getChildByName("btn_buy"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:addChild(require("src/app/views/territories_war/BuyBuff").new(self.data.terrId))
        end
    end)

    self.progressbar = self.tabs[1]:getChildByName("progressbar_bg"):getChildByName("progressbar_info")
    self.progressbarRed = self.tabs[1]:getChildByName("progressbar_red"):getChildByName("progressbar_info")
--    self.progressbarRed:loadTexture("res/pic/common/progressbar/bar_building_red.png",ResType)
--    self.progressbar:getParent():addChild(self.progressbarRed,1)
    self.progressbar_text = self.tabs[1]:getChildByName("progressbar_bg"):getChildByName("text_info")
    self.progressbar_textRed = self.tabs[1]:getChildByName("progressbar_red"):getChildByName("Text_73")
--    self.progressbar_text:setLocalZOrder(2)
    local sc = self.tabs[1]:getChildByName("scrollview_map")
    sc:setVisible(false)
    NodeTranslator:deltaDo(0.01,function()
        sc:setVisible(true)
        sc:getInnerContainer():setPosition(cc.p(0,0))
        sc:jumpToPercentBothDirection(cc.p(-(self.mMap:getContentSize().width-sc:getContentSize().width)/2,0))
    end)

--    self.text_info = self.tabs[1]:getChildByName("text_info")
    self.text_time = self.tabs[1]:getChildByName("text_time")
    self.text_prompt = self.tabs[1]:getChildByName("text_prompt")
    self.text_charge = self.panel_scout_bg:getChildByName("text_charge")
    self.icon_coin = self.panel_scout_bg:getChildByName("icon_coin")
    self.text_charge:setString(self.data.restAtkCDcost)
    self.btn_attack = self.panel_scout_bg:getChildByName("btn_attack")
    self.text_desc_01 = self.panel_scout_bg:getChildByName("text_desc_01")
    self.text_desc_02 = self.panel_scout_bg:getChildByName("text_desc_02")
    showShader:buttonToGray(self.btn_attack)
    
--    self.tabs[1]:getChildByName("btn_repair"):addTouchEventListener(function(e, t)
--        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
--            local TroopsView = require("src/app/views/troops/TroopsView")
--            TroopsView:open(self,1,nil,3)
--        end
--    end)

    local pos_arrow = self.tabs[1]:getChildByName("pos_arrow")
    self.arrow_green = Animation:createAnimation("res/art/skill/skillbuff;skillbuff_green_loop;loop_play")
    pos_arrow:addChild(self.arrow_green)

    local pos_arrow_red = self.tabs[1]:getChildByName("pos_arrow_red")
    self.arrow_red= Animation:createAnimation("res/art/skill/skillbuff;skillbuff_red_loop;loop_play")
    pos_arrow_red:addChild(self.arrow_red)

    self:updateAtkTime(0)
    self:updateView()
end

function TerritoriesContend:updateAtkTime(dt)
    if self.data.atkCD > 0 then
        self.data.atkCD = math.floor(self.data.atkCD - dt)
        if self.data.atkCD < 0 then
            self.data.atkCD = 0
            self:updateBtnInfo()
        end
        self.text_time:setVisible(true)
        self.text_prompt:setVisible(false)
        self.text_time:setString(string.format(StringRes.earawar_21,StringTemp:toTime(self.data.atkCD)))
    else
        self.text_time:setVisible(false)
        self.text_prompt:setVisible(true)
    end
end

function TerritoriesContend:updateBtnInfo()
    local x,y  = self.panel_black_bg:getPosition()
    local isSelected = not (x == -5000 and y == -5000)
    self.text_charge:setVisible(isSelected and self.data.atkCD > 0)
    self.icon_coin:setVisible(isSelected and self.data.atkCD > 0)
    Common:setBtnTouchEnable(self.btn_attack,isSelected)
    if self.data.atkCD > 0 then
        --重置
        self.btn_attack:setTitleText(StringRes.earawar_24) 
        self.btn_attack:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                local need = self.data.restAtkCDcost
                DialogUtil:buyWithTitle(need,string.format(StringRes.earawar_25,need),function()
                    Connect:sendMsg("GuildwarAction","resetGuildWarAtkCd",{},
                        function(data)
                            if data.state == 1 then
                                local pd = PlayerData:getInstanse().basicData
                                pd.gold = data.gold
                                if data.restAtkCDcost then
                                    self.data.restAtkCDcost = data.restAtkCDcost
                                end
                                self.text_charge:setString(self.data.restAtkCDcost)
                                self.data.atkCD = 0
                                self:updateAtkTime(0)
                                self:updateBtnInfo()
                            end
                        end)
                end)

            end
        end)
    else
        --攻击
        self.btn_attack:setTitleText(StringRes.attacking)
        self.btn_attack:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                self.panel_black_bg:setPosition(cc.p(-5000,-5000))
                self:checkCanAtk(self,self.data.terrId,self.selectSid,true)
            end
        end)
    end
end

function TerritoriesContend:updateView()
    local pd = PlayerData:getInstanse().basicData
--    if pd.guildId ~= 0 and (self.data.guildId == pd.guildId or self.data.tempGuildId == pd.guildId) then
--        self.progressbar:setVisible(true)
--        self.progressbarRed:setVisible(false)
--        self.progressbar:setPercent(self.data.occupy*100)
--        if self.data.occupy < 0.6 then
--            self.text_info:setString(StringRes.earawar_10)
--        else
--            self.text_info:setString(StringRes.earawar_9)
--        end
--    else
--        self.progressbar:setVisible(false)
--        self.progressbarRed:setVisible(true)
--        self.progressbarRed:setPercent(self.data.occupy*100)
--        self.text_info:setString(StringRes.earawar_10)
--    end
--    self.progressbar_text:setString(string.format("%0.2f%%",self.data.occupy*100))
    if self.data.guildId == pd.guildId or self.data.tempGuildId == pd.guildId then
        self.progressbar_text:setString(string.format("%0.2f%%",self.data.occupy*100))
        self.progressbar_textRed:setString("")
        self.progressbar:setPercent(self.data.occupy*100)
        self.progressbarRed:setPercent(0)
        
        if self.data.occupy == 1 then
            self.arrow_green:setVisible(false)
            self.arrow_red:setVisible(false)
        elseif self.data.armark == -1 then
            self.arrow_green:setVisible(true)
            self.arrow_red:setVisible(false)
            self.arrow_green:setRotation(90)
        elseif self.data.armark == 1 then
            self.arrow_green:setVisible(true)
            self.arrow_red:setVisible(false)
            self.arrow_green:setRotation(-90)
        else
            self.arrow_green:setVisible(false)
            self.arrow_red:setVisible(false)
        end
        
    else
        self.progressbar_text:setString("")
        self.progressbar_textRed:setString(string.format("%0.2f%%",self.data.occupy*100))
        self.progressbar:setPercent(0)
        self.progressbarRed:setPercent(self.data.occupy*100)
        
        if self.data.occupy == 1 then
            self.arrow_green:setVisible(false)
            self.arrow_red:setVisible(false)
        elseif self.data.armark == -1 then
            self.arrow_green:setVisible(false)
            self.arrow_red:setVisible(true)
            self.arrow_red:setRotation(90)
        elseif self.data.armark == 1 then
            self.arrow_green:setVisible(false)
            self.arrow_red:setVisible(true)
            self.arrow_red:setRotation(-90)
        else
            self.arrow_green:setVisible(false)
            self.arrow_red:setVisible(false)
        end
        
    end

    self.mMap:removeAllChildren()
--    self.icon_ligth = self.tabs[1]:getChildByName("icon_ligth"):clone()
--    self.icon_ligth:setPosition(cc.p(-500,-500))
--    self.mMap:addChild(self.icon_ligth)
    
--    local panel_scout_bg = self.tabs[1]:getChildByName("panel_scout_bg"):clone()
--    self.panel_scout_bg = panel_scout_bg
--    panel_scout_bg:setPosition(cc.p(-500,-500))
--    self.mMap:addChild(panel_scout_bg,10)
    local text_desc = self.content:getChildByName("text_desc")
    if self.data.guildId == 0 then
        text_desc:setString(StringRes.earawar_7)
        text_desc:setColor(CommonColor.Red)
    else
        text_desc:setString(string.format(StringRes.earawar_8,self.data.guildName))
        if self.data.guildId == pd.guildId then
            text_desc:setColor(CommonColor.Green)
        else
            text_desc:setColor(CommonColor.Red)
        end
    end
    for k,v in pairs(self.data.strongpointVOs) do
        local image = ccui.ImageView:create(v.pic,ResType)
        image:setPosition(v.coordinate)
        image:setTouchEnabled(true)
        if v.guildId == pd.guildId then
            image:setColor(CommonColor.Green)
        elseif v.playerId > 0 then
            image:setColor(CommonColor.Red)
        end
        if v.playerId == pd.playerId then
            local flag = self.tabs[1]:getChildByName("icon_flag"):clone()
            local size = image:getContentSize()
            flag:setPosition(size.width/2,size.height/2)
            image:addChild(flag)
        end

        image:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                self.selectSid = v.id
--                local mapH = self.mMap:getContentSize().height
--                local tmp = v.coordinate.y + (image:getContentSize().height*1.5)+24 - mapH
--                if tmp > 0 then
--                    panel_scout_bg:setPosition(cc.pAdd(v.coordinate,cc.p(0,image:getContentSize().height/2-tmp)))
--                else
--                    panel_scout_bg:setPosition(cc.pAdd(v.coordinate,cc.p(0,image:getContentSize().height/2)))
--                end
--                self.icon_ligth:setScale(image:getContentSize().width/self.icon_ligth:getContentSize().width*1.1)
                self.panel_black_bg:setPosition(cc.p(CONFIG_SCREEN_WIDTH/2,CONFIG_SCREEN_HEIGHT/2))
                
                if v.inName == "" then
                    self.text_desc_01:setString("")
                    self.text_desc_02:setString(StringRes.earawar_29)
                else
                    local tmp = StringRes[v.inName]
                    if tmp then
                        self.text_desc_01:setString(string.format(StringRes.earawar_28,tmp))
                    else
                        self.text_desc_01:setString(string.format(StringRes.earawar_28,v.inName))
                    end
                    self.text_desc_02:setString("")
                end
                
                local panel_scout_bg = self.panel_scout_bg
                panel_scout_bg:getChildByName("text_name"):setString(v.name)
                panel_scout_bg:getChildByName("text_desc"):setString(string.format(StringRes.earawar_22,v.occupy))
                panel_scout_bg:getChildByName("btn_scout"):addTouchEventListener(function(e, t)
                    if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
--                        self.icon_ligth:setPosition(cc.p(-500,-500))
                        PromptView:type2(StringRes.notice,
                            string.format(StringRes.spy_1,v.cost )
                            ,StringRes.ok,StringRes.cancel,
                            function()
                                self.panel_black_bg:setPosition(cc.p(-5000,-5000))
                                Connect:sendMsg("GuildwarAction","spyStrongpoint",{terrId = self.data.terrId,sId = v.id},
                                    function(data)
                                        pd.crystal = data.crystal
                                        local ReportView = require("src/app/views/mail/ReportView")
                                        ReportView:openByInfo(self,data.warRecordInfoVO,false)
                                    end)
                            end)

                    end
                end)
                self:updateBtnInfo()
            end
        end)
        self.mMap:addChild(image,1)
    end
    self.mMap:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self.panel_black_bg:setPosition(cc.p(-5000,-5000))
--            self.icon_ligth:setPosition(cc.p(-500,-500))
            self:updateBtnInfo()
        end
    end)


    for k,v in pairs(gGuildwarbuffshop) do
        local item = self.panel_gain_bg:getChildByName("icon_item_0"..v.id)
        item:getChildByName("num_desc"):setString("x"..self.data["buff"..v.id])
    end

    self:updateBtnInfo()
end

function TerritoriesContend:showTab(index)
    for i,v in ipairs(self.tabs)do
        v:setVisible(i == index)
    end
end

function TerritoriesContend:initTabs()
    self:registerTabEvent(1,function()
        self:showTab(1)
        self.nowPage = -1
        self.tabs[2]:getChildByName("listview_log"):removeAllItems()
    end)
    self:registerTabEvent(2,function()
        self:showTab(2)
        if self.nowPage == -1 then 
            self.nowPage = 1
            self:getLogData()
        end
    end)

    self:setTabSelect(1)
end

--log
function TerritoriesContend:getLogData()
    local msg = {nowPage = self.nowPage,type = 2}
    Connect:sendMsg("GuildAction","openGuildInfo",msg,function(data)
        self:pushItems(data)
    end)
end

function TerritoriesContend:pushItems(data)
    if data then
        local temItem = self.tabs[2]:getChildByName("panel_event")
        local listview = self.tabs[2]:getChildByName("listview_log")
        local panel_more = self.tabs[2]:getChildByName("panel_more")
        for i,v in ipairs(data.data) do
            local item = temItem:clone()
            local text_time = item:getChildByName("text_time")
            text_time:setString(StringTemp:serverTimetoDate(v.recordTime))
            local text_event = item:getChildByName("text_event")
            if v.type == 1 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.joinName))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 2 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.outName))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 3 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.kickName))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 4 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.upName))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 5 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.downName))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 6 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],gGuildtech[v.techId].name,v.techlv))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 7 then
                local armyGuild = v.armyGuild
                if armyGuild ~= "" then
                    armyGuild= "("..armyGuild..")"
                end
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.guildPlayerName,v.armyName,armyGuild,StringTemp:toNum(v.robCount)))
            elseif v.type == 8 then
                local tagId = v.charId.."_"..v.missionId
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.guildPlayerName,gGuildFb[tagId].fbname,v.addGuildExp,gGuildFbReward[tagId].boxname))
            elseif v.type == 9 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.armyGuild,StringRes[gTerritory[v.terrId].name]))
                text_event:setColor(CommonColor.Red)
                text_time:setColor(CommonColor.Red)
            elseif v.type == 10 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],StringRes[gTerritory[v.terrId].name]))
                text_event:setColor(CommonColor.Green)
                text_time:setColor(CommonColor.Green)
            elseif v.type == 11 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.guildPlayerName,StringRes[gTerritory[v.terrId].name],gGuildwarbuffshop[v.buffId].name))
                text_event:setColor(CommonColor.Purple)
                text_time:setColor(CommonColor.Purple)
            elseif v.type == 12 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],v.guildPlayerName,StringRes[gTerritory[v.terrId].name],gStrongpoint[v.sId].name))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 13 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],StringRes[gTerritory[v.terrId].name],gStrongpoint[v.sId].name,v.armyGuild,v.armyName))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            elseif v.type == 14 then
                text_event:setString(string.format(StringRes["army_group_log_"..v.type],StringRes[gTerritory[v.lostTerrId].name]))
                text_event:setColor(CommonColor.White)
                text_time:setColor(CommonColor.White)
            end

            listview:pushBackCustomItem(item)
        end

        if data.hasNext then
            local btn_more = panel_more:clone()
            btn_more:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    e:removeFromParent()
                    self.nowPage = self.nowPage + 1
                    self:getLogData()
                end
            end)
            listview:pushBackCustomItem(btn_more)
        end
    end
end

return TerritoriesContend