



TerritoriesWar = class("TerritoriesWar",function(data)
    return PanelTabLayer.new(data,{title=StringRes.earawar_1,tabs={StringRes.earawar_2,StringRes.earawar_3}})
end)
local Scheduler = cc.Director:getInstance():getScheduler()

function TerritoriesWar:ctor(data)
    self.earawarInfo = nil
    self.earawarRank = nil
    
    
    --新服关卡信息
    self.Panel = CCUILoader:load("res/csd/operation_center/territories_war/ui_territories_war.csb")
    self:addChild(self.Panel)


    self.Animation = cc.CSLoader:createTimeline("res/csd/operation_center/territories_war/ui_territories_war.csb")
    self.Panel:runAction(self.Animation)
    self.Animation:gotoFrameAndPlay(0,80,true)
    
    
    self.earawarInfo = self.Panel:getChildByName("panel_mask"):getChildByName("panel_territories")
    self.earawarRank = self.Panel:getChildByName("panel_mask"):getChildByName("panel_ranking")
    
    local sc = self.earawarInfo:getChildByName("scrollview_map")
    --sv:jumpToPercentBothDirection(cc.p(-1000,100))
    self.Panel:setVisible(false)
    NodeTranslator:deltaDo(0.2,function()
        self.Panel:setVisible(true)
        

        local inner = sc:getInnerContainer():setPosition(cc.p(0,0))
        sc:jumpToPercentBothDirection(cc.p(-561+640/2,-240))
    end)
    
    
    self.moveLen = 0
    local function update(parameters)

        if self.moveLen ~= 0 then
            local x,y = sc:getInnerContainer():getPosition()
            sc:jumpToPercentBothDirection( cc.p(self.moveLen,0))
        end

    end
    
    local function onNodeEvent(tag)
        if tag == "enter" then
            self.update = Scheduler:scheduleScriptFunc(update, 0.01, false)
        elseif tag == "exit" then
            Scheduler:unscheduleScriptEntry(self.update)
        end
    end
    self:registerScriptHandler(onNodeEvent)
    
    
    
    --选中动画
    self.arrow_green = Animation:createAnimation("res/art/skill/skillbuff;skillbuff_green_loop;loop_play")
    --self.arrow_green:setRotation()
    sc:addChild(self.arrow_green) 
    self.arrow_green:setPosition(cc.p(-280,40))
    
    
    self.data = data
    self:initTabs()
end



function TerritoriesWar:resetContent()
    if self.earawarInfo then self.earawarInfo:setVisible(false) end
    if self.earawarRank then self.earawarRank:setVisible(false) end
end

function TerritoriesWar:ViewPage(page)
    if self.earawarInfo then self.earawarInfo:setVisible(false) end
    if self.earawarRank then self.earawarRank:setVisible(false) end

    page:setVisible(true)
end


function TerritoriesWar:fresh()
    Connect:sendMsg("GuildwarAction","openGuildwar",nil,
        function(data)
            local pd = PlayerData:getInstanse()
            --更新数据
            self.data = data
            self:FreshEarawarInfo()
            self:FreshEarawarRank()
        end)
end


function TerritoriesWar:FreshEarawarInfo()

    local pd = PlayerData:getInstanse()


    --军团名称
    self.earawarInfo:getChildByName("panel_title"):getChildByName("text_name"):setString(pd.basicData.guildName)

    --关于按钮
    local about = self.earawarInfo:getChildByName("panel_title"):getChildByName("btn_info")
    about:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect) 
            local DescriptView = require("src/app/views/prompt/DescriptView")
            DescriptView:open(self,StringTemp:Descript(StringRes.earawar_4))
        end
    end)

    --领地数量
    self.earawarInfo:getChildByName("panel_title"):getChildByName("text_info_num"):setString(self.data.count)

    --资源产出加速
    self.earawarInfo:getChildByName("panel_title"):getChildByName("text_desc_01_num"):setString((self.data.speedUp*100).."%")

    --金币收益
    self.earawarInfo:getChildByName("panel_title"):getChildByName("text_desc_02_num"):setString(self.data.gold)

    --维护费用
    self.earawarInfo:getChildByName("panel_title"):getChildByName("text_desc_03_num"):setString(self.data.keepcost)













    local sc = self.earawarInfo:getChildByName("scrollview_map")
    
    
    --向左移动按钮
    local moveLeftBtn = self.earawarInfo:getChildByName("btn_left")
    moveLeftBtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then
            self.moveLen = 0
        elseif t == ccui.TouchEventType.began then MyAudio:PlayEffect(MusicAndEffect.btnEffect) 
            self.moveLen = 10
        end
    end)
    
    --向右移动按钮
    local moveRightBtn = self.earawarInfo:getChildByName("btn_right")
    moveRightBtn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then
            self.moveLen = 0
        elseif t == ccui.TouchEventType.began then MyAudio:PlayEffect(MusicAndEffect.btnEffect) 
            self.moveLen = -10
        end
    end)

   -- self.data.territoryVOs[1].guildId =  pd.basicData.guildId  
   -- self.data.territoryVOs[3].guildId =  pd.basicData.guildId 
   -- self.data.territoryVOs[8].guildId =  3
   -- self.data.territoryVOs[9].guildId =  4
   -- self.data.territoryVOs[10].guildId =  5
   -- self.data.territoryVOs[2].guildId =  pd.basicData.guildId 

    --己方军团占领领地号
    local myGuildId = {}
    --相邻领地号
    local adjoinId = {}
    --可攻击领地号
    local canAttack = {}
    for key, var in pairs(self.data.territoryVOs) do
        if var.guildId == pd.basicData.guildId then
            myGuildId[var.id] = var

            local ids = StringTemp:Split(gTerritory[var.id].adjoinNO,",") 
            for key1, var1 in pairs(ids) do
                adjoinId[var.id.."_"..var1] = {from = var.id,to = tonumber(var1)}
            end
        end
    end

    --隐藏所有箭头
    local children = sc:getChildByName("panel_map"):getChildren()
    for key, var in pairs(children) do
        if string.find(var:getName(),"arrow") ~= nil then
            var:setVisible(false)
        end
    end
    --显示可攻击领地箭头
    for key, var in pairs(adjoinId) do
        if myGuildId[var.to] == nil then
            canAttack[var.from.."_"..var.to] = {from = var.from,to = var.to}
            local item = sc:getChildByName("panel_map"):getChildByName("arrow_"..var.from.."_"..var.to)
            if item ~= nil then
                item:setVisible(true)
            end
    	end
    end
    
    --显示领地详细信息
    local function showLingDiInfo(data)
    
        self.oneData = data
        --侦查
        local scout = self.earawarInfo:getChildByName("panel_item"):getChildByName("btn_scout")
        showShader:buttonToGray(scout)
    
        if data ~= nil then
            --领地名称
            self.earawarInfo:getChildByName("panel_item"):getChildByName("text_desc_01_num"):setString(StringRes[gTerritory[data.id].name])
            --所属军团
            local gn = data.guildName
            if data.guildName == "" then
                gn = StringRes.null
            end
            self.earawarInfo:getChildByName("panel_item"):getChildByName("text_desc_02_num"):setString(gn)
            --领地收益
            self.earawarInfo:getChildByName("panel_item"):getChildByName("text_desc_03_num"):setString(
                string.format(StringRes.earawar_20,data.speedUp*100,data.gold))
                
            local item = sc:getChildByName("panel_map"):getChildByName("territories_"..data.id)
            local x,y = item:getPosition()
            --self.arrow_green:setPosition(cc.p(x,y))

            --选中效果
            --隐藏所有箭头
            local children = sc:getChildByName("panel_map"):getChildren()
            for key, var in pairs(children) do
                if string.find(var:getName(),"icon_chapter") ~= nil then
                    if var:getName() == "icon_chapter_"..data.id then
                        showShader:toNormal(var)
                    else
                        showShader:toGray(var)
                    end

                end
                if string.find(var:getName(),"icon_light") ~= nil then
                    if var:getName() == "icon_light_"..data.id then
                        var:setVisible(true)
                    else
                        var:setVisible(false)
                    end
                end
            end
               
            

            Common:setBtnTouchEnable(scout,true)
            scout:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect) 
                    require("app/views/territories_war/TerritoriesContend"):show(self,data.id)
                    
                end
            end)
        else
            --领地名称
            self.earawarInfo:getChildByName("panel_item"):getChildByName("text_desc_01_num"):setString("")
            --所属军团
            self.earawarInfo:getChildByName("panel_item"):getChildByName("text_desc_02_num"):setString(StringRes.null)
            --领地收益
            self.earawarInfo:getChildByName("panel_item"):getChildByName("text_desc_03_num"):setString(StringRes.null)

            Common:setBtnTouchEnable(scout,false)


            --选中效果
            --隐藏所有箭头
            local children = sc:getChildByName("panel_map"):getChildren()
            for key, var in pairs(children) do
                if string.find(var:getName(),"icon_chapter") ~= nil then
                    showShader:toGray(var)
                    --var:setVisible(false)
                end
                if string.find(var:getName(),"icon_light") ~= nil then
                    var:setVisible(false)
                    --var:setVisible(false)
                end
            end
        end
    
        
    end
    
    --所有领地
    
    for key, var in pairs(self.data.territoryVOs) do
    
        local item = sc:getChildByName("panel_map"):getChildByName("territories_"..var.id)
    
        if var.guildId == pd.basicData.guildId then
    		--自己军团
            -- item:getChildByName("red"):setVisible(false)
            -- item:getChildByName("green"):setVisible(true)
            item:setColor(cc.c3b(0,255,24))
            
    	elseif var.guildId ~= 0 then
    	    -- item:getChildByName("red"):setVisible(true)
         --    item:getChildByName("green"):setVisible(false)
         item:setColor(cc.c3b(255,0,0))
            
    	else
            -- item:getChildByName("red"):setVisible(false)
            -- item:getChildByName("green"):setVisible(false)
            item:setColor(cc.c3b(255,255,255))
    	end
    	local item1 = sc:getChildByName("panel_map"):getChildByName("icon_chapter_"..var.id)
        item1:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect) 
                showLingDiInfo(var)
            end
        end)
    	
    end
    showLingDiInfo(self.oneData)
    
    
    
    
end


function TerritoriesWar:FreshEarawarRank()


    local list = self.earawarRank:getChildByName("panel_info_bg"):getChildByName("listview_ranking")
    list:removeAllItems()
    
    --自己
    local myitem = self.earawarRank:getChildByName("panel_info_bg"):getChildByName("panel_honor_player"):clone()
    local rank = "--"
    if self.data.territoryRankVO.rank > 0 then
        rank = self.data.territoryRankVO.rank
    end
    myitem:getChildByName("panel_bg"):getChildByName("text_ranking"):setString( rank )
    --名字
    myitem:getChildByName("panel_bg"):getChildByName("text_name"):setString( self.data.territoryRankVO.guildName )
    --等级
    myitem:getChildByName("panel_bg"):getChildByName("text_lev"):setString( self.data.territoryRankVO.lv )
    --值
    myitem:getChildByName("panel_bg"):getChildByName("text_territories"):setString( self.data.territoryRankVO.count )
    list:pushBackCustomItem(myitem)
    
    
    for var=1, 30 do

        if self.data.territoryRankVOs[var] == nil then
            break
        end

        local item = nil
        --自己
        if var == 1 then
            item = self.earawarRank:getChildByName("panel_info_bg"):getChildByName("panel_honor_1st"):clone()
        elseif var == 2 then
            item = self.earawarRank:getChildByName("panel_info_bg"):getChildByName("panel_honor_2nd"):clone()
        elseif var == 3 then
            item = self.earawarRank:getChildByName("panel_info_bg"):getChildByName("panel_honor_3rd"):clone()
        else
            item = self.earawarRank:getChildByName("panel_info_bg"):getChildByName("panel_honor_other"):clone()
            item:getChildByName("panel_bg"):getChildByName("text_ranking"):setString( self.data.territoryRankVOs[var].rank )
        end

        --名字
        item:getChildByName("panel_bg"):getChildByName("text_name"):setString( self.data.territoryRankVOs[var].guildName )
        --等级
        item:getChildByName("panel_bg"):getChildByName("text_lev"):setString( StringTemp:toNum(self.data.territoryRankVOs[var].lv) )
        --值
        item:getChildByName("panel_bg"):getChildByName("text_territories"):setString( (self.data.territoryRankVOs[var].count) )

        list:pushBackCustomItem(item)
    end
end

function TerritoriesWar:initTabs()
    self:registerTabEvent(1,function()

        self:FreshEarawarInfo()
        self:ViewPage(self.earawarInfo)
    end)
    self:registerTabEvent(2,function()
        self:FreshEarawarRank()
        self:ViewPage(self.earawarRank)
    end)
    
    self:setTabSelect(1)
end

return TerritoriesWar