
local TaskExeBar = class("TaskExeBar",function(node)
    return node
end)

function TaskExeBar:ctor(node)
    self.ListData = {}
    self.Items = {}
    self:init()
end

local timeSchs = {}
local timeSchsDetail = nil

local Scheduler = cc.Director:getInstance():getScheduler()

local moveActionTag = 9993
local moveTime = 0.5

local ResourceName = {"crystal","iron_ore","oil","vanadium","titanium",[6] = "Rebel_name1",
    [7] = "Rebel_name2",
    [8] = "Rebel_name3",
    [9] = "Rebel_name4",
    [10] = "Rebel_name5",
    [11] = "Rebel_name6",}

local TypeIcons = {"icon_crystal","icon_copper","icon_oil","icon_iron","icon_ore"}

local ItemCfg = {
    --前往
    {
        "btn_go",--按钮
        "icon_attack",--图标
        "progressbar_01",--进度条
    },
    --采集
    {
        "btn_return",
        "TypeIcons",
        "progressbar_01",
    },
    --返回
    {
        "btn_go",
        "icon_return",
        "progressbar_02",
    },
    --待命中
    {
        "btn_return",
        "icon_flag",
        "progressbar_01",
    },
    --驻军防御中
    {
        "btn_return",
        "icon_flag",
        "progressbar_01",
    },
    --前往驻军
    {
        "btn_go",
        "icon_attack",
        "progressbar_01",
    },
    --返回驻军
    {
        "btn_go",
        "icon_return",
        "progressbar_02",
    },
    --据点占领
    {
        "btn_return",
        "icon_return",
        "progressbar_01",
    },
}

local function getTypeIconsNodeName(info)
    local tmp = ItemCfg[info.type][2]
    if tmp == "TypeIcons" then
        tmp = TypeIcons[info.resType]
    end
    return tmp
end

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local ended = ccui.TouchEventType.ended

--一个时序结束
function TaskExeBar:endTimeInfo(id,isSingle)
    local eId = timeSchs[id]
    if eId then
        Scheduler:unscheduleScriptEntry(eId)
        timeSchs[id] = nil
    end
    if isSingle then
        if timeSchsDetail then
            Scheduler:unscheduleScriptEntry(timeSchsDetail)
        end
        timeSchsDetail = nil
    end
end

--所有时序
function TaskExeBar:endTimeScheduler()
    for k,v in pairs(timeSchs) do
        Scheduler:unscheduleScriptEntry(v)
    end
    timeSchs = {}
    if timeSchsDetail then
        Scheduler:unscheduleScriptEntry(timeSchsDetail)
    end
    timeSchsDetail = nil
end

--时序计时
function TaskExeBar:startTimeSch(item,info)
    local UIScaleBack = item:getChildByName("Image_scaleback")
    local UIScale = UIScaleBack:getChildByName("LoadingBar_scale")
    local UIScaleDescript = UIScaleBack:getChildByName("Text_descript")
    local funcs = {
        function(interval)
            --info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString(string.format(StringRes.arrive_time,
                StringTemp:toTime(info.time)))
            UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
            if info.time <= 0 then
                return true
            end
        end,
        function(interval)
            --info.nowRes = info.nowRes + math.floor(interval+0.5)*info.resGather
            UIScaleDescript:setString(string.format(StringRes.collect,
                StringTemp:toNum(info.nowRes),StringTemp:toNum(info.maxRes)))
            UIScale:setPercent(info.nowRes*100/info.maxRes)
            if info.nowRes >= info.maxRes then
                return true
            end
        end,
        function(interval)
            --info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString(string.format(StringRes.return_time,
                StringTemp:toTime(info.time)))
            UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
            if info.time <= 0 then
                return true
            end
        end,
        function(interval)
            UIScaleDescript:setString(StringRes.waiting)
            UIScale:setPercent(100)
            return true
        end,
        function(interval)
            UIScaleDescript:setString(StringRes.defensing)
            UIScale:setPercent(100)
            return true
        end,
        function(interval) --驻军行进
            --info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString(string.format(StringRes.arrive_time,
                StringTemp:toTime(info.time)))
        UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
        if info.time <= 0 then
            return true
        end
        end,
        function(interval) --驻军返回
            --info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString(string.format(StringRes.return_time,
                StringTemp:toTime(info.time)))
        UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
        if info.time <= 0 then
            return true
        end
        end,
        function(interval)
            UIScaleDescript:setString(StringRes.occuping)
            UIScale:setPercent(100)
            return true
        end,
    }
    if funcs[info.type](0) == nil then
        timeSchsDetail = Scheduler:scheduleScriptFunc(function(time)
            if funcs[info.type](time) then
                self:endTimeInfo(info.troopId,true)
            end
        end,1,false)
    end
end

--xin时序计时
function TaskExeBar:startNewTimeSch(item,info)
    local panel_progressbar_bg = item:getChildByName("panel_progressbar_bg")
    local UIScale = panel_progressbar_bg:getChildByName(ItemCfg[info.type][3])
    UIScale:setVisible(true)
    local UIScaleDescript = item:getChildByName("text_tiem")
    UIScaleDescript:setVisible(true)
    local funcs = {
        function(interval)
            info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString( StringTemp:toTime(info.time))
            UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
            if info.time <= 0 then
                return true
            end
        end,
        function(interval)
            info.nowRes = info.nowRes + math.floor(interval+0.5)*info.resGather
            UIScaleDescript:setString( StringTemp:toTime(math.ceil((info.maxRes-info.nowRes)/info.resGather)))
            UIScale:setPercent(info.nowRes*100/info.maxRes)
            if info.nowRes >= info.maxRes then
                item:getChildByName("text_desc"):setString(StringRes.collectfinished)
                UIScaleDescript:setVisible(false)
                return true
            end
        end,
        function(interval)
            info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString( StringTemp:toTime(info.time))
            UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
            if info.time <= 0 then
                return true
            end
        end,
        function(interval)
            UIScaleDescript:setString(StringRes.standingby)
            UIScale:setPercent(100)
            return true
        end,
        function(interval)
            UIScaleDescript:setString(StringRes.defending)
            UIScale:setPercent(100)
            return true
        end,
        function(interval) --驻军行进
            info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString( StringTemp:toTime(info.time))
            UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
            if info.time <= 0 then
                return true
            end
        end,
        function(interval) --驻军返回
            info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString( StringTemp:toTime(info.time))
            UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
            if info.time <= 0 then
                return true
            end
        end,
        function(interval)
            UIScaleDescript:setString(StringRes.occpuy)
            UIScale:setPercent(100)
            return true
        end,
    }
    if funcs[info.type](0) == nil then
        timeSchs[info.troopId] = Scheduler:scheduleScriptFunc(function(time)
            if funcs[info.type](time) then
                self:endTimeInfo(info.troopId)
            end
        end,1,false)
    end
end

function TaskExeBar:update()

end

function TaskExeBar:init()


    local Scheduler = cc.Director:getInstance():getScheduler()
    self:update(0)
    self.updateId = Scheduler:scheduleScriptFunc(handler(self,self.update), 1, false)
    local function onNodeEvent(tag)
        if tag == "exit" then
            self:endTimeScheduler()
        end
    end
    self:registerScriptHandler(onNodeEvent)

    local btn_up = self:getChildByName("btn_up")
    self.panel_bg = self:getChildByName("panel_bg")
    self.btn_up = btn_up
    self.listview = self.panel_bg:getChildByName("listview_bg")
    self.panel_title_bg = self.panel_bg:getChildByName("panel_title_bg")
    self.text_title = self.panel_bg:getChildByName("text_title")
    btn_up:setSelected(false)
    local moveX = self:getChildByName("panel_bg"):getContentSize().width
    self.moveX = moveX 
    local lastX = self:getPositionX()
    local lastY = self:getPositionY()
    self.lastX = lastX
    self.lastY = lastY
    btn_up:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self:getActionByTag(moveActionTag) then return end
            local tmpX = lastX+moveX
            if btn_up:isSelected() then
                tmpX = lastX
                self:endTimeScheduler()
                self:moveAction(cc.p(tmpX,lastY),function()
                    self.listview:removeAllItems()
                end)
            else
                Connect:sendMsg("WorldAction","getWorldTroopsInfo",nil,
                    function(data)
                        self:endTimeScheduler()
                        self.ListData = {}
                        self.Items = {}
                        local list = {}
                        for k,v in ipairs(data) do
                            list[v.troopId] = v
                        end
                        self.ListData = list
                        self:updataViews(data)
                        self:moveAction(cc.p(tmpX,lastY),nil)
                    end,true)
            end
        end
    end)
end

function TaskExeBar:moveAction(pos,callback)
    self.btn_up:setTouchEnabled(false)
    local action = cc.Sequence:create(cc.MoveTo:create(moveTime,pos),cc.CallFunc:create(function()
        self.btn_up:setTouchEnabled(true)
        if callback then
            callback()
        end
    end))
    action:setTag(moveActionTag)
    self:runAction(action)
end

function TaskExeBar:updataViews(data)
    self.listview:removeAllItems()
    local tmp = self.panel_bg:getChildByName("panel_item_bg")
    self.listview:removeAllChildren()
    for id,info in pairs(self.ListData) do
        local item = tmp:clone()
        self.listview:pushBackCustomItem(item)
        self:updateExcuteNewTaskItem(item,info)
        self.Items[info.troopId] = item
    end
    self:updateViewContentSize()
end

local function getHandleFuncs(info)
    local msg = {troopId=info.troopId}
    local TroopsView = require("src/app/views/troops/TroopsView")
    return {
        function()
            Connect:sendMsg("WorldAction","speedUpWroldTroop",msg,function(newMsg)
                local newInfo = {type=newMsg.nowstate,troopId=newMsg.troopId,
                    time=newMsg.nowTime,allTime=newMsg.allTime,nowRes=newMsg.nowRes,resGather=newMsg.gather,
                    maxRes=newMsg.allGather}
                PlayerData:getInstanse().basicData.gold = newMsg.gold
                TroopsView:serverSetTask(newInfo,newMsg.repairCount,newMsg.type==3)
            end,true)
        end,
        function()
            Connect:sendMsg("WorldAction","gatherBack",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,false)
            end,true)
        end,
        function()
            Connect:sendMsg("WorldAction","speedUpWorldTroopBack",msg,function(newMsg)
                local data = PlayerData:getInstanse().basicData
                data.gold = newMsg.gold
                data.crystal = newMsg.crystal
                data.ferrum = newMsg.fe
                data.oil = newMsg.oil
                data.lead = newMsg.lead
                data.titanium = newMsg.titan
                TroopsView:serverSetTask({troopId=newMsg.troopId},nil,true)
            end,true)
        end,
        function()
            Connect:sendMsg("WorldAction","garrisonBack",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,false)
            end,true)
        end,
        function()
            Connect:sendMsg("WorldAction","garrisonBack",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,false)
            end,true)
        end,
        function() --驻军行进中
            Connect:sendMsg("WorldAction","speedUpGarrison",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,false)
            end,true)
        end,
        function() --驻军返回中
            Connect:sendMsg("WorldAction","speedUpGarrisonBack",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,true)
            end,true)
        end,
        function() --领地返回
            Connect:sendMsg("GuildwarAction","backStrongPoint",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,true)
            end,true)
        end,
    }
end

local function getPromptFunc(info)
    local handleFun = getHandleFuncs(info)[info.type]
    local function spendGold()
        if info.time > 0 then
            local spend = math.ceil(info.time/60)*15
            PromptView:spendGold(spend,handleFun)
        end
    end
    local funcs = {
        spendGold,
        function()
            if info.nowRes >= info.maxRes then
                handleFun()
            else
                PromptView:type2(nil,StringRes.is_collecting,StringRes.ok,StringRes.cancel,handleFun)
            end
        end,
        spendGold,
        handleFun,
        handleFun,
        spendGold,
        spendGold,
        handleFun,
    }
    return funcs[info.type]
end

local function getName(info)
    if info.type == 8 then
        local msg = gStrongpoint[info.sId]
        return string.format("%s(%s)",StringRes["occupy_type_"..msg.type],msg.name)
    else
        local name = (info.atkPlayer and info.atkPlayer~="") and
            info.atkPlayer..string.format(StringRes.LV2,info.atklv) or
            StringRes[ResourceName[info.resType]]..string.format(StringRes.LV2,info.resLv)
        return name..string.format("(%s,%s)",info.x,info.y)
    end
end

local function getNameNew(info)
    if info.type == 8 then
        local msg = gStrongpoint[info.sId]
        return msg.name
    elseif info.type == 2 then
        return StringRes.collecting
    else
        return string.format("(%s,%s)",info.x,info.y)
    end
end

--新一项
function TaskExeBar:updateExcuteNewTaskItem(item,info)
    item:getChildByName("panel_progressbar_bg"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:checkDetail(info)
        end
    end)
    local node_item = item:getChildByName("node_item")
    local typeIcon = self.panel_bg:getChildByName(getTypeIconsNodeName(info)):clone()
    typeIcon:setPosition(cc.p(0,0))
    node_item:removeAllChildren()
    node_item:addChild(typeIcon)
    local panel_progressbar_bg = item:getChildByName("panel_progressbar_bg")
    panel_progressbar_bg:getChildByName("progressbar_01"):setVisible(false)
    panel_progressbar_bg:getChildByName("progressbar_02"):setVisible(false)
    item:getChildByName("btn_return"):setVisible(false)
    item:getChildByName("btn_go"):setVisible(false)
    local UIName = item:getChildByName("text_desc")
    UIName:setString(getNameNew(info))
    self:startNewTimeSch(item,info)
    local UIBack = item:getChildByName(ItemCfg[info.type][1])
    UIBack:setVisible(true)
    UIBack:addTouchEventListener(eventListner(ended,getPromptFunc(info)))
end

--一项
function TaskExeBar:updateExcuteTaskItem(item,info)
    local UIFlag = item:getChildByName("Image_flag")
    local UIName = item:getChildByName("Text_name")
    local UIPrompt = item:getChildByName("Button_prompt")
    local UIBack = item:getChildByName("Button_goback")
    local icons = gTaskBtnIcon[info.type]
    local LoadingBar = item:getChildByName("Image_scaleback"):getChildByName("LoadingBar_scale")
    LoadingBar:loadTexture(icons[4],ResType)
    UIFlag:loadTexture(icons[1])
    UIBack:loadTextures(icons[2],icons[3])
    UIName:setString(getName(info))
    self:startTimeSch(item,info)
    UIPrompt:addTouchEventListener(eventListner(ended,function() --描述
        local TroopsInfoView = require("src/app/views/troops/TroopsInfoView")
        TroopsInfoView:open(gWorldScene,info)
    end))
    UIBack:addTouchEventListener(eventListner(ended,getPromptFunc(info)))
end

function TaskExeBar:checkDetail(data)
    --查看
    local checkUI = cc.uiload:load("res/csd/world/layer_troops_info.csb")
    self.checkUI = checkUI
    self.checkUI.troopId = data.troopId
    local panel_bg = checkUI:getChildByName("panel_mask"):getChildByName("panel_bg")
    panel_bg:getChildByName("btn_close"):addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            NodeTranslator:transZoomIn(panel_bg,function()
                if timeSchsDetail then
                    Scheduler:unscheduleScriptEntry(timeSchsDetail)
                end
                timeSchsDetail = nil
                checkUI:removeFromParent()
                self.checkUI = nil
            end)
        end
    end)
    gWorldScene:addChild(checkUI)
    NodeTranslator:transZoomOut(panel_bg,nil)
    self:updateExcuteTaskItem(panel_bg:getChildByName("Image_mission"),data)
end

--服务器主动推送
function TaskExeBar:serverSetInfo(info,remove)
    if self.btn_up:isSelected() then
        local item = self.Items[info.troopId]
        local old = self.ListData[info.troopId] or {}
        if item then
            self:endTimeInfo(info.troopId)
            if remove then
                self.listview:removeChild(item)
                self.Items[info.troopId] = nil
                self.ListData[info.troopId] = nil
                self:updateViewContentSize()
            else
                for k,v in pairs(info) do
                    old[k] = v
                end
                self:updateExcuteNewTaskItem(item,old)
            end
        end
        if self.checkUI and self.checkUI.troopId == info.troopId then
            if timeSchsDetail then
                Scheduler:unscheduleScriptEntry(timeSchsDetail)
            end
            timeSchsDetail = nil
            if remove then
                self.checkUI:removeFromParent()
            else
                local panel_bg = self.checkUI:getChildByName("panel_mask"):getChildByName("panel_bg")
                self:updateExcuteTaskItem(panel_bg:getChildByName("Image_mission"),old)
            end
        end
    end
end

function TaskExeBar:setInVisible()
    self:setPosition(cc.p(self.lastX,
        self.lastY))
    self.btn_up:setSelected(false)
    self:setVisible(false)
end

function TaskExeBar:setVis(vis)
    if vis then
        self:setVisible(vis)
    else
        self:setInVisible()
    end
end

function TaskExeBar:setBarOpen()
    self:setPosition(cc.p(self.lastX+self.moveX,
        self.lastY))
    self.btn_up:setSelected(true)
    self:setVisible(true)
end

function TaskExeBar:serverUpdateAll(needOpen)
    if self.btn_up:isSelected() or needOpen then
        Connect:sendMsg("WorldAction","getWorldTroopsInfo",nil,
            function(data)
                if needOpen then self:setBarOpen() end
                self:endTimeScheduler()
                self.ListData = {}
                self.Items = {}
                local list = {}
                for k,v in ipairs(data) do
                    list[v.troopId] = v
                end
                self.ListData = list
                self:updataViews(data)
            end,true)
    end
end

function TaskExeBar:updateViewContentSize()
    local num = #(self.listview:getItems())
    if num == 0 then
        self:setInVisible()
        return
    end
    local height = self.panel_bg:getChildByName("panel_item_bg"):getContentSize().height+self.listview:getItemsMargin()
    self.panel_bg:setContentSize(self.panel_bg:getContentSize().width,height*(num+1))
    self.listview:setContentSize(self.listview:getContentSize().width,height*num)
    self.panel_title_bg:setPositionY(height*(num+0.6))
    self.text_title:setPositionY(height*(num+0.56))
    self.listview:setPositionY(height*(num+0.25))
end

return TaskExeBar