
--部队详情
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then 
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

FriendTroopsInfoView = class("FriendTroopsInfoView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.march_descript,
        tabs={}})
end)

function FriendTroopsInfoView:ctor(parent,data)
    self.MainPage = CCUILoader:load("csd/world/troops_garrisoned/Layer_troops_friend_info.csb")
    self:addChild(self.MainPage)
    
    local ui_head = self.MainPage:getChildByName("panel_troops_status")
    self.UIState = ui_head:getChildByName("text_status")
    self.UITime = ui_head:getChildByName("text_time")
    self.UILoad = ui_head:getChildByName("num_capability")
    
    self.UITroops = self.MainPage:getChildByName("panel_troops_info")
    
    self:setOther(data)
    self:setTroops(data.arms)
    self:setBtn(data)
end

--按钮设置
function FriendTroopsInfoView:setBtn(data)
    
    local btn1 = self.MainPage:getChildByName("btn_accept")
    local btn2 = self.MainPage:getChildByName("btn_back")
    showShader:buttonToGray(btn1)
    showShader:buttonToGray(btn2)
    
    
    if data.state == 4 then
        btn1:setTitleText(StringRes.btn_accept)
        btn1:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                local msg = {troopId=data.armyId,garrisonPlayerId=data.playerId}
                Connect:sendMsg("WorldAction","setGarrsion",msg,
                    function(data1)
                        local pd = PlayerData:getInstanse()
                        for key, var in pairs(data1) do
                            pd.FriendTroop[var.playerId..var.armyId] = var
                        end
                        local t = pd.FriendTroop[data.playerId..data.armyId]
                        self:setOther(t)
                        self:setBtn(t)
                        
                    end)
            end
        end)
        
        Common:setBtnTouchEnable(btn1,true)
        Common:setBtnTouchEnable(btn1,true)
    elseif data.state == 5 then
        btn1:setTitleText(StringRes.cancel)
        btn1:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                local msg = {troopId=data.armyId,garrisonPlayerId=data.playerId}
                Connect:sendMsg("WorldAction","cancelGarrsion",msg,
                    function(data1)
                        local pd = PlayerData:getInstanse()
                        pd.FriendTroop[data1.playerId..data1.armyId] = data1
                        
                        self:setOther(data1)
                        self:setBtn(data1)
                        
                    end)
            end
        end)
        
        Common:setBtnTouchEnable(btn1,true)
        Common:setBtnTouchEnable(btn1,true)
    elseif data.state == 6 then
        Common:setBtnTouchEnable(btn1,false)
        Common:setBtnTouchEnable(btn1,false)
	else
	
	end
	
    btn2:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            local msg = {troopId=data.armyId}
            Connect:sendMsg("WorldAction","repatriateGarrison",msg,
                function(data1)
                    local pd = PlayerData:getInstanse()
                    pd.FriendTroop[data1.playerId..data1.armyId] = nil

                    self:removeFromParent()

                end)
        end
    end)
	
end


--其他
function FriendTroopsInfoView:setOther(data)
    
--    local desc = { 
--        [4] = StringRes.defwords_3, 
--        [5] = StringRes.defwords_4, 
--        [6] = StringRes.defwords_2, 
--    }
    self.UIState:setString(StringRes["march_state"..data.state])
    --self.UIState:setString(desc[data.state])
    --local time = data.type == 2 and math.ceil((data.maxRes-data.nowRes)/data.resGather) or data.time
    self.UITime:setString(StringTemp:toTime(data.time))
    self.UILoad:setString(StringTemp:toNum(data.load))
end

--部队
function FriendTroopsInfoView:setTroops(troops)
    for _,info in ipairs(troops) do
        if info.id > 0 then
            local ui_icon = self.UITroops:getChildByName("icon_troop_"..info.index)
            local ui_text = ui_icon:getChildByName("text_troops_"..info.index)
            local msg = Tank[info.id]
            ui_icon:loadTexture(msg.icon,ResType)
            ui_text:setString(string.format("%s(%s)",StringRes[msg.name],info.count))
        end
    end
end

function FriendTroopsInfoView:open(parent,data)
    local newPage = self.new(parent,data)
    parent:addChild(newPage)
end

return FriendTroopsInfoView