
--将领详情查看
-- Created by IntelliJ IDEA.
-- User: HS18
-- Date: 2015/10/22
-- Time: 11:07
-- To change this template use File | Settings | File Templates.
--
local ended = ccui.TouchEventType.ended

local MAX_LV = {30,40,50,60}

local function eventListner(event,func)
    return function(e,t)
        if t == ended then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
        end
        if t == event then
            func(e)
        end
    end
end

local GeneralDetailView = class("GeneralDetailView",function()
    return display.newLayer()
end)

--类初始化
function GeneralDetailView:ctor(parent,data)
    self.MainPage = CCUILoader:load("csd/troops/layer_popout_general_info.csb")
    self:addChild(self.MainPage)

    local uiBackParent = self.MainPage:getChildByName("panel_mask")
    local uiBack = uiBackParent:getChildByName("panel_outline_bg")
    self.UIQuality = uiBack:getChildByName("icon_outline")
    self.UIName = uiBack:getChildByName("text_name")
    self.UILevel = uiBack:getChildByName("text_citizenhood")
    self.UIIcon = self.UIQuality:getChildByName("icon_bg"):getChildByName("icon_general")
    self.UIStarBack = self.UIQuality:getChildByName("icon_star_bg")

    self.UIBack = uiBack
--    self.UIBackParent = uiBackParent
    self.UISkillList = uiBack:getChildByName("listview_desc")
    self.UISkillItem = uiBack:getChildByName("panel_item_bg")

    uiBackParent:addTouchEventListener(eventListner(ended,function()
        self:close()
    end))

    local isMove = false
    self.UISkillList:addTouchEventListener(eventListner(ended,function(t)
        local startPos = t:getTouchBeganPosition()
        local  curPos = t:getTouchEndPosition()
        if cc.pGetDistance(startPos,curPos) < 10 then
            self:close()
        end
    end))

    self:setBaseMsg(data)

    NodeTranslator:transZoomOut(self.UIBack,function()

    end)
end

--设置星数量
function GeneralDetailView:setStar(star)
    for i = 1 , 5 do
        local uiStar = self.UIStarBack:getChildByName("panel_star_0"..i)
        uiStar:setVisible(i == star)
    end
end

--设置将领数据
function GeneralDetailView:setBaseMsg(id)
    local msg = gGeneral[id] --配置表
--    local info = GeneralData:get(id) --服务器数据
    self.UIQuality:loadTexture(gGeneralQualityIcon[msg.que],ResType)
    self.UIName:setString(msg.generalname)
    Common:changePic(self.UIIcon,msg.icon)
    self.UILevel:setString(string.format(StringRes.aca_lv2,"",1,MAX_LV[msg.que]))
    self:setStar(msg.que)
    self:setAttribute(msg)
    local tmp = {}
    local arrSkills = string.split(msg.skillids,",")
    for i,v in ipairs(arrSkills) do
        local arrdetail = string.split(v,":")
        local d = {}
        d.skillindex = tonumber(arrdetail[1])
        d.templateId = tonumber(arrdetail[2])
        d.unlock = (msg.que >= d.skillindex)
        table.insert(tmp,d)
    end
    self:setSkills(tmp)
end

--属性
function GeneralDetailView:setAttribute(attr)
    local attrKey = {"hit","dodge","crit","armor","pierce","def"}
    local attrStr = {"hit","dodge","crit","armor","aca_pierce","aca_def" }
    local pos = 0
    for index,key in ipairs(attrKey) do
        local value = attr["base"..key]
        if value > 0 then
            pos = pos + 1
            local uiItem = self.UIBack:getChildByName("panel_item_0"..pos)
            local uiIcon = uiItem:getChildByName("icon_item")
            local uiAddAttr = uiItem:getChildByName("text_desc")
--            uiIcon:loadTexture(gGeneralAttributeIcon[index],ResType)
            Common:changePic(uiIcon,gGeneralAttributeIcon[index])
            uiAddAttr:setString(StringRes[attrStr[index]]..string.format("+%s%%",value))
        end
    end
end

--技能
function GeneralDetailView:setSkills(skills)
    table.sort(skills,function(a,b)
        return a.skillindex < b.skillindex
    end)
    for index,info in ipairs(skills) do
        local item = self.UISkillItem:clone()
        self.UISkillList:pushBackCustomItem(item)
        local msg = gGeneralskill[info.templateId]
        local uiIcon = item:getChildByName("icon_item")
        local uiName = item:getChildByName("text_desc_01")
        local uiDescript = item:getChildByName("text_desc_02")
        local uiLock = item:getChildByName("icon_star")
        local uiBack = item:getChildByName("panel_shade_bg")
        local uiLockLevel = uiLock:getChildByName("text_desc")
        Common:changePic(uiIcon,msg.icon)
        uiName:setString(msg.skillname..string.format(StringRes.army_group_lv,1))
        local tmp = string.split(msg.effect,":")
        local effect = tonumber(tmp[2])
        uiDescript:setString(string.format(msg.skilldes,effect))
        uiLockLevel:setString(index)
        uiLock:setVisible(not info.unlock)
        uiBack:setVisible(not info.unlock)
    end
end

--打开
function GeneralDetailView:open(parent,data)
    local newPage = self.new(parent,data)
    parent:addChild(newPage)
end

--关闭
function GeneralDetailView:close()
    NodeTranslator:transZoomIn(self.UIBack,function()
        self:removeFromParent()
    end)
end

return GeneralDetailView



