
--关卡详情界面
local ItemData = Tank
local NodeTranslator = require("src/app/util/NodeTranslator")
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local LevelDetailView = class("LevelDetailView",function() 
    return display.newLayer()
end)

function LevelDetailView:ctor(parent,data)
    self.MainPage = CCUILoader:load("csd/public/LevelDetailLayer.csb")
    self:addChild(self.MainPage)

    self.UIClose = self.MainPage:getChildByName("Button_cancel")
    self.UIConfirm = self.MainPage:getChildByName("Button_ok")
    self.UIList = self.MainPage:getChildByName("ListView_detail")
    self.UIRewardItem = self.UIList:getChildByName("Panel_rewards")
    self.UIRandomItem = self.UIList:getChildByName("Panel_randomrewards")
    self.UITroopsItem = self.UIList:getChildByName("Panel_troops")
    
    self.UIClose:addTouchEventListener(eventListner(ended,function() 
        self:close()
    end))
    self.UIConfirm:addTouchEventListener(eventListner(ended,function() 
        self:close()
    end))
    

    self.Data = data
    self._parent = parent
end

--固定奖励
function LevelDetailView:updateReward(rewards)
    for pos,info in pairs(rewards) do
        local num = info.num
        if info.name == "exp" then
            num = math.ceil(info.num*(1+PlayerData:getInstanse().PlayerAddition.expAdd))
        end
        local UIImage = self.UIRewardItem:getChildByName("Image_reward_"..pos)
        local UIText = self.UIRewardItem:getChildByName("Text_reward_"..pos)
        UIImage:loadTexture(ResIconCfg[info.name],ResType)
        UIText:setString(string.format(StringRes.troops_name_count,StringRes[info.name],num))
    end
end

--随即奖励
function LevelDetailView:updateRandomReward(rewardStr)
    local rewards = StringTemp:toTabByStr1(rewardStr)
    for index = 1, 2 do
        local UIImage = self.UIRandomItem:getChildByName("Image_reward_"..index)
        local UIText = self.UIRandomItem:getChildByName("Text_reward_"..index)
        local info = rewards[index]
        if info then
            local msg = gItem[info.id]
            UIText:setString(StringRes[msg.name])
            UIImage:loadTexture(msg.icon,ResType)
        else
            UIText:setVisible(false)
            UIImage:setVisible(false)
        end
    end
end

local function findTroopInfo(_t,pos)
    for _,info in ipairs(_t) do
        if info.p == pos then
            return info
        end
    end
end

--兵力
function LevelDetailView:updateTroops(troopsStr)
    local troops = StringTemp:toTabByStr2(troopsStr,"i","n","p") --位置,id,数量，为了根服务器对应
    for index = 1 , 6 do
        local info = findTroopInfo(troops,index)
        local UIImage = self.UITroopsItem:getChildByName("Image_tank_"..index)
        local UIText = self.UITroopsItem:getChildByName("Text_namecount_"..index)
        local visible = false
        if info then
            local msg = Tank[info.i]
            visible= true
            Common:changePic(UIImage,msg.icon)
            UIText:setString(string.format(StringRes.troops_name_count,StringRes[msg.name],info.n))
            Common:setUnitTitleColor(UIText,msg)
        end
        UIText:setVisible(visible)
    end
end

function LevelDetailView:update()
    local data = self.Data
    self:updateReward(data.rewards)
    self:updateRandomReward(data.coeRewards)
    self:updateTroops(data.troops)
end

function LevelDetailView:close()
    NodeTranslator:transZoomIn(self,function()
        self._parent:removeChild(self)
    end)
end

function LevelDetailView:open(parent,data)
    local newPage = self.new(parent,data)
    newPage:update()
    parent:addChild(newPage)
    local size = newPage:getContentSize()
--    newPage:setAnchorPoint(0.5,0.5)
--    newPage:setPosition(size.width/2,size.height/2)
    NodeTranslator:transZoomOut(newPage,function()

        end)
end

return LevelDetailView
