-- 选择将领
-- Created by IntelliJ IDEA.
-- User: HS18
-- Date: 2015/10/19
-- Time: 13:57
-- To change this template use File | Settings | File Templates.
--

local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == ended then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
        end
        if t == event then
            func()
        end
    end
end

local SelectRoleView = class("SelectRoleView",function()
    return display.newLayer()
end)

function SelectRoleView:ctor(parent,callback,data)
    self.MainPage = CCUILoader:load("csd/troops/layer_troops_select_general.csb")
    self:addChild(self.MainPage)

    local uiBack = self.MainPage:getChildByName("panel_mask"):getChildByName("panel_bg")
    self.UIClose = uiBack:getChildByName("btn_close")
    local uiPanelBack = uiBack:getChildByName("panel_general_bg")
    self.UIList = uiPanelBack:getChildByName("listview_general")
    self.UIItem = uiPanelBack:getChildByName("panel_general")

    self.UIClose:addTouchEventListener(eventListner(ended,function()
        self:close()
    end))

    self.CallBack = callback

    self:updateList(data.troopslist) --列表
end

function SelectRoleView:updateList(list)
    self.UIList:setColumnCount(3)
    table.sort(list,function(a,b)
        return a.fight > b.fight
    end)
    for index,info in ipairs(list) do
        local item = self.UIItem:clone()
        self.UIList:pushBackCustomItem(item)
        local uiName = item:getChildByName("text_name")
        local uiIcon = item:getChildByName("panel_avatar"):getChildByName("icon_avatar")
        local uiQuality = item:getChildByName("panel_avatar"):getChildByName("panel_outline")
        local uiStarBack = item:getChildByName("Image_star_back")
        local uiSee = item:getChildByName("btn_view")
        local msg = gGeneral[info.id]
        uiIcon:loadTexture(msg.icon,ResType)
        uiName:setString(string.format("%sLV.%s",msg.generalname,info.lv))
        uiQuality:loadTexture(gGeneralQualityIcon[info.quality],ResType)
        for i = 1 , 5 do
            uiStarBack:getChildByName("panel_star_"..i):setVisible(i==info.quality)
        end
        uiSee:addTouchEventListener(eventListner(ended,function()
            self:see(info,msg)
        end))
        item:addTouchEventListener(eventListner(ended,function()
            self:select(info,msg)
        end))
    end
end

--查看
function SelectRoleView:see(info,msg)
    local GeneralDetailView = require("src/app/views/troops/GeneralDetailView")
    GeneralDetailView:open(self,info.id)
end

--选择
function SelectRoleView:select(info,msg)
    self.CallBack(info,1)
    self:close()
end

function SelectRoleView:open(parent,callback,data)
    local newPage = self.new(parent,callback,data)
    parent:addChild(newPage)
end

function SelectRoleView:close()
    self:removeFromParent()
end

return SelectRoleView