
local ended = ccui.TouchEventType.ended
local percentChanged = ccui.SliderEventType.percentChanged

local function eventListner(event,func)
    return function(e,t)
        if t == ended then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
        end
        if t == event then
            func()
        end
    end
end

local SelectTroopsView = class("SelectTroopsView", function()
    return display.newLayer()
end)

function SelectTroopsView:ctor(parent,callback,data)
    self.MainPage = CCUILoader:load("csd/SelectTroopsLayer.csb")
    self:addChild(self.MainPage)
    self.UIClose = self.MainPage:getChildByName("Button_close")
    self.UITroopsList = self.MainPage:getChildByName("ListView_troops")
    self.UITroopsItem = self.UITroopsList:getChildByName("Image_item")
    self.UITroopsItem:retain()
    self.UISlider = self.MainPage:getChildByName("Slider_scale")
    self.UISubEvent = self.MainPage:getChildByName("Image_sub")
    self.UIAddEvent = self.MainPage:getChildByName("Image_add")
    self.UITroopsCount = self.MainPage:getChildByName("Text_count")
    self.UIOkBtn = self.MainPage:getChildByName("Button_ok")
    self.UICancerBtn = self.MainPage:getChildByName("Button_cancer")

    --事件
    self.UIClose:addTouchEventListener(eventListner(ended,function()
        self:close()
    end))
    self.UICancerBtn:addTouchEventListener(eventListner(ended,function()
        self:close()
    end))
    self.UIOkBtn:addTouchEventListener(eventListner(ended,function()
        local _t = self.SelectInfo
        self.CallBack(_t,self.CurrentCount)
        self:close()
    end))
    self.UISubEvent:addTouchEventListener(eventListner(ended,function()
        if self.CurrentCount > 1 then
            self:chageSelectCount(self.CurrentCount-1)
        end
    end))
    self.UIAddEvent:addTouchEventListener(eventListner(ended,function()
        if self.CurrentCount < self.SelectMaxCount then
            self:chageSelectCount(self.CurrentCount+1)
        end
    end))
    self.UISlider:addEventListener(eventListner(percentChanged,function()
        local percent = self.UISlider:getPercent()
        self:chageSelectCount(1+math.floor(percent*(self.SelectMaxCount-1)/100),true)
    end))

    self.CurrentCount = nil
    self.SelectMaxCount = nil
    self.SelectItem = nil
    self.SelectInfo = nil
    self.CallBack = callback
    self.ParentLayer = parent
    --self.Data = data --{leadcount=40,troopslist={}}
    self.LeadCount = data.leadcount
    self.TroopsList = data.troopslist

--    self:addMsgPromptItem()
end

--关闭
function SelectTroopsView:close()
    self.UITroopsItem:release()
    self.ParentLayer:removeChild(self)
end

--打开 data = {leadcount=66,troopslist={{id=1,count=100},{id=1,count=3}}}
function SelectTroopsView:open(parent,callback,data)
    if data.troopslist then
        local newPage = self.new(parent,callback,data)
        parent:addChild(newPage)
        newPage:updateTroopsList()
        local can = next(data.troopslist) and true or false
        newPage:setCanClick(can)
        if can then
            local item = newPage.UITroopsList:getItem(0)
            local index = item:getTag()
            newPage:selectTroops(index,item)
        end
    end
end

function SelectTroopsView:updateTroopsList()
    self.UITroopsList:removeAllChildren()
    self.UITroopsList:setColumnCount(3)
    for index,info in ipairs(self.TroopsList) do
        local item = self.UITroopsItem:clone()
        item:setTag(index)
        self.UITroopsList:pushBackCustomItem(item)
        local UIIcon = item:getChildByName("Image_icon")
        local UIName = item:getChildByName("Text_name")
        local UICount = item:getChildByName("Text_count")
        local UISelect = item:getChildByName("Image_select")
        local UIPrompt = item:getChildByName("icon_tip")
        local msg = Tank[info.id]
        UIIcon:loadTexture(msg.icon,ResType)
        UIName:setString(StringRes[msg.name])
        Common:setUnitTitleColor(UIName,msg)
        UICount:setString(info.count)
        UISelect:setVisible(false)
        UIIcon:addTouchEventListener(eventListner(ended,function()
            self:selectTroops(index,item)
        end))
        SpecialView:registerEvent(UIPrompt,ended,function()
            require("src/app/views/prompt/TankInfoPanel"):show(self,info.id)
        end)
    end
end

--是否有可选内容
function SelectTroopsView:setCanClick(can)
    self.UISlider:setEnabled(can)
    self.UISubEvent:setEnabled(can)
    self.UIAddEvent:setEnabled(can)
end

--刷新选择的数量
function SelectTroopsView:updateSelectCount(count)
    local item,info = self.SelectItem,self.SelectInfo
    local UISelect = item:getChildByName("Image_select")
    local UICount = item:getChildByName("Text_count")
    local UISelectCount = UISelect:getChildByName("Text_count")
    UISelectCount:setString(count)
    UICount:setString(info.count-count)
end

--选择某个部队
function SelectTroopsView:selectTroops(index,item)
    if self.SelectItem then
        local UISelect = self.SelectItem:getChildByName("Image_select")
        local UICount = self.SelectItem:getChildByName("Text_count")
        UICount:setString(self.SelectInfo.count)
        UISelect:setVisible(false)
    end
    local infoMsg = self.TroopsList[index]
    self.SelectItem = item
    self.SelectInfo = infoMsg
    local count = (infoMsg.count<self.LeadCount) and infoMsg.count or self.LeadCount
    self.SelectMaxCount = count
    self:chageSelectCount(count)
    local UISelect = item:getChildByName("Image_select")
    UISelect:setVisible(true)
end

--改变选择的数量
function SelectTroopsView:chageSelectCount(count,isEvent)
    if not isEvent then
        self.UISlider:setPercent((count-1)*100/(self.SelectMaxCount-1))
    end
    self.UITroopsCount:setString(count)
    self.CurrentCount = count
    self:updateSelectCount(count)
end

--添加详情描述
function SelectTroopsView:addMsgPromptItem()
--    local w = gLittleUi:getChildByName("Image_7"):clone()
--    local c = w:getChildByName("Text_num")
--    c:setVisible(false)
--    w:setName("msg_prompt")
--    w:setTouchEnabled(true)
--    local size = self.UITroopsItem:getContentSize()
--    self.UITroopsItem:addChild(w)
--    w:setPosition(size.width,size.height)
end

return SelectTroopsView