
--部队详情
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then 
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local TroopsInfoView = class("TroopsInfoView",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.march_descript,
        tabs={}})
end)

function TroopsInfoView:ctor(parent,data)
    self.MainPage = CCUILoader:load("csd/troops/layer_troops_info.csb")
    self:addChild(self.MainPage)
    
    local ui_head = self.MainPage:getChildByName("panel_troops_status")
    self.UIState = ui_head:getChildByName("text_status")
    self.UITime = ui_head:getChildByName("text_time")
    self.UILoad = ui_head:getChildByName("num_capability")
    
    self.UITroops = self.MainPage:getChildByName("panel_troops_info")
    
    self:setOther(data)
    self:setTroops(data.arms)
end

--其他
function TroopsInfoView:setOther(data)
    self.UIState:setString(StringRes["march_state"..data.type])
    local time = data.type == 2 and math.ceil((data.maxRes-data.nowRes)/data.resGather) or data.time
    self.UITime:setString(StringTemp:toTime(time))
    self.UILoad:setString(StringTemp:toNum(data.maxRes))
end

--部队
function TroopsInfoView:setTroops(troops)
    for _,info in ipairs(troops) do
        if info.id > 0 then
            local ui_icon = self.UITroops:getChildByName("icon_troop_"..info.index)
            local ui_text = ui_icon:getChildByName("text_troops_"..info.index)
            local msg = Tank[info.id]
            ui_icon:loadTexture(msg.icon,ResType)
            ui_text:setString(string.format("%s(%s)",StringRes[msg.name],info.count))
        end
    end
end

function TroopsInfoView:open(parent,data)
    local newPage = self.new(parent,data)
    parent:addChild(newPage)
end

return TroopsInfoView