
local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local TroopsRepairView = class("TroopsRepairView",function() 
    return display.newLayer()
end)

function TroopsRepairView:ctor(parent,data)
    self.MainPage = CCUILoader:load("csd/public/TroopsRepairLayer.csb")
    self:addChild(self.MainPage)
    --修理坦克
    self.UIRepairTank = self.MainPage:getChildByName("Image_repair")
    self.UIRAllMoney = self.UIRepairTank:getChildByName("Image_money")
    self.UIMoneyCount = self.UIRAllMoney:getChildByName("Text_use")
    self.UIRAllCrystal = self.UIRepairTank:getChildByName("Image_crystal")
    self.UICrystalCount = self.UIRAllCrystal:getChildByName("Text_use")
    self.UIRepairList = self.UIRepairTank:getChildByName("ListView_repair")
    self.UIRepairItem = self.UIRepairList:getChildByName("Image_item")
    self.UIRepairItem:retain()

    self.RepairTanksData = data or {}--{{baseId=1,num=10,gold=10,crystal=1000}} -- 需要修理的坦克
    parent:setWarningCount(3,#data)
    
    self._parent = parent
end

--重新设置数据
function TroopsRepairView:resetRepairData(data)
    self.RepairTanksData = data or {}
    self:updateRepairTank()
end

--type,1为金币，2为水晶,count 需要消耗的量
function TroopsRepairView:repairTank(tanks,type,isOne)
    if not tanks[1] then
        return
    end
    table.sort(tanks,function(a,b)
        return a>b
    end)
    local baseId = nil
    for index,pos in ipairs(tanks) do
        baseId = self.RepairTanksData[pos].baseId
    end
    Connect:sendMsg("TroopAction",isOne and "repair" or "repairAll",
    {type=type,baseId=isOne and baseId or nil},
    function(newdata)
--        if newdata.code == 1 then
            self.RepairTanksData = newdata.repairs
            self:updateRepairTank()
            self._parent.CanUpdate1 = true
            self._parent:setWarningCount(3,#self.RepairTanksData)
            gWorldScene:BaseQuest()
            local str = (newdata.code==1) and (isOne and string.format(StringRes.repair_info,StringRes[Tank[baseId].name])
                    or StringRes.repair_all) or StringRes.not_repair_all
                FlyWordPrompt:prompt(str)
--        end
    end,true)
    
end

--更新消耗
function TroopsRepairView:updateConsume(money,crystal)
    local _t = {}
    for index,info in ipairs(self.RepairTanksData) do
        table.insert(_t,index)
    end
    self.UIMoneyCount:setString(StringTemp:toNum(money))
    self.UICrystalCount:setString(StringTemp:toNum(crystal))
    self.UIRAllMoney:addTouchEventListener(eventListner(ended,function() 
        self:repairTank(_t,1,false)
    end))
    self.UIRAllCrystal:addTouchEventListener(eventListner(ended,function() 
        self:repairTank(_t,2,false)
    end))
end

--修理坦克
function TroopsRepairView:updateRepairTank()
    local money,crystal = 0,0
    self.UIRepairList:removeAllChildren()
    for index,info in ipairs(self.RepairTanksData) do
        local item = self.UIRepairItem:clone()
        self.UIRepairList:pushBackCustomItem(item)
        local msg = Tank[info.baseId]
        money,crystal = money + info.gold,crystal + info.crystal
        local UIName = item:getChildByName("Text_name")
        local UIIcon = item:getChildByName("Image_icon")
        local UICount = item:getChildByName("Text_count")
        local UIMB = item:getChildByName("Image_money")
        local UICB = item:getChildByName("Image_crystal")
        local UIM = UIMB:getChildByName("Text_use")
        local UIC = UICB:getChildByName("Text_use")
        UIName:setString(StringRes[msg.name])
        Common:setUnitTitleColor(UIName,msg)
        UIIcon:loadTexture(msg.icon,ResType)
        UICount:setString(info.num)
        UIM:setString(StringTemp:toNum(info.gold))
        UIC:setString(StringTemp:toNum(info.crystal))
        UIMB:addTouchEventListener(eventListner(ended,function() 
            self:repairTank({index},1,true)
        end))
        UICB:addTouchEventListener(eventListner(ended,function() 
            self:repairTank({index},2,true)
        end))
    end
    self:updateConsume(money,crystal)
end

function TroopsRepairView:destroy()
    self.UIRepairItem:release()
end

PublicViews.TroopsRepairView = TroopsRepairView

return TroopsRepairView