
local timeSchs = {}
local ResourceName = {"crystal","iron_ore","oil","vanadium","titanium",[6] = "Rebel_name1",
    [7] = "Rebel_name2",
    [8] = "Rebel_name3",
    [9] = "Rebel_name4",
    [10] = "Rebel_name5",
    [11] = "Rebel_name6",}
local Scheduler = cc.Director:getInstance():getScheduler()

local ended = ccui.TouchEventType.ended

local function eventListner(event,func)
    return function(e,t)
        if t == event then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            func()
        end
    end
end

local TroopsTaskView = class("TroopsTaskView",function() 
    return display.newLayer()
end)

function TroopsTaskView:ctor(parent,data)
    self.MainPage = CCUILoader:load("csd/public/TroopsTaskLayer.csb")
    self:addChild(self.MainPage)
    --执行任务
    self.UIExcuteTask = self.MainPage:getChildByName("Image_mission")
    self.UITaskList = self.UIExcuteTask:getChildByName("ListView_have")
    self.UITaskItem = self.UITaskList:getChildByName("Image_mission")
    self.UITaskItem:retain()
    self.UIEmptyBtn = self.UIExcuteTask:getChildByName("Button_empty")
    
    local function onNodeEvent(tag)
        if tag == "exit" then
            self:removed()
        end
    end
    self:registerScriptHandler(onNodeEvent)
    
    --事件
    self.UIEmptyBtn:addTouchEventListener(eventListner(ended,function()  --立即前往事件
        --前往世界地图攻击玩家页面
        --app:enterScene("WorldScene",3)
        parent:removeFromParent()
        gWorldScene:toField()
--        gWorldScene.BgPage = 3
--        gWorldScene:TurnBgQuest()
        
        
    end))
    
    self._parent = parent
    self.ListData = data or {}
    self.Items = {} --保存ui和数据，方便服务器推送数据查询
    
    
    self:updateFromServer()
end

--一个时序结束
function TroopsTaskView:endTimeInfo(id)
    local eId = timeSchs[id]
    if eId then
        Scheduler:unscheduleScriptEntry(eId) 
        timeSchs[id] = nil 
    end 
end

--所有时序
function TroopsTaskView:endTimeScheduler()
    for k,v in pairs(timeSchs) do
        Scheduler:unscheduleScriptEntry(v)
    end
    timeSchs = {}
end

--时序计时
function TroopsTaskView:startTimeSch(item,info)
    local UIScaleBack = item:getChildByName("Image_scaleback")
    local UIScale = UIScaleBack:getChildByName("LoadingBar_scale")
    local UIScaleDescript = UIScaleBack:getChildByName("Text_descript")
    local funcs = {
        function(interval)
            info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString(string.format(StringRes.arrive_time,
            StringTemp:toTime(info.time)))
            UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
            if info.time <= 0 then
                return true
            end
        end,
        function(interval)
            info.nowRes = info.nowRes + math.floor(interval+0.5)*info.resGather
            UIScaleDescript:setString(string.format(StringRes.collect,
                StringTemp:toNum(info.nowRes),StringTemp:toNum(info.maxRes)))
            UIScale:setPercent(info.nowRes*100/info.maxRes)
            if info.nowRes >= info.maxRes then
                return true
            end
        end,
        function(interval)
            info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString(string.format(StringRes.return_time,
                StringTemp:toTime(info.time)))
            UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
            if info.time <= 0 then
                return true
            end
        end,
        function(interval)
            UIScaleDescript:setString(StringRes.waiting)
            UIScale:setPercent(100)
            return true
        end,
        function(interval)
            UIScaleDescript:setString(StringRes.defensing)
            UIScale:setPercent(100)
            return true
        end,
        function(interval) --驻军行进
            info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString(string.format(StringRes.arrive_time,
                StringTemp:toTime(info.time)))
            UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
            if info.time <= 0 then
                return true
            end
        end,
        function(interval) --驻军返回
            info.time = info.time - math.floor(interval+0.5)
            UIScaleDescript:setString(string.format(StringRes.return_time,
                StringTemp:toTime(info.time)))
            UIScale:setPercent((info.allTime-info.time)*100/info.allTime)
            if info.time <= 0 then
                return true
            end
        end,
        function(interval)
            UIScaleDescript:setString(StringRes.occuping)
            UIScale:setPercent(100)
            return true
        end,
    }
    if funcs[info.type](0) == nil then
        timeSchs[info.troopId] = Scheduler:scheduleScriptFunc(function(time)
            if funcs[info.type](time) then
                self:endTimeInfo(info.troopId)
            end
        end,1,false)
    end
end

local function getHandleFuncs(info)
    local msg = {troopId=info.troopId}
    local TroopsView = require("src/app/views/troops/TroopsView")
    return { 
       function()
            Connect:sendMsg("WorldAction","speedUpWroldTroop",msg,function(newMsg)
                local newInfo = {type=newMsg.nowstate,troopId=newMsg.troopId,
                time=newMsg.nowTime,allTime=newMsg.allTime,nowRes=newMsg.nowRes,resGather=newMsg.gather,
                maxRes=newMsg.allGather}
                PlayerData:getInstanse().basicData.gold = newMsg.gold
                TroopsView:serverSetTask(newInfo,newMsg.repairCount,newMsg.type==3)
            end,true)
        end,
        function()
            Connect:sendMsg("WorldAction","gatherBack",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,false)
            end,true)
        end,
        function()
            Connect:sendMsg("WorldAction","speedUpWorldTroopBack",msg,function(newMsg)
                local data = PlayerData:getInstanse().basicData
                data.gold = newMsg.gold
                data.crystal = newMsg.crystal
                data.ferrum = newMsg.fe
                data.oil = newMsg.oil
                data.lead = newMsg.lead
                data.titanium = newMsg.titan
                TroopsView:serverSetTask({troopId=newMsg.troopId},nil,true)
            end,true)
        end,
        function()
            Connect:sendMsg("WorldAction","garrisonBack",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,false)
            end,true)
        end,
        function()
            Connect:sendMsg("WorldAction","garrisonBack",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,false)
            end,true)
        end,
        function() --驻军行进中
            Connect:sendMsg("WorldAction","speedUpGarrison",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,false)
            end,true)
        end,
        function() --驻军返回中
            Connect:sendMsg("WorldAction","speedUpGarrisonBack",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,true)
            end,true)
        end,
        function() --领地返回
            Connect:sendMsg("GuildwarAction","backStrongPoint",msg,function(newMsg)
                TroopsView:serverSetTask(newMsg,nil,true)
            end,true)
        end,
    }
end

local function getPromptFunc(info)
    local handleFun = getHandleFuncs(info)[info.type]
    local function spendGold()
        if info.time > 0 then
            local spend = math.ceil(info.time/60)*15
            PromptView:spendGold(spend,handleFun)
        end
    end
    local funcs = {
        spendGold,
        function() 
            if info.nowRes >= info.maxRes then
                handleFun()
            else
                PromptView:type2(nil,StringRes.is_collecting,StringRes.ok,StringRes.cancel,handleFun)
            end
        end,
        spendGold,
        handleFun,
        handleFun,
        spendGold,
        spendGold,
        handleFun,
    }
    return funcs[info.type]
end

local function getName(info)
    if info.type == 8 then
        local msg = gStrongpoint[info.sId]
        return string.format("%s(%s)",StringRes["occupy_type_"..msg.type],msg.name)
    else
        local name = (info.atkPlayer and info.atkPlayer~="") and 
            info.atkPlayer..string.format(StringRes.LV2,info.atklv) or
            StringRes[ResourceName[info.resType]]..string.format(StringRes.LV2,info.resLv)
        return name..string.format("(%s,%s)",info.x,info.y)
    end
end

--一项
function TroopsTaskView:updateExcuteTaskItem(item,info)
    local UIFlag = item:getChildByName("Image_flag")
    local UIName = item:getChildByName("Text_name")
    local UIPrompt = item:getChildByName("Button_prompt")
    local UIBack = item:getChildByName("Button_goback")
    local icons = gTaskBtnIcon[info.type]
    local LoadingBar = item:getChildByName("Image_scaleback"):getChildByName("LoadingBar_scale")
    LoadingBar:loadTexture(icons[4],ResType)
    UIFlag:loadTexture(icons[1])
    UIBack:loadTextures(icons[2],icons[3])
    UIName:setString(getName(info))
    self:startTimeSch(item,info)
    UIPrompt:addTouchEventListener(eventListner(ended,function() --描述
        local TroopsInfoView = require("src/app/views/troops/TroopsInfoView")
        TroopsInfoView:open(self,info)
    end))
    UIBack:addTouchEventListener(eventListner(ended,getPromptFunc(info)))
end

---------------------------
----刷新前往按钮
--@param
--@return
function TroopsTaskView:updateBtn()
	local showList = self.ListCount > 0
    self.UIEmptyBtn:setVisible(not showList)
    self.UITaskList:setVisible(showList)
	return showList
end

--执行任务
function TroopsTaskView:updateExcuteTask()
    if self:updateBtn() then
        self.UITaskList:removeAllChildren()
        for id,info in pairs(self.ListData) do
            local item = self.UITaskItem:clone()
            self.UITaskList:pushBackCustomItem(item)
            self:updateExcuteTaskItem(item,info)
            self.Items[info.troopId] = item
        end
    end
end

--服务器主动推送
function TroopsTaskView:serverSetInfo(info,remove)
    local item = self.Items[info.troopId]
    local old = self.ListData[info.troopId] or {}
    if item then
        self:endTimeInfo(info.troopId)
        if remove then
            self.UITaskList:removeChild(item)
            self:updateBtn()
            self._parent.CanUpdate1 = true
            self.Items[info.troopId] = nil
            self.ListData[info.troopId] = nil
        else
            for k,v in pairs(info) do
                old[k] = v
            end
            self:updateExcuteTaskItem(item,old)
        end
    end
    self:updateWarningCount()
end

function TroopsTaskView:updateWarningCount(count)
    if count == nil then
        count = 0
        for k,v in pairs(self.ListData) do
            count = count + 1
        end
    end
    self._parent:setWarningCount(2,count)
end    

--从服务器获取数据并刷新
function TroopsTaskView:updateFromServer()
    Connect:sendMsg("WorldAction","getWorldTroopsInfo",nil,
        function(newMsg) 
            local list = {}
            local count = 0
            for k,v in ipairs(newMsg) do
                list[v.troopId] = v
                count = count + 1
            end
            self.ListCount = count
            self.ListData = list
            self:updateExcuteTask()
            self:updateWarningCount(count)
        end,true)
end

function TroopsTaskView:destroy()
    self.UITaskItem:release()
end

function TroopsTaskView:removed()
    self:endTimeScheduler()
end

PublicViews.TroopsTaskView = TroopsTaskView

return TroopsTaskView