Recharge = class("Recharge", function(index)
    return PanelTabLayer.new(scene, { title = StringRes.buy_gold, tabs = { StringRes.gold, StringRes.month_card } })
end)

function Recharge:setRemoveNoticeParent(fun)
    self.fun = fun
end

function Recharge:ctor(index)

    self.Recharge = CCUILoader:load("csd/recharge/ui_recharge_main.csb")
    self:addChild(self.Recharge)

    self.mouthCardId = 99
    self.recharge_data = nil
    self.hasShowRechargeList = false
    self.hasShowMonthcard = false
    self:initTabs(index)
    self.remainDay = 0 --军衔卡剩余天数
    self.oldJinbiPosition=nil
    local function registerMonthCardNotification()
        Connect:register("notifyMonthCardInfo", function(data)
            if data then
                self:updateMonthCardInfo(data)
                PromptView:type1(nil, StringRes.month_card_avtive, StringRes.ok)
            end

        end)
    end
    registerMonthCardNotification()

    local function onNodeEvent(tag)
        if tag == "exit" then
            Connect:unregister("notifyMonthCardInfo")
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.updateId)
            if self.fun ~= nil then
                self.fun(tag)
            end

        end
    end
    self:registerScriptHandler(onNodeEvent)

    self.updateId = cc.Director:getInstance():getScheduler():scheduleScriptFunc(handler(self, self.update), 1, false)

    --    if SDKPlatform:getSDKId() == "5" then
    --        self:gonghui()
    --    else
    --        self.Recharge:getChildByName("Panel_16"):setVisible(false)
    --    end

    ViewManager:OpenView(self)
end

function Recharge:update(dt)
    local pd = PlayerData:getInstanse().basicData
    local panel_header = self.tabs[1]:getChildByName("panel_header")
    local text_coin = panel_header:getChildByName("text_coin")
    local text_vip = panel_header:getChildByName("text_vip")
    local text_desc = panel_header:getChildByName("text_desc")
    local text_info = panel_header:getChildByName("text_info")
    text_info:setVisible(false)

    local text_top = panel_header:getChildByName("icon_top")
    local text_get = panel_header:getChildByName("text_get")
    local text_coin_desc = panel_header:getChildByName("text_coin_desc")
    local num_coin = panel_header:getChildByName("num_coin")
    text_top:setVisible(false)
    text_get:setVisible(false)
    text_coin_desc:setVisible(false)
    num_coin:setVisible(false)


    text_coin:setString(string.format(StringRes.coin_num, pd.gold))
    text_vip:setString(string.format(StringRes.vip_lv, pd.vipLv))
    local vipLv = pd.vipLv
    if vipLv > #gVIP or vipLv == #gVIP then
        --VIP等级上限
        text_desc:setString(StringRes.vip_max)
    else
        local vipExp = pd.vipExp
        local need = gVIP[vipLv + 1].exp - vipExp
        text_desc:setString(string.format(StringRes.vip_info, StringRes.vip .. (vipLv + 1), need))
    end

    if pd.firstPay ~= nil and pd.firstPay ~= 0 then
        local lv = self.tabs[1]:getChildByName("listview_recharge")
        local item = lv:getChildByName("panel_first_recharge_bg")
        if item then
            lv:removeItem(0) --移除首冲
        end
    end

    if self.recharge_data then
        local lv = self.tabs[1]:getChildByName("listview_recharge")
        local lastItem = lv:getChildByTag(self.recharge_data.id)
        self:refreshRechargeItem(lastItem)
    end
    --使用后重新刷新显示
    Connect:sendMsg("PlayerAction","getPlayerInfo",{},
            function (data)
                local pd = PlayerData:getInstanse()
                pd.basicData = data
                local cjson = require("cjson")
                require("src/app/util/SDKPlatform")
                SDKPlatform:printLog("update playerData="..cjson.encode(PlayerData:getInstanse().basicData))
                local lv = self.tabs[1]:getChildByName("listview_recharge")
                local lastItem = lv:getChildByTag(self.recharge_data.id)
                self:refreshRechargeItem(lastItem)
            end,false)
end

function Recharge:showTab(index)
    --    if SDKPlatform:getSDKId() ~= "5" then
    for i, v in ipairs(self.tabs) do
        v:setVisible(i == index)
    end
    --    end
end

function Recharge:addFirstRechargeView()
    local lv = self.tabs[1]:getChildByName("listview_recharge")
    local panel_first_recharge_bg = self.tabs[1]:getChildByName("panel_first_recharge_bg")
    panel_first_recharge_bg:retain()
    panel_first_recharge_bg:removeFromParent()
    --    panel_first_recharge_bg:setTag(999)
    FirstRecharge:setAllItem(panel_first_recharge_bg:getChildByName("panel_first_recharge"))
    lv:pushBackCustomItem(panel_first_recharge_bg)
    panel_first_recharge_bg:release()
end

function Recharge:showRechargeList()
    self:refreshVipInfo()
    if self.hasShowRechargeList == false then
        local playerId = PlayerData:getInstanse().basicData.playerId
        self.tabs[1]:getChildByName("Text_63"):setString(string.format(StringRes.id_info, playerId))
        local lv = self.tabs[1]:getChildByName("listview_recharge")
        local pd = PlayerData:getInstanse().basicData
        if pd.firstPay ~= nil and pd.firstPay == 0 then
            self:addFirstRechargeView()
        end

        local panel_recharge_title = self.tabs[1]:getChildByName("panel_recharge_title")
        panel_recharge_title:retain()
        panel_recharge_title:removeFromParent()
        lv:pushBackCustomItem(panel_recharge_title)
        panel_recharge_title:release()

        local panel_option = self.tabs[1]:getChildByName("panel_option")
        for i = 1, #gRecharge do
            local info = gRecharge[i]
            local item = panel_option:clone()
            local num_coin = item:getChildByName("num_coin")
            self.oldJinbiPosition=num_coin:getPositionX()
            item.tag_data = info
            item:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then
                    self:selectItem(item, true)
                    self.recharge_data = e.tag_data
                end
            end)
            item:setTag(info.id)
            self:refreshRechargeItem(item)
            lv:pushBackCustomItem(item)
        end

        --充值
        local btn_recharge = self.tabs[1]:getChildByName("btn_recharge")
        showShader:buttonToGray(btn_recharge)
        --        Common:setBtnTouchEnable(btn_recharge,false)

        self.tabs[1]:getChildByName("btn_recharge"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then
                local playerId = PlayerData:getInstanse().basicData.playerId
                local msg = { server_id = SDKPlatform:get("ServerId"), channel_id = SDKPlatform:getSDKId(), player_id = playerId, product_id = self.recharge_data.id, order_amt = self.recharge_data.rmb, create_time = os.time() }
                if SDKPlatform:haveSdk() then
                    Connect:requestPayHttp(msg, function(data)
                        self:pay(data, (self.recharge_data.gold*3) .. StringRes.coin, msg.order_amt, nil)
                    end)
                else
                    self:testPay(self.recharge_data.id) --假支付
                end
            end
        end)

        --VIP
        self.tabs[1]:getChildByName("panel_header"):getChildByName("btn_info"):addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then
                require("src/app/views/vip/VipInfo"):show(gWorldScene)
                self:removeFromParent()
            end
        end)

        self.hasShowRechargeList = true
    end
end

function Recharge:refreshRechargeItem(item)
    local data = item.tag_data
    local num_coin = item:getChildByName("num_coin")
    local num_discount = item:getChildByName("num_discount")
    local payinfo=PlayerData:getInstanse().basicData.payinfo
    num_coin:setPositionX( self.oldJinbiPosition+20)
    num_discount:setPositionX( self.oldJinbiPosition+40)
    --SDKPlatform:printLog("num_coin positionX="..positionX)
    --SDKPlatform:printLog("num_discount positionX="..num_discount:getPositionX())
    if payinfo[data.id]==0 then
        num_coin:setString(data.gold)
        num_discount:setVisible(true)
        num_discount:setString(string.format(StringRes.discount_info, data.gold*2))
    else
        num_coin:setString(data.gold)
        num_discount:setVisible(false)
    end

    local icon_banner = item:getChildByName("icon_banner")
    icon_banner:setVisible(true)
    local text_hot = item:getChildByName("text_hot")
    text_hot:setVisible(true)
    Common:changePic(item:getChildByName("icon_coin"), data.icon)
    local num_rmb = item:getChildByName("num_rmb")
    num_rmb:setString(string.format(StringRes.price, data.rmb / 100))

    --if data.discount > 0 then
    --    num_discount:setVisible(true)
    --    num_discount:setString(string.format(StringRes.discount_info, data.discount * 100))
    --else
    --    num_discount:setVisible(false)
    --end
    if data.bestsell == 1 then
        self:selectItem(item, true)
        self.recharge_data = item.tag_data
        Common:changePic(icon_banner, ResIconCfg.panel_hot)
        text_hot:setString(StringRes.price_hot)
    elseif data.affordable == 1 then
        Common:changePic(icon_banner, ResIconCfg.panel_cheap)
        text_hot:setString(StringRes.price_cheap)
    else
        icon_banner:setVisible(false)
        text_hot:setVisible(false)
    end
    end

    function Recharge:selectItem(item, select)
        if self.recharge_data and self.recharge_data ~= item.tag_data then
            local lv = self.tabs[1]:getChildByName("listview_recharge")
            local lastItem = lv:getChildByTag(self.recharge_data.id)
            if lastItem then
                self:selectItem(lastItem, false)
            end
        end
        local num_rmb = item:getChildByName("num_rmb")
        item:getChildByName("checkbox_option"):setSelected(select)
        if select then
            item:setBackGroundImage(ResIconCfg.panel_re_infoTab_highlight, ResType)
            num_rmb:setColor(CommonColor.White)
        else
            item:setBackGroundImage(ResIconCfg.panel_re_infoTab, ResType)
            num_rmb:setColor(CommonColor.Blue2)
        end
    end

    function Recharge:refreshVipInfo()

    end

    function Recharge:showMonthCard()
        if self.hasShowMonthcard == false then
            local panel = self.tabs[2]
            panel:getChildByName("text_num"):setString(string.format(StringRes.price, gRecharge[self.mouthCardId].rmb / 100))
            local DescriptCfg = require("src/app/cfg/DescriptCfg")
            SpecialView:addRichText(panel:getChildByName("panel_info_bg"):getChildByName("listview_info"):getChildByName("text_info"), DescriptCfg.Month_Card_Des)

            local btn_get = panel:getChildByName("btn_get")
            showShader:buttonToGray(btn_get)
            btn_get:setBright(false)
            btn_get:setEnabled(false)
            local btn_activate = panel:getChildByName("btn_activate")
            btn_get:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then
                    Connect:sendMsg("PayAction", "getMonthCardGold", {}, function(data)
                        if data.state == 1 then
                            FlyWordPrompt:prompt(string.format(StringRes.get_coin_num, data.getGold))
                            e:setBright(false)
                            e:setEnabled(false)
                        end
                    end)
                end
            end)

            --for 审核
            showShader:buttonToGray(btn_activate)
            --        Common:setBtnTouchEnable(btn_activate,false)

            btn_activate:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then
                    if self.remainDay > 30 then
                        FlyWordPrompt:prompt(StringRes.month_card_limit)
                    else

                        local playerId = PlayerData:getInstanse().basicData.playerId
                        local info = gRecharge[self.mouthCardId]
                        if SDKPlatform:haveSdk() then
                            local msg = { server_id = SDKPlatform:get("ServerId"), channel_id = SDKPlatform:getSDKId(), player_id = playerId, product_id = info.id, order_amt = info.rmb, create_time = os.time() }
                            Connect:requestPayHttp(msg, function(data)

                                self:pay(data, StringRes.month_card, info.rmb, nil)
                            end)
                        else
                            self:testPay(info.id) --假支付
                        end

                    end
                end
            end)

            self.hasShowMonthcard = true
        end
        if self.monthCard_data then
            self:updateMonthCardInfo(self.monthCard_data)
            self.monthCard_data = nil
            return
        end
        local msg = {}
        Connect:sendMsg("PayAction", "getMonthCardInfo", msg, function(data)
            self:updateMonthCardInfo(data)
        end)
    end

    function Recharge:updateMonthCardInfo(data)
        self.remainDay = data.remainDay
        local panel = self.tabs[2]
        local btn_get = panel:getChildByName("btn_get")
        local text_activate = panel:getChildByName("panel_activate_bg"):getChildByName("text_activate")
        local btn_activate = panel:getChildByName("btn_activate")
        if data.canGet == 1 then
            btn_get:setBright(true)
            btn_get:setEnabled(true)
        else
            showShader:buttonToGray(btn_get)
            btn_get:setBright(false)
            btn_get:setEnabled(false)
        end
        if data.remainDay > 0 then
            btn_activate:setBright(true)
            btn_activate:setEnabled(true)
            text_activate:setString(string.format(StringRes.remainDay, data.remainDay))
            text_activate:setColor(CommonColor.White)
        else
            btn_activate:setBright(true)
            btn_activate:setEnabled(true)
            text_activate:setString(StringRes.unActive)
            text_activate:setColor(CommonColor.Red)
        end
    end

    function Recharge:initTabs(index)
        self.tabs = { self.Recharge:getChildByName("panel_bg"), self.Recharge:getChildByName("panel_munition_bg") }
        self:registerTabEvent(1, function()
            --金币
            self:showTab(1)
            self:showRechargeList()
        end)
        self:registerTabEvent(2, function()
            --军需卡
            self:showTab(2)
            self:showMonthCard()
        end)
        if index == nil then
            index = 1
        end
        self:setTabSelect(index)
        self:update(0)
    end

    function Recharge:show(parent, index)
        if index == 2 then
            Connect:sendMsg("PayAction", "getMonthCardInfo", {}, function(data)
                local recharge = Recharge.new(index)
                recharge.monthCard_data = data
                parent:addChild(recharge)
                NodeTranslator:transZoomOut(recharge, nil)
            end)
            return nil
        else
            local recharge = Recharge.new(index)
            parent:addChild(recharge)
            NodeTranslator:transZoomOut(recharge, nil)
            return recharge
        end
    end

    function Recharge:pay(data, name, price, callback)
        local UserDefault = cc.UserDefault:getInstance()
        if (UserDefault:getStringForKey("type") ~= "1") and SDKPlatform:isSelfProgram() then
            PromptView:type2(StringRes.text_world00038,
                    StringRes.text_world00039
            , StringRes.text_world00040, StringRes.cancel,
                    function()
                        local RegisterView = require("src/app/views/login/RegisterView")
                        RegisterView:open(self, true)
                    end)
        else
            if data.ret == 1 then
                local cjson = require("cjson")
                require("src/app/util/SDKPlatform")
                SDKPlatform:printLog("playerData11="..cjson.encode(data))
                SDKPlatform:pay(name, price, data, callback)
            else
                PromptView:type1(nil, StringRes.order_error, StringRes.ok)
            end
        end

    end

    --公会需求
    function Recharge:gonghui()
        for i, v in ipairs(self._Tabs) do
            v:setVisible(false)
        end
        self.Imageback:setVisible(false)
    end

    function Recharge:testPay(tmpgoodsId)
        local UserDefault = cc.UserDefault:getInstance()
        if (UserDefault:getStringForKey("type") ~= "1") and SDKPlatform:isSelfProgram() then
            PromptView:type2(StringRes.text_world00038,
                    StringRes.text_world00039
            , StringRes.text_world00040, StringRes.cancel,
                    function()
                        local RegisterView = require("src/app/views/login/RegisterView")
                        RegisterView:open(self, true)
                    end)
        else
            --假支付 --
            Connect:sendMsg("PayAction", "buyGold", { goodsId = tmpgoodsId },
                    function(data)
                    end)
            --假支付 --
        end
    end

    return Recharge