
local VipInfo = class("VipInfo",function(data,type,showPackage)
    if type and type == 1 then
        return CCUILoader:load("res/csd/vip/ui_vip_main.csb")
    else
        return CCUILoader:load("res/csd/vip/ui_vip_info.csb")
    end
end)

VipInfo.WithTab = 1

function VipInfo:show(parent)
    local layer = VipInfo.new(nil,0,false)
    parent:addChild(layer)
    NodeTranslator:transUp(layer,nil)
end

function VipInfo:showWithTab(parent)
    Connect:sendMsg("VipAction","getVipPackagesInfo",{},function(data)
        local layer = VipInfo.new(data,VipInfo.WithTab)
        parent:addChild(layer)
        NodeTranslator:transUp(layer,nil)
    end)
    
end

function VipInfo:showPackageTab(parent)
    --获取VIP礼包
    Connect:sendMsg("VipAction","getVipPackagesInfo",{},function(data)
        local layer = VipInfo.new(data,VipInfo.WithTab,true)
        parent:addChild(layer)
        NodeTranslator:transUp(layer,nil)
    end)
    
end

function VipInfo:ctor(data,type,showPackage)
    self.showPackage = showPackage
    self.type = type
    if data then
        self.vipPackages = data.packages
    end
--    self:initView()
    if self.type == 1 then
--        self:getVipPackages()
        if self.vipPackages  then
            self:updatePackages()
        end
    end
    self:initView()
end

function VipInfo:initView()
    local ui_bg = self:getChildByName("ui_bg")

    local btn_close = ui_bg:getChildByName("btn_close")
    btn_close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)

    --title
    ui_bg:getChildByName("text_title"):setString(StringRes.vip)

    --充值
    local btn_charge = self:getChildByName("btn_charge")
    btn_charge:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
--            self:close()
            Recharge:show(gWorldScene)
            self:removeFromParent()
        end
    end)

    self:initTitle()
    self:initTabs()
--    self:initDes()
end

function VipInfo:initTitle()
    local pd = PlayerData:getInstanse()
    local vipLv = pd.basicData.vipLv

    local panel_header = self:getChildByName("panel_header")
    local text_vip = panel_header:getChildByName("panel_title"):getChildByName("text_vip")
    text_vip:setString(StringRes.vip..vipLv)
    
    local progress_bar_vip = panel_header:getChildByName("progress_bar_bg"):getChildByName("progress_bar_vip")
    local text_desc_1 = panel_header:getChildByName("text_desc_1")
    local text_desc_2 = panel_header:getChildByName("text_desc_2")

    if vipLv>#gVIP or vipLv==#gVIP then --VIP等级上限
        text_desc_1:setString(StringRes.vip_max)
        text_desc_2:setVisible(false)
        progress_bar_vip:setPercent(100)
    else
        local vipExp = pd.basicData.vipExp
        local need = gVIP[vipLv+1].exp - vipExp
        text_desc_1:setString(string.format(StringRes.vip_info,StringRes.vip..(vipLv+1),need))
        text_desc_2:setVisible(true)
        progress_bar_vip:setPercent((vipExp - gVIP[vipLv].exp)/(gVIP[vipLv+1].exp - gVIP[vipLv].exp)*100)
    end

end

function VipInfo:setButtonEnabled(button,enable)
    button:setBright(enable)
    button:setEnabled(enable)
    button:setTouchEnabled(enable)
--    button:setTitleColor(enable and CommonColor.White or CommonColor.White)
end

function VipInfo:initTabs()
    if self.type ~= VipInfo.WithTab then self:initDes() return end
    local btn_tab_1 = self:getChildByName("btn_tab_1")
    local btn_tab_2 = self:getChildByName("btn_tab_2")

    function showInfo()
        self:setButtonEnabled(btn_tab_1,false)
        self:setButtonEnabled(btn_tab_2,true)
        if self.listview_des then
            self.listview_des:setVisible(true)
        else
            self:initDes()
        end
        if self.listview_package then self.listview_package:setVisible(false) end
    end
    
    btn_tab_1:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            showInfo()
        end
    end)

    function showPackage()
        self:setButtonEnabled(btn_tab_1,true)
        self:setButtonEnabled(btn_tab_2,false)
        if self.listview_package then
            self.listview_package:setVisible(true)
        else
            self:updatePackages()
        end
        if self.listview_des then self.listview_des:setVisible(false) end
    end

    btn_tab_2:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            showPackage()
        end
    end)

    if self.showPackage then
        showPackage()
    else
        showInfo()
    end
end

function VipInfo:updatePackages()

    if self.vipPackages == nil or #(self.vipPackages)==0 then return end
    
    local vipLv = PlayerData:getInstanse().basicData.vipLv
    
    local listview_vip_list = self:getChildByName("listview_vip_list")
    
    if self.listview_package then
        self.listview_package:removeAllItems()
    else
        self.listview_package = listview_vip_list:clone()
        self:addChild(self.listview_package)
    end

    --local panel_vip_package = self:getChildByName("panel_vip_package")

    for k,v in pairs(self.vipPackages) do
    
        local desInfo = gVIPPackage[v.id]
        
        if desInfo == nil or desInfo.viplv > vipLv+2 then print("cann't find VIPPackage") break end
    
        local item = preLoad:getPanel("vipPkg")--panel_vip_package:clone()
        local listview_package_desc = item:getChildByName("panel_desc_bg"):getChildByName("listview_package_desc")
        listview_package_desc:setPropagateTouchEvents(false)

        item:setTag(v.id)
--        item:getChildByName("btn_gift"):addTouchEventListener(function(e, t)
--            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
--                require("src/app/views/vip/VipReward.lua"):show(self,desInfo.item)
--            end
--        end)
        
        item:getChildByName("btn_gift"):getChildByName("icon_gift"):loadTexture(desInfo.icon,ResType)

        local text_desc = listview_package_desc:getChildByName("text_desc")
        text_desc:setString(StringRes[desInfo.des])
        local text_vip_package_title = item:getChildByName("text_vip_package_title")
        text_vip_package_title:setString(StringRes[desInfo.name])
        
        local btn_buy = item:getChildByName("btn_buy")
        btn_buy.dataInfo = v
        local function getOrBuy(action,method,sid,discount)
            --获取/购买VIP礼包
            Connect:sendMsg(action,method,{id = sid},function(data)
                if data.state == 1 then --领取成功
--                    FlyWordPrompt:prompt(string.format(StringRes.get_success,StringRes[gVIPPackage[sid].des]))
                    self.listview_package:removeChildByTag(sid)
                    self:prompt(data)
                elseif data.state == 2 and discount then --购买成功
                    PlayerData:getInstanse().basicData.gold = PlayerData:getInstanse().basicData.gold
--                    FlyWordPrompt:prompt(string.format(StringRes.buy_success,StringRes[gVIPPackage[sid].des]))
                    self.listview_package:removeChildByTag(sid)
                    self:prompt(data)
                end
            end)
        end
        btn_buy:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                local sdata = e.dataInfo
                local desInfo = gVIPPackage[sdata.id]
                if desInfo.got ==  0 then --领取
                    if desInfo.viplv > vipLv then--VIP等级不够
                        FlyWordPrompt:prompt(StringRes.vip_not_enough)
                    else
                        getOrBuy("VipAction","getVipPackage",sdata.id)
                    end
                elseif desInfo.got ==  1 then
                    if desInfo.viplv > vipLv then--VIP等级不够
                        FlyWordPrompt:prompt(StringRes.vip_not_enough)
                    elseif sdata.discprice > PlayerData:getInstanse().basicData.gold then --金币不够
                        FlyWordPrompt:prompt(StringRes.gold_not_enough2)
                    else
                        getOrBuy("VipAction","buyVipPackage",sdata.id,sdata.discprice)
                    end
                end
            end
        end)
        
        local text_get = item:getChildByName("text_get")
        local text_price = item:getChildByName("text_price")
        local text_discount = item:getChildByName("text_discount")
        local icon_coin = item:getChildByName("icon_coin")
        local icon_coin2 = item:getChildByName("icon_coin2")
        if desInfo.got ==  0 then
            text_get:setString(string.format(StringRes.can_get,StringRes.vip..(desInfo.viplv)))
            btn_buy:setTitleText(StringRes.attach)
            text_price:setVisible(false)
            text_discount:setVisible(false)
            icon_coin:setVisible(false)
            icon_coin2:setVisible(false)
            item:getChildByName("icon_redline"):setVisible(false)
        elseif desInfo.got ==  1 then
            btn_buy:setTitleText(StringRes.buy)
            text_price:setVisible(true)
            text_discount:setVisible(true)
            icon_coin:setVisible(true)
            icon_coin2:setVisible(true)
            item:getChildByName("icon_redline"):setVisible(true)
            text_get:setString(string.format(StringRes.can_buy,StringRes.vip..(desInfo.viplv)))
            text_price:setString(string.format(StringRes.price_org,v.orgprice))
            --icon_coin:setPositionX(text_price:getPositionX()+text_price:getContentSize().width+8)
            text_discount:setString(string.format(StringRes.discount,v.discprice))
            --icon_coin2:setPositionX(text_discount:getPositionX()+text_discount:getContentSize().width+8)
        end
        if desInfo.viplv > vipLv then
            text_get:setVisible(true)
            btn_buy:loadTextureNormal(ResIconCfg.btn_negative)
            btn_buy:loadTexturePressed(ResIconCfg.btn_negativePress)
        else
            text_get:setVisible(false)
            if v.discprice > PlayerData:getInstanse().basicData.gold then
                btn_buy:loadTextureNormal(ResIconCfg.btn_negative)
                btn_buy:loadTexturePressed(ResIconCfg.btn_negativePress)
            else
                btn_buy:loadTextureNormal(ResIconCfg.btn_positive)
                btn_buy:loadTexturePressed(ResIconCfg.btn_positivePress)
            end
        end
        
        self.listview_package:pushBackCustomItem(item)
    end
    self:runAction(cc.Sequence:create(cc.DelayTime:create(0.01),cc.CallFunc:create(function(dt)
        self.listview_package:scrollToTop(0.01,false)
    end)))
end

function VipInfo:prompt(data)
    local str = ""
    --道具
    if data and data.items then
        for i,v in ipairs(data.items) do
            local item = gItem[v.baseId]
            if item then
                str = str..StringRes[item.name].."x"..v.num.." "
            end
        end
    end
    --将领魂魄
    if data and data.commanders then
        for i,v in ipairs(data.commanders) do
            local item = gGeneral[v.baseId]
            if item then
                str = str..item.generalname..StringRes.aca_item2.."x"..v.num.." "
            end
        end
    end
    if str ~= "" then
        FlyWordPrompt:prompt(string.format(StringRes.exchange_success,str))
    end
end

function VipInfo:lvListener(listview,item,index,type)
    if type == ExpandListView_Type_Open then
        item:getChildByName("check_detail"):setSelected(true)
--        local panel_vip_desc = self:getChildByName("panel_vip_desc")
--        local item2 = panel_vip_desc:clone()
--        SpecialView:addRichText(item2,StringTemp:Descript(StringRes[item.tag_data.vippow]))
        self.listview_des:insertExpandContent(self.tag_item,index+1)
        self.tag_item:release()
    elseif type == ExpandListView_Type_Close then
        item:getChildByName("check_detail"):setSelected(false)
    end
end

function VipInfo:getExHeight(item,index)
        local panel_vip_desc = self:getChildByName("panel_vip_desc")
        local item2 = panel_vip_desc:clone()
        SpecialView:addRichText(item2,StringTemp:Descript(StringRes[item.tag_data.vippow],24,CommonColor.White))
        self.tag_item = item2
        self.tag_item:retain()
        return item2:getContentSize().height
end

function VipInfo:initDes()
    local listview_vip_list = self:getChildByName("listview_vip_list")
    local panel_vip_title = self:getChildByName("panel_vip_title")

    self.listview_des = ExpandListView.new(listview_vip_list:clone(),handler(self,self.lvListener),handler(self,self.getExHeight))
    self:addChild(self.listview_des)

--    local psize = panel_vip_desc:getContentSize()

    for i = 0 , #gVIP , 1 do
        local info = gVIP[i]
        local item1 = panel_vip_title:clone()
        item1:setName("vip"..i)
        item1.tag_data = info
        item1:getChildByName("panel_header"):getChildByName("text_vip_level"):setString(StringRes.vip..i)
        self.listview_des:pushExpandItem(item1)
    end
    local vipLv =  PlayerData:getInstanse().basicData.vipLv
    if vipLv then
        NodeTranslator:deltaDo(0.3,function() 
            self.listview_des:setCurSelectedIndex(vipLv)
        end)
    end
    
end

function VipInfo:close()
    NodeTranslator:transDown(self,function()
        self:removeFromParent()
    end)
end

function VipInfo:getVipPackages()
    --获取VIP礼包
    Connect:sendMsg("VipAction","getVipPackagesInfo",{},function(data)
        self.vipPackages = data.packages
--        if self.listview_package and self.listview_package:isVisible() then
        self:updatePackages()
        self:initView()
--        end
    end)
end

return VipInfo