local VipReward = class("VipReward",function(items)
    return CCUILoader:load("res/csd/vip/layer_vip_reward.csb")
end)

function VipReward:show(parent,items)
    local layer = VipReward.new(items)
    parent:addChild(layer)
    local panel_mask = layer:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    local listview_reward = panel_bg:getChildByName("listview_reward")
    listview_reward:setSwallowTouches(false)
    
    DialogUtil:addClickEvent(panel_mask, function ()
        NodeTranslator:transZoomIn(panel_bg,function() 
            layer:removeFromParent()
        end)
    end)
    
    NodeTranslator:transZoomOut(panel_bg,nil)
end

function VipReward:ctor(is)
    self.items = is
	self:initView()
end

function VipReward:initView()
    local panel_mask = self:getChildByName("panel_mask")
    local panel_bg = panel_mask:getChildByName("panel_bg")
    local listview_reward = panel_bg:getChildByName("listview_reward")
    
    local panel_reward = panel_mask:getChildByName("panel_reward")
    
    for i,v in ipairs(string.split(self.items,",")) do 
        local info = string.split(v,":")
        local id = tonumber(info[1])
        local count = info[2]
        local item = panel_reward:clone()
        local icon_reward = item:getChildByName("icon_reward")
        icon_reward:loadTexture(gItem[id].icon,ResType)
        local text_reward = item:getChildByName("text_reward")
        text_reward:setString(StringRes[gItem[id].name].."*"..count)
        listview_reward:pushBackCustomItem(item)
    end
    
end

return VipReward